#define _CRT_SECURE_NO_DEPRECATE
#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <memory.h>
#include <utility>
#include <set>
#include <sstream>
#include <vector>
#include <map>
#include <string>
#include <queue>
using namespace std;

#define ll long long
#define pb push_back
#define mp make_pair
#define mod 1000000007
#define inf 1000000000
#define task "abbreviation"


string s;
int n;
vector<double>d, m;
void init()
{
	cin >> s;
	n = s.size();
	d.resize(n);
	m.resize(n);
}

void solve()
{
	d[0] = 1.0 / n;
	for (int i = 1; i < n; ++i)
		d[i] = d[i - 1] * (1.0 / (n - i)) + d[i - 1];

	
	int w = 0, c = 0;
	double ans = 0;

	for (int i = n - 1; i >= 0; --i)
	{

		if (s[i] == 'W')
			++w;
		else
			++c;
		if (i == 0)
		{
			if (s[i] == 'C')
			{
				if (w > 0)
					ans = ans + (1.0 / (n - i) * ((w + 1) * 1LL * w / 2.0));
			}
			else
			{
				if (c > 0)
					ans = ans * (1.0 / (n - i) * ((c + 1) * 1LL * c / 2.0));
			}
			continue;
		}
		if (s[i] == 'C')
		{
			if (w > 0)
				ans = ans + d[i - 1] * (1.0 / (n - i) * ((w + 1) * 1LL * w / 2.0));
		}
		else
		{
			if (c > 0)
				ans = ans + d[i - 1] * (1.0 / (n - i) * ((c + 1) * 1LL * c / 2.0));
		}
	}
	cout.precision(9);
	cout << fixed << ans;
}

int main()
{
	//freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
	//freopen("abbreviation.in", "rt", stdin); freopen("abbreviation.out", "wt", stdout);
	init();
	solve();
	return 0;
}
