#pragma (linker, "/STACK:1000000000")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <ctime>
#include <map>
#include <climits>
#include <set>
#include <string>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef double dbl;

#define sz(x) (int)x.size()
#define pb push_back
#define all(x) x.begin(),x.end()
#define X first
#define Y second

#define TASK "abbreviation"

const int maxn = (int)1e6 + 10;

bool good(char c) {
	return ('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z');
}

bool cap(string & s) {
	bool flag = true;

	if (!('A' <= s[0] && s[0] <= 'Z')) {
		return false;
	}

	if (sz(s) == 1)
		return false;

	for (int i = 1; i < sz(s); i++) {
		if (!('a' <= s[i] && s[i] <= 'z')) {
			return false;
		}
	}
	return true;
}

int main() {
#ifdef NSU
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	string s;
	vector<string> v;
	while (getline(cin, s)) {
		v.pb(s);
	}

	vector< vector<string> > w;
	for (int i = 0; i < sz(v); i++) {
		w.pb(vector<string>());
		int pos = 0;
		string cur = "";
		while (pos < sz(v[i])) {
			cur = "";
			while (pos < sz(v[i]) && !good(v[i][pos])) {
				cur += v[i][pos];
				pos++;
			}
			if (sz(cur))
				w[i].pb(cur);
			if (pos >= sz(v[i]))
				continue;
			cur = "";
			while (pos < sz(v[i]) && good(v[i][pos])) {
				cur += v[i][pos];
				pos++;
			}
			w[i].pb(cur);
		}	
	}

	vector<string> res;

	for (int i = 0; i < sz(w); i++) {
		int j = 0;
		res.pb("");
		while (j < sz(w[i])) {
			int cnt = 0;
			string t = "";
			string abbr = "";
			if (cap(w[i][j])) {
				while (j < sz(w[i]) && cap(w[i][j])) {
					t += w[i][j];
					abbr += w[i][j][0];
					j++;
					cnt++;
					if (j < sz(w[i])) {
						if (w[i][j] == " ") {
							t += w[i][j];
							j++;
						} else {
							break;
						}
					}
				}

				if (t.back() == ' ') {
					t.pop_back();
					j--;
				}

				if (cnt >= 2) {
					res[i] += abbr + " (";
					res[i] += t + ")";
				} else {
					res[i] += t;
				}
			} else {
				res[i] += w[i][j];
				j++;
			}

			
		}
	}

	for (int i = 0; i < sz(res); i++) {
		puts(res[i].c_str());
	}

#ifdef NSU
	cerr << "Time: " << (double)clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
