#pragma (linker, "/STACK:1000000000")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <ctime>
#include <map>
#include <climits>
#include <set>
#include <string>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef double dbl;

#define sz(x) (int)x.size()
#define pb push_back
#define all(x) x.begin(),x.end()
#define X first
#define Y second

#define TASK "foreign"

int main() {
#ifdef NSU
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	string v;
	getline(cin, v);
	ll n = sz(v);

	vector <double> dp(n, 0);
	vector <double> suf_dp(n, 0);
	vector <ll> s(n, 0);
	vector <ll> t(n, 0);

	dp[n - 1] = 0;
	suf_dp[n - 1] = 0;
	s[n - 1] = (v[n - 1] == 'W' ? 1 : 0);
	t[n - 1] = 1 - s[n - 1];

	for (ll i = n - 2; i >= 0; i--) {
		s[i] = s[i + 1] + (n - i) * (v[i] == 'W');
		t[i] = t[i + 1] + (n - i) * (v[i] == 'C');

		dp[i] = (v[i] == 'C' ? s[i] : t[i]);
		dp[i] += suf_dp[i + 1];
		dp[i] /= (n - i);

		suf_dp[i] = suf_dp[i + 1] + dp[i];
	}

	printf("%.10lf\n", dp[0]);

#ifdef NSU
	cerr << "Time: " << (double)clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
