#include <iostream>
#include <fstream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>
#include <sstream>

using namespace std;

bool up(char c) {
	return c >= 'A' && c <= 'Z';
}

bool lo(char c) {
	return c >= 'a' && c <= 'z';
}

bool ch(char c) {
	return lo(c) || up(c);
}
bool  ok(string s) {
	if (s.length() < 2)
		return false;
	for (char c : s)
		if (!ch(c))
			return false;
	if (lo(s[0]))
		return false;
	for (int i = 1; i < s.length(); i++)
		if (up(s[i]))
			return false;
	return true;
}

string ww(string s) {
	string ans = "";
	stringstream ss;
	ss << s;
	string t;
	int y = 0;
	while (ss >> t) {
		y++;
		if (!ok(t)) {
			return s.substr(0, s.length() - 1);
		}
		ans += t[0];
	}
	return y > 1 ? (ans + " (" + s.substr(0, s.length() - 1) + ")") : (s.length() ? s.substr(0, s.length() - 1) : "");
}
char buf[500];

bool okn(int y) {
	int x = y;
	string s = "";
	if (lo(buf[y]))
		return false;
	y++;
	while (lo(buf[y])) {
		y++;
	}
	if (up(buf[y]))
		return false;
	return y - x > 1;
}

bool punkt(char c) {
	return c != ' ' && !(lo(c) || up(c));
}

string nextt(int y) {
	string s = "";
	while (lo(buf[y]) || up(buf[y])) {
		s += buf[y];
		y++;
	}
	return s;
}

bool ccch(string s) {
	for (char c : s)
		if (!ch(c))
			return false;
	return true;
}

bool spp(string s) {
	for (char c : s)
		if (c != ' ')
			return false;
	return true;
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#endif
	cin.getline(buf, 500);
	while (strlen(buf)) {
		string s, tt;
		int n = strlen(buf);
		bool sp = false;
		bool wo = false;
		string b = "";
		vector<string> vs;
		bool cc = ch(buf[0]);
		string cur = "";
		for (int i = 0; i < n; i++) {
			if (cc && !ch(buf[i]) || (!cc && ch(buf[i]))) {
				cc = !cc;
				vs.push_back(cur);
				cur = "";
			}
			cur += buf[i];
		}
		if (cur.length())
			vs.push_back(cur);
		int k = vs.size();
		bool r = false, l = false;
		int kk = 0;
		for (int i = 0; i < k; i++) {
			if (ok(vs[i])) {
				b += vs[i] + " ";
				r = true;
				continue;
			}
			if (vs[i] == " ") {
				if (!r) {
					cout << " ";
					kk = 0;
				}
				else
					kk++;
			}
			else {
				if (!r) {
					cout << vs[i];
					r = false;
					b = "";
				}
				else {
					cout << ww(b);
					if ((!punkt(vs[i][0])) && ccch(vs[i]) && kk > 0) {
						cout << " ";
					}
					cout << vs[i];
					b = "";
					r = false;
				}
			}
		}
		if (b.length())
			cout << ww(b);
 		cout << endl;
		cin.getline(buf, 500);
	}
	return 0;
}