#include <iostream>
#include <fstream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <sstream>

using namespace std;

string s;
vector<long long> v;
vector<bool> p;
int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
#endif

	cin >> s;
	while (!s.empty() && s[0] == 'c') {
		s = s.substr(1);
	}
	int n = s.length();
	v.resize(n);
	p.resize(n);
	int ww = 0;
	int lw = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == 'w') {
			p[i] = true;
			ww++;
			lw = i;
		}
	}
	if (s.empty()) {
		cout << 0 << endl;
		return 0;
	}
	if (s[0] == 'w') {
		int q = 0, e = 0;
		for (int i = 1; i < n; i++) {
			if (s[i] == 'w')
				q++;
		}
		v[0] = q;
		for (int i = 1; i < n; i++) {
			if (s[i] == 'w')
				q--;
			else
				e++;
			v[i] = q + e;
		}
	}
	else {
		int q = 0, e = 0;
		for (int i = 1; i < n; i++) {
			if (s[i] == 'w')
				q++;
		}
		int j = 0;
		while (j < n && s[j] == 'c') {
			v[j] = q; 
            j++;
			//e++;
		}
		for (int i = j; i < n; i++) {
			if (s[i] == 'w')
				q--;
			else
				e++;
			v[i] = q + e;
		}
	}
	long long sum = 0, ss = 0;
	for (int x : v)
		ss += x;
	int cnt = 0, e = 0;
	for (int i = 0; i <= lw; i++) {
		if (s[i] == 'c') {
			e++;
			cnt++;
			sum += ww ;
			ss -= v[i];
        }
		if (!p[i])
			continue;
		int len = n - i;
		cnt += len;
		sum += ss - e * len;
		ss -= v[i];
		ww--;
	}
	printf("%.9lf\n", (double)(sum)/cnt);
	return 0;
}