import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;

public class Main {

	
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("foreign.in"));
		PrintWriter out = new PrintWriter(new FileWriter("foreign.out"));
		
		String s = in.readLine();
		while (!s.equals("") && s.charAt(0) == 'C') {
			s = s.substring(1);
		}
		int n = s.length();
		
		long v[] = new long[n];
		boolean[] p = new boolean[n];
		
		int ww = 0;
		int lw = 0;
		for (int i = 0; i < n; i++) {
			if (s.charAt(i) == 'W') {
				p[i] = true;
				ww++;
				lw = i;
			}
		}
		if (s.equals("")) {
			out.println(0);
			out.close();
			return;
		}
		if (s.charAt(0) == 'W') {
			int q = 0, e = 0;
			for (int i = 1; i < n; i++) {
				if (s.charAt(i) == 'W')
					q++;
			}
			v[0] = q;
			for (int i = 1; i < n; i++) {
				if (s.charAt(i) == 'W')
					q--;
				else
					e++;
				v[i] = q + e;
			}
		}
		else {
			int q = 0, e = 0;
			for (int i = 1; i < n; i++) {
				if (s.charAt(i) == 'W')
					q++;
			}
			int j = 0;
			while (j < n && s.charAt(j) == 'C') {
				v[j] = q; 
	            j++;
				//e++;
			}
			for (int i = j; i < n; i++) {
				if (s.charAt(i) == 'W')
					q--;
				else
					e++;
				v[i] = q + e;
			}
		}
		
		long sum = 0, ss = 0;
		
		for(int i = 0; i < v.length; i++) ss += v[i];
		//for (int x : v)
		//	ss += x;
		int cnt = 0, e = 0;
		for (int i = 0; i <= lw; i++) {
			if (s.charAt(i) == 'C') {
				e++;
				cnt++;
				sum += ww ;
				ss -= v[i];
	        }
			if (!p[i])
				continue;
			int len = n - i;
			cnt += len;
			sum += ss - e * len;
			ss -= v[i];
			ww--;
		}
		
		out.println(String.format("%.9f", ((double)sum) / cnt).replace(',', '.'));
	
		in.close();
		out.close();
	}
	
}
