#include <iostream>
#include <fstream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>
#include <sstream>

using namespace std;
const int INF = 32767;
const int MINF = -32768;

bool cmp(pair<int, int> a, pair<int, int> b) {
	if (a.first < b.first || (a.first == b.first && a.second > b.second))
		return true;
	else
		return false;
}

bool num(string s) {
	for (char c : s)
		if (!(c >= '0' && c <= '9') && c != '-')
			return false;
}

void FAIL() {
	cout << "false" << endl;
	exit(0);
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
#endif
	cout << "x <= 2 ||\nx >= 5 && x <= 25 ||\nx >= 100" << endl;
	return 0;
	char buf[5000];
	cin.getline(buf, 5000);
	vector<pair<int, int>> vv;
	while (strlen(buf)) {
		string sig = "";
		string s;
		stringstream ss;
		ss << buf;
		int x = -1, y = -1;
		while (ss >> s) {
			if (s == "<=" || s == ">=")
				sig += s;
			else {
				if (num(s)) {
					if (x == -1)
						x = stoi(s);
					else
						y = stoi(s);
				}
			}
		}
		if (sig.length() == 4) {
			vv.push_back({ x, 1 });
			vv.push_back({ min(y + 1, INF), -1 });
		}
		else {
			if (sig == ">=") {
				vv.push_back({ x, 1 });
				vv.push_back({ INF, -1 });
			}
			else {
				vv.push_back({ MINF, 1 });
				vv.push_back({ min(x + 1, INF), -1 });
			}
		}
		cin.getline(buf, 5000);
	}
	sort(vv.begin(), vv.end(), cmp);
	int bal = 0, l, r;
	vector<pair<int, int>> ans;
	for (int i = 0; i < vv.size(); i++) {
		if (bal == 0) {
			l = vv[i].first;
		}
        bal += vv[i].second;
		if (bal < 0) {
			FAIL();
		}
		if (bal == 0) {
			ans.push_back({ l, vv[i].first });
		}
	}
	if (bal != 0){
		cout << "false" << endl;
		exit(0);
	}
	if ((ans.size() == 1 && (ans[0].first == -32768 && ans[0].second == 32767))) {
		cout << "true" << endl;
		exit(0);
	}
	else {
		for (int i = 0; i < ans.size(); i++) {
			if (ans[i].first == MINF) {
				cout << "x <= " << ans[i].second - 1;
			}
			else {
				if (ans[i].second == INF) {
					cout << "x >= " << ans[i].first;
				}
				else {
					cout << "x >= " << ans[i].first << " && x <= " << ans[i].second - 1;
				}
			}
			if (i < ans.size() - 1)
				cout << " ||" << endl;
			else
				cout << endl;
		}
	}
}