#include <iostream>
#include <fstream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>
#include <sstream>

using namespace std;
const int INF = 100000;

pair<pair<bool, int>, pair<bool, int>> make_g(string l) {
	int begin = 0, end = 0;
	bool wb = false, we = false;
	int n = 0;
	for (int j = 0; j < l.length(); j++) {
		if (l[j] == '>') {
			wb = true;
			n = stoi(l.substr(j + 3, l.length() - j - 3));
			if (n == -32768)
				n = -INF;
			break;
		}
		else
			if (l[j] == '<') {
			we = true;
			n = stoi(l.substr(j + 3, l.length() - j - 3));
			if (n == 32767)
				n = INF - 1;
			break;
			}
	}
	if (wb)
		begin = n;
	else
		if (we)
			end = n;
	return make_pair(make_pair(wb, begin), make_pair(we, end));
}

bool cmp(pair<int, int> a, pair<int, int> b) {
	if (a.first < b.first || (a.first == b.first && a.second > b.second))
		return true;
	else
		return false;
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
#endif
	string s, s1;
	vector<string> a;
	while (!cin.eof()) {
		getline(cin, s1);
		if (s1.back() == '|')
			s = s1.substr(0, s1.length() - 3);
		else
			s = s1;
		a.push_back(s);
	}
	vector<pair<int, int>> v;
	for (int i = 0; i < a.size(); i++) {
		int begin, end, j = 0;
		string l, r;
		for (j = 0; j < a[i].length(); j++) {
			if (a[i][j] == '&') {
				l = a[i].substr(0, j);
				r = a[i].substr(j + 3, a[i].length() - j - 3);
				break;
			}
		}
		if (!l.empty() && !r.empty()) {
			pair<pair<bool, int>, pair<bool, int>> tmp = make_g(l);
			if (tmp.first.first)
				begin = tmp.first.second;
			if (tmp.second.first)
				end = tmp.second.second;
			pair<pair<bool, int>, pair<bool, int>> tmp2 = make_g(r);
			if (tmp2.first.first && !tmp.first.first)
				begin = tmp2.first.second;
			else
				if (tmp2.second.first && !tmp.second.first)
					end = tmp2.second.second;
				else
				{
					cout << "false" << endl;
					return 0;
				}
			if (begin > end) {
				cout << "false" << endl;
				return 0;
			}
			v.push_back(make_pair(begin, 1));
			v.push_back(make_pair(end + 1, -1));
		}
		else {
			pair<pair<bool, int>, pair<bool, int>> tmp = make_g(a[i]);
			if (tmp.first.first){
				begin = tmp.first.second;
				end = INF;
			}
			else
				if (tmp.second.first) {
				    end = tmp.second.second + 1;
					begin = -INF;
				}
			v.push_back(make_pair(begin, 1));
			v.push_back(make_pair(end, -1));
		}
	}
	sort(v.begin(), v.end(), cmp);
	vector<pair<int, int>> ans;
	int b = 0, l = v[0].first, r = 0;
	for (int i = 0; i < v.size(); i++) {
		b += v[i].second;
		if (b == 0) {
			r = v[i].first;
			ans.push_back(make_pair(l, r));
			if (i < v.size() - 1)
                if (v[i + 1].second < 0) {
				    cout << "false" << endl;
				    return 0;
			    }
			    else
				    if (i < v.size() && v[i + 1].second > 0)
					    l = v[i + 1].first;
		}
	}
	if (b != 0){
		cout << "false" << endl;
		return 0;
	}
	if ((ans.size() == 1 && (ans[0].first == -INF && ans[0].second == INF))) {
		cout << "true" << endl;
		return 0;
	}
	else
		for (int i = 0; i < ans.size(); i++) {
		    if (ans[i].first == -INF) {
			    cout << "x <= " << ans[i].second - 1;
		    }
		    else
			    if (ans[i].second == INF)
				    cout << "x >= " << ans[i].first;
			    else
				    cout << "x >= " << ans[i].first << " && x <= " << ans[i].second - 1;
			if (i < ans.size() - 1)
				cout << " ||" << endl;
			else
				cout << endl;
		}
}