#include<iostream>
#include<string>
#include<vector>
#include<sstream>
#include<algorithm>
using namespace std;

string s;
vector<pair<int, int > > v;
vector<bool > e;

pair<int, int > parse(int l, int r){
	string to = s.substr(l, r - l + 1);
	stringstream ss(to);
	char c; string q; int x;
	ss >> c >> q >> x;
	if (q == ">=") return pair <int, int >(x, 32767);
	if (q == "<=") return pair<int, int >(-32768, x);
}

bool cross(pair<int, int > a, pair<int, int > b, pair<int, int > &res){
	res=make_pair(b.first, a.second);
	return a.second >= b.first;
}

bool Union(pair<int, int > a, pair<int, int > b, pair<int, int > &res){
	if (a.first >= b.first && a.second <= b.second){
		res = b;
		return 1;
	}
	if (b.first >= a.first && b.second <= a.second){
		res = a;
		return 1;
	}

	res = make_pair(a.first, b.second);
	return a.second + 1 >= b.first;
}

int main(){
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
	while (getline(cin, s)){
		bool ok = false;
		pair<int, int > a, b;
		int l = 0, r = s.size() - 1, i = 0;
		for (i = 0; i < s.size(); i++){
			if (s[i] == '&'){
				r = i - 1;
				ok = true;
				break;
			}
		}
		a=parse(l, r);
		if (ok){
			i += 2; l = i;
			for (i = 0; i < s.size(); i++){
				if (s[i] == '&'){
					r = i - 1;
					break;
				}
			}
			b=parse(l, r);

			if (a.first>b.first) swap(a, b);
			pair<int, int > c;
			if (cross(a, b, c)){
				v.push_back(c);
				e.push_back(1);
			}
			else{
				e.push_back(0);
			}
		}
		else
			v.push_back(a), e.push_back(1);
	}
	bool Ok = false;
	for (int i = 0; i < e.size(); i++){
		if (e[i])
			Ok = true;
	}
	if (!Ok){ cout << "false"; return 0; }
	sort(v.begin(), v.end());
	vector < pair<int, int > > g;
	g.push_back(v[0]);
	for (int i = 1; i < v.size(); i++){
		pair<int, int > c;
		if (Union(g.back(), v[i], c)){
			g.back() = c;
		}
		else
			g.push_back(v[i]);
	}
	
	if (g.size() == 1 && g[0] == make_pair(-32768, 32767)){
		cout << "true";
		return 0;
	}
	else{
		for (int i = 0; i < g.size(); i++){
			if (g[i].first == -32768){
				printf("x <= %d", g[i].second);
			}else
			if (g[i].second == 32767){
				printf("x >= %d", g[i].first);
			} else
				printf("x >= %d && x <= %d", g[i].first, g[i].second);
			if (i < g.size() - 1){ puts(" ||"); }
		}
	}
}
/*
x >= 5 && x <= 10 ||
x >= 7 && x <= 20 ||
x <= 2 ||
x >= 21 && x <= 25 ||
x >= 8 && x <= 10 ||
x >= 100

*/