#pragma comment(linker, "/STACK:256000000")

#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include <time.h>
#include <memory.h>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <random>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e7);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-11;
const double PI = acos(-1);
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)(0))++)

vector<string> lines;

bool is_capit(string &s)
{
	if (s.size() < 2 || !('A' <= s[0] && s[0] <= 'Z'))
		return 0;
	for (int i = 1; i < (int)s.size(); i++)
		if (!('a' <= s[i] && s[i] <= 'z'))
			return 0;
	return 1;
}

bool is_letter(char c)
{
	return ('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z');
}

void parse(string s)
{
	vector<string> words;
	string cur = "";
	for (int i = 0; i < (int)s.size(); i++)
	{
		if (i == 0 || (is_letter(s[i - 1]) != is_letter(s[i])))
		{
			if (cur != "")
			{
				words.push_back(cur);
				cur = "";
			}
		}
		cur += s[i];
	}
	if (cur != "")
		words.push_back(cur);
	int n = words.size();
	for (int i = 0; i < n;)
	{
		int ctr = 1;
		if (is_capit(words[i]))
		{
			while (i + ctr * 2 < n && words[i + ctr * 2 - 1] == " " && is_capit(words[i + ctr * 2]))
				ctr++;
		}
		if (ctr >= 2)
		{
			string abbr = "";
			for (int j = 0; j < ctr; j++)
				abbr += words[i + j * 2][0];
			cout << abbr << " (";
			for (int j = 0; j < ctr * 2 - 1; j++)
				cout << words[i + j];
			cout << ")";
			i += ctr * 2 - 1;
		}
		else
		{
			cout << words[i];
			i++;
		}
	}
	cout << '\n';
}

void solve()
{
	string ts;
	while (getline(cin, ts))
	{
		lines.push_back(ts);
	}
	for (int i = 0; i < (int)lines.size(); i++)
		parse(lines[i]);
}

#define TASK "abbreviation"
int main()
{
	cin.tie(0); ios_base::sync_with_stdio(false);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
	freopen(TASK ".in", "rt", stdin); freopen(TASK ".out", "wt", stdout);
#endif
	srand(88);

	solve();

	return 0;
}