#pragma comment(linker, "/STACK:256000000")

#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include <time.h>
#include <memory.h>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <random>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e7);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-11;
const double PI = acos(-1);
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)(0))++)
const int MAXN = (int)2e5;

int k, n, q;
pll sum[MAXN];
vector < pll > bal;
vector < pll > sor;

void solve()
{
	scanf("%d %d\n", &n, &q);
	int cur = 0;
	for (int i = 0; i < n; ++i)
	{
		char p;
		int t, k;
		scanf("%c %d %d\n", &p, &t, &k);
		if (p == '-')
		{
			cur -= k;
		}
		else
		{
			cur += k;
		}
		bal.push_back(pll(cur, t));
	}
	int64 str = 0;

	for (int i = 0; i < n - 1; ++i)
	{
		int64 a = bal[i].first;
		int64 t = bal[i + 1].second - bal[i].second;
		if (a < 0)
		{
			sor.push_back(pll(-a, t));
			str += -a * (int64)t;
		}
	}
	sort(sor.begin(), sor.end());
	for (int i = 0; i < (int)sor.size(); ++i)
	{
		if (i)
		{
			sum[i].first += sum[i - 1].first;
			sum[i].second += sum[i - 1].second;
		}
		sum[i].first += sor[i].first * sor[i].second;
		sum[i].second += sor[i].second;
	}
	int n = sor.size();
	for (int i = 0; i < q; ++i)
	{
		int b;
		scanf("%d", &b);
		if (cur + b < 0)
		{
			printf("INFINITY\n");
			continue;
		}
		int64 ans = str;
		int l = 0, r = (int)sor.size() - 1, mid, j = n;
		while (l <= r)
		{
			mid = (l + r) >> 1;
			if (sor[mid].first <= b)
			{
				l = mid + 1;
			}
			else
			{
				r = mid - 1;
				j = mid;
			}
		}

		ans = ans - (j ? sum[j - 1].first : 0) - b * (sum[n - 1].second - (j ? sum[j - 1].second : 0));
		printf("%lld\n", ans);
	}
}

#define TASK "expect"
int main()
{
	cin.tie(0); ios_base::sync_with_stdio(false);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
	freopen(TASK ".in", "rt", stdin); freopen(TASK ".out", "wt", stdout);
#endif
	srand(88);

	solve();

	return 0;
}