#include <stdio.h>
#include <iostream>
#include <fstream>
#include <string>
#include <string.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <math.h>
#include <alg.h>
#include <algorithm>
#include <limits>
#include <limits.h>

using namespace std;

bool isRightWord(string str) {
	if (str.length() == 1) {
		return false;
	}
	if (str[0] < 'A' || str[0] > 'Z') {
		return false;
	}
	for (int i = 1; i < str.length(); ++i) {
		if (str[i] < 'a' || str[i] > 'z') {
			return false;
		}
	}
	return true;
}

string createPhrase(string str) {
	string a;
	for (int i = 0; i < str.length(); ++i) {
		if (str[i] >= 'A' && str[i] <= 'Z') {
			a += str[i];
		}
	}

	if (str.back() == ' ') {
		return a + " (" + str.substr(0, str.length() - 1) + ") ";
	}
	return  a + " (" + str + ")";
}

vector<string> split(string str) {
	string buffer;
	vector<string> result;
	for (int i = 0; i < str.length(); ++i) {
		if (str[i] == ' ' || str[i] == '.' || str[i] == ',') {
			result.push_back(buffer);
			string str2;
			str2 += str[i];
			result.push_back(str2);
			buffer = "";
		}
		else {
			buffer += str[i];
		}
	}
	if (buffer.size() != 0) {
		result.push_back(buffer);
	}
	return result;
}

int main() {
	double a, b;
	ifstream inp("abbreviation.in");
	ofstream outp("abbreviation.out");
	
	while (!inp.eof()) {
		string str;
		getline(inp, str);
		vector<string> words = split(str);
		int rightWordsCounter = 0;
		bool lastWordIsRight = false;
		string phrase;
		for (int i = 0; i < words.size(); ++i) {

			if (words[i] == " ") {
				if (lastWordIsRight) {
					phrase += words[i];
				}
				else {
					outp << words[i];
				}
				continue;
			}

			if (words[i] == "." || words[i] == ",") {
				if (lastWordIsRight && rightWordsCounter > 1) {
					string phrase2 = createPhrase(phrase);
					outp << phrase2 << words[i];
					phrase = "";
					lastWordIsRight = false;
					rightWordsCounter = 0;
				}
				else {
					outp << phrase << words[i];
					phrase = "";
					lastWordIsRight = false;
					rightWordsCounter = 0;
				}
				continue;
			}


			if (isRightWord(words[i])) {
				phrase += words[i];
				rightWordsCounter++;
				lastWordIsRight = true;
			}
			else {
				if (lastWordIsRight) {
					if (rightWordsCounter > 1) {
						string phrase2 = createPhrase(phrase);
						outp << phrase2 << words[i];
						phrase = "";
						lastWordIsRight = false;
						rightWordsCounter = 0;
					}
					else {
						outp << phrase << words[i];
						phrase = "";
						lastWordIsRight = false;
						rightWordsCounter = 0;
					}
				}
				else {
					outp << words[i];
				}
				lastWordIsRight = false;
			}
		}
		if (phrase.length() != 0) {
			if (lastWordIsRight && rightWordsCounter > 1) {
				string phrase2 = createPhrase(phrase);
				outp << phrase2;
			}
			else {
				outp << phrase;
			}
		}
		outp << "\n";
	}

	return 0;
}

