#include <cstdio>

const int LEN = 1000000;

bool a[LEN];
int _count_w[LEN]; int len = 0;
double m[LEN];

inline int count_w(int n)
{
	return _count_w[n];
}
inline int count_w(int l, int r)
{
	return (l == 0) ? count_w(r) : (count_w(r) - count_w(l - 1));
}

int main()
{
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);

	int count = 0;
	for (char x = getchar(); x == 'C' || x == 'W'; x = getchar(), ++len)
	{
		if (x == 'W') a[len] = false, ++count;
		else a[len] = true;

		_count_w[len] = count;
	}

	int last = len-1;
	for (int i = last; i >= 0; --i)
	{
		double chance = (1.0 / static_cast<double>(last-i + 1));
		double res = chance * static_cast<double>(a[i] ? count_w(i, last) : (last-i + 1 - count_w(i, last)));

		for (int k = 1; k < last-i + 1; ++k)
			res += chance * (static_cast<double>(a[i] ? count_w(i, i+k-1) : (k - count_w(i, i+k-1))) + m[i+k]);
		
		m[i] = res;
	}

	printf("%.12lf", m[0]);

	return 0;
}