#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
using namespace std;

const int MaxN = 500000;
const int Max = 32767;
const int Min = -32768;
struct el {
	el() {}
	el(int val, int isOpen) : val(val), isOpen(isOpen) {}
	int val;
	int isOpen;
};

vector<el> arr;
vector<pair<int, int>> brr;
vector<pair<int, int>> crr;

bool cmp(const el & a, const el & b) {
	if (a.val == b.val) return a.isOpen > b.isOpen;
	return a.val < b.val;
}
bool cmp2(const pair<int, int> & a, const pair<int, int> & b) {
	return a.first < b.first;
}

int main(int argc, char ** argv) {
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	string x, equal, logic;
	int val1, val2;
	while (true) {
		cin >> x >> equal >> val1 >> logic;
		if (logic.compare("&&") == 0) {
			cin >> x >> equal >> val2 >> logic;
			if (logic.compare("||") != 0) {
				arr.push_back(el(val1, 1));
				arr.push_back(el(val2, 0));
				break;
			}
			if (val1 <= val2) {
				arr.push_back(el(val1, 1));
				arr.push_back(el(val2, 0));
			}
		}
		else if (logic.compare("||") == 0) {
			if (equal.compare(">=") == 0) {
				arr.push_back(el(val1, 1));
				arr.push_back(el(Max, 0));
			}
			else {
				arr.push_back(el(Min, 1));
				arr.push_back(el(val1, 0));
			}
		}
		else {
			if (equal.compare(">=") == 0) {
				arr.push_back(el(val1, 1));
				arr.push_back(el(Max, 0));
			}
			else {
				arr.push_back(el(Min, 1));
				arr.push_back(el(val1, 0));
			}
			break;
		}
	}
	sort(arr.begin(), arr.end(), cmp);
	int open = 0;
	int openVal;
	for (size_t i = 0; i < arr.size(); ++i) {
		if (arr[i].isOpen) {
			if (open == 0) openVal = arr[i].val;
			++open;
		}
		else {
			--open;
			if (open == 0) {
				brr.push_back(make_pair(openVal, arr[i].val));
			}
		}
	}
	sort(brr.begin(), brr.end(), cmp2);
	for (size_t i = 1; i < brr.size(); ++i) {
		if (brr[i].first == brr[i - 1].second + 1) {
			brr[i - 1].second = brr[i].second;
			brr[i].first = brr[i - 1].first;
		}
	}
	for (int i = 0; i < (int)brr.size() - 1; ++i) {
		if (brr[i].first == brr[i + 1].first && brr[i].second == brr[i + 1].second) brr.erase(brr.begin() + i + 1);
	}
	if (brr.size() == 1 && brr[0].first == Min && brr[0].second == Max) cout << "true" << endl;
	else if (brr.size() == 0) cout << "false" << endl;
	else {
		for (size_t i = 0; i < brr.size(); ++i) {
			if (brr[i].first == Min) {
				cout << "x <= " << brr[i].second << (i == brr.size() - 1 ? "" : " ||") << endl;
			}
			else if (brr[i].second == Max) {
				cout << "x >= " << brr[i].first << (i == brr.size() - 1 ? "" : " ||") << endl;
			}
			else {
				cout << "x >= " << brr[i].first << " && x <= " << brr[i].second << (i == brr.size() - 1 ? "" : " ||") << endl;
			}
		}
	}
	return 0;
}