items = []


def refactor_items():
    items.sort()
    end = len(items)
    i = 0
    while i < end - 1:
        leftitem = items.__getitem__(i)
        rightitem = items.__getitem__(i + 1)
        if rightitem[0] <= leftitem[1] + 1:
            leftitem = (leftitem[0], max(rightitem[1], leftitem[1]))
            items.__delitem__(i + 1)
            items.__setitem__(i, leftitem)
            end -= 1
        else:
            i += 1


# def add_item(left, right):
#     if len(items) == 0:
#         items.append((left, right))
#
#     items_to_remove = []
#     for item in items:
#         if left < item[0] and right > item[1]:
#             # item is fully inside
#             item[0] = left
#             item[1] = right
#         elif left >= item[0] and right <= item[1]:
#             # item is fully outside
#             items_to_remove.append(item)
#             items.append((left, right))
#         elif item[0] <= left and left <= item[1] + 1:
#             # left is inside or touches
#             item[1] = right
#         elif item[0] - 1 <= right and right <= item[1]:
#             # right is inside or touches
#             item[0] = left
#         else:
#             # item does not intersect or touch
#             items.append((left, right))


def process_line(line):
    params = line.split(' ')
    if params[1] == '<=':
        left = -32768
        right = int(params[2])
    else:
        left = int(params[2])
        if len(params) > 3:
            right = int(params[6])
        else:
            right = 32767
    if left > right:
        pass
    else:
        items.append((left, right))


def main():
    with open('hard.in') as input:
        lines = input.readlines()
    with open('hard.out', 'w') as output:
        for line in lines:
            process_line(line)
        refactor_items()
        if len(items) == 0:
            output.write("false")
        elif items[0][0] == -32768 and items[0][1] == 32767:
            output.write("true")
        else:
            for i in range(0, len(items)):
                item = items[i]
                if item[0] != -32768 and item[1] != 32767:
                    output.write("x >= " + str(item[0]) + " && x <= " + str(item[1]))
                elif item[0] != -32768:
                    output.write("x >= " + str(item[0]))
                elif item[1] != 32767:
                    output.write("x <= " + str(item[1]))
                if i != len(items) - 1:
                    output.write(" ||\n")
                else:
                    output.write("\n")

# def test():
#     pass
main()
# test()
