import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;

/**
 * Created by neerc on 05.12.2016.
 */
public class H {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader("jenga.in"));
        FileWriter wrt = new FileWriter("jenga.out");
        String str[] = br.readLine().split(" ");
        int n = Integer.parseInt(str[0]);
        int w = Integer.parseInt(str[1]);

        String str1[] = br.readLine().split(" ");
        int h = Integer.parseInt(str1[0]);
        int m = Integer.parseInt(str1[1]);
        boolean exists[][] = new boolean[h + 1][n + 1];
        for (boolean[] item : exists) {
            Arrays.fill(item, true);
        }
        int[] existCount = new int[h + 2];
        Arrays.fill(existCount, n);
        existCount[h + 1] = 0;
        double centroidX[] = new double[h + 1];
        double centroidY[] = new double[n + 1];
        Arrays.fill(centroidX, n / 2.0);
        Arrays.fill(centroidY, n / 2.0);

        for (int i = 0; i < m; i++) {
            String[] step = br.readLine().split(" ");
            int l = Integer.parseInt(step[0]);
            int k = Integer.parseInt(step[1]);
            exists[l][k] = false;
            existCount[l]--;
//            double sum = 0;
//            int count = 0;
//            for (int blockNumber = 1; blockNumber < n + 1; blockNumber++) {
//                if (exists[l][blockNumber]) {
//                    sum += blockNumber - 0.5;
//                    count++;
//                }
//            }
//            sum = sum / count;
//            if (l % 2 == 1) {
//                centroidX[l] = sum;
//            } else {
//                centroidY[l] = sum;
//            }
            double currentCenterX = n/2.0;
            double currentCenterY = n/2.0;
            int currentCount = 0;
            for (int levelNumber = n; levelNumber > 0; levelNumber--) {
                double sum = 0;
                int count = 0;
                if (levelNumber == l) {
                    for (int blockNumber = 1; blockNumber < n + 1; blockNumber++) {
                        if (exists[levelNumber][blockNumber]) {
                            sum += blockNumber - 0.5;
                            count++;
                        }
                    }
                    sum = sum / count;
                    if (levelNumber % 2 == 1) {
                        centroidX[levelNumber] = sum;
                    } else {
                        centroidY[levelNumber] = sum;
                    }
                }
                if (levelNumber % 2 == 1) {
                    currentCenterX = (currentCenterX * currentCount + centroidX[levelNumber] * existCount[levelNumber]) / (currentCount + existCount[levelNumber]);
                } else {
                    currentCenterY = (currentCenterY * currentCount + centroidY[levelNumber] * existCount[levelNumber]) / (currentCount + existCount[levelNumber]);
                }
                currentCount += existCount[levelNumber];

                int maxI = 0;
                int minI = n + 1;
                for (int r = 1; r < n + 1; r++) {
                    if (exists[levelNumber - 1][r]) {
                        if (r > maxI) {
                            maxI = r;
                        }
                        if (r < minI) {
                            minI = r;
                        }
                    }
                }
                minI--;
                if (levelNumber % 2 == 0) {
                    if (currentCenterX >= maxI || currentCenterX <= minI) {
                        wrt.append("yes\n");
                        wrt.append(String.valueOf(i + 1));
                        wrt.close();
                        return;
                    }
                } else {
                    if (currentCenterY >= maxI || currentCenterY <= minI) {
                        wrt.append("yes\n");
                        wrt.append(String.valueOf(i + 1));
                        wrt.close();
                        return;
                    }
                }
            }

        }

        wrt.append("no");
        wrt.close();
    }
}

