#include <iostream>
#include <fstream>
#include <vector>
#include <string>

using namespace std;

const int inf = 32769;

int main()
{

    ifstream cin("hard.in");
    ofstream cout("hard.out");
    vector <bool> met(65538, false);
    string s;
    while (getline(cin, s)) {
        int len = s.length();
        int a = -inf, b = inf;
        for (int i = 0; i < len; ++i) {
            if (s[i] == '>') {
                a = s[i + 3] - '0';
                for (int j = i + 4; ; ++j)
                    if (s[j] >= '0' && s[j] <= '9')
                        a = 10*a + (s[j] - '0');
                    else
                        break;
            }
            if (s[i] == '<') {
                b = s[i + 3] - '0';
                for (int j = i + 4; ; ++j)
                    if (s[j] >= '0' && s[j] <= '9')
                        b = 10*b + (s[j] - '0');
                    else
                        break;
            }
        }
        for (int x = a; x <= b; ++x)
            met[x + inf] = true;
    }

    vector <int> v;
    if (met[0])
        v.push_back(-inf);
    for (int x = -inf + 1; x < inf; ++x) {
        if (met[x + inf - 1] && !met[x + inf])
            v.push_back(x - 1);
        if (!met[x + inf - 1] && met[x + inf])
            v.push_back(x);
    }
    if (met[2*inf - 1])
        v.push_back(inf);

    if (v.empty()) {
        cout << "false\n";
        return 0;
    }

    if (v[0] == -inf && v[1] == inf) {
        cout << "true\n";
        return 0;
    }
    for (int i = 0; 2*i < v.size(); ++i) {
        if (v[2*i] == -inf)
            cout << "x <= " << v[2*i + 1];
        else if (v[2*i + 1] == inf)
            cout << "x >= " << v[2*i];
        else
            cout << "x >= " << v[2*i] << " && x <= " << v[2*i + 1];
        if (2*(i + 1) < v.size())
            cout << " ||\n";
        else
            cout << "\n";
    }

}
