#include <vector>
#include <iostream>
#include <fstream>
#include <cmath>
#include <map>
#include <algorithm>
#include <array>
#include <string>


using namespace std;

/*bool isup(string s) {
	if (isupper(s[0]) && s.size() != 1)
		for (int i = 1; i < s.size(); i++) {
			if (isupper(s[i])) return false;
		}
	else return false;
	return true;
}

bool isdel(char c) {
	if (c == '.' || c == ',') return true;
	return false;
}

int main() {
	ifstream cin("abbreviation.in");
	ofstream cout("abbreviation.out");
	string curs, cur;
	string abr1, abr2;
	getline(cin, curs);
	while (curs != "") {
		for (int i = 0; i < curs.size(); i++) {
			char c = curs[i];
			bool f1 = isdel(c);
			if (c == ' ' || f1) {
				bool f2 = isup(cur);
				if (cur == "" || f1 || !f2) {
					if (!f2) {
						if (abr1.size() > 1) {
							cout << abr1 << " (" << abr2 << ')' << ' ';
						}
						else {
							if (abr1.size() != 0) cout << abr2 << ' ';
						}
						cout << cur << c;
						abr1 = "";
						abr2 = "";
						cur = "";
						continue;
					}
					else {
						if (abr1.size() >= 1) {
							cout << abr1 << cur[0] << " (" << abr2 << ' ' << cur << ')';
							cout << c;
						}
						else {
							 cout << cur << c;
						}
						abr1 = "";
						abr2 = "";
						cur = "";
						continue;
					}
		
				}
				if (f2) {
					abr1 += cur[0];
					if (abr2.size() == 0) abr2 = cur;
					else abr2 = abr2 + ' ' + cur;
					cur = "";
				}
			}
			else {
				cur += curs[i];
			}
		}
		if (cur != "") {
			if (isup(cur)) {
				if (abr1.size() >= 1) {
					cout << abr1 << cur[0] << " (" << abr2 << ' ' << cur << ')';
				}
				else cout << cur;
			}
			else 
				if (abr1.size() > 1) {
				cout << abr1 << " (" << abr2 << ')' << cur;
				}
				else
					if (abr1.size() == 1)
						cout << abr2 << ' ' << cur;
					else cout << cur;
		}
		abr1 = "";
		abr2 = "";
		cur = "";
		cout << endl;
		curs = "";
		getline(cin, curs);
	}

}
/*
This is ACM North Eastern European Regional Contest,
sponsored by Inter Business Machines.
The. Best. Contest. Ever.
A Great Opportunity for all contestants

Oh  No  Extr Spaces. And,Punc Ruin Every

*/


struct el{
	int a;
	char c;
	el(){
		a = 0;
		c = '0';
	}
	el(int i, char l){
		a = i;
		c = l;
	}
	void set(int i, char l){
		a = i;
		c = l;
	}
};

bool isend = false;

inline pair<int,int> FRMT(string s)
{
	int E;
	if (s[s.size() - 1] == '|')
		E = 2;
	else
	{
		E = 0;
		isend = true;
	}

	int tmp;
	if (s.size() < 19)
	{
		tmp = stoll(s.substr(5, s.size() - E));
		if (s[2] == '<')
			return make_pair(-32768, tmp);
		else
			return make_pair(tmp, 32767);
	}
	else
	{
		int i = s.find('&');
		tmp = stoll(s.substr(5, i-1));
		int tmp2 = stoll(s.substr(i + 8, s.size() - E));

		if (tmp <= tmp2)
			return make_pair(tmp, tmp2);
		else
			return make_pair(99999, 99999);
	}

}

vector<pair<int, int>> ADD(vector<pair<int, int>> T, pair<int, int> A)
{
	if (!T.size())
	{
		T.push_back(A);
		return T;
	}

	int beg = -1, end = -1;
	int Beg = -1, End = -1;//beg  , end 
	if (T[0].first >= A.second)
	{
		if (T[0].first == A.second || T[0].first-1 == A.second)
		{
			T[0].first = A.first;
			return T;
		}
		T.insert(T.begin(), A);
		return T;
	}
	if (T[T.size()-1].second <= A.first)
	{
		if (T[T.size() - 1].second == A.first || T[T.size() - 1].second+1 == A.first)
		{
			T[T.size()-1].second = A.second;
			return T;
		}
		T.push_back(A);
		return T;
	}
	for (int i(0); i < T.size();i++)
	{
		if (beg == -1 && A.first >= T[i].first && A.first <= T[i].second)
			beg = i;
		if (end ==-1 && A.second >= T[i].first && A.second <= T[i].second)
			end = i;
		if (i!= T.size() && Beg != -1 && T[i].second < A.first && T[i+1].first > A.first)
			Beg = i;
		if (i != T.size()-1 && End ==-1 && T[i].first > A.second && T[i-1].second < A.second)
			End = i;
	}
	if (T[0].first > A.first)
		Beg = 0;
	if (T[T.size() - 1].second < A.second)
		End = T.size()-1;
	int b,e;

	if (beg == -1)
		b = Beg;
	else
		b = beg;
	if (end == -1)
		e = End;
	else
		e = end;
	
	int tmp,tmp2;

	if (beg == -1)
		tmp = A.first;
	else
		tmp = min(T[b].first, A.first);

	if (end == -1)
		tmp2 = A.second;
	else
		tmp2 = max(T[e].second, A.second);

	pair <int, int> pr = make_pair(tmp,tmp2);


	if (b != e)
		T.erase(T.begin() + b, T.begin() + e);

	T.insert(T.begin() + b, pr);
	return T;
}

void main()
{
	vector<pair<int, int>> T;

	bool b;
	ifstream cin("hard.in");
	ofstream cout("hard.out");
	while (!isend)
	{
		string S;
		getline(cin, S);
		pair<int, int> p = FRMT(S);
		if (p.first != 99999)
			T = ADD(T, p);
	}

	if (!T.size())
		cout << "false" << endl;

	if (T.size() == 1 && T[0].first == -32768 && T[0].second == 32767)
		cout << "true" << endl;

	for (int i(0); i < T.size(); i++)
	{
		if (T[i].first == -32768)
		{
			cout << "x <= " << T[i].second;
		}
		else if (T[i].second == 32767)
		{
			cout << "x >= " << T[i].first;
		}
		else
		{
			cout << "x >= " << T[i].first << " && x <= " << T[i].second;
		}
		if (i != T.size() - 1)
			cout << " ||" << endl;
	}

}

/*
x >= 5 && x <= 10 ||
x >= 7 && x <= 20 ||
x <= 2
*/