#include <iostream>
#include <algorithm>
#include <string>
#include <map>
#include <vector>
#include <set>
#include <fstream>
#include <iterator>
#include <cstdint>
using namespace std;

#define TO_IDX(x) (x+32768)

int main()
{
	vector<int8_t> v(65536, 0);
	
	ifstream in("hard.in");
	ofstream out("hard.out");

	
	string token;
	bool correct = true;
	while (in >> token && correct)
	{
		int l = -32768;
		int r = 32767;
		if (token == "x")
		{
			in >> token;
			if (token == ">=") 
				in >> l;
			else if (token == "<=") in >> r;

			if (!(in >> token))
			{
				if (r < l) { correct = false; break; }
				for (int i = TO_IDX(l), sz = TO_IDX(r + 1); i < sz; i++) v[i] = 1;
				break;
			}

			if (token == "&&")
			{
				in >> token;
				if (token == "x")
				{
					in >> token;
					if (token == ">=")
					{
						int m;
						in >> m;
						l = max(m, l);
					}
					else if (token == "<=")
					{
						int m;
						in >> m;
						r = min(m, r);
					}
					if (!(in >> token))
					{
						if (r < l) { correct = false;  break; }
						for (int i = TO_IDX(l), sz = TO_IDX(r + 1); i < sz; i++) v[i] = 1;
						break;
					}
				}
			}

			if (token == "||")
			{
				if (r < l) { correct = false;  break; }
				for (int i = TO_IDX(l), sz = TO_IDX(r + 1); i < sz; i++) v[i] = 1;
			}
		}
	}

	if (!correct)
	{
		out << "false";
		return 0;
	}

	auto left = find(v.begin(), v.end(), 1);
	auto right = find(left, v.end(), 0);
	if (left == v.end())
	{
		out << "false";
		return 0;
	}

	if (left == v.begin() && right == v.end())
	{
		out << "true";
		return 0;
	}

	while(left != v.end())
	{		
		if (left == v.begin())
		{
			out << "x <= " << right - v.begin() - 32769;
		}
		else if (right == v.end())
		{ 
			out << "x >= " << left - v.begin() - 32768;
		}
		else
		{
			out << "x >= " << left - v.begin() - 32768 << " && ";
			out << "x <= " << right - v.begin() - 32769;
		}

		left = find(right, v.end(), 1);
		right = find(left, v.end(), 0);
		if (left != v.end()) out << " || " << endl;
	}	

	return 0;
}