#include <iostream>
#include <algorithm>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <cstring>
#include <ctype.h>

#define NAME "abbreviation"
#define X first
#define Y second

using namespace std;

typedef long long int64;

vector<string> f(string & s) {
	vector<string> res;

	int l = 0, r = 0, ll = 0;
	int state = 0;
	vector<pair<int, int>> u;
	while (r < s.length()) {
		switch (state) {
		case 0:
			ll = r;
			if (isupper(s[r])) {
				state = 1;
				++r;
			}
			else {
				if (!isalpha(s[r])) {
					state = 3;
				}
				else {
					state = 4;
				}
			}
			break;
		case 1:
			if (islower(s[r])) {
				state = 2;
				++r;
			}
			else {
				state = 4;
			}
			break;
		case 2:
			if (islower(s[r])) {
				++r;
				continue;
			}
			if (s[r] == ' ') {
				u.push_back(make_pair(ll, r - 1));
				++r;
				state = 0;
			}
			else if (!isalpha(s[r])) {
				u.push_back(make_pair(ll, r - 1));
				ll = r;
				state = 3;
			}
			else {
				state = 4;
			}
			break;
		case 3:
			if (u.size() > 1) {
				string abbr;
				for (int i = 0; i < u.size(); ++i) {
					abbr.push_back(s[u[i].X]);
				}
				
				abbr.push_back(' ');
				abbr.push_back('(');

				res.push_back(abbr);
				res.push_back(s.substr(l, u.back().Y - l + 1));
				res.push_back(")");
				l = u.back().Y + 1;	
			}
			u.clear();
			res.push_back(s.substr(l, r - l + 1));
			++r;
			l = r;
			state = 0;
			break;
		case 4:
			if (isalpha(s[r])) {
				++r;
			}
			else {
				state = 3;
			}
		}
	}
	
	if (state == 2) {
		u.push_back(make_pair(ll, r - 1));
	}

	if (u.size() > 1) {
		string abbr;
		for (int i = 0; i < u.size(); ++i) {
			abbr.push_back(s[u[i].X]);
		}

		abbr.push_back(' ');
		abbr.push_back('(');

		res.push_back(abbr);
		res.push_back(s.substr(l, u.back().Y - l + 1));
		res.push_back(")");
		l = u.back().Y + 1;
	}
	u.clear();
	res.push_back(s.substr(l, r - l + 1));
	++r;
	l = r;
	state = 0;

	return res;
}

int main() {
	freopen(NAME ".in", "r", stdin);
	freopen(NAME ".out", "w", stdout);
	
	string s;
	while (getline(cin, s)) {
		vector<string> str = f(s);
		for (auto & i : str) {
			cout << i;
		}
		cout << endl;
	}

	return 0;
}