
#include <iostream>
#include <algorithm>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <cstring>

#define NAME "foreign"

using namespace std;

typedef long long int64;

int main() {
	freopen(NAME ".in", "r", stdin);
	freopen(NAME ".out", "w", stdout);

	string s;
	getline(cin, s);
	const char *a = s.c_str();
	const int Len = s.length();
	vector<int> ws(Len), cs(Len);
	vector<int64> wss(Len), css(Len);

	int wcounter, ccounter;
	int64 wacc, cacc;
	wcounter = ccounter = wacc = cacc= 0;
	for (int i = 0; i < Len; ++i) {
		ws[i] = a[i] == 'W' ? ++wcounter : wcounter;
		wss[i] = (wacc += wcounter);
		cs[i] = a[i] == 'C' ? ++ccounter : ccounter;
		css[i] = (cacc += ccounter);
	}

	vector<double> ksi(Len+1);
	ksi[1] = 0;
	double ksiSum = 0.0;
	for (int ksiIdx = 2; ksiIdx <= Len; ++ksiIdx) {
		const int idx = Len - ksiIdx;
		const int64 ankw = wacc - (idx == 0 ? 0 : wss[idx - 1]) - ksiIdx * ws[idx];
		const int64 ankc = cacc - (idx == 0 ? 0 : css[idx - 1]) - ksiIdx * cs[idx];
		const int64 magic = (a[Len - ksiIdx] == 'C' ? ankw : ankc);
		ksiSum += (ksi[ksiIdx] = (ksiSum + magic) / (double)ksiIdx);
	}

	printf("%.9lf", ksi[Len]);
	
	return 0;
}
