#include <iostream>
#include <algorithm>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <cstring>

#define NAME "hard"
#define X first
#define Y second
using namespace std;

typedef long long int64;

#define AMIN -32768
#define AMAX 32767

inline void outpair(pair<int, int> &p) {
	if (p.X == AMIN && p.Y == AMAX) {
		cout << "true";
	}
	else if (p.X == AMIN) {
		cout << "x <= " << p.Y;
	}
	else if (p.Y == AMAX) {
		cout << "x >= " << p.X;
	}
	else {
		cout << "x >= " << p.X << " && x <= " << p.Y;
	}
}

inline void intersect(const vector<pair<int, int>> & win, vector<pair<int, int>> & wout) {
	vector<pair<int, int>> v;
	v.reserve(win.size() * 2);
	for (auto & i : win) {
		v.push_back({ i.X, 0 });
		v.push_back({ i.Y, 1 });
	}

	sort(v.begin(), v.end());
	int depth = 0;
	pair<int, int> p;
	bool flag = false;
	for (auto & i : v) {
		if (i.Y == 0) {
			++depth;
			if (depth == 1) {
				if (flag) {
					flag = false;
					if (p.Y + 1 >= i.X) {

					}
					else {
						wout.push_back(p);
						p.X = i.X;
					}
				}
				else {
					p.X = i.X;
				}
			}
		}
		else {
			if (depth == 1) {
				p.Y = i.X;
				flag = true;
			}
			--depth;
		}
	}

	if (flag) {
		wout.push_back(p);
	}
}

int main() {
	freopen(NAME ".in", "r", stdin);
	freopen(NAME ".out", "w", stdout);

	vector<pair<int, int>> w;
	vector<pair<int, int>> wout;
	string s;
	while (true) {
		getline(cin, s);
		if (s.find('&') != std::string::npos) {
			int xpos = s.find('>') + 3;
			int ypos = s.find('<') + 3;
			int x = strtol(s.c_str() + xpos, NULL, 10);
			int y = strtol(s.c_str() + ypos, NULL, 10);
			if (x > y) {
		
			}
			else {
				w.push_back({ x, y });
			}
		}
		else {
			int idx = s.find('=');
			int x = strtol(s.c_str() + idx + 2, NULL, 10);
			if (s.find('<') == std::string::npos)
				w.push_back({ x, AMAX });
			else
				w.push_back({ AMIN, x });
		}

		if (s.find('|') == std::string::npos)
			break;
	}

	intersect(w, wout);

	if (wout.empty()) {
		cout << "false" << endl;
	}
	else {
		for (int i = 0; i < wout.size() - 1; ++i) {
			outpair(wout[i]);
			cout << " ||" << endl;
		}
		outpair(wout.back());
	}

	return 0;
}

/*
#include <iostream>
#include <algorithm>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <cstring>

#define NAME "foreign"

using namespace std;

typedef long long int64;

int main() {
	freopen(NAME ".in", "r", stdin);
	freopen(NAME ".out", "w", stdout);

	string s;
	getline(cin, s);
	const char *a = s.c_str();
	const int Len = s.length();
	vector<int> ws(Len), cs(Len);
	vector<int64> wss(Len), css(Len);

	int wcounter, ccounter, wacc, cacc;
	wcounter = ccounter = wacc = cacc= 0;
	for (int i = 0; i < Len; ++i) {
		ws[i] = a[i] == 'W' ? ++wcounter : wcounter;
		wss[i] = (wacc += wcounter);
		cs[i] = a[i] == 'C' ? ++ccounter : ccounter;
		css[i] = (cacc += ccounter);
	}
	return 0;
}
*/