#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <string>

using namespace std;
#define FOR(i,n) for(int (i) = 0; (i) < (int)(n); ++(i))
#define forn(i,n) for(int (i) = 0; (i) < (int)(n); ++(i))
#define for1(i,n) for(int (i) = 1; (i) <= (int)(n); ++(i))
#define sz(v) (int)v.size()
#define pb push_back

bool is_letter(char c) {
	return (c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z');
}

int n;
string st;

string parse_word(int&i) {
	string ret = "";
	while (i < n && is_letter(st[i])) {
		ret += st[i];
		++i;
	}
	return ret;
}

bool is_cap(string word) {
	if (sz(word) <= 1) return false;
	if (word[0] <'A' || word[0] > 'Z') return false;
	for (int i = 1; i < sz(word); ++i) {
		if (word[i] <'a' || word[i] > 'z') return false;
	}
	return true;
}

string make_abr(vector<string> &words) {
	string ret = "";
	for (auto &word : words) {
		ret += word[0];
	}
	return ret;
}

string parse_mid(int &i) {
	string ret = "";
	while (i < n && !is_letter(st[i])) {
		ret += st[i];
		++i;
	}
	return ret;
}

string concat(vector<string> &words) {
	string ret = "";
	FOR(i, sz(words)) {
		ret += words[i];
		if (i + 1 < sz(words)) ret += ' ';
	}
	return ret;
}

string norm(string st) {
	::st = st;
	n = sz(st);
	string ret = "";
	
	int i = 0;
	while (true) {
		while (i < n && !is_letter(st[i])) {
			ret += st[i];
			++i;
		}
		if (i == n) break;
		int start = i;
		vector<string> words;
		while (true) {
			string word = parse_word(i);

			if (word == "") {
				if (sz(words) > 1) {
					ret += make_abr(words);
					ret += " (";
				}
				ret += st.substr(start, i - start);
				if (sz(words) > 1) {
					ret += ")";
				}
				break;
			}

			if (!is_cap(word)) {
				if (sz(words) > 1) {
					ret += make_abr(words);
					ret += " (";
				}
				ret += concat(words);
				if (sz(words) > 1) {
					ret += ")";
				}
				if (sz(words)) ret += ' ';
				ret += word;
				break;
			}
			words.pb(word);
			string mid = parse_mid(i);
			if (mid != " ") {
				if (sz(words) > 1) {
					ret += make_abr(words);
					ret += " (";
				}
				ret += concat(words);
				if (sz(words) > 1) {
					ret += ")";
				}
				ret += mid;
				break;
			}
		}
	}

	return ret;
}

void solve(){
	char buf[256];
	while (cin.getline(buf, 256)) {
		printf("%s\n", norm(string(buf, buf+strlen(buf))).c_str());
	}
}

int main(){
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
#define task "abbreviation"
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
#endif
	solve();
	return 0;
}