#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <string>
#include <cassert>

using namespace std;
#define FOR(i,n) for(int (i) = 0; (i) < (int)(n); ++(i))
#define forn(i,n) for(int (i) = 0; (i) < (int)(n); ++(i))
#define for1(i,n) for(int (i) = 1; (i) <= (int)(n); ++(i))
#define sz(v) (int)v.size()
#define pb push_back
#define mp make_pair
#define all(v) (v).begin(), (v).end()

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii > vpi;

typedef long long LL;


const int N = 500007; //TODO 500007
struct node {
	int to[26];

	node() {
		memset(to, -1, sizeof to);
	}
} T[N];
int tsize = 1;
char buf[N];
int n;
vector<int> G[10 * N], RG[10 * N];
vector<int> mas[N], Z[N], Y[N];
int xcnt;
int par[N];

string ans[2][N];

int newnode() {
	return tsize++;
}

void add_string(string st, int u) {
	int n = sz(st);
	int root = 0;
	FOR(i, n) {
		int c = st[i] - 'a';
		if (T[root].to[c] == -1) {
			T[root].to[c] = newnode();
			par[T[root].to[c]] = root;
		}
		root = T[root].to[c];
	}
	mas[root].pb(u);
}

int neg(int i) {
	return 2 * i + 1;
}

int uxix(int i) {
	return 2 * i;
}

int negate(int u) {
	if (u % 2 == 0) return u + 1;
	return u - 1;
}

void add_imp(int u, int v) {
	G[u].pb(v);
	RG[v].pb(u);
	G[negate(v)].pb(negate(u));
	RG[negate(u)].pb(negate(v));
}

void add_kam(int u, int v) {
	add_imp(negate(u), v);
}

void make_x(string st, int i) {
	int pos = -1;
	int n = sz(st);
	FOR(j, n) {
		if (st[j] == '?') pos = j;
	}
	if (pos == -1) {
		if (st[0] == '0') add_imp(uxix(i), neg(i));
		else add_imp(neg(i), uxix(i));

		int val = st[0];
		st[0] = '0';
		add_string(st, neg(i));
		ans[0][i] = st;
		st[0] = '1';
		add_string(st, uxix(i));
		ans[1][i] = st;
		st[0] = val;
	}
	else {
		st[pos] = '0';
		add_string(st, neg(i));
		ans[0][i] = st;
		st[pos] = '1';
		ans[1][i] = st;
		add_string(st, uxix(i));
	}
}

int newvar() {
	return xcnt++;
}

bool used[10 * N];
int comp[10 * N];
vector<int> order;
int value[10 * N];

void dfs(int u) {
	used[u] = true;
	for (int to : G[u]) {
		if (!used[to]) dfs(to);
	}
	order.pb(u);
}

void rdfs(int u, int c) {
	comp[u] = c;
	for (int to : RG[u]) {
		if (comp[to] == 0) rdfs(to, c);
	}
}

void solve() {
	scanf("%d", &n);
	FOR(i, n) {
		scanf("%s", buf);
		string st = string(buf, buf + strlen(buf));
		make_x(st, i);
	}
	xcnt = n;

	FOR(i, tsize) {
		if (sz(mas[i]) == 0) {
			continue;
		}
		int cnt = sz(mas[i]);
		vector<int> y(cnt), z(cnt);
		FOR(j, cnt) y[j] = newvar();
		FOR(j, cnt) z[j] = newvar();
		vector<int> &x = mas[i];

		Y[i] = y;
		Z[i] = z;

		FOR(j, cnt) {
			add_imp(x[j], z[j + 1]);
			add_imp(x[j], y[j - 1]);
			add_imp(y[j], y[j - 1]);
			add_imp(y[j], negate(x[j]));
			add_imp(z[j], z[j + 1]);
			add_imp(z[j], negate(x[j]));
		}

		for (int xx : x) {
			int u = par[i];
			do {
				if (sz(mas[u]) > 0) {
					add_imp(xx, Y[u][sz(mas[u]) - 1]);
				}
				if (u == 0) break;
				u = par[u];
			} while (u);
		}

		FOR(i, xcnt) {
			if (!used[i]) {
				dfs(i);
			}
		}
		reverse(all(order));
		int cur_comp = 0;
		for (int u : order) {
			++cur_comp;
			if (comp[u] == 0) {
				rdfs(u, cur_comp);
			}
		}
		bool ok = true;
		FOR(i, xcnt) {
			if (comp[i] == comp[negate(i)]) ok = false;
			else if (comp[i] < comp[negate(i)]) {
				value[i] = false;
				value[negate(i)] = true;
			}
			else {
				value[negate(i)] = true;
				value[i] = false;
			}
		}

		if (!ok) puts("NO");
		else {
			puts("YES");
			FOR(i, n) {
				if (value[uxix(i)]) {
					printf("%s\n", ans[1][i].c_str());
				}
				else  {
					printf("%s\n", ans[0][i].c_str());
				}
			}
		}
	}
}

int main(){
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
#define task "binary"
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
#endif
	solve();
	return 0;
}