inp = open('abbreviation.in', 'r')
out = open('abbreviation.out', 'w')

def is_cap(word):
	if len(word) < 2:
		return False
	if word[0].lower() == word[0]:
		return False
	for ch in word[1:]:
		if ch.upper() == ch:
			return False
	return True

def abbr(caps, res):
	# Abbreviate
	abr = ''
	#print (caps)
	for i in range(0, len(caps)):
		abr += caps[i][0]
	res.append(abr)
	res.append(' (')
	res.append(' '.join(caps))
	res.append(')')

while True:
	line = inp.readline()
	if len(line) <= 1:
		break
	line = line[:-1]
	
	tokens = []
	cur_word = ''
	cur_pun = ''
	for ch in line:
		if ch.isalpha():
			if len(cur_pun) != 0:
				tokens.append(cur_pun)
				cur_pun = ''
			cur_word += ch
		else:
			if len(cur_word) != 0:
				tokens.append(cur_word)
				cur_word = ''
			cur_pun += ch
	if len(cur_word) != 0:
		tokens.append(cur_word)
	if len(cur_pun) != 0:
		tokens.append(cur_pun)

	#print (tokens)

	res = []
	caps = []
	i = 0
	while i < len(tokens):
		#print (res, 'r')
		#print (caps, 'c')
		if i & 1 == 1 and tokens[i] == ' ':
			if len(caps) == 0:
				res.append(' ')
		elif i & 1 == 0 and is_cap(tokens[i]):
			caps.append(tokens[i])
		else:
			if len(caps) > 1:
				abbr(caps, res)
			else:
				res.extend( caps )  
			if i & 1 == 0 and len(caps) > 0:
				res.append( ' ' )
			caps = []
			res.append( tokens[i] )
		i += 1

	if len(caps) != 0:
		if len(caps) > 1:
			abbr(caps, res)
		else:
			res.extend(caps)
	if i & 1 == 1 and len(caps) > 0:
		res.append( ' ' )

	out.write(''.join(res) + '\n')
	



