#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>

using namespace std;

ifstream in("abbreviation.in");
ofstream out("abbreviation.out");

bool normal(const string& s) {
	if (s.size() <= 1) {
		return false;
	}
	if (s[0] >= 'A' && s[0] <= 'Z') {
		for (int i = 1; i < s.size(); ++i) {
			if (s[i] < 'a' || s[i] > 'z') {
				return false;
			}
		}
		return true;
	}
	return false;
}

string tpel(const vector<string>& v) {
	if (v.empty()) {
		return "";
	}
	string answer = "";
	if (v.size() > 1) {
		for (int j = 0; j < v.size(); ++j) {
			answer += v[j][0];
		}
		answer += " (";
		for (int j = 0; j < v.size(); ++j) {
			answer += v[j];
			if (j != v.size() - 1) {
				answer += " ";
			}
		}
		answer += ")";
		return answer;
	}
	return v[0];
}

int main()
{
	string line, s;
	while (getline(in, line)) {
		line += '.';
		string cur = "", answer = "";
		vector<string> v;
		for (int i = 0; i < line.size(); ++i) {
			//cout << cur << " " << v.size() << " " << line[i] << endl;
			/*if (line[i] == ' ' && v.size() > 0 && cur == "") {
				answer += tpel(v);
				answer += cur + line[i];
				v.clear();
				continue;
			}*/
			if (line[i] == ' ' || line[i] == ',' || line[i] == '.') {
				if (normal(cur) && line[i] == ' ') {
					v.push_back(cur);
				}	else {
					bool lav = false;
					if (normal(cur)) {
						v.push_back(cur);
						cur = "";
						lav = true;
					}
					answer += tpel(v);					
					if (!lav && !v.empty())
						answer += " ";
					answer += cur + line[i];					
					v.clear();
				}
				cur = "";
			}	else {
				cur = cur + line[i];
			}
		}
		answer.erase(answer.end() - 1);
		out << answer << endl;
	}
}