#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>
#include <iomanip>

using namespace std;

typedef long long ll;

const int maxn = 1000500;

int suf[2][maxn];
ll prefsum[2][maxn];
double m[maxn];
double msum[maxn];

int main()
{
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
	string s;
	cin >> s;
	int n = s.size();


	for (int i = n - 1; i >= 0; --i)
	{
		int t = (s[i] == 'C' ? 1 : 0);
		
		suf[0][i] = suf[0][i + 1];
		suf[1][i] = suf[1][i + 1];
		
		prefsum[0][i] = prefsum[0][i + 1];
		prefsum[1][i] = prefsum[1][i + 1];
		msum[i] = msum[i + 1];

		suf[t][i]++;
		prefsum[t][i] += n - i;

		m[i] = (msum[i + 1] + prefsum[1-t][i]) / double(n - i);
		
		msum[i] += m[i];
	}

	cout << setprecision(10) << fixed << m[0] << endl;

}