#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>
#include <algorithm>

using namespace std;

vector<pair<int, bool> > p;
vector<pair<int, int> > res;

bool get_line()
{
	bool r = false;
	char c;
	char s;
	if (!(cin >> c)) {
		return false;
	}
	cin >> s >> c;
	int a = -32768;
	int b = 32767;
	if (s == '>')
		cin >> a;
	else {
		cin >> b;
	}

	if (cin >> c) {
		if (c == '|') {
			cin >> c;
			r = true;
		}
		else if (c == '&') {
			cin >> c >> c >> s >> c >> b;
			if (cin >> c) {
				cin >> c;
				r = true;
			}
		}
	}

	if (a <= b) {
		p.push_back(pair<int, bool>(a, false));
		p.push_back(pair<int, bool>(b, true));
	}
	return r;
}

int main()
{
	freopen("hard.in", "rt", stdin);
	freopen("hard.out", "wt", stdout);
	while (get_line());
	sort(p.begin(), p.end());
	int st;
	int c = 0;
	bool f = false;
	for (int i = 0; i < p.size(); ++i) {
		if (p[i].second) {
			--c;
			if (c == 0) {
				if (i + 1 < p.size() && p[i + 1].first == p[i].first + 1) {
					f = true;
				}
				else {
					res.push_back(pair<int, int>(st, p[i].first));
				}
			}
		}
		else {
			++c;
			if (c == 1) {
				if (f) {
					f = false;
				}
				else {
					st = p[i].first;
				}
			}
		}
	}
	if (res.empty()) {
		cout << "false";
	}
	else {
		if (res.size() == 1 && res[0].first == -32768 && res[0].second == 32767) {
			cout << "true";
		}
		else {
			for (int i = 0; i < res.size(); ++i) {
				if (res[i].first == -32768) {
					cout << "x <= " << res[i].second;
				}
				else if (res[i].second == 32767) {
					cout << "x >= " << res[i].first;
				}
				else
				{
					cout << "x >= " << res[i].first << " && x <= " << res[i].second;
				}
				if (i + 1 != res.size()) {
					cout << " ||\n";
				}
			}
		}
	}
	cout << endl;
	return 0;
}

/*
x >= 5 && x <= 10 ||
x >= 7 && x <= 20 ||
x <= 2 ||
x >= 21 && x <= 25 ||
x >= 8 && x <= 10 ||
x >= 100

x >= 10 && x <= 0

x <= 10 ||
x >= 0

x >= -32768

*/