#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <fstream>
using namespace std;

bool arr[68000];

bool isAnd(string s) {
	for (int i = 0; i < s.length(); i++) {
		if (s[i] == '&') {
			return true;
		}
	}
	return false;
}

int toInt(string s) {
	int x = 1;
	int ans = 0;
	int k = 0;
	if (s[0] == '-') {
		k = 1;
	}
	for (int i = s.length() - 1; i >= k; i--) {
		ans += x * (s[i] - 48);
		x = x * 10;
	}
	if (s[0] == '-') {
		return ans * -1;
	}
	else {
		return ans;
	}
}

bool isTrue() {
	for (int i = 0; i < 2 * 32768; i++) {
		if (arr[i] == false) {
			return false;
		}
	}
	return true;
}

bool isFalse() {
	for (int i = 0; i < 2 * 32768; i++) {
		if (arr[i] == true) {
			return false;
		}
	}
	return true;
}

int main()
{
	ifstream cin("hard.in");
	ofstream cout("hard.out");

	string s;
	while (getline(cin, s)) {
		if (s[s.length() - 1] == '|') {
			s = s.substr(0, s.length() - 3);
		}
		if (isAnd(s)) {
			string sa = "", sb = "";
			for (int i = 5; i < s.length(); i++) {
				if (s[i] >= '0' && s[i] <= '9' || s[i] == '-') {
					sa += s[i];
				}
				else {
					break;
				}
			}
			for (int i = 14 + sa.length(); i < s.length(); i++) {
				if (s[i] >= '0' && s[i] <= '9' || s[i] == '-') {
					sb += s[i];
				}
				else {
					break;
				}
			}
			int a = toInt(sa);
			int b = toInt(sb);
			if (a > b) {
				continue;
			}
			else {
				for (int i = a + 32768; i <= b + 32768; i++) {
					arr[i] = true;
				}
			}
		}
		else {
			string sx = "";
			for (int i = 5; i < s.length(); i++) {
				if (s[i] >= '0' && s[i] <= '9' || s[i] == '-') {
					sx += s[i];
				}
				else {
					break;
				}
			}
			//cout<<sx<<endl;
			int x = toInt(sx);
			//cout<<x<<endl;
			if (s[2] == '>') {
				for (int i = x + 32768; i <= 2 * 32768; i++) {
					arr[i] = true;
				}
			}
			else {
				for (int i = 0; i <= x + 32768; i++) {
					arr[i] = true;
				}
			}
		}
	}

	//for (int  i =0 ; i< 100; i++) {
	//    cout<<arr[i]<< " ";
	//}

	if (isFalse()) {
		cout << "false";
		return 0;
	}
	if (isTrue()) {
		cout << "true";
		return 0;
	}
	string ddd = "";
	int  a = -1;
	for (int i = 0; i < 2 * 32768; i++) {
		if (arr[i])
		{
			if (a == -1)
			{
				a = i;
				continue;
			}
		}
		else{
			if (a == 0)
			{
				ddd += "x <= " + to_string(i - 32769) + " ||\n";
				a = -1;
				continue;
			}
			if (a != -1)
			{
				ddd += "x >= " + to_string(a - 32768) + " && x <= " + to_string(i - 32769) + " ||\n";
				a = -1;
			}			
		}
	}

	if (arr[2 * 32768 - 1])
		ddd += "x >= " + to_string(a - 32768) + '\n';
	else {
		ddd = ddd.substr(0, ddd.size() - 3);		
		ddd += '\n';
		}

	cout << ddd;

	return 0;
}



// This is ACM North Eastern European Regional Contest,

//x >= 5 && x <= 10 ||
//x >= 7 && x <= 20 ||
//x <= 2 ||
//x >= 21 && x <= 25 ||
//x >= 8 && x <= 10 ||
//x >= 100

