#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define fori(n) for(int i = 0; i < n; i++)

ifstream fin("hard.in");
ofstream fout("hard.out");

int read_int() {
    char c;
    int res = 0;
    while (fin >> c) {
        if (c == '|' || c == '&') {
            break;
        }
        res = res * 10 + c - '0';
    }
    return res;
}

pair<int, int> read_bounds() {
        int l = -32768;
        int r = 32767;
        char c;
        fin >> c;
        if (c == '<') {
            fin >> c;
            r = min(r, read_int());
        } else {
            fin >> c;
            l = max(l, read_int());
        }
        return make_pair(l, r);
}

int main()
{
    char c;
    vector<pair<int, int>> ps;

        int l = -32768;
        int r = 32767;
        while (fin >> c) {
            pair<int, int> bounds = read_bounds();
            l = max(l, bounds.first);
            r = min(r, bounds.second);
            fin >> c;
            if (c == '|') {
                if (l > r) {
                    fout << "false";
                    return 0;
                }
                vector<pair<int, int>> p;
                for (int i = 0; i < ps.size(); ++i) {
                    if (ps[i].first >= l && ps[i].first <= r || l >= ps[i].first && r <= ps[i].second) {
                        r = max(r, ps[i].second);
                        l = min(l, ps[i].first);
                    } else if (ps[i].second >= l && ps[i].second <= r || l >= ps[i].second && r <= ps[i].second) {
                        l = min(l, ps[i].first);
                        r = max(r, ps[i].second);
                    } else if (ps[i].second + 1 == l) {
                        l = ps[i].first;
                    } else if (ps[i].first == r + 1) {
                        r = ps[i].second;
                    } else {
                        p.push_back(ps[i]);
                    }
                }
                p.push_back(make_pair(l, r));
                ps = p;
                l = -32768;
                r = 32767;
            }
        }
                if (l > r) {
                    fout << "false";
                    return 0;
                }
                vector<pair<int, int>> p;
                for (int i = 0; i < ps.size(); ++i) {
                    if (ps[i].first >= l && ps[i].first <= r || l >= ps[i].first && r <= ps[i].second) {
                        r = max(r, ps[i].second);
                        l = min(l, ps[i].first);
                    } else if (ps[i].second >= l && ps[i].second <= r || l >= ps[i].second && r <= ps[i].second) {
                        l = min(l, ps[i].first);
                        r = max(r, ps[i].second);
                    } else if (ps[i].second + 1 == l) {
                        l = ps[i].first;
                    } else if (ps[i].first == r + 1) {
                        r = ps[i].second;
                    } else {
                        p.push_back(ps[i]);
                    }
                }
                p.push_back(make_pair(l, r));
                ps = p;
    if (ps[0].first == -32768 && ps[0].second == 32767) {
        fout << "true";
        return 0;
    }
    if (ps[0].first != -32768) {
        fout << "x >= " << ps[0].first << " ";
    }
    if (ps[0].second != 32767) {
        if (ps[0].first != -32768) {
            fout << "&& ";
        }
        fout << "x <= " << ps[0].second << " ";
    }
    for (int i = 1; i < ps.size(); ++i) {
        fout << "||" << endl;
        if (ps[i].first != -32768) {
            fout << "x >= " << ps[i].first << " ";
        }
        if (ps[i].second != 32767) {
            if (ps[i].first != -32768) {
                fout << "&& ";
            }
            fout << "x <= " << ps[i].second << " ";
        }
    }
    fin.close();
    fout.close();
    return 0;
}
