#include <bits/stdc++.h>
#define For(i,s,n) for (int i=s;i<=n;i++)
#define FOR(i,s,n) for (int i=s;i<n;i++)
#define Ford(i,s,n) for (int i=s;i>=n;i--)

using namespace std;

typedef long long ll;

string s;
string ans;

bool check(const string &str) {
    if (str.size() < 2) {
        return false;
    }

    if (str[0] < 'A' || str[0] > 'Z') {
        return false;
    }

    for (int i = 1; i < str.size(); i++) {
        if (str[i] < 'a' || str[i] > 'z') {
            return false;
        }
    }

    return true;
}

string solve(int l, int r) {
    string res = "";
    while (l <= r && s[l] == ' ') {
        res += " ";
        l++;
    }

    if (l == r) {
        return "";
    }

    int k = r;
    int tail = 0;
    while (k >= l && s[k] == ' ') {
        k--;
        tail++;
    }

    string word = "";
    string abr = "";
    string letters = "";
    string sp = "";
    bool p = false;
    for (int i = l; i <= r; i++) {
        if (s[i] == ' ') {
            int spaces = 0;
            sp = "";
            while (i < s.length() && s[i] == ' ') {
                sp += " ";
                spaces++;
                i++;
            }
            i--;
            bool ok = check(word);

            if (ok) {
                if (letters.size() > 0) {
                    abr += " ";
                }
                abr += word;
                letters += word[0];
                if (spaces > 1) {
                    if (letters.size() > 1) {
                        res += letters;
                        res += " (";
                        res += abr;
                        res += ") ";
                    } else {
                        if (abr.size() > 0) {
                            res += abr;
                            res += sp;
                        }
                    }
                    letters = "";
                    abr = "";
                }
            } else {
                if (letters.size() > 1) {
                    res += letters;
                    res += " (";
                    res += abr;
                    res += ") ";
                } else {
                    if (abr.size() > 0) {
                        res += abr;
                        res += " ";
                    }
                }
                res += word;
                res += sp;
                p = true;
                letters = "";
                abr = "";
            }

            word = "";
        } else {
            word += s[i];
        }
    }

    bool ok = check(word);
    if (ok) {
        if (letters.size() > 0) {
            abr += " ";
        }
        abr += word;
        letters += word[0];
        word = "";
    }
    if (letters.size() > 1) {
        res += letters;
        res += " (";
        res += abr;
        res += ")";
    } else {
        if (abr.size() > 0) {
            res += abr;
        }
    }
    if (word.size() > 0) {
        if (!p) {
            res += " ";
        }
        res += word;
    }

    tail--;
    while (tail-- > 0)
        res += " ";
    return res;
}


int main(){
    freopen("abbreviation.in","r",stdin);
    freopen("abbreviation.out","w",stdout);
    while (getline(cin, s)) {
        ans = "";
        int last = 0;
        s += " ";
        for (int i = 0; i < s.size(); i++) {
            if (s[i] == '.' || s[i] == ',') {
                ans += solve(last, i - 1);
                ans += s[i];
                last = i + 1;
            }
        }

        if (s[s.size() - 1] != '.' && s[s.size() - 1] != ',') {
            ans += solve(last, s.size() - 1);
        }
        cout << ans << endl;
    }
    return 0;
}
