#include <iostream>
#include <vector>
#include <string>
#include <cstdio>
#include <cstdlib>


using namespace std;

bool isLetter(char c) {
    return 'a' <= c && c <= 'z' || 'A' <= c && c <= 'Z';
}
bool isUpper(char c) {
    return 'A' <= c && c <= 'Z';
}

bool isUpperWord(string str, int s, int e) {
    if (!isUpper(str[s]))
        return false;
    for (int i = s + 1; i <= e; i++) {
        if (isUpper(str[i]))
            return false;
    }
    return true;
}
bool isAbr(string str, int s, int e) {
    int cnt = 0;
    for (int i = s; i <= e; i++) {
        if (!isLetter(str[i]) && str[i] != ' ')
            return false;
        if (str[i] == ' ')
            cnt++;
    }
    if (cnt == 0)
        return false;
    for (int i = s; i < e; i++)
        if (str[i] == ' ' && str[i + 1] == ' ')
            return false;
    if (!isLetter(str[s]) || !isUpper(str[s]))
        return false;
    if (!isLetter(str[e]) || isUpper(str[e]))
        return false;
    if (!isUpper(str[s]))
        return false;

    for (int i = s; i < e; i++) {
        if (isUpper(str[i])) {
            if (isLetter(str[i + 1]) && !isUpper(str[i + 1]))
                continue;
            return false;
        }
        else if (str[i] == ' ') {
            if (!isUpper(str[i + 1]))
                return false;
        }
        else {
            if (str[i + 1] == ' ' || !isUpper(str[i + 1]))
                continue;
            else
                return false;
        }
    }
    return true;
}

int main()
{
    freopen("abbreviation.in", "r", stdin);
    freopen("abbreviation.out", "w", stdout);
    char c;
    string word;
    bool prev = false;
    string str;
    while ((getline(cin, str))) {
        //cout << str << endl;
        int last = 0;
        for (int i = 0; i < str.length(); i++) {
            if (!isUpper(str[i]) || i > 0 && isLetter(str[i - 1])) {
                cout << str[i];
                continue;
            }
            bool found = false;
            for (int j = str.length() - 1; j > i; j--) {
                    if (j < str.length() && isLetter(str[j + 1]))
                    continue;
                if (isAbr(str, i, j)) {
                    found = true;
                    cout << str[i];
                    for (int k = i; k < j; k++) {
                        if (str[k] == ' ')
                            cout << str[k + 1];
                    }
                    cout << ' ';
                    cout << "(" << str.substr(i, j - i + 1) << ")";
                    i = j;
                    break;
                }
            }
            if (!found)
                cout << str[i];
        }
        cout << endl;
    }
    return 0;
}
