#include <iostream>
#include <vector>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <map>
#include <algorithm>

using namespace std;

int n, q;
pair<long long, long long> arr[100009];
long long hh[100009];
map<long long, long long> m;

int main()
{
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);
    scanf("%d %d\n", &n, &q);
    long long v = 0;
    long long wa = 0;
    long long prev = 0;
    long long a, b;
    char c;
    for (int i = 0; i < n; i++) {
        scanf("%c %lld %lld\n", &c, &a, &b);
        m[wa] += (a - prev);
        if (c == '-') {
            if (b > v) {
                b -= v;
                wa += b;
            }
            else {
                v -= b;
            }
        }
        else {
            if (wa > b) {
                wa -= b;
            }
            else {
                wa = 0;
            }
        }
        prev = a;
    }
    int cnt = 0;
    m[0] = 0;
    for (map<long long, long long>::iterator it = m.begin(); it != m.end(); it++) {
        arr[cnt++] = make_pair(it->first, it->second);
    }
    sort(arr, arr + cnt);
    long long sum = arr[1].first * arr[1].second;
    hh[1] = sum;
    for (int i = 2; i < cnt; i++) {
        sum += arr[i].first * arr[i].second;
        arr[i].second += arr[i - 1].second;
        hh[i] = sum;
    }

    long long st = 0;
    while (q--) {
        scanf("%lld ", &st);
        if (st < wa) {
            printf("INFINITY\n");
            continue;
        }
        else {
            int l = 1, r = cnt - 1;
            int ans = -1;
            while (l <= r) {
                int mid = (l + r) / 2;
                if (arr[mid].first <= st) {
                    l = mid + 1;
                    ans = mid;
                }
                else
                    r = mid - 1;
            }

            long long res = sum;
            res = res - hh[ans];

            res = res - st * (arr[cnt - 1].second - arr[ans].second);
            printf("%lld\n", res);
        }
    }
    return 0;
}
