#include<bits/stdc++.h>
using namespace std;


inline bool isLowerCase(char c){ return (c >= 'a' && c <= 'z'); }
inline bool isUpperCase(char c){ return (c >= 'A' && c <= 'Z'); }
inline bool isLetter(char c){ return (isLowerCase(c) || isUpperCase(c)); }

inline bool isDelimiter(const string &s){ return (!isLetter(s[0])); }
inline bool isWord(const string &s){ return isLetter(s[0]); }
inline bool isSpace(const string &s){ return (s[0] == ' '); }
inline bool canBeDelimited(const string &s){
    if (s.length() < 2) return false;
    if (!isUpperCase(s[0])) return false;
    for (int i = 1; i < s.length(); i++)
        if (!isLowerCase((s[i]))) return false;
    return true;
}

void getWordList(vector<string> &words){
    string word = "";
    char c;
    ifstream file("abbreviation.in");
    while(true){
        if (file.fail() || file.eof()) break;
        file.get(c);
        if (isLetter(c)) word += c;
        else{
            if(word.length() > 0) words.push_back(word);
            word = "";
            words.push_back(word + c);
        }
    }
    file.close();
}

void printAbbreviation(vector<const string*> &abbreviation, ofstream &file){
    for (int j = 0; j < abbreviation.size(); j++){
        file << (*abbreviation[j]);
        if (j < abbreviation.size() - 1) file << " ";
    }
}

void printShit(const vector<string> &words){
    ofstream file("abbreviation.out");
    for(int i = 0; i < words.size(); i++){
        vector<const string*> abbreviation;
        while (canBeDelimited(words[i])){
            abbreviation.push_back(&words[i]);
            i++; if(i >= words.size() || (!isSpace(words[i]))) break;
            i++;
        }
        if (abbreviation.size() > 0){
            while (!canBeDelimited(words[i])) i--;
            if(abbreviation.size() > 1){
                for (int j = 0; j < abbreviation.size(); j++)
                    file << ((*abbreviation[j])[0]);
                file << " (";
                printAbbreviation(abbreviation, file);
                file << ")";
            }
            else{
                printAbbreviation(abbreviation, file);
            }
        }
        else file << words[i];
    }
    file.close();
}

int main(){
    vector<string> words;
    getWordList(words);
    printShit(words);
}
