#include <bits/stdc++.h>

#define F first
#define S second
#define x1 privet1
#define y1 privet2
#define pref privet3

using namespace std;
typedef long long ll;
typedef long double ld;

const int inf = 1011111111;

int col;

ld sqr(ld x) {
    return x * x;
}

struct cent {
    ld x, y;
    int val, l, r;
    cent() {x = y = (ld)(col + 1) / 2; val = col; l = 1; r = col;}
    cent(int z) {
        val = z;
        l = 1;
        r = col;
        x = y = (ld)(col + 1 ) / 2;
    }
    void write() {
        cout << x << " " << y << " " << val << " " << l << " " << r << "\n";
    }
};

ld dist(cent a, cent b) {
    return sqrt(sqr(a.x - b.x) + sqr(a.y - b.y));
}
const ld eps = 1e-9;
bool is_null(ld x) {
    return fabs(x) < eps;
}
cent get_cent(cent a, cent b) {
    cent ans = cent();
    ld d = dist(a, b);
    ld d1 = d * b.val / (a.val + b.val);
    //cout << d << " " << d1 << endl;
    ans.x = b.x - a.x;
    ans.y = b.y - a.y;
    if (is_null(d - d1)) {
        ans.val = a.val + b.val;
        ans.x += a.x;
        ans.y += a.y;
        return ans;
    }
    if (is_null(d1)) {
        ans.val = a.val + b.val;
        ans.x = a.x;
        ans.y = a.y;
        return ans;
    }
    ans.x = ans.x * d1 / (d - d1);
    ans.y = ans.y * d1 / (d - d1);
    ans.val = a.val + b.val;
    ans.x += a.x;
    ans.y += a.y;
    return ans;
}

const int max_n = 5055;

int width, n, m, sum[max_n], m1;
bool p[max_n][max_n * 2];
cent suf[max_n], block[max_n];

void finish() {
    cout << "yes\n" << m1 - m << "\n";
    exit(0);
}

bool cmp(ld a, ld b) {
    return a - eps <= b;
}
void alpha(int h) {
    for (int i = h; i > 0; --i) {
        suf[i] = get_cent(suf[i + 1], block[i]);
        //cout << "#" << i << "\n";
        if (i != n) {
            //cout << i << "\n" << "suf[i + 1]: "; suf[i + 1].write();
            //cout << "block[i]: "; block[i].write();
            if (i % 2 == 0 && (cmp(suf[i + 1].y, block[i].l - 0.5) || cmp(block[i].r + 0.5, suf[i + 1].y))) {
                finish();
            }
            if (i % 2 != 0 && (cmp(suf[i + 1].x, block[i].l - 0.5) || cmp(block[i].r + 0.5, suf[i + 1].x))) {
                finish();
            }
        }
        //cout << "suf[" << i << "] = ";
        //suf[i].write();
    }
}

ld get_sum(int h) {
    ll s = 0;
    int cnt = 0, l = inf, r = -inf;;
    for (int i = 1; i <= col; ++i) {
        s += p[h][i] * i;
        cnt += p[h][i];
        if (p[h][i]) {
            l = min(l, i);
            r = max(r, i);
        }
    }
    block[h].l = l;
    block[h].r = r;
    //cout << "!!!" << cnt << "\n";
    if (h != n && cnt == 0) finish();
    return ((ld)s) / cnt;
}

void write() {
    for (int i = 1; i <= n; ++i) {
        for (int q = 1; q <= col; ++q) {
            cout << p[i][q] << " ";
        }cout << "\n";
    }
    cout << "\n";
    for (int i = 1; i <= n; ++i) {
        cout << "suf[" << i << "] = ";
        suf[i].write();
    }
    cout << "\n";
    for (int i = 1; i <= n; ++i) {
        cout << "block[" << i << "] = ";
        block[i].write();
    }
}

int main() {
    //freopen("input.txt", "r", stdin);
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
    scanf("%d%d%d%d", &col, &width, &n, &m1);
    m = m1;
    for (int i =0 ; i <= n; ++i) {
        for (int q = 0; q <= col; ++q) {
            p[i][q] = 1;
        }
    }
    suf[n + 1] = cent(0);
    for (int i = n; i > 0; --i) {
        sum[i] = col;
        if (i != n) sum[i] += sum[i + 1];
        suf[i] = cent(sum[i]);
        block[i] = cent();
    }
    //write();
    while (m--) {
        int h, k;
        scanf("%d%d", &h, &k);
        p[h][k] = 0;
        block[h].val--;
        if (h == n && block[h].val == 0) {
            suf[h] = cent(0);
            block[h] = cent(0);
            n--;
            if (h != 1) alpha(h - 1);
        } else {
            if (h % 2 == 0) {
                //y
                block[h].y = get_sum(h);
            } else {
                //x
                block[h].x = get_sum(h);
            }
            alpha(h);
        }
        //cout << "12123123123\n";
        //write();
    }
    cout << "no\n";
    return 0;
}
