#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <string.h>
#include <algorithm>
using namespace std;

#define N 100005

struct st
{
	long long diff;
	long long people;
};

bool operator < (const st& a, const st& b)
{
	return a.people < b.people;
}


int n, q;
long long t[N];
long long num[N];
st d[N];
long long min_need = 0;
long long pPeople[N];
long long pK[N];

int main() {
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);

	scanf("%d %d", &n, &q);
	for (int i = 0; i < n; ++i) {
		char op;
		scanf(" %c %lld %lld", &op, &t[i], &num[i]);
		if (op == '-')
			num[i] *= -1;

		d[i].diff = (i == 0) ? 0 : t[i] - t[i - 1];
		d[i].people = (i == 0) ? 0 : max(0ll, d[i - 1].people - num[i - 1]);
		min_need += -num[i];
	}
	d[n].people = d[n - 1].people - num[n - 1];
	d[n].diff = 0;

	//for (int i = 0; i <= n; ++i)
	//printf("%lld %lld\t", d[i].people, d[i].diff);
	sort(d + 1, d + n + 1);
	// printf("\n");

	for (int i = 0; i <= n; ++i) {
		pPeople[i] = ((i == 0) ? 0 : pPeople[i - 1]) + d[i].people * d[i].diff;
		pK[i] = ((i == 0) ? 0 : pK[i - 1]) + d[i].diff;
	}

	//for (int i = 0; i <= n; ++i)
	//printf("%lld %lld\t", d[i].people, d[i].diff);
	//printf("\n");

	//for (int i = 0; i <= n; ++i)
	//printf("%lld\t", pPeople[i]);
	//printf("\n");

	//for (int i = 0; i <= n; ++i)
	//printf("%lld\t", pK[i]);
	//printf("\n");

	//printf("MIN_NEEDED: %lld\n", min_need);

	long long ans0 = 0;

	for (int i = 0; i < q; ++i) {
		long long k;
		scanf("%lld", &k);

		st K;
		K.people = k;
		if (k < min_need) {
			printf("INFINITY\n");
			continue;
		}

		int id = upper_bound(d, d + n + 1, K) - d;

		long long ans = pPeople[n] - pPeople[id - 1];
		ans += -k * (pK[n] - pK[id - 1]);

		//printf("id: %d\t %lld\t %lld\n", id, pPeople[id - 1], pK[n] - pK[id]);
		printf("%lld\n", max(0ll, ans));
	}

	return 0;
}

/*
5 4
- 1 1
- 2 2
+ 4 1
- 6 1
+ 7 2
0 3 1 2
*/