#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <algorithm>
#include <cmath>
#include <queue>
#include <map>

#define files(in,out) freopen(in, "r", stdin);freopen(out,"w",stdout);

using namespace std;

void cfind(string &s, int &index){
	for (; index < s.size(); index++)
		if (!(islower(s[index]) || isupper(s[index])))
			return;
	return;
}

int isUsefull(string &s,int &index){
	if (index >= s.size())
		return -2;
	int j = index;
	int cnt = 0;
	if (!isupper(s[index])){
		cfind(s, index);
		return 0;
	}
	bool ind = false;
	for (; index < s.size(); index++){
		
		if (s[index] != ' '&&(!(islower(s[index]) || isupper(s[index])))){
				ind = true;
				break;
		}
		if (isupper(s[index])){
			cnt++;
			if (cnt>1){
				cfind(s, index);
				if (index == -1)
					index = s.size();
				return 0;
			}
		}
		if (s[index] == ' ')
			break;
		
	}
	if (index - j == 1)
		return 0;
	if (ind&&(isupper(s[index - 1]) || islower(s[index - 1])))
		return -1;
	if (!ind && (isupper(s[index - 1]) || islower(s[index - 1])))
		return 1;
	return -1;
}
vector<int> g;

void ans(int &i,string &src,string &s){
	int j = i;
	int ind = isUsefull(src, i);
	i++;
	if (ind == -2){
		if (g.size() > 1){
			string abr = "";
			for (int w = 0; w<g.size(); w++)
				abr += src[g[w]];
			s = abr + " (" + s + ") ";
			g.clear();
		}
		else {
			g.clear();

		}
		return;
	}
	if (!ind){
		if (g.size() > 1){
			string abr = "";
			for (int w = 0; w<g.size(); w++)
				abr += src[g[w]];
			if (s.back() == ' ')
				s.pop_back();
			string t = src.substr(j, i - j);
			s = abr + " (" + s + ") "+t;
			g.clear();
		}
		else {
			s += src.substr(j, i - j);
			g.clear();
			
		}
		return;
	}
	if (ind==1){
		s += src.substr(j, i - j);
		g.push_back(j);
		ans(i, src, s);
	}
	if (ind==-1){
		if (!g.size())
			s += src.substr(j, i - j);
		else {
			string abr = "";
			for(int w=0;w<g.size();w++)
				abr += src[g[w]];
			string t = src.substr(j, i - j);
			char c = t[t.size() - 1];
			t.pop_back();
			abr += t[0];
			s = abr + " (" +s+ t + ")" + c;
			g.clear();
		}
		return;
	}
}
int main(){
	files("abbreviation.in", "abbreviation.out");
	
	string line;

	while (getline(cin, line)){
		string line_ans = "";
		for (int i = 0; i < line.size();){
			string s;
			ans(i,line,s);
			line_ans += s;
		}
		printf("%s\n", line_ans.c_str());
	}



	return 0;
}