#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <ctime>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double real;

const double pi = 3.1415926535897932384626433832795;

#define FILL(x, v) memset(x, v, sizeof(x))
#define ALL(x) (x).begin(), (x).end()
#define SZ(x) ((int)(x).size())

const int max_n = 1000 * 1000;
string SEQ;
int n;
ll SUM[max_n + 10];
ll SSUM[max_n + 10];

real D[max_n + 10];
real SD[max_n + 10];


void cleanup(){
	SEQ.clear();
	FILL(SUM, 0);
	FILL(SSUM, 0);
	FILL(D, 0);
	FILL(SD, 0);
}

bool read(){
	cleanup();
	if (!getline(cin, SEQ)) return false;
	return true;
}

void solve(){
	reverse(ALL(SEQ));
	n = SZ(SEQ);
	for (int i = 1; i <= n; i++){
		SUM[i] = SUM[i - 1] + (SEQ[i - 1] == 'C');
		SSUM[i] = SSUM[i - 1] + SUM[i];
	}
	SEQ = "!" + SEQ;
	for (int i = 1; i <= n; i++){
		ll ans = i * SUM[i] - SSUM[i - 1];
		
		if (SEQ[i] == 'C'){
			ans = ( i * 1ll * (i + 1) ) / 2 - ans;
		}
		real rans = (ans + SD[i - 1]) / i;
		D[i] = rans;
		SD[i] = SD[i - 1] + D[i];
	}
	printf("%0.16Lf\n", D[n]);
}


int main(){
	int t;
#ifdef RAU1
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	t = 100000;
#else
#define task "foreign"
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	t = 1;
#endif
	while (t--){
		clock_t tm = clock();
		if (!read()) break;
		solve();
		fprintf(stderr, "\n>>>>>>>>>>>>>>>>>>>>TIME: %d\n", tm - clock());
	}
}