#include <iostream>
#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>
#include <fstream>

const int _inf = -32768, inf = 32767;

using namespace std;

string s, l, r;

struct coord{
	int l, r;
}t;

bool comp(coord p, coord q){
	if (p.l == q.l)
		return p.r < q.r;
	return p.l < q.l;
}
vector<coord>a;
vector <int> b;

int main()
{

	ifstream fin("hard.in");
	ofstream fout("hard.out");

	while (getline (fin, s))
	{
		int cnt = 0;
		for (int i = 1; i < s.size(); i++){
			int k = 0;
			if (s[i] >= '0' && s[i] <= '9'){
				cnt++;
				bool ind = false;
				if (s[i-1]== '-') ind = true;
				while (s[i] >= '0' && s[i] <= '9') k = k * 10 + s[i] - '0', i++;
				if (ind) k = -k;
				b.push_back(k);
				ind = 0;
			}

		}
		if (b.size() == 2){
			if (b[0] <= b[1]){
				t.l = b[0];
				t.r = b[1];
				a.push_back(t);
			}
		}
		else{
			if (s[2] == '>'){
				t.l = b[0];
				t.r = inf;
				a.push_back(t);
			}
			else{
				t.l = _inf;
				t.r = b[0];
				a.push_back(t);
			}
			
		}
		b.resize(0);

		if (s[s.size() - 1] != '|')
			break;
	}
	sort(a.begin(), a.end(), comp);

	if (!a.size())
	{
		fout << "false";
		return 0;
	}

	if (a.size() == 1 && a[0].l == _inf && a[0].r == inf)
	{
		fout << "true";
		return 0;
	}

		t.l = a[0].l;
		t.r = a[0].r;
	for (int i = 1; i < a.size(); i++)
	{
		if (a[i].l -1 <= t.r)
			t.r = max(t.r, a[i].r);
		else
		{
			if (t.l == _inf && t.r == inf)
			{
				fout << "true";
				return 0;
			}
			if (t.l == _inf)
			{
				fout << "x <= " << t.r << ' ' << "||" << endl;
				t.l = a[i].l;
				t.r = a[i].r;
			}
			else
				if (t.r == inf)
				{
				fout << "x >= " << t.l << " ||" << endl;
				t.l = a[i].l;
				t.r = a[i].r;
				}
				else
				{
					fout << "x >= " << t.l << " && x <= " << t.r << " ||" << endl;
					t.l = a[i].l;
					t.r = a[i].r;
				}
		}
	}
	if (t.l == _inf && t.r == inf)
	{
		fout << "true";
		return 0;
	}

	if (t.l == _inf)
		fout << "x <= " << t.r;
	else
		if (t.r == inf)
			fout << "x >= " << t.l;
		else
			fout << "x >= " << t.l << " && x <= " << t.r;

	return 0;
}
