#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>
#include <vector>

using namespace std;


bool isWord(string s){
    if (s.length() < 2){
        return false;
    }
    if (!(s[0] >= 'A' && s[0] <='Z')) return false;
    for (int i = 1; i < s.length(); i++){
        if (!(s[i] >= 'a' && s[i] <='z')) return false;
    }
    return true;
}

vector<string> maini(string s){
    vector<string> v1;
    vector<string> v2;
    vector<string> ans;
    int last = 0;
    for (int i = 0; i < s.length(); i++){
        while (i < s.length() && (s[i] >= 'a' && s[i] <='z') || (s[i] <= 'Z' && s[i] >= 'A')){
            i++;
        }
        string cur = s.substr(last, i-last);
        v1.push_back(cur);
        last = i;
        while (i < s.length() && (s[i] == ' ' || s[i] == '.' || s[i] == ',')){
            i++;
        }
        string cur2 = s.substr(last, i-last);
        v2.push_back(cur2);
        last = i;
        i--;
    }
    for (int i = 0; i < v1.size(); i++){
        if (isWord(v1[i])){
            int k = 1;
            string cur = "";
            cur += v1[i][0];
            while (i+k < v1.size()){
                if (v2[i+k-1] == " " && isWord(v1[i+k])){
                    cur += v1[i+k][0];
                    k++;
                } else {
                    break;
                }
            }
            if (k > 1){
                ans.push_back(cur);
                ans.push_back(" (");
                for (int j = i; j< i+k-1; j++){
                    ans.push_back(v1[j]);
                    ans.push_back(v2[j]);
                }
                ans.push_back(v1[i+k-1]);
                ans.push_back(")");
                ans.push_back(v2[i+k-1]);
                i = i+k - 1;
            } else {
                ans.push_back(v1[i]);
                ans.push_back(v2[i]);
            }
            continue;
        } else {
        ans.push_back(v1[i]);
        ans.push_back(v2[i]);
        }
    }
    return ans;
}


int main() {
    string s;
    char x;
    string cur;
    freopen("abbreviation.in", "r", stdin);
    freopen("abbreviation.out", "w", stdout);

    while (getline(cin, cur)) {
        vector<string> k = maini(cur);
        for (int i = 0; i < k.size(); i++){
            cout << k[i];
        }
        cout << endl;
    }
}
