#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>
#include <vector>

using namespace std;

struct mylist {
    mylist *prev, *next;
    int value;
};

struct listindex {
    mylist *start, *mend;
    vector<mylist*> addr;
    int cnt;
    double value;
};

int main() {
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
    int n, m;
    int w, h;
    cin >> n >> w;
    cin >> h >> m;

    vector<listindex> vec;

    for (int i=0; i<h; i++) {
        listindex cur;
        for (int j=0; j<n; j++) {
            mylist *newOne = new mylist;
            newOne->value = j;
            cur.addr.push_back(newOne);
            if (j != 0) {
                cur.addr[j-1]->next = newOne;
                newOne->prev = cur.addr[j-1];
            }
        }
        cur.cnt = n;
        cur.value = n / 2.0;
        cur.addr[0]->prev = NULL;
        cur.addr[n-1]->next = NULL;
        cur.start = cur.addr[0];
        cur.mend = cur.addr[cur.addr.size()-1];
        vec.push_back(cur);
    }

    for (int i=0; i<m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        mylist *cur = vec[a].addr[b];
        if (vec[a].start == vec[a].mend) {
            cout << "yes\n" << i+1 << endl;
            break;
        }
        if (cur->prev == NULL) {
            vec[a].start = cur->next;
            cur->next->prev = NULL;
        } else {
            if (cur->next == NULL) {
                vec[a].mend = cur->prev;
                cur->prev->next = NULL;
            } else {
                cur->next->prev = cur->prev;
                cur->prev->next = cur->next;
            }
        }

        vec[a].value = (vec[a].value * vec[a].cnt - (b + 0.5)) / (vec[a].cnt-1);
        vec[a].cnt--;

        double x, y;
        x = y = n / 2.0;
        int cnt = 0;
        for (int j=h-1; j>0; j--) {
            if (j % 2) {
                x = (x * cnt + vec[j].value * vec[j].cnt) / (cnt + vec[j].cnt);
                y = (y * cnt + (n / 2.) * vec[j].cnt) / (cnt + vec[j].cnt);
                if (!(y > 0.0 + vec[j-1].start->value && y < vec[j-1].mend->value + 1.)) {
                    cout << "yes\n" << i+1 << endl;
                    return 0;
                }

            } else {
                x = (x * cnt + (n / 2.) * vec[j].cnt) / (cnt + vec[j].cnt);
                y = (y * cnt + vec[j].value * vec[j].cnt) / (cnt + vec[j].cnt);
                if (!(x > 0.0 + vec[j-1].start->value && x < vec[j-1].mend->value + 1.)) {
                    cout << "yes\n" << i+1 << endl;
                    return 0;
                }
            }
            cnt += vec[j].cnt;
        }

    }

    cout << "no" << endl;
}
