#include <bits/stdc++.h>
using namespace std;

#define FOR(i,a,b) for (int i = (a); i < (b); i++)
#define RFOR(i,b,a) for (int i = (b)-1; i >= (a); i--)
#define ITER(it,a) for (__typeof(a.begin()) it = a.begin(); it != a.end(); it++)
#define FILL(a, value) memset(a, value, sizeof(a))

#define SZ(a) (int)a.size()
#define ALL(a) a.begin(), a.end()
#define MP make_pair
#define PB push_back

typedef long long LL;
typedef vector<int> VI;
typedef pair<int, int> PII;

const double PI = acos(-1.0);
const int INF = 1000 * 1000 * 1000 + 7;
const LL LINF = INF * (LL) INF;

const int MAX = 1001000;

short int S[5007][10007];
LL SUM[5007], L[5007], R[5007], NUM[5007];
int n, w;
int h, m;

bool check(LL SX, LL SY, LL w, int num, bool type)
{
	if (!NUM[num]) return false;
	if (!type)
	{
		if (SX <= 2*L[num]*w || SX >= w*(2*R[num]+2)) return false;
	}
	else
	{
		if (SY <= 2*L[num]*w || SY >= w*(2*R[num]+2)) return false;
	}
	return true;
}

bool check()
{
	LL SX=0, SY=0, N=0;
	RFOR (i,h,0)
	{
		//cout << SX<< " "<<SY<< " "<<N<<" "<<i<<" "<<L[i]<<" "<<R[i]<<endl;
		if (N != 0 && !check(SX,SY,N,i,i&1)) return false;
		if (i&1)
		{
			SX += n*NUM[i];
			SY += SUM[i];
			N += NUM[i];
		}
		else
		{
			SY += n*NUM[i];
			SX += SUM[i];
			N += NUM[i];
		}
	}
	return true;
}

int main()
{
	//freopen("in.txt", "r", stdin);
	//ios::sync_with_stdio(false); cin.tie(0);
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);

	cin >> n >> w >> h >> m;
	FOR (i,0,h)
	{
		FOR (j,0,n) S[i][j] = 2*j+1, SUM[i] += S[i][j];
		L[i] = 0; R[i] = n-1; NUM[i] = n;
	}
	FOR (i,0,m)
	{
		//cout << "------\n";
		int H, K;
		cin >> H >> K;
		//H = 1; K = i+1;
		H--; K--;
		S[H][K] = -1;
		SUM[H] -= 2*K+1;
		NUM[H]--;
		L[H] = R[H] = -1;
		FOR (j,0,n)
		{
			if (S[H][j] != -1)
			{
				R[H] = j;
				if (L[H] == -1) L[H] = j;
			}
		}
		if (!check())
		{
			cout << "yes\n" << i+1 << "\n";
			return 0;
		}
	}
	cout << "no\n";
	return 0;
}
