#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>

using namespace std;


int n;
vector<pair<int, int> > cond;

// >= 1
// <= 2
// 3 - true
int diff = 32768;
const int bval = 1e5;
int a[bval];


void processline(string &s){

	int st = 0;

	pair<int, int> fr = make_pair(0, 0);
	pair<int, int> se = make_pair(0, 0);
	if (s[st + 2] == '>'){
		fr.first = 1;
	}
	else{
		fr.first = 2;
	}

	int eni = 5;
	int num = 0;
	while (s[eni] != ' ' && eni < s.length()){
		num = num * 10;
		num += (s[eni] - '0');
		eni++;
	}
	fr.second = num;
	cond.push_back(fr);

	eni++;

	if (eni >= s.length() || s[eni] == '|'){
		se.first = 3;
		cond.push_back(se);
		return;
	}
	else{
		eni += 8;
		num = 0;
		while (s[eni] != ' ' && eni < s.length()){
			num = num * 10;
			num += (s[eni] - '0');
			eni++;
		}
		se.first = 2;
		se.second = num;
		cond.push_back(se);
	}

}

bool acc(int x, int indx){
	if (cond[indx].first == 3)
		return true;

	if (cond[indx].first == 1){
		if (x >= cond[indx].second)
			return true;
	}
	else{
		if (x <= cond[indx].second)
			return true;
	}
	return false;
}

bool condacc(int x){
	for (int i = 0; i < cond.size(); i += 2){
		if (acc(x, i) && acc(x, i + 1)) return true;
	}
	return false;
}

int main()
{
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
	string line;
	while (getline(cin, line)){
		processline(line);
		if (line[line.length() - 1] != '|')
			break;
	}


	for (int i = -32768; i <= 32767; i++){
		if (condacc(i))
			a[i + diff] = 1;
	}


	int i = -32768;
	vector<pair<int, int> > vec;

	while (i <= 32767){
	
		while (a[i + diff] == 0 && i <= 32767) i++;

		int prev = i;
		while (a[i + diff] == 1 && i <= 32767) i++;

		if (prev < i - 1)
			vec.push_back(make_pair(prev, i - 1));
		//cout << "x >= " << prev << " && x <= " << i - 1 << " ||" << endl;
	
	}

	if (vec.empty()){
		cout << "false";
	}
	else{
		if (vec.size() == 1){
			if (vec[0].first == -32768 && vec[0].second == 32767){
				cout << "true" << endl;
				return 0;
			}

			if (vec[0].first == -32768){
				cout << "x <= " << vec[0].second << endl;
				return 0;
			}

			if (vec[0].second == 32767){
				cout << "x >= " << vec[0].first << endl;
				return 0;
			}

			cout << "x >= " << vec[0].first << " && x <= " << vec[0].second << endl;
			return 0;
		}

		if (vec[0].first == -32768){
			cout << "x <= " << vec[0].second << " ||" << endl;
			vec.erase(vec.begin());
		}

		for (int i = 0; i < vec.size() - 1; i++){
			cout << "x >= " << vec[i].first << " && x <= " << vec[i].second << " ||" << endl;
		}


		if (vec[vec.size() - 1].second == 32767){
			cout << "x >= " << vec[vec.size() - 1].first << endl;
		}
		else{
			cout << "x >= " << vec[vec.size() - 1].first << " && x <= " << vec[vec.size() - 1].second << endl;
		}




	}

	/* for (int i = ; i <= 32767; i++){
		if (condacc(i))
			a[i + diff] = 1;
	}*/

	return 0;
}
