#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <iostream>
using namespace std;
typedef long long ll;

ll n, w, h, m;
ll sumx[5002], sumy[5002], cnt[5002], minleft[5002], maxleft[5002], leveln[5002];
bool removed[5002][10001];

void fall(int i) {
	cout << "yes" << endl << i << endl;
	exit(0);
}

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);

	cin >> n >> w;
	cin >> h >> m;

	for (int i = h; i >= 1; i--) {
		minleft[i] = 1;
		maxleft[i] = n;
		leveln[i] = n;
		sumx[i] = sumx[i + 1];
		sumy[i] = sumy[i + 1];
		cnt[i] = cnt[i + 1];

		sumx[i] += n * w * n;
		sumy[i] += n * w * n;
		cnt[i] += n;
	}

	for (int z = 1; z <= m; z++) {
		int x, y;
		cin >> x >> y;

		removed[x][y] = 1;
		leveln[x]--;
		if (leveln[x]) {
			minleft[x] = 1;
			while (removed[x][minleft[x]]) minleft[x]++;
			maxleft[x] = n;
			while (removed[x][maxleft[x]]) maxleft[x]--;
		}

		for (int i = 1; i <= x; i++) {
			if (x % 2 == 0) {
				sumx[i] -= (2 * y - 1) * w;
				sumy[i] -= 2 * n;
			}
			else {
				sumy[i] -= (2 * y - 1) * w;
				sumx[i] -= 2 * n;
			}
			cnt[i]--;
		}

		for (int i = h; i >= 2; i--) if (cnt[i] > 0) {
			if (leveln[i - 1] == 0) fall(z);
			if ((i - 1) % 2 == 0) {
				if (sumx[i] <= 2 * w * cnt[i] * (minleft[i - 1] - 1)) fall(z);
				if (sumx[i] >= 2 * w * cnt[i] * (maxleft[i - 1])) fall(z);
			}
			else {
				if (sumy[i] <= 2 * w * cnt[i] * (minleft[i - 1] - 1)) fall(z);
				if (sumy[i] >= 2 * w * cnt[i] * (maxleft[i - 1])) fall(z);
			}
		}
	}


	cout << "no" << endl;
	return 0;
}
