import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class ForeignPostcards {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File("foreign.in"));
		PrintWriter pw = new PrintWriter(new File("foreign.out"));
		String str = sc.nextLine();
		int n = str.length();
		int[] cc = new int[n], wc = new int[n];
		long[] cs = new long[n], ws = new long[n];
		cc[0] = str.charAt(0) == 'C' ? 1 : 0;
		wc[0] = str.charAt(0) == 'W' ? 1 : 0;
		cs[0] = cc[0];
		ws[0] = wc[0];
		for (int i = 1; i < n; i++) {
			if (str.charAt(i) == 'C') {
				cc[i] = cc[i - 1] + 1;
				wc[i] = wc[i - 1];
				cs[i] = cs[i - 1] + cc[i];
				ws[i] = ws[i - 1] + wc[i];
			}
			else {
				cc[i] = cc[i - 1];
				wc[i] = wc[i - 1] + 1;
				cs[i] = cs[i - 1] + cc[i];
				ws[i] = ws[i - 1] + wc[i];
			}
		}
		double[] e = new double[n];
		double sum = 0;
		for (int i = n - 2; i >= 0; i--) {
			long temp = str.charAt(i) == 'C' ? ws[n - 1] - (i > 0 ? ws[i - 1] : 0)
											 : cs[n - 1] - (i > 0 ? cs[i - 1] : 0);
			
			if (i > 0) temp -= str.charAt(i) == 'C' ? wc[i - 1] * 1L * (n - i) : cc[i - 1] * 1L * (n - i);
					
			e[i] = (sum + temp) / (1.0 * n - i);
			sum += e[i];
		}
		pw.print(e[0]);
		pw.close();
	}

}
