#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define endl '\n'
#define sz size()
#define TASK "expect"

const int N = 3e5 + 10;
const int inf = 1e9 + 7;
const ll INF = 1e18 + 10;
const int maxn = N;

int Min[4 * maxn];
ll Sum[4 * maxn];

int n, q;
ll t[maxn], k[maxn], cnt[maxn], answer[maxn], ans;
pair <ll, ll> a[maxn];
char type[maxn];

void build(int v, int tl, int tr)
{
	if (tl == tr)
	{
		Min[v] = max(cnt[tl], 0ll);
		Sum[v] = t[tl + 1] - t[tl];
		if (!Min[v]) Sum[v] = 0;
		return;
	}
	int mid = (tl + tr) >> 1;
	build(v + v, tl, mid);
	build(v + v + 1, mid + 1, tr);
	bool flagLeft = false, flagRight = false;
	if (!Min[v + v]) flagLeft = true;
	if (!Min[v + v + 1]) flagRight = true;
	if (flagLeft && flagRight)
	{
		Min[v] = 0;
		Sum[v] = 0;
	}
	else if (flagLeft)
	{
		Min[v] = Min[v + v + 1];
		Sum[v] = Sum[v + v + 1];
	}
	else if (flagRight)
	{
		Min[v] = Min[v + v];
		Sum[v] = Sum[v + v];
	}
	else
	{
		Min[v] = min(Min[v + v], Min[v + v + 1]);
		Sum[v] = Sum[v + v] + Sum[v + v + 1];
	}
}

void upd(int v, int tl, int tr, int val)
{
	if (Min[v] > val) return;
	if (!Min[v]) return;
	if (tl == tr)
	{
		Min[v] = 0;
		Sum[v] = t[tl + 1] - t[tl];
		ans -= Sum[v] * cnt[tl];
		if (!Min[v]) Sum[v] = 0;
		return;
	}
	int mid = (tl + tr) >> 1;
	upd(v + v, tl, mid, val);
	upd(v + v + 1, mid + 1, tr, val);
	bool flagLeft = false, flagRight = false;
	if (!Min[v + v]) flagLeft = true;
	if (!Min[v + v + 1]) flagRight = true;
	if (flagLeft && flagRight)
	{
		Min[v] = 0;
		Sum[v] = 0;
	}
	else if (flagLeft)
	{
		Min[v] = Min[v + v + 1];
		Sum[v] = Sum[v + v + 1];
	}
	else if (flagRight)
	{
		Min[v] = Min[v + v];
		Sum[v] = Sum[v + v];
	}
	else
	{
		Min[v] = min(Min[v + v], Min[v + v + 1]);
		Sum[v] = Sum[v + v] + Sum[v + v + 1];
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
	
	cin >> n >> q;
	swap(n, q);
	for (int i = 1; i <= q; ++i)
	{
		cin >> type[i] >> t[i] >> k[i];
		cnt[i] = cnt[i - 1];
		ans += max(cnt[i], 0ll) * (t[i] - t[i - 1]);
		if (type[i] == '-')
			cnt[i] += k[i];
		else
			cnt[i] -= k[i];
	}
	t[q + 1] = t[q];

	build(1, 1, q);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i].F;
		a[i].S = i;
	}
	sort(a, a + n);
	for (int i = 0; i < n; ++i)
	{
		while (Min[1] && Min[1] <= a[i].F) upd(1, 1, q, a[i].F);
		if (cnt[q] > a[i].F)
			answer[a[i].S] = INF;
		else
			answer[a[i].S] = ans - Sum[1] * a[i].F;
	}
	for (int i = 0; i < n; ++i)
		if (answer[i] == INF)
			cout << "INFINITY\n";
		else
			cout << answer[i] << endl;
	return 0;
}

