#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define endl '\n'
#define sz size()
#define TASK "hard"

const int N = 1e5 + 10;
const int inf = 1e9 + 7;
const ll INF = 1e18 + 10;
const int maxn = (1 << 20);

bool was[maxn];

bool findSymbol(string s, char x)
{
	for (int i = 0; i < (int)s.length(); ++i)
		if (s[i] == x) return true;
	return false;
}

int findNumber(string s, int &pos)
{
	int l = pos;
	while (l < (int)s.length() && ((s[l] < '0' || s[l] > '9') && s[l] != '-')) ++l;
	int x = 0;
	bool minu = false;
	for (int i = l; i < (int)s.length(); ++i)
	{
		if (s[i] == '-')
		{
			minu = true;
			continue;
		}
		if (s[i] < '0' || s[i] > '9')
		{
			pos = i;
			return x * (minu ? -1 : 1);
		}
		x = x * 10 + s[i] - '0';
	}
	pos = (int)s.length();
	return x * (minu ? -1 : 1);
}

string s;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
	
	int Left = 0;
	int Right = (1 << 16);
	int add = (1 << 15);
	for (int i = Left; i < Right; ++i)
		was[i] = false;
	
	while (getline(cin, s))
	{
		if (!findSymbol(s, 'x')) continue;
		if (findSymbol(s, '&'))
		{
			int pos = 0;
			int l = findNumber(s, pos) + add;
			int r = findNumber(s, pos) + add;
			for (int i = l; i <= r; ++i)
				was[i] = true;
		}
		else
		{
			int pos = 0;
			int x = findNumber(s, pos) + add;
			if (findSymbol(s, '>'))
			{
				for (int i = x; i < Right; ++i)
					was[i] = true;
			}
			else
			{
				for (int i = Left; i <= x; ++i)
					was[i] = true;
			}
		}
	}
	
	bool False = true, True = true;
	for (int i = Left; i < Right; ++i)
		if (was[i]) False = false;
		else True = false;
	if (False)
	{
		cout << "false\n";
		return 0;
	}
	if (True)
	{
		cout << "true\n";
		return 0;
	}
	bool prev = false;
	for (int i = Left; i < Right; ++i)
	{
		int l = i, r = i;
		if (was[i])
		{
			while (r + 1 < Right && was[r + 1]) ++r;
			
			if (l == Left)
			{
				prev = true;
				cout << "x <= " << r - add << ' ';
				i = r;
				continue;
			}
			if (r == Right - 1)
			{
				if (prev)
					cout << "||\n";
				prev = true;
				cout << "x >= " << l - add << ' ';
				i = r;
				continue;
			}
			if (prev)
				cout << "||\n";
			prev = true;
			cout << "x >= " << l - add << " && " << "x <= " << r - add << ' ';
		}
		else
		{
			continue;
		}
		i = r;
	}
	cout << "\n";
	return 0;
}

