#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define endl '\n'
#define sz size()
#define TASK "jenga"

const int N = 5000 + 10;
const int inf = 1e9 + 7;
const ll INF = 1e18 + 10;

short n, w, h, m, top, lg, rg;
short lt[N], rt[N], nxt[N][2 * N], prv[N][2 * N];

void rem(int l, int k)
{
	short f = nxt[l][k];
	short b = prv[l][k];
	prv[l][f] = b;
	nxt[l][b] = f;
	prv[l][k] = 0;
	nxt[l][k] = n + 1;
	if (lt[l] == k)
	{
		lt[l] = f;
	}
	if (rt[l] == k)
	{
		rt[l] = b;
	}
}

bool check(int l)
{
	if (l != top && (lt[l] > lg || rt[l] <= rg))
	{
		return true;
	}
	return false;
}

void check_top()
{
	if (lt[top] == n + 1)
	{
		--top;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
	
	cin >> n >> w >> h >> m;
	top = h;
	lg = (n + 1) / 2;
	rg = n / 2;
	for (short i = 1; i <= h; ++i)
	{
		lt[i] = 1;
		rt[i] = n;
	}
	for (short i = 1; i <= h; ++i)
	{
		for (short j = 1; j <= n; ++j)
		{
			prv[i][j] = j - 1;
			nxt[i][j] = j + 1;
		}
	}
	int flag = 0, ans = -1;
	for (short i = 1, l, k; i <= m; ++i)
	{
		cin >> l >> k;
		rem(l, k);
		if (!flag)
		{
			if (check(l))
			{
				ans = i;
				flag = 1;
			}
			check_top();
		}
	}
	if (flag)
	{
		cout << "yes" << endl;
		cout << ans << endl;
	}
	else
	{
		cout << "no";
	}

	return 0;
}

