#include <bits/stdc++.h>

using namespace std;

typedef long long LL;
typedef long double LD;
typedef pair <int, int> PII;
typedef vector <int> VI;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(v) (int)(v).size()
#define file "abbreviation"

const int INF = 1 << 30;
const int MOD = 1e9 + 7;
const int maxn = 1e6;

string g[maxn], d[maxn], s;

bool up(string s) {
	if (s.length() < 2) return 0;
	if ('A' <= s[0] && s[0] <= 'Z') {
		for (int i = 1; i < s.length(); i++) {
			if (s[i] < 'a' || s[i] > 'z') return 0;
		}
		return 1;
	}
	return 0;
}

bool letter(char ch) {
	return 'a' <= ch && ch <= 'z';
}

int cnt;
void add(string s, int p) {
	if (p >= s.length()) return;
	cnt++;
	d[cnt] = g[cnt] = "";
	while (p < s.length() && letter(tolower(s[p]))) {
		d[cnt] += s[p];
		p++;
	}
	
	while (p < s.length() && !letter(tolower(s[p]))) {
		g[cnt] += s[p];
		p++;
	}
	add(s, p);
}

int main() {
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	while (getline(cin, s)) {
	    cnt = 0;               
		add(s, 0);

		int l = 1;
		while (l <= cnt) {
			int r = l;
			while (r <= cnt && up(d[r]) && g[r] == " ") {
				r++;	
			}
			if (r - l >= 1) {
				int c = up(d[r]);
				if (r - l + c > 1) {
					for (int i = l; i < r + c; i++) {
						cout << d[i][0];
					}
					cout << " (";
					for (int i = l; i < r + c; i++) {
						cout << d[i];
						if (i < r + c - 1) cout << " ";
				   	}
				   	cout << ")" << g[r - 1 + c];
					l = r + c;
				} else {
					for (int i = l; i < r; i++)
						cout << d[i] << g[i];
					l = r;
				}
			} else {
				cout << d[l] << g[l];
				l = r + 1;
			}
		}

		cout << "\n";
	}


	return 0;
}