#include <bits/stdc++.h>

using namespace std;

typedef long long LL;
typedef long double LD;
typedef pair <int, int> PII;
typedef vector <int> VI;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(v) (int)(v).size()
#define file "hard"

const int MIN = -32768;
const int MAX = 32767;
const int INF = 1 << 30;
const int MOD = 1e9 + 7;

int get(string s) {
	int sign = 1;
	if (s[0] == '-') {
		sign = -1;
		s = s.substr(1);
	}
	int x = 0;
	for (int i = 0; i < sz(s); i++) {
		x = 10 * x + (s[i] - '0');
	}
	return x * sign;
}

int getL(const string &s) {
	int l = MIN;
	for (int i = 0; i < sz(s) - 1; i++) {	
		if (s[i] == '>' && s[i + 1] == '=') {
			string t = "";
			for (int j = i + 3; ; j++) {
				if (s[j] == ' ') {
					break;
				}
				t += s[j];
			}
			l = max(l, get(t));
		}
	}
	return l;
}

int getR(const string &s) {
	int r = MAX;
	for (int i = 0; i < sz(s) - 1; i++) {
		if (s[i] == '<' && s[i + 1] == '=') {
			string t = "";
			for (int j = i + 3; ; j++) {
				if (s[j] == ' ') {
					break;
				}
				t += s[j];
			}
			r = min(r, get(t));
		}
	}
	return r;
}

int main() {
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	string s;
	vector <PII> v;
	while (getline(cin, s)) {
		if (s == "") {
			break;
		}
		s += " ";
		int l = getL(s);
		int r = getR(s);
		//cout << s << " " << " -- " << l << " " << r << "\n"; 	 	
		v.pb({l, r});		
	}
	sort(v.begin(), v.end());
	vector <bool> used(sz(v), false);
	for (int i = 0; i < sz(v) - 1; i++) {
		if (used[i]) {
			continue;
		}

		for (int j = i + 1; j < sz(v); j++) { 
		if (used[j]) continue;
			if ((v[i].F <= v[j].F && v[j].F <= v[i].S) || 
				(v[i].F <= v[j].S && v[j].S <= v[i].S) ||
				(min(v[i].S, v[j].S) + 1 == max(v[i].F, v[j].F))) {
				v[i].F = min(v[i].F, v[j].F);
				v[i].S = max(v[i].S, v[j].S);
				used[j] = true;
			}		
		}
	}
	vector <PII> res;
	for (int i = 0; i < sz(v); i++) {
		if (!used[i]) {
			res.pb(v[i]);
			//cout << i << " -- " << v[i].F << " " << v[i].S << "\n"; 
		}
	}
	bool bad = true;
	for (int i = 0; i < sz(res); i++) {
		if (res[i].F == MIN && res[i].S == MAX) {
			cout << "true";
			return 0;
		}
		if (res[i].F <= res[i].S) {
			bad = false;			
		}
	}
	if (bad) {
		cout << "false";
		return 0;
	}
	for (int i = 0; i < sz(res); i++) {
		if (res[i].F != MIN && res[i].S != MAX) {
			printf("x >= %d && x <= %d", res[i].F, res[i].S);
		} else if (res[i].F == MIN) {
			printf("x <= %d", res[i].S);
		} else {
			printf("x >= %d", res[i].F);		
		}
		if (i < sz(res) - 1) {
			printf(" ||\n");
		}
	}
	return 0;                        
}