#include <bits/stdc++.h>
using namespace std;


#define FILE "abbreviation"
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;

const int INF = 2e9;
const ll LINF = 2e18;
const double DINF = LINF;

const int ITER = 300;
const double EPS = 1e-9;
const int MOD = 1e9 + 7;
const int MAXN = 1;


bool iscap(char ch) {
    return ch >= 'A' && ch <= 'Z';
}

bool isCapitalized(string s) {
    if((int)s.length() < 2)
        return false;
    if(!(s[0] >= 'A' && s[0] <= 'Z'))
        return false;
    for(int i = 1; i < (int)s.length(); ++i) {
        if(iscap(s[i]))
            return false;
    }
    return true;
}

bool white(char ch) {
    return (ch == ' ' || ch == '\n');
}
bool punct(char ch) {
    return (ch == ',' || ch == '.');
}

vector<string> text;

void solve() {
    string buffW, buffO;
    char ch;
    cin >> noskipws;
    while(cin >> ch) {
        if(isalpha(ch)) {
            if(!buffO.empty()) {
                text.pb(buffO);
                buffO = "";
            }
            buffW += ch;
        }
        else {
            if(!buffW.empty()) {
                text.pb(buffW);
                buffW = "";
            }
            buffO += ch;
        }
    }
    if(!buffO.empty())
        text.pb(buffO);
    else
        text.pb(buffW);
    string res;
    vector<string> s = text;

    for(int i = 0; i < (int)text.size(); ++i) {
        if(isCapitalized(text[i])) {
            string toadd = s[i];
            int cnt = 1;
            int j;
            for(j = i + 2; j < (int)text.size(); j+=2) {
                if(isCapitalized(s[j]) && s[j-1] == " ") {
                    toadd += " " + s[j];
                    ++cnt;
                }
                else
                    break;
            }
            if(cnt >= 2) {
                string rs = "";
                for(int j = 0; j < (int)toadd.size(); ++j)
                    if(iscap(toadd[j]))
                        rs += toadd[j];
                res += rs + " (";
                res += toadd;
                res += ")";
            }
            else {
                res += toadd;
            }
            i = j-2;
        }
        else res += s[i];
    }
    cout << res;

}


int main() {
    freopen(FILE".in", "r", stdin);
    freopen(FILE".out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int t = 1;
    while(t--) {
        solve();
    }
}
