#include <bits/stdc++.h>
using namespace std;


#define FILE "hard"
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;

const int INF = 32767;
const ll LINF = 2e18;

const double DINF = LINF;

const int ITER = 300;
const double EPS = 1e-9;
const int MOD = 1e9 + 7;
const int MAXN = INF*4;

vector<pii> a;
bool mt[MAXN];

bool inter(pii x, pii y) {
    if(x.second < y.first && abs(x.second-y.first) != 1)
        return false;
    swap(x, y);
    if(x.second < y.first && abs(x.second-y.first) != 1)
        return false;
    return true;
}

void solve() {
    string x, sign;
    int num;

    while(true) {
        cin >> x >> sign >> num;
        pair<int, int> toadd = mp(-32768, 32767);
        if(sign == ">=")
            toadd.first = num;
        else
            toadd.second = num;

        if(!(cin >> x)) {
            a.pb(toadd);
            break;
        }
        if(x == "||") {
            a.pb(toadd);
            continue;
        }
        cin >> x >> sign >> num;
        toadd.second = num;
        a.pb(toadd);
        if(!(cin >> x))
            break;
    }
    vector<pii> goodOnes;
    for(int i = 0; i < (int)a.size(); ++i) {
        if(a[i].first > a[i].second) {}
        else goodOnes.pb(a[i]);
    }
    a = goodOnes;
    if(a.empty()) {
        cout << "false";
        return;
    }

    sort(a.begin(), a.end());
    vector<pii> ans;
    for(int i = 0; i < (int)a.size(); ++i) {
        pair<int, int> res = a[i];
        int j;
        for(j = i; j < (int)a.size(); ++j) {
            if(inter(res, a[j])) {
                res.first = min(res.first, a[j].first);
                res.second = max(res.second, a[j].second);
            }
            else break;
        }
        i = j-1;
        ans.pb(res);
    }

    if(ans.size() == 1 && ans[0].first == -32768 && ans[0].second == 32767) {
        cout << "true";
        return;
    }
    for(int i = 0; i < (int)ans.size(); ++i) {
        if(ans[i].first == -32768) {
            cout << "x <= " << ans[i].second;
        }
        else if(ans[i].second == 32767)
            cout << "x >= " << ans[i].first;
        else
            cout << "x >= " << ans[i].first << " && x <= " << ans[i].second;
        if(i != (int)ans.size()-1)
            cout << " ||\n";
    }
}

/*
x >= 10 && x <= 0 ||
x >= 2 && x <= 5
*/

int main() {
    freopen(FILE".in", "r", stdin);
    freopen(FILE".out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int t = 1;
    while(t--) {
        solve();
    }
}
