#include <iostream>
#include <fstream>
#include <vector>
#include <sstream>
#include <string>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define forn(i, n) for(ll i = 0; i < (n); ++i)
#define infp 32768
#define info -32769

typedef long long ll;
typedef unsigned long long ull;

string x, op;
ll y;
vector<pair<ll, ll>> v;

int main()
{
	ifstream cin("hard.in"); ofstream cout("hard.out");

	while (cin >> x >> op >> y)
	{
		ll l = info, r = infp;

		if (op[0] == '>')
			l = y - 1;
		else
			r = y + 1;

		if (cin >> op)
		{
			if (op[0] == '&')
			{
				cin >> x >> op >> y;

				if (op[0] == '>')
				{
					if (l == info || l < y - 1)
						l = y - 1;
				}
				else
				{
					if (r == infp || r > y + 1)
						r = y + 1;
				}

				cin >> op;
			}
		}

		if (l + 1 >= r)
			continue;

		char pere = 1;

		forn(i, v.size())
		{
			if (v[i].F <= l && v[i].S >= r)
			{
				pere = 0;
				break;
			}
			else if (v[i].F <= l && v[i].S > l && r >= v[i].S)
			{
				v[i].S = r;
				pere = 0;
				break;
			}
			else if (v[i].F < r && v[i].S >= r && l <= v[i].F)
			{
				v[i].F = l;
				pere = 0;
				break;
			}
		}

		if (pere)
			v.pb(mp(l, r));
	}

	if (!v.size())
		cout << "false";
	else
	{
		string s = "";

		forn(i, v.size())
		{
			if (v[i].F == info && v[i].S == infp)
			{
				cout << "true";
				return 0;
			}

			char m = 0;

			if (v[i].F != info)
			{
				s += "x >= " + to_string(v[i].F + 1);
				m = 1;
			}

			if (v[i].S != infp)
			{
				if (m)
					s += " && ";
				s += "x <= " + to_string(v[i].S - 1);
			}

			if (i != v.size() - 1)
				s += " ||\n";
		}

		cout << s;
	}

}
