#include <bits/stdc++.h>

#define f first
#define s second
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define all(c) (c).begin(), (c).end()
#define fname "hard"

using namespace std;

const double eps = 1e-9;
const int mod = (int) 1e9 + 7;
const int N = (int) 1e4 + 7;

int sz;
string s;
pair <int, int> a[N];

int getnum(string s) {
	int res = 0, neg = 1, pos = 0;
	if(s[0] == '-')
		neg = -1, pos ++;
	for(int i = pos; i < s.size(); i ++)
		res = res * 10 + s[i] - '0';
	return res * neg;
}

void parse(string s) {
	 istringstream tin(s);
	 string t;
	 tin >> t;
	 tin >> t;
	 pair<int, int> otr = mp(-32768, 32767);
	 if(t == ">=") {
	 	tin >> t;
	  	otr.f = getnum(t);
	 } else {
	 	tin >> t;
	  	otr.s = getnum(t);
	 }
	 tin >> t;
	 if(t != "&&") {
	 	a[sz ++] = otr;
	 	return;
	}
	tin >> t;
	tin >> t;
	if(t == ">=") {
	 	tin >> t;
	  	otr.f = getnum(t);
	} else {
	 	tin >> t;
	  	otr.s = getnum(t);
	}
	if(otr.f > otr.s) 
		return;
	a[sz ++] = otr;
}

vector < pair <int, int> > ans;

int main() {
	freopen(fname".in", "r", stdin);
	freopen(fname".out", "w", stdout);

	while(getline(cin, s)) {
		if(s.size() > 3) parse(s);
	}
	
	if(sz == 0) {
		cout << "false\n";
		return 0;
	}

	sort(a, a + sz);

	int l, r;
	for(int i = 0; i < sz; i ++) {
		int j = i + 1;
		l = a[i].f, r = a[i].s;
		while(j < sz && a[j].f-1 <= r) {
			r = max(r, a[j].s);
			j ++;
		}
		ans.pb(mp(l, r));
		i = j - 1;
	}

	if(ans[0].f == -32768 && ans[0].s == 32767) {
		cout << "true\n";
		return 0;
	}


	for(int i = 0; i < ans.size(); i ++) {
		l = ans[i].f, r = ans[i].s;
		if(l != -32768 && r != 32767) {
			cout << "x >= " << l << " && x <= " << r;
		} else if (l == -32768)
			cout << "x <= " << r;
		else
			cout << "x >= " << l;

	   if(i != ans.size() - 1)
	   	cout << " ||";
	 	cout << "\n";
	}
	return 0;
}