#include <iostream>
#include <stdio.h>
#include <cstdlib>
#include <string>
#include <cstring>
#include <algorithm>
#include <time.h>
#include <ctime>
#include <set>
#include <vector>
#include <map>

using namespace std;





int main()	{
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
    string s;
    int cntr = 0;
    pair<int, int> intervals[1010];

    while (getline(cin, s)){
        pair<int, int> interval;
        interval.first = -32768;
        interval.second = 32767;
        bool first = true;
        bool hasNext = false;
        bool neg = false;
        for (int i = 0; i < s.size(); i++){
            if (s[i] == '>'){
                first = true;
            }
            else if (s[i] == '<'){
                first = false;
            }
            else if (s[i] == '-'){
                neg = true;
            }
            else if (s[i] <= '9' && s[i] >= '0'){
                int val = 0;
                while (true){
                    val = val*10 + s[i]-'0';
                    if (i+1 >= s.size() || (s[i+1] > '9' || s[i+1] < '0')){
                        break;
                    }
                    else{
                        i++;
                    }
                }
                if (neg){
                    val = -val;
                    neg = false;
                }
                if (first) interval.first = val;
                else interval.second = val;
            }
            else if (s[i] == '|'){
                hasNext = true;
            }
        }
        if (interval.first <= interval.second){
            intervals[cntr] = interval;
            cntr++;
        }
        if (!hasNext) break;
    }
    if (cntr == 0){
        cout << "false" << endl;
        return 0;
    }
    set<pair<int, pair<int, int> > > pp;
    set<pair<int, pair<int, int> > >::iterator it;
    for (int i = 0; i < cntr; i++){
        pp.insert(make_pair(intervals[i].first, make_pair(i, 0)));
        pp.insert(make_pair(intervals[i].second, make_pair(i, 1)));
    }
    set<int> open;


    set<pair<int, int> > ans;
    bool answer[70000];
    for (int i = 0; i < 65000; i++){
        answer[i] = false;
    }
    int last = -32768;
    int diff = 32768;
    for (it = pp.begin(); it != pp.end(); it++){
        bool opening = ((it->second.second == 0) ? true : false);
        int id = it->second.first;
        int val = it->first;
        if (!open.empty()){
            for (int i = last; i <= val; i++){
                answer[i+diff] = true;
            }
        }
        if (opening){
            open.insert(id);
            answer[val+diff] = true;
        }
        else{
            open.erase(id);
        }
        last = val;
    }
    vector<pair<int, int> > fin;
    int lastOpening = -1;
    for (int i = 0; i < 32768*2; i++){
        if (answer[i] == true && (i-1 < 0 || answer[i-1] == false)){
            lastOpening = i;
        }
        if (answer[i] == false && i > 0 && answer[i-1] == true){
            fin.push_back(make_pair(lastOpening-32768, i-32768-1));
            lastOpening = -1;
        }
    }
    if (lastOpening != -1){
        fin.push_back(make_pair(lastOpening-32768, 32767));
    }

    if (fin.size() == 1 && fin[0].first == -32768 && fin[0].second == 32767){
        cout << "true" << endl;
    }
    else {
        for (int i = 0; i < fin.size(); i++){
            pair<int, int> interval = fin[i];
            bool write = false;
            if (interval.first != -32768){
                cout << "x >= " << interval.first << " ";
                write = true;
            }
            if (interval.second != 32767){
                if (write){
                    cout << "&& ";
                }
                cout << "x <= " << interval.second << " ";
            }
            if (i+1 < fin.size()) cout << "||";
            cout << endl;
        }
    }
	return 0;
}

