#include <iostream>
#include <stdio.h>
#include <cstdlib>
#include <string>
#include <cstring>
#include <iomanip>
#include <algorithm>
#include <time.h>
#include <ctime>
#include <set>
#include <vector>
#include <unordered_map>

using namespace std;
typedef long long ll;
typedef long double ld;
ll n, w, h, m;

int main()	{
    ios_base::sync_with_stdio(0);
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
    ll cmx[5010], cmy[5010], sz[5010], l[5010], r[5010];
    set<ll> rmv[5010];
    cin >> n >> w;
    cin >> h >> m;
    for (ll i = 0; i < h; i++){
        sz[i+1] = n;
        l[i+1] = 1;
        r[i+1] = n;
        cmx[i+1] = n*(n+1)/2;
        cmy[i+1] = n*(n+1)/2;
    }
    for (ll i = 0; i < m; i++){
        ll lv, k;
        cin >> lv >> k;

        rmv[lv].insert(k);
        if (rmv[lv].size() == n){
            cout << "yes" << endl << i+1 << endl;
            return 0;
        }
        sz[lv]--;
        for (ll j = 1; j <= n; j++){
            if (rmv[lv].find(j) == rmv[lv].end()){
                l[lv] = j;
                break;
            }
        }

        for (ll j = n; j >= 1; j--){
            if (rmv[lv].find(j) == rmv[lv].end()){
                r[lv] = j;
                break;
            }
        }



        if (lv%2 == 1){
            cmx[lv] -= k;
            cmy[lv] = sz[lv]*(n+1)/2;
        }
        else{
            cmx[lv] = sz[lv]*(n+1)/2;
            cmy[lv] -= k;
        }
        ll mx = 0;
        ll my = 0;
        ll total_size = 0;
        for (ll lvl = lv+1; lvl <= h; lvl++){
            mx += cmx[lvl];
            my += cmy[lvl];
            total_size += sz[lvl];
        }
        ll M;
        if (lv%2 == 1){
            M = mx;
        }
        else{
            M = my;
        }

        if (total_size > 0 && (M > r[lv]*total_size || M < l[lv]*total_size)){
            cout << "yes" << endl << i+1 << endl;
            return 0;
        }
    }
    cout << "no" << endl;

	return 0;
}

