#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <cstdio>
#include <cstdlib>


using namespace std;

bool capital(char c) {
	if (c >= 'A' && c <= 'Z')
		return true;
	return false;
}
         
bool lowercase(char c) {
	if (c >= 'a' && c <= 'z')
		return true;
	return false;
}

bool letter(char c) {
	return capital(c) || lowercase(c);
}

bool capitalizedWord(string temp) {
	if (capital(temp[0]) && temp.length() > 1) {
		for (int i = 1; i < temp.length(); i++)
			if (!lowercase(temp[i]))
				return false;
		return true;
	}
	return false;
}

string nextWord(int i, string &s) {
	string temp = "";
	while (letter(s[i]) && i < s.length()) {
		temp += s[i];
		i++;
	}
	return temp;
}

int main() {
	
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	string line, temp, result = "";
	vector <string> s;
	int counter = 0;
	          vector<string> lines;
		
	while (getline(cin, line)) {
		lines.push_back(line);
	}

	for (int tt = 0; tt < lines.size(); tt++) {
	line = lines[tt];
    if (line.length() > 0) {
    	while (result.size() > 0 && result.back() == ' ')
    		result.pop_back();
    	int i= 0, len = line.length();
    	
    	while (line[i] == ' ')
    		i++;
    	for (; i < line.length(); i++) {
    		char c = line[i];
    		if (capital(c)) {
                temp = "";
                int j;
    			for (j = i; letter(line[j]) && j < len; j++)
    				temp += line[j];

    			i = j;

    			if (capitalizedWord(temp)) {
    				s.push_back(temp);
    		   	
    		   		if (!(line[j] == ' ' && capitalizedWord(nextWord(j + 1, line)))) {
    		   			if (s.size() > 1) {
    		   				for (int j = 0; j < s.size(); j++)
    		   					result += s[j][0];

    		   				result += " (";
    		   				for (j = 0; j < s.size() - 1; j++) {
    		   					result += s[j];
    		   					result += " ";
    		   				}
    		   				result += s.back();
    		   				result += ")";
    		   			} else 
    		   				result += s.back();   

    				   	if (i < len && line[i] != '\n')
		    		   		result += line[i];
    		   			s.clear();                                  
    		   		}                     
    		   	} else {
    		   		result += temp;
    				if (i < len && line[i] != '\n')
    		   			result += line[i];
    		   	}
    		} else
    			result += c;
       	}
    }
    if (tt < lines.size() - 1)
    	result += "\n";
    }

    cout << result;
	return 0;
}