#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define TOP 32767 
#define BOTTOM -32768

vector< pair<int, int> > arr, ans;

int getN(string s, int i) {
	
	int ans = 0, sign = 1;

	if ( s[i] == '-' ) {
		sign = -1;
		i++;
	}

	while ( i < s.length() && s[i] >= '0' && s[i] <= '9' )
		ans = ans * 10 + int(s[ i++ ] - '0');

	return ans * sign;
}

void add(int l, int r) {
	if (l <= r)
		arr.push_back( make_pair(l, r) );

	//printf("%d %d\n", l, r);
} 

int main() {

	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	string s;
	int l, r;

	while ( getline(cin, s) ) {
		l = BOTTOM;
		r = TOP;

		if ( s[2] == '>' )
			l = getN(s, 5);
	   	else if ( s[2] == '<' )
	   		r = getN(s, 5);

	   	int i = 5;
	   	while ( i < s.length() && (s[i] == '-' || (s[i] >= '0' && s[i] <= '9')) )	
	   		i++;

	   	if (i == s.length() || s[i + 1] == '|')
	   		add(l, r);
	   	
	   	if ( i == s.length() )
	   		break;
	   	else if ( s[i + 1] == '|' )
	   		continue;
	   	else {
	   		if ( s[i + 6] == '>' )
	   			l = getN(s, i + 9);
	   	   	else
	   	   		r = getN(s, i + 9);

	   	   	add(l, r);
	   	}

	   	if ( s[ s.length() - 1] != '|' )
	   		break;
	}
	
	if ( arr.empty() ) {
		printf("false");
		return 0;
	}

	sort( arr.begin(), arr.end() );

	int start, finish;

	for (int i = 0; i < arr.size(); i++) {
		//printf("%d %d\n", arr[i].first, arr[i].second);
		if ( i == 0 || arr[i].first - finish > 1 ) {
			if (i > 0)
				ans.push_back( make_pair(start, finish) );

			start = arr[i].first;
			finish = arr[i].second;
		} else {
			finish = max(finish, arr[i].second);
		}
	}

	ans.push_back( make_pair(start, finish) );

	if ( ans[0].first == BOTTOM && ans[0].second == TOP )
	{
		printf("true");
		return 0;
	}

	for (int i = 0; i < ans.size(); i++) {
		if ( ans[i].first == BOTTOM )
			printf("x <= %d", ans[i].second);
		else if (ans[i].second == TOP )
			printf("x >= %d", ans[i].first);
	   	else
	   		printf("x >= %d && x <= %d", ans[i].first, ans[i].second);

	   	if ( i + 1 < ans.size() )
	   		printf(" ||\n");
	}

	return 0;
}