#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<map>
#include<vector>
#include<cstdlib>
#include<cmath>

using namespace std;

#define ll long long
#define pb push_back
#define mp make_pair

const int L = -32768;
const int R = 32767;

string s;

int Right = 100000, Left = -100000, m1, l = 0, n = 0, col = 0, sz = 0, c[1010], d[1010], cc[1010], dd[1010];

bool was[1010];

bool intersect(int l1, int r1, int l2, int r2) {
	return (l1 <= l2 && l2 <= r1) || (l2 <= r1 && r1 <= r2) || (r2 + 1 == l1) || (r1 + 1 == l2);
}

int main() {
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	while (getline(cin, s)) {
		bool ok = false;
		int i = 5, a = 0, b = 0;
		while (i < s.length() && s[i] != ' ') {
		 	if (s[i] == '-') ok = true;
		 	else a = a * 10 + s[i] - '0';
		 	i++;
		}
		if (ok) a = -a;
		if (i == s.length() || s[i + 1] == '|') {			
			if (s[2] == '>') Right = min(Right, a);
			else Left = max(Left, a);
	    } else {
	    	i += 9;
	    	ok = false;
			while (i < s.length() && s[i] != ' ') {
			 	if (s[i] == '-') ok = true;
			 	else b = b * 10 + s[i] - '0';
			 	i++;
			}
			if (ok) b = -b;
			if (a > b) {
				col++;
			} else {
				c[sz] = a;
				d[sz] = b;
				sz++;
			}
	    }
	    n++;
	}

	if (col == n) {
		cout << "false";
		return 0;
	}

//	for (int i = 0; i < sz; ++i) cerr << c[i].x << " " << c[i].y << endl;

	cerr << Left << " " << Right << endl;

	n = sz;

	for (int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j)		
			if (!was[j] && intersect(c[i], d[i], c[j], d[j])) {
				c[j] = min(c[i], c[j]);
				d[j] = max(d[i], d[j]);
				was[i] = true;				
			}

	for (int i = 0; i < n; ++i)
		if (!was[i]) {
			if (d[i] <= Left) was[i] = true;
			if (c[i] <= Left && Left <= d[i]) {
				was[i] = true;
				Left = d[i];
			}
			if (c[i] >= Right) was[i] = true;
			if (c[i] <= Right && Right <= d[i]) {
				was[i] = true;
				Right = c[i];
			}
		}

	if (Left + 1 >= Right || (Right > R && Left == R) || (Left < L && Right == L)) {
		cout << "true";		
		return 0;
	}

	sz = 0;
	for (int i = 0; i < n; ++i) 
		if (!was[i]) {
			cc[sz] = c[i];
			dd[sz] = d[i];
			sz++;
		}

	if (Left != -100000) {
		cout << "x <= " << Left;
		if (sz > 0 || Right != 100000) cout << " ||\n";
	}

	for (int i = 0; i < sz - 1; ++i) {
		cout << "x >= " << cc[i] << " && x <= " << dd[i] << " ||\n"; 
	}

	if (sz > 0) cout << "x >= " << cc[sz - 1] << " && x <= " << dd[sz - 1];
	
	if (Right != 100000) {
		if (sz > 0) cout << " ||\n";	
		cout << "x >= " << Right;
	}

}