#include <bits/stdc++.h>
using namespace std;

#define fname "abbreviation" // <- here

typedef long long ll;

const int N = 1e5 + 256;
const int INF = 1e9 + 256;
const int Mod = 1e9 + 7;

#define all(x) x.begin(), x.end()

inline pair <string, int> parseString(const string &s, int p) {
	if (!isalpha(s[p])) {
		string t; t += s[p++];
		return make_pair(t, p);
	}
	string t;
	do {
		t += s[p++];
	} while (p < s.size() && isalpha(s[p]));
	t += s[p++];
	return make_pair(t, p);
}

inline bool check(const string &s) {
	if (s.size() == 1 || (s.size() == 2 && !isalpha(s[1])) || !isupper(s[0]))
		return false;
	for (int i = 1; i < s.size(); ++i)
		if (isalpha(s[i]) && isupper(s[i]))
			return false;
	return true;
}

int main () {
	freopen(fname".in", "r", stdin);
	freopen(fname".out", "w", stdout);

	string s, v;
	while (getline(cin, s)) {
		vector <string> curv;
		string abr, last;
		for (int i = 0; i < s.size(); ++i) {
			auto t = parseString(s, i);
			// cerr << t.first << "|";
			// cerr << abr << endl;
			if (check(t.first) && (isalpha(t.first.back()) || t.first.back() == ' ')) {
				// cerr << t.first;
				curv.push_back(t.first);
				abr += t.first[0];
			} else {
				// cerr << t.first << " " << abr << endl;

				if (abr != "") {
					if (check(t.first)) {
						// cerr << t.first << "|";
						curv.push_back(t.first);
						abr += t.first[0];
						t.first = "";
					}
				}

				if (abr != "" && abr.size() != 1) {
					v += (abr);
					v += " (";
					for (int i = 0; i < (int)curv.size(); ++i)
						v += curv[i];
					if (!isalpha(v.back())) {
						v.pop_back();
						v += ")";
						v += curv.back().back();
					} else {
						v += ")";
					}
					abr = "";
					curv.clear();
				} else {
					if (abr.size() == 1)
						v += curv[0];
					abr = "";
					curv.clear();
				}
				v += t.first;
			}
			i = t.second - 1;
		}
		if (abr != "" && abr.size() != 1) {
			v += (abr);
			v += " (";
			for (int i = 0; i < (int)curv.size(); ++i)
				v += curv[i];
			if (!isalpha(v.back())) {
				v.pop_back();
				v += ")";
				v += curv.back().back();
			} else {
				v += ")";
			}
			abr = "";
			curv.clear();
		} else {
			if (abr.size() == 1)
				v += curv[0];
			abr = "";
			curv.clear();
		}
		// v += t.first;
		v += "\n";
	}
	cout << v;

	return 0;
}
