
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.regex.Pattern;

/**
 * Created by neerc on 04.12.2016.
 */
public class H {
    private static final Pattern p1 = Pattern.compile("^x >= [0-9]+ && x <= [0-9]+ [|][|]$");
    private static final Pattern p2 = Pattern.compile("^x >= [0-9]+ && x <= [0-9]+$");
    private static final Pattern p3 = Pattern.compile("^x >= [0-9]+$");
    private static final Pattern p4 = Pattern.compile("^x <= [0-9]+$");
    private static final Pattern p5 = Pattern.compile("^x >= [0-9]+ [|][|]$");
    private static final Pattern p6 = Pattern.compile("^x <= [0-9]+ [|][|]$");
    private static final List<List<Integer>> ranges = new ArrayList<>();
    private static final StringBuilder BUILDER = new StringBuilder();
    private static final StringBuilder OPTIMIZE_BUILDER = new StringBuilder();

    public static void main(String[] args) throws IOException {
        Scanner SCANNER = new Scanner(new File("hard.in"));

        while (SCANNER.hasNext()) {
            String input = SCANNER.nextLine();
            char checkRes = check(input);
            if (checkRes == 'f') {
                writeToFile("false");
                return;
            } else {
            }
        }
        if (!ranges.isEmpty()) {
            for (int i = 0; i < ranges.size(); i++) {
                List<Integer> r = ranges.get(i);
                OPTIMIZE_BUILDER.append("x >= " + r.get(0) + " && x <= " + r.get(1) + " ||");
                if (i < ranges.size() - 1) {
                    OPTIMIZE_BUILDER.append("\n");
                }
            }

            writeToFile(OPTIMIZE_BUILDER.toString().concat("\n" + BUILDER.toString()));
            return;
        }

        writeToFile("true");


    }

    private static void writeToFile(String line) throws IOException {
        FileOutputStream fileOutputStream = new FileOutputStream(new File("hard.out"));
        BufferedOutputStream bufferedOutputStream = new BufferedOutputStream(fileOutputStream);
        bufferedOutputStream.write(line.getBytes());
        bufferedOutputStream.flush();

    }

    private static char check(String line) {
        char res = 'u';
        if (p1.matcher(line).matches()) {
            int start1 = line.indexOf(">") + 3;
            int end1 = line.indexOf("&") - 1;
            Integer i1 = Integer.parseInt(line.substring(start1, end1));

            int start2 = line.indexOf("<") + 3;
            int end2 = line.indexOf("|") - 1;
            Integer i2 = Integer.parseInt(line.substring(start2, end2));

            if (!ranges.isEmpty()) {
                List<Integer> l = ranges.get(ranges.size() - 1);
                if (i1 >= l.get(0) && i1 <= l.get(1) && i2 >= l.get(1)) {
                    ranges.remove(ranges.size() - 1);
                    ranges.add(Arrays.asList(l.get(0), i2));

                } else if (l.get(1) + 1 == i1) {
                    ranges.remove(ranges.size() - 1);
                    ranges.add(Arrays.asList(l.get(0), i2));
                } else {
                    if (!(i1 >= l.get(0) && i1 <= l.get(1) && i2 >= l.get(0) && i2 <= l.get(1))) {
                        ranges.add(Arrays.asList(i1, i2));
                    }
                }
            } else {
                ranges.add(Arrays.asList(i1, i2));
            }

            return i1 >= i1 && i1 <= i2 ? 't' : 'f';
        } else if (p5.matcher(line).matches() || p6.matcher(line).matches()) {
            /*int start1 = line.indexOf("=") + 2;
            int end1 = line.indexOf("|") - 1;
            Integer i1 = Integer.parseInt(line.substring(start1, end1));*/
            BUILDER.append(line);
            BUILDER.append("\n");
        } else if (p2.matcher(line).matches()) {
            int start1 = line.indexOf(">") + 3;
            int end1 = line.indexOf("&") - 1;
            Integer i1 = Integer.parseInt(line.substring(start1, end1));

            int start2 = line.indexOf("<") + 3;
            Integer i2 = Integer.parseInt(line.substring(start2));
            if (!ranges.isEmpty()) {
                List<Integer> l = ranges.get(ranges.size() - 1);
                if (l.get(0) >= i1 && l.get(0) <= i2 && l.get(1) >= i2) {
                    ranges.add(Arrays.asList(i1, l.get(1)));

                } else {
                    ranges.add(Arrays.asList(i1, i2));
                }
            }
            return i1 >= i1 && i1 <= i2 ? 't' : 'f';
        } else if (p3.matcher(line).matches() || p4.matcher(line).matches()) {
            BUILDER.append(line);
            //BUILDER.append("\n");
        }
        return 'u';
    }

}
