#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <ctype.h>
#include <set>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

#define _name "foreign"
#define mp make_pair
const int maxlen = 1e5;

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(_name".in", "r", stdin);
	freopen(_name".out", "w", stdout);
#endif
	string s;
	cin >> s;
	int n = s.size();
	long double dp = 0;
	ll sum0 = 0, sum1 = 0;
	long double sum_dp = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		sum0 += (s[i] == 'W')*(n - i);
		sum1 += (s[i] == 'C')*(n - i);
		dp = (sum_dp + (s[i] == 'W' ? sum1 : sum0) ) / (n-i);
		sum_dp += dp;
	}
	cout << fixed << setprecision(9) << dp;
	return 0;
}