#include <bits/stdc++.h>

#define F first
#define S second
#define mp make_pair
#define pb push_back

#ifndef LOCAL
#define cerr if(0)cerr
#endif // LOCAL

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

#define FILE "expect"
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(FILE".in", "r", stdin);
    freopen(FILE".out", "w", stdout);
#endif // LOCAL
    int n, qu;
    cin >> n >> qu;
    vector<pair<char, pii> > e(n);
    int v = 0;
    vector<pii> w;
    for (int i = 0; i < n; ++i) {
        cin >> e[i].F >> e[i].S.F >> e[i].S.S;
        if (i && (-v) > 0)
            w.pb(mp(-v, e[i].S.F - e[i - 1].S.F));
        if (e[i].F == '-')
            v -= e[i].S.S;
        else
            v += e[i].S.S;
    }
    sort(w.rbegin(), w.rend());
    vector<ll> slen(w.size());
    vector<ll> sp(w.size());
    for (int i = 0; i < w.size(); ++i) {
        if (i) {
            slen[i] += slen[i - 1];
            sp[i] += sp[i - 1];
        }
        slen[i] += w[i].S;
        sp[i] += w[i].F * 1ll * w[i].S;
    }
    int need = -v;
    for (int i = 0; i < qu; ++i) {
        int q;
        cin >> q;
        if (q < need) {
            cout << "INFINITY\n";
            continue;
        }
        int j = -1;
        int l = 0, r = w.size() - 1;
        while (l <= r) {
            int mid = (l + r) / 2;
            if (q >= w[mid].F)
                r = mid - 1;
            else
                j = mid, l = mid + 1;
        }
        cerr << j << endl;
        ll ans = 0;
        if (j != -1)
            ans = 1ll * sp[j] - 1ll * q * slen[j];
        cout << ans << endl;
    }
    return 0;
}
