#include <bits/stdc++.h>

#define F first
#define S second
#define mp make_pair
#define pb push_back

#ifndef LOCAL
#define cerr if(0)cerr
#endif // LOCAL

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

#define FILE "jenga"
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(FILE".in", "r", stdin);
    freopen(FILE".out", "w", stdout);
#endif // LOCAL
    int n, useless;
    cin >> n >> useless;
    int h, m;
    cin >> h >> m;
    vector<vector<bool> > used(h, vector<bool>(n));
    vector<vector<short> > a(h, vector<short>(n));
    vector<int> b(h);
    for (int i = h - 1; i >= 0; --i) {
        for (int j = 0; j < n; ++j) {
            if (i + 2 < h)
                a[i][j] += a[i + 2][j] + 1;
        }
        if (i + 2 < h)
            b[i] += b[i + 2] + n;
    }
    vector<ll> l(h), r(h);
    vector<ll> lbal(h), rbal(h);
    for (int i = 0; i < h; ++i) {
        l[i] = 0;
        r[i] = n - 1;
        lbal[i] = n * 1ll * (h - 1 - i) * 1ll * n * (n + 1) / 2;
        rbal[i] = -lbal[i];
        cerr << lbal[i] << " " << rbal[i] << endl;
        ///COUNT BAL;
    }
    cerr << endl;
    vector<ll> ltemp(n + 1), rtemp(n + 1);
    ltemp[0] = 1ll * n * (n + 1) / 2;
    for (int i = 1; i <= n; ++i) {
        ltemp[i] = ltemp[i - 1] - (n - i + 1) - i;
    }
    for (int iter = 1; iter <= m; ++iter) {
        int lev, k;
        cin >> lev >> k;
        k--;
        lev--;
        for (int i = lev - 1; i >= 0; --i) {
            if (i % 2 == lev % 2) {
                lbal[i] += n * 1ll * (k - l[i] + (k >= l[i] ? 1 : 0));
                rbal[i] += n * 1ll * (k - r[i] - (k <= r[i] ? 1 : 0));
            } else {
                ///COUNT BAL
                lbal[i] -= ltemp[l[i]];
                rbal[i] -= ltemp[r[i] + 1];
            }
            if (lbal[i] <= 0 || rbal[i] >= 0) {
                cout << "yes\n";
                cout << iter;
                return 0;
            }
        }
        used[lev][k] = 1;
        l[lev] = n + 1, r[lev] = -1;
        for (int i = 0; i < n; ++i)
            if (!used[lev][i])
                l[lev] = min(l[lev], i), r[lev] = max(r[lev], i);
        if (r[lev] == -1) {
            cout << "yes\n";
            cout << iter;
            return 0;
        }
        lbal[lev] = 0;
        rbal[lev] = 0;
        lbal[lev] += 1ll * ltemp[l[lev]] * b[lev];
        rbal[lev] += 1ll * ltemp[r[lev] + 1] * b[lev];
//        lbal[lev] = 0;
//        rbal[lev] = 0;
        cerr << "#" << lbal[lev] << " " << rbal[lev] << " " << l[lev] << " " << r[lev] << endl;
        for (int i = 0; i < n; ++i) {
            lbal[lev] += a[lev][i] * 1ll * n * (i - l[lev] + (i >= l[lev] ? 1 : 0));
            rbal[lev] -= a[lev][i] * 1ll * n * (r[lev] - i + (i <= r[lev] ? 1 : 0));
            cerr << "#" << lbal[lev] << " " << rbal[lev] << " " << l[lev] << " " << r[lev] << endl;
        }
        for (int i = 0; i < h; ++i)
            cerr << lbal[i] << " " << rbal[i] << endl;
        cerr << endl;
//        for (int i = 0; i <= n ;++i)
//            cout << ltemp[i] << " ";
//        cout << endl;
        if (lev < h - 1 && (lbal[lev] <= 0 || rbal[lev] >= 0)) {
            cout << "yes\n";
            cout << iter;
            return 0;
        }
        for (int i = lev - 1; i >= 0; i -= 2)
            b[i]--;
        for (int i = lev - 2; i >= 0; i -= 2)
            a[i][k]--;
    }
    cout << "no";
    return 0;
}
