#include <bits/stdc++.h>

#define F first
#define S second
#define mp make_pair
#define pb push_back

#ifndef LOCAL
#define cerr if(0)cerr
#endif // LOCAL

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef vector<char> vc;
typedef vector<vector<char> > mtr;

mtr p(3001, vc(3001));

void clr() {
    for (int i = 0; i <= 3000; ++i)
        for (int j = 0; j <= 3000; ++j)
            p[i][j] = 0;
}

pii pt(mtr& x) {
    for (int i = 0; i < x.size(); ++i)
        for (int j = 0; j < x[i].size(); ++j)
            if (x[i][j])
                return mp(i, j);
    return mp(1000, 1000);
}

bool any() {
    for (int i = 0; i <= 3000; ++i)
        for (int j = 0; j <= 3000; ++j)
            if (p[i][j])
                return 1;
    return 0;
}

bool lay(mtr& x, const pii& pos) {
    for (int i = 0; i < x.size(); ++i)
        for (int j = 0; j < x[i].size(); ++j)
            if (x[i][j])
                p[pos.F + i][pos.S + j] ^= 1;
}

pii operator+(const pii& a, const pii& b) {
    return mp(a.F + b.F, a.S + b.S);
}

pii operator-(const pii& a, const pii& b) {
    return mp(a.F - b.F, a.S - b.S);
}

void print() {
    for (int i = 980; i <= 1020; ++i) {
        for (int j = 980; j <= 1020; ++j)
            if (p[i][j])
                cout << '*';
            else
                cout << '.';
        cout << endl;
    }
}

#define FILE "kids"
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(FILE".in", "r", stdin);
    freopen(FILE".out", "w", stdout);
#endif // LOCAL
    int n, m;
    cin >> n >> m;
    mtr a(n, vc(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            if (c == '*')
                a[i][j] = 1;
            else
                a[i][j] = 0;
        }
    }
    cin >> n >> m;
    mtr b(n, vc(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            if (c == '*')
                b[i][j] = 1;
            else
                b[i][j] = 0;
        }
    }
    cin >> n >> m;
    mtr c(n, vc(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char d;
            cin >> d;
            if (d == '*')
                c[i][j] = 1;
            else
                c[i][j] = 0;
        }
    }
    pii pa = pt(a);
    pii pb = pt(b);
    pii pc = pt(c);
    pii center = mp(1000, 1000);
    if (pa > pb) {
        lay(b, center);
        lay(a, center + pb - pa);
        pii mda = pt(p);
        lay(c, mda - pc);
        if (!any()) {
            cout << "YES\n";
            pa = pa - pb;
            cout << pa.S << " " << pa.F << endl;
            return 0;
        }
    } else {
        lay(a, center);
        lay(b, center + pa - pb);
        pii mda = pt(p);
        lay(c, mda - pc);
        if (!any()) {
            cout << "YES\n";
            pb = pa - pb;
            cout << pb.S << " " << pb.F << endl;
            return 0;
        }
    }
    clr();
    if (pa > pc) {
        lay(c, center);
        lay(a, center + pc - pa);
        pii mda = pt(p);
        lay(b, mda - pb);
        if (!any()) {
            cout << "YES\n";
            pb = mda - pb - pc + pa - center;
            cout << pb.S << " " << pb.F << endl;
            return 0;
        }
    } else {
        lay(a, center);
        lay(c, center + pa - pc);
        pii mda = pt(p);
        lay(b, mda - pb);
        if (!any()) {
            cout << "YES\n";
            pb = mda - pb - pa + pc - center;
            cout << pb.S << " " << pb.F << endl;
            return 0;
        }
    }
    clr();
    if (pb > pc) {
        lay(c, center);
        lay(b, center + pc - pb);
        pii mda = pt(p);
        lay(a, mda - pa);
        if (!any()) {
            cout << "YES\n";
            pa = (center + pc - pb) - (mda - pa);
            cout << pa.S << " " << pa.F << endl;
            return 0;
        }
    } else {
        lay(b, center);
        lay(c, center + pb - pc);
        pii mda = pt(p);
        lay(a, mda - pa);
        if (!any()) {
            cout << "YES\n";
            pa = (center - (mda - pa));
            cout << pa.S << " " << pa.F << endl;
            return 0;
        }
    }
    cout << "NO";
    return 0;
}
