#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++)
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B> &a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A> &a) {
	out << "[";
	forn(i, sz(a)) {
		if(i) out << ", ";
		out << a[i];
	}
	return out << "]";
}

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(-1.0);
const int MOD = INF + 7;
mt19937 myrand(time(NULL));
const int N = 100 * 1000 + 43;
#define FILENAME "expect"

int n, q;
pair<int, pt> a[N];
pair<li, li> rng[N];
int qs[N];
li pref[N];
li psum[N];

bool read() {
	if(scanf("%d %d\n", &n, &q) != 2)
		return false;
	forn(i, n)
	{
		char buf;
		int ttt;
		int k;
		scanf("%c %d %d\n", &buf, &ttt, &k);
		a[i].x = (buf == '+' ? 1 : -1);
		a[i].y = mp(ttt, k);
	}
	forn(i, q) scanf("%d", &qs[i]);
	return true;
}

void solve() {
	li cur = a[0].y.y * a[0].x;
	for (int i = 0; i < n - 1; i++)
	{
		rng[i] = mp(max(0ll, -cur), a[i + 1].y.x - a[i].y.x);
		cur += a[i + 1].y.y * a[i + 1].x;
	}
	sort(rng, rng + n - 1);
	
	//forn(i, n - 1)
		//cerr << rng[i] << endl;
	pref[0] = 0;
	forn(i, n - 1)
		pref[i + 1] = pref[i] + rng[i].y;
	psum[0] = 0;
	forn(i, n - 1)
		psum[i + 1] = psum[i] + rng[i].x * 1ll * rng[i].y;
	for (int i = 0; i < q; i++)
	{
		li val = qs[i];
		if (-cur > val)
			puts("INFINITY");
		else
		{
			auto it = lower_bound(rng, rng + n - 1, mp(li(val), -INF64));
			int cnt = it - rng;
			printf("%lld\n", psum[n - 1] - (pref[n - 1] - pref[cnt]) * 1ll * val - psum[cnt]);
		}
	}
}

int main() {

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);

	int tt = clock();

#else
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
	
#endif

	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);

	while(read()) {
	
		solve();
		
#ifdef _DEBUG

		cerr << "TIME = " << clock() - tt << " ms\n";
		tt = clock();
		
#endif

	}
	
	return 0;
}