#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++)
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B> &a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A> &a) {
	out << "[";
	forn(i, sz(a)) {
		if(i) out << ", ";
		out << a[i];
	}
	return out << "]";
}

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(-1.0);
const int MOD = INF + 7;
mt19937 myrand(time(NULL));

#define FILENAME "hard"

vector<pt> a;

const int SINF = 32767;

bool get_string() {
	pt seg = pt(-SINF - 1, SINF);
	string lastsign;
	while(true) {
		string s;
		if(!(cin >> s)) {
			if(seg.x <= seg.y)
				a.pb(seg);	
			return false;
		}
		if(s == "||") {	
			if(seg.x <= seg.y)
				a.pb(seg);
			return true;
		}
		if(s == "x" || s == "&&") continue;
		if(s == ">=" || s == "<=")
			lastsign = s;
		else {
			int num = atoi(s.c_str());
			if(lastsign == ">=")
				seg.x = num;
			else
				seg.y = num;
		}
	}
	return false;
}

bool read() {
	while(get_string());
	return true;
}

void solve() {
	if(a.empty()) {
		puts("false");
		return;
	}
	
	// DO IT!
	
	while(true) {
		sort(all(a));
		bool bad = true;
		forn(i, sz(a) - 1) {
			if(a[i].y + 1 >= a[i + 1].x) {
				int l = min(a[i].x, a[i + 1].x);
				int r = max(a[i].y, a[i + 1].y);
				a.erase(a.begin() + i + 1);
				a[i] = pt(l, r);
				bad = false;
				break;
			}
		}
		if(bad) break;
	}
	
	if(sz(a) == 1 && a[0] == pt(-SINF - 1, SINF)) {
		puts("true");
		return;
	}
	
	forn(i, sz(a)) {
		if(i) cout << " ||\n";
		bool was = false;
		if(a[i].x > -SINF - 1) {
			cout << "x >= " << a[i].x;
			was = true;
		}
		if(a[i].y < SINF) {
			if(was) cout << " && x <= ";
			else cout << "x <= ";
			cout << a[i].y;
		}
	}
	cout << endl;
}

int main() {

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);

	int tt = clock();

#else
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
	
#endif

	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);

	while(read()) {
	
		solve();
		
#ifdef _DEBUG

		cerr << "TIME = " << clock() - tt << " ms\n";
		tt = clock();
		
#endif
		
		break;

	}
	
	return 0;
}