#include <iostream>
#include <vector>
#include <string>
#include <sstream>
#include <cstring>

using namespace std;

string spaces;

void f(vector<string>& words) {
    if (words.size() == 0) {
        return;
    } else if (words.size() == 1) {
        cout << words[0];
    } else {
        string abbr;
        for (string& word : words) {
            abbr.push_back(word[0]);
        }
        abbr += " (";
        string sep;
        for (string& word : words) {
            abbr += sep;
            abbr += word;
            sep = " ";
        }
        abbr += ")";
        cout << abbr;
    }
    words.clear();
}

bool capWord(string& word) {
    if ((word.size() < 2) || !isupper(word[0])) {
        return false;
    }
    for (int i = 1; i < word.size(); ++i) {
        if (isupper(word[i])) {
            return false;
        }
    }
    return true;
}

bool g(string& word, vector<string>& words) {
    bool flag = true;
    for (char chr : spaces) {
        if (chr != ' ') {
            flag = false;
            break;
        }
    }
    if (!flag) {
        f(words);
        cout << spaces;
        spaces.clear();
    }
    if (capWord(word)) {
        if (words.size() == 0) {
            cout << spaces;
        }
        words.push_back(word);
        word.clear();
        spaces.clear();
        return true;
    } else {
        f(words);
        cout << spaces << word;
        spaces.clear();
    }
    word.clear();
    return false;
}

int main() {
    freopen("abbreviation.in", "r", stdin);
    freopen("abbreviation.out", "w", stdout);
    vector<string> words;
    string word;
    string line_sep;
    while (!cin.eof()) {
        cout << line_sep;
        char line[121];
        cin.getline(line, sizeof(line));
        int line_len = strlen(line);
        spaces.clear();
        for (int i = 0; i < line_len; ++i) {
            char chr = line[i];
            if (isupper(chr) || islower(chr)) {
                word.push_back(chr);
            } else {
                if (!g(word, words)) {
                    cout << chr;
                } else {
                    spaces.push_back(chr);
                }
            }
        }
        g(word, words);
        word.clear();
        g(word, words);
        line_sep = "\n";
    }
    return 0;
}
