#include <iostream>
#include <stdlib.h>
#include <cstdio>
#include <cctype>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
using namespace std;

typedef long long ll;

string getWord(int &i, string &s) {
    string ans = "";
    for (; i < s.size(); i++) {
        if (!isalpha(s[i])) {
            i--;
            return ans;
        }
        ans += s[i];
    }
    i--;
    return ans;
}


bool isCorert(string s) {
    if (s.size() < 2) {
        return false;
    }
    if (!isupper(s[0])) {
        return false;
    }
    for (int i = 1; i < s.size(); i++) {
        if (!islower(s[i]))
            return false;
    }
    return true;
}


void f(string& ans, vector<string>& words) {
    if (words.empty())
        return;
    if (words.size() == 1) {
        ans += words[0];
        words.clear();
        return;
    }
    string abv = "";
    for (int i = 0; i < words.size(); i++)  {
        abv += words[i][0];
    }
    ans += abv + " (";
    for (int i=0;i<words.size(); i++) {
        ans+=words[i]+ (i==words.size()-1?"":" ");
    }
    ans += ")";
    words.clear();

}

int main() {
#ifndef _CONSOLE
    freopen("abbreviation.in","r",stdin);
    freopen("abbreviation.out", "w", stdout);
#else
    freopen("A.in", "r", stdin);
#endif
    string s;
    
    while (getline(cin, s)) {
        s += '.';
        string ans = ""; 
        vector<string> words;
        for (int i = 0; i < s.size(); i++) {
            if (isupper(s[i])) {
                string word = getWord(i, s);
                if (isCorert(word)) {
                    words.push_back(word);
                }
                else {
                    if (!words.empty()) {
                        f(ans, words);
                        ans += " ";
                    }
                    ans += word;
                }
            }
            else {
                if (!words.empty() && s[i - 1] == ' ' && s[i] == ' ') {
                    f(ans, words);
                    ans += ' ';
                }

                if (!words.empty() && s[i] == ' ') {
                    continue;
                }
                
                if (!words.empty() && s[i - 1] == ' ') {
                    f(ans, words);
                    ans += " ";
                }
                else {
                    f(ans, words);
                }
                
                ans += s[i];

                
            }
        }
        ans.pop_back();
        cout << ans << endl;

    }
    return 0;
}