#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;

const int MAXN = 200000;
const int INF = 1e9 + 10;
const ll LONGINF = 4e18;
const ll MOD = 1000000007;

ll d[1010][1010];

int e[1010], s[1010];

bool tw(const string &s) {
    if (s.size() < 2 || !('A' <= s[0] && s[0] <= 'Z'))
        return false;
    for (int i = 1; i < s.size(); ++i)
    {
        if ('A' <= s[i] && s[i] <= 'Z')
            return false;
    }
    return true;
}

void dump(vector<string> &buf) {
    if (buf.size() == 0)
        return;
    if (buf.size() < 2) {
        cout << buf[0];
        buf.clear();
        return;
    }
    for (int i = 0; i < buf.size(); ++i) {
        cout << buf[i][0];
    }
    cout << " (";
    cout << buf[0];
    for (int i = 1; i < buf.size(); ++i) {
        cout << ' ' << buf[i];
    }
    cout << ')';
    buf.clear();

}

void solve() {
    string s;
    vector<string> buf;
    while (getline(cin , s)) {
        buf.clear();
        string cur = "";
        int pos = 0;
        while (pos < s.size()) {
            cur = "";
            while (pos < s.size() && isalpha(s[pos])) {
                cur.push_back(s[pos]);
                ++pos;
            }
            if (tw(cur)) {
                buf.push_back(cur);
            } else {
                if (buf.size()) {
                    dump(buf);
                    cout << ' ';
                }
                cout << cur;
            }
            cur = "";
            while (pos < s.size() && !isalpha(s[pos])) {
                cur.push_back(s[pos]);
                ++pos;
            }
            if (!buf.size() || !(cur.size() == 1 && cur[0] == ' '))
            {
                dump(buf);
                cout << cur;
            }
        }
        cout << endl;
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen("abbreviation.in", "r", stdin);
    freopen("abbreviation.out", "w", stdout);
#endif // _DEBUG

    solve();

    return 0;
}

