#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <climits>
#include <numeric>
#include <string>

using namespace std;
typedef long long LL;

int mod = 32768;
bool used[65536];


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
#endif
	memset(used, 0, sizeof(used));

	while (!cin.eof())
	{
		vector<int> tmp(65536);

		char c;
		string usl;
		int y;
		cin >> c >> usl >> y;
		if (cin.eof()) break;
		y += mod;
		if (usl == ">=")
		{
			for (int i = y; i < 65536; i++)
			{
				tmp[i]++;
			}
		}
		else
		{
			for (int i = y; i >= 0; i--)
			{
				tmp[i]++;
			}
		}
		if (cin.eof()) break;
		cin >> usl;
		bool flag = false;
		if (usl == "&&")
		{
			flag = true;
			cin >> c >> usl >> y;
			y += mod;
			if (usl == ">=")
			{
				for (int i = y; i < 65536; i++)
				{
					tmp[i]++;
				}
			}
			else
			{
				for (int i = y; i >= 0; i--)
				{
					tmp[i]++;
				}
			}
			cin >> usl;
		}
		if (flag)
		{
			for (int i = 0; i < 65536; i++)
			{
				if (tmp[i] == 2)
					used[i] = 1;
			}
		}
		else
		{
			for (int i = 0; i < 65536; i++)
			{
				if (tmp[i] == 1)
					used[i] = 1;
			}
		}
		
	}
	int cnt = 0;
	for (int i = 0; i < 65536; i++)
	{
		if (used[i]) cnt++;
	}
	if (cnt >= 65536)
	{
		puts("true");
		return 0;
	}
	if (cnt == 0)
	{
		puts("false");
		return 0;
	}

	int l = -1, r = -1;


	bool flag = false;
	for (int i = 0; i < 65536; i++)
	{
		if (used[i])
		{
			if (l == -1)
				l = i;
			r = i;
		}
		else
		{
			if (l == -1)
			{
				r = -1;
				continue;
			}

			if (l == 0)
			{
				cout << "x <= " << r - mod;
				l = -1;
				r = -1;
				flag = 1;
			}
			else
			{
				if (!flag)
				{
					cout << "x >= " << l - mod << " && x <= " << r - mod;
					flag = 1;
					l = -1;
					r = -1;
				}
				else
				{
					cout << " ||\nx >= " << l - mod << " && x <= " << r - mod;
					l = -1;
					r = -1;
				}
			}
		}
	}

	if (l != -1)
	{
		if (!flag)
		{
			cout << "x >= " << l - mod;
		}
		else
		{
			cout << " ||\nx >= " << l - mod;
		}
	}




	return 0;
}
