#include <bits/stdc++.h>

using namespace std;

int main() {
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);


    long long n, q;
    cin >> n >> q;
    vector <long long> pref(n);
    vector <long long> T(n);

    for (long long i = 0; i < n; i++) {
        char c;
        cin >> c;
        long long b;
        cin >> T[i] >> b;

        pref[i] = (i == 0 ? 0 : pref[i - 1]);

        if (c == '+') {
            pref[i] += b;
        } else {
            pref[i] -= b;
        }
    }
    vector <pair <long long, long long> > A(q);

    for (long long i = 0; i < q; i++) {
        cin >> A[i].first;
        A[i].second = i;
    }
    sort(A.begin(), A.end());

    vector <pair <long long, long long> > res(q);
    vector <long long> ans(q);
    long long INF_BND = 0;

    for (long long i = 0; i < n; i++) {
        long long pos = (long long) (lower_bound(A.begin(), A.end(), make_pair(-pref[i], -1LL)) - A.begin());

        if (i == n - 1) {
            INF_BND = pos;
            break;
        }

        if (pos > 0) {
            pos--;

            res[pos].first += -(A[pos].first + pref[i]) * (T[i + 1] - T[i]);
            res[pos].second += (T[i + 1] - T[i]);
        }
    }
    long long now = 0, nowstep = 0;

    for (long long i = q - 1; i >= 0; i--) {
        now += nowstep;

        now += res[i].first;
        nowstep += res[i].second;

        ans[A[i].second] = now;

        if (i < INF_BND) {
            ans[A[i].second] = -1;
        }
    }

    for (long long i = 0; i < q; i++) {
        if (ans[i] == -1) {
            cout << "INFINITY\n";
        } else {
            cout << ans[i] << '\n';
        }
    }

    return 0;
}
