#include <bits/stdc++.h>
using namespace std;

typedef double ld;
const int H = 5005;
const int N = 10005;
const ld EPS = 1e-9;
int n, w;
int h, m;
int le[H], ri[H], u[H], v[H];
ld c[H];
bool a[H][N];

bool my_less(ld x, ld y) {
    return x < y + EPS;
}

bool my_greater(ld x, ld y) {
    return x > y - EPS;
}

int main() {
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin >> n >> w;
    cin >> h >> m;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < n; ++j) {
            a[i][j] = true;
        }
        le[i] = 0, ri[i] = n - 1;
        u[i] = (h - i - 1) / 2 * n;
        v[i] = (h - i) / 2 * n;
        c[i] = ld(n) / 2;
    }
    for (int q = 0; q < m; ++q) {
        int i, j;
        cin >> i >> j, --i, --j;
        a[i][j] = false;
        le[i] = -1;
        for (int k = 0; k < n; ++k)
            if (a[i][k]) { le[i] = k; break; }
        ri[i] = -1;
        for (int k = n - 1; k >= 0; --k)
            if (a[i][k]) { ri[i] = k; break; }
        for (int k = i - 1; k >= 0; --k) {
            if ((i - k) % 2 == 0) {
                --u[k];
                if (u[k] > 0)
                    c[k] = ((u[k] + 1) * c[k] - (j + 0.5)) / u[k];
            } else {
                --v[k];
            }
        }
        for (int k = i; k >= 0; --k) {
            if (u[k] + v[k] == 0) continue;
            ld x = (u[k] * c[k] + v[k] * (ld(n) / 2)) / (u[k] + v[k]);
            if (le[k] == -1 || my_less(x, le[k]) || my_greater(x, ri[k] + 1.0)) {
                cout << "yes" << endl;
                cout << q + 1 << endl;
                return 0;
            }
        }
        //for (int k = 0; k < h; ++k)
        //    cout << c[k] << ' ';
        //cout << endl;
    }
    cout << "no" << endl;
    return 0;
}
