#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int n, w, h, q, l, k;
char u[5005][5005];
int L[5005], R[5005];
ld x[5005], y[5005], m[5005];

const ld eps = 1e-9;

inline bool leq(ld a, ld b) {
    return fabs(a - b) <= eps || a < b;
}

int main()
{
    ios_base::sync_with_stdio(false);
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);

    cin >> n >> w >> h >> q;
    for (int i = 1; i <= h; ++i) {
        x[i] = y[i] = n / 2.0;
        m[i] = (h - i + 1) * n;
        L[i] = 0;
        R[i] = n;
    }
    for (int i = 1; i <= q; ++i) {
        cin >> l >> k;
        ld xt, yt;
        if (l % 2 == 0) {
            xt = n / 2.0;
            yt = k - 0.5;
        } else {
            xt = k - 0.5;
            yt = n / 2.0;
        }
       // cerr << i << " " << xt << " " << yt << endl;
        u[l][k] = true;
        while (L[l] < R[l] && u[l][L[l] + 1])
            ++L[l];
        while (L[l] < R[l] && u[l][R[l]])
            --R[l];
        if (L[l] >= R[l]) {
            cout << "yes\n" << i << endl;
            return 0;
        }
        for (int j = l; j >= 1; --j) {
            x[j] = (m[j] * x[j] - xt) / (m[j] - 1);
            y[j] = (m[j] * y[j] - yt) / (m[j] - 1);
            m[j] -= 1;
        }

//        for (int j = 1; j <= h; ++j) {
//            cerr << x[j] << " " << y[j] << " " << m[j] << " " << L[j] << " " << R[j] << endl;
//        }cerr << endl;

        for (int j = l; j >= 1; --j) {
            if (j < h) {
                if (j % 2 == 0) {
                    if (leq(y[j + 1], L[j]) || leq(R[j], y[j + 1])) {
                        cout << "yes\n" << i << endl;
                        return 0;
                    }
                } else {
                    if (leq(x[j + 1], L[j]) || leq(R[j], x[j + 1])) {
                        cout << "yes\n" << i << endl;
                        return 0;
                    }
                }
            }
        }


    }

    cout << "no\n";
    return 0;
}
