#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>
#include <set>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

/*
This is ACM North Eastern European Regional Contest,
sponsored by Internationak Business Machines.
The. Best. Contest. Ever.
A Great Opportunityt for all contestants.
*/

bool check_a(string s) {
	if (islower(s[0]) || s.length() < 2)
		return 0;
	else {
		for (int i = 1; i < s.length(); ++i) {
			if (isupper(s[i]))
				return 0;
		}
	}
	return 1;
}

void solve_a() {
	vector<string> a(1, "");
	while (!cin.eof()) {
		string line, w = "";
		getline(cin, line);
		line += "\n";
		for (int i = 0; i < line.length(); ++i) {
			if (isalpha(line[i])) {
				w += line[i];
			}
			else {
				bool ch = check_a(w);
				string t = w;
				if (ch) {
					a[0] += w[0];
					a.push_back(w);
					w = "";
				}
				if (!ch) {
					if (a.size() > 2) {
							cout << a[0] << " (";
							for (int j = 1; j < a.size() - 1; ++j) {
								cout << a[j] << ' ';
							}
							cout << a[a.size() - 1] << ") ";
						}
					else if (a.size() > 1) {
						cout << a[1] << ' ';
					}
					cout << w << line[i];
					a.clear();
					a.resize(1, "");
				}
				else if (line[i] != ' ' || line[i] == ' ' && line[i - 1] == ' ') {
					if (a.size() > 2) {
						cout << a[0] << " (";
						for (int j = 1; j < a.size() - 1; ++j) {
							cout << a[j] << ' ';
						}
						cout << a[a.size() - 1] << ')';
					}
					else if (a.size() > 1) {
						cout << a[1];
					}
					cout << w << line[i];
					a.clear();
					a.resize(1, "");
				}
				w = "";
			}
		}
	}
}

int main() {
#define OJFILE "abbreviation"
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen(OJFILE".in", "r", stdin);
	freopen(OJFILE".out", "w", stdout);
#endif
	solve_a();
	return 0;
}