#include <iostream>
#include <fstream>
#include <string>
#include <queue>
#include <vector>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;

const int CMAX = 1e5+505;
typedef pair <int, int> ii;
vector <ii> v;

ll psums[CMAX], times[CMAX];

int bs(ll x) {

	int l = 0, r = v.size();

	while (l < r) {
		int mid = (l + r + 1) / 2;
		if (v[mid].first < x) {
			l = mid+1;
		}
		else if (v[mid].first >= x) {
			r = mid-1;
		}
	}

	l -= 2;
	if (l < 0) l = 0;
	while (l < v.size() && v[l].first < x) l++;
	return l - 1;
}

int main()
{
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);

	

	ll x;

	string s;
	ll n, q;
	ll t, k, pt;
	cin >> n >> q;

	ll cur = 0;
	cin >> s >> t >> k;
	cur = k;
	pt = t;

	v.push_back(ii(0, t));

	if (s == "+") cur *= -1;

	for (int i = 1; i < n; i++) {
		cin >> s >> t >> k;
		v.push_back(ii(max(cur, 0ll), t - pt));
		if (s == "+") k *= -1;
		cur += k;
		pt = t;
	}

	const ll INF = cur;

	sort(v.begin(), v.end());



	/*for (int i = 0; i < v.size(); i++) {
		cout << v[i].first << " " << v[i].second << endl;
	}*/

	times[0] = t;
	psums[0] = 0;

	for (int i = 1; i < v.size(); i++) {
		times[i] = times[i - 1] - v[i-1].second;
		psums[i] = psums[i - 1] + times[i] * (v[i].first - v[i - 1].first);
	}

	/*cout << "times" << endl;
	for (int i = 0; i < v.size(); i++) {
		cout << times[i] << " ";
	}
	cout << endl;

	cout << "psums" << endl;
	for (int i = 0; i < v.size(); i++) {
		cout << psums[i] << " ";
	}
	cout << endl;*/

	


	while (q--) {
		cin >> x;
		if (x < INF) { cout << "INFINITY" << endl; continue; }

		if (x >= v.back().first) {cout << "0" << endl; continue;}


		int i = bs(x);

		ll res = 0;
		if (i == -1) res = x * times[0];
		else res = psums[i] + (x - v[i].first) * times[i+1];
		//cout << x << " " << v[i].first << " " << times[i];
		cout << psums[v.size()-1] - res << endl;
	}

	return 0;
}