#include <iostream>
#include <sstream>
#include <vector>
#include <string>

using namespace std;

bool check(string& st)
{
	if (st.size() < 2) return false;
	if (st[0] < 'A' || st[0] > 'Z') return false;
	for (int i = 1; i < st.size(); ++i)
	{
		if (st[i] < 'a' || st[i] > 'z') return false;
	}
	return true;
}

void abv(vector<string> &v, bool &f)
{
	if (v.size() > 1)
	{
		for (int j = 0; j < v.size(); ++j)
		{
			cout << v[j][0];
		}
		cout << " (";
		for (int j = 0; j < v.size() - 1; ++j)
		{
			cout << v[j] << " ";
		}
		cout << v.back() << ")";
		f = true;
	}
	else
	{
		for (int j = 0; j < v.size(); ++j)
		{
			cout << v[j] << (j == v.size() -1 ? "" : " ");
			f = true;
		}
	}
	v.clear();
}

void make_abv(string sb, bool &f)
{
	vector<string> let;
	string tmp = "";
	for (int i = 0; i < sb.size(); ++i)
	{
		if (sb[i] != ' ') tmp += sb[i];
		else
		{
			let.push_back(tmp);
			tmp = "";
		}
	}
	if (!sb.empty()) let.push_back(tmp);
	
	vector<string> v;
	int i = 0;
	for (i = 0; i < let.size(); ++i)
	{
		if (check(let[i]))
		{
			v.push_back(let[i]);
		}
		else
		{
			if (f && !v.empty()) cout << " ";
			abv(v, f);
			if (f) cout << " ";
			cout << let[i];
			f = true;
		}
	}
	if (!v.empty()) 
	{
		if (f) cout << " ";
		abv(v, f);
	}

}

int main()
{
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	string st;
	while (getline(cin, st))
	{
		string sb;
		bool f = false;
		for (int i = 0; i < st.size(); ++i)
		{
			if (st[i] == '.' || st[i] == ',' || (st[i] == ' ' && i < st.size() - 1 && st[i + 1] == ' '))
			{
				make_abv(sb, f);
				sb = "";
			}
			else
			{
				if (!sb.empty() || st[i] != ' ') sb += st[i];
			}
			if (sb.empty() && (st[i] == '.' || st[i] == ',' || st[i] == ' '))
			{
				cout << st[i];
				f = false;
			}
		}
		if (!sb.empty()) make_abv(sb, f);
		cout << endl;
	}
}