//#include <iostream>
#include <fstream>
#include <stdio.h>
#include <string>
#include <string.h>
using namespace std;

bool is_capital(char c) {
	return 'A' <= c && c <= 'Z';
}

bool is_small(char c) {
	return 'a' <= c && c <= 'z';
}

bool is_good(char* word) {
	int cnt = 0;
	if (is_capital(word[cnt++])) {
		while (is_small(word[cnt])) cnt++;
		return !is_capital(word[cnt]) && cnt > 1;
	}
	return false;
}

int main() {
	ifstream cin ("abbreviation.in");
	ofstream cout("abbreviation.out");
	char buff[1024 * 32];
	char sub[1024];
	while (!cin.eof()) {
		cin.getline(buff, sizeof(buff) - 1);
		int r = 0;

		while (buff[r]) {
			int l = r;
			int w_cnt = 0;
			while (is_good(buff + r)) {
				sub[w_cnt] = buff[r];
				++w_cnt;
				++r;
				while (is_small(buff[r])) ++r;
				if (buff[r] != ' ') break;
				else								++r;
			}
			sub[w_cnt] = 0;

			if (w_cnt > 1) {
				if (buff[r] == ' ' || buff[r - 1] == ' ') --r;
				char t = buff[r];
				buff[r] = 0;
				cout << sub << " (" << (buff + l) << ")" << t;
				buff[r] = t;
				l = r;
			} else {
				while (is_capital(buff[r]) || is_small(buff[r])) ++r;
				if (!buff[r]) --r;
				while (l <= r)	cout << buff[l++];
			}
			if (!buff[r])	break;
			else					r++;
		}
		cout << endl;
	}
	return 0;
}