#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>


using namespace std;


int main()
{
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
	long long n, q;
	cin >> n >> q;
	vector<pair<long long, long long> > qoutes;
	for (long long i = 0; i < n; i++)
	{
		char x;
		cin >> x;
		long long a, b;
		cin >> a >> b;
		if (x == '-')
			qoutes.push_back(make_pair(a, -b));
		if (x == '+')
			qoutes.push_back(make_pair(a, b));
	}
	vector<pair<long long, pair<long long, long long>> > balance;
	balance.push_back(make_pair(0, make_pair(0, 0)));
	for (long long i = 1; i <= n; i++)
		balance.push_back(make_pair(balance[i - 1].first + qoutes[i - 1].second, make_pair(i, (i > 1) ? (qoutes[i-1].first - qoutes[i-2].first) : 0)));
	long long last_bal = balance[n].first;
	sort(balance.begin(), balance.end());
	vector<long long> pref;
	pref.push_back(0);
	for (long long i = 1; i <= n; i++)
		pref.push_back(pref[i - 1] + balance[i - 1].second.second);
	reverse(balance.begin(), balance.end());
	vector<pair<long long, long long> > cur;
	for (long long i = 0; i < q; i++)
	{
		long long a;
		cin >> a;
		cur.push_back(make_pair(a, i));
	}
	sort(cur.begin(), cur.end());
	vector<long long> answers(q);
	long long ptr = 0;
	while (ptr < q && cur[ptr].first + last_bal < 0)
	{
		answers[cur[ptr].second] = -1;
		ptr++;
	}
	long long que = 0;
	long long worst = 0;
	for (long long i = 0; i <= n; i++) {
		worst += max(0LL, -balance[i].first*balance[i].second.second);
	}
	while (que <= n && ptr < q) {
		if (cur[ptr].first + balance[que].first < 0) {
			answers[cur[ptr].second] = worst - pref[n - que + 1]*cur[ptr].first;
			ptr++;
		}
		else {
			worst -= max(0LL, -balance[que].first*balance[que].second.second);
			que++;
		}
	}
	for (long long i = 0; i < q; i++) {
		if (answers[i] == -1) cout << "INFINITY" << endl;
		else cout << answers[i] << endl;
	}
	return 0;
}