#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>


using namespace std;

vector<long long> U1;

vector<long long> U2;

vector<double> dp;


int main()
{
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
	string s;
	cin >> s;
	U1.assign(s.size() + 1, 0);
	U2.assign(s.size() + 1, 0);
	dp.assign(s.size() + 1, 0);
	U1[s.size()] = 0;
	U2[s.size()] = 0;
	int n = s.size();
	for (int i = s.size() - 1; i >= 0; i--)
	{
		U1[i] = U1[i + 1];
		if (s[i] == 'C')
			U1[i] += s.size() - i;
	}
	for (int i = s.size() - 1; i >= 0; i--)
	{
		U2[i] = U2[i + 1];
		if (s[i] == 'W')
			U2[i] += s.size() - i;
	}

	dp[n] = 0.0;
	double sum = 0.0;
	for (int i = n - 1; i >= 0; i--)
	{
		if(s[i] == 'W')
			dp[i] = (U1[i] + sum) / ((double)(n - i));
		else
			dp[i] = (U2[i] + sum) / ((double)(n - i));
		sum += dp[i];
	}
	cout << fixed << setprecision(9) << dp[0];
	return 0;
}