#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>


using namespace std;

#define MAXN 65537

vector<bool> vis;

int main()
{
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
	vis.assign(MAXN, false);

	while (!cin.eof())
	{
		string s;
		getline(cin, s);
		if (s == "")
			continue;
		bool tp = false;
		for (int i = 1; i < s.size(); i++)
		{
			if (s[i] == '&' && s[i - 1] == '&')
				tp = true;
		}
		string a, b;
		bool nextnum = false;
		bool min1 = false, min2 = false;
		for (int i = 0; i < s.size(); i++)
		{
			if (s[i] == '-' && !nextnum)
				min1 = true;
			if (s[i] == '-' && nextnum)
				min2 = true;
			if (s[i] <= '9' && s[i] >= '0')
			{
				if (nextnum)
					b.push_back(s[i]);
				else
					a.push_back(s[i]);
			}
			if (a.size() != 0 && (s[i] > '9' || s[i] < '0'))
				nextnum = true;
		}
		int A = 0, B = 0;
		for (int i = 0; i < a.size(); i++)
			A = A * 10 + a[i] - '0';
		for (int i = 0; i < b.size(); i++)
			B = B * 10 + b[i] - '0';
		bool frst = false, sec = false;
		bool nextcmp = false;
		if (min1)
			A = -A;
		if (min2)
			B = -B;
		for (int i = 0; i < s.size(); i++)
		{
			if (s[i] == '<')
			{
				if (nextcmp)
					sec = false;
				else
					frst = false;
				nextcmp = true;
			}
			if (s[i] == '>')
			{
				if (nextcmp)
					sec = true;
				else
					frst = true;
				nextcmp = true;
			}
		}
		if (tp)
		{
			if (frst && sec)
			{
				for (int i = max(A, B) + MAXN / 2; i < MAXN; i++)
					vis[i] = true;
			}
			if (!frst && sec)
			{
				for (int i = B + MAXN / 2; i <= A + MAXN / 2; i++)
					vis[i] = true;
			}
			if (frst && !sec)
			{
				for (int i = A + MAXN / 2; i <= B + MAXN / 2; i++)
					vis[i] = true;
			}
			if (!frst && !sec)
			{
				for (int i = min(A, B) + MAXN / 2; i >= 0; i--)
					vis[i] = true;
			}
		}
		else
		{
			if (frst)
				for (int i = A + MAXN / 2; i < MAXN; i++)
					vis[i] = true;
			if (!frst)
				for (int i = A + MAXN / 2; i >= 0; i--)
					vis[i] = true;
		}
	}
	bool segm = false;
	int l = 0, r = 0;
	vector<pair<int, int> > ans;
	for (int i = 0; i < MAXN; i++)
	{
		l = i;
		r = 0;
		while (i < MAXN && vis[i])
		{
			if (l != 0)
				segm = true;
			r = i;
			i++;
		}
		if (r != 0)
			ans.push_back(make_pair(l, r));
	}
	//for (int i = 0; i < ans.size(); i++)
	//	cout << ans[i].first - MAXN / 2 << ' ' << ans[i].second - MAXN / 2 << endl;
	if (ans.size() == 0)
	{
		cout << "false";
		return 0;
	}
	if (ans.size() == 1 && ans[0].first == 0 && ans[0].second == MAXN - 1)
	{
		cout << "true";
		return 0;
	}
	if (ans.size() == 1)
	{
		cout << "x >= " << ans[0].first - MAXN / 2 << " && x <= " << ans[0].second - MAXN / 2 << " \n";
		return 0;
	}

	for (int i = 0; i < ans.size(); i++)
	{
		if (i != 0 && i != (ans.size() - 1))
		{
			cout << "x >= " << ans[i].first - MAXN / 2 << " && x <= " << ans[i].second - MAXN / 2 << " ||\n";
		}
		if (i == 0 && ans[i].first == 0)
		{
			cout << "x <= " << ans[i].second - MAXN / 2 << " ||\n";
		}
		if (i == (ans.size() - 1) && ans[i].second == MAXN - 1)
		{
			cout << "x >= " << ans[i].first - MAXN / 2 << " \n";
		}
		if (i == 0 && ans[i].first != 0)
		{
			cout << "x >= " << ans[i].first - MAXN / 2 << " && x <= " << ans[i].second - MAXN / 2 << " ||\n";
		}
		if (i == (ans.size() - 1) && ans[i].second != MAXN - 1)
		{
			cout << "x >= " << ans[i].first - MAXN / 2 << " && x <= " << ans[i].second - MAXN / 2 << " \n";
		}
	}
	return 0;
}