#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define mp make_pair
#define pb push_back

const int MAXN = 100005;
const int MAXM = 1000006;

int head[MAXN], to[MAXM], nxt[MAXM], E;
int p[MAXN];
int n;

void addEdge (int a, int b) {                  
	to[E] = b, nxt[E] = head[a], head[a] = E++;
	to[E] = a, nxt[E] = head[b], head[b] = E++;
}

int getP (int v) {
	if (p[v] == v) return v;
	return p[v] = getP (p[v]);
}

void join (int a, int b) {
	a = getP (a);
	b = getP (b);
	if (a != b)
		cout << "j " << a << ' ' << b << '\n';
	p[a] = b;
}

void load () {
	int t;
	memset (head, 0xff, sizeof (head));
	cin >> n >> t;
	for (int i = 1; i <= n; i++) {
		p[i] = i;
	}

	for (int i = 0, a, b, k; i < t; i++) {
		cin >> k >> a;
		for (int j = 1; j < k; j++) {
			cin >> b;
			addEdge (a, b);
			a = b;
		}
	}                                         
}

char was[MAXN];
vector<int> four[MAXN];
char ft[MAXN];

void dfs (int v, int par = -1) {
	was[v] = 1;
	cout << "r " << v << " 1 3\n";

	int CR = -1;
	
	for (int id = head[v]; ~id; id = nxt[id]) {
		int nv = to[id];
		if (nv == par) continue;
		if (was[nv] == 1) {
			ft[v] = 1;
			four[nv].pb (v);
			CR = nv;
			continue;
		}
		if (was[nv]) continue;
		dfs (nv, v);
	}

	//clog << v << ' ' << CR << endl;

	set<int> fr;

	for (auto nv : four[v]) {
		join (v, nv);
		fr.insert (nv);
	} 
	cout << "c " << v << " 4 3\n";
	cout << "r " << v << " 4 1\n";

	for (int id = head[v]; ~id; id = nxt[id]) {
		int nv = to[id];
		if (nv == par) continue;
		if (nv == CR) continue;
		if (fr.count (nv)) continue;
		join (v, nv);
	}                             
	cout << "c " << v << " 3 2\n";
	cout << "c " << v << " 3 4\n";
	cout << "r " << v << " 2 1\n";
	int c = 2;
	if (ft[v]) c = 4;
	cout << "r " << v << " 3 " << c << '\n';
	was[v] = 2;
}

void solve () {

	dfs (1);
}           

int main () {
	ios_base::sync_with_stdio (false);
	cin.tie (0);                
	freopen ("cactus.in", "r", stdin);
	freopen ("cactus.out", "w", stdout);

	load ();
	solve ();

	return 0;
}