#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define mp make_pair
#define pb push_back

struct Q {
	ll t;
	pair<ll, ll> pr;
	int id;
	Q () {}
	Q (ll t, int id) : t (t), pr (mp (0ll, 0ll)), id (id) {}
	Q (ll t, pair<ll, ll> pr) : t (t), pr (pr), id (-1) {};

   	bool operator < (Q tmp) const {
   		if (t != tmp.t)
   			return t > tmp.t;
		return id > tmp.id;
   	}
};

void operator += (pair<ll, ll> &a, pair<ll, ll> b) {
	a.first += b.first;
	a.second += b.second;
}

void recalc (pair<ll, ll> &a, ll t) {
	a.first += a.second * t;
}

void recalc (pair<ll, ll> &a, ll t1, ll t2) {
	recalc (a, t1 - t2);
}

ll c2 (ll n) {
	return n * (n + 1) / 2;
}

void add (ll &v, ll sv, ll a, ll d, ll t1, ll t2) {
	v += sv;
	ll n = t2 - t1;
	v += a * n;
	v += d * c2 (n);
}

int n, q;     
pair<ll, ll> lst[100005];
pair<ll, int> qq[100005];
ll ans[100005];
int t[100005];
int k[100005];
char tt[100005];
ll bal;

void load () {
	cin >> n >> q;
	string tmp;
	for (int i = 0; i < n; i++) {
		cin >> tmp >> t[i] >> k[i];
		tt[i] = tmp[0];
	}
	t[n] = t[n - 1] + 1;
	for (int i = 0; i < n; i++) {
		if (tt[i] == '+') {
			bal -= k[i];
		}
		else {
			bal += k[i];
		}
		ll dt = t[i + 1] - t[i]; 
		lst[i] = mp (bal, dt);
	}
	for (int i = 0, T; i < q; i++) {
		cin >> T;
		qq[i] = mp (T, i);   
	}
}

void solve () {                     
	sort (lst, lst + n);            
	reverse (lst, lst + n);         
	sort (qq, qq + q);            
	reverse (qq, qq + q);

	fill (ans, ans + q, -1ll);

	ll sum = 0;
	ll last = 0;
	ll tot = 0;

	for (int i = 0, cur = 0; i < q; i++) {
		if (bal - qq[i].first > 0)
			break;
		auto &res = ans[qq[i].second];
		ll dt = last - qq[i].first;
		last = qq[i].first;
		res = dt * sum + tot;
		if (i && qq[i].first == qq[i - 1].first) {
			res = ans[qq[i - 1].second];
			continue;
		} 
        while (cur < n && lst[cur].first >= last) {
        	res += (lst[cur].first - last) * lst[cur].second;
        	sum += lst[cur].second;
        	cur++;
        }
        tot = res;
	}

	for (int i = 0; i < q; i++) {
		if (-1ll == ans[i])
			cout << "INFINITY\n";
		else
			cout << ans[i] << '\n'; 
	}
}

int main () {
	ios_base::sync_with_stdio (false);
	cin.tie (0);                
	freopen ("expect.in", "r", stdin);
	freopen ("expect.out", "w", stdout);
	load ();
	solve ();


	return 0;
}