#include <iostream>
#include <iomanip>
#include <string>
#include <vector>

using namespace std;

string text, ans;
int beginAbb;
int ansBegin;
vector <char> abb;
bool wasFirstLetter;

vector<string> split(string s, char c)
{
	vector<string> mas;
	string buf;
	for (int i = 0; i < s.size(); i++)
	{
		if (s[i] == ' ' || s[i] == ',' || s[i] == '.' || s[i] == '\n')
		{
			if (buf.size() != 0)
				mas.push_back(buf);
			buf.resize(0);
			buf += s[i];
			mas.push_back(buf);
			buf.resize(0);
		}
		else
		{
			buf += s[i];
		}
	}
	return mas;
}

bool isLetter(int i){
	return i < text.size() && text[i] != ' ' && text[i] != ',' && text[i] != '.' && text[i] != '\n';
}

bool isFirstLetter(int i){
	return i == 0 || !isLetter(i - 1);
}

int main(){
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	text = "";
	ans = "";
	string new_s;
	while (getline(cin, new_s)){
		text += new_s;
		text += '\n';
	}

	vector<string> words;
	vector<pair<int,string> > abbWords;
	words = split(text, ' ');
	string abbr = "";
	bool abbrContinue = false;
	int startWord;
	int countSpace = 0;
	for (int i = 0; i < words.size(); i++)
	{
		bool isAbbr = true;
		if (words[i] == " ")
		{
			countSpace++;
			if (countSpace > 1)
			{
				isAbbr = false;
				if (!isAbbr && abbrContinue && abbr.size() > 1)
				{
					abbr += " ";
					//words.insert(words.begin() + startWord, abbr);
					abbWords.push_back(make_pair(startWord,abbr));
					words[startWord].insert(0, "(");
					words[i-1].insert(words[i-1].size(), ")");
					abbrContinue = false;
					abbr = "";
				}
				abbr = "";
				abbrContinue = false;
			}
			continue;
		}
		else
		{
			countSpace = 0;
		}
		if (words[i][0] >= 'A' && words[i][0] <= 'Z')
		{
			for (int j = 1; j < words[i].size(); j++)
			{
				if (words[i][j] >= 'a' && words[i][j] <= 'z')
				{
					isAbbr = true;
				}
				else
				{
					isAbbr = false;
					break;
				}
			}
			if (words[i].size() == 1)
			{
				isAbbr = false;
			}
		}
		else
		{
			isAbbr = false;
		}

		if (!isAbbr && abbrContinue)
		{
			if (!isAbbr && abbrContinue && abbr.size() > 1)
			{
				abbr += " ";
				//words.insert(words.begin() + startWord, abbr);
				abbWords.push_back(make_pair(startWord, abbr));
				words[startWord].insert(0, "(");
				if (words[i-1] == " ")
				{
					words[i-2].insert(words[i-2].size(), ")");
				}
				else
				{
					words[i-1].insert(words[i-1].size(), ")");
				}
				abbrContinue = false;
				abbr = "";
			}
			abbr = "";
			abbrContinue = false;
		}
		if (isAbbr && abbrContinue)
		{
			abbr += words[i][0];
		}
		if (isAbbr && !abbrContinue)
		{
			abbr += words[i][0];
			startWord = i;
			abbrContinue = true;
		}
	}

	int k = 0;
	for (int i = 0; i < words.size(); i++)
	{
		if (k<abbWords.size() && abbWords[k].first == i)
		{
			ans += abbWords[k].second;
			ans += words[i];
			k++;
		}
		else
		{
			ans += words[i];
		}
	}
	cout << ans << endl;

}