#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

#define MININT -32768
#define MAXINT 32767
#define DELETED (MAXINT + 1)

using namespace std;

vector<pair<int, int> > v;

bool cmp(pair<int, int> p1, pair<int, int> p2){
	return p1.first < p2.first || p1.first == p2.first && p1.second < p2.second;
}


int main(){
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);



	string s, tmp;
	int a, b;

	while (true){
		cin >> tmp;
		cin >> s;
		cin >> a;

		int left = MININT;
		int right = MAXINT;

		if (s == ">="){
			left = a;
		}
		else{
			right = a;
		}



		if (!(cin >> tmp))
		{			
			v.push_back(make_pair(left,right));
			break;
		}

		if (tmp == "||"){
			v.push_back(make_pair(left, right));
			continue;
		}

		cin >> tmp >> s >> b;

		if (s == "<="){
			right = b;
		}
		else{
			left = b;
		}


		if (left <= right){
			v.push_back(make_pair(left, right));
		}

		if (!(cin >> s && s == "||")){
			break;
		}
	}



	if (v.size() == 0){
		cout << "false";
		return 0;
	}

	sort(v.begin(), v.end(), cmp);

	for (int i = 0; i < v.size() - 1; i++){
		if (v[i].second + 1 >= v[i + 1].first){
			v[i + 1].first = v[i].first;
			v[i + 1].second = max(v[i].second, v[i + 1].second);
			v[i].first = DELETED;
		}
	}



	vector<pair<int, int > > v2;

	for (int i = 0; i < v.size(); i++){
		if (v[i].first != DELETED)
			v2.push_back(v[i]);
	}

	if (v2.size() == 1 && v2[0].first == MININT && v2[0].second == MAXINT){
		cout << "true";
		return 0;
	}


	for (int i = 0; i < v2.size(); i++){

		if (i != 0) cout << " ||" << endl;

		if (v2[i].first == MININT)
		{
			cout << "x <= " << v2[i].second;
		}

		if (v2[i].second == MAXINT){
			cout << "x >= " << v2[i].first;
		}

		if (v2[i].first != MININT && v2[i].second != MAXINT){
			cout << "x >= " << v2[i].first << " && x <= " << v2[i].second;		
		}

	}

	cout << endl;


}