#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include<string>
#include<vector>
#include<time.h>
#include<set>
#include<map>

using namespace std;

typedef long long int int64;


string st;
double ans;

const int N = 1000031;

int n;
double dp[N];
double S_W, S_C;
int S[N];

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#else
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
#endif

	getline(cin, st);
	
	int cnt_good = 0;
	int cnt_bad = 0;

	n = st.size();

	for (int i = 0; i < st.size(); i++)
	{
		S[i + 1] = S[i] + (st[i] == 'W');
	}

	dp[st.size()] = 0;
	S_W = S[st.size()];
	S_C = n - S[st.size()];

	for (int i = st.size() - 1; i >= 0; --i)
	{
		if (st[i] == 'C')
		{
			double total_prob = S_W - (S[i])*1.0*(n - i);
			dp[i] = total_prob / (n - i);
		}
		else
		{
			double total_prob = S_C - (i - S[i])*1.0*(n - i);
			dp[i] = total_prob / (n - i);
		}
		S_W += dp[i] + S[i];
		S_C += dp[i] + (i - S[i]);
		//cout << i << " " << S_W << " " << S_C << endl;
	}

	cout.precision(12);
	cout << fixed << dp[0] << endl;

	return 0;
}