import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Program {
    static String FILE_NAME = "abbreviation";

    public static void main(String... args) throws Exception {
        new Program().Run();
    }

    public void Run() throws Exception {
//        Scanner input = new Scanner(FILE_NAME + ".in");
//        FileInputStream i1 = new FileInputStream("");
//        BufferedInputStream s1 = new BufferedInputStream((i1));
        List<String> lines = Files.readAllLines(new File(FILE_NAME + ".in").toPath());
        //FileOutputStream output = new FileOutputStream(FILE_NAME + ".out");
        FileWriter output = new FileWriter(FILE_NAME + ".out");

        for (String s : lines) {
            //char[] chars = s.toCharArray();
            String[] strings = SuperSplit(s);//s.split("[ \\.,]");

            int ss = -1;
            List<String> seq = new ArrayList<>();
            //boolean reqSpace = true;

            for (int i = 0; i < strings.length; i++) {
                String word = strings[i];

                if (WordGood(word) ||
                        (i >= 1 && word.equals(" ") && WordGood(strings[i - 1]))) {
                    seq.add(word);
                } else {
                    // BEG
                    if (seq.size() >= 3) {
                        for (String seqw : seq) {
                            if (seqw.equals(" "))
                                continue;

                            output.write(seqw.charAt(0));
                        }

                        output.write(" (");

                        for (int j = 0; j < seq.size() - 1; j++) {
                            String seqw = seq.get(j);

                            if (seqw.equals(" "))
                                continue;

                            if (j != 0) {
                                output.write(" ");
                            }
                            output.write(seqw);
                        }

                        String lastInSequence = seq.get(seq.size() - 1);
                        if (!lastInSequence.equals(" "))
                            output.write(lastInSequence);

                        seq.clear();

                        output.write(")");

                        if (lastInSequence.equals(" "))
                            output.write(lastInSequence);
                    } else {
                        for (String seqw : seq) {
                            output.write(seqw);
                        }

                        seq.clear();
                    }
                    // END

                    output.write(word);
                }
            }

            // BEG
            if (seq.size() >= 3) {
                for (String seqw : seq) {
                    if (seqw.equals(" "))
                        continue;

                    output.write(seqw.charAt(0));
                }

                output.write(" (");

                for (int j = 0; j < seq.size() - 1; j++) {
                    String seqw = seq.get(j);

                    if (seqw.equals(" "))
                        continue;

                    if (j != 0) {
                        output.write(" ");
                    }
                    output.write(seqw);
                }

                String lastInSequence = seq.get(seq.size() - 1);
                if (!lastInSequence.equals(" "))
                    output.write(lastInSequence);

                seq.clear();

                output.write(")");

                if (lastInSequence.equals(" "))
                    output.write(lastInSequence);
            } else {
                for (String seqw : seq) {
                    output.write(seqw);
                }

                seq.clear();
            }
            // END

            output.write("\r\n");
        }

        // End
        //input.close();
        output.close();
    }

    public String[] SuperSplit(String s) {
        ArrayList<String> result = new ArrayList<>();
        char[] chars = s.toCharArray();

        StringBuilder sb = new StringBuilder();

        for (int i = 0; i < chars.length; i++) {
            if (Character.isLetter(chars[i])) {
                sb.append(chars[i]);
            } else {
                if (sb.length() > 0) {
                    result.add(sb.toString());
                    sb = new StringBuilder();
                }

                result.add(Character.toString(chars[i]));
            }
        }

        if (sb.length() > 0) {
            result.add(sb.toString());
            sb = new StringBuilder();
        }

        return result.toArray(new String[result.size()]);
    }

    public boolean WordGood(String s) {
        if (s.length() < 2)
            return false;

        for (int i = 0; i < s.length(); i++) {
            if (!Character.isLetter(s.charAt(i))) {
                return  false;
            }
        }

        if (!Character.isUpperCase(s.charAt(0)))
            return false;

        for (int i = 1; i < s.length(); i++) {
            if (Character.isUpperCase(s.charAt(i))) {
                return  false;
            }
        }

        return true;
    }

    public enum State {
        No,
        MaybeFirst,
        Maybe
    }
}
