// CCC.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <math.h>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; i++)
#define mp make_pair
#define left first
#define right second

const int minInf = -32769;
const int maxInf = 32768;

vector <pair <int, int> > segments;
vector <pair <int, int> > ans;
string s;

pair<int, int> GetSegment(string s) {
	pair<int, int> curSegment;
	curSegment = mp(minInf, maxInf);
	int uk = 2;
	int curInt = 0;
	bool minus = false;
	if (s[uk] == '>') {
		uk = 5;
		if (s[uk] == '-') {
			uk++;
			minus = true;
		}
		while (s[uk] != ' ') {
			curInt = curInt * 10 + (int)(s[uk]) - (int)('0');
			uk++;
		}
		if (minus)
			curInt = -curInt;
		curSegment.left = max(curSegment.left, curInt);
		curInt = 0;
		minus = false;
	}
	else {
		uk = 5;
		if (s[uk] == '-') {
			uk++;
			minus = true;
		}
		while (s[uk] != ' ') {
			curInt = curInt * 10 + (int)(s[uk]) - (int)('0');
			uk++;
		}
		if (minus)
			curInt = -curInt;
		curSegment.right = min(curSegment.right, curInt);
		curInt = 0;
		minus = false;
	}
	while (true) {
		if (uk == s.size() || s[uk] == '|')
			return curSegment;
		if (s[uk] == '<' || s[uk] == '>')
			break;
		uk++;
	}
	if (s[uk] == '>') {
		uk += 3;
		if (s[uk] == '-') {
			uk++;
			minus = true;
		}
		while (s[uk] != ' ') {
			curInt = curInt * 10 + (int)(s[uk]) - (int)('0');
			uk++;
		}
		if (minus)
			curInt = -curInt;
		curSegment.left = max(curSegment.left, curInt);
		curInt = 0;
		minus = false;
	}
	else {
		uk += 3;
		if (s[uk] == '-') {
			uk++;
			minus = true;
		}
		while (s[uk] != ' ') {
			curInt = curInt * 10 + (int)(s[uk]) - (int)('0');
			uk++;
		}
		if (minus)
			curInt = -curInt;
		curSegment.right = min(curSegment.right, curInt);
		curInt = 0;
		minus = false;
	}
	return curSegment;
}

void write(pair<int, int> cur) {
	if (cur.left <= minInf + 1) {
		printf("x <= %d", cur.right);
		return;
	}
	if (cur.right >= maxInf - 1) {
		printf("x >= %d", cur.left);
		return;
	}
	printf("x >= %d && x <= %d", cur.left, cur.right);
	return;
}

int main()
{
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	while (getline(cin, s))
	{
		s += ' ';
		pair<int, int> p = GetSegment(s);
		if (p.left <= p.right)
			segments.push_back(p);
	}
	sort(segments.begin(), segments.end());
	int rightedEnd = minInf - 2;
	int leftedStart = minInf - 2;
	forn(i, segments.size()) {
		if (segments[i].left - 1 > rightedEnd) {
			if (rightedEnd != minInf - 2) {
				ans.push_back(mp(leftedStart, rightedEnd));
			}
			leftedStart = segments[i].left;
			rightedEnd = segments[i].right;
		}
		else {
			rightedEnd = max(rightedEnd, segments[i].right);
		}
	}
	if (rightedEnd != minInf - 2) {
		ans.push_back(mp(leftedStart, rightedEnd));
	}

	if (ans.size() == 0) {
		printf("false");
		return 0;
	}

	if (ans.size() == 1 && ans[0].left <= minInf + 1 && ans[0].right >= maxInf - 1) {
		printf("true");
		return 0;
	}

	forn(i, ans.size()) {
		write(ans[i]);
		if (i != ans.size() - 1)
			printf(" ||\n");
	}
	return 0;
}

