#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int inf = 32768;

int main()
{

    //freopen("abbreviation.in", "r", stdin);

    ifstream cin("hard.in");
    ofstream cout("hard.out");
    //ofstream cout("abbreviation.out");

    //ios_base::sync_with_stdio(false);
    //cin.tie(0);

    vector<int> cnt(2 * inf);

    string s;
    while (getline(cin, s)) {
        if (s[0] != 'x') {
            continue;
        }
        int pos = -1;
        for (int i = 0; i < sz(s); ++i) {
            if (s[i] == '&') {
                pos = i;
            }
        }
        if (pos == -1) {
            for (int i = 0; i < sz(s); ++i) {
                if (s[i] == '<') {
                    pos = i;
                }
            }
            int val = 0;
            int sgn = 1;
            for (int i = 0; i < sz(s); ++i) {
                if (s[i] >= '0' && s[i] <= '9') {
                    val *= 10;
                    val += (s[i] - '0');
                }
                if (s[i] == '-') {
                    sgn = -1;
                }
            }
            val *= sgn;
            if (pos == -1) {
                //cout << " >= " << val << "\n";
                val += inf;
                for (int i = val; i < 2 * inf; ++i) {
                    cnt[i] = 1;
                }
            } else {
                //cout << " <= " << val << "\n";
                val += inf;
                for (int i = 0; i <= val; ++i) {
                    cnt[i] = 1;
                }
            }
        } else {
            int val1 = 0, val2 = 0;
            int sgn1 = 1, sgn2 = 1;
            int state = 0;
            for (int i = 0; i < sz(s); ++i) {
                if (s[i] >= '0' && s[i] <= '9') {
                    if (state == 0) {
                        val1 *= 10;
                        val1 += s[i] - '0';
                    } else {
                        val2 *= 10;
                        val2 += s[i] - '0';
                    }
                }
                if (s[i] == '-') {
                    if (state == 0) {
                        sgn1 = -1;
                    } else {
                        sgn2 = -1;
                    }
                }
                if (s[i] == '&') {
                    state = 1;
                }
            }
            val1 *= sgn1;
            val2 *= sgn2;
            val1 += inf;
            val2 += inf;
            for (int i = val1; i <= val2; ++i) {
                cnt[i] = 1;
            }
        }
    }

    int prev = -1;
    vector<pii> segs;
    for (int i = 0; i < 2 * inf; ++i) {
        if (prev == -1) {
            if (cnt[i] == 1) {
                prev = i;
            }
        } else if (cnt[i] == 0) {
            segs.pb({prev, i - 1});
            prev = -1;
        }
    }
    if (prev != -1) {
        segs.pb({prev, 2 * inf - 1});
    }

    if (segs.empty()) {
        cout << "false\n";
        return 0;
    }
    if (sz(segs) == 1 && segs[0].first == 0 && segs[0].second == 2 * inf - 1) {
        cout << "true\n";
        return 0;
    }

    for (int i = 0; i < sz(segs); ++i) {
        if (segs[i].first == 0) {
            cout << "x <= " << segs[i].second - inf;
        } else if (segs[i].second == 2 * inf - 1) {
            cout << "x >= " << segs[i].first - inf;
        } else {
            cout << "x >= " << segs[i].first - inf << " && x <= " << segs[i].second - inf;
        }
        if (i != sz(segs) - 1) {
            cout << " ||\n";
        } else {
            cout << "\n";
        }
    }

}
