#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int main()
{

    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
    //freopen("abbreviation.out", "w", stdout);

    //ifstream cin("abbreviation.in");
    //ofstream cout("abbreviation.out");

    //ios_base::sync_with_stdio(false);
    //cin.tie(0);

    ll n, w;
    cin >> n >> w;

    int h, q;
    cin >> h >> q;

    vector<pll> sumAbove(h + 1);
    vector<ll> cntAbove(h + 1);
    sumAbove[h] = {0, 0};
    cntAbove[h] = 0;

    for (int i = h - 1; i >= 1; --i) {
        ll x = ll(2) * (w * n * (n + 1) - n * w);
        ll y = ll(2) * n * w * n;
        if (i & 1) {
            swap(x, y);
        }
        sumAbove[i] = {sumAbove[i + 1].first + x, sumAbove[i + 1].second + y};
        cntAbove[i] = cntAbove[i + 1] + ll(4) * n;
    }

    vector<vector<char> > alive(h + 1, vector<char>(n + 1, true));
    vector<int> lf(h + 1, 1);
    vector<int> rg(h + 1, n);

    for (int step = 1; step <= q; ++step) {
        int level, id;
        cin >> level >> id;
        ll x = ll(2) * (w * ll(id - 1) + w * ll(id));
        ll y = ll(2) * w * n;
        if (!(level & 1)) {
            swap(x, y);
        }
        for (int i = level - 1; i >= 1; --i) {
            sumAbove[i].first -= x;
            sumAbove[i].second -= y;
            cntAbove[i] -= 4;
        }
        alive[level][id] = false;
        while (lf[level] <= n && !alive[level][lf[level]]) {
            ++lf[level];
        }
        while (rg[level] >= 1 && !alive[level][rg[level]]) {
            --rg[level];
        }
        bool ok = true;
        for (int i = h - 1; i >= 1; --i) {
            if (lf[i + 1] == n + 1) {
                continue;
            }
            if (lf[i] == n + 1) {
                ok = false;
                break;
            }
            if (i & 1) {
                ll sum = sumAbove[i].first;
                ll cnt = cntAbove[i];
                ll xmin = ll(lf[i] - 1) * w;
                ll xmax = ll(rg[i]) * w;
                if (sum > cnt * xmin && sum < cnt * xmax) {
                    continue;
                } else {
                    ok = false;
                    break;
                }
            } else {
                ll sum = sumAbove[i].second;
                ll cnt = cntAbove[i];
                ll ymin = ll(lf[i] - 1) * w;
                ll ymax = ll(rg[i]) * w;
                /*if (step == q && i == 4) {
                    cout << sum << " " << cnt << " " << ymin << " " << ymax << "\n";
                }*/
                if (sum > cnt * ymin && sum < cnt * ymax) {
                    continue;
                } else {
                    ok = false;
                    break;
                }
            }
        }
        if (!ok) {
            cout << "yes\n";
            cout << step << "\n";
            return 0;
        }
    }

    cout << "no\n";

}
