#include <bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long long ll;

const int MAXH = 5000;
const int MAXN = 10000;

ll hp[MAXH + 1], wp[MAXH + 1];

int n, h, m;
ll l[MAXH + 1], r[MAXH + 1], cnt[MAXH + 1];
bool delt[MAXH + 1][MAXN + 1];
int reqn;

void rebound(int level) {
    while (l[level] + 1 <= n && delt[level][l[level] + 1]) {
        l[level]++;
    }
    while (r[level] > 0 && delt[level][r[level]]) {
        r[level]--;
    }
    if (r[level] == 0) {
        if (level == h) {
            h--;
        } else {
            cout << "yes\n" << reqn;
            exit(0);
        }
    }
}

int lev, k;

void recalc(int level) {
    ld x = n;
    ld y = k * 2 - 1;
    if (lev ^ 1)
        swap(x, y);
    hp[level] -= x;
    wp[level] -= y;
    cnt[level]--;
}

bool isgood(int level) {
    if (level + 1 > h) {
        return true;
    }
    ld x = hp[level + 1];
    if (lev ^ 1) {
        x = wp[level + 1];
    }
    return (x > cnt[level + 1] * 2 * l[level] &&
    		x < cnt[level + 1] * 2 * r[level]);
}

int main() {
    ios_base::sync_with_stdio(false);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
#endif // KOBRA
    cin >> n >> h >> h >> m;
    for(int i = h; i >= 1; i--){
    	cnt[i] = cnt[i+1] + n;
    	hp[i] = wp[i] = ll(cnt[i]) * n;
    }
    fill(r, r + MAXH + 1, n);
    for (reqn = 1; reqn <= m; reqn++) {
        cin >> lev >> k;
        delt[lev][k] = true;
        rebound(lev);
        for (int i = lev; i >= 1; i--) {
            if (!isgood(i)) {
                cout << "yes\n" << reqn;
                exit(0);
            }
            recalc(i);
        }
    }
    cout << "no\n";
}
