#include <iostream>
#include <string>

using namespace std;

void addAbbr(string abbr, string &ans, string s, int first, int last, int cur)
{
	if (abbr.length() > 1)
	{
		ans += abbr + " (" + s.substr(first, last - first) + ")";
		ans += s.substr(last, cur - last + 1);
	}
	else {
		ans += s.substr(first, cur - first + 1);
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	string s;
	int sost = 0;
	string abbr = "";
	string ans = "";
	string temp = "";
	int curL = 1, first = 0, last = 0, abbrLast = 0;
	while (!cin.eof())
	{
		getline(cin, s);
		sost = 0;
		abbr = "";
		ans = "";
		temp = "";
		for (int i = 0; i < s.length(); i++)
		{
			switch (sost)
			{
			case 0:
				if (s[i] >= 'A' && s[i] <= 'Z' && (i == 0 || (s[i - 1] ==' ' || s[i-1] == '.' || s[i-1] == ',')))
				{
					abbr = "";
					abbr += s[i];
					sost = 1;
					curL = 1;
					first = i;
					last = i;
					abbrLast = 0;
				}
				else {
					ans += s[i];
				}
				break;
			case 1:
				if (s[i] >= 'a' && s[i] <= 'z')
				{
					curL++;
				}
				else if (s[i] >= 'A' && s[i] <= 'Z')
				{
					abbr = abbr.substr(0, abbr.length() - 1);
					addAbbr(abbr, ans, s, first, last, i);
					sost = 3;
				}
				else if (s[i] == ' ')
				{ 
					if (i < s.length() - 1 && (s[i + 1] >= 'A' && s[i + 1] <= 'Z'))
					{
						if (curL == 1)
						{
							abbr = abbr.substr(0, abbr.length() - 1);
							addAbbr(abbr, ans, s, first, last, i);
						}
						else {
						    sost = 2;
						}
					}
					else {
						if (curL == 1)
						{
							abbr = abbr.substr(0, abbr.length() - 1);
						}
						else {
							last = i;
						}
						addAbbr(abbr, ans, s, first, last, i);
						sost = 0;
					}
                }
				else {
					if (curL == 1)
					{
						abbr = abbr.substr(0, abbr.length() - 1);
					}
					else {
						last = i;
					}
					addAbbr(abbr, ans, s, first, last, i);
					sost = 0;
				}
				break;
			case 2:
				abbr += s[i];
				curL = 1;
				last = i - 1;
				sost = 1;
				break;
			case 3:
				ans += s[i];
				if (s[i] == ' ' || s[i] == '.' || s[i] == ',')
				{
					sost = 0;
				}
				break;
			}
		}
		if (sost == 1)
		{
			if (curL == 1)
			{
				abbr = abbr.substr(0, abbr.length() - 1);
			}
			else {
				last = s.length();
			}
			addAbbr(abbr, ans, s, first, last, s.length() - 1);
		}
		cout << ans << endl;
	}
}