#include <bits/stdc++.h>

using namespace std;

const int maxn = 2501;
long long dp[maxn + 200][maxn + 200];
long long ct[maxn + 200][maxn + 200];
int p[maxn + 200];
int cnt = 0;

bool isPrime(int x){
    for (int i = 2; i * i <= x; i++){
        if (x % i == 0) return 0;
    }
    return 1;
}

long long getl(int x){
    int ct = 0;
    while (x > 0){
        ct++;
        x /= 10;
    }
    return ct + 2;
}

vector<int> an;

string tos(int x, string& a){
    string ans = "";
    while (x > 0){
        ans.push_back(x % 10 + '0');
        x /= 10;
    }
    reverse(ans.begin(), ans.end());
    for (auto c: ans)
        a.push_back(c);
}

struct ans_t{
    long long cnt, pos;
    string s;

    ans_t(long long cnt, long long pos, string s):cnt(cnt), pos(pos), s(s){}
};

long long sub(int sum, int j, long long remain){
    return dp[sum][j] - dp[sum][j + 1] + (ct[sum][j] - ct[sum][j + 1]) * remain;
}

ans_t gans(long long a){
    an.clear();
    a++;
    int sum = 1;
    long long cnta = 0;
    while (a > dp[sum][0]){
        a -= dp[sum][0];
        cnta += ct[sum][0];
        sum++;
    }
    int j = 0;
    long long remain = 0;
    while (j < cnt){
        if (a > sub(sum, j, remain)){
            a -= sub(sum, j, remain);//(dp[sum][j] - dp[sum][j + 1]) + ;
            cnta += ct[sum][j] - ct[sum][j + 1];
        }
        else{
            an.push_back(p[j]);
            remain += getl(p[j]);
            sum -= p[j];
        }
        j++;
    }
    //cerr << cnta << "\n";
    string out = "[";
    for (int j = 0; j < an.size(); j++){
        tos(an[j], out);
        if (j == an.size() - 1){
            out.push_back(']');
        }
        out.push_back(',');
        out.push_back(' ');
    }
    a--;
    return ans_t(cnta, a, out);
}

void print(long long a, long long b){
    a--;
    b--;
    ans_t l = gans(a);
    ans_t r = gans(b);
    while (l.cnt < r.cnt){
        for (size_t i = l.pos; i < l.s.size(); i++){
            cout << l.s[i];
        }
        a += l.s.size() - l.pos;
        l = gans(a);
    }
    for (int i = l.pos; i <= r.pos; i++){
        cout << l.s[i];
    }
}

int main()
{
    #ifndef DEBUG
    freopen("list.in", "r", stdin);
    freopen("list.out", "w", stdout);
    #else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // DEBUG
    long long a, b;
    cin >> a >> b;
    for (int i = 2; i <= maxn - 1; i++){
        if (isPrime(i)){
            p[cnt++] = i;
        }
    }
    long long sum = 0;
    for (int i = 1; i <= maxn - 1; i++){
        for (int j = cnt - 1; j >= 0; j--){
            if (i < p[j]){
                ct[i][j] = 0;
                dp[i][j] = 0;
            }
            else if (i == p[j]){
                ct[i][j] = 1;
                dp[i][j] = getl(p[j]) + 2;
            }
            else{
                ct[i][j] = ct[i][j + 1] + ct[i - p[j]][j + 1];
                dp[i][j] = dp[i][j + 1] + dp[i - p[j]][j + 1] + getl(p[j]) * ct[i - p[j]][j + 1];
            }
        }
        sum += dp[i][0];
    }
    print(a, b);
    return 0;
}


