#include <iostream>
#include <cstdio>

const int N = (int)1e6 + 34;

using namespace std;
typedef long long ll;

char ch[N];
int t[N], k[N], x, n, m;
ll p[N], sum[N];

int main() {
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);

    scanf("%d%d\n", &n, &m);
    for (int i = 0; i < n; i++) {
        scanf("%c %d %d\n", ch + i, t + i, k + i);
    }

    int bal = 0;
    for (int i = 0; i + 1 < n; i++) {
        if (ch[i] == '+') k[i] = -k[i];
        bal += k[i];
        if (bal >= 0)
            p[bal] += (t[i + 1] - t[i]);
    }
    if (ch[n - 1] == '+') k[n - 1] = -k[n - 1];
    bal += k[n - 1];

    for (int i = N - 2; i >= 0; i--) {
        p[i] += p[i + 1];
        sum[i] = p[i] + sum[i + 1];
    }

    while (m--) {
        scanf("%d", &x);
        if (bal - x > 0)
            cout << "INFINITY\n";
        else
            cout << sum[x + 1] << "\n";
    }

    return 0;
}
