#include <iostream>
#include <cstdio>
#include <map>

const int N = (int)1e6 + 34;

using namespace std;
typedef long long ll;

char ch[N];
int t[N], k[N], x, n, m;
ll sum[N], p[N];

map <int, ll> mp;

pair <int, ll> l[N];
int len;

int main() {
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);

    scanf("%d%d\n", &n, &m);
    for (int i = 0; i < n; i++) {
        scanf("%c %d %d\n", ch + i, t + i, k + i);
    }

    int bal = 0;
    for (int i = 0; i + 1 < n; i++) {
        if (ch[i] == '+') k[i] = -k[i];
        bal += k[i];
        if (bal >= 0)
            mp[bal] += (t[i + 1] - t[i]);
    }
    if (ch[n - 1] == '+') k[n - 1] = -k[n - 1];
    bal += k[n - 1];

    for (auto it: mp) {
        l[len++] = {it.first, it.second};
        //printf("%d %I64d\n", l[len - 1].first, l[len - 1].second);
    }

    p[len - 1] = sum[len - 1] = l[len - 1].second;
    for (int i = len - 2; i >= 0; i--) {
        p[i] = p[i + 1] + l[i].second;
        sum[i] = p[i] + sum[i + 1] + p[i + 1] * (l[i + 1].first - l[i].first - 1);
    }

    int num;
    ll res;
    while (m--) {
        scanf("%d", &x);
        if (-x + bal > 0) {
            cout << "INFINITY\n";
            continue;
        }

        x++;
        num = lower_bound(l, l + len, make_pair(x, -1ll)) - l;
        res = sum[num] + p[num] * (l[num].first - x);
        cout << res << "\n";
    }



    return 0;
}
