#include <iostream>
#include <cstdio>
#include <map>
#include <vector>
#include <algorithm>

const int N = (int)1e6 + 34;

using namespace std;
typedef long long ll;

const int SUM = 2100;

ll len[N];
ll dp[SUM + 2][SUM + 2];
ll kol[SUM + 2][SUM + 2];
bool u[N];
ll d[SUM + 2];
ll k[SUM + 2];
int m;
ll pd[SUM + 2];
vector <int> p;

string inttostr(int x) {
    string res = "";
    while (x > 0) {
        res += char('0' + x % 10);
        x /= 10;
    }
    reverse(res.begin(), res.end());
    return res;
}

string print(vector <int> v) {
    string res = "[";
    for (int i = 0; i < (int)v.size(); i++) {
        if (i) res += ", ";
        res += inttostr(v[i]);
    }
    res += "], ";
    return res;
}

ll start = -1;
ll start0 = -1;
ll leng;

string tostr(ll l) {
    vector <int> v;
    v.clear();
    ll sum = 0, cur_sum = 0;
    while (pd[sum] < l) sum++;
    leng = pd[sum - 1];
    ll len_left = 0;

    int lst = -1;
    while (cur_sum < sum) {
        for (int i = lst + 1; i < m; i++) {
            leng += dp[sum - cur_sum][i] + kol[sum - cur_sum][i] * len_left;
            if (leng >= l) {
                leng -= dp[sum - cur_sum][i] + kol[sum - cur_sum][i] * len_left;
                v.push_back(p[i]);
                cur_sum += p[i];
                len_left += (len[p[i]] + 2);
                lst = i;
                break;
            }
        }
    }

    start = leng + 1;
    if (start0 == -1)
        start0 = leng + 1;

    return print(v);
}

int main() {
    freopen("list.in", "r", stdin);
    freopen("list.out", "w", stdout);

    for (int i = 1; i < N; i++)
        len[i] = len[i / 10] + 1;

    for (ll i = 2; i <= SUM; i++) {
        if (u[i]) continue;

        //cerr << i << "\n";

        dp[i][p.size()] = len[i] + 4;
        kol[i][p.size()] = 1;
        p.push_back(i);
        for (ll j = i * i; j <= SUM; j += i) {
            u[j] = true;
        }
    }

    m = p.size();
    //for (int i = 0; i < m; i++) cout << p[i] << " "; cout << "\n";

    //cerr << m << "\n";
    for (int sum = 2; sum <= SUM; sum++)
    for (int lst = m - 1; lst >= 0; lst--) {
        if (kol[sum][lst] == 0) continue;
        d[sum] += dp[sum][lst];
        k[sum] += kol[sum][lst];
        for (int i = 0; i < lst; i++) {
            if (sum + p[i] > SUM) continue;
            dp[sum + p[i]][i] += dp[sum][lst] + kol[sum][lst] * (len[p[i]] + 2);
            kol[sum + p[i]][i] += kol[sum][lst];
        }
    }

    pd[0] = d[0];
    for (int i = 1; i <= SUM; i++)
        pd[i] = pd[i - 1] + d[i];

    /*int q = 0;
    for (int i = 0; i < 15; i++) {
        cout << dp[31][i] << "\n";
        q += dp[31][i];
    }
    cout << q << " " << d[31] << "\n";
    return 0;*/

    //cout << pd[2096] << "\n";
    //cout << 1000000000000000000 << "\n";


    /*cerr << d[29] << "\n";
    cerr << dp[29][0] << "\n";
    cerr << dp[29][1] << "\n";
    cerr << dp[29][2] << "\n";
    cerr << dp[29][3] << "\n";

    cerr << d[31] << " " << d[29] << " " << dp[31][0] << " " << d[29] - dp[29][0] << "\n";
    cerr << k[31] << " " << kol[31][0] << " " << k[29] - kol[29][0] << "\n";*/

    ll l, r;
    cin >> l >> r;

    ll clen = 0;

    /*cerr << tostr(952) << "\n";
    cerr << tostr(998) << "\n";*/

    string big;
    string t;

    big = t = tostr(l);
    clen = t.length();
    //cerr << t << "\n";

    //cerr << start0 << " st\n";
    while (start0 + (int)big.length() <= r) {
        t = tostr(start0 + (int)big.length() + 2);
        //if (t == "[2, 3, 7, 19], ")
        //    cerr << start0 + (int)big.length() + 2 << " " << t << "\n";
        big += t;
    }

    t.clear();

    for (ll i = l; i <= r; i++)
        t += big[i - start0];

    cout << t;

    return 0;
}
