#define _CRT_SECURE_NO_WARNINGS
#define TASK "abbreviation"

#include <iostream>
#include <string>
#include <vector>
#include <stdio.h>
#include <stack>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <iomanip>

using namespace std;

double workTime()
{
	return (double)clock() / CLOCKS_PER_SEC;
}

void myReturn(int code = 0)
{
#ifdef LOCAL
	cout << "\nTime = " << fixed << setprecision(3) << workTime() << endl;
#endif
	exit(code);
}

string cur, abr, babr;
bool pr;

void abrOut()
{
	if (abr.length() > 1)
	{
		if (babr[babr.length() - 1] == ' ')
		{
			babr.pop_back();
			cout << abr << " (" << babr << ") ";
		}
		else
			cout << abr << " (" << babr << ')';
	}
	else
		cout << babr;
	abr = "";
	babr = "";
	pr = false;
}

bool LET(char c)
{
	return c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z';
}

bool CAP(char c)
{
	return c >= 'A' && c <= 'Z';
}

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	while (getline(cin, cur))
	{
		abr = "";
		babr = "";
		pr = false;

		for (size_t i = 0; i < cur.length(); i++)
		{
			if (CAP(cur[i]))
			{
				if (i > 0)
				{
					if (!LET(cur[i - 1]))
					{
						pr = true;
						abr += cur[i];
						babr += cur[i];
					}
					else
					{
						stack<char> temp;
						while (!babr.empty() && LET(babr[babr.length() - 1]))
						{
							temp.push(babr[babr.length() - 1]);
							babr.pop_back();
						}
						if(!abr.empty())
							abr.pop_back();
						abrOut();
						while (!temp.empty())
						{
							cout << temp.top();
							temp.pop();
						}
						cout << cur[i];
					}
				}
				else
				{
					pr = true;
					abr += cur[i];
					babr += cur[i];
				}
			}
			else if (cur[i] >= 'a' && cur[i] <= 'z')
			{
				if (pr && i > 0 && !LET(babr[babr.length() - 1]))
					abrOut();
				if (pr)
					babr += cur[i];
				else
					cout << cur[i];
			}
			else if (cur[i] == ' ')
			{
				if (i > 0 && cur[i - 1] == ' ' || CAP(cur[i - 1]))
				{
					if (babr.length() > 0)
					{
						if (LET(babr[babr.length() - 1]))
						{
							char temp = babr[babr.length() - 1];
							babr.pop_back();
							abr.pop_back();
							abrOut();
							cout << temp;
						}
						else
							abrOut();
					}
					else
						abrOut();
					cout << cur[i];
				}
				else
				{
					if (pr)
						babr += cur[i];
					else
						cout << cur[i];
				}
			}
			else
			{
				abrOut();
				cout << cur[i];
			}
		}
		abrOut();

		cout << endl;

	}

	myReturn();
}

//This is ACM Nor Esdfjk Efghkl Radfskjbfe Conted,
//sponsored bi Internatio Busina Mache.
//The.Best.Contest.Eva.
//A Great Opotunity fo al contest.