#define _CRT_SECURE_NO_WARNINGS
#define TASK "abbreviation"

#include <iostream>
#include <string>
#include <vector>
#include <stdio.h>
#include <stack>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <iomanip>

using namespace std;

double workTime()
{
	return (double)clock() / CLOCKS_PER_SEC;
}

void myReturn(int code = 0)
{
#ifdef LOCAL
	cout << "\nTime = " << fixed << setprecision(3) << workTime() << endl;
#endif
	exit(code);
}

string cur, abr, babr;
bool pr;

void abrOut()
{
	if (abr.length() > 1)
	{
		if (babr[babr.length() - 1] == ' ')
		{
			babr.pop_back();
			cout << abr << " (" << babr << ") ";
		}
		else
			cout << abr << " (" << babr << ')';
	}
	else
		cout << babr;
	abr = "";
	babr = "";
	pr = false;
}

bool LET(char c)
{
	return c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z';
}

bool CAP(char c)
{
	return c >= 'A' && c <= 'Z';
}

bool capitalized(string &s)
{
	if (s.length() == 1)
		return false;
	if (!CAP(s[0]))
		return false;
	for (int i = 1; i < s.length(); ++i)
		if (CAP(s[i]))
			return false;
	return true;
}

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	while (getline(cin, cur))
	{
		vector <string> lst;
		int ll = 0, rr = 0;
		while (ll < cur.length())
		{
			while (rr < cur.length() && LET(cur[rr]))
				++rr;
			lst.push_back(cur.substr(ll, rr - ll));
			ll = rr;
			while (rr < cur.length() && !LET(cur[rr]))
				++rr;
			if (ll < cur.length())
				lst.push_back(cur.substr(ll, rr - ll));
			ll = rr;
		}

		ll = 0, rr = 0;
		while (ll < lst.size())
		{
			if (!capitalized(lst[ll]))
			{
				cout << lst[ll];
				++ll;
				rr = ll;
			}
			else
			{
				rr = ll + 2;
				while (rr < lst.size() && lst[rr - 1] == " " && capitalized(lst[rr]))
					rr += 2;
				if (rr - ll == 2)
				{
					cout << lst[ll];
					++ll;
					rr = ll;
				}
				else
				{
					string abbr = "";
					for (int i = ll; i < rr; i += 2)
						abbr.push_back(lst[i][0]);
					cout << abbr << " (";
					for (int i = ll; i < rr - 1; ++i)
						cout << lst[i];
					cout << ")";
					ll = rr - 1;
					rr = ll;
				}
			}
		}
		cout << endl;
	}

	myReturn();
}

//This is ACM Nor Esdfjk Efghkl Radfskjbfe Conted,
//sponsored bi Internatio Busina Mache.
//The.Best.Contest.Eva.
//A Great Opotunity fo al contest.