#define _CRT_SECURE_NO_WARNINGS
#define TASK "hard"

#include <iostream>
#include <string>
#include <vector>
#include <stdio.h>
#include <stack>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <iomanip>

using namespace std;

double workTime()
{
	return (double)clock() / CLOCKS_PER_SEC;
}

void myReturn(int code = 0)
{
#ifdef LOCAL
	cout << "\nTime = " << fixed << setprecision(3) << workTime() << endl;
#endif
	exit(code);
}

const int MIN = -32768, MAX = 32767;
vector <pair <int, int> > segm;

pair <int, int> intersect(pair <int, int> a, pair <int, int> b)
{
	if (a.first == MAX && a.second == MIN)
		return{ MAX, MIN };
	if (b.first == MAX && b.second == MIN)
		return{ MAX, MIN };
	if (max(a.first, b.first) <= min(a.second, b.second))
		return { max(a.first, b.first), min(a.second, b.second) };
	else
		return { MAX, MIN };
}

int k = 0;
struct pt
{
	int x;
	bool open;
} p[2010];

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	string s;
	vector <pair <int, int> > cur;
	while (cin >> s)
	{
		if (s == "x")
		{
			int val;
			cin >> s >> val;
			if (s == ">=")
				cur.push_back({ val, MAX });
			else
				cur.push_back({ MIN, val });
		}
		else if (s == "||")
		{
			cur.push_back({MIN, MAX});
			while (cur.size() > 1)
			{
				cur[cur.size() - 2] = intersect(cur.back(), cur[cur.size() - 2]);
				cur.pop_back();
			}
			segm.push_back(cur[0]);
			cur.pop_back();
		}
	}
	if (!cur.empty())
	{
		cur.push_back({ MIN, MAX });
		while (cur.size() > 1)
		{
			cur[cur.size() - 2] = intersect(cur.back(), cur[cur.size() - 2]);
			cur.pop_back();
		}
		segm.push_back(cur[0]);
		cur.pop_back();
	}

	for (int i = 0; i < segm.size(); ++i)
	{
		if (segm[i].first == MAX && segm[i].second == MIN)
			continue;
		p[k].x = segm[i].first;
		p[k++].open = true;
		p[k].x = segm[i].second;
		p[k++].open = false;
	}
	sort(p, p + k, [](pt a, pt b) {
		return a.x < b.x || a.x == b.x && a.open < b.open;
	});

	vector <pair <int, int> > ans, res;
	int opened = 0, ll = MIN;
	for (int i = 0; i < k; ++i)
	{
		if (p[i].open)
		{
			if (opened == 0)
				ll = p[i].x;
			++opened;
		}
		else
		{
			--opened;
			if (opened == 0)
				ans.push_back({ ll, p[i].x });
		}
	}

	if (!ans.empty())
	{
		pair <int, int> foo = ans[0];
		for (int i = 1; i < ans.size(); ++i)
		{
			if (ans[i].first - foo.second > 1)
			{
				res.push_back(foo);
				foo = ans[i];
			}
			else
				foo.second = ans[i].second;
		}
		res.push_back(foo);
	}

	if (res.empty())
		cout << "false\n";
	else if (res.size() == 1 && res[0].first == MIN && res[0].second == MAX)
		cout << "true\n";
	else
	{
		for (int i = 0; i < res.size(); ++i)
		{
			if (res[i].first == MIN)
				cout << "x <= " << res[i].second;
			else if (res[i].second == MAX)
				cout << "x >= " << res[i].first;
			else
				cout << "x >= " << res[i].first << " && x <= " << res[i].second;
			if (i + 1 < res.size())
				cout << " ||\n";
		}
	}

	myReturn();
}

//This is ACM Nor Esdfjk Efghkl Radfskjbfe Conted,
//sponsored bi Internatio Busina Mache.
//The.Best.Contest.Eva.
//A Great Opotunity fo al contest.