//   ,   
//18+
#define _CRT_SECURE_NO_WARNINGS
#define TASK "jenga"

#include <iostream>
#include <string>
#include <vector>
#include <stdio.h>
#include <stack>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <iomanip>

using namespace std;

double workTime()
{
	return (double)clock() / CLOCKS_PER_SEC;
}

void myReturn(int code = 0)
{
#ifdef LOCAL
	cout << "\nTime = " << fixed << setprecision(3) << workTime() << endl;
#endif
	exit(code);
}

int n, h, q;
long long sumX[5010], sumY[5010], cnt[5010];
pair <int, int> blya[5010];
set <int> rem[5010];

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	cin >> n >> h >> h >> q;
	for (int i = 1; i <= q; ++i)
		cin >> blya[i].first >> blya[i].second;
	for (int i = 1; i <= h; ++i)
	{
		cnt[i] = n;
		sumX[i] = n * 1ll * n;
		sumY[i] = n * 1ll * n;
	}
	for (int i = 0; i <= h; ++i)
	{
		rem[i].insert(1);
		rem[i].insert(n);
	}
	for (int i = 1; i <= q; ++i)
	{
		for (int j = blya[i].second - 1; j <= blya[i].second + 1; ++j)
		{
			if (1 <= j && j <= n)
				rem[blya[i].first].insert(j);
		}
	}

	for (int id = 1; id <= q; ++id)
	{
		int level = blya[id].first, pos = blya[id].second;
		if (level % 2 == 1)
		{
			--cnt[level];
			sumX[level] -= 2 * pos - 1;
			sumY[level] -= n;
			rem[level].erase(pos);
		}
		else
		{
			--cnt[level];
			sumY[level] -= 2 * pos - 1;
			sumX[level] -= n;
			rem[level].erase(pos);
		}

		bool good = true;
		long long curX = 0, curY = 0, curCnt = 0;
		for (int j = h; j >= 1; --j)
		{
			curX += sumX[j];
			curY += sumY[j];
			curCnt += cnt[j];
			if (curCnt == 0)
				continue;
			int ll = *rem[j - 1].begin(), rr = *rem[j - 1].rbegin();
			ll = 2 * ll - 2, rr = 2 * rr;

			if (j % 2 == 1)
			{
				if (curX <= ll * 1ll * curCnt || curX >= rr * 1ll * curCnt)
					good = false;
			}
			else
			{
				if (curY <= ll * 1ll * curCnt || curY >= rr * 1ll * curCnt)
					good = false;
			}
		}
		if (!good)
		{
			cout << "yes\n" << id << endl;
			myReturn(0);
		}
	}
	cout << "no\n";

	myReturn();
}

//This is ACM Nor Esdfjk Efghkl Radfskjbfe Conted,
//sponsored bi Internatio Busina Mache.
//The.Best.Contest.Eva.
//A Great Opotunity fo al contest.