import java.io.*;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by neerc on 04.12.2016.
 */
public class Solution {
    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream("abbreviation.in")));
        PrintWriter out = new PrintWriter(new FileOutputStream("abbreviation.out"));
        String text = in.readLine();
        ArrayList<String> buffer = new ArrayList<>();
        StringBuilder ans = new StringBuilder();
        while (text != null && text.length() > 0){
            StringBuilder builder = new StringBuilder();
            ArrayList<String> split = split(text);
            for (int i = 0; i < split.size(); i++) {
                String s = split.get(i);
                if (isUpperFirstAndLowerOther(s) || (s.equals(" ") && isUpperFirstAndLowerOther(split.get(i - 1)))){
                    buffer.add(s);
                } else {
                    builder.append(get(buffer));
                    buffer.clear();
                    builder.append(s);
                }
            }
            builder.append(get(buffer));
            String trim = builder.toString().trim();
            if (trim.length() > 0) {
                ans.append(trim);
                ans.append("\n");
            }
            buffer.clear();
            text = in.readLine();
        }
        out.print(ans);
        out.close();
    }

    public static String get(List<String> buffer){
        if (buffer.size() > 2) {
            StringBuilder abb = new StringBuilder();
            StringBuilder value = new StringBuilder("(");
            for (String s : buffer) {
                if (s.length() > 1) {
                    abb.append(s.charAt(0));
                }
                value.append(s);
            }
            //value.setCharAt(value.length() - 1, ')');
            if (buffer.get(buffer.size() - 1).equals(" ")){
                value.setCharAt(value.length() - 1, ')');
                value.append(' ');
            } else {
                value.append(")");
            }
            String result = abb.append(" ").append(value.toString()).toString();
            return result;
        } else {
            StringBuilder value = new StringBuilder();
            for (String s : buffer) {
                value.append(s);
            }
            return value.toString();
        }
    }

    public static boolean isUpperFirstAndLowerOther(String s){
        if (s.length() < 2){
            return false;
        }
        if(!Character.isUpperCase(s.charAt(0))){
            return false;
        }

        for (int i = 1; i < s.length(); i++) {
            if (!Character.isAlphabetic(s.charAt(i)) || !Character.isLowerCase(s.charAt(i))){
                return false;
            }
        }
        return true;
    }

    public static ArrayList<String> split(String s){
        ArrayList<String> lst = new ArrayList<>();
        StringBuilder cur = new StringBuilder();
        //boolean prevNotAlphabe = true;
        for (int i = 0; i < s.length(); i++) {
            if (Character.isAlphabetic(s.charAt(i))){
                cur.append(s.charAt(i));
                //prevNotAlphabe = true;
            } else {
                if (cur.length() > 0) {
                    lst.add(cur.toString());
                }
                cur = new StringBuilder();
                lst.add(new String(new char[]{s.charAt(i)}));
            }
        }
        if (cur.length() > 0){
            lst.add(cur.toString());
        }
        return lst;
    }
}
