#ifdef DEBUG
#include <fstream>
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#else
#include <fstream>
std::ifstream cin("abbreviation.in");
std::ofstream cout("abbreviation.out");
#endif
#include <algorithm>
#include <vector>
#include <map>
#include <ctype.h>
#include <set>
#include <deque>
#include <string>
using namespace std;

bool isAl(char x) {
	return (x >= 'a' && x <= 'z') || (x >= 'A' && x <= 'Z');
}

bool isBig(char x) {
	return x >= 'A' && x <= 'Z';
}


bool canAbb(string &s) {
	if (s.length() < 2) return false;
	if (!isBig(s[0])) return false;
	for (int i = 1; i < s.length(); i++) {
		if (isBig(s[i])) {
			return false;
		}
	}
	return true;
}


void solve(string &s) {
	vector<string> prevWords;
	string prevWord;
	for (int i = 0; i < s.length(); i++) {
		string currWord;
		int j = i;
		while (j < s.length() && isAl(s[j])) {
			currWord += s[j];
			j++;
		}
		if (canAbb(currWord)) {
			prevWords.push_back(currWord);
			if (j == s.length() || s[j] != ' ') {
				if (prevWords.size() >= 2) {
					for (int k = 0; k < prevWords.size(); k++) {
						cout << prevWords[k][0];
					}
					cout << " (";
					for (int k = 0; k < prevWords.size(); k++) {
						if (k != 0) cout << " ";
						cout << prevWords[k];
					}
					cout << ")";
				}
				else {
					for (int k = 0; k < prevWords.size(); k++) {
						if (k != 0) cout << " ";
						cout << prevWords[k];
					}
				}
				prevWords.clear();
				if (j != s.length()) cout << s[j];
			}
		}
		else {
			if (prevWords.size() >= 2) {
				for (int k = 0; k < prevWords.size(); k++) {
					cout << prevWords[k][0];
				}
				cout << " (";
				for (int k = 0; k < prevWords.size(); k++) {
					if (k != 0) cout << " ";
					cout << prevWords[k];
				}
				cout << ") ";
			}
			else {
				for (int k = 0; k < prevWords.size(); k++) {
					cout << prevWords[k];
				}
				if (prevWords.size() != 0) cout << " ";
			}
			prevWords.clear();
			cout << currWord;
			if (j < s.length()) cout << s[j];
		}
		i = j;
	}
}

int main(){
	ios_base::sync_with_stdio(0);
	string s;
	while (getline(cin, s)) {
		solve(s);
	}
}