#ifdef DEBUG
#include <fstream>
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#else
#include <fstream>
std::ifstream cin("foreign.in");
std::ofstream cout("foreign.out");
#endif
#include <algorithm>
#include <vector>
#include <map>
#include <ctype.h>
#include <set>
#include <deque>
#include <string>
#include <sstream>
#include <iomanip>
using namespace std;

int n;
bool isCorr[1000000];
int prefCorr[1000000];

double dp[1000000];

/*struct otr{
	int l, r;
	bool operator<(const otr&o) const{
		return l == o.l ? r < o.r : l < o.l;
	}
};
*/
int main(){
	ios_base::sync_with_stdio(0);
	/*
	string s;
	set<otr> o;
	while (getline(cin, s)) {
		stringstream ss(s);
		int l=-32768, r=32767;
		if (s.find("&&") != s.npos){
			char buf;
			ss >> buf>>buf>>buf>>l>>buf>>buf>>buf>>buf>>buf>>r;
		}
		else if (s.find(">=") != s.npos){
			char buf;
			ss >> buf >> buf >> buf >> l;
		}
		else{
			char buf;
			ss >> buf >> buf >> buf >> r;
		}
		otr a;
		a.l = l;
		a.r = r;
		o.insert(a);
	}
	set<otr> oo;
	for (auto &a : o){
		if (oo.rbegin() != oo.rend()){
			auto prev = *oo.rbegin();
			if (prev.r >= a.l){
				oo.erase(oo.rbegin().base());
				otr newa = a;
				newa.l = min(prev.l, a.l);
				newa.r = max(prev.r, a.r);
				oo.insert(newa);
			}
			else{
				oo.insert(a);
			}
		}
		else{
			oo.insert(a);
		}
	}
	for (auto &a : oo){
		cout << a.l << " " << a.r << endl;
	}
	*/
	string s;
	cin >> s;
	n = s.length();
	for (int i = 0; i < n; i++) {
		if (s[i] == 'C') {
			isCorr[i] = true;
		}
	}

	prefCorr[0] = isCorr[0];
	for (int i = 1; i < n; i++) {
		prefCorr[i] = prefCorr[i - 1] + isCorr[i];
	}

	
	dp[n - 1] = 0;
	double sumDp = dp[n - 1];
	long long numOfCorr = isCorr[n - 1];
	long long numOfIncorr = !isCorr[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		numOfCorr += isCorr[i] * (n - i);
		numOfIncorr += (1 - isCorr[i]) * (n - i);
		dp[i] = (sumDp + (isCorr[i] ? numOfIncorr : numOfCorr)) / (n - i);
		sumDp += dp[i];
	}

	//for (int i = 0; i < n; i++) cout << i << " " << dp[i] << endl;
	cout << fixed << setprecision(15) << dp[0];
}