#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
using namespace std;

bool isupper(char c) {
    return 'A' <= c && c <= 'Z';
}

bool islower(char c) {
    return 'a' <= c && c <= 'z';
}

bool isletter(char c) {
    return islower(c) || isupper(c);
}

int findword(string &s, int i) {
    while (isletter(s[i]))
        ++i;
    return i;
}

bool check(string &s, int i, int j) {
    if (j - i < 2)
        return 0;
    if (!isupper(s[i]))
        return 0;
    for (int q = i + 1; q < j; ++q)
        if (!islower(s[q]))
            return 0;
    return 1;
}

string substr(string &s, int i, int j) {
    return string(s.begin() + i, s.begin() + j);
}

#define taskname "abbreviation"
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(taskname".in", "r", stdin);
    freopen(taskname".out", "w", stdout);
#endif
    string s;
    while (getline(cin, s)) {
        s += '$';
        int n = s.length();
        string out;

        //vector<string> words;
        bool ok = 1;
        for (int i = 0; i < n; ++i) {
            //printf("%d\n", i);
            //printf("\t%s\n", s.substr(i).c_str());
            //printf("\t%s\n", out.c_str());
            if (!isletter(s[i])) {
                out += s[i];
                continue;
            }

            int j = findword(s, i);
            //printf("\t%d %s %d %d\n", j, substr(s, i, j).c_str(), check(s, i, j), s[j] == ' ');
            if (check(s, i, j) && s[j] == ' ') {
                int j2 = findword(s, j + 1);
                if (check(s, j + 1, j2)) {
                    vector<string> words = {substr(s, i, j), substr(s, j + 1, j2)};
                    int last = j2;
                    while (s[j2] == ' ') {
                        int j3 = findword(s, j2 + 1);
                        last = j3;
                        if (check(s, j2 + 1, j3)) {
                            words.push_back(substr(s, j2 + 1, j3));
                            j2 = j3;
                        }
                        else
                            break;
                    }
                    i = last - 1;

                    for (string s : words)
                        out += s[0];
                    out += " (";
                    out += words[0];
                    for (int q = 1; q < (int)words.size(); ++q) {
                        out += ' ' + words[q];
                    }
                    out += ")";
                }
                else {
                    out += substr(s, i, j);
                    i = j - 1;
                }
            }
            else {
                out += substr(s, i, j);
                i = j - 1;
            }

            /*
            for (string word : words)
                printf("\t\t%s\n", word.c_str());
            if (isupper(s[i]) && ok) {
                string word;
                word += s[i];
                int j;
                for (j = i + 1; 'a' <= s[j] && s[j] <= 'z'; ++j)
                    word += s[j];
                words.push_back(word);
                if (s[j] != ' ' || s[j] == ' ' && (j + 1 == n || !isupper(s[j + 1]))) {
                    i = j;
                    ok = 0;
                }
                else
                    i = j + 1;
                --i;
            } else {
                ok = 1;
                if (words.size() >= 2) {
                    for (string s : words)
                        out += s[0];
                    out += " (";
                    out += words[0];
                    for (int q = 1; q < (int)words.size(); ++q) {
                        out += ' ' + words[q];
                    }
                    out += ")";
                }
                else if (!words.empty()) {
                    out += words[0];
                }
                words.clear();
                out += s[i];
            }*/
        }
        out.pop_back();
        cout << out << endl;
        //break;
    }
}