#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;

#define taskname "foreign"
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(taskname".in", "r", stdin);
    freopen(taskname".out", "w", stdout);
#endif
    string s;
    cin >> s;
    int n = s.length();
    s = ' ' + s;
    vector<int> numzeros(n + 1, 0);
    vector<ll> sum(n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        numzeros[i] = numzeros[i - 1] + (s[i] == 'W');
        sum[i] = sum[i - 1] + numzeros[i];
    }

    vector<long double> dp(n + 1, 0);
    vector<long double> sumdp(n + 2, 0);
    for (int i = n; i >= 1; --i) {
        ll len = n - i + 1;
        dp[i] = sumdp[i + 1];
        ll add = (sum[n] - sum[i - 1] - numzeros[i - 1] * len);
        if (s[i] == 'W')
            add = len * (len + 1) / 2 - add;
        dp[i] += add;
        dp[i] /= len;
        sumdp[i] = sumdp[i + 1] + dp[i];
    }
    printf("%.9f\n", (double) dp[1]);
}