#include <iostream>
#include <set>
#include <iomanip>
#include <map>
#include <queue>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string.h>
#include <string>

using namespace std;


const int N = 1e5 + 5;
const int K = 30;

typedef long long li;

#define mp make_pair
#define pb push_back
#define sz(x) (x).size()

const int d = 35000;
bool m[71000];

#define FILE "hard" 
int main(){
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else 
  freopen(FILE ".in", "r", stdin);
  freopen(FILE ".out", "w", stdout);
#endif
  string s;
  while (getline(cin, s)){
    if (s.empty()) break;

    int a1 = 0;
    int a2 = 0;

    int cnt = 0;
    char sign;
    bool m1 = true;
    bool m2 = true;

    for (int i = 0; i < s.length(); i++){
      if (s[i] == '<' || s[i] == '>') sign = s[i];
      if (s[i] == '='){
        cnt++;
      }
      if (isdigit(s[i])){
        if (cnt == 2) {
          a2 = a2 * 10 + (s[i] - '0');
          if (s[i - 1] == '-') m2 = false;
        }
        else if (cnt == 1){
          a1 = a1 * 10 + (s[i] - '0');
          if (s[i - 1] == '-') m1 = false;
        }
      }
    }

    if (!m1) a1 *= -1;
    if (!m2) a2 *= -1;

    if (cnt == 1){
      if (sign == '<') {
        a2 = a1;
        a1 = -32768;
      }
      else{
        a2 = 32767;
      }
    }


    for (int i = a1; i <= a2; i++){
      m[i + d] = true;

    }

  }
  bool f1 = false, f2 = false;
  for (int i = -32768; i <= 32767; i++){
    if (m[i + d] == true) f1 = true;
    if (m[i + d] == false) f2 = true;
  }
  if (!f1){
    cout << "false" << endl;
    return 0;
  }
  if (!f2){
    cout << "true" << endl;
    return 0;
  }

  int start = -40000;

  vector<pair<int, int>> ans;
  for (int i = -32768; i <= 32768; i++){
    if (m[i + d] == true){
      if (start == -40000)
        start = i;
    }
    else{
      if (start != -40000){
        ans.push_back(mp(start, i - 1));
      }
      start = -40000;
    }
  }

  for (int i = 0; i < ans.size(); i++){
    int cnt = 0;
    if (ans[i].first != -32768){
      cout << "x >= " << ans[i].first;
      cnt++;
    }
    if (ans[i].first != -32768 && ans[i].second != 32767){
      cout << " && ";
    }
    if (ans[i].second != 32767){
      cout << "x <= " << ans[i].second;
      cnt++;
    }
    if (i + 1 != ans.size())
      cout << " ||";
    cout << endl;
  }
}