#include <iomanip>
#include <ios>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <cstdio>
#include <cstring>
#include <string>
#include <array>
#include <stack>
#include <queue>

#define mp make_pair
#define ll long long
using namespace std;

int main() {
	//freopen("input.txt", "r", stdin);
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
	int n, q;
	cin >> n >> q;
	map<ll, ll> szs;
	ll lst = -1e9;
	ll now = 0;
	vector<pair<ll, pair<ll, char> > > ws(n), ds;	
	ll min_lev = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> ws[i].second.second >> ws[i].first >> ws[i].second.first;
		if (ws[i].second.second == '-')
			min_lev += ws[i].second.first;
		else
			min_lev -= ws[i].second.first;
	}	

	min_lev = max(min_lev, (ll)0);
	ll lev = 0;
	for (int i = 0; i < n; ++i){		
		if (ws[i].second.second == '-'){
			ll next_lev = lev + ws[i].second.first;
			if (next_lev < min_lev){
				continue;
			}
			else{
				ds.push_back(mp(ws[i].first, mp(next_lev - max(min_lev, lev), '-')));
			}
			lev += ws[i].second.first;
		}
		else{
			ll next_lev = lev - ws[i].second.first;
			if (lev < min_lev){
				continue;
			}
			else{
				ds.push_back(mp(ws[i].first, mp(lev - max(min_lev, next_lev), '+')));
			}
			lev -= ws[i].second.first;
		}
	}

	for (int i = 0; i < ds.size(); i++)
	{
		char w;
		ll t, k;
		w = ds[i].second.second;
		t = ds[i].first;
		k = ds[i].second.first;
		if (w == '-')
		{
			if (lst != -1e9)
			{
				szs[now] += t - lst;
			}
			now += k;
			lst = t;
		}
		else
		{
			if (lst != -1e9)
			{
				szs[now] += t - lst;
			}
			now -= k;
			lst = t;
		}
	}
	ll ans = 0, ans1 = 0;
	
	for (auto it = szs.begin(); it != szs.end(); it++)
	{
		ans += it->first*it->second;
		ans1 += it->second;
	}

	vector<pair<int, int> > qur(q);
	for (int i = 0; i < q; i++)
	{
		cin >> qur[i].first;
		qur[i].second = i;
	}
	sort(qur.begin(), qur.end());
	vector<ll> answ(q, 1e18);
	auto it = szs.begin();
	now = it->first;
	for (int i = 0; i < q; i++)
	{
		if (qur[i].first < min_lev)
		{
			answ[qur[i].second] = 1e18;
			continue;
		}
		qur[i].first -= min_lev;
		if (it == szs.end())
		{
			answ[qur[i].second] = ans;
			continue;
		}
		if (it->first == qur[i].first)
		{
			answ[qur[i].second] = ans;
		}
		else
		{
			while (it != szs.end())
			{
				auto it2 = it;
				it2++;
				if (it2 == szs.end())
				{
					ans = 0;
					it = it2;
					break;
				}
				if (it2->first <= qur[i].first)
				{
					ans1 -= it->second;
					ans -= ans1*(it2->first - now);
					now = it2->first;
					it = it2;
					if (it2->first == qur[i].first)
					{
						answ[qur[i].second] = ans;
						break;
					}
				}
				else
				{
					ans1 -= it->second;
					ans -= ans1*(qur[i].first - now);
					now = qur[i].first;
				}

			}

		}

	}

	for (ll i : answ)
	{
		if (i > 1e15)
		{
			cout << "INFINITY\n";
		}
		else
		{
			cout << i << '\n';
		}


	}


	

	
	
	
	




	return 0;
}