#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define mp make_pair
#define pb push_back
#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif
#define TASK "hard"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1);


void precalc() {
}

int n;


vector<pair<int, int> > ss;

void solve() {
  ss.clear();
  while (1) {
    bool ok = 0;
    pair<int, int> segm(-(1 << 15), (1 << 15) - 1);
    int x;
    scanf(" x");
    if (scanf(" >= %d", &x) == 1) {
      segm.first = x;
      ok = 1;
    }
    scanf(" &&");
    scanf(" x");
    if (scanf(" <= %d", &x) == 1) {
      segm.second = x;
      ok = 1;
    }
    scanf(" ||");
    if (!ok) {
      break;
    }
    if (segm.first > segm.second) {
      printf("false\n");
      return;
    }
    ss.pb(segm);
  }
  
  sort(ss.begin(), ss.end());
  
  int n = 0;
  for (int i = 0; i < sz(ss); ++i) {
    if (n && ss[n - 1].second >= ss[i].first - 1) {
      ss[n - 1].second = max(ss[n - 1].second, ss[i].second);
    } else {
      ss[n++] = ss[i];
    }
  }
  if (!n) {
    printf("true\n");
    return;
  }
  if (n == 1 && ss[0] == mp(-(1 << 15), (1 << 15) - 1)) {
    printf("true\n");
    return;
  }
  for (int i = 0; i < n; ++i) {
    bool was = 0;
    if (ss[i].first > -(1 << 15)) {
      printf("x >= %d ", ss[i].first);
      was = 1;
    }
    if (ss[i].second < (1 << 15) - 1) {
      if (was) {
        printf("&& ");
      }
      printf("x <= %d ", ss[i].second);
      was = 1;
    }
    if (i < n - 1) {
      printf("||");
    }
    printf("\n");
  }
}

int main() {
  precalc();
  
  freopen(TASK ".out", "w", stdout);
  freopen(TASK ".in", "r", stdin);
  
  solve();
  eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
  
  return 0;
}