#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define fs first
#define sc second

using namespace std;

typedef long double ld;
typedef long long ll;

int rt[100100];
int rh[100100];
pair<int, int> q[100100];
ll ans[100100];
vector<pair<int, int> > seg;

int main()
{
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);
    int n, m;
    cin >> n >> m;
    int ch = 0;
    forn (i, n) {
        char s[10];
        int t, k;
        cin >> s >> rt[i] >> k;
        if (s[0] == '-') {
            k = -k;
        }
        ch += k;
        rh[i] = ch;
    }
    rt[n] = rt[n - 1] - 1;
    forn (i, n) {
        seg.push_back(make_pair(rh[i], rt[i + 1] - rt[i]));
    }
    sort(seg.begin(), seg.end());
    /*forn (i, n) {
        cerr << seg[i].fs << " " << seg[i].sc << endl;
    }
    cerr << endl;*/
    forn (i, m) {
        cin >> q[i].fs;
        q[i].fs = -q[i].fs;
        q[i].sc = i;
    }
    sort(q, q + m);
    ll sum = 0, l = 0, h = -2000000000;
    int qi = 0;
    forn (i, seg.size() + 1) {
        while (qi < m && q[qi].fs <= seg[i].fs) {
            if (l == -1) {
                ans[q[qi].sc] = -1;
            } else {
                ans[q[qi].sc] = sum + l * (q[qi].fs - h);
            }
            ++qi;
        }
//        cerr << seg[i].fs << " " << l << endl;
        if (i == int(seg.size())) {
            break;
        }
        if (l == -1) {
            continue;
        }
        sum += l * (seg[i].fs - h);
        h = seg[i].fs;
        int j = i;
        while (j < int(seg.size()) && seg[j].fs == seg[i].fs) {
            if (seg[j].sc == - 1) {
                l = -1;
            } else if (l != -1) {
                l += seg[j].sc;
            }
            ++j;
        }
        i = j - 1;
    }
    forn (i, m) {
        if (ans[i] == -1) {
            cout << "INFINITY";
        } else {
            cout << ans[i];
        }
        cout << endl;
    }
    return 0;
}
