#include <iostream>
#include <vector>
#include <string>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)

using namespace std;

typedef long double ld;

string s;

ld p[1000100];

int main()
{
    freopen("foreign.in", "r", stdin);
    freopen("foreign.out", "w", stdout);
    cin >> s;
    int n = s.size();
    p[0] = 1;
    p[1] = p[0] / n;
    for (int i = 1; i < n - 1; ++i) {
        p[i + 1] = p[i] * (1 + ld(1) / (n - i));
    }
    ld sumW = 0, sumC = 0;
    ld ans = 0;
    forn (i, n) {
        ans += (n - i) * (s[i] == 'W' ? sumC : sumW);
        if (s[i] == 'W') {
            sumW += p[i] / (n - i);
        } else {
            sumC += p[i] / (n - i);
        }
    }
    cout.precision(15);
    cout << ans << endl;
    return 0;
}
