#include <iostream>
#include <vector>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)

using namespace std;

const int MN = -32768;
const int MX = 32767;

int mnv[1010], mxv[1010];
vector<int> x;

int main()
{
    freopen("hard.in", "r", stdin);
    freopen("hard.out", "w", stdout);
    char s[100];
    int mn = MN, mx = MX;
    int n = 0;
    while (true) {
        int r = scanf("%s", s);
        if (s[0] == '&') {
            continue;
        }
        if (s[0] == '|' || r == -1) {
            mnv[n] = mn;
            mxv[n++] = mx;
//            cerr << mn << " " << mx << endl;
            mn = MN;
            mx = MX;
            if (r == -1) {
                break;
            }
            continue;
        }
        scanf("%s", s);
        bool le = s[0] == '<';
        scanf("%s", s);
        int a = 0;
        bool neg = s[0] == '-';
        for (int i = 0; s[i]; ++i) {
            if (s[i] == '-') {
                continue;
            }
            a *= 10;
            a += s[i] - '0';
        }
        if (neg) {
            a *= -1;
        }
        if (le) {
            mx = min(mx, a);
        } else {
            mn = max(mn, a);
        }
    }
    for (int i = MN; i <= MX; ++i) {
        bool ok = false;
        forn (j, n) {
            if (mnv[j] <= i && mxv[j] >= i) {
                ok = true;
                break;
            }
        }
        if (ok) {
            x.push_back(i);
        }
    }
    if (x.size() == 0) {
        cout << "false\n";
        return 0;
    }
    if (x.size() == MX - MN + 1) {
        cout << "true\n";
        return 0;
    }
    vector<int> mna, mxa;
    forn (i, x.size()){
        if (i && x[i - 1] == x[i] - 1) {
            mxa.back()++;
        } else {
            mna.push_back(x[i]);
            mxa.push_back(x[i]);
        }
    }
    forn (i, mna.size()) {
        if (mna[i] != MN) {
            cout << "x >= " << mna[i];
            if (mxa[i] != MX) {
                cout << " && ";
            }
        }
        if (mxa[i] != MX) {
           cout << "x <= " << mxa[i];
        }
        if (i < int(mna.size()) - 1) {
            cout << " ||";
        }
        cout << "\n";
    }
    return 0;
}
