#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define fs first
#define sc second

using namespace std;

typedef long double ld;
typedef long long ll;

bool was[5010][10010];
int l[5010], r[5010], b[5010];
ll x[5010], y[5010];

int main()
{
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
    int n, w;
    cin >> n >> w;
    int H, m;
    cin >> H >> m;
    forn (i, H) {
        l[i] = 0;
        r[i] = 2 * n;
        b[i] = (H - i - 1) * n;
        x[i] = b[i] * ll(n);
        y[i] = b[i] * ll(n);
    }
    forn (i, m) {
        int h, ind;
        cin >> h >> ind;
        --h;
        --ind;
        int x_ = 0, y_ = 0;
        if (h % 2) {
            y_ = n;
            x_ = ind * 2 + 1;
        } else {
            x_ = n;
            y_ = ind * 2 + 1;
        }
        was[h][ind] = true;
        l[h] = 0;
        r[h] = 0;
        for (int j = 0; j < n; ++j) {
            if (!was[h][j]) {
                l[h] = j * 2;
                break;
            }
        }
        for (int j = n - 1; j >= 0; --j) {
            if (!was[h][j]) {
                r[h] = (j + 1) * 2;
                break;
            }
        }
        forn (j, h) {
            x[j] -= x_;
            y[j] -= y_;
            --b[j];
        }
        bool bad = false;/*
        cerr << endl;
        forn (j, H) {
            cerr << b[j] << endl;
            cerr << x[j] << " " << y[j] << endl;
            cerr << l[j] << " " << r[j] << endl;
        }*/
        forn (j, H) {
            if (b[j] == 0) {
                continue;
            }
            if (j % 2) {
                if (x[j] <= ll(l[j]) * b[j] || x[j] >= ll(r[j]) * b[j]) {
                    bad = true;
                    break;
                }
            } else {
                if (y[j] <= ll(l[j]) * b[j] || y[j] >= ll(r[j]) * b[j]) {
                    bad = true;
                    break;
                }
            }
        }
        if (bad) {
            cout << "yes\n" << i + 1 << endl;
            return 0;
        }
    }
    cout << "no\n";
    return 0;
}
