#include <bits/stdc++.h>

#define FILENAME "abbreviation"

using namespace std;

string line;
vector< pair< int, int > > abbrpos;
vector< string > abbr;
vector< string > decode;

bool isUpp( char tmp )
{
	return ( tmp >= 'A' && tmp <='Z');
}

bool isLower( char tmp )
{
	return ( tmp >= 'a' && tmp <='z');
}


int main()
{
	//#ifndef LOCAL
	freopen( FILENAME ".in", "r", stdin );
	freopen( FILENAME ".out", "w", stdout );
	//#endif // LOCAL

	while ( getline( cin, line ) )
	{
		if ( line == "" )break;

		int len = line.size();

		for ( int i=0; i<len; )
		{
            if ( i==0 || line[ i-1 ]==',' || line[ i-1 ]=='.' || line[ i-1 ]==' ' )
			{
				int lj = i-1;
				string ABBR = "";
				string dec ="";
				string word = "";
				int cntabbr = 0;
				while ( true )
				{
					int j = lj+1;

					if ( j>= len )
						break;

					if ( !isUpp( line[ j ] ) )
					{
						break;
					}

					word = line[ j ];
					j++;

					bool isLowercase = false;
					while ( j<len && isLower(line[ j ]) )
					{
						word += line[ j ];
						isLowercase=true, j++;
					}

					if ( j < len && isUpp( line[ j ] ) )
						break;

                    if ( isLowercase )
					{
                        ABBR += word[ 0 ];
                        if ( cntabbr ) dec = dec + " ";
                        dec += word;
                        cntabbr++;
						lj = j;
					}
					else
						break;

					if ( j>=len || line[ j ]!=' ')
						break;
				}

				//cout<<ABBR<<" "<<dec<<endl;

				if ( cntabbr > 1 )
				{
					int l = i;
					int r = lj; // NEIESKAITOT
                    abbrpos.emplace_back( l, r );
                    abbr.push_back( ABBR );
                    decode.push_back( dec );
                    i=lj;
				}
				else i++;
			}
			else i++;
		}

		for ( int i=abbrpos.size()-1; i>=0; i-- )
		{
			auto pos = abbrpos[ i ];
			string abb = abbr[ i ];
			string dec = decode[ i ];
			string rep = abb + " ("+dec+")";
			line.replace( pos.first, pos.second - pos.first, rep );
		}
		abbr.clear();
		decode.clear();
		abbrpos.clear();

		cout<<line<<endl;
	}

	return 0;
}
