#include <bits/stdc++.h>

#define FILENAME "jenga"

using namespace std;

typedef long long ll;

const int MAXN = 10009;
const int MAXH = 5009;
int n, w;
int h, m;

int hodd, heven;

int minb[ MAXH ];
int maxb[ MAXH ];
vector< int > rem[ MAXH ];

long long suma[ MAXN ];
long long sumai[ MAXN ];
long long sumo[ MAXN ];
long long sumoi[ MAXN ];

int blockrem[ MAXN ];

void RecalcMinMax( int lvl )
{
	static int iteration = 0;
	iteration++;
	for ( auto t : rem[ lvl ] )
		blockrem[ t ] = iteration;

	int MIN = 1;
	while ( MIN <= n && blockrem[ MIN ] == iteration )
		MIN++;

	int MAX = n;
	while ( MAX >= 1 && blockrem[ MAX ] == iteration )
		MAX--;

	minb[ lvl ] = MIN;
	maxb[ lvl ] = MAX;
}

void PrintAnsw( int REQ )
{
	printf("yes\n%d\n", REQ );
}

bool CHECK( int lvl )
{
	if ( lvl == 1 ) return true;

    ll MINP = 2*minb[ lvl-1 ] - 2;
	ll MAXP = 2*maxb[ lvl-1 ];

    // IZMANTOJAM suma + sumo

    return ( MINP * (suma[ lvl ] + sumo[ lvl ]) ) < ( sumai[ lvl ] + sumoi[ lvl ] )
		&& ( (sumai[ lvl ]+sumoi[ lvl ]) < ( MAXP * (suma[ lvl ]+sumo[ lvl ])) );
}

int main()
{
	//#ifndef LOCAL
	freopen( FILENAME ".in", "r", stdin );
	freopen( FILENAME ".out", "w", stdout );
	//#endif // LOCAL

	scanf("%d %d", &n, &w );
	scanf("%d %d", &h, &m );

	heven = h / 2;
	hodd = heven + h%2;

	int cnteven, cntodd;
	cnteven = cntodd = 0;
	int lvlcnt, olvlcnt;

	int middle = n;

	for ( int i=h; i>0; i-- )
	{
		minb[ i ] = 1;
		maxb[ i ] = n;
		if ( h%2 == 1 )
		{
			cntodd++;
			lvlcnt = cntodd;
			olvlcnt = cnteven;
		}
		else
		{
			cnteven++;
			lvlcnt = cnteven;
			olvlcnt = cntodd;
		}

        suma[ i ] = n * (ll)olvlcnt;
        sumai[ i ] = olvlcnt * ( ( 1 + (2*(n-1)+1) ) * (ll) n )/2;
		sumo[ i ] = n * (ll)lvlcnt;
		sumoi[ i ] = lvlcnt * (ll) n * middle;
	}

	int l, k;
	for ( int REQ = 1; REQ <= m; REQ++ )
	{
		scanf("%d %d", &l, &k );
		rem[ l ].push_back( k );

        if ( minb[ l ] == k || maxb[ l ] == k )
            RecalcMinMax( l );

		if ( maxb[ l ] == 0 ) // NAV VAIRS BLOKI LIMENI
		{

			PrintAnsw( REQ );
			return 0;
		}

		// AUGSEJIEM LIMENIEM NEKAS NEMAINAS

		// 1 vai UZ SO LIMENI VISS KARTIBA

		if ( l + 1 <= h )
		{
			if (!CHECK( l+1 ))
			{
				PrintAnsw( REQ );
				return 0;
			}
		}

		// 2 vai UZ APAKSEJIEM LIMENIEM VIS KARTIBA

		for ( int i=l; i>0; i-- )
		{
			if ( i%2 == l%2 )
			{
				sumo[ i ] -= 1;
				sumoi[ i ] -= middle;
			}
			else
			{
				suma[ i ] -= 1;
				sumai[ i ] -= (2*(k-1)+1);
			}
			if ( !CHECK( i ) )
			{
				PrintAnsw( REQ );
				return 0;
			}
		}
	}

	printf("no\n");

	return 0;
}
