#include <bits/stdc++.h>

#define FILENAME "kids"
#define get ololol

using namespace std;

const int MX = 1000;

void read(char A[MX][MX + 1], int& dx, int& dy) {
	int n, m;
	scanf("%d %d", &n, &m);
    for (int i = 0; i < n; i++) scanf(" %s", A[i]);

    dx = -1;
    for (int i = 0; i < n && dx == -1; i++)
		for (int j = 0; j < m; j++)
			if (A[i][j] == '*')
				dx = i;

	dy = -1;
	for (int j = 0; j < m && dy == -1; j++)
		for (int i = 0; i < n; i++)
			if (A[i][j] == '*')
				dy = j;

    for (int i = 0; i < n - dx; i++)
		for (int j = 0; j < m - dy; j++)
            A[i][j] = A[i + dx][j + dy];

	n -= dx;
	m -= dy;

    for (int i = 0; i < MX; i++)
		for (int j = m; j < MX; j++)
            A[i][j] = '.';

	for (int i = n; i < MX; i++)
		for (int j = 0; j < MX; j++)
			A[i][j] = '.';
}

int get(char A[MX][MX + 1], int x, int y) {
	if (x < 0) return 0;
	if (x >= MX) return 0;
	if (y < 0) return 0;
	if (y >= MX) return 0;

    return A[x][y] == '*' ? 1 : 0;
}

char A[MX][MX + 1], B[MX][MX + 1], C[MX][MX + 1];

bool solve(int& ansx, int& ansy) {
	const int OLOLO = 1e9;

    int x0 = OLOLO, y0;
    int x1 = OLOLO, y1;
    for (int i = 0; i < MX; i++)
		for (int j = 0; j < MX; j++) {
            if (x0 == OLOLO && get(A, i, j) != get(B, i, j)) {
				x0 = i;
				y0 = j;
            }

            if (x1 == OLOLO && get(C, i, j) == 1) {
				x1 = i;
				y1 = j;
            }
		}

	bool ok = true;
    for (int i = -MX; i < 2 * MX; i++)
		for (int j = -MX; j < 2 * MX; j++)
            if ((get(A, i - x1 + x0, j - y1 + y0)) != get(C, i, j))
				ok = false;

	if (ok) {
		ansx = ansy = 0;

		return true;
	}

    int p = 0, q = 0;
	while (A[0][p] != '*') p++;
	while (C[0][q] != '*') q++;

	int x = OLOLO, y;
    for (int i = -MX; i < 2 * MX && x == OLOLO; i++)
		for (int j = -MX; j < 2 * MX; j++)
			if (get(A, i, j - q + p) != get(C, i, j)) {
                x = i;
                y = j;

                break;
			}

    if (x == OLOLO) return false;

    int r = 0;
    while (B[0][r] != '*') r++;

    for (int i = -MX; i < 2 * MX; i++)
		for (int j = -MX; j < 2 * MX; j++)
            if ((get(A, i, j - q + p) ^ get(B, i - x, j - y + r)) != get(C, i, j))
				return false;

    ansx = x;
    ansy = r - y - p + q;

	return true;
}

void rotate() {
	for (int i = 0; i < MX; i++)
		for (int j = 0; j < i; j++) {
			swap(A[i][j], A[j][i]);
			swap(B[i][j], B[j][i]);
			swap(C[i][j], C[j][i]);
		}
}

int Adx, Ady, Bdx, Bdy, Cdx, Cdy, ansx, ansy;

void fun() {
    ansx -= Bdx - Adx;
    ansy -= Bdy - Ady;

    printf("YES\n%d %d\n", ansy, ansx);

	exit(0);
}

int main()
{
	#ifndef LOCAL
	freopen( FILENAME ".in", "r", stdin );
	freopen( FILENAME ".out", "w", stdout );
	#endif // LOCAL


    read(A, Adx, Ady);
    read(B, Bdx, Bdy);
    read(C, Cdx, Cdy);

    if (solve(ansx, ansy)) fun();
    rotate();
    if (solve(ansx, ansy)) {
        swap(ansx, ansy);
		fun();
    }
    swap(A, B);
    if (solve(ansx, ansy)) {
        swap(ansx, ansy);
        ansx *= -1;
        ansy *= -1;
		fun();
    }
    rotate();
    if (solve(ansx, ansy)) {
        ansx *= -1;
        ansy *= -1;
		fun();
    }

	printf("NO\n");

	return 0;
}
