#include "bits/stdc++.h"

using namespace std;

bool isCapitalize(const string & s) {
	if (s.size() > 0 && !isupper(s[0]))
		return false;
	for (int i = 1; i < s.size(); ++i) {
		if (!islower(s[i]))
			return false;
	}
	if (s.size() == 1)
		return false;
	return true;
}

void make_words(const vector<string>& w, const vector<string>& b_w) {
	vector<char> cap(w.size(), 0);
	for (int i = 0; i < w.size(); ++i) {
		cap[i] = isCapitalize(w[i]);
	}

	int f_p = -1, l_p = -1;
	for (int i = 0; i <= w.size(); ++i) {
		if (i < w.size() && cap[i]) {
			if (f_p == -1)
				f_p = i;
			l_p = i;
		}
		else {
			if (l_p - f_p > 0) {
				cout << b_w[f_p];
				for (int p = f_p; p <= l_p; ++p)
					cout << w[p][0];
				cout << " (";
				for (int p = f_p; p <= l_p; ++p) {
					cout << w[p];
					if (p != l_p)
						cout << " ";
				}
				cout << ")";
				l_p = f_p = -1;
			}
			else if (l_p != -1) {
				cout << b_w[f_p];
				cout << w[f_p];
				l_p = f_p = -1;
			}
			
			if(i < w.size()) {
				cout << b_w[i];
				cout << w[i];
			}
		}
	}

	cout << b_w.back();
}

void solve() {
	string s;
	int count = 0;
	while (getline(cin,s)) {
		if(count)
			cout << endl;
		++count;
		int last_sp = 0;

		vector<string> words;
		vector<string> bef_word;
		bef_word.push_back("");

		for (int i = 0; i < s.size(); ++i) {
			if (isalpha(s[i])) {
				if (i == 0 || !isalpha(s[i - 1])) {
					words.push_back("");
					bef_word.push_back("");
				}
				words.back() += s[i];
				last_sp = 0;
			}
			else {
				bef_word.back() += s[i];
				if (isspace(s[i]))
					last_sp++;
				else
					last_sp = 0;
				
				if (!isspace(s[i]) || last_sp == 2) {
					while (i+1 < s.size() && !isalpha(s[i+1])) {
						bef_word.back() += s[i + 1];
						i++;
					}
					make_words(words, bef_word);
					words.clear();
					bef_word.clear();
					bef_word.push_back("");
				}
			}
		}

		if (words.size()) {
			make_words(words, bef_word);
		}
	}

	//if(count == 1)
}

int main() {
#if ZEBER
	freopen("abbreviation3.in", "r", stdin);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	solve();

}