#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <queue>
#include <iomanip>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;

typedef long long LL;
typedef pair<int, int> pair_ii;
typedef pair<long long, long long> pair_LL;
typedef pair<string, string> pair_s;

#define fori(i,s,n) for (int i = s; i < n; ++i)
#define forir(i,f) for (int i = f - 1; i >= 0; --i)
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz size()

void print(vector <string> &tmp) {
	if (tmp.sz == 0) {
		return;
	}
	if (tmp.sz == 1) {
		cout << tmp[0];
	}
	else {
		fori(i, 0, tmp.sz) {
			cout << tmp[i][0];
		}
		cout << " (";
		fori(i, 0, tmp.sz) {
			if (i != tmp.sz - 1) {
				cout << tmp[i] << " ";
			}
			else {
				cout << tmp[i];
			}
		}
		cout << ")";
	}
}

bool check(string s) {
	if (s.length() < 2) {
		return 0;
	}
	if (isupper(s[0])) {
		fori(i, 1, s.length()) {
			if (!islower(s[i])) {
				return 0;
			}
		}
		return 1;
	}
	else {
		return 0;
	}
}

string word(string &s) {
	if (s == "") {
		return "";
	}
	string ans = "";
	for (int i = 0; (isupper(s[i]) || islower(s[i])) && i < s.length(); ++i) {
		ans.pb(s[i]);
	}
	s.erase(0, ans.length());
	return ans;
}

string sym(string &s) {
	if (s == "") {
		return "";
	}
	string ans = "";
	for (int i = 0; (!isupper(s[i]) && !islower(s[i])) && i < s.length(); ++i) {
		ans.pb(s[i]);
	}
	s.erase(0, ans.length());
	return ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt","w",stdout);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#endif
	string s;
	while (getline(cin, s)) {
		vector <string> tmp;
		string last = "";
		while (s.length() > 0) {
			string w = word(s);
			string n = sym(s);
			if (check(w)) {
				tmp.pb(w);
				last = n;
			}
			else {
				print(tmp);
				cout << last;
				tmp.clear();
				last = "";
				cout << w;
				cout << n;
			}
			if (n != " ") {
				print(tmp);
				cout << last;
				tmp.clear();
				last = "";
				//cout << n;
			}
		}
		cout << endl;
	}
	return 0;
}