#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <iomanip>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second

typedef long long ll;
typedef long double ld;
typedef pair < int ,int > pii;
typedef pair < ll, ll > pll;

vector<string> split(const string &s) {
    vector<string> ans;
    ans.push_back(string());
    for (int i = 0; i < (int)s.size(); ++i) {
        if (!isalpha(s[i])) {
            ans.push_back(string());
            ans.back() += s[i];
            ans.push_back(string());
        }
        else
            ans.back() += s[i];
    }

    return ans;
}

bool is_capit_word(const string &s) {
    if (s.empty())
        return false;
    if (!isalpha(s[0]))
        return false;

    if (!isupper(s[0]))
        return false;
    if (s.size() == 1)
        return false;
    for (int i = 1; i < (int)s.size(); ++i) {
        if (!islower(s[i]))
            return false;
    }

    return true;
}

int main() {
//    freopen("input.txt", "r", stdin);
    freopen("abbreviation.in", "r", stdin);
    freopen("abbreviation.out", "w", stdout);
    string s;
    while (getline(cin, s)) {
        vector<string> words = split(s);
//        for (auto &it : words) {
//            cout << "'" << it << "'\n";
//        }
        words.push_back(string());

        vector<int> is_capit(words.size());
        for (int i = 0; i < (int)words.size(); ++i) {
            is_capit[i] = is_capit_word(words[i]);
        }

        for (int i = 0; i < (int) words.size(); ++i) {
            if (!is_capit[i]) {
                cout << words[i];
                continue;
            }
            int j = i;
            for (j = i; j < (int) words.size() - 2; ++j) {
                if ((j - i) % 2 == 1)
                    continue;
                if (!is_capit[j + 2])
                    break;
            }

            string abbr;
            for (int k = i; k <= j; k += 2) {
                abbr += words[k][0];
            }

            if (abbr.size() < 2) {
                cout << words[i];
                continue;
            }

            cout << abbr << " (";
            for (int k = i; k <= j; ++k)
                cout << words[k];

            cout << ")";
            i = j;
        }

        cout << "\n";
    }

    return 0;
}
