#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <iomanip>
#include <climits>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second

typedef long long ll;
typedef long double ld;
typedef pair < int ,int > pii;
typedef pair < ll, ll > pll;

const int MAXN = 1000400;
const ll INF = (ll) 2e18;

int n, q;
map < ll, ll > m;
int a[MAXN];
ll p[MAXN];
ll ans[MAXN];

bool cmp(ll i, ll j){
    return a[i] < a[j];
}

int main() {
    //freopen ("input.txt", "r", stdin);
    freopen ("expect.in", "r", stdin);
    freopen ("expect.out", "w", stdout);
    scanf ("%d%d", &n, &q);
    ll cur = 0;
    ll predT = 0;
    for (int i = 1; i <= n; i ++) {
        char s[5];
        int t, k;
        scanf ("%s %d %d", s, &t, &k);
        ll kol = (t - predT) ;
        predT = t;
        m[cur] += kol;
        if (s[0] == '-') cur += k;
        else cur -= k;
    }
    m[cur] = INF;
    for (int i = 1; i <= q; i ++)
        scanf ("%d", &a[i]), p[i] = i;
    sort (p + 1, p + 1 + q, cmp);
    vector < pll > vec;
    for (auto v : m) {
        vec.pb(mp(v.F, v.S));
    }
    ll kol = 0;
    ll sum = 0;
    ll it = vec.size() - 1;
    for (int i = q; i >= 1; i --) {
        while (it && vec[it].F > a[ p[i] ]) {
            sum += 1ll * vec[it].F * vec[it].S;
            if (kol == INF || vec[it].S == INF) kol = INF;
            else kol += 1ll * vec[it].S;
            it --;
        }
        if (kol == INF) ans[ p[i] ] = INF;
        else ans[ p[i] ] = 1ll * sum - kol * a[ p[i] ];
    }
    for (int i = 1; i <= q; i ++)
        if (ans[i] == INF) cout << ("INFINITY\n");
        else cout << ans[i] << "\n";
    return 0;
}
