#define FNAME "expect"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int,int> pii;

#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define all(V) V.begin(), V.end()
#define sz(V) (int)(V.size())
#define forn(i, N) for(int i = 0; i < int(N); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define fornr(i, N) for(int i = int(N) - 1; i >= 0; --i)
#define forit(i, V) for(__typeof(V.begin()) i = V.begin(); i != V.end(); ++i)

const int INF = 1e9 + 7;
const int N = 4e5 + 100;

int b[N];
vector <pair<int, pii>> changes, events;
map<int, ll> ans;

int main(){
	assert(freopen(FNAME".in", "r", stdin));
	assert(freopen(FNAME".out", "w", stdout));
	int n, q;
	scanf("%d%d", &n, &q);	
	int total = 0;
	forn (i, n) {
		char ch;
		int t, k, type;
		scanf(" %c%d%d", &ch, &t, &k);
		if (ch == '-') {
			type = 1;
		} else {
			type = -1;
		}
		total += type * k;
		changes.pb(mp(type, mp(t, k)));
	}
	int lastTime = changes[0].snd.fst;
	int bal = 0;
	forn(i, sz(changes)) {
		int now = changes[i].snd.fst, cnt = changes[i].snd.snd;
		int type = changes[i].fst;
		events.pb(mp(bal, mp(lastTime, now)));
		bal += cnt * type;
		lastTime = now;
	}
	events.pb(mp(bal, mp(lastTime, INF)));
	forn(i, q) {
		scanf("%d", &b[i]);
		events.pb(mp(b[i], mp(0, 0)));
	}
	sort(all(events));
	reverse(all(events));
	ll s = 0, lastBal = events[0].fst, len = 0;
	forn(i, sz(events)) {
		auto e = events[i];
		int bal = e.fst;
//		cout << bal << '\n';
		s += (lastBal - bal) * 1ll * len;
		for (; i < sz(events) && events[i].fst == bal; i++) {
			len += events[i].snd.snd - events[i].snd.fst;
//			cout << "len = " << events[i].snd.snd - events[i].snd.fst << '\n';
//			cout << "l = " << events[i].snd.fst << ", r = " << events[i].snd.snd << '\n';
		}
//		cout << "s = " << s << ", len = " << len << '\n';
//		cout << "//////\n";
		i--;
		ans[bal] = s;
		lastBal = bal;
	}
	forn(i, q) {
		if (b[i] - total >= 0) {
			printf("%lld\n", ans[b[i]]);
		} else {
			puts("INFINITY");
		}
	}
	
	
	return 0;
}