#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#define ll long long
#define ld double
#define pii pair <int, int>
#define mp make_pair

using namespace std;

const int maxn = (int)1e5 + 10;
char c[maxn];
int t[maxn], k[maxn];
pii v[maxn];
int b[maxn];
pair <ll, ll> ans[maxn];

void change(int l, int r, int pos, ll z) {
	if (r < 0) {
		return;
	}
	if (r < l) {
		return;
	}

    if (pos == 0) {
		ans[r].first += z;

		if (l != 0) {
			ans[l - 1].first -= z;
		}
	}
	else {
		ans[r].second += z;

		if (l != 0) {
			ans[l - 1].second -= z;
		}
	}
}

ll res[maxn];

int main() {
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	int n, q;

	scanf("%d %d", &n, &q);

	int now = 0;

	for (int i = 0; i < n; i++) {
		scanf(" %c %d %d", &c[i], &t[i], &k[i]);

		b[i] = now;

		if (c[i] == '+') {
			now += k[i];
		}
		else {
			now -= k[i];
		}
	}

	for (int i = 0; i < q; i++) {
		scanf("%d", &v[i].first);
		v[i].second = i;
	}

	sort(v, v + q);

	for (int i = 0; i < n; i++) {
		if (c[i] == '-') {
			if (b[i] >= k[i]) {
				continue;
			}

			int x = k[i] - b[i];

			int l = upper_bound(v, v + q, mp(-b[i], -1)) - v;
			int pos = upper_bound(v, v + q, mp(x, -1)) - v;
			change(0, l - 1, 0, -(ll)k[i] * t[i]);
			change(l, pos - 1, 0, (ll)(b[i] - k[i]) * t[i]);
			change(l, pos - 1, 1, t[i]);
		}
		else {
			if (b[i] >= 0) {
				continue;
			}

			int x = -k[i] - b[i];

			int pos = upper_bound(v, v + q, mp(x, -1)) - v;

			change(0, pos - 1, 0, (ll)k[i] * t[i]);

			int r = upper_bound(v, v + q, mp(-b[i], -1)) - v;

			change(pos, r - 1, 0, (ll)-b[i] * t[i]);
			change(pos, r - 1, 1, (ll)-t[i]);
		}
	}

	for (int i = q - 1; i >= 1; i--) {
		ans[i - 1].first += ans[i].first;
		ans[i - 1].second += ans[i].second;
	}

	for (int i = 0; i < q; i++) {
		if (now + v[i].first >= 0) {
			res[v[i].second] = ans[i].first + ans[i].second * v[i].first;
		}
		else {
			res[v[i].second] = -1;
		}
	}

	for (int i = 0; i < q; i++) {
		if (res[i] >= 0) {
			printf("%lld\n", res[i]);
		}
		else {
			printf("INFINITY\n");
		}
	}
}
