import sys
import re

def get_chn(w):
    tk = w.split()
    result = ''
    for i in tk:
        result += i[0]
    result += ' ('
    result += w
    result += ')'
    return result

def transf(line):
    line = '.' + line + '.'
    rexp = r'[^A-Za-z]([A-Z][a-z]+( [A-Z][a-z]+)+)[^A-Za-z]'
    for_change = re.findall(rexp, line)
    changes = [get_chn(i[0]) for i in for_change]
    n = len(for_change)
    for i in range(n):
        line = re.sub(for_change[i][0], changes[i], line)
    return line[1: -1]

def main():
    sys.stdin = open("abbreviation.in", "r")
    sys.stdout = open("abbreviation.out","w")
    for line in sys.stdin:
        print(transf(line), end = '')

main()
