#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<cstdio>
#include<algorithm>
#include<set>
#include<map>
#include<string>
#include<cstring>
#include<queue>
#include<functional>
#include<cassert>

using namespace std;
typedef long long ll;
typedef long long lint;

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
#endif

	string s;
	cin >> s;
	lint n = s.length();
	vector<lint> prefw(n);
	vector<lint> prefc(n);

	if (s[0] == 'C')
		prefc[0]++;
	else
		prefw[0]++;
	for (lint i = 1; i < n; i++) {
		prefc[i] = prefc[i - 1];
		prefw[i] = prefw[i - 1];
		if (s[i] == 'C')
			prefc[i]++;
		else
			prefw[i]++;
	}

	vector<double> ans(n);
	double a_c = 0;
	double a_w = 0;
	for (lint i = n - 1; i >= 0; i--) {
		ans[i] = 0;
		if (s[i] == 'C') {
			ans[i] += prefw[n - 1] + a_w;
			if (i)
				ans[i] -= prefw[i - 1];
			ans[i] -= (n - i - 1) * prefw[i];
		}
		else {
			ans[i] += prefc[n - 1] + a_c;
			if (i)
				ans[i] -= prefc[i - 1];
			ans[i] -= (n - i - 1) * prefc[i];
		}
		ans[i] /= (n - i);
		a_c += ans[i] + ((i > 0) ? prefc[i - 1] : 0);
		a_w += ans[i] + ((i > 0) ? prefw[i - 1] : 0);
	}
	printf("%.11lf", ans[0]);
}