#include <iostream>
#include <iomanip>
#include <string>
#include <set>
#include <vector>
#include <algorithm>
#include <sstream>

using namespace std;
typedef long long ll;

int main(){
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, q; cin >> n >> q;
	ll curH = 0;
	vector<pair<ll, ll> > a; //array h, width
	int lastT;
	for (int i = 0; i < n; ++i){
		char c; int t, k, nxtH;
		cin >> c >> t >> k;
		if (i > 0){
			a.emplace_back(curH, t - lastT);
		}
		if (c == '+'){
			nxtH = curH - k;
		}
		else {
			nxtH = curH + k;
		}
		curH = nxtH;
		lastT = t;
	}

	sort(a.begin(), a.end());
	vector<ll> I(n);
	vector<ll> It(n);
	for (int i = 1; i < n; ++i){
		I[i] = I[i - 1] + a[i - 1].first * a[i - 1].second;
		It[i] = It[i - 1] + a[i - 1].second;
	}
	

	for (int ttt = 0; ttt < q; ++ttt){
		ll h; cin >> h;
		if (curH > h) {
			cout << "INFINITY" << endl;
			continue;
		}
		int pos = lower_bound(a.begin(), a.end(), make_pair(h + 1, 0LL)) - a.begin();
		if (pos == n - 1){
				cout << 0 << endl;
				continue;
		}
		ll totalT = It[n - 1] - It[pos];
		ll ans = (I[n - 1] - I[pos]) - h * totalT;
		cout << ans << endl;
	}
	return 0;
}