#include <iostream>
#include <iomanip>
#include <string>
#include <set>
#include <vector>
#include <algorithm>
#include <sstream>

using namespace std;
typedef long double ld;
typedef long long ll;
const int N = 1e6 + 100;

ll ac[N], aw[N];
ll Ic[N], Iw[N];

int main(){
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	string s; cin >> s;

	const int n = s.size();
	
	for (int i = 0; i < n; ++i) {
		if (s[i] == 'C') ac[i] = n - i;
		else aw[i] = n - i;
	}

	for (int i = n - 1; i >= 0; --i) {
		Ic[i] = ac[i];
		Iw[i] = aw[i];
		if (i != n - 1) Ic[i] += Ic[i + 1];
		if (i != n - 1) Iw[i] += Iw[i + 1];

		//cout << "Ic[" << i << "] = " << Ic[i] << endl;
		//cout << "Iw[" << i << "] = " << Iw[i] << endl;
	}

	ld res = 0;
	for (int i = 0; i < n; ++i) {
		ld cur = 0;
		if (s[i] == 'C') cur = Iw[i];
		else cur = Ic[i];
		cur /= n - i;
		if (n - i + 1 <= n) cur /= n - i + 1;
		res += cur;
	}

	cout << fixed << setprecision(10) << res << endl;

	return 0;
}