#include <bits/stdc++.h>
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
using namespace std;
typedef long long ll;

const int MAXN = 1 << 16;

int n, m;
vector<int> e[MAXN];
vector<string> ans;

char g(char c) {
    return c;
    /*if (c == 'r') return "recolor";
    if (c == 'j') return "join";
    if (c == 'c') return "connect";
    assert(0);
    return "";*/
}

void add(char c, int a, int b) {
    a++;
    b++;
    string s = "";
    s += g(c);
    s += " ";
    s += to_string(a);
    s += " ";
    s += to_string(b);
    ans.push_back(s);
}

void add(char c, int a, int c1, int c2) {
    a++;
    string s = "";
    s += g(c);
    s += " ";
    s += to_string(a);
    s += " ";
    s += to_string(c1);
    s += " ";
    s += to_string(c2);
    ans.push_back(s);
}

int vis[MAXN];

pair<int, int> dfs(int v, int pr) {
    vis[v] = 1;
    pair<int, int> res = make_pair(-1, -1);

    vector<pair<int, pair<int, int> > > vct;
    for (int to : e[v]) {
        if (to == pr) continue;
        if (vis[to] == 1) {
            res = make_pair(v, to);
            continue;
        }
        if (vis[to] == 2) continue;
        pair<int, int> x = dfs(to, v);
        vct.push_back(make_pair(to, x));
    }
    sort(vct.begin(), vct.end(), [&](pair<int, pair<int, int> > x, pair<int, pair<int, int> > y) {
        return ((int)(x.second.second == v)) > ((int)(y.second.second == v));
    });
    for (auto to : vct) {
        add('j', v, to.first);
        if (to.second.second == v) {
            add('c', v, 1, 2);
            add('r', v, 2, 4);
        } else {
            if (to.second.second != -1) {
                assert(res == make_pair(-1, -1));
                res = to.second;
            }
        }
        add('c', v, 1, 3);
        if (to.second.first == to.first) {
            add('r', v, 3, 2);
        } else {
            add('r', v, 3, 4);
        }
    }   
    add('r', v, 1, 3);
    vis[v] = 2;
    return res;
}

#define TASK "cactus"
int main()
{
    assert(freopen(TASK".in", "r", stdin));
    assert(freopen(TASK".out", "w", stdout));

    scanf("%d%d", &n, &m);
    for (int i = 0; i < m; i++) {
        int k;
        scanf("%d", &k);
        vector<int> v(k);
        for (int j = 0; j < k; j++) {
            scanf("%d", &v[j]);
            v[j]--;
        }

        for (int j = 1; j < k; j++) {
            e[v[j]].push_back(v[j - 1]);
            e[v[j - 1]].push_back(v[j]);
        }
    }  
    for (int i = 0; i < n; i++) vis[i] = 0;
    dfs(0, -1);

    printf("%d\n", (int)ans.size());
    for (int i = 0; i < (int)ans.size(); i++) printf("%s\n", ans[i].c_str());
    return 0;
}