#include <bits/stdc++.h>
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
using namespace std;
typedef long long ll;
typedef vector<int> vi;
#define pb push_back
#define F first
#define S second
#define sz(a) ((int)(a).size())
typedef pair<int, int> pi;

const int N = 4e5 + 10;

vi v[N];
vi vr[N];

int n, m;

int gena[N];
int gosha[N];
int deg[N];

pi q[N];
int st, en;

void solve0()
{
    //gena0, gosha1
    st = en = 0;
    forn(i, n) if (sz(v[i]) == 0)
    {
        q[en++] = {i, 0};
        gena[i] = 0;
    }
    while (st < en)
    {
        int x = q[st].F;
        int who = q[st].S;
        st++;
        if (who == 0)
        {
            //gena
            for (int y : vr[x])
            {
                if (gosha[y] == -1)
                {
                    gosha[y] = 1;
                    q[en++] = {y, 1};
                }
            }
        }
        else
        {
            //gosha
            for (int y : vr[x])
            {
                if (gena[y] == -1)
                {
                    deg[y]--;
                    if (deg[y] == 0)
                    {
                        gena[y] = 0;
                        q[en++] = {y, 1};
                    }
                }
            }
        }
    }
}

void solve1()
{
    //gena0, gosha1
    st = en = 0;
    forn(i, n) if (sz(v[i]) == 0)
    {
        q[en++] = {i, 1};
        gosha[i] = 0;
    }
    while (st < en)
    {
        int x = q[st].F;
        int who = q[st].S;
        st++;
        if (who == 0)
        {
            //gena
            for (int y : vr[x])
            {
                if (gosha[y] == -1)
                {
                    gosha[y] = 0;
                    q[en++] = {y, 1};
                }
            }
        }
        else
        {
            //gosha
            for (int y : vr[x])
            {
                if (gena[y] == -1)
                {
                    deg[y]--;
                    if (deg[y] == 0)
                    {
                        gena[y] = 1;
                        q[en++] = {y, 0};
                    }
                }
            }
        }
    }
}
        

#define TASK "game"
int main()
{
    assert(freopen(TASK".in", "r", stdin));
    assert(freopen(TASK".out", "w", stdout));
    memset(gena, -1, sizeof gena);
    memset(gosha, -1, sizeof gosha);

    scanf("%d%d", &n, &m);
    forn(i, m)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        --x, --y;
        v[x].pb(y);
        vr[y].pb(x);
        deg[x]++;
    }
    solve0();
    solve1();

    char c[3] = {'D', 'L', 'W'};
    forn(i, n) putchar(c[gena[i] + 1]);
    puts("");
    forn(i, n) putchar(c[gosha[i] + 1]);

    return 0;
}