#include <algorithm>
#include <iostream>
#include <cmath>
#include <fstream>
#include <string>
#include <vector>

using namespace std;

const int maxN = 100000 + 100;
string a[maxN];
bool b[maxN];

bool letter(char s) {
	if (s >= 'a' && s <= 'z') return true;
	if (s >= 'A' && s <= 'Z') return true;
	return false;
}

bool smallletter(char s) {
	if (s >= 'a' && s <= 'z') return true;
	return false;
}


bool isGoodWord(string s) {
	if (s.size() <= 2) return false;
	if (!(s[0] >= 'A' && s[0] <= 'Z')) {
		return false;
	}
	for (int i = 1; i < s.size(); ++i) {
		if (smallletter(s[i])) continue; else return false;
	}
	return true;
}

void solve(string s) {
	int cnt = 0;
	string curS = "";
	int i = 0;
	while (i < s.size()) {
		if (letter(s[i])) {
			int j = i + 1;
			while (j < s.size() && letter(s[j])) ++j; --j;
			curS = "";
			for (int k = i; k <= j; ++k) curS += s[k];
			++cnt;
			a[cnt - 1] = curS;
			i = j + 1;
		}
		else {
			++cnt;
			a[cnt - 1] = s[i];
			i = i + 1;
		}
	}

	for (int i = 0; i < cnt; ++i) {
		if (isGoodWord(a[i])) b[i] = true; else b[i] = false;
	}
	i = 0;
	while (i < cnt) {
		if (b[i]) {
			int j = i;
			while (j + 2 < cnt && a[j + 1] == " " && b[j + 2]) j += 2;
			if (i == j) {
				cout << a[i];
				i = i + 1;
			}
			else {
				string st = "";
				for (int k = i; k <= j; k += 2) {
					st += a[k][0];
				}
				cout << st << " (";
				for (int k = i; k <= j; ++k) cout << a[k];
				cout << ")";
				i = j + 1;				
			}		
		}
		else {
			cout << a[i];
			i = i + 1;
		}
	}
}

int main() {
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	string s;
	bool first = true;
	while (getline(cin, s)) {
		if (!first) cout << endl;
		first = false;
		solve(s);
	}
	return 0;
}