#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <set>

using namespace std;

set <int> levels[100001];
double xs[100001];
double ys[100001];
int cnt[100001];

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	
	int n;
	double w;
	int h, m;
	int l, k;
	cin >> n >> w >> h >> m;
	cnt[h - 1] = n;
	for (int i = h - 2; i >= 0; --i) {
		cnt[i] = cnt[i + 1] + n;
	}
	for (int i = 0; i < n; ++i) {
		if (i & 1) {
			xs[h - 1] += w * i + (w / 2.0);
			ys[h - 1] += (n * w) / 2.0;
		}
		else {
			ys[h - 1] += w * i + (w / 2.0);
			xs[h - 1] += (n * w) / 2.0;
		}
	}
	for (int i = h - 2; i >= 0; --i) {
		xs[i] = xs[i + 1];
		ys[i] = ys[i + 1];
		for (int j = 0; j < n; ++j) {
			if (i & 1) {
				xs[i] += w * j + ((double)w / 2.0);
				ys[i] += (n * w) / 2.0;
			}
			else {
				ys[i] += w * j + ((double)w / 2.0);
				xs[i] += (n * w) / 2.0;
			}
		}
	}

	for (int i = 0; i < h; ++i) for (int j = 0; j < n; ++j) levels[i].insert(j);
	for (int t = 1; t <= m; ++t) {
		scanf("%d %d", &l, &k);
		levels[l - 1].erase(k - 1);
		if (levels[l - 1].empty()) {
			cout << "yes\n";
			cout << k;
			return 0;
		}
		for (int i = l - 1; i >= 0; --i) {
			--cnt[i];
			if (i & 1) {
				xs[i] -= w * k - ((double)w / 2.0);
				ys[i] -= double(n * w) / 2.0;
			}
			else {
				ys[i] -= w * k - ((double)w / 2.0);
				xs[i] -= double(n * w) / 2.0;
			}
		}
		for (int i = h - 2; i >= 0; --i) {
			if (i & 1) {
				double hui = xs[i + 1] / (double)cnt[i + 1];
				int left = *levels[i].begin();
				int right = *(--levels[i].end());
				if (hui < 1e-9 + left * w || hui + 1e-9 > (right + 1) * w) {
					cout << "yes\n";
					cout << k;
					return 0;
				}
			}
			else {
				double hui = ys[i + 1] / (double)cnt[i + 1];
				int left = *levels[i].begin();
				int right = *(--levels[i].end());
				if (hui < 1e-9 + left * w || hui + 1e-9 >(right + 1) * w) {
					cout << "yes\n";
					cout << k;
					return 0;
				}
			}
		}
	}
	cout << "no";


	return 0;
}
