def is_c(s):
    return len(s) > 1 and s[0].isupper() and all(not x.isupper() for x in s[1:])

def split(s):
    if len(s) == 0:
        return []
    i = 0
    while i < len(s) and not s[i].isalpha:
        yield s[i]
        i += 1
    c = []
    while i < len(s):
        if s[i].isalpha():
            c.append(s[i])
        else:
            if c:
                yield ''.join(c)
            yield s[i] 
            c = []
        i += 1
    if c:
        yield ''.join(c)

def g(s):
    sx = list(split(s))
    res = []
    i = 0
    while i < len(sx):
        if is_c(sx[i]):
            r = [sx[i]]
            i += 1
            while i < len(sx) - 1:
                if sx[i] == ' ' and is_c(sx[i + 1]):
                    r.append(sx[i + 1])
                    i += 2
                else:
                    break
            res.append(r)
        else:
            res.append([sx[i]])
            i += 1
    return res

def p(s):
    r = g(s)
    rx = []
    for x in r:
        if len(x) == 1:
            rx.append(x[0])
        else:
            rx.append(''.join([y[0] for y in x]))
            rx.append(' (')
            rx.append(' '.join(x))
            rx.append(')')
    return ''.join(rx)
    
#s = input()
#while s:
#    print(p(s))
#    s = input()

r = []
with open('abbreviation.in', 'r') as f:
    for l in f:
        r.append(p(l))

with open('abbreviation.out', 'w') as f:
    for x in r:
        f.write(x)
