#include <iostream>
#include <vector>
#include <unordered_set>
#include <set>
#include <map>

long long n, w, h, m;

struct Foo
{
	long long i, l, k, b1, b2;
	double s, m, sum = 0, sum1 = 0;
	std::set<int> missed;
	long long x = 0;

	bool is_empty() const
	{
		return k == 0;
	}
};

int main()
{
	std::cin >> n >> w >> h >> m;
	
	std::map<int, Foo> lvls;

	for (int i = 0; i < m; ++i)
	{
		long long a, b;
		std::cin >> a >> b;
		bool is_new = false;
		if (lvls.count(a) == 0)
		{
			is_new = true;
			Foo f;
			f.l = a;
			f.k = n;
			f.s = n * (n + 1) / 2;
			f.b1 = 1;
			f.b2 = n;
			f.m = f.s / f.k;
			
			lvls[a] = f;

			auto it = lvls.find(a);
			if (it != lvls.begin())
			{
				it = std::prev(it);
				lvls.at(a).sum = it->second.sum + it->second.k * it->second.m;
				lvls.at(a).sum1 = it->second.sum1 + it->second.k;
				lvls.at(a).x = it->second.x + 1;
			}	
		}
		else 
		{
			auto& f = lvls.at(a);
			f.k--;
			f.missed.insert(b);
			f.s -= b;
			f.m = f.s / f.k;
		}

		auto& f = lvls.at(a);
		if (b == f.b1)
		{
			do
			{
				f.b1++;
			} while (f.missed.count(f.b1) == 1 && f.b1 < n);
		}
		if (b == f.b2)
		{
			do
			{
				f.b2--;
			} while (f.missed.count(f.b2) == 1 && f.b2 > 0);
		}
		if (f.is_empty())
		{
			if (f.l == h)
			{
				// h--;
			}
			else
			{
				std::cout << "yes" << std::endl;
				std::cout << i + 1 << std::endl;
			}
			
			return 0;
		}

		{
			auto& x = lvls.at(a);

			double f1 = ((h - x.l - x.x) * n * (n + 1) / 2 + x.sum);
			double f2 = ((h - x.l - x.x) * n + x.sum1);
			double ff = f1 / f2;
			if (!(x.b1 - 0.5 < ff && x.b2 + 0.5 > ff))
			{
				if (x.l != h)
				{

					std::cout << "yes" << std::endl;
					std::cout << i + 1 << std::endl;
					return 0;
				}
			}
		}

		auto it = lvls.find(a);
		it = std::next(it);
		while (it != lvls.end())
		{
			auto prev = std::prev(it);
			it->second.x = prev->second.x + 1;
			it->second.sum = prev->second.sum + prev->second.k * prev->second.m;
			it->second.sum1 = prev->second.sum1 + prev->second.k;

			auto& x = it->second;
			double f1 = ((h - x.l - x.x) * n * (n + 1) / 2 + x.sum);
			double f2 = ((h - x.l - x.x) * n + x.sum1);
			double f = f1 / f2;
			if (!(x.b1 - 0.5 < f && x.b2 + 0.5 > f))
			{
				if (x.l != h)
				{

					std::cout << "yes" << std::endl;
					std::cout << i + 1 << std::endl;
					return 0;
				}
			}

			it = std::next(it);
		}
	}

	std::cout << "no" << std::endl;

	return 0;
}