#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#include <cstdio>

using namespace std;

const string filename = "expect";
const int inf = 1e9 + 7;

int main ()
{
    ios_base::sync_with_stdio (false);
    cin.tie (NULL);

    freopen ((filename + ".in").c_str (), "r", stdin);
    freopen ((filename + ".out").c_str (), "w", stdout);

    int n, q;

    cin >> n >> q;

    vector<pair<int, int>> xl (n + 1);

    int lust = 0;

    for (int i = 0; i < n; i++)
    {
        char c;
        int t, k;

        cin >> c >> t >> k;

        if (i != 0)
            xl[i + 1] = xl[i];

        if (c == '-')
        {
            xl[i + 1].first += k;
            xl[i].second = t - lust;
            lust = t;
        }
        else
        {
            xl[i + 1].first -= k;
            xl[i].second = t - lust;
            lust = t;
        }
    }

    vector<pair<int, int>> quer (q);

    int t = 0;

    for (auto &it : quer)
    {
        cin >> it.first;
        it.second = t++;
    }

    sort (xl.begin (), xl.end ());
    sort (quer.begin (), quer.end ());

    long long sum = 0;

    for (auto it : xl)
        sum += max (0, it.first) * (long long)it.second;

    int gov;

    for (gov = 0; xl[gov].second != 0; gov++);

    t = lower_bound (xl.begin (), xl.end (), make_pair (0, 0)) - xl.begin ();

    vector<long long> ans (quer.size ());
    vector<long long> pq (xl.size () + 1);

    for (int i = 1; i < pq.size (); i++)
        pq[i] = pq[i - 1] + xl[i - 1].second;

    for (int i = 0; i < quer.size (); i++)
    {
        if (xl[gov].first > quer[i].first)
        {
            ans[quer[i].second] = -1;

            continue;
        }

        while (t < xl.size () && xl[t].first < quer[i].first)
        {
            sum -= xl[t].first * (long long)xl[t].second;

            t++;
        }

        ans[quer[i].second] = sum - (pq.back () - pq[t]) * (long long)quer[i].first;
    }

    for (auto it : ans)
        if (it == -1)
            cout << "INFINITY" << endl;
        else
            cout << it << endl;

    return 0;
}
