#include <iostream>
#include <vector>

#include <cstdio>

using namespace std;

const string filename = "hard";

const int li = -32768, ri = 32767;

bool iscap (char c)
{
    return 'A' <= c && c <= 'Z';
}

bool issm (char c)
{
    return 'a' <= c && c <= 'z';
}

int main ()
{
    ios_base::sync_with_stdio (false);

    freopen ((filename + ".in").c_str (), "r", stdin);
    freopen ((filename + ".out").c_str (), "w", stdout);

    //vector<string> text (1);

    //cin.unsetf (ios_base::skipws);

    //while (true)
    //{
    //    char c;

    //    cin >> c;

    //    if (cin.eof ())
    //        break;

    //    text.back ().push_back (c);

    //    if (c == ' ')
    //        if (text.back ().size () > 1 && text.back ()[text.back ().size () - 2] == ' ')
    //            text.push_back ("");
    //        else if (c == ',' || c == '.' || c == '\n')
    //            text.push_back ("");
    //}

    //for (auto str : text)
    //{
    //    int pos = 0, st = 0;

    //    while (st < str.size ())
    //    {
    //        pos = st;
    //        int r;

    //        for (r = pos + 1; r < str.size () && str[r] != ' '; r++);

    //        int cap = 0, sm = 0;

    //        for (int i = pos; i < r; i++)
    //            if (iscap (str[i]))
    //                cap++;
    //            else
    //                sm++;

    //        if (cap == 1 && sm > 0)
    //            pos = r + 1;

    //        while (pos >= st && pos >= str.size () ||
    //               !(iscap (str[pos]) || issm (str[pos])))
    //               pos--;

    //        if (pos >= st)
    //        {
    //            for (int i = st; i <= pos; i++)
    //                if (iscap (str[i]))
    //                    cout << str[i];

    //            for ()

    //            st = pos + 1;
    //        }
    //        else
    //        {
    //            while (st < str.size () && (iscap (str[st]) || issm (str[st])))
    //                cout << str[st++];
    //        }

    //        while (st < str.size () && !(iscap (str[st]) || issm (str[st])))
    //            cout << str[st++];
    //    }
    //}

    cin.unsetf (ios_base::skipws);

    vector<bool> us (65536);

    while (!cin.eof ())
    {
        string str;

        while (true)
        {
            char c;

            cin >> c;

            if (cin.eof () || c == '\n')
                break;
            else
                str.push_back (c);
        }

        if (str.empty ())
            break;

        if (str.back () == '|')
            str.resize (str.size () - 3);

        int l, r;

        if (str[2] == '<')
        {
            l = li;

            sscanf (str.substr (5).c_str (), "%i", &r);
        }
        else
        {
            int pos = -1;
            for (int i = 0; i < str.size (); i++)
                if (str[i] == '&')
                {
                    pos = i;
                    break;
                }

            if (pos == -1)
            {
                r = ri;

                sscanf (str.substr (5).c_str (), "%i", &l);
            }
            else
            {
                sscanf (str.substr (5).c_str (), "%i", &l);

                while (str[pos] > '9' || str[pos] < '0')
                    pos++;

                sscanf (str.substr (pos).c_str (), "%i", &r);
            }
        }

        for (int i = l; i <= r; i++)
            us[i - li] = true;
    }

    bool f = true;

    for (int l = 0, r; l < us.size (); l = r + 1)
    {
        for (r = l; r < us.size () && us[r]; r++);

        if (l == 0 && r == us.size ())
        {
            cout << "true" << endl;

            return 0;
        }

        if (r > l)
        {
            if (f)
                f = false;
            else
                cout << " ||" << endl;

            if (l == 0)
                cout << "x <= " << r + li - 1;
            else if (r == us.size ())
                cout << "x >= " << l + li;
            else
                cout << "x >= " << l + li << " && x <= " << r + li - 1;
        }
    }

    if (f)
        cout << "false" << endl;

    return 0;
}
