import re

FILENAME = "abbreviation"

def replacer(s):
    group = s.group()
    words = group.split()
    abbr = ''
    for word in words:
        abbr += word[0]
    return "{} ({})".format(abbr, group)

def main():
    with open(FILENAME + ".in") as f:
        text = f.read()
    text = '#' + text + '#'
    text = re.sub("((?<=[^A-Za-z])([A-Z][a-z]+ )+([A-Z][a-z]+(?=[^A-Za-z])))", replacer, text)
    with open(FILENAME + '.out', 'w') as f:
        f.write(text[1:-1])

main()
