//Ural FU 2 Apex (604)

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <assert.h>
#include <ctime>
using namespace std;

typedef long long ll;

#define FILENAME "expect"

struct Event {
    int H, Len, Type, Ind;
};

vector <Event> vec;

bool cmp(Event a, Event b) {
    return (a.H < b.H);
}

ll answers[100010];

void solve() {
    int n, q;
    cin >> n >> q;
    int curX = 0;
    ll curH = 0;
    int finalH;
    for (int i = 0; i < n; i++) {
        char ch;
        Event ev;
        cin >> ch;
        int x, y;
        cin >> x >> y;
        ev.H = curH;
        ev.Ind = -1;
        ev.Len = (x - curX);
        ev.Type = 1;
        vec.push_back(ev);
        curX = x;
        if (ch == '+') {
            curH += y;
        }
        else {
            curH -= y;
        }
    }
    finalH = curH;
    int req;
    for (int i = 0; i < q; i++) {
        cin >> req;
        Event ev;
        ev.H = -req;
        ev.Ind = i;
        ev.Len = -1;
        ev.Type = 2;
        vec.push_back(ev);
    }

    sort(vec.begin(), vec.end(), cmp);

    int sz = vec.size();

    ll totalLen = 0;
    ll totalAns = 0;
    curH = vec[0].H;
    for (int i = 0; i < sz; i++) {
        if (vec[i].Type == 1) { // 
            totalAns += totalLen * abs(curH - vec[i].H);
            totalLen += vec[i].Len;
            curH = vec[i].H;
        }
        else { // 
            totalAns += totalLen * abs(curH - vec[i].H);
            curH = vec[i].H;
            if (vec[i].H <= finalH) {
                answers[vec[i].Ind] = totalAns;
            }
            else {
                answers[vec[i].Ind] = -1;
            }
        }
    }

    for (int i = 0; i < q; i++) {
        if (answers[i] >= 0) {
            printf("%lld\n", answers[i]);
        }
        else {
            printf("INFINITY\n");
        }
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);
#endif

    assert(FILENAME != "TODO");
    solve();

#ifdef LOCAL
    fprintf(stderr, "\n\n\n%.2lf ms\n", clock() * 1000.0 / CLOCKS_PER_SEC);
#endif
}