//Ural FU 2 Apex (604)

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <assert.h>
#include <ctime>
using namespace std;

typedef long long ll;
#define FILENAME "list"

const int sumLim = 3250;
const int primeLim = sumLim;

int getLen(int x)
{
    if (x == 0)
        return 1;
    int res = 0;
    while (x > 0)
    {
        x /= 10;
        ++res;
    }
    return res;
}

int getLen(vector<int> const &v)
{
    if (v.empty())
        return 0;
    int res = v.size() * 2 + 2;
    for (int i = 0; i < v.size(); ++i)
        res += getLen(v[i]);
}

vector<int> primes;
bool unprime[primeLim];
ll backpack[sumLim][500];
//vector<int> rf[sumLim][500];

void solve()
{
    for (int i = 2; i < primeLim; ++i)
    {
        if (!unprime[i])
        {
            for (ll j = (ll)i * i; j < primeLim; j += i)
                unprime[j] = true;
            primes.push_back(i);
        }
    }
    for (int i = primes.size() - 1; i >= 0; --i)
    {
        int cur = primes[i];
        int curLen = getLen(cur);
        backpack[cur][i] = curLen + 4;
        if (i != primes.size() - 1)
        {
            for (int j = 0; j < sumLim; ++j)
            {
                backpack[j][i] += backpack[j][i + 1];
                /*for (int k = 0; k < rf[j][i + 1].size(); ++k)
                rf[j][i].push_back(rf[j][i + 1][k]);*/
            }
            for (int j = cur + 1; j < sumLim; ++j)
            {
                if (backpack[j - cur][i + 1] > 0)
                {
                    backpack[j][i] = backpack[j - cur][i + 1] + curLen + 2;
                    //rf[j][i].push_back(cur);
                }
            }
        }
    }
    ll total = 0;
    for (int s = 0; s < sumLim; ++s)
    {
        ll ss = backpack[s][0];
        cout << s << ' ' << ss << endl;
        total += ss;
        if (total < 0)
            cout << s;
    }
    cout << total << endl;
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);
#endif

    assert(FILENAME != "TODO");
    solve();

#ifdef LOCAL
    fprintf(stderr, "\n\n\n%.2lf ms\n", clock() * 1000.0 / CLOCKS_PER_SEC);
#endif
}