#include <bits/stdc++.h>
using namespace std;

void go(deque<pair<int, int> > &q, int &cur, int T, long long &sum, vector<pair<int, long long> > &all, vector<int> &times)
{
    while(!q.empty())
    {
        if(cur == 0) break;
        pair<int, int> test = q.front();
        q.pop_front();
        if(cur > test.second)
        {
            cur -= test.second;
            all.push_back(make_pair(test.second, 1LL * test.second * (T - test.first)));
            times.push_back(T - test.first);
        }
        else
        {
            if(test.second > cur)
                q.push_front(make_pair(test.first, test.second - cur));
            all.push_back(make_pair(cur, 1LL * cur * (T - test.first)));
            times.push_back(T - test.first);
            cur = 0;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    //ifstream cin("expect.in");
    //ofstream cout("expect.out");
    int n, q;
    cin >> n >> q;
    vector<pair<int, long long > > all;
    vector<int> times;
    int cur = 0;
    long long w8sum = 0;
    deque<pair<int, int> > dq;
    int balance = 0;
    for(int i = 0; i < n; ++i)
    {
        char type;
        int t, k;
        cin >> type >> t >> k;
        if(type == '+')
        {
            cur += k;
            balance += k;
        }
        else
        {
            balance -= k;
            dq.push_back(make_pair(t, k));
        }
        go(dq, cur, t, w8sum, all, times);
    }
    vector<pair<int, long long> > sums(all.size());
    for(int i = (int)all.size() - 1; i >= 0; --i)
    {
        sums[i] = all[i];
        if(i + 1 != all.size())
        {
            sums[i].first += sums[i + 1].first;
            sums[i].second += sums[i + 1].second;
        }
    }
    /*for(int i = 0; i < all.size(); ++i)
    {
        cout << all[i].first << " " << times[i] << endl;
    }
    cout << endl;*/
    for(int i = 0; i < q; ++i)
    {
        int a;
        cin >> a;
        if(a + balance < 0)
        {
            cout << "INFINITY" << endl;
            continue;
        }
        if(sums.size() == 0)
        {
            cout << 0 << endl;
            continue;
        }
        int left = 0, right = (int)all.size();
        while(right - left > 1)
        {
            int m = (left + right) / 2;
            if(sums[m].first >= a) left = m;
            else right = m;
        }
        //cout << "a = " << a << "; left = " << left << endl;
        long long ans = sums[0].second;
        if(left + 1 < sums.size())
        {
            ans -= sums[left + 1].second;
            a -= sums[left + 1].first;
        }
        ans -= 1LL * a * times[left];
        cout << ans << endl;
    }
    return 0;
}










