#include <vector>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <algorithm>
#include <utility>
using namespace std;

#define mp make_pair
#define forn(i,a,b) for(int i=a;i<b;i++)

typedef long long ll;
typedef int Int;
//#define int ll

string str;

bool big(char c)
{
	return 'A' <= c&&c <= 'Z';
}

bool small(char c)
{
	return 'a' <= c&&c <= 'z';

}

bool capitalized(const string&str)
{
	if (str.size() == 1)return false;

	if (!big(str[0])) return false;

	bool was = false;
	forn(i, 1, str.size()) {
		if (!small(str[i])) {
			was = true;
			break;
		}
	}
	if (was)return false;
	return true;
}

bool is_char(char c)
{
	return small(c) || big(c);
}

void printst(const vector<string>&st)
{
	if (st.size() == 0)return;
	if (st.size() == 1) {
		cout << st[0];
		return;
	}
	for (auto&u : st) {
		cout << u[0];
	}
	cout << " ";
	cout << "(";
	bool first = true;
	for (auto&u : st) {
		if (first)first = false;
		else cout << " ";
		cout << u;
	}
	cout << ")";
}

string next_word()
{
	string ret;
	for (; is_char(cin.peek());) {
		ret += cin.get();
	}
	return ret;
}

bool nl(char c)
{
	return c == '\n' || c == '\r';
}

string skip_space(bool &res,bool&dont_add)
{
	bool was = false;
	int spaces=0;
	bool punct = false;
	string ret;
	for (;!(is_char(cin.peek())||cin.peek()==EOF);) {
		if (cin.peek() == ',' || cin.peek() == '.') {
			punct = true;
		}
		if (cin.peek() == ' ') {
			spaces++;
		}
		if (nl(cin.peek())) {
			was = true;
			ret+=cin.get();
		} else {
			ret += cin.get();
		}
	}
	res = was;
	dont_add = punct || spaces > 1;
	return ret;
}

int main()
{
#ifdef Home
	freopen("inp.txt", "r", stdin);
#else
#define FILENAME "abbreviation"
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
#endif


	for (;cin.peek()!=EOF;) {
		string qwe = next_word();
		bool NL = false;
		bool __;
		if (capitalized(qwe)) {
			vector<string> st;
			st.push_back(qwe);
			for (;;) {
				string split = skip_space(NL, __);
				if (split != " ") {
					printst(st);
					cout << split;
					break;
				} else {
					string ww = next_word();
					if (capitalized(ww)) {
						st.push_back(ww);
					} else {
						printst(st);
						cout << split;
						cout << ww;
						cout << skip_space(NL, __);
						break;
					}
				}
			}
		} else {
			cout << qwe;
			cout << skip_space(NL, __);
		}
	}

	return 0;
}