#include <vector>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <algorithm>
#include <utility>

using namespace std;

#define mp make_pair
#define forn(i,a,b) for(int i=a;i<b;i++)

typedef long long ll;
typedef int Int;
#define int ll

const int OO = 1e18;
const int N = 1e6 + 3;

#define Mod(a,b) (((a)%(b)+(b))%(b))


int n, m;

struct query {
	int b, id, ans;
	query(int b = 0, int id = 0,int ans=0) :b(b), id(id),ans(ans) {}
};

struct seg {
	int l, r, d;
	seg(int l = 0, int r = 0, int d= 0) : l(l), r(r), d(d) {}
};

Int main()
{
#ifdef Home
	freopen("inp.txt", "r", stdin);
#else
#define FILENAME "expect"
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
#endif

	cin >> n >> m;
	string tp;


	vector<seg> segs;
	int last = 0;
	int curr = 0;
	forn(i, 0, n) {
		cin >> tp;
		int t, k;
		cin >> t >> k;
		segs.push_back(seg(last, t, curr));
		if (tp[0] == '-') {
			curr -= k;
		} else {
			curr += k;
		}
		last = t;
	}
	segs.push_back(seg(last, OO,curr));

	sort(segs.begin(), segs.end(), [](seg a, seg b) {
		if (a.d != b.d) {
			return a.d < b.d;
		}
		return a.l < b.l;
	});

	vector<query> q;
	forn(i, 0, m) {
		int a;
		cin >> a;
		q.push_back(query(a, i));
	}

	sort(q.begin(), q.end(), [](query a, query b) {
		return a.b < b.b;
	});

	int j = -1;
	int sseg = 0;
	int ans = 0;
	int cd = 0;
	forn(i, 0,segs.size())  {
		cd = min(cd, segs[i].d);
	}
	for (int i = m - 1; i >= 0;i--) {

		if (sseg>=OO) {
			q[i].ans = OO;
			continue;
		}

		int d = -q[i].b;

		int l = j+1;
		for (; !(j + 1 == segs.size() || segs[j + 1].d >= d); j++) {
	/*		int k = j;
			for (; !(k + 1 == segs.size() || segs[k + 1].d != segs[j + 1].d); k++);
			int add = 0;
			forn(i, j + 1, k + 1) {
				add += segs[i].r - segs[i].l;
			}
			ans += (sseg+add)*(segs[k].d-cd);
			cd = segs[k].d;
			j = k;
			sseg += add;*/
	/*		if (sseg >= OO) {
				break;
			}*/
		}

		int add = 0;
		for (int i = l; i <= j;i++) {
			ans += (segs[i].r-segs[i].l)*(d-segs[i].d);
			add += segs[i].r - segs[i].l;
		}
		ans += sseg*(d - cd);
		cd = d;
		sseg += add;

		if (sseg >= OO) {
			q[i].ans = OO;
			continue;
		}



		q[i].ans = ans;
	}

	sort(q.begin(), q.end(), [](query a, query b) {
		return a.id < b.id;
	});

	forn(i, 0, m) {
		if (q[i].ans >= OO) {
			cout << "INFINITY" << endl;
		} else {
			cout << q[i].ans << endl;
		}
	}

	return 0;
}