#include <vector>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <algorithm>
#include <utility>
using namespace std;
const int OO = 1e9;

#define mp make_pair
#define forn(i,a,b) for(int i=a;i<b;i++)

typedef long long ll;
typedef int Int;
//#define int ll

bool sign(char c)
{
	return c == '<' || c == '>';
}

bool is_num(char c)
{
	return '0' <= c&&c <= '9';
}

int num()
{
	int ret = 0;
	int sign = 1;
	if (cin.peek() == '-') {
		cin.get();
		sign *= -1;
	}
	for (; is_num(cin.peek());) {
		char c = cin.get();
		ret = ret * 10 + c - '0';
	}
	return ret*sign;;
}

void eat(int cnt)
{
	forn(i, 0, cnt) {
		cin.get();
	}
}

void next_segment(int &l, int&r,bool &last)
{
	eat(2);

	r = OO;
	l = -OO;

	if (cin.peek() == '<') {
		eat(3);
		r = num();
		eat(1);
	} else {
		eat(3);
		l = num();
		eat(1);
	}


	if (cin.peek() == '&') {
		eat(5);
		if (cin.peek() == '<') {
			eat(3);
			r = num();
			eat(1);
		} else {
			eat(3);
			l = num();
			eat(1);
		}
	}

	if (cin.peek() == '|') {
		eat(2);
	} else {
		last = true;
	}
	if (cin.peek() == '\r') {
		eat(1);
	}
	if (cin.peek() == '\n') {
		eat(1);
	}
}

struct evt {
	int tp; // 0 - open, 1 - close
	int id;
	int x;
	evt(int tp = 0, int id = 0,int x=0) : tp(tp), id(id),x(x) {}
	bool operator<(evt o) const
	{
		if (x != o.x)return x < o.x;
		return tp < o.tp;
	}
};

int main()
{
#ifdef Home
	freopen("inp.txt", "r", stdin);
#else
#define FILENAME "hard"
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
#endif


	int l, r;
	bool last = false;
	bool was = false;

	vector<pair<int, int> > segs;
	int cnt = 0;
	int total = 0;
	for (;;) {
		next_segment(l, r, last);
		if (r != OO)r++;
		total++;
		if (l > r) {
			cnt++;
		} else {
			segs.push_back(mp(l, r));
		}
		if (last) break;
	}

	if (cnt==total) {
		cout << "false" << endl;
		return 0;
	}

	vector<evt> e;
	forn(i, 0, segs.size()) {
		e.push_back(evt(0,i,segs[i].first));
		e.push_back(evt(1, i, segs[i].second));
	}

	sort(e.begin(), e.end());

	vector<pair<int, int>> res;
	int bal = 0;
	int L = -OO;
	forn(i, 0, e.size()) {
		evt&curr = e[i];
		if (curr.tp == 0) {
			bal++;
			if (bal == 1) {
				L = curr.x;
			}
		} else {
			bal--;
			if (bal == 0) {
				res.push_back(mp(L, curr.x));
			}
		}
	}

	if (res[0].first <= -32768&&res[0].second>=32767) {
		cout << "true" << endl;
	} else {
		forn(i, 0, res.size()) {
			int l = res[i].first;
			int r = res[i].second;
			if (r != OO)r--;
			if (l == -OO) {
				printf("x <= %d", r);
			} else if (r == OO) {
				printf("x >= %d", l);
			} else {
				printf("x >= %d && x <= %d", l,r);
			}
			if (i != (int)res.size() - 1) {
				printf(" ||\n");
			}
		}
	}

	return 0;
}