#include <iostream>
#include <algorithm>
#include <string> 
#include <iomanip>

using namespace std;

#define REP(i, n) for (int i = 0; i < n; ++i)
#define DB(x) cerr << #x << ": " << x << endl;

int main() {
  freopen("foreign.in", "r", stdin); 
  freopen("foreign.out", "w", stdout); 
  string s;
  cin >> s;
  cout.precision(12);
  cout << fixed;
  int n = s.length();
  reverse(s.begin(), s.end());
  long double dpSum = 0;
  long double wSum = 0;
  long double dpLast = 0;
  REP(i, n) {
    wSum += (s[i] == 'W') * (i + 1);
    long double dpVal = 0;
    if (s[i] == 'C') {
      dpVal = wSum + dpSum;
    } else {
      dpVal = -wSum + dpSum;
      dpVal += (i + 2) * (i + 1) / 2;
    }
    dpVal /= (i + 1);
    dpSum += dpVal;
    dpLast = dpVal;
  }
  cout << dpLast << endl;
	return 0;
}
