#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
using namespace std;

#define TASK "expect" 
#define int64 long long
#define mp make_pair

const int64 INF = 6e18;

const int N = 200010;
int n, q, t[N];
int64 ans[N];
int64 sa[N], sb[N];
pair <int, int> queries[N];
vector <pair<int64, int> > d;


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	scanf("%d%d\n", &n, &q);
	sa[0] = 0;
	sb[0] = 0;
	for (int i = 1; i <= n; ++i) {
		char ch;
		int tc, k;
		scanf("%c %d%d\n", &ch, &tc, &k);
		sa[i] = sa[i - 1];
		sb[i] = sb[i - 1];
		t[i] = tc;
		if (ch == '+') sa[i] += k;
		else sb[i] += k;
	}
	for (int i = 1; i <= n; i++) d.push_back(mp(sb[i] - sa[i], i));
	sort(d.begin(), d.end());
	for (int i = 1; i <= q; i++)
	{
		int x;
		scanf("%d", &x);
		queries[i] = mp(x, i);
	}
	sort(queries + 1, queries + q + 1);
	int64 res = 0;
	int64 sumDT = 0;
	int64 x = sb[n] - sa[n];
	for (int i = 1; i <= n; i++)
	{
		if (sb[i] - sa[i] - x >= 0)
		{
			res += 1ll * (sb[i] - sa[i] - x) * (t[i + 1] - t[i]);
			sumDT += t[i + 1] - t[i];
		}
	}
	int p = 0;
	while (p < d.size() && d[p].first < x) p++;
	for (int i = 1; i <= q; i++)
	{
		if (queries[i].first < x) ans[queries[i].second] = INF;
		else if (queries[i].first == x) ans[queries[i].second] = res;
		else
		{
			int y = queries[i].first;
			while (p < d.size() && d[p].first < y)
			{
				int j = d[p].second;
				res -= 1ll * (sb[j] - sa[j] - x) * (t[j + 1] - t[j]);
				sumDT -= t[j + 1] - t[j];
				p++;
			}
			res -= sumDT;
			ans[queries[i].second] = res;
			x = y;
		}
	}
	for (int i = 1; i <= q; i++)
	{
		if (ans[i] == INF) cout << "INFINITY" << endl;
		else cout << ans[i] << endl;
	}
	return 0;
}