#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
using namespace std;

#define TASK "foreign" 

const int N = 1000010;
int n, sc[N], sw[N];
string s;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	cin >> s;
	int n = s.length();
	if (s[0] == 'C')
	{
		sc[0] = 1;
	}
	else
	{
		sw[0] = 1;
	}
	for (int i = 1; i < n; i++)
	{
		sc[i] = sc[i - 1];
		sw[i] = sw[i - 1];
		if (s[i] == 'C') sc[i]++; 
		else sw[i]++;
	}
	double sumC = 0, sumW = 0;
	double ans = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		sumC += sc[i];
		sumW += sw[i];
		int tmpC = 0, tmpW = 0;
		if (i > 0)
		{
			tmpC = sc[i - 1];
			tmpW = sw[i - 1];
		}
		if (s[i] == 'C') ans = (sumW - 1.0 * (n - i) * tmpW) / (n - i);
		else ans = (sumC - 1.0 * (n - i) * tmpC) / (n - i);
		sumW += ans;
		sumC += ans;
	}
	cout << fixed << setprecision(15) << ans;
	return 0;
}