#define FFFF "expect"

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define fore(i, l, r) for (int i = int(l); i < int(r); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define pb push_back
#define mp make_pair
#define x first
#define y second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X abs(const X &a) {return a < 0 ? -a : a;}
template<typename X> inline X sqr(const X &a) {return a * a;}

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(ld(-1));

mt19937 mt(time(NULL));

const int N = int(1e5) + 5;
int n, q;
char buf[N][2];
int t[N], ks[N];
pt tq[N];
li ans[N];

inline bool read() {
	if (!(cin >> n >> q))
		return false;
	forn(i, n) {
		assert(scanf("%s%d%d", buf[i], &t[i], &ks[i]) == 3);
	}
	forn(i, q) {
		assert(scanf("%d", &tq[i].x) == 1);
		tq[i].y = i;
	}
	return true;
}

inline void solve() {
	li sumb = 0;
	li sump = 0;
	
	li cp = 0;
	li cb = 0;
	
	queue <pt> tp, tb;
	
	multiset <pt> qq;
	queue <pt> qp;
	forn(i, n) {
		if (buf[i][0] == '+') {
			tb.push(mp(t[i], ks[i]));
		} else {
			tp.push(mp(t[i], ks[i]));
		}
		
		while (sz(tb) && sz(tp)) {
			pt &b = tb.front();
			pt &p = tp.front();
			
			int take = min(b.y, p.y);
			b.y -= take;
			p.y -= take;
			
			if (b.x >= p.x) {
				qq.insert(mp(b.x, take));
				sumb += take * 1ll * b.x;
				cb += take;
				cp += take;
				sump += take * 1ll * p.x;
				qp.push(mp(p.x, take));
			}
			
			if (!b.y)
				tb.pop();
			if (!p.y)
				tp.pop();
		}
	}	
	
	while (sz(tp)) {
		qp.push(tp.front());
		cp += tp.front().y;
		sump += tp.front().x * 1ll * tp.front().y;
		tp.pop();
	}
	
//	cerr << cp << 
	
	int prev = 0;
	sort(tq, tq + q);
	forn(i, q) {
		int delta = tq[i].x - prev;
		while (sz(qp) && delta) {
			int take = min(qp.front().y, delta);
			qp.front().y -= take;
			cp -= take;
			delta -= take;
			sump -= take * 1ll * qp.front().x;
			if (qp.front().y == 0)
				qp.pop();
		
		
    		while (sz(qq) && sz(qp) && qp.front().x >= qq.begin()->x) {
    			pt b = *qq.begin(); qq.erase(qq.begin());
    			
    			int take = min(qp.front().y, b.y);
    			cp -= take;
    			cb -= take;
    			sump -= take * 1ll * qp.front().x;
    			qp.front().y -= take;
    			if (qp.front().y == 0)
    				qp.pop();
    			sumb -= take * 1ll * b.x;
    			b.y -= take;
    			if (b.y != 0)
    				qq.insert(b);
    		}
		}
		
    		while (sz(qq) && sz(qp) && qp.front().x >= qq.begin()->x) {
    			pt b = *qq.begin(); qq.erase(qq.begin());
    			
    			int take = min(qp.front().y, b.y);
    			cp -= take;
    			cb -= take;
    			sump -= take * 1ll * qp.front().x;
    			qp.front().y -= take;
    			if (qp.front().y == 0)
    				qp.pop();
    			sumb -= take * 1ll * b.x;
    			b.y -= take;
    			if (b.y != 0)
    				qq.insert(b);
    		}		
		
    	while (cb > cp) {
    		li take = min((li) qq.rbegin()->y, cb - cp);
    		pt p = *(--qq.end());
    		qq.erase(--qq.end());
    		p.y -= (int) take;
    		cb -= take;
    		sumb -= take * p.x;
    		if (p.y)
    			qq.insert(p);
    	}
    	
    /*	cerr << "---------\n";
    	cerr << cb << " " << cp << endl;
    	cerr << sumb << " " << sump << endl;*/

    	
  /*  cerr << tq[i].x << endl;
	cerr << cb << " " << sumb << endl;
	cerr << cp << " " << sump << endl;*/

    		
    	if (cb < cp) {
    		ans[tq[i].y] = -1;
    	} else {
    		ans[tq[i].y] = sumb - sump;
    	}
		prev = tq[i].x;
	}
	
	forn(i, q) {
		if (ans[i] == -1) {
			puts("INFINITY");
		}
		else {
			printf("%lld\n", ans[i]);
		}
	}
}

int main() {
#ifdef SU2_PROJ
	assert(freopen("input.txt", "r", stdin));
	assert(freopen("output.txt", "w", stdout));
#else
	assert(freopen(FFFF ".in", "r", stdin));
	assert(freopen(FFFF ".out", "w", stdout));
#endif
	
	cout << setprecision(25) << fixed;
	cerr << setprecision(10) << fixed;
	
	assert(read());
	solve();

#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif
	return 0;
}