#define FFFF "hard"

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define fore(i, l, r) for (int i = int(l); i < int(r); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define pb push_back
#define mp make_pair
#define x first
#define y second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X abs(const X &a) {return a < 0 ? -a : a;}
template<typename X> inline X sqr(const X &a) {return a * a;}

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(ld(-1));

mt19937 mt(time(NULL));

const int N = 70000;
const int HALF = 35000;
const int M = 5000;

char s[55];

int _cnt[N], *cnt = _cnt + HALF;
vector<pt> v[M];
int n;

int getNum(char *s) {
	string ss = string(s);
	istringstream iss(ss);
	int x;
	iss >> x;
	return x;
}

inline bool read() {
	int lastSign = 1;
	int lastNum = 0;
	n = 1;
	while (scanf("%s", s) == 1) {
		/*if (s[0] == 'a') {
			break;
		}*/
		if (s[0] == 'x' || strlen(s) == 0) {
			continue;
		}
		if (s[0] == '>') {
			lastSign = 1;
		} else if (s[0] == '<') {
			lastSign = -1;
		} else if (s[0] == '&') {
			v[n - 1].pb(mp(lastSign, lastNum));
		} else if (s[0] == '|') {
			v[n - 1].pb(mp(lastSign, lastNum));
			++n;
		} else {
			lastNum = getNum(s);
		}
	}
	v[n - 1].pb(mp(lastSign, lastNum));
	assert(sz(v[n - 1]) == 1 || sz(v[n - 1]) == 2);
	return true;
}

const int MAX_POS = 32767;
const int MIN_NEG = -32768;

void pr(int from, int to) {
	if (from == MIN_NEG) {
		printf("x <= %d", to);
	} else if (to == MAX_POS) {
		printf("x >= %d", from);
	} else {
		printf("x >= %d && x <= %d", from, to);
	}
}

inline void solve() {
	memset(_cnt, 0, sizeof _cnt);
	forn(i, n) {
		if (sz(v[i]) == 1) {
			pt p = v[i][0];
			if (p.x == 1) {
				cnt[p.y]++;
				cnt[MAX_POS + 1]--;
			} else {
				cnt[MIN_NEG]++;
				cnt[p.y + 1]--;
			}
		} else {
			assert(sz(v[i]) == 2);
			pt p = v[i][0];
			pt q = v[i][1];
			if (p.x == 1) {
				if (q.x == 1) {
					int yy = max(p.y, q.y);
					cnt[yy]++;
					cnt[MAX_POS + 1]--;
				} else {
					if (p.y > q.y) {
						continue;
					}
					cnt[p.y]++;
					cnt[q.y + 1]--;
				}
			} else {
				if (q.x == -1) {
					int yy = min(p.y, q.y);
					cnt[MIN_NEG]++;
					cnt[yy + 1]--;
				} else {
					if (q.y > p.y) {
						continue;
					}
					cnt[q.y]++;
					cnt[p.y + 1]--;
				}	
			}
		}
	}
	bool eq = true;
	for (int i = MIN_NEG + 1; i <= MAX_POS; ++i) {
		cnt[i] += cnt[i - 1];
	}
	for (int i = MIN_NEG; i <= MAX_POS; ++i) {
		if (cnt[i] > 0) {
			cnt[i] = 1;
		}
	}
	for (int i = MIN_NEG + 1; i <= MAX_POS; ++i) {
		if (cnt[i] != cnt[i - 1]) {
			eq = false;
		}
	}
	if (eq) {
		if (cnt[MIN_NEG]) {
			cout << "true" << endl;
		} else {
			cout << "false" << endl;
		}
		return;
	}
	bool firstTime = true;
	for (int beg = MIN_NEG; beg <= MAX_POS; ) {
		if (cnt[beg]) {
			int end = beg + 1;
			while (end <= MAX_POS && cnt[end]) {
				++end;
			}
			if (firstTime) {
				firstTime = false;
			} else {
				printf(" ||\n");
			}
			pr(beg, end - 1);
			beg = end;
		} else {
			++beg;
		}
	}
	puts("");
}

int main() {
#ifdef SU2_PROJ
	assert(freopen("input.txt", "r", stdin));
	assert(freopen("output.txt", "w", stdout));
#else
	assert(freopen(FFFF ".in", "r", stdin));
	assert(freopen(FFFF ".out", "w", stdout));
#endif
	
	cout << setprecision(25) << fixed;
	cerr << setprecision(10) << fixed;
	
	assert(read());
	solve();

#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif
	return 0;
}