#define FFFF "jenga"

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define fore(i, l, r) for (int i = int(l); i < int(r); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define pb push_back
#define mp make_pair
#define x first
#define y second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X abs(const X &a) {return a < 0 ? -a : a;}
template<typename X> inline X sqr(const X &a) {return a * a;}

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(ld(-1));

mt19937 mt(time(NULL));

const int N = 10 * 1000 + 13;
int n, w, h, m;

inline bool read() {
	if (scanf ("%d%d%d%d", &n, &w, &h, &m) != 4)
		return false;

	return true;
}

int cnt[N];
li sumX[N], sumY[N];
vector<int> dels[N];

int used[N], u;

inline bool isOk ()
{
	li curSumX = 0, curSumY = 0;
	li curCnt = 0;
	
	for (int i = h - 1; i >= 0; i--)
	{
		if (curCnt > 0)
		{
			if (sz(dels[i]) == n)
				return false;
				
			u++;
			forn (j, sz(dels[i]))
				used[ dels[i][j] ] = u;
				
			int minI = -1, maxI = -1;
			forn (j, n)
				if (used[j] != u)
				{
					minI = j;
					break;
				}
				
			ford(j, n)
				if (used[j] != u)
				{
					maxI = j;
					break;
				}
				
			assert(minI != -1 && maxI != -1);
			
			int x1, y1, x2, y2;
			if (i & 1)
			{
				y1 = 0, y2 = w * n;
				x1 = minI * w, x2 = (maxI + 1) * w;				
			}
			else
			{
				x1 = 0, x2 = w * n;
				y1 = minI * w, y2 = (maxI + 1) * w;
			}
			
			if (!(x1 * curCnt < curSumX && curSumX < x2 * curCnt))
				return false;
			if (!(y1 * curCnt < curSumY && curSumY < y2 * curCnt))
				return false;				
		}
		
		curCnt += cnt[i];
		curSumX += sumX[i];
		curSumY += sumY[i];
	}
	
	return true;
}

inline void solve() {
	li sumx0 = 0, sumy0 = 0;
	li sumx1 = 0, sumy1 = 0;
	forn (i, n)
	{
		sumx0 += w * n;
		sumy0 += w * (2 * i + 1); 
		
		sumy1 += w * n;
		sumx1 += w * (2 * i + 1); 		
	}
	
	forn (i, h)
	{
		cnt[i] = 2 * n;
		
		if (i & 1)
		{
			sumX[i] = sumx1;
			sumY[i] = sumy1;
		}
		else
		{
			sumX[i] = sumx0;
			sumY[i] = sumy0;
		}
		
		dels[i].clear();
	}
		
	forn (i, m)
	{
		int l, k;
		assert(scanf ("%d%d", &l, &k) == 2);
		
		l--, k--;
		
		dels[l].pb(k);
		cnt[l] -= 2;
		
		if (l & 1)
		{
			sumY[l] -= w * n;
			sumX[l] -= (2 * k + 1) * w;			
		}
		else
		{
			sumX[l] -= w * n;
			sumY[l] -= (2 * k + 1) * w;
		}
		
		if (!isOk())
		{
			puts("yes");
			printf ("%d\n", i + 1);
			return;
		}
	}
	
	puts("no");
}

int main() {
#ifdef SU2_PROJ
	assert(freopen("input.txt", "r", stdin));
	assert(freopen("output.txt", "w", stdout));
#else
	assert(freopen(FFFF ".in", "r", stdin));
	assert(freopen(FFFF ".out", "w", stdout));
#endif
	
	cout << setprecision(25) << fixed;
	cerr << setprecision(10) << fixed;
	
	assert(read());
	solve();

#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif
	return 0;
}