#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>
#include <cstring>

using namespace std;


#define fst first
#define snd second
#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back

template<typename T>
T abs(T x) {
	return x > 0 ? x : -x;
}

template<typename T>
T sqr(T x) {
	return x * x;
}

template<typename U, typename V>
ostream& operator << (ostream &s, const pair<U, V> &x) {
	return s << "(" << x.fst << ", " << x.snd << ")";
}

template<typename T>
ostream& operator << (ostream &s, const vector<T> &x) {
	s << "[";
	for (auto y : x) {
		s << y << ", ";
	}
	s << "]";
	return s;
}



int main() {
#ifdef LOCAL
	freopen("a.in", "r", stdin);
#else
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
#endif


	const int lb = -32768, ub = 32767;

	vector<pair<int, int>> a;

	string s;
	while (getline(cin, s)) {
		int cnt = 0;
		for (char c : s) {
			cnt += c == '<' || c == '>';
		}

		if (cnt == 2) {
			int l = 1 << 20, r = 1 << 20;

			for (int i = 0; i < s.size(); i++) {
				if (!isdigit(s[i]) && s[i] != '-') {
					continue;
				}

				int j = i;
				int x = 0;
				bool neg = false;
				while (j < s.size() && (s[j] == '-' || isdigit(s[j]))) {
					if (isdigit(s[j])) {
						x = x * 10 + s[j] - '0';
					}
					neg |= s[j] == '-';
					j++;
				}

				if (neg) {
					x = -x;
				}

				if (l == (1 << 20)) {
					l = x;
				}
				else {
					r = x;
				}

				i = j - 1;
			}

			if (l < lb || r > ub) {
				cout << "false" << endl;
				return 0;
			}

			if (l > r) {
				cout << "false" << endl;
				return 0;
			}
			a.pb(mp(l, r));
		}
		else {
			bool gr = false;
			int x = 0;
			for (int i = 0; i < s.size(); i++) {
				if (s[i] == '>') {
					gr = true;
				}

				if (!(isdigit(s[i]) || s[i] == '-')) {
					continue;
				}

				int j = i;
				
				bool neg = false;
				while (j < s.size() && (s[j] == '-' || isdigit(s[j]))) {
					if (isdigit(s[j])) {
						x = x * 10 + s[j] - '0';
					}
					neg |= s[j] == '-';
					j++;
				}

				if (neg) {
					x = -x;
				}

				i = j - 1;
			}


			if (gr) {
				a.pb(mp(x, ub));

				if (x > ub) {
					cout << "false" << endl;
					return 0;
				}
			}
			else {
				if (x < lb) {
					cout << "false" << endl;
					return 0;
				}
				a.pb(mp(lb, x));
			}
		}
			
		
	}


 
	sort(a.begin(), a.end());

	vector<pair<int, int>> ans;

	for (int i = 0; i < a.size(); i++) {
		int j = i;
		int r = a[i].snd;
		while (j < a.size() && a[j].fst <= r + 1) {
			r = max(r, a[j].snd);
			j++;
		}

		ans.pb(mp(a[i].fst, r));
		i = j - 1;
	}

	if (ans.size() == 1 && ans[0] == mp(lb, ub)) {
		cout << "true" << endl;
	}
	else {
		for (int i = 0; i < ans.size(); i++) {
			auto x = ans[i];
			if (x.fst == lb) {
				cout << "x <= " << x.snd;
			}
			else if (x.snd == ub) {
				cout << "x >= " << x.fst;
			}
			else {
				cout << "x >= " << x.fst << " && x <= " << x.snd;
			}

			if (i != ans.size() - 1) {
				cout << " ||";
			}

			cout << endl;
		}
	}
	

	return 0;
}