#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>
#include <cstring>

using namespace std;


#define fst first
#define snd second
#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back

template<typename T>
T abs(T x) {
	return x > 0 ? x : -x;
}

template<typename T>
T sqr(T x) {
	return x * x;
}

template<typename U, typename V>
ostream& operator << (ostream &s, const pair<U, V> &x) {
	return s << "(" << x.fst << ", " << x.snd << ")";
}

template<typename T>
ostream& operator << (ostream &s, const vector<T> &x) {
	s << "[";
	for (auto y : x) {
		s << y << ", ";
	}
	s << "]";
	return s;
}

/////////////////////////////////////////////////

const int maxn = 5005;
int l[maxn], r[maxn], cnt[maxn], sum[maxn];
bool used[maxn][maxn];

int main() {
#ifdef LOCAL
	freopen("a.in", "r", stdin);
#else
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
#endif

	int n, w;
	cin >> n >> w;
	int h, m;
	cin >> h >> m;
	ll all = 0;
	for (int i = 1; i <= n; i++) {
		all += i * 2 - 1;
	}
	for (int i = 1; i <= h; i++) {
		cnt[i] = n;
		l[i] = 1;
		r[i] = n;
		sum[i] = all;
	}
	for (int t = 1; t <= m; t++) {
		int level, k;
		cin >> level >> k;
		cnt[level]--;
		sum[level] -= k * 2 - 1;
		used[level][k] = true;
		while (l[level] <= n && used[level][l[level]]) {
			l[level]++;
		}
		while (r[level] >= 1 && used[level][r[level]]) {
			r[level]--;
		}
		ll cursum = 0;
		ll c = 0;
		for (int i = level + 1; i <= h; i++) {
			if ((i - level) & 1) {
				cursum += n * cnt[i];
			}
			else {
				cursum += sum[i];
			}
			c += cnt[i];
		}
		//cout << cursum << " " << c << "\n";
		if (c == 0) {
			continue;
		}
		ll lower = (l[level] - 1) * 2ll * c, upper = (r[level]) * 2ll * c;
		if (cursum > lower && cursum < upper) {
			continue;
		}
		cout << "yes\n" << t << "\n";
		return 0;
	}
	cout << "no\n";

	return 0;
}