#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:100000000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <sstream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <list>
#include <iomanip>
#include <climits>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef std::pair<int, int> pii;
typedef std::pair<ll, ll> pll;
typedef std::pair<double, double> pdd;

#define fori(N) for(int i = 0;i<(N);i++)
#define fori1(N) for(int i = 1;i<=(N);i++)
#define forj(N) for(int j = 0;j<(N);j++)
#define forj1(N) for(int j = 1;j<=(N);j++)
#define fork(N) for(int k = 0;k<(N);k++)
#define fork1(N) for(int k = 1;k<=(N);k++)
#define mp make_pair

#define File "abbreviation"
using namespace std;

string s;
bool isWord[200];
int wordEnd[200];
bool isCapitalised[200];
bool isSmall[200];
int len;

void printAbbrv(int index, bool first) {
	if (!isCapitalised[index] || (!first && index > 0 && s[index - 1] != ' '))
		return;
	cout << s[index];
	printAbbrv(wordEnd[index] + 1, false);
}

int printFull(int index, bool first) {
	if (!isCapitalised[index] || (!first && index > 0 && s[index - 1] != ' '))
		return index - 1;
	if (!first)
		cout << ' ';
	for (int i = index; i < wordEnd[index]; i++) {
		cout << s[i];
	}
	return printFull(wordEnd[index] + 1, false);
}

void walk(int &index) {
	if (!isCapitalised[index]) {
		cout << s[index++];
		return;
	}

	int nnext = wordEnd[index];
	if (s[nnext] != ' ' || !isCapitalised[nnext + 1]) {
		cout << s[index++];
		return;
	}

	printAbbrv(index, true);
	cout << " (";
	index = printFull(index, true);
	cout << ")";
}

int main() {
#if defined(_DEBUG) || defined(_RELEASE)
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	freopen(File".in", "r", stdin); freopen(File".out", "w", stdout);
#endif

	while (getline(cin, s)) {
		//cout << '"' << s << '"' << endl;

		fori(200) isSmall[i] = isCapitalised[i] = false;

		len = s.length();
		int index = len;

		for (int i = len - 1; i >= 0; i--) {
			isWord[i] = (s[i] >= 'A' && s[i] <= 'Z') || (s[i] >= 'a' && s[i] <= 'z');
			if (!isWord[i])
				index = i;
			wordEnd[i] = index;
		}

		for (int i = len - 1; i >= 0; i--) {
			if (isWord[i]) {
				if (s[i] >= 'a' && s[i] <= 'z') {
					isSmall[i] = (wordEnd[i] == i + 1) || isSmall[i + 1];
				}
				if (s[i] >= 'A' && s[i] <= 'Z') {
					isCapitalised[i] = (i == 0 || !isWord[i - 1]) && isSmall[i + 1];
				}
			}
		}

		index = 0;
		while (index < len) {
			walk(index);
		}
			cout << "\n";
	}

	return 0;
}