#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:100000000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <sstream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <list>
#include <iomanip>
#include <climits>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef std::pair<int, int> pii;
typedef std::pair<ll, ll> pll;
typedef std::pair<double, double> pdd;

#define fori(N) for(int i = 0;i<(N);i++)
#define fori1(N) for(int i = 1;i<=(N);i++)
#define forj(N) for(int j = 0;j<(N);j++)
#define forj1(N) for(int j = 1;j<=(N);j++)
#define fork(N) for(int k = 0;k<(N);k++)
#define fork1(N) for(int k = 1;k<=(N);k++)
#define mp make_pair

#define File "hard"
using namespace std;

double ans[1010000];
int goodsum[1010000];
int badsum[1010000];

int cnt[70000];

bool possible = true;

void addInterval(int s, int e) {
	if (s > e) {
		possible = false;
		return;
	}
	cnt[s]++;
	cnt[e + 1]--;
}

bool shouldBeTrue[70000];

int main() {
#if defined(_DEBUG) || defined(_RELEASE)
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	freopen(File".in", "r", stdin); freopen(File".out", "w", stdout);
#endif

	char x;
	string comp1;
	int n1;
	string op;
	string comp2;
	int n2;

	while (true) {
		cin >> x >> comp1 >> n1;
		n1 += 32768;
		if (!(cin >> op)) {
			if (comp1[0] == '>')
				addInterval(n1, 65535);
			else
				addInterval(0, n1);
			break;
		}
		if (op[0] == '|') {
			if (comp1[0] == '>')
				addInterval(n1, 65535);
			else
				addInterval(0, n1);
			continue;
		}
		cin >> x >> comp2 >> n2;

		n2 += 32768;
		addInterval(n1, n2);

		if (!(cin >> op))
			break;
	}

	if (!possible) {
		cout << "false" << endl;
		return 0;
	}

	int ccnt = 0;
	bool allTrue = true;
	for (int i = 0; i < 65536; i++) {
		ccnt += cnt[i];
		shouldBeTrue[i] = ccnt > 0;
		allTrue &= shouldBeTrue[i];
	}

	if (allTrue) {
		cout << "true" << endl;
		return 0;
	}

	int start = 0;
	bool printedAnything = false;
	while (start < 65536) {
		while (start < 65536 && !shouldBeTrue[start])
			start++;
		if (start >= 65536)
			break;
		int endd = start;
		while (endd < 65536 && shouldBeTrue[endd + 1])
			endd++;
		if (printedAnything) {
			cout << " ||\n";
		}
		if (start == 0) {
			cout << "x <= " << (endd - 32768);
		}
		else if (endd >= 65535) {
			cout << "x >= " << (start - 32768);
		}
		else {
			cout << "x >= " << (start - 32768) << " && x <= " << (endd - 32768);
		}
		printedAnything = true;
		start = endd + 1;
	}

	return 0;
}