#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
bool isUpper(char t) {
	return t >= 'A' && t <= 'Z';
}
bool isLower(char t) {
	return t >= 'a' && t <= 'z';
}
bool isAlpha(char t) {
	return isUpper(t) || isLower(t);
}
bool isF(const std::string &s) {
	int cnt = 0;
	bool flag = false;
	for (auto &e : s)
		if (isUpper(e))
			cnt++;
		else flag = true;
		return flag && cnt == 1 && isUpper(s[0]);
}
bool isR(const std::string &s) {
	int cnt = 0;
	for (int i = 0; i < (int)s.size(); i++) {
		if (s[i] == ' ') cnt++;
		else return false;
	}
	return cnt == 1;
}
int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	std::string text;
	while (std::getline(std::cin, text)) {
		std::string tmp;
		bool st = true;
		std::vector <std::string> word;
		std::vector <std::string> r;
		text.push_back('#');
		for (auto &e : text) {
			if (st) {
				if (isAlpha(e)) {
					tmp.push_back(e);
				}
				else if (e == '#') {
					word.push_back(tmp);
					break;
				} else {
					word.push_back(tmp);
					tmp.clear();
					st = !st;
					tmp.push_back(e);
				}
			}
			else {
				if (isAlpha(e)) {
					r.push_back(tmp);
					tmp.clear();
					st = !st;
					tmp.push_back(e);
				} else if (e == '#') {
					word.push_back(tmp);
					break;
				} else {
					tmp.push_back(e);
				}
			}
		}
		std::vector <std::pair <int, std::string> > abr;
		for (int i = 0; i < (int)word.size(); i++) {
			if (isF(word[i])) {
				int j = i + 1;
				while (j < (int)word.size() && isF(word[j]) && isR(r[j - 1])) {
					j++;
				}
				j--;
				if (j - i > 0) {
					abr.push_back(std::make_pair(i, ""));
					for (int k = i; k <= j; k++) {
						abr.back().second.push_back(word[k][0]);
					}
					word[i].insert(word[i].begin(), '(');
					word[i].insert(word[i].begin(), ' ');
					word[j].push_back(')');
					i = j;
				}
			}
		}
		for (int i = 0, j = 0; i < (int)word.size(); i++) {
			if (j < (int)abr.size()) {
				if (i == abr[j].first) {
					std::cout << abr[j].second;
					j++;
				}
			}
			std::cout << word[i];
			if (i < (int)r.size()) std::cout << r[i];
		}
		std::cout << std::endl;
	}
}