#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <string>
#include <list>
#include <sstream>

using namespace std;

void solve();
void solve2();
int main()
{
	solve();
}
#define int long long

bool big(char c)
{
	return isalpha(c) && isupper(c);
}
bool small(char c)
{
	return isalpha(c) && islower(c);
}
string s; 
int n;
bool good(int pos)
{
	if (!big(s[pos]))
		return false;
	pos++;
	if (pos == n ||!small(s[pos]))
		return false;
	
	while (pos < n && small(s[pos]))
		pos++;
	if (pos < n && big(s[pos]))
		return false;
	return true;
}
void solve()
{
#ifndef HOME
	string task = "abbreviation";
	ifstream cin(task + ".in");
	ofstream cout(task + ".out");
#else
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#endif

	while (getline(cin, s))
	{
		string res = "";
		string abb = "";
		n = s.size();
		for (int i = 0; i < n; i++)
		{
			if (good(i))
			{
				abb += s[i];
				res += s[i];
				i++;
				while (i < n && small(s[i]))
				{
					res += s[i];
					i++;
				}
				
				if (i < n - 1 && s[i] == ' ' && good(i+1))
				{
					res += s[i];
					continue;
				}
				else
				{

					i--;
					if (abb.size() == 1)
						cout << res;
					else
						cout << abb << " (" << res << ")";
					res = "";
					abb = "";
				}
			}
			else
			{
				abb = "";
				res = "";
				bool ok = false;
				while (i<n&& (big(s[i])||small(s[i])))
				{
					cout << s[i];
					i++;
				}
				cout << s[i];
				
			}
		}
		cout << endl;
	}





	cout << endl;
#ifdef HOME
	system("pause");
#endif

}


void solve2()
{
#ifndef HOME
	string task = "hard";
	ifstream cin(task + ".in");
	ofstream cout(task + ".out");
#else
	ifstream cin("input.txt");
#endif

	
	bool isleft = false,
		isright = false;
	int left = -1,
		right = -1;

	vector <pair <int, int> > a;
	while (1)
	{
		string s;
		cin >> s;

		if (s.find("&&") != string::npos)
		{
			int p = s.find(">=") + 3;
			string n1;
			while ('0' <= s[p] && s[p] <= '9')
				n1 += s[p++];

			p = s.find("<=") + 3;
			string n2;
			while ('0' <= s[p] && s[p] <= '9')
				n2 += s[p++];

			int l, r;

			stringstream ss;
			ss << n1;
			ss >> l;

			stringstream ss2;
			ss2 << n2;
			ss2 >> r;

			if (l <= r)
				a.push_back(make_pair(l, r));
		}
		else
		{
			if (s.find("<=") != string::npos)
			{
				int p = s.find("<=") + 3;
				string n1;
				while ('0' <= s[p] && s[p] <= '9')
					n1 += s[p++];

				isleft = true;
				int tmp;

				stringstream ss;
				ss << n1;
				ss >> tmp;

				left = max(left, tmp);
			}
			else
			{
				int p = s.find(">=") + 3;
				string n1;
				while ('0' <= s[p] && s[p] <= '9')
					n1 += s[p++];

				isright = true;
				int tmp;

				stringstream ss;
				ss << n1;
				ss >> tmp;

				right = min(right, tmp);
			}
		}
	
		if (s.back() != '|')
			break;
	}

	if (a.size() == 0 && !isleft && !isright)
		cout << "false";
	else
	{
		sort(a.begin(), a.end());

		list <pair <int, int> > b;

		for (int i = 0; i < n;)
		{
			int j = i + 1;

			while (a[i].first <= a[j].first && a[j].first <= a[i].second ||
				a[i].second + 1 == a[j].first)
			{
				a[i].second = max(a[i].second, a[j].second);
				j++;
			}

			b.push_back(a[i]);
			i = j;
		}

		while (isleft && b.size() > 0 &&
			(b.front().first <= left && left <= b.front().second ||
			b.front().first == left + 1))
		{
			left = b.front().second;
			b.pop_front();
		}

		while (isright && b.size() > 0 &&
			(b.back().first <= right && right <= b.back().second ||
			right == b.back().second + 1))
		{
			right = b.back().first;
			b.pop_front();
		}

		if (isleft && left == 32767 ||
			isright && right == -32768 ||
			b.size() > 0 && b.front().first == -32768 && b.front().second == 32767)
			cout << "true";
		else
		{
			vector <string> ans;
			if (isleft)
			{
				stringstream ss;
				ss << "x <= " << left << " ||";

				string s;
				ss >> s;
				ans.push_back(s);
			}
			if (isright)
			{
				stringstream ss;
				ss << "x >= " << right << " ||";

				string s;
				ss >> s;
				ans.push_back(s);
			}

			for (auto it : b)
			{
				stringstream ss;
				ss << "x > " << it.first << " && x <= " << it.second << " ||";

				string s;
				ss >> s;
				ans.push_back(s);
			}

			for (int i = 0; i < 3; i++)
				ans.back().pop_back();

			for (auto it : ans)
				cout << it << endl;
		}

	}




	cout << endl;
#ifdef HOME
	system("pause");
#endif

}
