#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define ft first
#define sd second
const ld EPS = 1e-12;

void solve()
{
	int n, q;
	scanf("%d %d", &n, &q);
	vector<pll> d(n);
	ll pred;
	for (int i = 0; i < n; i++){
		char c;
		ll t, k;
		scanf(" %c %I64d %I64d", &c, &t, &k);
		if (c == '-') k *= (-1);
		if (i == 0){
			d[i].ft = k;
		}
		else{
			d[i].ft = d[i - 1].ft + k;
			d[i - 1].sd = t - pred;
		}
		pred = t;
	}
	vector<pii> a(q);
	for (int i = 0; i < q; i++){
		scanf("%d", &a[i].ft);
		a[i].sd = i;
	}
	vector<pll> del(n);

	vector<ll> ans(q);
	sort(a.begin(), a.end());
	bool first = false;
	ll cnt = 0;
	ll p = 0;
	multiset<pll> st;
	for (int i = 0; i < q; i++){
		if (d.back().ft + a[i].ft < 0){
			ans[a[i].sd] = -1;
			continue;
		}
		if (!first){
			first = true;
			for (int j = 0; j < n; j++){
				if (d[j].ft + a[i].ft < 0)
					cnt += abs(d[j].ft + a[i].ft) * d[j].sd;
			}
			ans[a[i].sd] = cnt;
			for (int j = 0; j < n; j++){
				if (d[j].ft + a[i].ft < 0){
					st.insert(d[j]);
					p += d[j].sd;
				}
			}
		}
		else{
			while (!st.empty() && (*st.rbegin()).ft + a[i].ft >= 0){
				cnt -= (*st.rbegin()).sd * abs(a[i - 1].ft + (*st.rbegin()).ft);
				p -= (*st.rbegin()).sd;
				st.erase(st.find(*st.rbegin()));
			}
			cnt -= (1ll * a[i].ft - a[i - 1].ft) * p;
			ans[a[i].sd] = cnt;
		}
	}
	for (int i = 0; i < q; i++){
		if (ans[i] == -1) puts("INFINITY");
		else printf("%I64d\n", ans[i]);
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
#endif
	solve();
	return 0;
}