#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
using namespace std;

const int MAXN = 1000005;

typedef long double ld;
typedef long long ll;

ld dp[MAXN];
ld suf_sum[MAXN];
ll fc[MAXN];
ll fw[MAXN];
char str[MAXN];

void solve()
{
	scanf("%s", str);
	int n = strlen(str);
	dp[n - 1] = 0;
	suf_sum[n - 1] = 0;
	fc[n - 1] = str[n - 1] == 'C' ? 0 : 1;
	fw[n - 1] = str[n - 1] == 'W' ? 0 : 1;
	for (int i = n - 2; i >= 0; --i)
	{
		fc[i] = str[i] == 'C' ? fc[i + 1] : (fc[i + 1] + n - i);
		fw[i] = str[i] == 'W' ? fw[i + 1] : (fw[i + 1] + n - i);
		dp[i] = (suf_sum[i + 1] + (str[i] == 'C' ? fc[i] : fw[i])) / ((ld)n - i);
		suf_sum[i] = suf_sum[i + 1] + dp[i];
	}
	printf("%.15Lf\n", dp[0]);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
#endif
	solve();
	return 0;
}