#include <iostream>
#include <cstdlib>
#include <string>
#include <vector>

using namespace std;

string s;
int i;

string abbr;
string abbr_buf;
int abbr_len = 0;

inline bool is_big(char c) {
	return c >= 'A' && c <= 'Z';
}

string read_word(bool &is_cap)
{
	string result = "";
	bool first = true;
	bool cap_first = false;
	bool cap_not_first = false;
	while (i < s.size() && ((s[i] >= 'a' && s[i] <= 'z') || (s[i] >= 'A' && s[i] <= 'Z'))) {
		if (first) {
			if (s[i] >= 'a' && s[i] <= 'z') {
				cap_first = false;
			}
			else {
				cap_first = true;
			}
		}
		else {
			if (s[i] >= 'A' && s[i] <= 'Z')
			{
				cap_not_first = true;
			}
		}
		first = false;
		result.push_back(s[i]);
		i++;
	}
	is_cap = cap_first && !cap_not_first;
	if (result.size() == 1) {
		is_cap = false;
	}
	return result;
}

int main()
{
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	while (getline(cin, s)) {
		i = 0;
		while (i < s.size()) {
			if (s[i] >= 'a' && s[i] <= 'z') {
				bool is_capital;
				cout << read_word(is_capital);
			}
			else if (s[i] >= 'A' && s[i] <= 'Z') {
				abbr = "";
				abbr_buf = "";
				abbr_len = 0;
				bool was_space = false;
				while (true) {
					bool is_capital;
					string buf = read_word(is_capital);
					if (is_capital) {
						abbr.push_back(buf[0]);
						if (abbr_len) {
							abbr_buf += " " + buf;
							was_space = false;
						}
						else {
							abbr_buf += buf;
						}
						
						abbr_len++;

						if (i == s.size()) {
							break;
						}
						else if (i == s.size() - 1) {
							break;
						}
						else if (s[i] != ' ') {
							break;
						}
						else if (!is_big(s[i + 1])) {
							break;
						}
						else {
							was_space = true;
							i++;
						}
					}
					else {
						if (abbr_len == 1) {
							cout << abbr_buf;
						}
						else if (abbr_len >= 2) {
							cout << abbr << " (" << abbr_buf << ")";
						}
						if (abbr_len) {
							cout << ' ';
						}
						cout << buf;
						abbr_len = 0;
						break;
					}
				}
				if (abbr_len == 1) {
					cout << abbr_buf;
				}
				else if (abbr_len >= 2) {
					cout << abbr << " (" << abbr_buf << ")";
				}
			
				}
			else {
				cout << s[i];
				i++;
			}
		}
		cout << '\n';
	}

	return 0;
}