#include <iostream>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 33000;
const int MORE = 0;
const int LESS = 1;

bool A[2 * MAXN];

int main()
{
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	memset(A, 0, sizeof(A));

	string s;

	string buf;

	while (cin >> buf)
	{
		vector<pair<int, int>> comps;
		cin >> buf;
		int type;
		if (buf == ">=") {
			type = MORE;
		}
		else {
			type = LESS;
		}

		int c;
		cin >> c;
		comps.push_back(make_pair(type, c));

		if ((cin >> buf) && buf == "&&") {
			cin >> buf;
			cin >> buf;
			if (buf == ">=") {
				type = MORE;
			}
			else {
				type = LESS;
			}
			cin >> c;
			comps.push_back(make_pair(type, c));
			cin >> buf;
		}


		int lower = 0;
		int upper = 2 * MAXN - 1;
		for (auto p : comps) {
			if (p.first == MORE) {
				lower = max(lower, p.second + MAXN);
			}
			else {
				upper = min(upper, p.second + MAXN);
			}


        }

		for (int i = lower; i <= upper; i++) {
			A[i] = true;
		}
	}


	int l = -1;
	bool was_false = false;
	bool was_true = false;
	bool first = true;
	for (int i = -32768 + MAXN; i <= 32767 + MAXN; i++) {
		was_false |= A[i] == false;
		was_true |= A[i] == true;

		if (A[i] == true) {
			if (l == -1) {
				l = i;
			}
		}

		if (A[i] == false) {
			if (l != -1) {
				if (!first) {
					cout << " ||\n";
				}
				first = false;
				if (l == -32768 + MAXN) {
					cout << "x <= " << i - 1 - MAXN;
				}
				else {
					cout << "x >= " << l - MAXN << " && x <= " << i - 1 - MAXN;
				}
				l = -1;
			}
		}
	}

	if (l != -1) {
		if (!first) {
			cout << " ||\n";
		}
		first = false;
		if (l == -32768 + MAXN) {
			cout << "true";
		}
		else
			cout << "x >= " << l - MAXN;
		l = -1;
	}

	if (!was_true) {
		cout << "false";
	}

	return 0;
}