#include<iostream>
#include<cmath>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
using namespace std;
#define int long long

#define fi(i,a,b) for(int i = a; i < (b); i++)
const int N = 200006;

string makeabbr(vector<string> vv){
	if (vv.size() == 0)return"";
	if (vv.size() == 1)return vv[0];
	string t = "";
	string def = "";
	fi(i,0,vv.size()){
		t += toupper(vv[i][0]);
		def += vv[i];
		if (i != vv.size() - 1){
			def += " ";
		}
	}

	return t + " (" + def + ")";
}

void main(){
#if defined(_DEBUG)
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#endif

	//FILENAME
	string tmp;
	vector<string> res;
	while (getline(cin, tmp)){
		string otw;

		vector<string> currAbb;
		string currStr = "";
		char prev = '*';
		bool okstring = true;
		
		fi(i, 0, tmp.size()){
			if (isalpha(tmp[i])){
				if (currStr.size() == 0){
					if (!isupper(tmp[i])) okstring = false;
				}
				else if (isupper(tmp[i])) okstring = false;

				currStr += tmp[i];
				prev = tmp[i];
				continue;
			}

			if (currStr.size() < 2) okstring = false;

			if ((tmp[i] == ' ' && prev != ' ') || tmp[i] == ',' || tmp[i] == '.'){
				
				if (currStr != "" && !okstring){
					if (currAbb.size() > 0) otw += makeabbr(currAbb) + " ";
					currAbb.clear();
					otw +=  currStr + tmp[i];
				}
				else if (currStr != "" && okstring){
					currAbb.push_back(currStr);
					if (tmp[i] != ' '){
						otw += makeabbr(currAbb);
						currAbb.clear();
						otw += tmp[i];
					}
				}
				else if (prev == ' ' && currAbb.size() > 0){
					otw += makeabbr(currAbb) + " " + tmp[i];
					currAbb.clear();
				}
				else{
					otw += tmp[i];
				}
				prev = tmp[i];
				currStr = ""; okstring = true;
				continue;
			}

			if (tmp[i] == ' ' && prev == ' '){
				if (currAbb.size() > 0){
					otw += makeabbr(currAbb) + "  ";
					currAbb.clear();
				}
				else{
					otw += " ";
				}
				currStr = ""; okstring = true;
				prev = tmp[i];
				continue;
			}

		}

		if (currStr.size() < 2) okstring = false;

		if (currStr != "" && okstring){
			currAbb.push_back(currStr);
			currStr = "";
		}

		if (currAbb.size() > 0){
			otw += makeabbr(currAbb) + (currStr.size() > 0 ? " " : "");
			if (currStr.size() == 0 && prev == ' ') otw += ' ';
		}

		if (currStr != ""){
			otw += currStr;
			if (prev == ' ') otw += ' ';
		}



		res.push_back(otw);
//		cout << otw << endl;
	}

	fi(i, 0, res.size()){
		cout << res[i];;
		if (i != res.size() - 1){
			cout << endl;
		}
	}
}