#include <stdio.h>
#include <iostream>
#include <string>
#include <sstream>
#include <vector>
#include <map>
using namespace std;


map<int, int> mm;
int cnt = 0;
void go(int left, int right) {
	if (left > right) {
		return;
	}
	for (int i = left; i <= right; i++) {
		mm[i] = 1;
		cnt += 1;
	}
}

int main() {
	#ifdef RSATU2
	freopen("in.txt", "rt", stdin);
	freopen("out.txt", "wt", stdout);
	#else
	#define FILENAME "hard"
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
	#endif
	string s;
	while (getline(cin, s)) {
		
		int left, right;
		if (2 == sscanf(s.c_str(), "x >= %d && x <= %d", &left, &right)) {
			go(left, right);
			continue;
		}
		if (1 == sscanf(s.c_str(), "x >= %d", &left)) {
			right = 32767;
			go(left, right);
			continue;
		}
		if (1 == sscanf(s.c_str(), "x <= %d", &right)) {
			left = -32768;
			go(left, right);
			continue;
		}
		if (s.size())
			throw(0);
		
	}
	if (mm.size() == 65536) {
		cout << "true";
		return 0;
	}
	if (cnt == 0) {
		cout << "false";
		return 0;
	}

	vector<string> ans;
	int cur = -32768;
	if (mm[cur]) {
		while (mm[cur]) {
			mm[cur] = 0;
			cur += 1;
		}
		ans.push_back("x <= " + to_string(cur - 1));
	}
	
	cur = 32767;
	if (mm[cur]) {
		while (mm[cur]) {
			mm[cur] = 0;
			cur -= 1;
		}
		ans.push_back("x >= " + to_string(cur + 1));
	}
	int left, right;
	
	for (int i = -32768; i <= 32767; ) {
		if (mm[i]) {
			left = i;
			while (mm[i]) {
				mm[i] = 0;;
				right = i;
				i += 1;
				
			}
			ans.push_back("x >= " + to_string(left) + " && x <= " + to_string(right));
		}
		else i += 1;
	}
	for (int i = 0; i < (int)ans.size(); i++) {
		cout << ans[i];
		if (i != ans.size() - 1)
			cout << " ||";
		cout << endl;
	}
	return 0;
}