#define FNAME "hard"

#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < (n); i++)
#define fornr(i, n) for (int i = (n) - 1; i >= 0; i--)
#define forab(i, a, b) for (int i = (a); i < (b); i++)
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long LL;
typedef LL ll;
typedef unsigned long long ULL;
typedef ULL ull;
typedef pair <int, int> pii;
typedef vector <int> vi;
 
const int INF = (1<<15);
void print(pii segm) {

    if (segm.first != -INF) {
        if (segm.second != INF) {
            printf("x >= %d && x <= %d", segm.first, segm.second - 1);
        } else {
            printf("x >= %d", segm.first);
        }
    } else {
        assert(segm.second != INF);
        printf("x <= %d", segm.second - 1);
    }

}

char s[100000];
vector <pii> a;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen(FNAME".in", "r", stdin);
    freopen(FNAME".out", "w", stdout);


    while(1) {
        gets(s);
        int n = strlen(s);
        if (n == 0) break;
        char op = s[2];
        int lhs = atoi(s + 4);
        int pos = 5;
        while (s[pos] == '-' || isdigit(s[pos])) pos++;
        if (pos == n || s[pos + 1] == '|') {
            if (op == '<') {
                a.pb(mp(-INF, -1));
                a.pb(mp(lhs + 1, 1));
            } else {
                a.pb(mp(lhs, -1));
                a.pb(mp(INF, 1));
            }            
            continue;
        }
        while (!isdigit(s[pos]) && s[pos] != '-') pos++;
        int rhs = atoi(s + pos);
        a.pb(mp(rhs + 1, 1));
        a.pb(mp(lhs, -1));
        if (lhs > rhs) {
            puts("false");
            return 0;
        }
    }
    sort(all(a));
    int balance = 0;
    int pos = -INF;
    vector <pii> segms;
    for (pii x: a) {
        if (balance == 0) {
            pos = x.first;
        }
        balance += x.second;
        if (balance == 0) {
            segms.pb(mp(pos, x.first));
        }
    }
    if (segms.size() == 1 && segms[0].first == -INF && segms[0].second == INF) {
        puts("true");
        return 0;
    }
    forn(i, (int) segms.size() -1) {
        print(segms[i]);
        puts(" ||");
    }
    print(segms.back());
    puts("");
    return 0;
}
