#define FNAME "jenga"

#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < (n); i++)
#define fornr(i, n) for (int i = (n) - 1; i >= 0; i--)
#define forab(i, a, b) for (int i = (a); i < (b); i++)
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long LL;
typedef LL ll;
typedef unsigned long long ULL;
typedef ULL ull;
typedef pair <int, int> pii;
typedef vector <int> vi;

const int MAXN = 5e3 + 10;

LL sumX[MAXN], levelSize[MAXN], sumY[MAXN];
int n, w, h, m;
int minPos[MAXN], maxPos[MAXN];
bool a[MAXN][MAXN];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen(FNAME".in", "r", stdin);
    freopen(FNAME".out", "w", stdout);


    scanf("%d%d%d%d", &n, &w, &h, &m);
    forn(i, h) {
        forn(j, n)
            a[i][j] = 1, sumX[i] += 2 * w * j + w, sumY[i] += n * w ;
        levelSize[i] = n;
        minPos[i] = 0;
        maxPos[i] = n - 1;
    } 

    forn(i, m) {
        int x, y;
        scanf("%d%d", &x, &y);
        x--, y--;
        a[x][y] = 0;
        levelSize[x]--;
        if (levelSize[x]) {
            while (!a[x][minPos[x]]) minPos[x]++;
            while (!a[x][maxPos[x]]) maxPos[x]--;
        }
        sumX[x] -= 2 * w * y + w;
        sumY[x] -= n * w;
        LL sX = 0, sY = 0;
        int cnt = 0;
        fornr(level, h) {
            LL s1X = sX, s1Y = sY;
            if (level % 2 == 1) {
                s1X = sY, s1Y = sX;
            }
            if (cnt) {
//                printf("s1X=%f s1Y=%f minX=%f maxX=%f\n", s1X, s1Y, *Set[level].begin() * w + eps, (*(--Set[level].end()) + 1) * w - eps);
                if (levelSize[level] == 0 || s1X <= minPos[level] * 2ll * w * cnt 
                || s1X >= 2ll * (maxPos[level] + 1) * w * cnt) {
                    printf("yes\n%d\n", i + 1);
                    return 0;
                }
            }
            cnt += levelSize[level];
            if (level % 2 == 0) {
                sX += sumX[level], sY += sumY[level];
            } else {
                sX += sumY[level], sY += sumX[level];
            }
        }
    }
    puts("no");
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
    return 0;
}
