//#pragma comment(linker, "/STACK:10000000")
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <map>
#include <set>
#include <ctime>
#include <cmath>

typedef long long ll;

using namespace std;

bool isBigLet(char c) {
	return 'A' <= c && c <= 'Z';
}

bool isSmallLet(char c) {
	return 'a' <= c && c <= 'z';
}

bool isLet(char c) {
	return isBigLet(c) || isSmallLet(c);
}

bool isCap(string s) {
	if ((int)s.size() < 2)
		return false;
	if (isSmallLet(s[0]))
		return false;
	for (int i = 1; i < (int)s.size(); i++) {
		if (isBigLet(s[i]))
			return false;
	}
	return true;
}

void print(vector<string>& capWords) {
	int sz = (int)capWords.size();
	if (!sz)
		return;
	if (sz == 1) {
		cout << capWords[0];
		capWords.clear();
		return;
	}
	for (int i = 0; i < sz; i++)
		cout << capWords[i][0];
	cout << " (";
	for (int i = 0; i < sz; i++) {
		cout << capWords[i];
		if (i < sz - 1)
			cout << " ";
	}
	cout << ")";
	capWords.clear();
}

int main() {
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	string s;
	getline(cin, s, '\0');
	vector<string> capWords;
	string curWord = "";
	int cnt = 0;
	s += "\n";
	for (int i = 0; i < (int)s.size(); i++) {
		if (isLet(s[i]))
			curWord += s[i], cnt = 0;
		else if (s[i] == ' ') {
			cnt++;
			if (isCap(curWord))
				capWords.push_back(curWord);
			else {
				int sz = (int)capWords.size();
				print(capWords);
				if(sz)
					cout << " ";
				cout << curWord;
				cout << " ";
				cnt = 0;
			}
			if (cnt == 2) {
				print(capWords);
				cout << " ";
				cout << " ";
			}
			curWord = "";
		}
		else {
			if (isCap(curWord)) {
				capWords.push_back(curWord);
				print(capWords);
			}
			else {
				int sz = (int)capWords.size();
				print(capWords);
				if (sz)
					cout << " ";
				cout << curWord;
			}
			curWord = "";
			cout << s[i];
			cnt = 0;
		}
	}
	return 0;
}