//#pragma comment(linker, "/STACK:10000000")
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <map>
#include <set>
#include <ctime>
#include <cmath>

using namespace std;

typedef long long ll;
#define mp(a, b) make_pair(a, b)

const int MIN = -32768, MAX = 32767;

bool isDig(char c) {
	return '0' <= c && c <= '9';
}

struct point {
	int pos, x, type;
	point(int a, int b, int c) : pos(a), x(b), type(c) {}
};

bool cmp(const point& a, const point& b) {
	if (a.pos != b.pos)
		return a.pos < b.pos;
	else
		return a.type > b.type;
}

int main() {
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	string s;
	vector<pair<int, int> > v;
	while (true) {
		getline(cin, s, '\n');
		if (s.empty())
			break;
		int p1 = 0, p2 = 0, cnt = 0;
		bool f = false, sign = false;
		vector<char> op;
		s += " ";
		for (int i = 0; i < (int)s.size(); i++) {
			if (isDig(s[i])) {
				if (!f)
					cnt++;
				f = true;
				if (cnt == 1)
					p1 = p1 * 10 + (s[i] - '0');
				if (cnt == 2)
					p2 = p2 * 10 + (s[i] - '0');
			}
			else if (s[i] == '-')
				sign = true;
			else {
				if (s[i] == '>' || s[i] == '<')
					op.push_back(s[i]);
				if (sign) {
					if (cnt == 1)
						p1 *= -1;
					if (cnt == 2)
						p2 *= -1;
				}
				sign = false;
				f = false;
			}
		}
		if ((int)op.size() == 1) {
			if (op[0] == '>')
				v.push_back(mp(p1, MAX));
			else
				v.push_back(mp(MIN, p1));
		}
		else {
			v.push_back(mp(p1, p2));
		}
		s = "";
	}
	bool ok = false;
	vector<point> e;
	vector<pair<int, int> > res;
	for (int i = 0; i < (int)v.size(); i++) {
		if (v[i].first <= v[i].second) {
			ok = true;
			e.push_back(point(v[i].first, v[i].second, 1));
			e.push_back(point(v[i].second + 1, v[i].first, -1));
		}   
	}
	if (!ok) {
		cout << "false" << endl;
		return 0;
	}
	sort(e.begin(), e.end(), cmp);
	int bal = 0, op = -1, cl = -1;
	for (int i = 0; i < (int)e.size(); i++) {
		if (bal == 0)
			op = e[i].pos;
		bal += e[i].type;
		if (bal == 0) {
			cl = e[i].pos;
			res.push_back(mp(op, cl - 1));
		}
	}
	//for (int i = 0; i < (int)v.size(); i++)
	//	cout << v[i].first << " " << v[i].second << endl;
	if (res.empty())
		return 1;
	if ((int)res.size() == 1 && res[0].first == MIN && res[0].second == MAX) {
		cout << "true";
		return 0;
	}
	for (int i = 0; i < (int)res.size(); i++) {
		if (res[i].first == MIN) {
			cout << "x <= " << res[i].second;
		}
		else if (res[i].second == MAX) {
			cout << "x >= " << res[i].first;
		}
		else {
			cout << "x >= " << res[i].first << " && " << "x <= " << res[i].second;
		}
		if (i + 1 < (int)res.size())
			cout << " ||";
		cout << "\n";
	}
	return 0;
}