#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef long long i64;
#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define sz(x) ((int) (x).size())

#define get hget

#define NAME "kids"

const int maxn = 1005;
char a[3][maxn][maxn];
int n[3], m[3], px[3], py[3];
int sx[3], sy[3];

int get(int q, int x, int y) {
    x -= sx[q], y -= sy[q];
    if (x < 0 || x >= maxn || y < 0 || y >= maxn)
        return 0;
    return a[q][x][y] == '*';
}

bool check() {
    for (int x = 0; x < maxn; ++x)
        for (int y = -maxn; y < maxn; ++y) {
            int b = 0;
            forn (q, 3)
                b ^= get(q, x, y);
            if (b)
                return false;
        }
    return true;
}

void answer() {
    cout << "YES\n";
    cout << sy[1] - sy[0] << ' ' << sx[1] - sx[0] << '\n';
    exit(0);
}

int main() {
#ifdef LOCAL
    assert(freopen("k.in", "r", stdin));
#else
    assert(freopen(NAME ".in", "r", stdin));
    assert(freopen(NAME ".out", "w", stdout));
#endif
    forn (q, 3) {
        cin >> n[q] >> m[q];
        px[q] = py[q] = 1e9;
        bool flag = false;
        forn (i, n[q]) {
            scanf("%s", a[q][i]);
            forn (j, m[q])
                if (a[q][i][j] == '*' && !flag) {
                    px[q] = i, py[q] = j;
                    flag = true;
                }
        }
        if (!flag) {
            assert(q == 2);

            forn (q, 2)
                sx[q] = -px[q], sy[q] = -py[q];
            if (check()) {
                answer();
                return 0;
            }
        }
    }
    forn (i, 3)
        forn (j, i) {
            sx[i] = -px[i];
            sy[i] = -py[i];
            for (int sh = -maxn; sh < maxn; ++sh) {
                sx[j] = -px[j], sy[j] = -py[j] + sh;
                bool flag = false;
                for (int x = 0; x < maxn; ++x) {
                    for (int y = -maxn; y < maxn; ++y) {
                        int b = get(i, x, y) ^ get(j, x, y);
                        if (b) {
                            int k = 3 - i - j;
                            sx[k] = x - px[k];
                            sy[k] = y - py[k];
                            if (check())
                                answer();
                            flag = true;
                            break;
                        }
                    }
                    if (flag)
                        break;
                }
            }
        }
    cout << "NO\n";
}
