#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef long long i64;
#define forn(i,n) for (int i = 0; i < int(n); ++i)
typedef vector<int> vi;
#define pb push_back

const i64 inf = 1e18 + 1e17;

#define NAME "list"

bool prime(int n) {
    for (int i = 2; i*i <= n; ++i) if (n%i == 0) return false;
    return true;
}

const int K = 450;
const int S = 3000;
int pr[K+10];

i64 cnt[S + 10][K+10];
i64 size[S + 10][K+10];
int len[K+10];

void build() {
    int k = 0;
    for (int i = 2; k < K; ++i) {
        if (prime(i)) {
            pr[k++] = i;
        }
    }
    forn(i, k) {
        int x = pr[i];
        while (x) ++len[i], x /= 10;
    }

    for (int s = 2; s < S; ++s) {
        for (int x = K-1; x >= 0; --x) {
            if (pr[x] == s) {
                size[s][x] = len[x] + 4;
                cnt[s][x] = 1;
            } else if (pr[x] < s) {
                size[s][x] = size[s-pr[x]][x+1] + cnt[s-pr[x]][x+1] * (len[x] + 2);
                cnt[s][x] = cnt[s-pr[x]][x+1];

                size[s][x] += size[s][x+1];
                cnt[s][x] += cnt[s][x+1];
            }
        }
    }

    forn(i, K) cnt[0][i] = 1, size[0][i] = 2;
}

string tostr(int x) {
    string s;
    while (x) s += '0'+x%10, x /= 10;
    reverse(s.begin(), s.end());
    return s;
}

string go(i64 k, int need) {
    int s = 1;
    while (size[s][0] <= k) {
        k -= size[s++][0];
    }
    //cerr << "s = " << s << endl;

    vi pref;
    int last = -1;
    int preflen = 0;
    int prefs = 0;
    while (prefs < s) {
        int x = last + 1;
        while (true) {
            i64 curlen = size[s-prefs-pr[x]][x+1] +
                    (preflen + len[x] + 2) * cnt[s-prefs-pr[x]][x+1];
            //cerr << "x = " << x << ", curlen = " << curlen << endl;
            //return "";
            if (curlen <= k) {
                k -= curlen;
                ++x;
            } else {
                pref.pb(x);
                prefs += pr[x];
                preflen += len[x] + 2;
                last = x;
                break;
            }
        }
    }
    {
    string s("[");
    forn(i, pref.size()) {
        s += tostr(pr[pref[i]]);
        if (i+1 == (int)pref.size()) s += "], ";
        else s += ", ";
    }
    return s.substr(k, min(need, (int)(s.size() - k)));
    }
    //for (int x: pref) cerr << pr[x] << " ";
    //cerr << endl;
    //cerr << "k = " << k << endl;

    //return "";
}


int main() {
#ifdef LOCAL
    assert(freopen("l.in", "r", stdin));
#else
    assert(freopen(NAME ".in", "r", stdin));
    assert(freopen(NAME ".out", "w", stdout));
#endif

    build();
    //cerr << pr[K-1] << " " << S << endl;

    /*
    cout << go(0, 100) << endl;
    cout << go(2, 100) << endl;
    //forn(i, 100) go(i, 0);
    return 0;
    */

    i64 l, r;
    cin >> l >> r;
    i64 k = l;
    int len = r-l+1;
    --k;

    string res;
    while ((int)res.size() < len) {
        res += go(k + res.size(), len - res.size());
    }
    assert((int)res.size() == len);
    //cerr << res.size() << endl;
    cout << res << endl;
    //cerr << 1.0 * clock()/CLOCKS_PER_SEC << endl;
}
