#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define for1(i, n) for (int i = 1; i < int(n); ++i)
#define forft(i, f, t) for (int i = int(f); i < int(t); ++i)
#define forr(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define X first
#define Y second
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define ms(a, v) memset(a, v, sizeof(a))

template <typename X> X sqr(const X &a) {return a * a;}

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = 1e9;
const li INF64 = 1e18;
const ld EPS = 1e-9;

string s;
int ptr, n;
bool cap = 0;

bool read() {
	if(getline(cin, s)) {
		return true;
	} else {
		return false;
	}
}

void get_word() {
	int uc = 0;
	int lc = 0;
	bool fu = isupper(s[ptr]);
	while (ptr < n && isalpha(s[ptr])) {
		uc += isupper(s[ptr]);
		lc += islower(s[ptr]);
		ptr++;
	}
	if (uc == 1 && lc > 0 && fu) {
		cap = true;
	} else {
		cap = false;
	}
}

void print_word(int l, int r) {
	forft(i, l, r) {
		printf("%c", s[i]);
	}
}

struct st {
	char c;
	bool s;
	int l;
	int r;
	bool cap;

	st(char c) {
		this->c = c;
		this->s = true;
	}

	st(int l, int r, int cap) {
		this->s = false;
		this->l = l;
		this->r = r;
		this->cap = cap;
	}
};

void print_st(st& c) {
	if (c.s) {
		printf("%c", c.c);
	} else {
		print_word(c.l, c.r);
	}
}

vector<st> sq;

void print_abbr(int l, int r) {
	for (int i = l; i <= r; i += 2) {
		printf("%c", s[sq[i].l]);
	}
	printf(" (");
	forft(i, l, r + 1) {
		print_st(sq[i]);
	}
	printf(")");
}

void solve() {
	sq.clear();
	ptr = 0;
	n = sz(s);    
	while (ptr < n) {
		if (isalpha(s[ptr])) {
			int l = ptr;
			get_word();
			sq.pb(st(l, ptr, cap));
		} else {
			sq.pb(st(s[ptr]));
			ptr++;
		}    
	}
	int cur = 0;
	while (cur < sz(sq)) {
		int l = cur;
		while (cur + 2 < sz(sq) && !sq[cur].s && sq[cur].cap && sq[cur + 1].s && sq[cur + 1].c == ' ' && !sq[cur + 2].s && sq[cur + 2].cap) {
			cur += 2;
		}
		if (l != cur) {
			print_abbr(l, cur);
			cur++;
		} else {
			print_st(sq[cur]);
			cur++;
		}
	}
	printf("\n");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("abbreviation.in", "rt", stdin);
	freopen("abbreviation.out", "wt", stdout);
#endif

	srand(time(NULL));
	cout << setprecision(10) << fixed;	
	cerr << setprecision(10) << fixed;

	while (read()) {
		solve();
	}

#ifdef _DEBUG
	cerr << "Time: " << clock() << endl;
#endif

	return 0;	
}