#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define for1(i, n) for (int i = 1; i < int(n); ++i)
#define forft(i, f, t) for (int i = int(f); i < int(t); ++i)
#define forr(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define X first
#define Y second
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define ms(a, v) memset(a, v, sizeof(a))

template <typename X> X sqr(const X &a) {return a * a;}

typedef long long li;
typedef long double ld;
typedef pair<li, li> pt;

const int INF = 1e9;
const li INF64 = 1e18;
const ld EPS = 1e-9;

int n, m;

const int N = (int)1e5 + 10;

char tp[N];
li ck[N];
li ct[N];
li q[N];

bool read() {
	scanf("%d %d\n", &n, &m);
	forn(i, n) {
		int a, b;
		scanf("%c %d %d\n", &tp[i], &a, &b); 
		ck[i] = b;
		ct[i] = a;
	}
	forn(i, m) {
		int a;
		scanf("%d", &a);
		q[i] = a;
	}
	return true;
}
            
li psumX[N];
li psumY[N];
li psumXY[N];

void solve() {
	vector<pt> a;
	li b = 0;
	a.pb(pt(0, 0));
	forn(i, n - 1) {
		if (tp[i] == '+') {
			b += ck[i];
		} else {
			b -= ck[i];
		}
		a.pb(pt(b, ct[i + 1] - ct[i]));
	}               
	if (tp[n - 1] == '+') {
		b += ck[n - 1];
	} else {
		b -= ck[n - 1];
	}
	sort(all(a));  
	psumX[0] = a[0].X; 
	psumY[0] = a[0].Y;
	psumXY[0] = a[0].X * a[0].Y;
	for1(i, n) {                   
		psumX[i] = psumX[i - 1] + a[i].X;
		psumY[i] = psumY[i - 1] + a[i].Y;
		psumXY[i] = psumXY[i - 1] + a[i].X * a[i].Y;
	}
	forn(i, m) {
		li cq = q[i];
		if (b + cq < 0) {
			printf("INFINITY\n");
			continue;
		}
		int idx = lower_bound(all(a), pt(-cq, -INF)) - a.begin();
		idx--;
		if (idx < 0) {
			printf("0\n");
		} else {
			printf("%lld\n", abs(psumXY[idx]) - cq * abs(psumY[idx]));
		}
	} 
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("expect.in", "rt", stdin);
	freopen("expect.out", "wt", stdout);
#endif

	srand(time(NULL));
	cout << setprecision(10) << fixed;	
	cerr << setprecision(10) << fixed;

	read();
	solve();

#ifdef _DEBUG
	cerr << "Time: " << clock() << endl;
#endif

	return 0;	
}