#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define for1(i, n) for (int i = 1; i < int(n); ++i)
#define forft(i, f, t) for (int i = int(f); i < int(t); ++i)
#define forr(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define X first
#define Y second
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define ms(a, v) memset(a, v, sizeof(a))

template <typename X> X sqr(const X &a) {return a * a;}

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = 1e9;
const li INF64 = 1e18;
const ld EPS = 1e-9;

const int N = 5e3 + 10;
const int M = 1e4+ 1;

int n, w;
int h, m;

pt a[N];
int f[N];

ld f1[N], f2[N];
bitset<M> used[N];

pt sides[N];

void add(int pos, ld val, ld *f) {
	for(; pos < N; pos |= (pos + 1)) {
		f[pos] += val;
	}
}

void add(int pos, int val, int *f) {
	for(; pos < N; pos |= (pos + 1)) {
		f[pos] += val;
	}
}

int sum(int pos, int *f) {
	int ans = 0;

	for (; pos >= 0; pos = (pos & (pos + 1)) - 1) {
		ans += f[pos];
	}

	return ans;
}

ld sum(int pos, ld *f) {
	ld ans = 0;

	for (; pos >= 0; pos = (pos & (pos + 1)) - 1) {
		ans += f[pos];
	}

	return ans;
}

bool read() {
	scanf("%d%d%d%d", &n, &w, &h, &m);
   	          
   	forn(i, m) {
   		scanf("%d%d", &a[i].X, &a[i].Y);
   		a[i].X--;
   		a[i].Y--;
   	}

   	return true;
}

void precalc() {
	pair<ld, ld> ans = mp(0, 0);
	pair<ld, ld> cur = mp(ld(w) / ld(2), ld(n * w) / ld(2));

	forn(i, n) {
		ans.X += cur.X;
		ans.Y += cur.Y;
		cur.X += w;
	}                                     

    forn(i, h) {
		add(i, n, f);
		if (!(i & 1)) {
			add(i, ans.X, f1);
			add(i, ans.Y, f2);
		}
	}

	ans = mp(0, 0);
	cur = mp(ld(n * w) / ld(2), ld(w) / ld(2));

	forn(i, n) {
		ans.X += cur.X;
		ans.Y += cur.Y;
		cur.Y += w;
	}                                              

	forn(i, h) {     
		if (i & 1) {
			add(i, ans.X, f1);
			add(i, ans.Y, f2);
		}
	}

	forn(i, h) {
		sides[i] = mp(0, n - 1);
	}
}

void update(int lvl) {
	while (sides[lvl].Y >= 0 && used[lvl][sides[lvl].Y]) {
		sides[lvl].Y--;
	}
	
	while (sides[lvl].X < n && used[lvl][sides[lvl].X]) {
		sides[lvl].X++;
	}
}

bool check(int lvl) {
	int csum = sum(N - 1, f) - sum(lvl, f);

	pair<ld, ld> cur = mp(sum(N - 1, f1) - sum(lvl, f1), sum(N - 1, f2) - sum(lvl, f2));

	pair<ld, ld> g1, g2;

	if (!(lvl & 1)) {
		g1 = mp(sides[lvl].X * w, 0);
		g2 = mp((sides[lvl].Y + 1) * w, n * w);
	} else {
		g1 = mp(0, sides[lvl].X * w);
		g2 = mp(n * w, (sides[lvl].Y + 1) * w);
	}
	cur.X /= ld(csum);
	cur.Y /= ld(csum);
                                               
	return cur.X > g1.X + EPS && cur.X < g2.X - EPS && cur.Y > g1.Y + EPS && cur.Y < g2.Y - EPS;
}

void solve() {
	precalc();
	int max_lvl = h - 1;
    
    forn(i, m) {         

		pair<ld, ld> cur = mp(0, 0);

		if (!(a[i].X & 1)) {
			cur = mp(a[i].Y * w + w / ld(2), ld(n * w) / ld(2));
		} else {
			cur = mp(ld(n * w) / ld(2), a[i].Y * w + w / ld(2));
		}

		add(a[i].X, -1, f);
		add(a[i].X, -cur.X, f1);
		add(a[i].X, -cur.Y, f2);
		used[a[i].X][a[i].Y] = true;

		update(a[i].X);

		if (sides[a[i].X].X < 0 || sides[a[i].X].Y == n) {
			if (a[i].X != max_lvl) {
				cout << "yes" << endl;
				cout << i + 1 << endl;
				return;
			} else {
				max_lvl--;
			}
		} else {
			if (a[i].X < max_lvl && !check(a[i].X)) {
				cout << "yes" << endl;
				cout << i + 1 << endl;
				return;
			}			
		}

		forr(j, a[i].X) {
			if (!check(j)) {
				cout << "yes" << endl;
				cout << i + 1 << endl;
				return;
			}
		}
	}

	cout << "no" << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("jenga.in", "rt", stdin);
	freopen("jenga.out", "wt", stdout);
#endif

	srand(time(NULL));
	cout << setprecision(10) << fixed;	
	cerr << setprecision(10) << fixed;

	read();
	solve();

#ifdef _DEBUG
	cerr << "Time: " << clock() << endl;
#endif

	return 0;	
}