#include <bits/stdc++.h>
#define DEBUG(x) cout << #x << " = " << x << endl;
using namespace std;
typedef long long ll;
const int maxn = 100009;

pair<int, int> Q[maxn];
int ans[maxn];

int main()
{
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);

    ios::sync_with_stdio(false);

    int n, q;
    cin >> n >> q;

    multiset<pair<int, int>> S;
    ll tmpAns = 0;
    int sumLast = 0;
    int negativeLen = 0;

    for (int i = 0, prevTime = 0; i < n; i++) {
        char type;
        int time, val;
        cin >> type >> time >> val;

        if (type == '-') val *= -1;

        sumLast += val;

        if (sumLast < 0) {
            S.insert(make_pair(-sumLast, time - prevTime));
            tmpAns += ll(time - prevTime) * ll(-sumLast);
            negativeLen += time - prevTime;
        }

        prevTime = time;
    }

    //cout << sumLast << " " << tmpAns << endl;

    for (int i = 1; i <= q; i++) {
        cin >> Q[i].first;
        Q[i].second = i;
    }

    sort(Q + 1, Q + q + 1);

    for (int i = 1; i <= q; i++) {
        while (!S.empty() && S.begin()->first <= Q[i].first) {
            tmpAns -= (ll)(S.begin()->first) * (ll)(S.begin()->second);
            negativeLen -= S.begin()->second;
            S.erase(S.begin());
        }

        // cout << Q[i].first + sumLast << " " << tmpAns - (ll)negativeLen * (ll)Q[i].first << endl;

        if (Q[i].first + sumLast >= 0) {
            ans[ Q[i].second ] = tmpAns - (ll)negativeLen * (ll)Q[i].first;
        }
        else {
            ans[ Q[i].second ] = -1;
        }
    }

    for (int i = 1; i <= q; i++) {
        if (ans[i] == -1) {
            cout << "INFINITY\n";
        }
        else {
            cout << ans[i] << "\n";
        }
    }

    return 0;
}
