#include <bits/stdc++.h>
#define DEBUG(x) cout << #x << " = " << x << endl;
using namespace std;
typedef long long ll;
const int MAXN = 10005;
const int MAXH = 5005;

struct Level
{
    bool sticks[MAXN];
    long long l, r;
    long long sumC;
    long long weightC;
};

Level L[MAXH];

int main()
{
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);

    long long N, W;
    cin >> N >> W;

    long long H;
    int M;
    cin >> H >> M;

    for (int i = 1; i <= H; i++)
    {
        long long c = N * (H - i);
        L[i].sumC = N * c;
        L[i].weightC = c * N * (N + 1) / 2LL;

        for (int j = 1; j <= N; j++)
            L[i].sticks[j] = true;

        L[i].sticks[0]     = false;
        L[i].sticks[N + 1] = false;


        L[i].l = 1;
        L[i].r = N;
    }

    for (int j = 1; j <= M; j++)
    {
        int lvl;
        long long idx;
        cin >> lvl >> idx;

        L[lvl].sticks[idx] = false;
        while(!L[lvl].sticks[L[lvl].l]) L[lvl].l++;
        while(!L[lvl].sticks[L[lvl].r]) L[lvl].r--;

        if (L[lvl].l == N + 1)
        {
            if (lvl != H)
            {
                cout << "yes" << endl;
                cout << j << endl;
                return 0;
            }
            else
            {
                H--;
            }
        }

        for (int i = lvl - 1; i >= 1; i--)
        {
            if ((lvl - i) % 2 == 0)
            {
                L[i].sumC -= N;
                L[i].weightC -= idx * N;
            }
            else
            {
                L[i].sumC -= N;
                L[i].weightC -= N * (N + 1) / 2LL;
            }
        }

        for (int i = 1; i <= lvl; i++)
        {
            if (lvl >= H) continue;
            long long Up   = L[i].weightC;
            long long Down = L[i].sumC;

            if (2LL * Up <= (2LL * L[i].l - 1LL) * Down ||
                2LL * Up >= (2LL * L[i].r + 1LL) * Down)
            {
                cout << "yes" << endl;
                cout << j << endl;
                return 0;
            }
        }
    }

    cout << "no" << endl;

    return 0;
}
