#include <bits/stdc++.h>

using namespace std;

const long double eps = 1e-7;

struct Level {
    int lm;
    int rm;
    int cnt = 0;
    vector<char> alive;

    long long sum;
};

vector<Level> lev;

int main()
{
    //freopen("input.txt", "rt", stdin);
    //freopen("output.txt", "wt", stdout);
    freopen("jenga.in", "rt", stdin);
    freopen("jenga.out", "wt", stdout);

    int n, w;
    scanf("%d %d", &n, &w);
    int h, m;
    scanf("%d %d", &h, &m);

    lev.resize(h);
    for (int i = 0; i < h; i++) {
        lev[i].lm = 1;
        lev[i].rm = n;

        lev[i].cnt = n;
        lev[i].sum = (((n+1)*n)/2);
        lev[i].alive.resize(n+1, 't');
        lev[i].alive[0] = 'f';
    }

    lev.push_back(Level());
    lev.back().sum = (((n+1)*n)/2);
    lev.back().cnt = n;
    lev.push_back(Level());
    lev.back().sum = (((n+1)*n)/2);
    lev.back().cnt = n;
    h += 2;

    for (int i = 0; i < m; i++) {
        int l, k;
        scanf("%d %d", &l, &k);
        l--;

        lev[l].cnt--;       // USELESS
        lev[l].alive[k] = 'f';

        lev[l].sum -= k;

        while (lev[l].lm <= n && lev[l].alive[lev[l].lm] == 'f') lev[l].lm++;       // RE
        while (lev[l].rm > 0 && lev[l].alive[lev[l].rm] == 'f') lev[l].rm--;

        int j;
        if (l%2 == (h-1)%2) {
            j = h-1;
        }
        else {
            j = h-2;
        }

        long long cord_sum = 0;
        long long mass_sum = 0;

        for (; j >= 0; j -= 2) {
            cord_sum += lev[j].sum;
            mass_sum += lev[j].cnt;

            if (j-2 >= 0) {
                //long double mass_center = (long double)cord_sum / (long double)mass_sum;
                Level &behind = lev[j-2];
                if (2*cord_sum <= (2*behind.lm-1)*mass_sum || 2*cord_sum >= (2*behind.rm+1)*mass_sum) {
                    //cerr << "i " << i << endl;
                    //cerr << "Level " << j << ' ' <<  mass_center << endl;
                    //cerr << "lm rm " << behind.lm << ' ' << behind.rm << endl;
                    printf("yes\n");
                    printf("%d\n", i+1);
                    return 0;
                }
            }
        }
    }

    printf("no");

    return 0;
}
