#define _CRT_SECURE_NO_DEPRECATE
#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <memory.h>
#include <utility>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <queue>
using namespace std;

#define ll long long
#define pb push_back
#define mp make_pair
#define mod 1000000007
#define inf 1000000000
#define task "hard"



string s;
vector<bool>used;
void init()
{
	used.assign(1000000, false);
}

void solve()
{
	int i = 0;
	while (getline(cin, s))
	{
		//getline(cin, s);
		i = 0;
		while (s[i] != '<' && s[i] != '>')
			++i;
		int val = 0;
		int flag = 1, sign = 1;
		if (s[i] == '<')
			flag = 0;
		while (i < (int)s.size() && s[i] != '&' && s[i] != '|')
		{
			if (s[i] == '-')
				sign = -1;
			if (s[i] >= '0' && s[i] <= '9')
				val = val * 10 + (s[i] - '0');
			++i;
		}
		val *= sign;
		if (!flag)
		{
			for (int i = 0; i <= val + 32768; ++i)
				used[i] = 1;
			continue;
		}

		if (s[i] == '|' || i == (int)s.size())
		{
			for (int i = val + 32768; i <= 32767 + 32768; ++i)
				used[i] = 1;
			continue;
		}

		sign = 1;
		int val2 = 0;
		while (i < (int)s.size() && s[i] != '|')
		{
			if (s[i] == '-')
				sign = -1;
			if (s[i] >= '0' && s[i] <= '9')
				val2 = val2 * 10 + (s[i] - '0');
			++i;
		}

		for (int i = val + 32768; i <= val2 + 32768; ++i)
			used[i] = 1;
	}

	int ok1 = false;
	int ok2 = false;
	for (int i = 0; i <= 32767 + 32768; ++i)
	{
		if (used[i])
			ok1 = true;
		else
			ok2 = true;
	}

	if (ok1 && !ok2)
	{
		cout << "true";
		return;
	}

	if (!ok1 && ok2)
	{
		cout << "false";
		return;
	}

	int l = 0, r = 0;
	int ok = false;
	while (l <= 32767 + 32768 && r <= 32767 + 32768)
	{

		if (used[l])
		{
			r = l;
			while (used[r])
			{
				++r;
			}
		}
		else
		{
			++l;
			continue;
		}
		
		if (l == 0)
		{
			if (ok)
				cout << " ||\n";
			ok = true;
			cout << "x <= " << r - 32768 - 1;
			l = r;
			continue;
		}
		if (r == 32767 + 32768 + 1)
		{
			if (ok)
				cout << " ||\n";
			ok = true;
			cout << "x >= " << l - 32768;
			l = r;
			continue;
		}
		if (ok)
			cout << " ||\n";
		ok = true;
		cout << "x >= " << l - 32768 << " && x <= " << r - 32768 - 1;
		l = r;

	}
}

int main()
{
	//freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
	freopen(task".in", "rt", stdin); freopen(task".out", "wt", stdout);

	init();
	solve();
	return 0;
}
