#pragma warning (disable : 4996)

#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <vector>
#include <iomanip>
#include <cassert>
#include <string>
#include <algorithm>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;
#define mp make_pair
#define NAME string("hard")

const int bleft = -(1 << 15);
const int bright = (1 << 15) - 1;

pair<int, int> get_interval(string s) {
	if ("" == s) {
		return mp(1, 0);
	}
	vector<string> vs;
	string temp = "";
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == ' ') {
			vs.push_back(temp);
			temp = "";
		}
		else {
			temp = temp + s[i];
		}
	}
	vs.push_back(temp);

	int a, b;
	int sz = vs.size();
	if (sz < 7) {
		stringstream ss;
		ss << vs[2];
		ss >> a;
		if (vs[1] == ">=") {
			return mp(a, bright);
		}
		else {
			return mp(bleft, a);
		}
	}
	else {
		stringstream ssa;
		ssa << vs[2];
		ssa >> a;
		stringstream ssb;
		ssb << vs[6];
		ssb >> b;
		return mp(a, b);
	}
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen((NAME + ".in").c_str(), "r", stdin);
	freopen((NAME + ".out").c_str(), "w", stdout);
#endif

	const int add_num = (1 << 15) + 1;
	vector<int> dp(100000, 0);
	string s;
	while (getline(cin, s)) {
		pair<int, int> p = get_interval(s);
		if (p.first > p.second) {
			continue;
		}
		p.first += add_num;
		p.second += add_num;
		++dp[p.first];
		--dp[p.second + 1];
	}
	for (int i = 1; i < dp.size(); ++i) {
		dp[i] = dp[i] + dp[i - 1];
	}

	int lb = -1;
	vector<pair<int, int>> ans;
	for (int i = 0; i < dp.size(); ++i) {
		if (dp[i] && -1 == lb) {
			lb = i;
		}
		if (!dp[i]) {
			if (-1 != lb) {
				ans.push_back(mp(lb - add_num, i - 1 - add_num));
				lb = -1;
			}
		}
	}
	if (-1 != lb) {
		ans.push_back(mp(lb - add_num, bright));
		lb = -1;
	}

	int sz = ans.size();
	if (0 == sz) {
		cout << "false";
		return 0;
	}
	if (ans[0].first == bleft && ans[0].second == bright) {
		cout << "true";
		return 0;
	}

	sort(ans.begin(), ans.end());
	int L = 0;
	int R = sz - 1;
	vector<string> ls;
	if (ans[0].first == bleft) {
		stringstream ss;
		ss << "x <= " << ans[0].second;
		getline(ss, s);
		ls.push_back(s);
		++L;
	}
	bool flfl1 = false;
	if (ans.back().second == bright) {
		stringstream ss;
		ss << "x >= " << ans.back().first;
		getline(ss, s);
		ls.push_back(s);
		--R;
	}
	for (int i = L; i <= R; ++i) {
		stringstream ss;
		ss << "x >= " << ans[i].first << " && x <= " << ans[i].second;
		getline(ss, s);
		ls.push_back(s);
	}

	for (int i = 0; i < ls.size(); ++i) {
		cout << ls[i];
		if (i != int(ls.size()) - 1) {
			cout << " ||\n";
		}
	}

	return 0;
}