#pragma warning (disable : 4996)

#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <vector>
#include <iomanip>
#include <cassert>
#include <string>
#include <algorithm>

using namespace std;

int n, w, h, m;

int used[5100][11000];

pair<int, int> lr[5100];

double mass[5100];

int countt[5100];

bool upd(int a, int b){
	used[a][b] = 0;
	if (countt[a] == 1) {
		return false;
	}
	if ((b - 1) * w == lr[a].first){
		while (!used[a][lr[a].first/w+1]) {
			lr[a].first+=w;
		}
	}
	if (b*w == lr[a].second) {
		while (!used[a][lr[a].second/w]) {
			lr[a].second-=w;
		}
	}
	mass[a] = ((mass[a] * countt[a]) - (b*w - w / 2.0)) / (countt[a] - 1);
	countt[a]--;
	double km,km2,h1,h2;
	if (n % 2 == 1){
		km2 = mass[n];
		km = mass[n - 1];
		if ((lr[n - 1].first >= (w*n / 2.0)) || (lr[n - 1].second <= (w*n / 2.0))){
			return false;
		}
	}
	else {
		km = mass[n];
		km2 = mass[n - 1];
		if ((lr[n - 1].first >=(w*n / 2.0)) || (lr[n - 1].second <= (w*n / 2.0))){
			return false;
		}
	}
	h1 = 1; h2 = 1;
	for (int i = n-2; i > 0; i--) {
		if (n % 2 == 1){
			if ((lr[i].first >= (km2 / h2)) || (lr[i].second <= (km2 / h2))){
				return false;
			}
			km2 += mass[i]; h2++;
		}
		if (n % 2 == 0){
			if ((lr[i].first >=(km / h1)) || (lr[i].second <= (km / h1))){
				return false;
			}
			km2 += mass[i]; h1++;
		}
	}
	return true;
}

int main(){
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	cin >> n >> w;
	cin >> h >> m;
	for (int i = 1; i <= h; ++i){
		for (int j = 1; j <= n; ++j){
			used[i][j] = 1;
		}
		countt[i] = n;
		mass[i] = (double)(w * n) / 2.0;
		lr[i].first = 0;
		lr[i].second = n * w;
	}
	if (h == 1) {
		cout << "no";
	}
	else{
		for (int i = 1, tmp1, tmp2; i <= m; ++i){
			cin >> tmp1 >> tmp2;
			if (!upd(tmp1, tmp2)){
				cout << "yes" << endl;
				cout << i;
				return 0;
			}
		}
		cout << "no";
	}
	return 0;
}