#include <iostream>
#include <fstream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>
#include <sstream>

using namespace std;

bool up(char c) {
	return c >= 'A' && c <= 'Z';
}
bool lo(char c) {
	return c >= 'a' && c <= 'z';
}

bool  ok(string s) {
	if (s.length() < 2)
		return false;
	if (lo(s[0]))
		return false;
	for (int i = 1; i < s.length(); i++)
		if (up(s[i]))
			return false;
	return true;
}

string ww(string s) {
	string ans = "";
	stringstream ss;
	ss << s;
	string t;
	int y = 0;
	while (ss >> t) {
		y++;
		if (!ok(t)) {
			return s.substr(0, s.length() - 1);
		}
		ans += t[0];
	}
	return y > 1 ? (ans + " (" + s.substr(0, s.length() - 1) + ")") : (s.length() ? s.substr(0, s.length() - 1) : "");
}
char buf[500];

bool okn(int y) {
	int x = y;
	string s = "";
	if (lo(buf[y]))
		return false;
	y++;
	while (lo(buf[y])) {
		y++;
	}
	if (up(buf[y]))
		return false;
	return y - x > 1;
}

bool punkt(char c) {
	return c != ' ' && !(lo(c) || up(c));
}

string nextt(int y) {
	string s = "";
	while (lo(buf[y]) || up(buf[y])) {
		s += buf[y];
		y++;
	}
	return s;
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "r", stout);
#endif
	cin.getline(buf, 500);
	while (strlen(buf)) {
		string s, tt;
		int n = strlen(buf);
		bool sp = false;
		bool wo = false;
		string b = "";
		for (int i = 0; i < n; i++) {
			if ((sp && buf[i] == ' ') || punkt(buf[i])) {
				cout << ww(b);
				cout << buf[i];
				if (buf[i] == ' ')
					cout << " ";
				b = "";
				wo = false;
				continue;
			}
			if (buf[i] == ' ' || punkt(buf[i])) {
				sp = true;
				if (!wo)
					cout << buf[i];
				continue;
			}
			sp = false;
			if (okn(i)) {
				tt = nextt(i);
				i += tt.length() - 1;
				b += tt + " ";
				wo = true;
			}
			else {
				tt = nextt(i);
				cout << ww(b);
				cout << (b.length() ? " " : "") << tt;
				i += tt.length() - 1;
				wo = false;
				b = "";
			}
		}
		if (b.length())
			cout << ww(b);
		cout << endl;
		cin.getline(buf, 500);
	}
	return 0;
}