#include <stdio.h>
#include <string.h>
#include <iostream>
#include <string>
#include <queue>
using namespace std;

const __int64 maxn = 100001;

struct time{
	__int64 next;
	__int64 add, rem;
};

__int64 prevv, first, t, k, n, q;
time a[maxn];
char cmd;
__int64 qq[maxn];

void process(char c, __int64 tt, __int64 kk)
{
	if (c == '+')
	{
		a[tt].add += kk;
	}
	else		
    if (c == '-')
	{
		a[tt].rem += kk;
	}
}

void execute(__int64 v)
{
	__int64 sumwait;
	__int64 velo, now, next;
	queue <int> och;

	now = first;
	next = a[now].next; 
	velo = v;
	sumwait = 0;

	while (now!=-1)
	{
		velo += a[now].add;
		for (__int64 j = 1; j <= a[now].rem; j++)
			och.push(now);

		while (velo > 0 && !och.empty())
		{
			sumwait += (now - och.front());
			velo--;
            och.pop();
		}

		now = next;
		next = a[now].next;
	}

	if (!och.empty())
	{
		printf("INFINITY\n");
	}
	else
	{
		printf("%I64d\n", sumwait);
	}
}

int main()
{
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
	scanf("%I64d %I64d\n", &n,&q);
	scanf("%c %I64d %I64d\n", &cmd, &t, &k);
	prevv = t; first = t;
	process(cmd, t, k);
	for (__int64 i = 2; i <= n; i++)
	{
		scanf("%c %I64d %I64d\n", &cmd, &t, &k);
		a[prevv].next = t;
		process(cmd, t, k);
		prevv = t;
	}
    
	a[t].next = -1;

	for (__int64 i = 1; i <= q; i++)
		scanf("%I64d", &qq[i]);

	for (__int64 i = 1; i <= q; i++)
		execute(qq[i]);

	return 0;
}