#pragma comment(linker, "/STACK:256000000")

#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include <time.h>
#include <memory.h>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <random>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e7);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-11;
const double PI = acos(-1);
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)(0))++)

//vector<string> lines;
vector<vector<pair<int, char> > > expr;
int f[1000000];
int u[1000000];
int off = 500000;
int n;

void init()
{
	bool flag = true;
	while (flag)
	{
		string xs, cs, ops;
		expr.push_back(vector<pair<int, char> >());
		int val;
		while (1)
		{
			cin >> xs >> cs >> val;

			expr.back().push_back(make_pair(val, cs[0]));

			if (!(cin >> ops))
			{
				flag = false;
				break;
			}
			if (ops == "||")
				break;
		}
	}
	n = expr.size();
}

const int MINV = -32768;
const int MAXV = 32767;

void solve()
{
	init();
	int was[2] = { 0, 0 };
	for (int x = MINV; x <= MAXV; x++)
	{
		int ix = off + x;
		int res = 0;
		for (int j = 0; j < n && !res; j++)
		{
			int tres = 1;
			for (int k = 0; k < (int)expr[j].size() && tres; k++)
			{
				if (expr[j][k].second == '<')
					tres &= (x <= expr[j][k].first);
				else
					tres &= (x >= expr[j][k].first);
			}
			res |= tres;
		}
		was[res] = 1;
		f[ix] = res;
	}
	if (was[0] && !was[1])
		cout << "false";
	else if (was[1] && !was[0])
		cout << "true";
	else
	{
		bool pre = false;
		for (int x = MINV; x <= MAXV; x++)
		{
			int ix = off + x;
			if (u[ix] || f[ix] == 0)
				continue;
			int ctr = 0;
			while (x + ctr <= MAXV && f[ix + ctr] == 1)
			{
				u[ix + ctr] = 1;
				ctr++;
			}
			int l = x;
			int r = x + ctr - 1;
			bool was = false;
			if (pre)
			{
				cout << " ||\n";
			}
			if (l != MINV)
			{
				was = true;
				pre = true;
				cout << "x >= " << l;
			}
			if (r != MAXV)
			{
				if (was)
					cout << " && ";
				pre = true;
				cout << "x <= " << r;
			}
		}
	}
}

#define TASK "hard"
int main()
{
	cin.tie(0); ios_base::sync_with_stdio(false);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
	freopen(TASK ".in", "rt", stdin); freopen(TASK ".out", "wt", stdout);
#endif
	srand(88);

	solve();

	return 0;
}