#pragma comment(linker, "/STACK:256000000")

#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include <time.h>
#include <memory.h>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <random>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e7);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-11;
const double PI = acos(-1);
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)(0))++)

int n, w, h, m;
int64 sm[2][10010];
int64 ctr[2][10010];
int64 mn[10010];
int64 mx[10010];
bool u[5010][10010];

void add(int64 tre[], int x, int64 val)
{
	for (int i = x; i < h; i |= (i + 1))
		tre[i] += val;
}

int64 get(int64 tre[], int x)
{
	int64 res = 0;
	for (int i = x; i >= 0; i = (i & (i + 1)) - 1)
		res += tre[i];
	return res;
}

int64 get(int64 tre[], int l, int r)
{
	return get(tre, r) - get(tre, l - 1);
}

void solve()
{
	cin >> n >> w >> h >> m;
	int64 tsum = 0;
	for (int i = 0; i < n; i++)
		tsum += (int64)(i * 2 + 1) * w;
	int64 tsum2 = 0;
	for (int i = 0; i < n; i++)
		tsum2 += (int64)w * n;
	for (int i = 0; i < h; i++)
	{
		add(ctr[i & 1], i, n);
		add(sm[i & 1], i, tsum);
		add(ctr[!(i & 1)], i, n); //check
		add(sm[!(i & 1)], i, tsum2);
		mx[i] = n - 1;
		mn[i] = 0;
	}
	int res = -1;
	for (int i = 0; i < m; i++)
	{
		int l, k;
		cin >> l >> k;
		l--;
		k--;
		int64 coord = k * 2 + 1;
		add(ctr[l & 1], l, -1);
		add(sm[l & 1], l, -coord * w);
		add(ctr[!(l & 1)], l, -1); //check
		add(sm[!(l & 1)], l, -(int64)w * n);
		u[l][k] = 1;
		while (mx[l] >= mn[l] && u[l][mx[l]] == 1)
			mx[l]--;
		while (mx[l] >= mn[l] && u[l][mn[l]] == 1)
			mn[l]++;
		if (mn[l] > mx[l]) //removed last on this level
		{
			if (get(ctr[l & 1], l + 1, h - 1) != 0) //but not last on top
			{
				res = i;
				break;
			}
		}
		
		
		int64 upsm = get(sm[l & 1], l + 1, h - 1);
		int64 upctr = get(ctr[l & 1], l + 1, h - 1);
		if (upctr == 0)
			continue;
		if (upsm <= (mn[l] * 2) * upctr * w || ((mx[l] + 1) * 2) * upctr * w <= upsm)
		{
			res = i;
			break;
		}
	}
	if (res == -1)
		cout << "no";
	else
		cout << "yes\n" << res + 1;
}

#define TASK "jenga"
int main()
{
	cin.tie(0); ios_base::sync_with_stdio(false);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
	freopen(TASK ".in", "rt", stdin); freopen(TASK ".out", "wt", stdout);
#endif
	srand(88);

	solve();

	return 0;
}