#pragma comment(linker, "/STACK:256000000")

#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include <time.h>
#include <memory.h>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <utility>
#include <algorithm>
#include <functional>
#include <random>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
const int INF = (int)(1e9 + 1e7);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-11;
const double PI = acos(-1);
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)(0))++)

int h, m;
int64 n, w;
int64 sm[2][10010];
int64 ctr[10010];
int64 mn[10010];
int64 mx[10010];
bool u[5010][10010];

void solve()
{
	cin >> n >> w >> h >> m;
	int64 tsum = 0;
	for (int i = 0; i < n; i++)
		tsum += (int64)(i * 2 + 1) * w;
	int64 tsum2 = 0;
	for (int i = 0; i < n; i++)
		tsum2 += (int64)w * n;
	for (int i = 0; i < h; i++)
	{
		ctr[i] += n;
		sm[i & 1][i] += tsum;
		sm[!(i & 1)][i] += tsum2; //check
		mx[i] = n - 1;
		mn[i] = 0;
	}
	int res = -1;
	for (int tt = 0; tt < m && res == -1; tt++)
	{
		int l, k;
		cin >> l >> k;
		l--;
		k--;
		int64 coord = k * 2 + 1;
		ctr[l]--;
		sm[l & 1][l] -= coord * w;
		sm[!(l & 1)][l] -= (int64)w * n; //check
		u[l][k] = 1;
		while (mx[l] >= mn[l] && u[l][mx[l]] == 1)
			mx[l]--;
		while (mx[l] >= mn[l] && u[l][mn[l]] == 1)
			mn[l]++;
		int64 upsm[2] = { 0, 0 };
		int64 upctr = 0;
		for (int i = h - 1; i >= 0; i--)
		{
			if (mn[i] > mx[i]) //removed last on this level
			{
				if (upctr != 0) //but not last on top
				{
					res = tt;
					break;
				}
			}

			if ((upctr != 0) && 
				(upsm[i & 1] <= (mn[i] * 2) * upctr * w || ((mx[i] + 1) * 2) * upctr * w <= upsm[i & 1]))
			{
				res = tt;
				break;
			}
			
			upsm[0] += sm[0][i];
			upsm[1] += sm[1][i];
			upctr += ctr[i];
		}
	}
	if (res == -1)
		cout << "no";
	else
		cout << "yes\n" << res + 1;
}

#define TASK "jenga"
int main()
{
	cin.tie(0); ios_base::sync_with_stdio(false);
#ifdef _MY_DEBUG
	freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#else
	freopen(TASK ".in", "rt", stdin); freopen(TASK ".out", "wt", stdout);
#endif
	srand(88);

	solve();

	return 0;
}