#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef long long int lld;

#define L (-32768)
#define U 32767

int n;

void task2();

bool suit[100000];

int main() {
	task2();
	return 0;
}

bool getVal(int x) {
	return suit[x + 40000];
}

void setVal(int x) {
	suit[x + 40000] = true;
}

void task2() {

	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	for (int i = 0; i < 100000; i++) {
		suit[i] = false;
	}

	bool flag = true;
	
	while (1) {

		char line[100];
		bool hasUpper = false;
		bool hasLower = false;
		int lower;
		int upper;

		int ok;

		while (1) {
			ok = scanf("%s", line);
			if (ok != 1) {
				break;
			}
			if (strcmp(line, "||") == 0) {
				break;
			}
			if (strcmp(line, ">=") == 0) {
				hasLower = true;
				scanf("%d", &lower);
			}
			if (strcmp(line, "<=") == 0) {
				hasUpper = true;
				scanf("%d", &upper);
			}
		}
		


		if (lower > upper && hasLower && hasUpper) {
			flag = false;
		}

		if (hasUpper && !hasLower) {
			for (int i = L; i <= upper; i++) {
				setVal(i);
			}
		}
		else if (!hasUpper && hasLower) {
			for (int i = lower; i <= U; i++) {
				setVal(i);
			}
		}
		else {
			for (int i = lower; i <= upper; i++) {
				setVal(i);
			}
		}

		if (ok != 1) {
			break;
		}
	}

	char out[2000][100];
	int index = 0;

	bool hasAny = false;
	for (int i = L; i <= U; i++) {
		if (getVal(i)) {
			hasAny = true;
		}
	}

	if (!hasAny && !flag) {
		printf("false");
		return;
	}

	bool all = true;
	for (int i = L; i <= U; i++) {
		if (!getVal(i)) {
			all = false;
		}
	}

	if (all) {
		printf("true");
		return;
	}

	int ss = L;
	bool fromStart = getVal(L);
	if (fromStart) {
		for (int i = L; i <= U; i++) {
			if (!getVal(i)) {
				ss = i;
				sprintf(out[index++], "x <= %d", ss - 1);
				break;
			}
		}
	}

	int ee = U;
	bool fromEnd = getVal(U);
	if (fromEnd) {
		for (int i = U; i >= L; i--) {
			if (!getVal(i)) {
				ee = i;
				sprintf(out[index++], "x >= %d", ee + 1);
				break;
			}
		}
	}

	int start = L;
	int end = L;
	bool hasPrev = false;

	for (int i = ss; i <= ee; i++) {
		if (!hasPrev && getVal(i)) {
			start = i;
			hasPrev = true;
		}
		if (!hasPrev && !getVal(i)) {
			//
		}
		if (hasPrev && getVal(i)) {
			//
		}
		if (hasPrev && !getVal(i)) {
			end = i - 1;
			hasPrev = false;
			sprintf(out[index++], "x >= %d && x <= %d", start, end);
		}
	}

	for (int i = 0; i < index - 1; i++) {
		printf("%s ||\n", out[i]);
	}
	printf("%s", out[index - 1]);
}




























