#include <stdio.h>
#include <vector>
#include <queue>

using namespace std;

void get(int&, int&, int);

struct s {
	char c;
	int t;
	int k;
};

struct wait {
	int startwait;

};


queue<int> wait;



int main(){
	FILE* fin = fopen("expect.in", "r");
	FILE* fout = fopen("expect.out", "w");
	int n;
	int q;

	fscanf(fin, "%d", &n);
	fscanf(fin, "%d", &q);

	vector<s> sV(n);
	vector<int> Q(q);
	vector<int> Cntp(q);
	int cntp = 0;
	int cntm = 0;
	for (int i = 0; i < n; i++) {
		char c;
		int t;
		int k;
		fscanf(fin, "\n%c", &c);
		fscanf(fin, "%d", &t);
		fscanf(fin, "%d", &k);
		if (c == '+') {
			cntp += k;
		}
		else if (c == '-') {
			cntm += k;
		}
		sV[i].c = c;
		sV[i].t = t;
		sV[i].k = k;
	}

	for (int i = 0; i < q; i++) {
		fscanf(fin, "%d", &Q[i]);
		Cntp[i] = Q[i] + cntp;
	}

	fclose(fin);

	int waiter;
	int count;
	int waittime;

	for (int j = 0; j < q; j++) {
		if (Cntp[j] < cntm) {
			fprintf(fout, "INFINITY\n");
		}
		else {
			count = Q[j];
			waittime = 0;
			waiter = 0;
			while (!wait.empty()) {
				wait.pop();
			}
			for (int i = 0; i < n; i++) {
				if (sV[i].c == '-') {
					for (int k = 0; k < sV[i].k; k++) {
						wait.push(sV[i].t);
					}
				}
				else if (sV[i].c == '+') {
					count += sV[i].k;
				}
				get(count, waittime, sV[i].t);
			}
			if (wait.empty()) {
				fprintf(fout, "%d\n", waittime);
			}
			else {
				fprintf(fout, "INFINITY\n");
			}
		}
		
	}

	fclose(fout);

	return 0;
}

void get(int& Count, int& WT, int T) {
	while (!wait.empty() && Count != 0) {
		WT += T - wait.front();
		wait.pop();
		Count--;
	}
}