#include <stdio.h>
#include <vector>

using namespace std;

struct s {
	char c;
	int t;
	int k;
};


int main(){
	FILE* fin = fopen("expect.in", "r");
	FILE* fout = fopen("expect.out", "w");
	int n;
	int q;

	fscanf(fin, "%d", &n);
	fscanf(fin, "%d", &q);

	vector<s> sV(n);
	vector<int> Q(q);
	vector<int> Cntp(q);
	int cntp = 0;
	int cntm = 0;
	for (int i = 0; i < n; i++) {
		char c;
		int t;
		int k;
		fscanf(fin, "\n%c", &c);
		fscanf(fin, "%d", &t);
		fscanf(fin, "%d", &k);
		if (c == '+') {
			cntp += k;
		}
		else if (c == '-') {
			cntm += k;
		}
		sV[i].c = c;
		sV[i].t = t;
		sV[i].k = k;
	}

	for (int i = 0; i < q; i++) {
		fscanf(fin, "%d", &Q[i]);
		Cntp[i] = Q[i] + cntp;
	}

	fclose(fin);

	int waiter;
	int count;
	int waittime;
	int tlast;
	vector<int> time(n);
	vector<int> Count(n);
	time[0] = 0;
	for (int i = 1; i < n; i++) {
		time[i] = sV[i].t - sV[i - 1].t;
	}
	count = 0;
	for (int i = 0; i < n; i++) {
		if (sV[i].c == '-') {
			count -= sV[i].k;
		}
		else if (sV[i].c == '+') {
			count += sV[i].k;
		}
		Count[i] = count;
	}
	for (int j = 0; j < q; j++) {
		if (Cntp[j] < cntm) {
			fprintf(fout, "INFINITY\n");
		}
		else if (Q[j] >= cntm) {
			fprintf(fout, "0\n");
		}
		else {
			count = Q[j];
			waittime = 0;
			for (int i = 0; i < n; i++) {
				if (Count[i] + Q[j] < 0) {
					waittime += -(Count[i]+Q[j])*time[i];
				}
			}
			if (count >= 0) {
				fprintf(fout, "%d\n", waittime);
			}
			else {
				fprintf(fout, "INFINITY\n");
			}
		}
		
	}

	fclose(fout);

	return 0;
}