#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <queue>
using namespace std;

#define ISUPPER(c) ('A' <= (c) && (c) <= 'Z')
#define ISLOWER(c) ('a' <= (c) && (c) <= 'z')
#define ISDIV(c) ((c) == ','|| (c) == '.')


// ifstream cin ("hard.in");
// ifstream cout ("hard.out");

string s;

struct pr {
    int i;
    bool r;
};

int main() {
    ifstream cin ("hard.in");
    ofstream cout ("hard.out");

    auto cmp = [](pr left, pr right) {
        if (left.i == right.i) {
            return (left.r && !right.r);
        }
        return (left.i) > (right.i);
    };
    std::priority_queue<pr, std::vector<pr>, decltype(cmp)> q(cmp);

    bool sec = false;
    pr prb;
    int a = -32768, b = 32767;

    while (!cin.eof()) {
        //getline(cin, s);
        cin >> s;
        if (s[0] == 'x') continue;
        // cout << s << endl;

        switch (s[0]) {
            case 'x': continue;
            case '>':
                cin >> a;
                break;
            case '<':
                cin >> b;
                break;
            case '&':
                sec = true;
                break;
            case '|':
                if (sec && a > b) {
                    sec = false;
                    a = -32768;
                    b = 32767;
                    continue;
                }

                prb.i = a;
                prb.r = false;
                q.push(prb);
                a = -32768;

                prb.i = b;
                prb.r = true;
                q.push(prb);
                b = 32767;

                sec = false;
                break;
        }
    }

    ///
    if (sec && a > b) {
        sec = false;
        a = -32768;
        b = 32767;
    } else {
        prb.i = a;
        prb.r = false;
        q.push(prb);
        a = -32768;

        prb.i = b;
        prb.r = true;
        q.push(prb);
        b = 32767;
    }
    ///

    if (q.size() == 0) {
        cout << "false" << endl;
        return 0;
    }

    vector< pair<int, int> > v;

    // std::cout << q.top().i << (q.top().r ? "(-)" : "(+)") << " ";
    int l, r;
    l = q.top().i;
    q.pop();
    int st = 1;

    while(!q.empty()) {
        // std::cout << q.top().i << (q.top().r ? "(-)" : "(+)") << " ";
        prb = q.top();
        q.pop();
        if (!prb.r) {
            if (st == 0) l = prb.i;
            st++;
        } else {
            r = prb.i;
            st--;
        }
        if (st == 0) {
            // cout << "!(" << l << " " << r << ")! ";
            v.push_back(make_pair(l, r));
        }
    }


    int i = 0;
    bool nx;
    l = v[i].first; r = v[i].second;
    i++;
    while (i < v.size()) {
        // cout << l << " " << r << " " << v[i].first << " " << v[i].second << endl;
        if (v[i].first == r + 1) {
            r = v[i].second;
            nx = true;
        } else {
            if (l != -32768) {
                cout << "x >= " << l;
            }
            if (l != -32768 && r != 32767) cout << " && ";
            if (r != 32767) {
                cout << "x <= " << r;
            }
            cout << " ||\n";
            l = v[i].first;
            r = v[i].second;
            nx = false;
        }
        i++;
    }
    if (l != -32768 || r != 32767) {
        if (l != -32768) {
            cout << "x >= " << l;
        }
        if (l != -32768 && r != 32767) cout << " && ";
        if (r != 32767) {
            cout << "x <= " << r;
        }
        cout << "\n";
    } else {
        cout << "true\n";
    }
    cout.flush();
    /*
    for (int i = 0; i < v.size(); i++) {
        if (v[i].first != -32768) {
            cout << "x >= " << v[i].first;
        }
        if (v[i].first != -32768 && v[i].second != 32767) cout << " && ";
        if (v[i].second != 32767) {
            cout << "x <= " << v[i].second;
        }
        if (i - 1 < v.size()) cout << " ||";
        cout << endl;
    }
    */
    return 0;
}
