#include <cstdio>
#include <string>
#include <vector>
#include <iostream>

using namespace std;

struct block
{
	int n;
	int i;
	int s;
	int k;
};



vector <block> byccl;
vector <block> people;


int search(int a, int b, int k)
{
	if (a == b)
		return a;

	int c = (a + b) / 2;
	if (people[c].k <= k)
		return search(a, c, k);
	else
		return search(c + 1, b, k);
}

int main()
{
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);

	int n, q;
	scanf("%d %d", &n, &q);

	for (int i = 0; i < n; i++)
	{
		char a;
		int b, c;
		scanf("%c %d %d", &a, &b, &c);
		block temp;
		temp.i = b;
		temp.n = c;
		if (a == '-')
		{
			temp.s = i * n;
			temp.k = n;
			if (byccl.size())
			{
				temp.s += byccl[byccl.size()].s;
				temp.k += byccl[byccl.size()].k;
			}
		}

		if (a == '+')
		{
			temp.s = i * n;
			temp.k = n;
			if (people.size())
			{
				temp.s += people[people.size()].s;
				temp.k += people[people.size()].k;
			}
		}
	}

	for (int j = 0; j < q; j++)
	{
		int question;
		scanf("%d", &question);
		int i = search(0, people.size() - 1, question);
		int cost = people[i].n * people[i].i;
		int answer;
		if (i != 0)
			answer = people[people.size() - 1].s - people[i - 1].s - cost;
		else answer = people[people.size() - 1].s - cost;

		answer *= -1;
		i = search(0, byccl.size() - 1, question);
		cost = byccl[i].n * byccl[i].i;
		if (i != 0)
		{
			answer += (byccl[byccl.size() - 1].s - cost - byccl[i - 1].s);
		}
		else
			answer += (byccl[byccl.size() - 1].s - cost);

		if (byccl.size() < people.size() - question)
		{
			printf("INFINITY\n");
			continue;
		}
		if (answer <= 0)
			printf("0\n");
		else
			printf("%d\n", answer);
	}

	return 0;
}