#include <cstdio>

const int LEN = 1000000;

bool a[LEN];
int _count_w[LEN]; int len = 0;
double m[LEN];

inline int count_w(int n)
{
	return _count_w[n];
}
inline int count_w(int l, int r)
{
	return (l == 0) ? count_w(r) : (count_w(r) - count_w(l - 1));
}

int main()
{
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);

	int count = 0;
	for (char x = getchar(); x == 'C' || x == 'W'; x = getchar(), ++len)
	{
		if (x == 'W') a[len] = false, ++count;
		else a[len] = true;

		_count_w[len] = count;
	}

	int last = len-1;
	double sum = 0.0,
		sum_c = 0.0,
		sum_w = 0.0;
	for (int i = last; i >= 0; --i)
	{
		double chance = (1.0 / static_cast<double>(last-i + 1));
		double res = 0.0;//chance * static_cast<double>(a[i] ? count_w(i, last) : (last-i + 1 - count_w(i, last)));

		if (a[i]) sum_c += last-i+1;
		else sum_w += last-i+1;

		res += chance * (sum + (a[i] ? sum_w : sum_c));
		
		m[i] = res;
		sum += res;
	}

	printf("%.12lf", m[0]);

	return 0;
}