#include <cstdio>
#include <vector>
#include <iostream>
#include <algorithm>
#include <string>

using namespace std;


bool cmp(pair <int, int> a, pair <int, int> b)
{
	if (a.first == b.first)
		return a.second < b.second;
	return a.first < b.first;
}

int main()
{
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);


	vector <pair <int, int> > v;
	string s;

	do
	{
		getline(cin, s);
		int a = -32768, b = 32767;
		bool a_otr = false, b_otr = false;
		bool bol_zn = false, men_zn = false;
		bool razd = false;
		for (int i = 0; i < s.length(); i++)
		{
			if (i > 0)
				if (!razd && s[i - 1] <= '9' && s[i - 1] >= '0' && (s[i] > '9' || s[i] < '0'))
					razd = true;

			if (s[i] == '<')
				men_zn = true;
			if (s[i] == '>')
				bol_zn = true;

			if (s[i] == '-')
			{
				if (razd)
				{
					b_otr = true;
				}
				else
					a_otr = true;
			}

			if (!razd && s[i] <= '9' && s[i] >= '0')
			{
				if (a == -32768)
					a = 0;
				a *= 10;
				a += s[i] - '0';
			}

			if (razd && s[i] <= '9' && s[i] >= '0')
			{
				if (b == 32767)
					b = 0;
				b *= 10;
				b += s[i] - '0';
			}
		}

		if (a_otr)
			a *= -1;
		if (b_otr)
			b *= -1;
		if (men_zn && !bol_zn)
			v.push_back(make_pair(-32768, a));
		else
			v.push_back(make_pair(a, b));
	} while (s[s.length() - 1] == '|' && s[s.length() - 2] == '|');

	
	sort(v.begin(), v.end(), cmp);

	const int beg = 32768;
	bool a[2 * beg] = {};
	bool exit = false;

	for (int i = 0; i < v.size(); i++)
	{
		if (!(v[i].first > v[i].second))
		{
			exit = true;
		}

		for (int j = v[i].first + beg; j <= v[i].second + beg; j++)
		{
			a[j] = true;
		}
	}

	if (!exit)
	{
		cout << "false";
		return 0;
	}

	bool tr = true;
	for (int i = 0; i < 2 * beg; i++)
	{
		if (!a[i])
			tr = false;
	}

	if (tr)
	{
		cout << "true";
		return 0;
	}

	int nash = -1;
	bool fires = false;
	for (int i = 0; i < beg * 2; i++)
	{
		if (nash == -1 && a[i])
		{
			nash = i;
		}

		if (i > 0)
		{
			if (nash != -1 && (!a[i] && a[i - 1] || i == (beg * 2 - 1) && a[i]))
			{
				if (fires)
				{
					cout << " ||\n";
				}
				fires = true;
				
				if (i == (beg * 2 - 1) && a[i])
					cout << "x >= " << nash - beg;
				else
				{
					if (nash == 0)
						cout << "x <= " << i - 1 - beg;
					else
						cout << "x >= " << nash - beg << " && x <= " << i - 1 - beg;
				}
				
				nash = -1;
			}
		}
	}

	return 0;
}