#include <iostream>
#include <fstream>
#include <vector>
#include <string>

using namespace std;

const int inf = 32769;

int main()
{

    ifstream cin("hard.in");
    ofstream cout("hard.out");
    vector <bool> met(65538, false);
    string s;
    while (1) {
        getline(cin, s);
        if (s == "")
            break;
        int len = s.length();
        int a = -inf, b = inf;
        for (int i = 0; i < len; ++i) {
            if (s[i] == '>') {
                int sign1 = 1, I1 = i + 3;
                if (s[I1] == '-') {
                    sign1 = -1;
                    I1 = i + 4;
                    a = -1*(s[I1] - '0');
                }
                else
                    a = s[I1] - '0';
                for (int j = I1 + 1; ; ++j)
                    if (s[j] >= '0' && s[j] <= '9')
                        a = 10*a + sign1*(s[j] - '0');
                    else
                        break;
            }
            if (s[i] == '<') {
                int sign2 = 1, I2 = i + 3;
                if (s[I2] == '-') {
                    sign2 = -1;
                    I2 = i + 4;
                    b = -1*(s[I2] - '0');
                }
                else
                    b = s[I2] - '0';
                for (int j = I2 + 1; ; ++j)
                    if (s[j] >= '0' && s[j] <= '9')
                        b = 10*b + sign2*(s[j] - '0');
                    else
                        break;
            }
        }
        for (int x = a; x <= b; ++x)
            met[x + inf] = true;
    }

    vector <int> v;
    if (met[0])
        v.push_back(-inf);
    for (int x = -inf + 1; x < inf; ++x) {
        if (met[x + inf - 1] && !met[x + inf])
            v.push_back(x - 1);
        if (!met[x + inf - 1] && met[x + inf])
            v.push_back(x);
    }
    if (met[2*inf - 1])
        v.push_back(inf);

    if (v.empty()) {
        cout << "false\n";
        return 0;
    }

    if (v[0] == -inf && v[1] == inf) {
        cout << "true\n";
        return 0;
    }
    for (int i = 0; 2*i < v.size(); ++i) {
        if (v[2*i] == -inf)
            cout << "x <= " << v[2*i + 1];
        else if (v[2*i + 1] == inf)
            cout << "x >= " << v[2*i];
        else
            cout << "x >= " << v[2*i] << " && x <= " << v[2*i + 1];
        if (2*(i + 1) < v.size())
            cout << " ||\n";
        else
            cout << "\n";
    }

}
