#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

pair<int, int> getPart(string value){
	pair<int, int> result = pair<int, int>(-32768, 32767);
	for (int i = 0; i < value.length(); i++){

		string buffer = "";
		if (value[i] == '>' && value[i+1] == '='){
			for (int k = i + 3; k < value.length() && (value[k] >= '0' && value[k] <= '9' || value[k] == '-'); k++)
				buffer += value[k];
			result.first = atoi(buffer.c_str());
		}
		if (value[i] == '<' && value[i+1] == '='){
			for (int k = i + 3; k < value.length() && (value[k] >= '0' && value[k] <= '9' || value[k] == '-'); k++)
				buffer += value[k];
			result.second = atoi(buffer.c_str());
		}
	}

	return result;
}

bool isIntersect(pair<int, int>l, pair<int, int> r){
	return (l.first - 1 <= r.first && l.second + 1 >= r.first || l.first - 1 <= r.second && l.second + 1 >= r.second);
}

bool isCorrect(pair<int, int> value){
	return value.first <= value.second;
}

vector<pair<int, int> > result = vector<pair<int, int> >();

int main(){

	freopen("hard.in","r",stdin);
	freopen("hard.out", "w", stdout);

	string buffer;
	do{
		getline(cin, buffer);
		pair<int, int> current = getPart(buffer);
		pair<int, int> joinPart = current;
		if (isCorrect(joinPart)){
			vector<pair<int, int> > next = vector<pair<int, int> >();

			for (int i = 0; i < result.size(); i++){
				if (isIntersect(result[i], joinPart)){
					joinPart.first = min(joinPart.first, result[i].first);
					joinPart.second = max(joinPart.second, result[i].second);
				}
				else {
					next.push_back(result[i]);
				}
			}
			next.push_back(joinPart);
			result = next;
		}

	} while (buffer[buffer.length()-1] == '|');


	if (result.size() == 0){
		printf("false");
		return 0;
	}

	if (result.size() == 1 && result[0].first == -32768 && result[0].second == 32767){
		printf("true");
		return 0;
	}


	for (int i = 0; i < result.size(); i++){
		if (result[i].first > -32768)
			printf("x >= %d ", result[i].first);
		if (result[i].first > -32768 && result[i].second < 32767)
			printf("&& ");
		if (result[i].second < 32767)
			printf("x <= %d ", result[i].second);
		
		if (i != result.size() - 1){
			printf("||\n");
		}
		
	}

	//system("pause");


	return 0;
}
