#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 1e3 + 10;
const int MAXLEN = 200;

string s[MAXN];
vector<pair<int, int>> pos[MAXN];
vector<pair<int, int>> intervals;
vector<pair<int, int>> result;
bool ghb = false;

int StringToInt(string s)
{
	int res = atoi(s.c_str());
	return res;
}

// TODO: change file names

int main()
{
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	int cnt = 0;
	while (getline(cin, s[cnt++])) {
		int l = -32768;
		int r = 32767;
		string num = "";
		int i = 5;
		for (; i < s[cnt - 1].size() && s[cnt - 1][i] != ' '; i++)
		{
			num += s[cnt - 1][i];
		}
		if (s[cnt - 1][2] == '>')
		{
			l = StringToInt(num);
		}
		else r = StringToInt(num);

		if (i < s[cnt - 1].size() && s[cnt - 1][i + 2] == '&')
		{
			i += 9;
			num = "";
			for (; i < s[cnt - 1].size() && s[cnt - 1][i] != ' '; i++)
			{
				num += s[cnt - 1][i];
			}
			r = StringToInt(num);
		}
		if (l <= r)
		{
			ghb = true;
			intervals.push_back(make_pair(l, r));
		}
	}

	if (!ghb){
		cout << "false" << endl;
		return 0;
	}

	sort(intervals.begin(), intervals.end());

	pair <int, int> curPair = intervals[0];
	for (int j = 0; j < intervals.size() - 1; j++){
		if (intervals[j + 1].first - 1 <= curPair.second){
			curPair.second = max(curPair.second, intervals[j + 1].second);
		}
		else
		{
			result.push_back(curPair);
			curPair = intervals[j + 1];
		}
	}
	result.push_back(curPair);
	if (result[0].first == -32768 && result[0].second == 32767)
	{
		cout << "true" << endl;
		return 0;
	}

	int j = 0;
	for (; j < result.size() - 1; j++)
	{
		if (result[j].first == -32768)
		{
			cout << "x <= ";
			cout << result[j].second;
			cout << " ||" << endl;

		}
		else if (result[j].second == 32767)
		{
			cout << "x >= ";
			cout << result[j].first;
			cout << " ||" << endl;

		}
		else {
			cout << "x >= ";
			cout << result[j].first;
			cout << " && x <= ";
			cout << result[j].second;
			cout << " ||" << endl;
		}
	}

	if (result[j].first == -32768)
	{
		cout << "x <= ";
		cout << result[j].second;
	}
	else if (result[j].second == 32767)
	{
		cout << "x >= ";
		cout << result[j].first;
	}
	else {
		cout << "x >= ";
		cout << result[j].first;
		cout << " && x <= ";
		cout << result[j].second;
	}
	return 0;
}