#define _CRT_SECURE_NO_DEPRECATE
#define MAX(a, b) ((a) > (b)? (a) : (b))
#define MIN(a, b) ((a) < (b)? (a) : (b))
#define ABS(a) ((a) > 0? (a) : -(a))
//#define DEBUG
#include <map>
#include <set>
#include <queue>
#include <cstdio>
#include <vector>
#include <math.h>
#include <string>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

typedef long long int64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pii64;
typedef vector<int> vi;
typedef vector<int64> vi64;
typedef vector<pii> vpii;
typedef vector<pii64> vpii64;
typedef vector<vi> vvi;
typedef vector<pair<int, pii> > vipii;

inline bool isUp(char c)
{
	return ('A' <= c && c <= 'Z');
}

inline bool isLow(char c)
{
	return ('a' <= c && c <= 'z');
}

int main()
{
#ifndef DEBUG
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#else
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	char buf[125];
	char abr[120];
	int abrPos, curWrite = 0, to = 0;
	int gto = 0;
	bool word = false;
	bool needPrint = false;
	while (cin.getline(buf, 120)) {
		int pos = 0;
		curWrite = 0;
		abrPos = 0;
		while (buf[pos] != '\0') {
			if (isUp(buf[pos]) && isLow(buf[pos + 1])) {
				char toInsert = buf[pos];
				++pos;
				++pos;
				word = true;
				while (isLow(buf[pos]))
					++pos;
				if (buf[pos] == ' ' || buf[pos] == '.' || buf[pos] == ',' || buf[pos] == '\0' || buf[pos] != '\r') {
					int spaces = 0;
					while (buf[pos] == ' ' || buf[pos] == '.' || buf[pos] == ',') {
						++spaces;
						++pos;
					}
					if (!(buf[pos - 1] == '.' || buf[pos - 1] == ',') || buf[pos] == '\0' || buf[pos] == '\r') {
						if (spaces == 1 || buf[pos] == '\0' || buf[pos] == '\r') {
							gto = pos - 1;
							to = pos;
							abr[abrPos] = toInsert;
							++abrPos;
						}
						else {
							word = false;
							to = pos;
						}
					}
					else {
						word = false;
						to = pos;
					}
				}
				else {
					while (isLow(buf[pos]) || isUp(buf[pos]))
						++pos;
					while (buf[pos] == ' ' || buf[pos] == '.' || buf[pos] == ',')
						++pos;
					word = false;
					to = pos;
				}
			}
			else {
				while (isLow(buf[pos]) || isUp(buf[pos]))
					++pos;
				while (buf[pos] == ' ' || buf[pos] == '.' || buf[pos] == ',')
					++pos;
				word = false;
				to = pos;
			}
			if (word == false || buf[pos] == '\r' || buf[pos] == '\0') {
				if (abrPos > 1) {
					abr[abrPos] = '\0';
					printf("%s ", abr);
					abrPos = 0;
					printf("(");
					while (curWrite < gto)
						printf("%c", buf[curWrite++]);
					if ((buf[gto + 1] == '\0' || buf[gto + 1] == '\r') && !(buf[gto] == '.' || buf[gto] == ','))
						printf("%c", buf[curWrite++]);
					printf(")");
				}
				while (curWrite < to)
						printf("%c", buf[curWrite++]);
				abrPos = 0;
			}
			if (buf[pos] == '\r')
				break;
		}
		if (buf[pos] == '\r')
			break;
		printf("\n");
	}
	return 0;
}