def main():
    import re
    import sys

    # sys.stdin = open("abbreviation.in")
    # sys.stdout = open("abbreviation.out", "w")

    rx = re.compile(r"[A-Z][a-z]+( [A-Z][a-z]+)+")
    for line in sys.stdin:
        prev = 0
        for m in rx.finditer(line):
            a = m.start()
            b = m.end()
            if prev != a:
                print(line[prev:a], end="")
            s = m.group()
            print("".join(filter(lambda c: c.isupper(), s)), end=" (")
            print(s, end=")")
            prev = b
        if prev != len(line):
            print(line[prev:], end="")

main()
