#define _CRT_SECURE_NO_WARNINGS
#include <array>
#include <bitset>
#include <climits>
#include <cmath>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#ifdef LOCAL_PROJECT
#   include <conio.h>
#endif

#define eps 1e-8
#define forn(i, n) for (int i = 0; i < (n); i++)
#define fst first
#define snd second
#define mp make_pair
#define pb push_back
#define eb emplace_back
#define pf push_front
#define ef emplace_front
#define sz(x) (int)(x).size()
#define let const auto
#define _ << ' ' <<
#define TIMESTAMP(msg) debug << "[" msg "]: " << clock() / (double)CLOCKS_PER_SEC << '\n'

using namespace std;

struct debug_t {
    template <typename T>
    debug_t& operator<<(const T& value) {
#       ifdef LOCAL_DEBUG
        cout << value << flush;
#       endif
        return *this;
    }

    template <typename T>
    debug_t& write(const char value[ ], streamsize n) {
#       ifdef LOCAL_DEBUG
        cout.write(value, n);
        cout << flush;
#       endif
        return *this;
    }
};

using uchar = unsigned char;
using ustring = basic_string<uchar>;
using llong = long long;
using ullong = unsigned long long;
using ldouble = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vector<int>>;

char s[(int)1e6 + 1];
double dp[(int)1e6], dpSum[(int)1e6];

int main() {
#   ifdef LOCAL_PROJECT
    freopen("input.txt", "r", stdin);
#   else
    freopen("foreign.in", "r", stdin);
    freopen("foreign.out", "w", stdout);
#   endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int i;
    while (cin >> s) {
        let n = (int)strlen(s);
        llong wCount = s[n - 1] == 'W'? 1 : 0, cCount = s[n - 1] == 'C'? 1 : 0;
        double sum = 0, last = 0;
        int len = 1;
        for (i = n - 2; i >= 0; i--) {
            len++;
            if (s[i] == 'C') {
                last = (sum + wCount) / len;
                cCount += len;
            } else {
                last = (sum + cCount) / len;
                wCount += len;
            }
            sum += last;
        }
        cout << setprecision(9) << fixed << last << '\n';
    }

#   ifdef LOCAL_PROJECT
    cout << flush;
    _getch();
#   endif
}
