#include <iostream>
#include <algorithm>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <cstring>

#define NAME "expect"
#define X first
#define Y second

using namespace std;

typedef long long int64;

inline
bool comp(const pair<int64, int64> & a, const pair<int64, int64> & b) {
	return a.X < b.X;
}

int main() {
	freopen(NAME ".in", "r", stdin);
	freopen(NAME ".out", "w", stdout);

	int64 n, q, t, k, t_start = 0, k_start = 0;
	cin >> n >> q;
	char sign;
	vector<pair<int64, int64>> v(n);
	for (int i = 0; i < n; ++i) {
		cin >> sign >> t >> k;
		v[i].X = k_start + (sign == '-' ? k : -k);
		k_start = v[i].X;
		v[i].X = max(0ll, v[i].X);
		v[i].Y = t - t_start;
		t_start = t;
	}

	int lim = max(0ll, v.back().X);
	sort(v.begin(), v.end(), comp);
	vector<pair<int64, int64>> d(n);
	d.back() = v.back();
	d.back().X *= d.back().Y;
	for (int i = n - 2; i >= 0; --i) {
		d[i].X = int64(v[i].X) * int64(v[i].Y) + d[i + 1].X;
		d[i].Y = int64(v[i].Y) + d[i + 1].Y;
	}

	int qi;
	for (int i = 0; i < q; ++i) {
		cin >> qi;
		if (qi < lim) {
			cout << "INFINITY";
		}
		else {
			pair<int64, int64> qzw = make_pair(qi, 0ll);
			auto it = upper_bound(v.begin(), v.end(), qzw, comp);
			int len = distance(v.begin(), it);
			if (it == v.end()) {
				cout << 0;
			}
			else {
				cout << (d[len].X - qi * d[len].Y);
			}
		}
		cout << endl;
	}

	return 0;
}
