#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <string>

using namespace std;
#define FOR(i,n) for(int (i) = 0; (i) < (int)(n); ++(i))
#define forn(i,n) for(int (i) = 0; (i) < (int)(n); ++(i))
#define for1(i,n) for(int (i) = 1; (i) <= (int)(n); ++(i))
#define sz(v) (int)v.size()
#define pb push_back
#define mp make_pair

typedef long long LL;
const int N = 1000 + 10;
const int M = N * 10 * 10;

int n, k, ms, me;
int a, b;
int s[N], e[N];

int so, si, nf;

int tope;
int la[N];
int f[M], u[M], c[M], to[M], v[M], ne[M];


int ind[N];

void add_edge(int v, int to, int u, int c){
	::to[tope] = to;
	::v[tope] = v;
	::u[tope] = u;
	::c[tope] = c;
	ne[tope] = la[v];
	la[v] = tope;

	++tope;
	::to[tope] = v;
	::v[tope] = to;
	::u[tope] = 0;
	::c[tope] = -c;
	ne[tope] = la[to];
	la[to] = tope;
	++tope;
}

int add(int l, int r, int c){
	l -= (k - 1);
	r -= (k - 1);
	int tp = tope;
	add_edge(l - 1, r, 1, -c);
	return tp;
}
void buildinit(){
	memset(ne, -1, sizeof ne);
	memset(la, -1, sizeof la);
	so = 0;
	si = (n - k + 1);
	nf = si + 1;
	for1(i, si)
		add_edge(i - 1, i, b - a, 0);
}
int qu[N];
LL d[N];
const LL INF = (LL)1000000000 * 1000000000;

int inqu[N];
int p[N];
LL bellman(){
	int st = 0, fi = 0;
	forn(i, nf){
		d[i] = INF;
		inqu[i] = 0;
		p[i] = -1;
	}
	d[so] = 0;
	qu[fi++] = so;
	inqu[so] = 1;
	while (st != fi){
		int v = qu[st++];
		inqu[v] = 0;

		if (st == N)st = 0;
		for (int in = la[v]; in != -1; in = ne[in]){
			int to = ::to[in];
			if (u[in] > f[in] && d[to] > d[v] + c[in]){
				d[to] = d[v] + c[in];
				p[to] = in;
				if (!inqu[to]){
					qu[fi++] = to;
					if (fi == N)
						fi = 0;
					inqu[to] = 1;
				}
			}
		}
	}
	int cr = si;
	while (cr != -1 && p[cr] != -1){
		int in = p[cr];
		++f[in];
		--f[in ^ 1];
		cr = v[in];
	}
	return d[si];
}
LL mincostflow(){
	LL res = 0;
	for1(it, b){
		LL G = bellman();
		res += G;
	}
	return res;
}
void solve() {
	scanf("%d%d%d%d", &n, &k, &ms, &me);
	for1(i, n)
		scanf("%d", &s[i]);
	for1(i, n)
		scanf("%d", &e[i]);
	a = ms, b = k - me;
	LL S = 0;
	for1(i, n)
		S += e[i];

	buildinit();
	for1(i, n){
		int l = max(i, k), r = min(n, i + k - 1);
		ind[i] = add(l, r, s[i] - e[i]);
	}
	LL res = mincostflow();
	printf("%lld\n", (-res) + S);
	for1(i, n){
		//ok
		if (f[ind[i]])
			printf("S");
		else
			printf("E");
	}
	puts("");
	//s[i]-e[i]
}

int main(){
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
#define task "delight"
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
#endif
	solve();
	return 0;
}