#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <set>
#include <string>
#include <map>

using namespace std;
typedef long long ll;
const int INF = 1000 * 1000 * 1000 + 7;

struct tab{
	double x;
	int l, r;
	int m;
};
tab TAB[10000 + 3];
int n, h, m;
bool M[5000 + 3][5000 + 3];
bool han(int l, int k){
	M[l][k] = 1;
	tab* t = &TAB[l];
	t->x = (t->x*(t->m) - (k - 0.5)) / (t->m - 1);
	t->m--;
	for (; t->l <= n; t->l++){
		if (M[l][t->l] == 0){
			break;
		}
	}
	for (; t->r >0; t->r--){
		if (M[l][t->r] == 0){
			break;
		}
	}
	if (t->l == n + 1 && t->r == 0){
		return 0;
	}



	//////////////
	int m0;
	double x0, y0;
	m0 = 0;
	x0 = y0 = n*0.5;
	for (int hh = h; hh > 0; hh--){
		//printf("%0.3f %0.3f %d", x0, y0, hh);
		if (hh != h){
			if (hh % 2 == 0){//zuyg
				if (!(y0 > TAB[hh].l - 1 && y0 < TAB[hh].r)){
					return 0;
				}
			}
			if (hh % 2 == 1){//kent
				if (!(x0 > TAB[hh].l - 1 && x0 < TAB[hh].r)){
					return 0;
				}
			}
		}


		if (hh % 2 == 0){//zuyg
			y0 = (y0*m0 + TAB[hh].x*TAB[hh].m) / (m0 + TAB[hh].m);
			m0 = m0 + TAB[hh].m;
		}
		if (hh % 2 == 1){//kent
			x0 = (x0*m0 + TAB[hh].x*TAB[hh].m) / (m0 + TAB[hh].m);
			m0 = m0 + TAB[hh].m;
		}
	}

	return 1;
}

int main(){
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	scanf("%d%d%d%d", &n, &h, &h, &m);
	for (int i = 1; i <= h; i++){
		TAB[i].m = n;
		TAB[i].x = n *0.5;
		TAB[i].l = 1;
		TAB[i].r = n;
	}

	//bool blec = 1;
	for (int i = 1; i <= m; i++){
		int l, k;
		scanf("%d%d", &l, &k);
		if (han(l, k) == 0){
			printf("yes\n%d\n", i);
			return 0;
		}
	}
	printf("no\n");

	return 0;
}