import sys
inp = open('abbreviation.in', 'r')
out = open('abbreviation.out', 'w')
'''
inp = sys.stdin
out = sys.stdout
'''

def is_cap(word):
	if len(word) < 2:
		return False
	if word[0].lower() == word[0]:
		return False
	for ch in word[1:]:
		if ch.upper() == ch:
			return False
	return True

def abbr(caps, res):
	# Abbreviate
	abr = ''
	#print (caps)
	for i in range(0, len(caps), 2):
		abr += caps[i][0]
	last_space = caps[-1] == ' '
	res.append(abr)
	res.append(' (')
	res.extend(caps)
	if last_space:
		res.pop()
	res.append(')')
	if last_space:
		res.append(' ')

while True:
	line = inp.readline()
	if len(line) == 1:
		break
	line = line[:-1]
	
	tokens = []
	cur_word = ''
	cur_pun = ''
	for ch in line:
		if ch.isalpha():
			if len(cur_pun) != 0:
				tokens.append(cur_pun)
				cur_pun = ''
			cur_word += ch
		else:
			if len(cur_word) != 0:
				tokens.append(cur_word)
				cur_word = ''
			cur_pun += ch
	if len(cur_word) != 0:
		tokens.append(cur_word)
	if len(cur_pun) != 0:
		tokens.append(cur_pun)

	#print (tokens)

	res = []
	caps = []
	in_caps = 0
	i = 0
	while i < len(tokens):
		#print (res, 'r')
		#print (caps, 'c')
		if i & 1 == 1 and tokens[i] == ' ':
			if len(caps) > 0:
				caps.append(tokens[i])
			else:
				res.append( ' ' )
		elif i & 1 == 0 and is_cap(tokens[i]):
			caps.append(tokens[i])
			in_caps += 1
		else:
			if in_caps > 1:
				abbr(caps, res)
			else:
				res.extend( caps )  
			caps = []
			in_caps = 0
			res.append( tokens[i] )
		i += 1

	if len(caps) != 0:
		if in_caps > 1:
			abbr(caps, res)
		else:
			res.extend(caps)

	out.write(''.join(res) + '\n')
	



