#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define fori(n) for(int i = 0; i < n; i++)


ifstream fin("hard.in");
ofstream fout("hard.out");

int MIN = -32768, MAX = 32767;

int read_int() {
    char c;
    int res = 0;
    bool flag = true;
    while (fin >> c) {
        if (c == '-') {
            flag = false;
            continue;
        }
        if (c == '|' || c == '&') {
            break;
        }
        res = res * 10 + c - '0';
    }
    if (!flag) {
        res = -res;
    }
    return res;
}

pair<int, int> read_bounds() {
        int l = MIN;
        int r = MAX;
        char c;
        fin >> c;
        if (c == '<') {
            fin >> c;
            r = min(r, read_int());
        } else {
            fin >> c;
            l = max(l, read_int());
        }
        return make_pair(l, r);
}

int main() {
    char c;
    vector<pair<int, int>> ps;

        int l = MIN;
        int r = MAX;
        while (fin >> c) {
            pair<int, int> bounds = read_bounds();
            l = max(l, bounds.first);
            r = min(r, bounds.second);
            fin >> c;
            if (c == '|') {
                if (l > r) {
                    fout << "false";
                    return 0;
                }
                bool f = true;
                vector<pair<int, int>> p;
                for (int i = 0; i < ps.size(); ++i) {
                    if (ps[i].first <= l && ps[i].second >= r) {
                        f = false;
                        break;
                    }
                    if (ps[i].first >= l && ps[i].first <= r) {
                        r = max(r, ps[i].second);
                        continue;
                    }
                    if (ps[i].second >= l && ps[i].second <= r) {
                        l = min(l, ps[i].first);
                        continue;
                    }
                    if (ps[i].second + 1 == l) {
                        l = ps[i].first;
                        continue;
                    }
                    if (ps[i].first == r + 1) {
                        r = ps[i].second;
                        continue;
                    }
                    p.push_back(ps[i]);
                }
                if (f) {
                    p.push_back(make_pair(l, r));
                    ps = p;
                }
                l = MIN;
                r = MAX;
            }
        }
                if (l > r) {
                    fout << "false";
                    return 0;
                }
                bool f = true;
                vector<pair<int, int>> p;
                for (int i = 0; i < ps.size(); ++i) {
                    if (ps[i].first <= l && ps[i].second >= r) {
                        f = false;
                        break;
                    }
                    if (ps[i].first >= l && ps[i].first <= r) {
                        r = max(r, ps[i].second);
                        continue;
                    }
                    if (ps[i].second >= l && ps[i].second <= r) {
                        l = min(l, ps[i].first);
                        continue;
                    }
                    if (ps[i].second + 1 == l) {
                        l = ps[i].first;
                        continue;
                    }
                    if (ps[i].first == r + 1) {
                        r = ps[i].second;
                        continue;
                    }
                    p.push_back(ps[i]);
                }
                if (f) {
                    p.push_back(make_pair(l, r));
                    ps = p;
                }
                l = MIN;
                r = MAX;
    if (ps[0].first == MIN && ps[0].second == MAX) {
        fout << "true";
        return 0;
    }
    if (ps[0].first != MIN) {
        fout << "x >= " << ps[0].first << " ";
    }
    if (ps[0].second != MAX) {
        if (ps[0].first != MIN) {
            fout << "&& ";
        }
        fout << "x <= " << ps[0].second << " ";
    }
    for (int i = 1; i < ps.size(); ++i) {
        fout << "||" << endl;
        if (ps[i].first != MIN) {
            fout << "x >= " << ps[i].first << " ";
        }
        if (ps[i].second != MAX) {
            if (ps[i].first != MIN) {
                fout << "&& ";
            }
            fout << "x <= " << ps[i].second << " ";
        }
    }
    fin.close();
    fout.close();
    return 0;
}
