#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define fori(n) for(int i = 0; i < n; i++)


ifstream fin("hard.in"); //abbreviation hard
ofstream fout("hard.out");

int MIN = -32768, MAX = 32767;

int read_int() {
    int res;
    fin >> res;
    char c;
    fin >> c;

    return res;
}

pair<int, int> read_bounds() {
        int l = MIN;
        int r = MAX;
        char c;
        fin >> c;
        if (c == '<') {
            fin >> c;
            r = min(r, read_int());
        } else {
            fin >> c;
            l = max(l, read_int());
        }
        return make_pair(l, r);
}

int check_abb(string s, int index) {
    if (index + 1 >= s.length()) {
        return -1;
    }
    if (!(s[index] >= 'A' && s[index] <= 'Z')) {
        return -1;
    }
    for (int i = index + 1; i < s.length(); ++i) {
        if (s[i] == ' ' || s[i] == ',' || s[i] =='.') {
            return i;
        }
        if (!(s[i] >= 'a' && s[i] <= 'z')) {
            return -1;
        }
    }
    return s.length() - 1;
}

int main() {
    // first - time,
    // second - count
    /*
    stack<pair<int, int>> req, drop;
    char ch;

    int n, q, t, k;

    for (inr  i = 0; i < n; ++i)
    {
        fin >> ch;

        if (ch == '+')
        {

        }
    }*/
    /*
    string s;
    while (getline(fin, s)) {
        string res = "";
        string part = "";
        string abb = "";
        for (int i = 0; i < s.length(); ++i) {
            int ind = check_abb(s, i);
            if (ind != -1 && ind != i + 1) {
                abb += s[i];
                for (; i < ind; ++i) {
                    part += s[i];
                }
            } else {
                if (abb.length() > 1) {
                    res = res + abb + " (" + part + ")" + s[i];
                } else {
                    res = res + part;
                }
                part = "";
                abb = "";
                for (; i < s.length(); ++i) {
                    if (s[i] == ' ' || s[i] == '.' || s[i] == ',') {
                        res = res + s[i];
                        break;
                    }
                    res = res + s[i];
                }
                if (s[i] == ',' || s[i] == '.') {
                    if (abb.length() > 1) {
                        res = res + abb + " (" + part + ")";
                    } else {
                        res = res + part;
                    }
                }
            }
        }
                if (abb.length() > 1) {
                    res = res + abb + " (" + part + ")";
                } else {
                    res = res + part;
                }
        fout << res << endl;
    }
*/

    char c;
    vector<pair<int, int>> ps;

        int l = MIN;
        int r = MAX;
        while (fin >> c) {
            pair<int, int> bounds = read_bounds();
            l = max(l, bounds.first);
            r = min(r, bounds.second);
            fin >> c;
            if (c == '|') {
                if (l > r) {
                        continue;
                }
                bool f = true;
                vector<pair<int, int>> p;
                for (int i = 0; i < ps.size(); ++i) {
                    if (ps[i].first <= l && ps[i].second >= r) {
                        f = false;
                        break;
                    }
                    if (ps[i].first >= l && ps[i].first <= r) {
                        r = max(r, ps[i].second);
                        continue;
                    }
                    if (ps[i].second >= l && ps[i].second <= r) {
                        l = min(l, ps[i].first);
                        continue;
                    }
                    if (ps[i].second + 1 == l) {
                        l = ps[i].first;
                        continue;
                    }
                    if (ps[i].first == r + 1) {
                        r = ps[i].second;
                        continue;
                    }
                    p.push_back(ps[i]);
                }
                if (f) {
                    p.push_back(make_pair(l, r));
                    ps = p;
                }
                l = MIN;
                r = MAX;
            }
        }
                if (l <= r) {
                bool f = true;
                vector<pair<int, int>> p;
                for (int i = 0; i < ps.size(); ++i) {
                    if (ps[i].first <= l && ps[i].second >= r) {
                        f = false;
                        break;
                    }
                    if (ps[i].first >= l && ps[i].first <= r) {
                        r = max(r, ps[i].second);
                        continue;
                    }
                    if (ps[i].second >= l && ps[i].second <= r) {
                        l = min(l, ps[i].first);
                        continue;
                    }
                    if (ps[i].second + 1 == l) {
                        l = ps[i].first;
                        continue;
                    }
                    if (ps[i].first == r + 1) {
                        r = ps[i].second;
                        continue;
                    }
                    p.push_back(ps[i]);
                }
                if (f) {
                    p.push_back(make_pair(l, r));
                    ps = p;
                }
                l = MIN;
                r = MAX;
                }
    if (ps.size() == 0) {
        fout << "false";
        return 0;
    }
    if (ps[0].first == MIN && ps[0].second == MAX) {
        fout << "true";
        return 0;
    }
    if (ps[0].first != MIN) {
        fout << "x >= " << ps[0].first << " ";
    }
    if (ps[0].second != MAX) {
        if (ps[0].first != MIN) {
            fout << "&& ";
        }
        fout << "x <= " << ps[0].second << " ";
    }
    for (int i = 1; i < ps.size(); ++i) {
        fout << "||" << endl;
        if (ps[i].first != MIN) {
            fout << "x >= " << ps[i].first << " ";
        }
        if (ps[i].second != MAX) {
            if (ps[i].first != MIN) {
                fout << "&& ";
            }
            fout << "x <= " << ps[i].second << " ";
        }
    }
    fin.close();
    fout.close();
    return 0;
}
