#include <iostream>
#include <vector>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <algorithm>

using namespace std;


double p[1000000];
int n;
string str;

int main()
{
    freopen("foreign.in", "r", stdin);
    freopen("foreign.out", "w", stdout);
    cin >> str;
    n = str.length();
    p[0] = 1;
    double ans = 0;
    p[1] = 1.0 / (n);
    for (int i = 2; i < n; i++) {
        p[i] = p[i - 1] + p[i - 1] / (n - i + 1);
    }
    for (int i = 0; i < n; i++) {
        p[i] /= (n - i);
    }
    double g = 0, b = 0;
    for (int i = 0; i < n; i++) {
        if (str[i] == 'C') {
            ans += b * (n - i);
            g += p[i];
        }
        else {
            ans += g * (n - i);
            b += p[i];
        }
    }
    printf("%.12lf\n", ans);
    return 0;
}
