#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <string>
#include <fstream>
#include <list>
#include <algorithm>
#include <memory>
#include <sstream>
using namespace std;
#define ll long long
#define ull unsigned long long
#define ld long double
typedef int int32;
typedef ll int;
typedef pair <int,int> pii;
typedef vector<int> vi;

string file = "abbreviation";
void run();
int32 main(){
	cout << fixed << setprecision(13);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
#ifdef RAU2
	freopen("in.txt", "r", stdin);
#else
	freopen((file + ".in").c_str(), "r", stdin);
	freopen((file + ".out").c_str(), "w", stdout);
#endif
	run();
	return 0;
}

bool is_let(char ch) {
	return ('a' <= ch && ch <= 'z') || ('A' <= ch && ch <= 'Z');
}

bool is_cap_word(const string& str) {
	for (int i = 1; i < str.length(); ++i) {
		if (!('a' <= str[i] && str[i] <= 'z'))
			return false;
	}
	return 'A' <= str[0] && str[0] <= 'Z' && str.length() > 1;
}

void run(){
	
	string line;

	while (getline(cin, line))
	{
		vector <string> words;
		vector <string> spaces;
		vector <string> abbr;
		string temp = "";

		int wstart = 0, sstart = 0;

		for (int i = 0; i < line.length(); ++i) {
			if (is_let(line[i])) {
				temp += line[i];
			}
			else {
				words.push_back(temp);
				temp = "";
				while (i < line.length() && !is_let(line[i])) { temp += line[i]; i++; }
				spaces.push_back(temp);
				temp = "";
				i--;
			}
		}
		if (temp != "") {
			if (is_let(temp[0]))
				words.push_back(temp);
			else
				spaces.push_back(temp);
		}

		
		for (int i = 0; i < words.size(); ++i) {
			abbr.clear();
			int ttt = i;
			while (i < words.size() && is_cap_word(words[i])) {
				abbr.push_back(words[i]);
				
				if ( i >= spaces.size() || spaces[i] != " ") {
					i++;
					break;
				}
				i++;
			}
			if (ttt != i) i--;
			

			if (abbr.size() > 1) {
				for (int j = 0; j < abbr.size(); ++j) {
					cout << abbr[j][0];
				}
				cout << " (";
				for (int j = 0; j < abbr.size(); ++j) {
					cout << abbr[j];
					if (j != abbr.size()-1) cout << " ";
				}
				cout << ")";
				if ( i < spaces.size() )
					cout << spaces[i];
				abbr.clear();
			}
			else {
				cout << words[i];
				if (i < spaces.size())
					cout << spaces[i];
			}
			
		}

		/*
		cout << "\n\n***!!!!!****\n\n";
		for (int i = 0; i < words.size(); ++i) {
			cout << words[i] << endl;
		}
		cout << endl;
		for (int i = 0; i < spaces.size(); ++i) {
			cout << spaces[i] << "?" << spaces[i].length() << endl;
		}
		*/
		cout << endl;
	}

}

/*
ab Ab A Abc AB Abcd ABc Abcde AbC
*/

/*
This is ACM North Eastern European Regional Contest,
sponsored by International Business Machines.
The. Best. Contest. Ever.
A Great Opportunity for all contestants.
*/