#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <string>
#include <fstream>
#include <list>
#include <algorithm>
#include <memory>
#include <sstream>
using namespace std;
#define ll long long
#define ull unsigned long long
#define ld long double
typedef int int32;
typedef ll int;
typedef pair <int,int> pii;
typedef vector<int> vi;

string file = "foreign";
void run();
int32 main(){
	cout << fixed << setprecision(13);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
#ifdef RAU2
	freopen("in.txt", "r", stdin);
#else
	freopen((file + ".in").c_str(), "r", stdin);
	freopen((file + ".out").c_str(), "w", stdout);
#endif
	run();
	return 0;
}

bool is_let(char ch) {
	return ('a' <= ch && ch <= 'z') || ('A' <= ch && ch <= 'Z');
}

bool is_cap_word(const string& str) {
	for (int i = 1; i < str.length(); ++i) {
		if (!('a' <= str[i] && str[i] <= 'z'))
			return false;
	}
	return 'A' <= str[0] && str[0] <= 'Z' && str.length() > 1;
}

void run(){
	
	string s;
	cin >> s;
	vector<int> Cs(s.size() + 1),  Ws(s.size() + 1);
	vector<int> Csum(s.size() + 1), Wsum(s.size() + 1);
	for (int i = 1; i < s.size(); ++i){
 		Csum[s.size() - i - 1] = Csum[s.size() - i];
		Wsum[s.size() - i - 1] = Wsum[s.size() - i];
		Csum[s.size() - i - 1] = Csum[s.size() - i] + (s[s.size() - i] == 'C') * i;

		//Csum[s.size() - i - 1] += Cs[s.size() - i - 1] += Cs[s.size() - i] + ( s[s.size() - i] == 'C' );
		Wsum[s.size() - i - 1] = Wsum[s.size() - i] + (s[s.size() - i] == 'W') * i;
			//Ws[s.size() - i] += Ws[s.size() - i + 1] + ( s[s.size() - i + 1] == 'W' );
	}
	vector<double> Ms(s.size(), 0);
	int nums = 1;
	double SUM = 0;
	for (int i = s.size() - 1; i >= 0; --i){
		Ms[i] = SUM;
		if (s[i] == 'C')
			Ms[i] += Wsum[i];
		else
			Ms[i] += Csum[i];
		Ms[i] /= nums;
		++nums;
		SUM += Ms[i];
	}

	cout << Ms[0] << endl;
}

/*
ab Ab A Abc AB Abcd ABc Abcde AbC
*/

/*
This is ACM North Eastern European Regional Contest,
sponsored by International Business Machines.
The. Best. Contest. Ever.
A Great Opportunity for all contestants.
*/