#include <iostream>
#include <string>
#include <algorithm>
#include <sstream>

using namespace std;

const int N = 50000; 
const int S = 2 * N + 100;
const int Gleft = -32768;
const int Gright = 32767;
bool a[S];


bool shouldEnter;
void enterIfNecessary()
{
	if (shouldEnter) {
		shouldEnter = false;
		cout << " ||\n";
	}
}
void mark(int x, int y)
{
	for (int i = x + N; i <= y + N; ++i) {
		a[i] = true;
	}
}

void mark(int x, bool more)
{
	if (more) {
		mark(x, S - N - 1);
	}
	else {
		mark(-N, x);
	}
}

bool iffalse()
{
	for (int i = Gleft + N; i <= Gright + N; ++i) {
		if (a[i] == true) {
			return false;
		}
	}
	return true;
}
bool iftrue()
{
	for (int i = Gleft + N; i <= Gright + N; ++i) {
		if (a[i] == false) {
			return false;
		}
	}
	return true;

}
int main()
{
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
	string s;
	while (getline(cin, s)) {
		istringstream fin(s);
		char c;
		fin >> c; //x
		if (s.find('&') != -1) {
			int left, right;
			fin >> c; //>
			fin >> c; //=
			fin >> left; //num
			fin >> c; //&
			fin >> c; //&
			fin >> c; //x
			fin >> c; //<
			fin >> c; //=
			fin >> right; //num
			mark(left, right);
		}
		else {
			char comp;
			fin >> comp;
			fin >> c;
			int num;
			fin >> num;
			mark(num, comp == '>');
		}
	}
		if (iftrue()) {
			cout << "true" << endl;
			return 0;
		}
		if (iffalse()) {
			cout << "false" << endl;
			return 0;
		}
		int left, right;
		left = -1;
		int i = Gleft + N;

		if (a[i] == true) {
			while (i < S && a[i])
			{
				a[i] = false;
				++i;
			}
			cout << "x <= " << i - N - 1;
			shouldEnter = true;
		}

		int li = Gright + N;
		if (a[li - 1] == true) {
			while (li >= 0 && a[li] == true) 
			{
				a[li] = false;
				--li;
			}
			enterIfNecessary();
			cout << "x >= " << li - N + 1;
			shouldEnter = true;
		}
		for (int j = i; j < S; ++j) {
			if (a[j]) {
				if (left == -1) {
					left = j;
				}
				
			}
			else {
				if (left != -1) {
					enterIfNecessary();
					shouldEnter = true;
					cout << "X >= " << left - N << " && x <= " << j - 1 - N;
					left = -1;
				}
			}
		

	}
	

}