#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <string.h>
#include <algorithm>
#include <set>
using namespace std;

double sum[10005];
int cnt[10005];
set <int> s[10005];

int n;
int h;
int w;

int upd(int ly, int pos) {
	--cnt[ly];
	sum[ly] -= pos - 0.5;
	s[ly].erase(pos);

	if (cnt[ly] == 0) {
		return 1;
	}

	double x = 0, y = 0;
	for (int i = h; i > 0; --i) {
		if (i == h) {
			if (i & 1) {
				x += (double)sum[i] / (double)cnt[i];
				y += (double)n / 2.0;
			}
			else {
				y += (double)sum[i] / (double)cnt[i];
				x += (double)n / 2.0;
			}
			continue;
		}

		// cout << "center of mass: " << x << " " << y << endl;

		double cx = x / (double)(h - i);
		double cy = y / (double)(h - i);

		//cout << i << " " << "center of mass: " << cx << " " << cy << "   " << x << " " << y<< endl;

		

		double chl, chr;

		chr = (double)(*(--s[i].end()));
		//chr *= w;
		chl = (double)(*s[i].begin());
		chl = (chl - 1);

		//cout << chl << " " << chr << endl;

		if (i & 1) {
			if (cx <= chl || cx >= chr) {
				return 1;
			}
		}
		else {
			if (cy <= chl || cy >= chr) {
				return 1;
			}
		}

		if (i & 1) {
			x += (double)sum[i] / (double)cnt[i] - 0.5;
			y += (double)n / 2.0;
		}
		else {
			y += (double)sum[i] / (double)cnt[i] - 0.5;
			x += (double)n / 2.0;
		}
	}
}

int main() {
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	
	int q;
	scanf("%d %d %d %d", &n, &w, &h, &q);

	for (int i = 1; i <= h; ++i) {
		for (int j = 1; j <= n; ++j) s[i].insert(j);
		cnt[i] = n;
		sum[i] = (n*(n - 1)) / 2;
		sum[i] += (double)n / 2.0;
	}

	for (int i = 0; i < q; ++i) {
		int ly, pos;
		scanf("%d %d", &ly, &pos);

		if (upd(ly, pos)) {
			printf("yes\n%d\n", i + 1);
			return 0;
		}
	}

	printf("no\n");
	return 0;
}

/*

5 2
6 6
4 1
4 2
4 5
5 3
4 3
1 1


3 3
10 1
10 3

2 2
2 1
1 1

*/