#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <algorithm>
#include <cmath>
#include <queue>
#include <map>

#define files(in,out) freopen(in, "r", stdin);freopen(out,"w",stdout);

using namespace std;

struct bl{
	int _min, _max;
	bl(int _mi,int _ma){
		_min = _mi;
		_max = _ma;
	}
};

bool mergeable(bl &a,bl &b){
	return (b._min <= a._max || abs(a._max - b._min) == 1);
}

int main(){
	files("hard.in", "hard.out");

	vector<bl> v;
	bool isEOF = false;
	do{
		int _min = 32768, _max = -32769;
		char c; int x;
		while (true){
			scanf("x %c= %d", &c, &x);
			if (c == '>'){
				if (_min > x)
					_min = x;
			}
			else {
				if (_max < x)
					_max = x;
			}

			if (scanf(" %c", &c) == EOF){
				isEOF = true;
				break;
			}
			getchar();
			getchar();
			if (c != '&')
				break;
		}
		if (_min == 32768)
			_min = -32768;
		if (_max == -32769)
			_max = 32767;
		v.push_back({ _min, _max });
	} while (!isEOF);

	sort(v.begin(), v.end(), [](bl a, bl b){
		return a._min < b._min;
	});

	vector<bl> ans;
	int z;
	for (z = 0; z < v.size(); z++){
		if (v[z]._min > v[z]._max)
			continue;
		ans.push_back(v[z]);
		break;
	}
	for (int i = z+1; i < v.size(); i++){
		if (v[i]._min > v[i]._max)
			continue;
		if (mergeable(ans.back(), v[i]))
			ans.back()._max = max(ans.back()._max, v[i]._max);
		else
			ans.push_back(v[i]);
	}

	if (!ans.size())
		return printf("false"),0;
	if (ans.size() == 1
		&& ans.front()._min == -32768 && ans.back()._max == 32767)
		return printf("true"),0;

	for (int i = 0; i < ans.size(); i++){
		bl a = ans[i];
		bool b = a._min != -32768;
		if (b){
			printf("x >= %d ", a._min);
		}
		if (a._max != 32767){
			if (b) printf("&& ");
			printf("x <= %d ", a._max);
		}
		if(i<ans.size()-1)
			printf("||\n");
	}

	return 0;
}