#include <iostream>
#include <vector>

using namespace std;

int main() {
    string s;
    freopen("foreign.in", "r", stdin);
    freopen("foreign.out", "w", stdout);
    cin >> s;
    long long n = s.length();
    vector<long long> wsum(n, 0);
    vector<long long> csum(n, 0);
    s[n-1] == 'C'? csum[n-1] = 1 : wsum[n-1] = 1;
    for (long long i=n-2; i>=0; i--) {
        wsum[i] = wsum[i+1] + (n-i) * (s[i] == 'W');
        csum[i] = csum[i+1] + (n-i) * (s[i] == 'C');
    }
    vector<double> p(n, 0);
    vector<double> psum(n, 0);
    for (long long i=n-2; i>=0; i--) {
        if (s[i] == 'W') {
            p[i] = (psum[i+1] + csum[i+1]) * 1.0 / (n - i);
        } else {
            p[i] = (psum[i+1] + wsum[i+1]) * 1.0 / (n - i);
        }
        psum[i] = psum[i+1] + p[i];
    }
    printf("%.9f\n", p[0]);
}
