

intervals = []
MAX = 32767
MIN = -32768


def add_int(x):
    if x[1] == '>=':
        intervals.append((int(x[2]), MAX))
    else:
        intervals.append((MIN, int(x[2])))


with open("hard.in") as open_file:
    data = open_file.readlines()
    for x in data:
        x = x.rstrip("||\n")
        x = x.split()
        if len(x) == 3:
            add_int(x)
        if len(x) == 7:
            first = int(x[2])
            second = int(x[6])
            if first <= second:
                intervals.append((first, second))

def sort_func(x):
    return x[0]

intervals = sorted(intervals, key=sort_func)

ans = []

for cur in intervals:
    if len(ans) == 0:
        ans.append(cur)
    elif ans[-1][1] + 1 >= cur[0] and ans[-1][1] <= cur[1]:
        ans[-1] = (ans[-1][0], cur[1])
    elif ans[-1][1] <= cur[0]:
        ans.append(cur)

with open("hard.out", "w") as open_file:
    if len(ans) == 0:
        open_file.write("false")
    elif len(ans) == 1 and ans[0][0] == MIN and ans[0][1] == MAX:
        open_file.write("true")
    else:
        for interval in ans:
            if interval[0] == MIN:
                open_file.write("x <= {}".format(interval[1]),)
            elif interval[1] == MAX:
                open_file.write("x >= {}".format(interval[0]))
            else:
                open_file.write("x >= {} && x <= {}".format(interval[0], interval[1]))
            if ans[-1] != interval:
                open_file.write(" ||\n")
