#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>
#include <vector>

using namespace std;

struct listindex {
    int start, mend;
    vector<bool> *addr;
    int cnt;
    float value;
};

int main() {
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);

    int n, m;
    int w, h;
    cin >> n >> w;
    cin >> h >> m;

    vector<listindex> vec;

    for (int i=0; i<h; i++) {
        listindex cur;
        cur.addr = new vector<bool>(n, true);
        cur.cnt = n;
        cur.value = n / 2.0;
        cur.start = 0;
        cur.mend = n-1;
        vec.push_back(cur);
    }

    for (int i=0; i<m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        (*vec[a].addr)[b] = false;

        vec[a].value = (vec[a].value * vec[a].cnt - (b + 0.5)) / (vec[a].cnt-1);
        vec[a].cnt--;

        if (vec[a].cnt == 0) {
            cout << "yes\n" << i+1 << endl;
            break;
        }

        if (b == vec[a].start) {
            for (int j=vec[a].start; j<=vec[a].mend; j++) {
                if ((*vec[a].addr)[j] == true) {
                    vec[a].start = j;
                    break;
                }
            }
        } else if(b == vec[a].mend) {
            for (int j=vec[a].mend; j>=vec[a].start; j--) {
                if ((*vec[a].addr)[j] == true) {
                    vec[a].mend = j;
                    break;
                }
            }
        }

        float x, y;
        x = y = n / 2.0;
        int cnt = 0;
        for (int j=h-1; j>0; j--) {
            if (j % 2) {
                x = (x * cnt + vec[j].value * vec[j].cnt) / (cnt + vec[j].cnt);
                y = (y * cnt + (n / 2.) * vec[j].cnt) / (cnt + vec[j].cnt);
                if (!(y > 0.0 + vec[j-1].start && y < vec[j-1].mend + 1.)) {
                    cout << "yes\n" << i+1 << endl;
                    return 0;
                }

            } else {
                x = (x * cnt + (n / 2.) * vec[j].cnt) / (cnt + vec[j].cnt);
                y = (y * cnt + vec[j].value * vec[j].cnt) / (cnt + vec[j].cnt);
                if (!(x > 0.0 + vec[j-1].start && x < vec[j-1].mend + 1.)) {
                    cout << "yes\n" << i+1 << endl;
                    return 0;
                }
            }
            cnt += vec[j].cnt;
        }

    }

    cout << "no" << endl;
}
