#define ONLINE_JUDJE

#include <fstream>
#include <string>
#include <cctype>
#include <vector>

using namespace std;


void Amocana_A();
#ifdef ONLINE_JUDJE
ifstream cin("abbreviation.in");
ofstream cout("abbreviation.out");
#else
ifstream cin("text.txt");
ofstream cout("out.txt");
#endif
int main(){


	ios_base::sync_with_stdio(false); cin.tie(NULL);

	Amocana_A();
}
bool pirveli;
bool IsCapWord(string word){
	if (word.size() == 1) return false;
	if (!isupper(word[0])) return false;

	for (int i = 1; i < word.size(); i++)
	{
		if (isupper(word[i])) return false;
	}

	return true;
}

string ProcessWords(vector<string> words){
	if (words.size() == 0) return "";
	if (words.size() == 1) return words[0];

	string ans;

	for (int i = 0; i < words.size(); i++)
	{
		ans += words[i][0];
	}

	ans += " ("; ans += words[0];

	for (int i = 1; i < words.size(); i++)
	{
		ans += " " + words[i];
	}

	ans += ")";

	return ans;
}

string ProcessVEctors(vector<string> words, vector<string> chars){
	string ans;
	vector<string> forProcess;

	if (pirveli == 0) { ans += chars[0]; chars.push_back(""); }
	int i;
	for (i = 0; i < words.size() && i < chars.size(); i++)
	{
		if (pirveli){
			if (IsCapWord(words[i])){
				forProcess.push_back(words[i]);

				if (chars[i] != " "){
					ans += ProcessWords(forProcess);
					ans += chars[i];
					forProcess.clear();
				}
			}
			else{
				ans += ProcessWords(forProcess);
				if (forProcess.size() >= 1)
					ans += " ";
				ans += words[i];//
				forProcess.clear();
				ans += chars[i];
			}
		}
		else{
			if (IsCapWord(words[i])){
				forProcess.push_back(words[i]);

				if (chars[i + 1] != " "){
					ans += ProcessWords(forProcess);
					ans += chars[i + 1];
					forProcess.clear();
				}
			}
			else{
				ans += ProcessWords(forProcess);
				if (forProcess.size() >= 1)
					ans += " ";
				ans += words[i];//
				forProcess.clear();
				ans += chars[i + 1];
			}
		}
	}

	if (i < words.size()){
		if (IsCapWord(words[i])){
			forProcess.push_back(words[i]);
			ans += ProcessWords(forProcess);
		}
		else{
			ans += ProcessWords(forProcess);
			if (forProcess.size() >= 1)
				ans += " ";
			ans += words[i];
			forProcess.clear();
		}
	}


	return ans;
}

void Amocana_A(){
	string line;

	while (getline(cin, line))
	{
		if (isalpha(line[0])) pirveli = 1;
		else pirveli = 0;

		string ans, word, otherChars;
		vector<string> words, others;
		for (int i = 0; i < line.size(); i++)
		{
			if (isalpha(line[i])){
				word += line[i];

				if (otherChars.size() > 0){
					others.push_back(otherChars);
					otherChars = "";
				}
			}
			else{
				otherChars += line[i];

				if (word.size() > 0){
					words.push_back(word);
					word = "";
				}
			}
		}
		if (word.size() > 0){
			words.push_back(word);
			word = "";
		}
		if (otherChars.size() > 0){
			others.push_back(otherChars);
			otherChars = "";
		}// faesfe

		cout << ProcessVEctors(words, others) << endl;

		/*for (int i = 0; i < words.size(); i++)
		{
		cout << "_" << words[i];
		}cout << endl;
		for (int i = 0; i < others.size(); i++)
		{
		cout << "_" << others[i];
		}cout << endl;*/
	}
}