#include <bits/stdc++.h>
using namespace std;

#define FOR(i,a,b) for (int i = (a); i < (b); i++)
#define RFOR(i,b,a) for (int i = (b)-1; i >= (a); i--)
#define ITER(it,a) for (__typeof(a.begin()) it = a.begin(); it != a.end(); it++)
#define FILL(a, value) memset(a, value, sizeof(a))

#define SZ(a) (int)a.size()
#define ALL(a) a.begin(), a.end()
#define MP make_pair
#define PB push_back

typedef long long LL;
typedef vector<int> VI;
typedef pair<int, int> PII;

const double PI = acos(-1.0);
const int INF = 1000 * 1000 * 1000 + 7;
const LL LINF = INF * (LL) INF;

const int MAX = 100100;

pair<int, int> A[MAX];
pair<int, int> B[MAX];

multiset<pair<int, int> > S;
LL RES[MAX];
LL res = 0;
LL total = 0;
int level = 0;

void push(int num)
{
//  cout<<"push"<<' '<<num<<endl;
    while(num > 0)
    {
        if (S.empty()) break;
        int top = S.begin() -> first - level;
        int cnt = min(num, top);

        res -= total * cnt;

        while(SZ(S) && S.begin() -> first - level == cnt)
        {
            total -= S.begin() -> second;
            S.erase(S.begin());
        }

        level += cnt;
        num -= cnt;
    }
}

int main()
{
    //freopen("in.txt", "r", stdin);
    //ios::sync_with_stdio(false); cin.tie(0);
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);

    int n,m;
    scanf("%d%d", &n, &m);
    int diff = 0;
    FOR (i, 0, n)
    {
        char c = getchar();
        while(c != '+' && c != '-') c = getchar();
        int t, k;
        scanf("%d%d", &t, &k);
        if (c == '+') A[i] = MP(t, -k);
        else A[i] = MP(t, k);

        if (c == '+') diff += k;
        else diff -= k;
    }

//  cout<<diff<<endl;

    FOR (i, 0, m)
    {
        scanf("%d", &B[i].first);
        B[i].second = i;
    }

    int start = 0;
    if (diff < 0) start = -diff;

    if (start > 0)
    {
        A[n] = MP(0, -start);
        n++;
    }

    sort(A, A+n);
    sort(B, B+m);

/*  FOR (i, 0, n)
    {
        cout<<A[i].first<<' '<<A[i].second<<endl;
    }
    cout<<endl;*/

    int pt = 0;
    int cnt = 0;
    FOR (i, 0, n)
    {
        int t = A[i].first;
        int c = A[i].second;

        if (cnt > 0)
        {
            int len = t - pt;
            S.insert(MP(cnt, len));
            res += len * (LL) cnt;
            total += len;
        }

        cnt += c;
        pt = t;
    }

/*  cout<<"*"<<endl;
    cout<<SZ(S)<<endl;

    ITER(it, S)
    {
        cout<<it->first<<' '<<it->second<<endl;
    }

    cout<<total<<' '<<res<<endl;*/

//  return 0;

    int cur = start;


    FOR (i, 0, m)
    {
        if (B[i].first < start)
        {
            RES[B[i].second] = LINF;
            continue;
        }

        int diff = B[i].first - cur;
        push(diff);
        RES[B[i].second] = res;
        cur = B[i].first;
    }

    FOR (i, 0, m)
    {
        if (RES[i] == LINF) printf("INFINITY\n");
        else printf("%lld\n", RES[i]);
    }

    return 0;
}
