#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <sstream>
#include <queue>
#include <cmath>


using namespace std;

const int MAXN = (1 << 16);
bool a[MAXN];

void modify(int l, int r){
	for (int i = l; i <= r; i++){
		a[i] = true;
	}
}



int main(){
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	int start = (1 << 15);

	string s;
	while (getline(cin, s)){
		istringstream sinp(s);
		string temp;
		vector <string> v;
		while (sinp >> temp){
			v.push_back(temp);
		}

		if (v.size() == 4 || v.size() == 3){
			if (v[1] == ">=")
				modify(stoi(v[2]) + start, MAXN - 1);
			else
				modify(0, stoi(v[2]) + start);
		}
		else{
			
			int l = stoi(v[2]) + start;
			int r = stoi(v[6]) + start;
			
			modify(l, r);
		}
	}
	bool started = false;
	int l, r;
	vector <pair <int, int> > ans;
	for (int i = 0; i < MAXN; i++){
		if (a[i] && !started){
			started = true;
			l = i;
		}
		if (started && !a[i]){
			started = false;
			r = i - 1;
			ans.emplace_back(l, r);
		}
	}



	if (started){
		ans.emplace_back(l, MAXN - 1);
	}
	if (ans.size() == 0){
		cout << "false" << endl; 	system("pause");  return 0;
	}

	if (ans[0].first == 0 && ans[0].second == MAXN - 1){
		cout << "true" << endl; 	system("pause");  return 0;
	}

	if (ans[0].first == 0){
		cout << "x <= " << ans[0].second - start << " ||" << endl;
	}
	else{
		cout << "x >= " << ans[0].first - start << " && x <= " << ans[0].second - start << " ||" << endl;
	}

	for (int i = 1; i < (int)ans.size() - 1; i++){
		cout << "x >= " << ans[i].first - start << " && x <= " << ans[i].second - start << " ||" << endl;
	}

	if (ans[ans.size() - 1].second == MAXN - 1){
		cout << "x >= " << ans[ans.size() - 1].first - start;
	}
	else{
		cout << "x >= " << ans[ans.size() - 1].first - start << " && x <= " << ans[ans.size() - 1].second - start << endl;
	}

	system("pause");
	return 0;
}
