#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <ctime>
#include <set>
#include <map>
#include <queue>
#include <stack>

#define f first
#define s second
#define ll long long
#define pb push_back
#define mp make_pair
#define pii pair<int, int>

int const maxn = 1e9;
int const N = 1e5 + 111;

using namespace std;

bool isCD(char c) {
	if (int(c) == 46 || int(c) == 44) 
		return true;
	return false;
}

bool isLow(char c) {
	if (int(c) >= 97 && int(c) <= 122) 
		return true;
	return 0;
}

bool isUp(char c) {
	if (int(c) >= 65 && int(c) <= 90) 
		return true;
	return 0;
}

bool isLet(char s) {
	if (isUp(s) || isLow(s))
		return true;
	return false;
}

bool isAbb(string s) {
	int n = s.size();
	if (!isUp(s[0])) 
		return false;
	for (int i = 1; i < n; ++i) {
		if (!isLow(s[i]))
			return false;
	}
	return true;
}

int main() {
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	string s;

	while (getline(cin, s)) {
		int n = s.length();
		int ind = 0;
		vector <pii> w;
		vector <bool> u;
		while (ind < n) {
			if (isLet(s[ind])) {
				int l = ind, r = ind + 1;
				bool flag = 1;
				if (!isUp(s[ind]))
					flag = 0;
				while (ind < n && isLet(s[ind])) {
					//cout << ind << "KO" << endl;
					if (ind != l && !isLow(s[ind])) 
						flag = 0;
					++ind;
				}
				r = ind - 1;
				w.pb(mp(l, r));
				if (l == r) {
					u.pb(false);
				} else {
					u.pb(flag);
				}
			} else {
				++ind;
			}
		}

		ind = 0;
		if (w.size() == 0) {
			cout << s << endl;
			continue;
		}
		for (int i = 0; i < n; ++i) {
			if (i > w[ind].s) {
				++ind;
			}
			if (ind < w.size() && i == w[ind].f) {
				if (u[ind] == false)  {
					for (int k = w[ind].f; k <= w[ind].s; ++k) {
						cout << s[k];
					}
					i = w[ind].s;
				} else {
					if (( + 1 < u.size() && u[ind + 1] == false) || ind == u.size() - 1) {
						for (int k = w[ind].f; k <= w[ind].s; ++k) {
							cout << s[k];
						}
						i = w[ind].s;
					} else {
						int l = ind, r = ind, cur = l;
						while (cur + 1 < u.size() && u[cur + 1] == 1) {
							bool flag = 0;
							for (int k = w[cur].s + 1; k < w[cur + 1].f; ++k) {
								if (s[k] != ' ') 
									flag = 1;
								if (w[cur + 1].f - w[cur].s != 2)
									flag = 1;
							}
							if (!flag) {
								r = cur + 1;
								++cur;
							} else {
								break;
							}
						}
						if (r == l) {
							for (int k = w[l].f; k <= w[l].s; ++k) {
								cout << s[k];
							}
							i = w[l].s;
						} else {
							for (int k = l; k <= r; ++k) {
								cout << s[w[k].f];
							}
							cout << " (";
							for (int k = w[l].f; k <= w[r].s; ++k) {
								cout << s[k];
							}
							i = w[r].s;
							ind = r + 1;
							cout << ")";
						}

					}
				}
			} else {
				cout << s[i];
			}
		} 
		cout << endl;
	}

	return 0;  	
}

