#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <ctime>
#include <set>
#include <map>
#include <queue>
#include <stack>
 
#define ll long long
#define f first
#define s second
 
int const maxn = 1e9;
int const N = 1e5 + 111;
 
using namespace std;
 
bool isDigit(char c) {
    if (int(c) >= int('0') && int(c) <= int('9'))
        return true;
    return false;
}
 
bool isMinus(char c) {
    return c == '-';
}
 
int main() {
    freopen("hard.in", "r", stdin);
    freopen("hard.out", "w", stdout);
 
    vector <pair <int, int> >  seg;
 
    string s;
 
    while (getline(cin, s))  {
        int n = s.length();
        if (n == 0) {
        	continue;
        }
        int a = 0, b = 0;
        int ind = 5;
        bool flag = 1;
        if (s[ind] == '-') {
            flag = 0;
            ++ind;
        }
        while (ind < n && isDigit(s[ind])) {
            a *= 10;
            a += s[ind] - '0';
            ++ind;
        }
 
        if (!flag)
            a *= -1;
 
        ind += 9;
 
        if (ind < n) {
            bool flag = 1;
            if(ind < n && s[ind] == '-') {
                flag = 0;
                ++ind;
            }
            while (ind < n && isDigit(s[ind])) {
                b *= 10;
                b += s[ind] - '0';
                ++ind;
            }
            if (!flag) {
                b *= -1;
            }
        }  else {
            if (s[2] == '>') {
                b = 32767;
            } else {
                b = a;
                a = -32768;
            }
        }
        if (a > b) {
            cout << "false" << endl;
            return 0;
        }
        seg.push_back(make_pair(a, b));
    }
 
    sort(seg.begin(), seg.end());
    for (int i = 0; i < seg.size(); ++i) {
      //cout << seg[i].f << ' ' << seg[i].s << endl;
    }
    vector <pair <int, int> >  ans;
 
      int ind = 0;
    while (ind < seg.size())  {
        int l = seg[ind].f;
        int r = seg[ind].s;
        while (ind < seg.size() && r+1 >= seg[ind].f) {
            r = max(seg[ind].s, r);
            ++ind;
        }
        ans.push_back(make_pair(l, r));
    }
    if (ans.size() == 1 && ans[0].f == -32768 && ans[0].s == 32767) {
        cout << "true" << endl;
        return 0;
    }
    for (int i = 0; i < ans.size(); ++i) {
        if (ans[i].f == -32768) {
            cout << "x <= " << ans[i].s;
            if (i + 1 < ans.size()) {
                cout << " ||";
            }
            cout << endl;
        } else if (ans[i].s == 32767) {
            cout << "x >= " << ans[i].f << endl;
        } else {
            cout << "x >= " << ans[i].f << " && x <= " << ans[i].s;
            if (i + 1 < ans.size()) {
                cout << " ||";
            }
            cout << endl;
        }
 
    }
    return 0;
}