#include <fstream>
using namespace std;

bool check(int ** a, int x, int n){
	for (int i = 1; i <= (n+1)/2; ++i){
		if (a[x][i] + a[x][n + 1 - i] == 2)
			return false;
	}
	return true;
}

int main(){
	ifstream fin("jenga.in");
	ofstream fout("jenga.out");
	int n,w,h,r,k=0;
	fin >> n >> w >> h >> r;
	int ** a = new int * [h + 1];
	for (int i = 1; i <= h; ++i){
		a[i] = new int[n + 1];
		for (int j = 1; j <= n; ++j){
			a[i][j] = 1;
		}
	}
	while (++k <= r){
		int x, y;
		fin >> x >> y;
		a[x][y] = 0;
		if (check(a, x, n)){
			fout << "yes" << endl << k;
			return 0;
		}
	}
	fout << "no";
	return 0;
}