import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;

public class HardRefactoring {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File("hard.in"));
		PrintWriter pw = new PrintWriter(new File("hard.out"));
		boolean[] sim = new boolean[65536];
		int offset = 32768;
		int Min = -32768, Max = 32768 - 1;
		while (sc.hasNextLine()) {
			String line = sc.nextLine().replace(" ||", "");
			int min = -32768, max = 32768 - 1;
			String[] toks = line.split(" ");
			if (line.contains("&&")) {
				min = Integer.parseInt(toks[2]);
				max = Integer.parseInt(toks[6]);
			}
			else {
				if (toks[1].equals("<=")) {
					max = Integer.parseInt(toks[2]);
				}
				else {
					min = Integer.parseInt(toks[2]);
				}
			}
			if (min > max) continue;
			for (int i = min + offset; i <= max + offset; i++) {
				sim[i] = true;
			}
		}
		boolean trues = true;
		boolean falses = true;
		for(boolean elem: sim) {
			if (!elem) trues = false;
			if (elem) falses = false;
		}
		if (trues) {
			pw.println("true");
		}
		else if (falses) {
			pw.println("false");
		}
		else {
			ArrayList<String> res = new ArrayList<String>();
			int b = -1, e = -1;
			boolean temp = false;
			for (int i = 0; i < sim.length; i++) {
				if (!temp && sim[i]) {
					b = i - offset;
					temp = true;
				}
				else if (temp && !sim[i]) {
					e = i - 1 - offset;
					temp = false;
					if (b == Min) res.add("x <= " + e + " ||");
					else if (e == Max) res.add("x >= " + b + " ||");
					else res.add("x >= " + b + " && x <= " + e + " ||");
				}
			}
			if (temp) {
				res.add("x >= " + b + " ||");
			}
			res.set(res.size() - 1, res.get(res.size() - 1).replace(" ||", ""));
			for(String line: res) {
				pw.println(line);
			}
		}
		pw.close();
	}

}
