#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <string, int> psi;

#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define endl '\n'
#define sz size()
#define TASK "abbreviation"

const int N = 1e5 + 10;
const int inf = 1e9 + 7;
const ll INF = 1e18 + 10;

vector <psi> cur;
vector <psi> ans;

bool check(char c)
{
	return (c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z');
}

bool isCap(string s)
{
	int n = s.sz;
	if (n < 2)
	{
		return false;
	}
	if (!(s[0] >= 'A' && s[0] <= 'Z'))
	{
		return false;
	}
	for (int i = 1; i < n; ++i)
	{
		if (!(s[i] >= 'a' && s[i] <= 'z'))
		{
			return false;
		}
	}
	return true;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
	
	string s;
	while (getline(cin, s))
	{
		cur.clear();
		int n = s.sz;
		for (int i = 0; i < n; ++i)
		{
			string t = "";
			if ((s[i] >= 'a' && s[i] <= 'z') || (s[i] >= 'A' && s[i] <= 'Z'))
			{
				int start = i;
				while (i < n && check(s[i]))
				{
					t += s[i];
					++i;
				}
				if (isCap(t))
				{
					cur.pb(mp(t, start));
				}
			}
		}
		if (cur.empty())
		{
			cout << s << endl;
			continue;
		}
		int l = cur[0].S + cur[0].F.sz - 1;
		int lastPos = 0;
		ans.pb(cur[0]);
		for (int i = 1; i < cur.sz; ++i)
		{
			if (l + 1 < n && s[l + 1] == ' ' && cur[i].S == l + 2)
			{
				ans.pb(cur[i]);
			}
			else
			{
				if (ans.sz > 1)
				{
					int curPos = ans[0].S;
					for (int j = lastPos; j < curPos; ++j)
						cout << s[j];
					lastPos = ans.back().S + ans.back().F.sz;
					for (int j = 0; j < ans.sz; ++j)
						cout << ans[j].F[0];
					cout << ' ';
					cout << '(';
					for (int j = 0; j < ans.sz; ++j)
					{
						if (j) cout << ' ';
						cout << ans[j].F;
					}
					cout << ")";
				}
				ans.clear();
				ans.pb(cur[i]);
			}
			l = cur[i].S + cur[i].F.sz - 1;
		}
		if (ans.sz > 1)
		{
			int curPos = ans[0].S;
			for (int j = lastPos; j < curPos; ++j)
				cout << s[j];
			lastPos = ans.back().S + ans.back().F.sz;
			for (int j = 0; j < ans.sz; ++j)
				cout << ans[j].F[0];
			cout << ' ';
			cout << '(';
			for (int j = 0; j < ans.sz; ++j)
			{
				if (j) cout << ' ';
				cout << ans[j].F;
			}
			cout << ")";
		}
		ans.clear();
		for (int j = lastPos; j < n; ++j)
			cout << s[j];
		cout << '\n';
	}

	return 0;
}

