#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair <int, int> PII;
typedef vector <int> VI;
 
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(v) (int)(v).size()
#define file "jenga"
 
const int INF = 1 << 30;
const int MOD = 1e9 + 7;
const int maxn = 1000000;
 
LD w;
int n, h, m, d[maxn];
vector <int> b[maxn];
bool used[maxn];
pair <pair <LD, LD>, LD> t[maxn];
 
void fall(int x)
{
    cout << "yes\n";
    cout << x;
    exit(0);
}
 
bool good(int l) {
    LD x = 0, y = 0, c = 0;
    for (int i = l + 1; i <= h; i++) {
        x += t[i].F.F;
        y += t[i].F.S;
        c += t[i].S;
    }
    if (c == 0) return true;
 
    LD L = LLONG_MAX, R = LLONG_MIN;
        memset(used, false, sizeof(used));
        for (int j = 0; j < sz(b[l]); j++) {
            used[b[l][j]] = true;
        }
        for (int j = 1; j <= n; j++) {
            if (used[j]) {
                continue;
            }
            L = min(L, (j - 1) * w);
            R = max(R, j * w);
        }
    if (L > R) return true;
    if (l % 2 == 0) {
        return (L * c < x && x < R * c);
    } else {
        return (L * c < y && y < R * c);
    }
 
}
 
pair <LD, LD> F(int x, int y) {
    if (y % 2 == 1) {
        return mp(n * w / 2.0, (x - 1) * w + w / 2.0);
    }
    return mp((x - 1) * w + w/2, n * w / 2.0);
}
 
int main() {
    freopen(file".in", "r", stdin);
    freopen(file".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
     
    cin >> n >> w;
    cin >> h >> m;
 
    for (int j = 1; j <= h; j++) {
        for (int i = 1; i <= n; i++) {
            pair <LD, LD> cur = F(i, j);
            t[j].F.F += cur.F;
            t[j].F.S += cur.S;
            t[j].S++;
        }
    }
 
 
    for (int i = 1; i <= n; i ++) d[i] = n;
     
    for (int i = 1; i <= m; i++) {
        int l, k;
        cin >> l >> k;
        b[l].pb(k);
            pair <LD, LD> cur = F(k, l);
            t[l].F.F -= cur.F;
            t[l].F.S -= cur.S;
            t[l].S--;
 
        /*if (!good(l)) {
            fall(i);
        }
        if (l > 1 && !good(l - 1)) {
            fall(i);
        }*/
        for (int j = max(1, l - 10); j <= l; j++)
            if (!good(j)) {
                fall(i);
            }
    }
    cout << "no";
 
    return 0;
}