#include <bits/stdc++.h>

using namespace std;

typedef long long LL;
typedef long double LD;
typedef pair <int, int> PII;
typedef vector <int> VI;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(v) (int)(v).size()
#define file "jenga"

const int INF = 1 << 30;
const int MOD = 1e9 + 7;

int w, n, h, m, d[5010];
vector <int> b[5010];
bool used[10010];

void fall(int x)
{
	cout << "yes\n";
	cout << x;
	exit(0);
}

void check(int l, int i)
{
	if (l < 1) return;
	if (d[l + 1] == 0) return;
        if (d[l] == 1)
        {
            if (n % 2 == 0) fall(i);
            int cur = n / 2 + 1;
            for (int j = 0; j < sz(b[l]); j ++)
            {
                if (b[l][j] == cur) fall(i);
            }
        }
        else if (n & 1)
        {
            int mid = n / 2 + 1;
            bool ok = true;
            int l = n / 2, r = n / 2;
            for (int j = 0; j < sz(b[l]); j ++)
            {
                if (b[l][j] < mid) l --;
                else if (b[l][j] > mid) r --;
                if (b[l][j] == mid) ok = false;
            }
            if (!ok && (!l || !r)) fall(i);
        }
        else
        {
            int mid = n / 2;
            int l = n / 2, r = n / 2;
            for (int j = 0; j < sz(b[l]); j ++)
            {
                if (b[l][j] <= mid) l --;
                else if (b[l][j] > mid) r --;
            }
            if (!l || !r) fall(i);  
        }

		LL L = LLONG_MAX, R = LLONG_MIN;
		memset(used, false, sizeof(used));
		for (int j = 0; j < sz(b[l]); j++) {
			used[b[l][j]] = true;
		}
		for (int j = 1; j <= n; j++) {
			if (used[j]) {
				continue;
			}
			L = min(L, (j - 1) * 1ll * w);
			R = max(R, j * 1ll * w);
		}
		if (l + 2 <= h && sz(b[l + 2]) != n) {
			LD sum = 0;
			int cnt = n - sz(b[l + 2]);
			for (int j = 0; j < n; j ++) sum += (LD)(j * 1ll * w) + w / 2.0;
			for (int j = 0; j < sz(b[l + 2]); j ++)
			{
				sum -= ((LD)(b[l + 2][j] * 1ll * w) - w / 2.0);
			}
			LD center = sum;
			if (L > R) {
				fall(i);	
			} 
			//cout << i << " ---- " << L << " " << R << " -- " << center / cnt << "\n"; 
			if (L * 1ll * cnt < center && center < R * 1ll * cnt) {
								
			} else {
				fall(i);
			}
		}
}

int main() {
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	cin >> n >> w;
	cin >> h >> m;

	for (int i = 1; i <= n; i ++) d[i] = n;
	for (int i = 1; i <= m; i++) {
		int l, k;
		cin >> l >> k;
		d[l] --;
        b[l].pb(k);
        check(l, i);
        check(l - 2, i);
	}
	cout << "no";

	return 0;
}