#include <bits/stdc++.h>
using namespace std;

#define fname "abbreviation" // <- here

const int N = 1e5 + 256;
const int INF = 1e9 + 256;
const int Mod = 1e9 + 7;

#define all(x) x.begin(), x.end()

inline bool check(const string &s) {
	if (s.size() == 1 || !isupper(s[0]))
		return false;
	for (int i = 1; i < (int)s.size(); ++i)
		if (isupper(s[i]))
			return false;
	return true;
}

inline void addAbr(string &res, string &abr, vector <string> &st, string c = "", bool toAdd = false) {
	if (abr.empty())
		return;
	if (abr.size() == 1) {
		res += st[0] + c;
		abr.clear();
		st.clear();
		return;
	}
	res += abr + " (";
	for (auto it : st)
		res += it + " ";
	res.pop_back();
	string sss; sss += c;
	res += ")" + sss;
	if (toAdd) res += " ";
	abr.clear();
	st.clear();
}

int main () {
	freopen(fname".in", "r", stdin);
	freopen(fname".out", "w", stdout);

	string s;

	while (getline(cin, s)) {
		string res;
		string abr;
		vector <string> st;
		for (int i = 0; i < s.size(); ++i) {
			int j = i;
			string puck;
			while (j < s.size() && !isalpha(s[j])) {
				// cerr << res << s[j] << "|\n";
				puck += s[j];++j;
				/* // cerr << s[j] << "|\n";
				string q; q += s[j];
				addAbr(res, abr, st, q);
				continue;               */
			}
			// cerr << puck << "|\n";
			if (!puck.empty()) {
				addAbr(res, abr, st, " ");
				res += puck;
				i = j - 1;
				continue;
			}
			string cur;
			while (j < s.size() && isalpha(s[j])) {
				cur += s[j];
				++j;
			}
			if (check(cur)) {
				abr += cur[0];
				st.push_back(cur);
				if (j == s.size() || s[j] != ' ') {
					if (j != s.size()) {
						string q; q += s[j];
						addAbr(res, abr, st, q);
					} else
						addAbr(res, abr, st);
					/* if (j != s.size())
						res += s[j]; */
				}
			} else {
				addAbr(res, abr, st, " ");
				res += cur;
				if (j != s.size()) {
					res += s[j];
					// cerr << res << "|\n";
				}
			}
			i = j;
		}
		cout << res << endl;
	}

	return 0;
}
