
#include<bits/stdc++.h>

#define ll long long 
#define mp make_pair
#define pb push_back
#define F first
#define S second
#define fname "abbreviation"

using namespace std;

const int maxn = (1e5) + 12;
const int inf = (1e9);

int n;
string input;

inline bool isSpace(char x) {
	return x == ' ' || x == '.' || x == ',';
}

int isAbr(int pos) {
//	fprintf(stderr, "f(%d)%c=", pos, input[pos]);
	if (!('A' <= input[pos] && input[pos] <= 'Z')) {
//		fprintf(stderr, "%d\n", -1);
		return -1;
	}
	for (int j = pos + 1; j < n; j++) {
		if (isSpace(input[j])) {
//		fprintf(stderr, "%d\n", j - 1);
			return j - 1;
		}
		if ('A' <= input[j] && input[j] <= 'Z')
			return -1;
	}
//	fprintf(stderr, "%d\n", n - 1);
	return n - 1;
}

int parse(int pos) {
//	fprintf(stderr, "p(%d)=\n", pos);
	vector <string> ve;
	int i = isAbr(pos);
	if (i == -1 || i == pos)
		return -1;
	ve.pb(input.substr(pos, i - pos + 1));
	i++;
	for (; i < n;) {
		if (input[i] != ' ')
			break;
		int j = isAbr(i + 1);
		if (j == i + 1) {
			break;
		}
		if (j == -1) {
			break;
		}
		ve.pb(input.substr(i + 1, j - i));
		i = j + 1;
	}
//	for (auto x : ve)
//		cerr << "|" << x << "|";
//	cerr << endl;
	if (ve.size() > 1) {
		string output = "";
		for (int j = 0; j < (int)ve.size(); j++)
			output += ve[j][0];
		output += " (";
		for (int j = 0; j < (int)ve.size(); j++) {
			if (j)
				output += " ";
			output += ve[j];
		}
		output += ")";
		printf("%s", output.c_str());
		return i;
	} else
		return -1;
}

int out(int pos) {
	for (int i = pos; i < n; i++) {
		if (input[i] == ' ' || input[i] == ',' || input[i] == '.')
			return i;
		putchar(input[i]);
	}
	return n;
}

int main()
{
	freopen(fname".in", "r", stdin);
	freopen(fname".out", "w", stdout);
	while (getline(cin, input)) {
		n = int(input.size());
		int i = 0;
		while (i < n) {
			if (input[i] == ' ' || input[i] == '.' || input[i] == ',') {
				putchar(input[i]);
				i++;
				continue;
			} 
			int j = parse(i);
//			fprintf(stderr, "p(%d)=%d\n", i, j);
			if (j == -1) {
				j = out(i);
			}
			if (j == i) {
				putchar(input[i]);
				i++;
			}
			else
				i = j;
		}
		puts("");
	}
	return 0;
}
