#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)x.size()
#define pb push_back
#define mp make_pair
#define all(x) (x.begin(), x.end())
#define sq(x) ((x) * (x))

typedef long long ll;
typedef vector <int> vi;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int maxn = (int)1e5 + 10;
const int inf = (int)2e9;
const int mod = (int)1e9 + 7;
const double pi = acos(-1.0);
const double eps = (double)1e-9;

bool check(string cur) {
	if (cur[0] >= 'a' && cur[0] <= 'z') {
		return 0;
	}
	int n = cur.size();
	if (n == 1) {
		return 0;
	}
	for (int i = 1; i < n; i++) {
		if (cur[i] >= 'A' && cur[i] <= 'Z') {
			return 0;
		}
	}
	return 1;
}

bool alpha(char cur) {
	if ((cur >= 'A' && cur <= 'Z') || (cur >= 'a' && cur <= 'z')) {
		return true;
	}
	return false;
}

string text, good, bad;

int main(){
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	int pos, n;
	vector <string> all;
	while (getline(cin, text)) {
		n = text.size();
		all.clear();
		for (int i = 0; i < n; i++) {
			if (alpha(text[i])) {
				good += text[i];
			} else {
				pos = i;
				while (pos < n && !alpha(text[pos])) {
					bad += text[pos++];
				}
				if (bad.size() > 1 || bad[0] != ' ') {
					bool ok = 1;
					if (check(good)) {
						all.push_back(good);
						good = "";
						ok = 0;
					}
					if (all.size() > 1) {
						for (int j = 0; j < all.size(); j++) {
							cout << all[j][0];
						}
						cout << " (";
						for (int j = 0; j < all.size(); j++) {
							cout << all[j];
							if (j < all.size() - 1) {
								cout << ' ';
							}
						}
						cout << ")";
						all.clear();
					} else {
						if (!all.empty()) {
							cout << all[0];
							all.clear();
						}
					}
					if (ok) {
						cout << good;
						good = "";
					}
					cout << bad;
					bad = "";
				} else {
					if (check(good)) {
						all.push_back(good);
						good = "";
					} else {
						if (all.size() > 1) {
							for (int j = 0; j < all.size(); j++) {
								cout << all[j][0];
							}
							cout << " (";
							for (int j = 0; j < all.size(); j++) {
								cout << all[j];
								if (j < all.size() - 1) {
									cout << ' ';
								}
							}
							cout << ") ";
							all.clear();
						} else {
							if (!all.empty()) {
								cout << all[0] << ' ';
								all.clear();
							}
						}
						cout << good << bad;
						good = "";
					}
//					cout << bad;
					bad = "";
				}
				i = pos - 1;
			}
		}
		bool ok = 1;
		if (check(good)) {
			all.push_back(good);
			good = "";
			ok = 0;
		}
		if (all.size() > 1) {
			for (int j = 0; j < all.size(); j++) {
				cout << all[j][0];
			}
			cout << " (";
			for (int j = 0; j < all.size(); j++) {
				cout << all[j];
				if (j < all.size() - 1) {
					cout << ' ';
				}
			}
			cout << ")";
			all.clear();
		} else {
			if (!all.empty()) {
				cout << all[0] << ' ';
				all.clear();
			}
		}
		if (ok) cout << good;
		good = bad = "";
		cout << endl;
	}
 	return 0;
}