#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <cstdio>

using namespace std;

struct range {
	int l, r;
} a[1010], Min[1010], Max[1010];

int n, L = -32768, R = 32767, x, mini = -32768, maxi = 32767, nmini, nmaxi, Mini, Maxi;
string s;

int toNum(string s) {
	int sum = 0, c = 1;
	for (int i = s.length() - 1; i >= 1; i--) {
		sum += (s[i] - 48) * c;
		c *= 10;
	}
	if (s[0] != '-')
		sum += (s[0] - 48) * c;
	else
		sum *= -1;
	return sum;
}

bool cmp(range a, range b) {
	return a.l < b.l || (a.l == b.l && a.r < b.r);
}

vector <range> ans;

int main() {
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	int l, r;
	while (1) {
		l = L;
		r = R;
		getline(cin, s);
		int len = s.length(), i = 0;
		string t;
		if (s[2] == '>') {
			t = "";
			i = 5;
			while (i < len && s[i] != ' ')
				t += s[i++];
			l = toNum(t);
			if (i + 1 < len && s[i + 1] == '&') {
				t = "";
				i += 9;
				while (i < len && s[i] != ' ')
					t += s[i++];
				r = toNum(t);
			}
		} else {
			t = "";
			for (i = 5; i < len; i++)
				if (s[i] != ' ')
					t += s[i];
				else
					break;
			r = toNum(t);
		}
		if (l > r) {
			cout << "false\n\n";
			return 0;
		}
		if (l == mini) {
			Min[nmini++].r = r;
		} else
		if (r == maxi) {
			Max[nmaxi++].l = l;
		} else {
		    a[n].l = l;
		    a[n].r = r;
			n++;
		}
		if (i == len)
			break;
	}

	sort(a, a + n, cmp);

	Mini = -1000000000;
	for (int i = 0; i < nmini; i++)
		Mini = max(Mini, Min[i].r);
	Maxi = 1000000000;
	for (int i = 0; i < nmaxi; i++)
		Maxi = min(Maxi, Max[i].l);

	/*for (int i = 0; i < n; i++)
		cout << a[i].l << " " << a[i].r << endl;
	cout << "@@@" << endl;*/

	if (nmini) {
		range r;
		r.l = mini;
		r.r = Mini;
		ans.push_back(r);
	}

	if (nmaxi) {
		range r;
		r.l = Maxi;
		r.r = maxi;
		ans.push_back(r);
	}

	int i = 0;
	while (i < n) {
		int L = a[i].l, R = a[i].r;
		bool ok = false;
		i++;
		while ((i < n && a[i].l <= R + 1)) {
			ok = true;
			R = max(R, a[i++].r);
		}
		range r;
		r.l = L;
		r.r = R;
		ans.push_back(r);
	}
	
	/*for (int i = 0; i < ans.size(); i++)
		cout << ans[i].l << " " << ans[i].r << endl;
	cout << "!!!" << endl;*/

	if (n + nmini + nmaxi == ans.size())
		cout << "true";
	else {
		for (int i = 0; i < ans.size() - 1; i++) {
			bool ok = false;
			if (ans[i].l != L) {
				ok = true;
				cout << "x >= " << ans[i].l;
			}
			if (ans[i].r != R) {
				if (ok)
					cout << " && x <= " << ans[i].r;
				else
					cout << "x <= " << ans[i].r;
				ok = true;
			}
			if (ok)
				cout << " ||\n";
		}
		bool ok = false;
		int i = ans.size() - 1;
		if (ans[i].l != L) {
			ok = true;
			cout << "x >= " << ans[i].l;
		}
		if (ans[i].r != R) {
			if (ok)
				cout << " && x <= " << ans[i].r;
			else
				cout << "x <= " << ans[i].r;
			ok = true;
		}
	}
	cout << endl;
	cout << endl;
	return 0;
}
