#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define _name "abbreviation"

int test(const string& s)
{
	if (s.size() <= 1)
		return 0;
	if (s[0] < 'A' || s[0] > 'Z')
		return 0;
	for (int i = 1; i < s.size(); i++)
		if (s[i] < 'a' || s[i] > 'z')
			return 0;
	return 1;
}

vector<string> ab;
int space = 0 ;
void print_ab()
{
	if (ab.size() == 0)
		return;
	if (ab.size() > 1)
	{
		for (int i = 0; i < ab.size(); i++)
			cout << ab[i][0];
		cout << " (";
	}
	cout << ab[0];
	for (int j = 1; j < ab.size(); j++)
		cout << ' ' << ab[j];
	if (ab.size() > 1)
		cout << ")";
	if (space)
		cout << ' ';
	space = 0;
	ab.clear();
}

int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(_name".in", "r", stdin);
	freopen(_name".out", "w", stdout);
#endif
	string s;
	while (getline(cin, s))
	{
		s.push_back('\n');
		string word;
		for (int i = 0; i < s.size(); i++)
		{
			if (s[i] >= 'a' && s[i] <= 'z' || s[i] >= 'A' && s[i] <= 'Z')
				word = word + s[i];
			else if (word.size())
			{
				if (test(word))
				{
					space = false;
					ab.push_back(word);
					word.clear();
					if (s[i] != ' ')
					{
						print_ab();
						cout << s[i];
					}
					else
						space = true;
				}
				else
				{
					if (ab.size())
					{
						print_ab();
						if (word.size())
						{
							cout << word;
						}
					}
					else
						cout << word;
					word.clear();
					cout << s[i];
				}

			}
			else
			{
				print_ab();
				cout << s[i];
			}
		}
		print_ab();
		//printf("\n");
	}
	return 0;
}