#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <ctype.h>
#include <set>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

#define _name "hard"
#define mp make_pair
const int maxlen = 1e5;

int t[maxlen];

vector<pii> ans;

int f(int x)
{
	return x &= x + 1;
}
int sum(int v)
{
	int res = 0;
	while (v >= 0)
	{
		res += t[v];
		v = f(v) - 1;
	}
	return res;
}
void add(int i, int d)
{
	for (; i < maxlen; i |= i + 1)
		t[i] += d;
}

pii get_int(string s, int pos)
{
	s = s + '%';
	int res = 0;
	int mul = 1;
	while (!isdigit(s[pos]) && s[pos] != '-')
		pos++;
	if (s[pos] == '-')
		mul = -1, pos++;
	while (isdigit(s[pos]))
	{
		res = 10 * res + (s[pos] - '0');
		pos++;
	}
	return mp(mul*res,pos);
}
int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(_name".in", "r", stdin);
	freopen(_name".out", "w", stdout);
#endif
	string s;
	int L = -32768;
	int R = 32767;
	while (getline(cin, s))
	{
		int l, r;
		int a, b;
		bool g1, g2, l1, l2;
		bool t = false;
		g1 = g2 = l1 = l2 = false;
		int sc = 0;
		for (int i = 0; i < s.size(); ++i)
		{
			if (s[i] == 'x')
				continue;
			if (s[i] == ' ')
				continue;
			if (s[i] == '|')
				continue;
			if (s[i] == '&')
			{
				i++;
				sc = 1;
				continue;
			}
			
			if ((s[i] == '>' || s[i] == '<') && sc == 1)
			{
				if (s[i] == '>')
					g2 = true;
				else
					l2 = true;
				pii v;
				i += 2;
				v = get_int(s, i);
				b = v.first;
				i = v.second;
				continue;
			}
			if (sc == 0 && (s[i] == '>' || s[i] == '<'))
			{
				if (s[i] == '>')
					g1 = true;
				else
					l1 = true;
				pii v;
				i += 2;
				v = get_int(s, i);
				a = v.first;
				i = v.second;
				continue;
			}
		}
		if (sc == 0)
		{
			if (l1)
			{
				add(0, 1);
				add(a - L + 1, -1);
			}
			else
			{
				add(a - L, 1);
				add(R - L + 1, -1);
			}
		}
		else
		{
			if (l1 && l2)
			{
				a = min(a, b);
				add(0, 1);
				add(a - L + 1, -1);
			}
			if (g1 && g2)
			{
				a = max(a, b);
				add(a - L, 1);
				add(R - L + 1, -1);
			}
			if (l1 && g2)
			{
				if (a < b)
					continue;
				add(b - L, 1);
				add(a - L + 1, -1);
			}
			if (g1 && l2)
			{
				swap(a, b);
				if (a < b)
					continue;
				add(b - L, 1);
				add(a - L + 1, -1);
			}
		}
	}
	int l = -1;
	
	for (int i = 0; i <= R - L + 1; ++i)
	{
		if (int k = sum(i))
		{
			if (l == -1)
				l = i;
			else
				continue;
		}
		else
		{
			if (l == -1)
				continue;
			else
			{
				ans.push_back(mp(l, i - 1));
				l = -1;
			}
		}
	}
	
	if (ans.size() == 0)
	{
		cout << "false";
		return 0;
	}
	if (ans.size() == 1 && ans[0].first == 0 && ans[0].second == R - L)
	{
		cout << "true";
		return 0;
	}

	for (int i = 0; i < ans.size(); ++i)
	{
		int l, r;
		l = ans[i].first + L;
		r = ans[i].second + L;
		if (l == L)
		{
			cout << "x <= " << r;
		}else if (r == R)
		{
			cout << "x >= " << l;
		}
		else
		{
			cout << "x >= " << l << " && " << "x <= " << r;
		}
		if (i + 1 < ans.size())
			cout << " ||" << endl;
	}
	return 0;
}