#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++)
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B> &a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A> &a) {
	out << "[";
	forn(i, sz(a)) {
		if(i) out << ", ";
		out << a[i];
	}
	return out << "]";
}

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(-1.0);
const int MOD = INF + 7;
mt19937 myrand(time(NULL));

#define FILENAME "abbreviation"

string buf;
vector<string> cur;
string ans;
int state;

void abbreviate()
{
	if (sz(cur) == 2)
	{
		printf("%s", cur[0].c_str());
		return;
	}
	for (int i = 0; i < sz(cur) - 1; i++)
	{
		printf("%c", cur[i][0]);
	}
	
	if (sz(cur) - 2 <= 0)
		return;
	printf(" (");
	if (!islower(cur[sz(cur) - 2].back()))
	{
		char lst = cur[sz(cur) - 2].back();
		cur[sz(cur) - 2].pop_back();
		for (int i = 0; i < sz(cur) - 1; i++)
		{
			printf("%s", cur[i].c_str());
		}
		printf(")%c", lst);
	}
	else
	{
		for (int i = 0; i < sz(cur) - 1; i++)
		{
			printf("%s", cur[i].c_str());
		}
		printf(")");
	}
	
}

bool read() {
	if(!getline(cin, buf))
		return false;
	//cerr << buf << endl;
	return true;
}

void solve() {
	state = 0;
	buf += "\n";
	for (auto c : buf)
	{
		//cerr << state << endl;
		if (state == -1)
		{
			if (!isalpha(c))
				state = 0;
			printf("%c", c);
		}
		else if (state == 0)
		{
			if (isupper(c))
			{
				state = 1;
				string cr;
				cr.pb(c);
				cur.pb(cr);
			}
			else
			{ 
				printf("%c", c);
				state = (isalpha(c) ? -1 : 0);
			}
		}
		else if (state == 1)
		{
			if (islower(c))
			{
				state = 2;
				cur[sz(cur) - 1].pb(c);
			}
			else
			{
				abbreviate();
				printf("%s", cur.back().c_str());
				printf("%c", c);
				cur.clear();
				state = (isalpha(c) ? -1 : 0);
			}
		}
		else if (state == 2)
		{
			if (islower(c))
				cur[sz(cur) - 1].pb(c);
			else if (isupper(c))
			{
				abbreviate();
				printf("%s", cur[sz(cur) - 1].c_str());
				printf("%c", c);
				cur.clear();
				state = -1;
			}
			else if (c == ' ')
			{
				cur[sz(cur) - 1].pb(c);
				state = 3;
			}
			else
			{
				cur.push_back("");
				abbreviate();
				printf("%c", c);
				cur.clear();
				state = 0;
			}
		}
		else
		{
			if (isupper(c))
			{
				cur.push_back("");
				cur[sz(cur) - 1].pb(c);
				state = 1;
			}
			else
			{
				cur.push_back("");
				abbreviate();
				printf("%c", c);
				cur.clear();
				state = (isalpha(c) ? -1 : 0);
			}
		}
	}
}

int main() {

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);

	int tt = clock();

#else
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
	
#endif

	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);

	while(read()) {
	
		solve();
		
#ifdef _DEBUG

		//cerr << "TIME = " << clock() - tt << " ms\n";
		tt = clock();
		
#endif

	}
	
	return 0;
}