#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++)
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B> &a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A> &a) {
	out << "[";
	forn(i, sz(a)) {
		if(i) out << ", ";
		out << a[i];
	}
	return out << "]";
}

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(-1.0);
const int MOD = INF + 7;
mt19937 myrand(time(NULL));

#define FILENAME "foreign"

const int N = 1000 * 1000 + 555;
char s[N];
int n;

bool read() {
	if(scanf("%s", s) != 1)
		return false;
	n = strlen(s);
	return true;
}

int sum[2][N];
li ss[2][N];

ld d[N];
ld sd[N];

void solve() {
	sum[0][0] = sum[1][0] = 0;
	forn(i, n) {
		sum[0][i + 1] = sum[0][i];
		sum[1][i + 1] = sum[1][i];
		
		int add = s[i] == 'C' ? 1 : 0;
		
		sum[0][i + 1] += add;
		sum[1][i + 1] += (1 - add);	
	}
	
	for(int i = n; i >= 0; i--) {
		if(i < n) {
			ss[0][i] = ss[0][i + 1];
			ss[1][i] = ss[1][i + 1];
		}
		
		ss[0][i] += sum[0][i];
		ss[1][i] += sum[1][i];
	}
	
	d[n] = 0.0;
	sd[n] = 0.0;
	
	for(int i = n - 1; i >= 0; i--) {
		int x = s[i] != 'C';
		
		d[i] = ld(ss[x][i + 1] - (n - i) * 1ll * sum[x][i] + sd[i + 1]) / ld(n - i);
		sd[i] = sd[i + 1] + d[i];
	}
	
	cout << n - d[0] << endl;
}

int main() {

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);

	int tt = clock();

#else
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
	
#endif

	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);

	while(read()) {
	
		solve();
		
#ifdef _DEBUG

		cerr << "TIME = " << clock() - tt << " ms\n";
		tt = clock();
		
#endif

	}
	
	return 0;
}