#include <iostream>
#include <stdlib.h>
#include <cstdio>
#include <cctype>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <sstream>
#include <map>
using namespace std;

typedef long long ll;
bool isAb;



int main() {
#ifndef _CONSOLE
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);
#else
    freopen("B.in", "r", stdin);
#endif

    int n, q;
    cin >> n >> q;
    map<ll, ll> ma;
    int curneed = 0;
    int prevtime = 0;
    for (int i = 0; i < n; ++i)
    {
        char c;
        int a, b;
        cin >> c >> a >> b;
        if (curneed != 0)
        {
            int curtime = a - prevtime;
            ma[curneed] += curtime;
        }
        if (c == '-')
        {
            curneed += b;
        }
        else
        {
            curneed -= b;
        }
        prevtime = a;
    }
    
    vector<pair<int, int> > zap(q);
    for (int i = 0; i < q; ++i)
    {
        cin >> zap[i].first;
        zap[i].second = i;
    }
    sort(zap.begin(), zap.end());

    vector<pair<ll, ll> > all;
    ll ans = 0;
    for (auto it = ma.begin(); it != ma.end(); ++it)
    {
        all.push_back(*it);
    }
    for (int i = 0; i < all.size(); ++i)
    {
        ans += all[i].first * all[i].second;
    }

    vector<ll> res(zap.size());
    
    vector<ll> chsum(all.size() + 1, 0);
    for (int i = 0; i < all.size(); ++i)
    {
        chsum[i + 1] = chsum[i] + all[i].second;
    }

    int ptr = 0;
    for (int i = 0; i < zap.size(); ++i)
    {
        int curadd = zap[i].first;
        int ind = zap[i].second;
        if (curadd < curneed)
        {
            res[ind] = -1;
            continue;
        }
        while (all[ptr].first < curadd)
        {
            ans -= all[ptr].first * all[ptr].second;
            ptr++;
        }
        ll curans = ans;
        curans -= curadd* (chsum.back() - chsum[ptr]);
        res[ind] = curans;
    }

    for (int i = 0; i < res.size(); ++i)
    {
        if (res[i] == -1)
        {
            cout << "INFINITY\n";
        }
        else
            cout << res[i] << "\n";
    }
 
    return 0;
}
/*



x >= 5 && x <= 10 ||
x >= 7 && x <= 20 ||
x <= 2 ||
x >= 21 && x <= 25 ||
x >= 8 && x <= 10 ||
x >= 100

x <= 10 ||
x >= 0

x >= 10 && x <= 0
*/