#include <iostream>
#include <stdlib.h>
#include <cstdio>
#include <cctype>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <sstream>
using namespace std;

typedef long long ll;
bool isAb;



int main() {
#ifndef _CONSOLE
    freopen("hard.in", "r", stdin);
    freopen("hard.out", "w", stdout);
#else
    freopen("B.in", "r", stdin);
#endif

    string str;
    vector < pair<int, int> >all;
    while (getline(cin, str))
    {
        str += "||";
        stringstream stream;
        stream << str;
        string c, zn;
        int a;
        stream >> c >> zn >> a >> c;
        int left = -32768, right = 32767;

        if (zn == "<=")
            right = min(right, a);
        else
            left = max(left, a);

        if (c == "&&")
        {
            stream >> c >> zn >> a;
            if (zn == "<=")
                right = min(right, a);
            else
                left = max(left, a);
        }
        if (right < left)
        {
            cout << "false";
            return 0;
        }
        all.push_back(make_pair(right, left));
    }
    vector<pair<int, int> > ans;

    vector<pair<int, int> > scan;
    for (int i = 0; i < all.size(); ++i)
    {
        scan.push_back(make_pair(all[i].first, 1));
        scan.push_back(make_pair(all[i].second - 1, 0));
    }

    sort(scan.begin(), scan.end());
    int l = 1e9, r = -1e9;
    int cnt = 0;
    for (int i = 0; i < scan.size(); ++i)
    {
        if (scan[i].second == 0)
        {
            l = min(l, scan[i].first);
            cnt++;
        }
        if (scan[i].second == 1)
        {
            r = max(r, scan[i].first);
            cnt--;
        }
        if (cnt == 0)
        {
            ans.push_back(make_pair(l + 1, r));
            l = 1e9, r = -1e9;
        }
    }

    if (ans.size() == 1)
    {
        if (ans[0].first == -32768 && ans[0].second == 32767)
        {
            cout << "true";
            return 0;
        }
    }
    for (int i = 0; i < ans.size(); ++i)
    {
        bool fl = false;
        if (ans[i].first != -32768)
        {
            fl = true;
            printf("x >= %d ", ans[i].first);
        }
        if (ans[i].second != 32767)
        {
            if (fl)
                printf("&& ");
            printf("x <= %d ", ans[i].second);
        }
        if (i != ans.size() - 1)
        {
            printf("||\n");
        }
    }

    return 0;
}
/*



x >= 5 && x <= 10 ||
x >= 7 && x <= 20 ||
x <= 2 ||
x >= 21 && x <= 25 ||
x >= 8 && x <= 10 ||
x >= 100

x <= 10 ||
x >= 0

x >= 10 && x <= 0
*/