#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(v) (v).begin(), (v).end()

using namespace std;

typedef long long ll;

const int MAXN = 200000;
const int INF = 1e9 + 10;
const ll LONGINF = 4e18;
const ll MOD = 1000000007;

int* st = (new int[80000]) + 40000;

pair<int,int> range() {
    char sym;
    int l = -INF, r = -INF;
    while(cin && cin.peek() != '|') {
        if(cin.peek() == '<' || cin.peek() == '>') {
            sym = cin.get();
        } else if(cin.peek() == '-' || isdigit(cin.peek()))
            cin >> (l == -INF ? l : r);
        else
            cin.get();
    }
    cin.get();
    cin.get();
    cin.get();
    if(r == -INF) {
        if(sym == '<') {
            return mp(-32768, l);
        } else
            return mp(l, 32768);
    } else
        return mp(l, r);
}

void solve() {
    vector<pair<int,int> > ev;
    while(cin) {
        pair<int,int> p = range();
        if(p.first > p.second) {
            puts("false");
            return;
        }
        ev.pb(mp(p.first, 1));
        ev.pb(mp(p.second + 1, -1));
    }
    sort(all(ev));
    for(int i = -32768; i < 32768; ++i)
        st[i] = 0;
    int cur = 0, bal = 0;
    for(int i = -32768; i < 32768; ++i) {
        while(cur < ev.size() && ev[cur].first == i)
            bal += ev[cur++].second;
        if(bal)
            st[i] = 1;
    }
    vector<pair<int,int> > rngs;
    for(int i = -32768; i < 32768;) {
        if(st[i]) {
            int l = i, r;
            while(i < 32768 && st[i])
                r = i++;
            rngs.pb(mp(l, r));
        }
        else
            ++i;
    }
    int ans = 0;
    for(auto p : rngs) {
        if(p.first!= -32768) {
            printf("x >= %d ", p.first);
            if(p.second != 32768 - 1)
                printf("&& ");
            ++ans;
        }
        if(p.second != 32768 - 1) {
            printf("x <= %d ", p.second);
            ++ans;
        }
        if(p!=rngs.back())
            puts("||");
    }
    if(!ans)
        cout << (st[0] ? "true" : "false");
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen("hard.in", "r", stdin);
    freopen("hard.out", "w", stdout);
#endif // _DEBUG

    solve();

    return 0;
}

