#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(v) (v).begin(), (v).end()

using namespace std;

typedef long long ll;

const int INF = 1e9 + 10;
const ll LONGINF = 4e18;
const ll MOD = 1000000007;

bool msk[5000][10000];
int l[5000], r[5000];
long long mass[5010];
double x[5010], y[5010];

double cm(double p1, double m1, double p2, double m2) {
    return (m1/(m1 + m2) * p1 + m2/(m1 + m2) * p2);
}

void solve() {
    long long n;
    double w;
    long long h, m;
    cin >> n >> w;
    cin >> h >> m;
    x[h] = 0;
    y[h] = 0;
    mass[h] = 0;
    for (int i = h - 1; i >= 0; --i) {
        r[i] = n - 1;
        x[i] = ((double) n * w) / 2;
        y[i] = ((double) n * w) / 2;
        mass[i] = n;
    }
    for (int i = 0; i < m; ++i) {
        int lvl, k;
        cin >> lvl >> k;
        --lvl;
        --k;
        msk[lvl][k] = true;
        while (l[lvl] < n && msk[lvl][l[lvl]])
            ++l[lvl];
        while (r[lvl] >= 0 && msk[lvl][r[lvl]])
            --r[lvl];
        if (l[lvl] > r[lvl])
        {
            cout << "yes\n";
            cout << i + 1 << endl;
            return;
        }
        if (lvl % 2 == 0) {
            x[lvl] = cm(x[lvl], mass[lvl], k * w + w / 2, -1);
        } else {
            y[lvl] = cm(y[lvl], mass[lvl], k * w + w / 2, -1);
        }
//        cerr << x[lvl] << ' ' << y[lvl] << endl;
        mass[lvl] -= 1;
        double cx = 0, cy = 0, cmass = 0;
        for (int j = h - 1; j >= 1; --j) {
            cx = cm(cx, cmass, x[j], mass[j]);
            cy = cm(cy, cmass, y[j], mass[j]);
            cmass += mass[h];
            double lx = 0, rx = n * w, ly = 0, ry = n * w;
            if (j % 2 == 1) {
                lx = l[j - 1] * w;
                rx = (r[j - 1] + 1) * w;
            } else {
                ly = l[j - 1] * w;
                ry = (r[j - 1] + 1) * w;
            }
            if (cx <= lx || cx >= rx || cy <= ly || cy >= ry)
            {
                cout << "yes\n";
                cout << i + 1 << endl;
                return;
            }
        }
    }
    cout << "no\n";
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
#endif // _DEBUG

    solve();

    return 0;
}

