#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <climits>
#include <numeric>
#include <string>

using namespace std;
typedef long long LL;


bool slower(char c)
{
	return c != ' ' && islower(c);
}

bool supper(char c)
{
	return c != ' ' && isupper(c);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#endif

	vector<string> s(1002);
	int n = 0;
	while (!cin.eof())
	{
		getline(cin, s[n++]);
		if (cin.eof())
			break;
	}

	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < s[i].length(); ++j)
		{
			int lf = 0;
			int sk = j;
			int k = j;
			string abr = "";
			if (supper(s[i][k]))
			{
				abr.push_back(s[i][k]);
				k++;
			}
			else
			{
				cout << abr << s[i][k];

				j = k; continue;
			}

			if (slower(s[i][k]))
			{
				abr.push_back(s[i][k]);
				k++;
				while (slower(s[i][k]))
				{
					abr.push_back(s[i][k++]);
				}
			}
			else
			{
				cout << abr << s[i][k];
				j = k; continue;
			}

			if (s[i][k] == ' ')
			{
				abr.push_back(s[i][k]);
				k++;
			}
			else
			{
				cout << abr << s[i][k];
				j = k; continue;
			}

			if (supper(s[i][k]))
			{
				abr.push_back(s[i][k]);
				k++;
			}
			else
			{
				cout << abr << s[i][k];
				j = k; continue;
			}

			if (slower(s[i][k]))
			{
				abr.push_back(s[i][k]);
				k++;
				while (slower(s[i][k]))
				{
					abr.push_back(s[i][k++]);
				}
			}
			else
			{
				cout << abr << s[i][k];
				j = k; continue;
			}

			if (k < s[i].length() && isalpha(s[i][k]))
			{
				cout << s[i][j];
				continue;
			}

			bool fin2 = true;
			lf = abr.length();
			while (true)
			{
				lf = abr.length();
				if (s[i][k] == ' ')
				{
					abr.push_back(s[i][k]);
					k++;
				}
				else break;

				if (supper(s[i][k]))
				{
					abr.push_back(s[i][k]);
					k++;
				}
				else
				{
					break;
				}

				if (slower(s[i][k]))
				{
					abr.push_back(s[i][k]);
					k++;
					while (slower(s[i][k]))
					{
						abr.push_back(s[i][k++]);
					}
				}
				else
				{
					break;
				}

				if (k < s[i].length() && isalpha(s[i][k]))
				{
					break;
				}
			}
				string nabr = "";
				while (abr.length() != lf)
					abr.pop_back();
				for (int ii = 0; ii < abr.length(); ++ii)
				{
					if (isupper(abr[ii]))
						nabr.push_back(abr[ii]);
				}
				int nj = sk+lf-1;
				cout << nabr << " (" << abr << ")";
				j = nj;
		}
		if (i != n-1)
		cout << endl;
	}


	return 0;
}
