#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <climits>
#include <numeric>
#include <string>

using namespace std;
typedef long long LL;


bool slower(char c)
{
	return c != ' ' && islower(c);
}

bool supper(char c)
{
	return c != ' ' && isupper(c);
}

inline bool check(string & s)
{
	bool res = s.length() > 1;
	if (!supper(s[0]))
	{
		res = false;
	}
	for (int k = 1; k < s.size(); ++k)
	{
		if (res == false) break;
		res = slower(s[k]);
	}
	return res;
}
int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#endif

	vector<string> s(1002);
	int n = 0;
	vector<vector<string>> words;
	while (!cin.eof())
	{
		getline(cin, s[n]);
		string asdfasf = s[n];
		words.push_back(vector<string>());
		string word = "";
		bool sp = false;
		for (int i = 0; i < s[n].length(); ++i)
		{
			if (s[n][i] == ' ')
			{
				if (!sp)
				{
					sp = true;
					words.back().push_back(word);
					word = "";
				}
				word.push_back(' ');
				continue;
			}

			if (sp)
			{
				sp = false;
				words.back().push_back(word);
				word = "";
			}
			if (!isalpha(s[n][i]))
			{
				words.back().push_back(word);
				word = "";
				word.push_back(s[n][i]);
			}
			else
			{
				if (word.length() > 0 && !isalpha(s[n][i-1]))
				{
					words.back().push_back(word);
					word = "";
				}

				word.push_back(s[n][i]);
			}

		}
		if (word != "")
			words.back().push_back(word);

		n++;
		if (cin.eof())
			break;
	}

	vector<vector<bool>> ab(words.size());
	for (int i = 0; i < words.size(); ++i)
	{
		for (int j = 0; j < words[i].size(); ++j)
		{
			ab[i].push_back(words[i][j].length() > 1);
			if (!supper(words[i][j][0]))
			{
				ab[i].back() = false;
			}
			for (int k = 1; k < words[i][j].size(); ++k)
			{
				if (ab[i].back() == false) break;
				ab[i].back() = slower(words[i][j][k]);
			}
		}
	}

	for (int i = 0; i < ab.size(); ++i)
	{
		for (int j = 0; j < ab[i].size(); ++j)
		{
			if (!ab[i][j])
			{
				cout << words[i][j];
				continue;
			}

			vector<string> abrs;
			bool flag = true;
			if (!(j + 2 < ab[i].size() && words[i][j + 1] == " " && ab[i][j + 2]))
			{
				cout << words[i][j];
				continue;
			}

			for (; j < ab[i].size(); j++)
			{
				if (ab[i][j])
				{
					if (j + 1 < ab[i].size() && words[i][j + 1] == " ")
					{
						if (j + 1 < ab[i].size())
						{
							abrs.push_back(words[i][j]);
							abrs.push_back(words[i][j + 1]);
							j++;
							continue;
						}
						break;
					}
					else
					{
						abrs.push_back(words[i][j]);
						break;
					}
				}
				else break;
			}

			if (!check(abrs.back()))
			{
				j-=2;
				abrs.pop_back();
			}

			string nabr = "";
			for (int ii = 0; ii < abrs.size(); ++ii)
			{
				if (isupper(abrs[ii][0]))
				nabr.push_back(abrs[ii][0]);
			}
			cout << nabr << " (";

			for (int ii = 0; ii < abrs.size(); ++ii)
			{
				
				cout << abrs[ii];
			}
			cout << ")";
		}
		if (i != ab.size()-1)
		cout << endl;
	}

	return 0;
}
