def solve(line, inp, outp):
    b = [False] * 200
    elems = []

    s = ''
    for ch in line:
        if ch.isalpha():
            s = s + ch
            continue
        if len(s):
            elems.append(s)
            elems.append(ch)
            b.append(False)
            s = ''
        else:
            elems.append(ch)
            b.append(False)
    for ind, word in enumerate(elems):
        if word.isalpha() and word[0].isupper() and word[1:].islower():
            b[ind] = True

    abr = []
    left = -2
    right = -2
    for i in range(len(elems)):
        if b[i] == False:
            continue

        if left == -2 and b[i] and i + 2 < len(elems) and b[i + 1] == False and b[i + 2] == True and elems[i + 1] == ' ':
            left = i
            right = i + 2
            continue

        if left == -2:
            continue

        if b[i] and i + 2 < len(elems) and b[i + 1] == False and b[i + 2] == True and elems[i + 1] == ' ':
            right += 2
            continue
        else:
            abr.append([left, right])
            left = -2
            right = -2

    ind = 0
    ind_abr = 0
    while ind < len(elems):
        if ind_abr < len(abr) and abr[ind_abr][0] == ind:
            left = abr[ind_abr][0]
            right = abr[ind_abr][1]
            outp.write(''.join(map(lambda s: s[0], elems[left: right + 1:2])))
            outp.write(' (')
            while ind < right + 1:
                outp.write(elems[ind])
                ind += 1
            outp.write(')')
            ind = right + 1
            ind_abr += 1
            continue
        outp.write(elems[ind])
        ind += 1


with open('abbreviation.in', 'r') as inp:
    lines = inp.readlines()
    outp = open('abbreviation.out', 'w')
    for line in lines:
        solve(line, inp, outp)