with open("hard.in") as ftr:
    strings = ftr.readlines()

left = -2 ** 15
right = 2 ** 15
used = [False] * (right - left + 1)
bal = [0] * (right - left + 1)
for string in strings:
    lst = string.split()
    if '&&' in lst:
        l = int(lst[2])
        r = int(lst[6]) + 1
        #print(lst)
    elif '>=' in lst:
        l = int(lst[2])
        r = right
    else:
        l = left
        r = int(lst[2]) + 1
    bal[l - left] += 1
    bal[r - left] -= 1

cur = 0
for i in range(len(bal)):
    cur += bal[i]
    used[i] = (cur > 0)

answer = []
if False not in used[:-1]:
    answer = 'true'
elif True not in used[:-1]:
    answer = 'false'
else:
    last = -1
    for i in range(len(bal)):
        if used[i] and last == -1:
            last = i
        elif not used[i] and last != -1:
            if last + left == left:
                answer.append('x <= {0}'.format(i - 1 + left))
            elif i + left == right:
                answer.append('x >= {0}'.format(last + left))
            else:
                answer.append('x >= {0} && x <= {1}'.format(last + left, i - 1 + left))
            last = -1
    answer = ' ||\n'.join(answer)

with open("hard.out", "w") as ftw:
    print(answer, file=ftw)
