import sys


FILENAME = 'abbreviation'
sys.stdin = open(FILENAME + '.in')
sys.stdout = open(FILENAME + '.out', 'w')


import re


def abbr(match):
    s = match.group()
    return '{} ({})'.format(''.join(chunk[0] for chunk in s.split()), s)


text = sys.stdin.read()
text = re.sub(r'\b[A-Z][a-z]+( [A-Z][a-z]+\b)+', abbr, text)
print(text)


sys.stdout.flush()

