#include <bits/stdc++.h>
using namespace std;

bool is_cap(const string& s) {
    if (!isalpha(s[0]) || !isupper(s[0]) || s.size() < 2) return false;
    for (int i = 1; i < (int)s.size(); ++i)
        if (!islower(s[i])) return false;
    return true;
}

bool is_sp(const string& s) {
    return s.size() == 1 && s[0] == ' ';
}

int main() {
    freopen("abbreviation.in", "r", stdin);
    freopen("abbreviation.out", "w", stdout);
    string s;
    while (getline(cin, s)) {
        int n = s.size();
        string ans;
        vector<string> f;
        string cur;
        for (int i = 0; i < n; ++i) {
            if (isalpha(s[i]) && i > 0 && !isalpha(s[i - 1])) {
                f.push_back(cur);
                cur = "";
                cur += s[i];
            } else if (isalpha(s[i])) {
                cur += s[i];
            } else if (!isalpha(s[i]) && i > 0 && isalpha(s[i - 1])) {
                f.push_back(cur);
                cur = "";
                cur += s[i];
            } else {
                cur += s[i];
            }
        }
        if (!cur.empty()) f.push_back(cur);
        int m = f.size();
        for (int i = 0; i < m;) {
            if (!is_cap(f[i])) {
                ans += f[i];
                i++;
            } else {
                int j = i + 1;
                while (j + 1 < m && is_sp(f[j]) && is_cap(f[j + 1])) j += 2;
                if (j - i > 1) {
                    for (int k = i; k < j; k += 2) ans += f[k][0];
                    ans += " (";
                    for (int k = i; k < j; ++k) ans += f[k];
                    ans += ')';
                } else {
                    ans += f[i];
                }
                i = j;
            }
        }
        cout << ans << '\n';
    }
    return 0;
}
