#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

bool is_cap(string s) {
    if (s.size() < 2) return false;
    if (!(s[0] >= 'A' && s[0] <= 'Z')) return false;
    for (int i = 1; i < s.size(); ++i)
        if (!(s[i] >= 'a' && s[i] <= 'z'))
            return false;
    return true;
}

pair<string, int> get_word(const string& s, int st) {
    string ans = "";
    while (st < s.size() && (s[st] >= 'A' && s[st] <= 'Z' || s[st] >= 'a' && s[st] <= 'z'))
        ans += s[st++];
    return make_pair(ans, st);
}

string parse(string s) {
    string ans = "";
    string curabbr = "", curphrase = "";
    for (int i = 0; i < s.size(); ) {
        if (s[i] >= 'A' && s[i] <= 'Z' || s[i] >= 'a' && s[i] <= 'z') {
            pair<string, int> qqq = get_word(s, i);
            if (is_cap(qqq.first)) {
                curabbr += qqq.first[0];
                curphrase += (curphrase.size() ? " " : "") + qqq.first;
                i = qqq.second;
                if (i >= s.size() || s[i] != ' ') {
                    if (curabbr.size() > 1) {
                        ans += curabbr + " (" + curphrase + ")";
                    } else if (curabbr.size() == 1) {
                        ans += curphrase;
                    }
                    curabbr = curphrase = "";
                    if (i < s.size())
                        ans += s[i++];
                } else ++i;
            } else {
                if (curabbr.size() > 1) {
                    ans += curabbr + " (" + curphrase + ") ";
                } else if (curabbr.size() == 1) {
                    ans += curphrase + " ";
                }
                curabbr = curphrase = "";
                //if (ans.size() && ans[ans.size() - 1] == ')')
                //    ans += " ";
                ans += qqq.first;
                i = qqq.second;
            }
        } else {
            if (curabbr.size() > 1) {
                ans += curabbr + " (" + curphrase + ") ";
            } else if (curabbr.size() == 1) {
                ans += curphrase + " ";
            }
            curabbr = curphrase = "";
            ans += s[i];
            ++i;
        }
    }
    return ans;
}

int main()
{
    freopen("abbreviation.in", "r", stdin);
    freopen("abbreviation.out", "w", stdout);

    string s = "";
    int x;
    while ((x = getc(stdin)) != -1)
        s += char(x);
    cout << parse(s);

    return 0;
}
