#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int n, q;
int t[100105], k[100105];
char z[2];
pii query[100105];
pair<int, ll> res[100105];

int main()
{
    ios_base::sync_with_stdio(false);
    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);

    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> z >> t[i] >> k[i];
        if (*z == '-')
            k[i] = -k[i];
    }
    for (int i = 0; i < q; ++i) {
        cin >> query[i].first;
        query[i].second = i;
    }
    sort(query, query + q);
    int delta = 0;
    for (int i = 0; i < n; ++i) {
        delta += k[i];
    }
    if (delta > 0)
        delta = 0;
    delta = -delta;
    int curidx = 0;
    while (curidx < q && query[curidx].first < delta)
        res[curidx] = make_pair(query[curidx].second, int(2e9)), ++curidx;

    int cycles = delta;
    vector<pair<pii, int> > v;
    queue< pii > qu; /// TIME/COUNT
    ll ans = 0;
    for (int i = 0; i < n || qu.size(); ++i) {
        if (i < n) {
            if (k[i] > 0) {
                cycles += k[i];
            } else {
                qu.push(make_pair(t[i], -k[i]));
            }
        }
        while (cycles > 0 && qu.size()) {
            if (qu.front().second <= cycles) {
                v.push_back(make_pair(make_pair(qu.front().first, 0), qu.front().second));
                v.push_back(make_pair(make_pair(t[i], 1), qu.front().second));
                ans += t[i] - qu.front().first;
                cycles -= qu.front().second;
                qu.pop();
            } else {
                v.push_back(make_pair(make_pair(qu.front().first, 0), cycles));
                v.push_back(make_pair(make_pair(t[i], 1), cycles));
                ans += t[i] - qu.front().first;
                qu.front().second -= cycles;
                cycles = 0;
            }
        }
    }

    sort(v.begin(), v.end());
    vector<int> stk;
    vector<pair<pii, int> > st; /// HEIGHT/TYPE/LEN
    int balance = 0;
    for (int i = 0; i < v.size(); ++i) {
        if (v[i].first.second == 0) {
            stk.push_back(v[i].first.first);
            balance += v[i].second;
        } else {
            if (stk.size() && stk.back() != v[i].first.first) {
                st.push_back(make_pair(make_pair(balance - v[i].second, 0), v[i].first.first - stk.back()));
                st.push_back(make_pair(make_pair(balance, 1), v[i].first.first - stk.back()));
                balance -= v[i].second;
                stk.pop_back();
            }
        }
    }

    sort(st.begin(), st.end());
    //for (int i = 0; i < st.size(); ++i)
    //    cerr << st[i].first.first << " "          << st[i].first.second << " " << st[i].second << endl;

    while (curidx < q && query[curidx].first == delta)
        res[curidx] = make_pair(query[curidx].second, ans), ++curidx;

    ll curlen = 0;
    int stidx = 0;
    int prevpos = 0;
    while (curidx < q) {
        while (stidx < st.size() && st[stidx].first.first <= query[curidx].first) {
            ans -= (st[stidx].first.first - prevpos) * curlen;
            prevpos = st[stidx].first.first;
            if (st[stidx].first.second == 0)
                curlen += st[stidx].second;
            else
                curlen -= st[stidx].second;
            ++stidx;
        }
        int nextidx = curidx;
        while (nextidx < q && query[curidx].first == query[nextidx].first)
            res[nextidx] = make_pair(query[nextidx].second, ans - curlen * (query[nextidx].first - prevpos)), ++nextidx;
        curidx = nextidx;
    }

    sort(res, res + q);
    for (int i = 0; i < q; ++i) {
        if (res[i].second == int(2e9)) cout << "INFINITY\n";
        else cout << res[i].second << "\n";
    }

    return 0;
}
