#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>
#include <set>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

/*
This is ACM North Eastern European Regional Contest,
sponsored by Internationak Business Machines.
The. Best. Contest. Ever.
A Great Opportunityt for all contestants.
*/

bool check_a(string s) {
	if (islower(s[0]) || s.length() < 2)
		return 0;
	else {
		for (int i = 1; i < s.length(); ++i) {
			if (isupper(s[i]))
				return 0;
		}
	}
	return 1;
}

//void solve_a() {
//	vector<string> a(1, "");
//	while (!cin.eof()) {
//		string line, w = "";
//		getline(cin, line);
//		for (int i = 0; i < line.length(); ++i) {
//			if (isalpha(line[i])) {
//				w += line[i];
//			}
//			else {
//				bool ch = check_a(w);
//				if (!ch || line[i] != ' ' || line[i] == ' ' && line[i - 1] == ' ') {
//					if (ch) {
//						a[0] += w[0];
//						a.push_back(w);
//						w = "";
//					}
//					if (a.size() > 
//				}
//				w = "";
//			}
//		}
//	}
//}

void solve_f() {
	string post;
	cin >> post;
	int n = post.length();
	vector<double> res(n);
	ll sumw = 0, sumc = 0;
	double sumf = 0.0;
	res[n - 1] = 0.0;
	if (post[n - 1] == 'C')
		sumc += 1;
	else
		sumw += 1;
	for (int i = n - 2; i >= 0; --i) {
		int lf = n - i;

		if (post[i] == 'C') {
			res[i] = (sumf + sumw) / (double)lf;
		}
		else {
			res[i] = (sumf + sumc) / (double)lf;
		}

		//cout << res[i] << ' ' << sumc << ' ' << sumw << ' ' << sumf << endl;
		if (post[i] == 'C')
			sumc += lf;
		else
			sumw += lf;
		sumf += res[i];
	}
	cout.precision(20);
	//for (int i = 0; i < n; ++i)
	//	cout << res[i] << endl;
	cout << res[0];
}

int main() {
#define OJFILE "foreign"
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen(OJFILE".in", "r", stdin);
	freopen(OJFILE".out", "w", stdout);
#endif
	solve_f();
	return 0;
}