#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>
#include <set>
using namespace std;

typedef long long ll;
typedef vector<int> vi;

/*
This is ACM North Eastern European Regional Contest,
sponsored by Internationak Business Machines.
The. Best. Contest. Ever.
A Great Opportunityt for all contestants.
*/

void solve_a() {
	vector<string> a;
	string word;
	for (; !cin.eof();) {
		string s;
		getline(cin, s);
		string word = "";
		bool IS = true;
		for (int i = 0; i < s.length();) {
			/*if (isalpha(s[i])) {
				word += s[i];
			}
			else {
				if (!isupper(word[0])) IS = false;
				if (IS) {
					for (int j = 1; j < word.length(); ++j) {
						if (isupper(word[i])) {
							IS = false;
						}
						else {
							;
						}
					}
				}
				if (IS && word.length() > 1) {
					a.push_back(word);
				}
				else {

				}
			}*/
			string w = "";
			while (isalpha(s[i])) {
				w += s[i++];
			}
		}
	}
}

vi tree;
int trsz = (1 << 16);
void updtree(int l, int r, int v, int vl, int vr) {
	if (r < vl || l > vr) return;
	if (l <= vl && r >= vr) {
		tree[v] = 1;
	}
	else {
		int m = (vl + vr) / 2;
		updtree(l, r, v * 2, vl, m);
		updtree(l, r, v * 2 + 1, m + 1, vr);
	}
}

void updbot(int v, int vl, int vr) {
	if (vl == vr) return;
	if (tree[v]) {
		for (int i = vl; i <= vr; ++i) {
			tree[trsz + i] = 1;
		}
	}
	else {
		int m = (vl + vr) / 2;
		updbot(v * 2, vl, m);
		updbot(v * 2 + 1, m + 1, vr);
	}
}

/*
x >= 5 && x <= 10 ||
x >= 7 && x <= 20 ||
x <= 2 ||
x >= 21 && x <= 25 ||
x >= 8 && x <= 10 ||
x >= 100
*/

void solve_h() {
	tree.assign(trsz * 2, 0);
	while (!cin.eof()) {
		string op, tok;
		int l, r;
		cin >> tok >> op >> l;
		if (!cin.eof()) cin >> tok;
		l += 32768;
		if (tok == "&&") {
			cin >> tok >> op >> r;
			if (!cin.eof()) cin >> tok;
			r += 32768;
			updtree(l, r, 1, 0, trsz - 1);
		}
		else if (tok == "||" || cin.eof()) { // cin.eof()
			if (op == "<=") {
				updtree(0, l, 1, 0, trsz - 1);
			}
			else {
				updtree(l, trsz - 1, 1, 0, trsz - 1);
			}
		}
		else{
			break;
		}
	}
	updbot(1, 0, trsz - 1);
	/*
	for (int i = trsz/2; i < trsz/2 + 200; ++i) {
		cout << i-32768 << ' ' << tree[trsz + i] << endl;
	}*/
	int type = 3;
	for (int i = 1; i < trsz; ++i)
		if (tree[trsz] != tree[trsz + i])
			type = 0;
	if (type != 0) {
		type = tree[trsz] == 0 ? 1 : 2;
	}

	if (type == 0) {
		int l = 0, r = 0;
		if (tree[trsz] == 1) {
			while (tree[trsz + r] != 0)
				++r;
			cout << "x <= " << r - 1 - 32768 << " ||" << endl;
			l = r;
		}
		while (l < trsz) {
			while (l < trsz && tree[trsz + l] == 0) ++l;
			r = l;
			while (r < trsz && tree[trsz + r] == 1) ++r;
			if (r == trsz) break;
			cout << "x >= " << l - 32768 << " && x <= " << r - 1 - 32768 << " ||" << endl;
			l = r;
		}
		if (r == trsz) {
			cout << "x >= " << l - 32768;
		}
	}
	else if (type == 1) {
		cout << "false";
	}
	else {
		cout << "true";
	}
}

int main() {
#define OJFILE "hard"
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen(OJFILE".in", "r", stdin);
	freopen(OJFILE".out", "w", stdout);
#endif
	solve_h();
	return 0;
}