#include <iostream>
#include <sstream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

bool isnum(string & str)
{
	int i = 0;
	if (str[i] == '-') i = 1;
	for (i; i < str.size(); ++i)
	{
		if (str[i] < '0' || str[i] > '9') return false;
	}
	return true;
}

void solve()
{
	string inp;
	set<pair<int, int> > st;
	bool f = false;
	while (getline(cin, inp))
	{
		stringstream ss(inp);
		string tmp;
		pair<int, int> p = make_pair(-32768, 32768);
		int less = 0;
		while (ss >> tmp)
		{
			if (isnum(tmp))
			{
				if (less == 1)
				{
					p.first = stoi(tmp);
				}
				else if (less == 2)
				{
					p.second = stoi(tmp) + 1;
				}
			}
			else
			{
				if (tmp == ">=")
				{
					less = 1;
				}
				else if (tmp == "<=")
				{
					less = 2;
				}
			}
		}
		if (p.first < p.second)
		{
			st.insert(p);
			f = true;
		}
	}
	if (!f)
	{
		cout << "false";
		return;
	}
	vector<pair<int, int> > ans;
	ans.push_back(*st.begin());
	for (auto it = ++st.begin(); it != st.end(); ++it)
	{
		if (it->first <= ans.back().second)
		{
			ans.back().second = max(it->second, ans.back().second);
		}
		else
		{
			ans.push_back(*it);
		}
	}
	if (ans.size() == 1 && ans[0].first == -32768 && ans[0].second == 32768)
	{
		cout << "true";
		return;
	}
	for (auto it : ans)
	{
		if (it.first == -32768)
		{
			cout << "x <= " << it.second - 1;
		}
		else if (it.second == 32768)
		{
			cout << "x >= " << it.first;
		}
		else
		{
			cout << "x >= " << it.first << " && x <= " << it.second - 1;
		}
		if (it != ans.back())
		{
			cout << " ||\n";
		}
	}
}

int main()
{
#ifndef HOME
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
#endif
	solve();
}