//#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <map>
using namespace std;
typedef long long   ill;
typedef long double lld;

//ifstream cin("abbreviation.in");
//ofstream cout("abbreviation.out");
ifstream cin ("expect.in");
ofstream cout("expect.out");


int main() {
	ill n, q;
	cin >> n >> q;
	char h;
	ill t, k, t_old = 0;
	ill people = 0;
	map <ill, ill> mp;
	for (ill i = 0; i < n; ++i) {
		cin >> h >> t >> k;
		if (people > 0)
			mp[people] += t - t_old;
		if (h == '+')
			people -= k;
		else
			people += k;
		t_old = t;
	}
	if (people > 0) {
		mp[people] += 1;
	}

	ill ans = 0;
	ill tmp = 0;
	for (auto it = mp.rbegin(); it != mp.rend(); ++it) {
		ans += it->second * it->first;
		it->second += tmp;
		tmp = it->second;
	}


	vector <pair<ill, ill > > cycle(q);
	for (ill i = 0; i < q; ++i) {
		cin >> cycle[i].first;
		cycle[i].second = i;
	}
	sort(cycle.begin(), cycle.end());

	vector <ill> result(q);
	ill step = 0;
	for (auto& it : mp) {
		if (step < cycle.size() && it.first >= cycle[step].first) {
			if (people > cycle[step].first) {
//				cout << "INFINITY" << endl;
				result[cycle[step].second] = -1;
			}
			else {
//				cout << ans << endl;
				result[cycle[step].second] = ans;
			}
			++step;
		}
		ans -= it.second;
	}
	while (step < cycle.size()){
		if (people > cycle[step].first) {
			//				cout << "INFINITY" << endl;
			result[cycle[step].second] = -1;
		}
		else {
			//				cout << ans << endl;
			result[cycle[step].second] = ans;
		}
		++step;
	}
	for (ill i = 0; i < result.size(); ++i){
		if (result[i] == -1)
			cout << "INFINITY" << endl;
		else
			cout << result[i] << endl;
	}
}