//#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

int max_inf =  32767;
int min_inf = -32768;
//ifstream cin("abbreviation.in");
//ofstream cout("abbreviation.out");
ifstream cin("hard.in");
ofstream cout("hard.out");

vector<pair<int, int>> compress(vector<pair<int, int>> base) {
	if (base.size() < 2) return base;
	vector<pair<int, int>> res;
	sort(base.begin(), base.end());
	pair<int, int> seg = base[0];
	for (int i = 0; i < base.size(); i++){
		if (base[i].first <= seg.second + 1)
			seg.second = max(seg.second, base[i].second);
		else {
			res.push_back(seg);
			seg = base[i];
		}
	}
	res.push_back(seg);
	return res;
}

int main() {
	vector<pair<int, int> > segs;
	while (!cin.eof()){
			string oper = "||", x, sign;
			pair<int, int> res(min_inf, max_inf);
			int border;
			cin >> x >> sign >> border >> oper;
			if (sign == ">=")	res.first  = max(res.first,  border);
			else							res.second = min(res.second, border);
			if (oper == "&&") {
				cin >> x >> sign >> border >> oper;
				if (sign == ">=")	res.first = max(res.first, border);
				else							res.second = min(res.second, border);
			}
			if (res.first <= res.second)	segs.push_back(res);
	}

	segs = compress(segs);
	if (segs.empty()) 
		cout << "false" << endl;
	else {
		if (segs.size() == 1 && segs[0] == make_pair(min_inf, max_inf))
			cout << "true" << endl;
		else {
			for (int i = 0; i < segs.size(); ++i) {
				if (segs[i].first != min_inf && segs[i].second != max_inf)
					cout << "x >= " << segs[i].first << " && " << "x <= " << segs[i].second;
				else
					if (segs[i].first != min_inf)  cout << "x >= " << segs[i].first;
					else												   cout << "x <= " << segs[i].second;

				if (i != segs.size() - 1)				cout << " ||" << endl;
			}
		}
	}
	return 0;
}