#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>


using namespace std;

int main()
{
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	string s;
	while (!cin.eof())
	{
		getline(cin, s);
		if (s == "")
			return 0;
		string answer;
		string abbr;
		vector<string> words;
		string word;
		vector<bool> correct;
		vector<string> transitions;
		string trans;
		bool correct_word = true;
		for (char ch : s) {
			if ((ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z')) {
				if (trans.size() > 0) {
					if (words.size() == 0) {
						cout << trans;
					}
					else {
						transitions.push_back(trans);
					}
					trans = "";
				}
				if ((ch >= 'a' && ch <= 'z') ^ (word.size() > 0)) {
					correct_word = false;
				}
				word += ch;
			}
			else {
				if (word.size() > 0) {
					if (word.size() == 1) {
						correct_word = false;
					}
					words.push_back(word);
					correct.push_back(correct_word);
					word = "";
					correct_word = true;
				}
				trans += ch;
			}
		}
		if (word.size() != 0) {
			words.push_back(word);
			correct.push_back(correct_word);
		}
		if (trans.size() != 0) {
			if (words.size() == 0) cout << trans;
			else transitions.push_back(trans);
		}
		for (int i = 0; i < words.size(); i++) {
			if (correct[i] && ((abbr.size() > 0 && i > 0 && transitions[i-1] == " ") || (i + 1 < words.size() && correct[i + 1] && transitions[i] == " "))) {
				abbr += words[i][0];
			}
			else {
				if (abbr.size() > 0) {
					if (abbr.size() < i) {
						cout << transitions[i - (int)abbr.size() - 1];
					}
					cout << abbr << " (";
					for (int j = i - (int)abbr.size(); j < i; j++) {
						cout << words[j];
						if (j < i - 1) {
							cout << ' ';
						}
					}
					cout << ")";
					abbr = "";
				}
				if (i > 0) {
					cout << transitions[i - 1];
				}
				cout << words[i];
			}
		}
		if (abbr.size() > 0) {
			if (abbr.size() < words.size()) {
				cout << transitions[(int)words.size() - (int)abbr.size() - 1];
			}
			cout << abbr << " (";
			for (int j = (int)words.size() - (int)abbr.size(); j < (int)words.size(); j++) {
				cout << words[j];
				if (j < (int)words.size() - 1) {
					cout << ' ';
				}
			}
			cout << ")";
			abbr = "";
		}
		if (words.size() == transitions.size() && transitions.size() > 0) {
			cout << transitions[transitions.size() - 1];
		}
		cout << endl;
	}

	return 0;
}