#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>


using namespace std;

vector<vector<pair<long long, long long> > > dp;

vector<int> arr;

#define MAXN 2100

long long memsum = 0;
int mp1 = 2, mp2 = 0;

vector<int> func2(long long pos, int minpr, int summ, long long add)
{
	vector<int> ans;
	long long sum = 0;

	if (summ <= 0)
		return ans;

	int i = summ;

	for (int j = minpr; j < arr.size(); j++)
	{
		sum += dp[j][i].first + add * dp[j][i].second;
		if (sum > pos)
		{
			sum -= dp[j][i].first + add * dp[j][i].second;
			ans = func2(pos - sum, j + 1, summ - arr[j], add + 2 + to_string(arr[j]).size());
			ans.push_back(arr[j]);
			return ans;
		}
	}
	return ans;
}

vector<int> func(long long pos, bool mem)
{
	vector<int> ans;
	long long sum = mem ? memsum : 0;

	for (int i = mem ? mp1 : 2; i < MAXN; i++)
	{

		for (int j = (mem && i == mp1) ? mp2 : 0; j < arr.size(); j++)
		{
			sum += dp[j][i].first;
			if (sum > pos)
			{
				sum -= dp[j][i].first;
				ans = func2(pos - sum, j + 1, i - arr[j], 2 + to_string(arr[j]).size());
				ans.push_back(arr[j]);
				mp1 = i;
				mp2 = j;
				memsum = sum;
				return ans;
			}
		}
	}
	return ans;
}

int main()
{
	freopen("list.in", "r", stdin);
	freopen("list.out", "w", stdout);
	


	for (int i = 2; i < MAXN; i++)
	{
		bool fl = true;
		for (int j = 2; j * j <= i; j++)
		{
			if (i % j == 0)
				fl = false;
		}
		if (fl)
			arr.push_back(i);
	}
	dp.resize(arr.size() + 1);
	for (int i = 0; i < dp.size(); i++)
		dp[i].resize(MAXN);
	dp[arr.size()][0] = make_pair(2, 1);
	vector<vector<pair<long long, long long> > > sfsum;
	sfsum.resize(arr.size() + 1);

	for (int i = 0; i < sfsum.size(); i++)
		sfsum[i].resize(MAXN);
	for (int i = 0; i < sfsum.size(); i++)
		sfsum[i][0] = make_pair(2, 1);
	for (int i = 1; i < MAXN; i++)
	{
		
		for (int j = arr.size() - 1; j >= 0; j--)
		{
			long long c = i - arr[j];
			if (c >= 0)
			{
				
			/*	for (int k = j + 1; k <= arr.size(); k++)
				{
					if (dp[k][c].second > 0)
					{
						dp[j][i].second += dp[k][c].second;
						dp[j][i].first += 2;
						dp[j][i].first += dp[k][c].first + (2 + (to_string(arr[j]).size())) * dp[k][c].second;
					}
				}*/
				dp[j][i].second = sfsum[j + 1][c].second;
				dp[j][i].first = sfsum[j + 1][c].first + (2 + to_string(arr[j]).size()) * sfsum[j + 1][c].second;
				
			}
			sfsum[j][i].first = sfsum[j + 1][i].first + dp[j][i].first;
			sfsum[j][i].second = sfsum[j + 1][i].second + dp[j][i].second;
		}
	}
	long long a, b;
	cin >> a >> b;
	
	vector<int> tmp = func(a - 1, true);
	vector<int> next = tmp;
	long long pos = a;
	long long l = a, r = a + 1000;
	while (r - l > 1)
	{
		long long m = (l + r) / 2;
		if (tmp == func(m - 1, false))
			l = m;
		else
			r = m;
	}
	/*while (next == tmp) {
		pos++;
		next = func(pos - 1);
	}
	*/
	next = func(r - 1, true);
	pos = r;
	string ans;
	ans = "[";
	for (int i = tmp.size() - 1; i >= 0; i--) {
		ans += to_string(tmp[i]);
		if (i > 0)
			ans += ", ";
	}
	ans += "], ";
	ans = ans.substr(ans.length() + a - pos, pos - a);
	while (pos <= b) {
		ans += "[";
		for (int i = next.size() - 1; i >= 0; i--) {
			ans += to_string(next[i]);
			if (i > 0)
				ans += ", ";
		}
		ans += "], ";
		pos = ans.size() + a;
		next = func(pos - 1, true);
	}
	cout << ans.substr(0, b - a + 1);
	return 0;
}