#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define mp make_pair
#define pb push_back

struct Q {
	ll t;
	pair<ll, ll> pr;
	int id;
	Q () {}
	Q (ll t, int id) : t (t), pr (mp (0ll, 0ll)), id (id) {}
	Q (ll t, pair<ll, ll> pr) : t (t), pr (pr), id (-1) {};

   	bool operator < (Q tmp) const {
   		if (t != tmp.t)
   			return t > tmp.t;
		return id > tmp.id;
   	}
};

void operator += (pair<ll, ll> &a, pair<ll, ll> b) {
	a.first += b.first;
	a.second += b.second;
}

void recalc (pair<ll, ll> &a, ll t) {
	a.first += a.second * t;
}

void recalc (pair<ll, ll> &a, ll t1, ll t2) {
	recalc (a, t1 - t2);
}

ll c2 (ll n) {
	return n * (n + 1) / 2;
}

void add (ll &v, ll sv, ll a, ll d, ll t1, ll t2) {
	v += sv;
	ll n = t2 - t1;
	v += a * n;
	v += d * c2 (n);
}

int n, q;
vector<Q> lst;
int ans[100005];
int t[100005];
int k[100005];
char tt[100005];
ll bal;

void load () {
	cin >> n >> q;
	string tmp;
	for (int i = 0; i < n; i++) {
		cin >> tmp >> t[i] >> k[i];
		tt[i] = tmp[0];
	}
	t[n] = t[n - 1] + 1;
	for (int i = 0; i < n; i++) {
		if (tt[i] == '+') {
			bal -= k[i];
		}
		else {
			bal += k[i];
		}
		ll dt = t[i + 1] - t[i];
		if (bal <= 0ll) continue;
		lst.pb (Q (bal, mp (0ll, dt)));
	}
	for (int i = 0, T; i < q; i++) {
		cin >> T;
		lst.pb (Q (T, i));   
	}
}

void solve () {
	sort (lst.begin (), lst.end ());
	lst.resize (lst.size () + 1);

	for (int i = 0; i < (int) lst.size (); i++) {
		if (~lst[i].id) {
			ans[lst[i].id] = lst[i].pr.first;
			if (bal - lst[i].t > 0)
				ans[lst[i].id] = -1;
		}
		auto tmp = lst[i].pr;
		ll dt = lst[i].t - lst[i + 1].t;
		recalc (tmp, dt);
		lst[i + 1].pr += tmp;
	}

	for (int i = 0; i < q; i++) {
		if (-1ll == ans[i])
			cout << "INFINITY\n";
		else
			cout << ans[i] << '\n'; 
	}
}

int main () {
	ios_base::sync_with_stdio (false);
	cin.tie (0);                
	freopen ("expect.in", "r", stdin);
	freopen ("expect.out", "w", stdout);
	load ();
	solve ();


	return 0;
}