#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <map>

#define MININT -32768
#define MAXINT 32767

using namespace std;

map<int,int> mas;

void add(int left, int right){

	bool b = false;

	for (map<int, int>::iterator it = mas.begin(); it != mas.end(); it++){
		if (left < it->first && right >= it->first - 1){			
			int r = it->second;
			mas.erase(left);
			mas[left] = r;
			b = true;
			break;
		}

		if (left <= it->second + 1 && right > it->second){
			mas[it->first] = right;
			b = true;
			break;
		}

		if (left >= it->first  && right <= it->second){
			b = true;
			break;
		}

	}

	if (!b){
		mas[left] = right;
	}
}

int main(){
	freopen("in.in", "r", stdin);
	freopen("out.out", "w", stdout);



	string s, tmp;
	int a, b;

	while (true){
		cin >> tmp;
		cin >> s;
		cin >> a;

		int left = MININT;
		int right = MAXINT;

		if (s == ">="){
			left = a;
		}
		else{
			right = a;
		}

		

		if (!(cin >> tmp))
		{
			add(left, right);
			break;			
		}
		
		if (tmp == "||"){
			add(left, right);
			continue;
		}

		cin >> tmp >> s >> b;		

		if (s == "<="){
			right = b;
		}
		else{
			left = b;
		}


		if (left <= right){
			add(left, right);
		}		

		if (!(cin >> s && s == "||")){
			break;
		}
	}

	if (mas.size() == 0){
		cout << "false";
		return 0;
	}

	if (mas.size() == 1 && mas.find(MININT) != mas.end() && mas[MININT] == MAXINT){
		cout << "true";
		return 0;
	}

	for (map<int, int>::iterator it = mas.begin(); it != mas.end(); it++){
		if (it != mas.begin()){
			cout << " || " << endl;
		}
		if (it->first == MININT){
			cout << "x <= " << it->second;			
			continue;
		}

		if (it->second == MAXINT){
			cout << "x >= " << it->first;
			continue;
		}

		cout << "x >= " << it->first << " && x <= " << it->second;

	}


}