#include <iostream>
#include <string>
#include <vector>
using namespace std;

bool is_big(char a)
{
	return
		'A' <= a &&
		a <= 'Z';
}

bool is_small(char a)
{
	return
		'a' <= a &&
		a <= 'z';
}

bool is_letter(char a)
{
	return is_big(a) || is_small(a);
}

int end_of_word(string &s, int start)
{
	for (int i = start; i < s.length(); ++i)
	{
		if (!is_letter(s[i]))
			return i;
	}
	return s.length();
}

int end_of_shit(string &s, int start)
{
	for (int i = start; i < s.length(); ++i)
	{
		if (is_letter(s[i]))
			return i;
	}
	return s.length();
}

bool check_length(string &s)
{
	if (s.length() == 0)
	{
		int a = 1;
		int b = 0;
		return 0;
        //return a / b;
	}
	if (s.length() == 1)
		return false;
	return true;
}

bool is_capitalized(string &s)
{
	if (!check_length(s))
		return false;
	if (!is_big(s[0]))
		return false;
	for (int i = 1; i < s.length(); ++i)
		if (!is_small(s[i]))
			return false;
	return true;
}

string get_not_abbr(vector<string> &abbr)
{
	string res = "";
	for (int i = 0; i < abbr.size(); ++i)
	{
		res += abbr[i];
		if (i != abbr.size() - 1)
			res += ' ';
	}
	return res;
}

string get_abbr_letters(vector<string> &abbr)
{
	string res = "";
	for (int i = 0; i < abbr.size(); ++i)
		res += abbr[i][0];
	return res;
}

string get_abbr(vector<string> &abbr)
{
	string res = get_abbr_letters(abbr) + " (" + get_not_abbr(abbr) + ")";
	return res;
}

string abbr_to_str(vector<string> &abbr)
{
	string result;
	if (abbr.size() == 1)
		result = get_not_abbr(abbr);
	else if (abbr.size() >= 2)
		result = get_abbr(abbr);
	abbr.clear();
	return result;
}

string get_ans(string &s)
{
	string result = "";
	vector<string> abbr;
	bool read_word = true;
	for (int i = 0; i < s.length();)
	{
		if (read_word)
		{
			int start_shit = end_of_word(s, i);
			string word = s.substr(i, start_shit - i);
			if (is_capitalized(word))
				abbr.push_back(word);
			else
			{
				if (abbr.size() != 0)
					result += abbr_to_str(abbr) + ' ' + word;
				else
					result += word;
			}
			i = start_shit;
		}
		else
		{
			int start_word = end_of_shit(s, i);
			string shit = s.substr(i, start_word - i);
			if (shit == " ")
			{
				if (abbr.size() == 0)
					result += " ";
			}
			else
			{
				result += abbr_to_str(abbr) + shit;
			}
			i = start_word;
		}
		read_word = !read_word;
	}
	result += abbr_to_str(abbr);
	return result;
}

int main()
{
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	string s;
	string result = "";
	while (getline(cin, s))
	{
		result += get_ans(s) + '\n';
	}
	cout << result;
	return 0;
}
/*
ab Ab A Abc AB Abcd ABc Abcde AbC


Oh  No  Ectra Spaces.And,Punctuation Ruin Everything*/