#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <math.h>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; i++)
#define mp make_pair
#define left first
#define right second

bool isSmall(char c) {
	return ((int)(c) >= (int)('a') && (int)(c) <= (int)('z'));
}

bool isBig(char c) {
	return ((int)(c) >= (int)('A') && (int)(c) <= (int)('Z'));
}

bool isLetter(char c) {
	return isSmall(c) || isBig(c);
}

string s;
vector < pair<string, bool> > lex;

void check(int k) {
	int countB = 0;
	forn(i, lex[k].first.size())
		if (isBig(lex[k].first[i]))
			countB++;
	lex[k].second = (isBig(lex[k].first[0]) && lex[k].first.size() > 1 && countB == 1);
}

void write(vector<string> abr) {
	if (abr.size() == 1) {
		cout << abr[0];
		return;
	}

	if (abr.size() == 2 && abr[1] == " ") {
		cout << abr[0] << " ";
		return;
	}

	string b = "";
	forn(i, abr.size()) {
		if (abr[i] != " ") {
			b += abr[i][0];
		}
	}
	cout << b << " (";
	forn(i, abr.size()) {
		if (abr[i] != " ") {
			cout << abr[i];
			if (i == abr.size() - 1 || i == abr.size() - 2 && abr[abr.size() - 1] == " ")
				cout << ")";
			else
				cout << " ";
		}
	}
	if (abr[abr.size() - 1] == " ")
		cout << " ";
}


int main() {
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	while (getline(cin, s)) {
		lex.resize(0);
		s += '\n';
		bool have = false;
		forn(i, s.length()) {
			if (isLetter(s[i])) {
				if (have)
					lex[lex.size() - 1].first += s[i];
				else
				{
					lex.push_back(mp("", false));
					lex[lex.size() - 1].first += s[i];
					have = true;
				}
			}
			else {
				have = false;
				lex.push_back(mp("", false));
				lex[lex.size() - 1].first += s[i];
			}
		}

		forn(i, lex.size()) {
			check(i);
		}
		vector<string> abr;

		have = false;
		bool lastP = false;
		forn(i, lex.size()) {
			if (lex[i].second) {
				if (have) {
					abr.push_back(lex[i].first);
					lastP = false;
				}
				else {
					have = true;
					lastP = false;
					abr.resize(0);
					abr.push_back(lex[i].first);
				}
			}
			else {
				if (have) {
					if (lex[i].first == " ") {
						if (!lastP) {
							lastP = true;
							abr.push_back(lex[i].first);
						}
						else {
							write(abr);
							abr.resize(0);
							have = false;
							lastP = false;
							cout << lex[i].first;
						}
					}
					else {
						write(abr);
						abr.resize(0);
						have = false;
						lastP = false;
						cout << lex[i].first;
					}
				}
				else {
					cout << lex[i].first;
				}
			}
		}
	}
	return 0;

}