//// CCC.cpp : Defines the entry point for the console application.
////
//
#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <math.h>
#include <algorithm>
//
using namespace std;
//
//#define forn(i, n) for (int i = 0; i < n; i++)
//#define mp make_pair
//#define left first
//#define right second
//
//const int minInf = -32769;
//const int maxInf = 32768;
//
//vector <pair <int, int> > segments;
//vector <pair <int, int> > ans;
//string s;
//
//pair<int, int> GetSegment(string s) {
//	pair<int, int> curSegment;
//	curSegment = mp(minInf, maxInf);
//	int uk = 2;
//	int curInt = 0;
//	bool minus = false;
//	if (s[uk] == '>') {
//		uk = 5;
//		if (s[uk] == '-') {
//			uk++;
//			minus = true;
//		}
//		while (s[uk] != ' ') {
//			curInt = curInt * 10 + (int)(s[uk]) - (int)('0');
//			uk++;
//		}
//		if (minus)
//			curInt = -curInt;
//		curSegment.left = max(curSegment.left, curInt);
//		curInt = 0;
//		minus = false;
//	}
//	else {
//		uk = 5;
//		if (s[uk] == '-') {
//			uk++;
//			minus = true;
//		}
//		while (s[uk] != ' ') {
//			curInt = curInt * 10 + (int)(s[uk]) - (int)('0');
//			uk++;
//		}
//		if (minus)
//			curInt = -curInt;
//		curSegment.right = min(curSegment.right, curInt);
//		curInt = 0;
//		minus = false;
//	}
//	while (true) {
//		if (uk == s.size() || s[uk] == '|')
//			return curSegment;
//		if (s[uk] == '<' || s[uk] == '>')
//			break;
//		uk++;
//	}
//	if (s[uk] == '>') {
//		uk += 3;
//		if (s[uk] == '-') {
//			uk++;
//			minus = true;
//		}
//		while (s[uk] != ' ') {
//			curInt = curInt * 10 + (int)(s[uk]) - (int)('0');
//			uk++;
//		}
//		if (minus)
//			curInt = -curInt;
//		curSegment.left = max(curSegment.left, curInt);
//		curInt = 0;
//		minus = false;
//	}
//	else {
//		uk += 3;
//		if (s[uk] == '-') {
//			uk++;
//			minus = true;
//		}
//		while (s[uk] != ' ') {
//			curInt = curInt * 10 + (int)(s[uk]) - (int)('0');
//			uk++;
//		}
//		if (minus)
//			curInt = -curInt;
//		curSegment.right = min(curSegment.right, curInt);
//		curInt = 0;
//		minus = false;
//	}
//	return curSegment;
//}
//
//void write(pair<int, int> cur) {
//	if (cur.left <= minInf + 1) {
//		printf("x <= %d", cur.right);
//		return;
//	}
//	if (cur.right >= maxInf - 1) {
//		printf("x >= %d", cur.left);
//		return;
//	}
//	printf("x >= %d && x <= %d", cur.left, cur.right);
//	return;
//}
//
//int main()
//{
//	freopen("hard.in", "r", stdin);
//	freopen("hard.out", "w", stdout);
//
//	while (getline(cin, s))
//	{
//		s += ' ';
//		pair<int, int> p = GetSegment(s);
//		if (p.left <= p.right)
//			segments.push_back(p);
//	}
//	sort(segments.begin(), segments.end());
//	int rightedEnd = minInf - 2;
//	int leftedStart = minInf - 2;
//	forn(i, segments.size()) {
//		if (segments[i].left - 1 > rightedEnd) {
//			if (rightedEnd != minInf - 2) {
//				ans.push_back(mp(leftedStart, rightedEnd));
//			}
//			leftedStart = segments[i].left;
//			rightedEnd = segments[i].right;
//		}
//		else {
//			rightedEnd = max(rightedEnd, segments[i].right);
//		}
//	}
//	if (rightedEnd != minInf - 2) {
//		ans.push_back(mp(leftedStart, rightedEnd));
//	}
//
//	if (ans.size() == 0) {
//		printf("false");
//		return 0;
//	}
//
//	if (ans.size() == 1 && ans[0].left <= minInf + 1 && ans[0].right >= maxInf - 1) {
//		printf("true");
//		return 0;
//	}
//
//	forn(i, ans.size()) {
//		write(ans[i]);
//		if (i != ans.size() - 1)
//			printf(" ||\n");
//	}
//	return 0;
//}
//

double tree[2][4000009];
double delta[2][4000009];

class SumIntervalTree {
public:
	int n;
	int sz;
	int index;

	SumIntervalTree(int size, int id) {
		sz = size;
		index = id;
		int log = 0;
		while ((1 << log) < size)
			log++;
		n = 1 << log;
	}

	double sum(int from, int to) {
		return sum(1, from, to, 0, sz - 1);
	}

	double sum(int v, int l, int r, int tl, int tr) {
		if (l > r)
			return 0;
		push(v, tl, tr);
		if (l == tl && r == tr)
			return tree[index][v];

		int tm = (tl + tr) / 2;
		return sum(v * 2, l, min(tm, r), tl, tm) +
			sum(v * 2 + 1, max(tm + 1, l), r, tm + 1, tr);
	}


	void add(int v, int l, int r, int tl, int tr, double val) {
		if (l > r) return;
		if (l == tl && r == tr) {
			delta[index][v] += val;
			push(v, tl, tr);
			return;
		}

		push(v, tl, tr);

		int tm = (tl + tr) / 2;
		add(v * 2, l, min(r, tm), tl, tm, val);
		add(v * 2 + 1, max(l, tm + 1), r, tm + 1, tr, val);
		tree[index][v] = tree[index][v * 2] + tree[index][v * 2 + 1];
	}

	void add(int from, int to, double val) {
		add(1, from, to, 0, sz - 1, val);
	}

	void push(int v, int tl, int tr) {
		if (v * 2 < 2 * n) {
			delta[index][v * 2] += delta[index][v];
			delta[index][v * 2 + 1] += delta[index][v];
			tree[index][v] += delta[index][v] * (tr - tl + 1);
		}
		else {
			tree[index][v] += delta[index][v];
		}
		delta[index][v] = 0;
	}
};

int main() {
		//        SumIntervalTree tree = new SumIntervalTree(10);
		//        for (int i = 0; i < 10; i++)
		//            System.out.println(tree.sum(i, i));
		//        tree.add(0, 0, 1);
		//        tree.add(5, 7, 2);
		//        System.out.println();
		//        for (int i = 0; i < 10; i++)
		//            System.out.println(tree.sum(i, i));
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
	string s;
	cin >> s;
		int n = s.size();
		SumIntervalTree tree(n + 1, 0);
		SumIntervalTree treeRev(n + 1, 1);

		for (int i = n - 1; i >= 0; i--) {
			if (s[i] == 'C') {
				double sum = tree.sum(i + 1, n);
				sum /= (n - i);
				tree.add(i, i, sum);
				treeRev.add(i, i, sum);
				treeRev.add(i + 1, n, 1);
			}
			else {
				double sum = treeRev.sum(i + 1, n);
				sum /= (n - i);
				tree.add(i, i, sum);
				treeRev.add(i, i, sum);
				tree.add(i + 1, n, 1);
			}
			//            for (int j = 0; j <= n; j++)
			//                System.out.print(tree.sum(j, j) + " ");
			//            System.out.println();
			//            for (int j = 0; j <= n; j++)
			//                System.out.print(treeRev.sum(j, j) + " ");
			//            System.out.println();
			//            System.out.println();
		}
		cout.precision(10);
		cout << tree.sum(0, 0);
		return 0;
}

