#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

struct data
{
    int type; // 0 for word, 1 for separator
    string s;
};

bool valid(const string& s)
{
    if (sz(s) < 2) {
        return false;
    }
    if (!(s[0] >= 'A' && s[0] <= 'Z')) {
        return false;
    }
    for (int i = 1; i < sz(s); ++i) {
        if (!(s[i] >= 'a' && s[i] <= 'z')) {
            return false;
        }
    }
    return true;
}

void makeAbbr(vector<string>& v)
{
    if (sz(v) <= 1) {
        for (int i = 0; i < sz(v); ++i) {
            cout << v[i];
        }
        v.clear();
    } else {
        for (int i = 0; i < sz(v); ++i) {
            cout << v[i][0];
        }
        cout << " (";
        for (int i = 0; i < sz(v); ++i) {
            cout << v[i];
            if (i != sz(v) - 1) {
                cout << " ";
            }
        }
        cout << ")";
        v.clear();
    }
}

int main()
{

    freopen("abbreviation.in", "r", stdin);
    freopen("abbreviation.out", "w", stdout);

    //ifstream cin("abbreviation.in");
    //ofstream cout("abbreviation.out");

    //ios_base::sync_with_stdio(false);
    //cin.tie(0);

    vector<data> text;

    char c;
    while (scanf("%c", &c) != -1) {
        if (isalpha(c)) {
            if (text.empty() || text.back().type == 1) {
                string tmp = "";
                tmp += c;
                text.pb({0, tmp});
            } else {
                text.back().s += c;
            }
        } else if (text.empty() || text.back().type == 0) {
            string tmp = "";
            tmp += c;
            text.pb({1, tmp});
        } else {
            text.back().s += c;
        }
    }

    vector<string> st;

    for (int i = 0; i < sz(text); ++i) {
        if (text[i].type == 0) {
            if (valid(text[i].s)) {
                st.pb(text[i].s);
            } else {
                cout << text[i].s;
            }
        } else {
            if (text[i].s != " ") {
                makeAbbr(st);
                cout << text[i].s;
            } else {
                if (i == sz(text) - 1 || st.empty()) {
                    makeAbbr(st);
                    cout << text[i].s;
                } else {
                    if (valid(text[i + 1].s)) {
                        continue;
                    }
                    makeAbbr(st);
                    cout << text[i].s;
                }
            }
        }
    }

}
