
#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

vector<int> p;
vector<vector<int> > A;
vector<int> used;

int getp(int v)
{
    if (v != p[v])
    {
        p[v] = getp(p[v]);
    }
    return p[v];
}

void unite(int v, int w)
{
    v = getp(v);
    w = getp(w);
    if (rand() % 2)
    {
        p[v] = w;
    }
    else
    {
        p[w] = v;
    }
}
struct data
{
    char op;
    int v;
    int c1, c2;

};
vector<data> ans;
vector<int> tin;
vector<int> tout;
int tim = 0;
void dfs(int v, int pr)
{
    if (used[v])
    {
        return;
    }
    used[v] = 1;
    tin[v]  =tim;
    tim++;
    vector<int> par, son;

    for (auto w : A[v]) {
        if (!used[w]) {
            dfs(w, v);
            son.push_back(w);
        }
    }

     tout[v] = tim;
    tim++;

    for(auto w:A[v])
    {
        if (w == pr || (tin[v] < tin[w] && tout[w] < tout[v])) {
            continue;
        }
        par.push_back(w);

    }
    ans.push_back({'r', v, 1, 4});
    for(auto w:son)
    {
        if (getp(v) != getp(w))
        {
            unite(v, w);
            ans.pb({'j', 0, v, w});
        }
        ans.pb({'c', v, 3, 4});
        ans.pb({'r', v, 3, 2});
    }
    for(auto w:par)
    {
        if (getp(v) != getp(w))
        {
            unite(v, w);
            ans.pb({'j', 0, v, w});
        }
        //cout<<v<<' '<<w<<endl;
        ans.pb({'c', v, 1, 4});
    }
    ans.pb({'r', v, 4, 3});
    used[v] = 2;

}


int main()
{
    freopen("cactus.in", "r", stdin);
    freopen("cactus.out", "w", stdout);
    int N, M;
    cin>>N>>M;
    A.resize(N);
    p.resize(N);
    for(int i = 0; i < N; ++i)
    {
        p[i] = i;
    }
    for(int i = 0; i < M; ++i)
    {
        int k;
        cin>>k;
        int v;
        cin>>v;
        v--;
        for(int j = 1 ; j < k; ++j)
        {
            int w;
            cin>>w;
            w--;
            A[v].push_back(w);
            A[w].push_back(v);
            v = w;
        }
    }
    used.resize(N);
    tin.resize(N);
    tout.resize(N);
    tim = 1;
   // cout<<"LOL"<<endl;

    dfs(0, -1);
    cout<<ans.size()<<endl;
    for(auto el:ans)
    {
        if (el.op == 'j')
        {
            cout<<el.op<<' '<<el.c1+1<<' '<<el.c2+1<<endl;
        }
        else
        {
            cout<<el.op<<' '<<el.v+1<<' '<<el.c1<<' '<<el.c2<<endl;
        }
    }




}
