
#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

struct data
{
    ll val;
    ll dt;
    bool operator<(const data& other) const
    {
        return val < other.val;
    }
};

struct query
{
    ll val;
    int id;
    bool operator<(const query& other) const
    {
        return val < other.val;
    }
};

int main()
{

    freopen("expect.in", "r", stdin);
    freopen("expect.out", "w", stdout);
    //freopen("jenga.out", "w", stdout);
    //freopen("abbreviation.out", "w", stdout);

    //ifstream cin("abbreviation.in");
    //ofstream cout("abbreviation.out");

    //ios_base::sync_with_stdio(false);
    //cin.tie(0);

    ll prevTimer = 0;

    int n, q;
    scanf("%d%d\n", &n, &q);
    ll currSum = 0;

    vector<data> v;

    for (int i = 0; i < n; ++i) {
        char type;
        scanf("%c", &type);
        ll timer, cnt;
        scanf("%lld%lld\n", &timer, &cnt);
        v.pb({max(currSum, ll(0)), timer - prevTimer});
        if (type == '+') {
            currSum -= cnt;
        } else {
            currSum += cnt;
        }
        prevTimer = timer;
    }
    v.pb({max(currSum, ll(0)), 0});

    sort(all(v));
    ++n;
    /*for (int i = 0; i < sz(v); ++i) {
        cout << v[i].val << " " << v[i].dt << "\n";
    }*/

    vector<ll> ans(q);
    vector<query> queries(q);
    for (int i = 0; i < q; ++i) {
        scanf("%lld", &queries[i].val);
        queries[i].id = i;
    }

    sort(all(queries));

    vector<ll> sumSuffDt(n);
    sumSuffDt[n - 1] = v.back().dt;
    for (int i = n - 2; i >= 0; --i) {
        sumSuffDt[i] = sumSuffDt[i + 1] + v[i].dt;
    }
    ll curr = 0;
    for (int i = 0; i < n; ++i) {
        curr += v[i].val * v[i].dt;
    }

    int ptr = 0;
    for (int i = 0; i < q; ++i) {
        ll x = queries[i].val;
        ll delta = x;
        if (i) {
            delta -= queries[i - 1].val;
        }
        while (ptr + 1 < n && v[ptr + 1].val < x) {
            curr -= (v[ptr + 1].val - (x - delta)) * v[ptr + 1].dt;
            v[ptr + 1].val = 0;
            ++ptr;
        }
        if (ptr + 1 < n) {
            curr -= delta * sumSuffDt[ptr + 1];
        }
        currSum -= delta;
        if (currSum > 0) {
            ans[queries[i].id] = -1;
        } else {
            ans[queries[i].id] = curr;
        }
    }

    for (int i = 0; i < q; ++i) {
        if (ans[i] == -1) {
            printf("INFINITY\n");
        } else {
            printf("%lld\n", ans[i]);
        }
    }

}
