#include <bits/stdc++.h>

using namespace std;

bool isok(string & word) {
	if (word.length() < 2) {
		return false;
	}
	if (!isupper(word[0])) {
		return false;
	}
	for (int i = 1; i < (int)word.length(); i++) {
		if (!islower(word[i])) {
			return false;
		}
	}
	return true;
}


string text;
string buf;
string abbr;
int space = 0;

void clearbuf(){
	if(abbr.size() > 1){
		stack<char> bx;
		while(!isalpha(buf.back())){
			bx.push(buf.back());
			buf.pop_back();
		}
		text += abbr;
		text += " (";
		text += buf;
		text += ")";
		while(!bx.empty()){
			text.push_back(bx.top());
			bx.pop();
		}
	} else {
		text += buf;
	}
	buf.clear();
	abbr.clear();
}

int main() {
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	string rawt;
	queue<char> qch;
	while (true) {
		char c = cin.get();
		if(cin.eof()){
			break;
		}
		if(!isalnum(c) && c != ' '){
			qch.push(c);
			rawt.push_back('\n');
		} else {
			rawt.push_back(c);
		}
	}
	stringstream ss;
	ss << rawt;
	while (!ss.eof()) {
		char c = ss.peek();
		if(isspace(c)){
			space++;
			if(c != ' ' || buf.empty() || space > 1){
				clearbuf();
				text.push_back(ss.get());
			} else {
				buf.push_back(ss.get());
			}
		} else {
			space = 0;
			string word;
			ss >> word;
			if(isok(word)){
				buf += word;
				abbr.push_back(word[0]);
			} else {
				clearbuf();
				text += word;
			}
		}
	}
	cerr << rawt;
	clearbuf();
	for(int i = 0; i < (int)text.length(); i++){
		if(text[i] == '\n'){
			text[i] = qch.front();
			qch.pop();
		}
	}
	assert(qch.empty());
	cout << text;
}
