#include <bits/stdc++.h>

using namespace std;
typedef long double ld;

const int MIN = -(1 << 15);
const int MAX = (1 << 15) - 1;

int readnum(int& pos, string const& s) {
	int ret = 0;
	int c = 1;
	if (s[pos] == '-') {
		c = -1;
		pos++;
	}
	while (pos < (int) s.size() && s[pos] <= '9' && s[pos] >= '0') {
		ret *= 10;
		ret += (s[pos++] - '0');
	}
	return ret * c;
}

void solve() {
	string s;
	vector< pair<int, int> > a;
	while (getline(cin, s)) {
		int l = MIN, r = MAX;
		int iter = 0;
		while (iter < (int) s.size()) {
			assert(s[iter] == 'x');
			char sgn = s[iter+2];
			iter = iter + 5;
			int value = readnum(iter, s);
			iter += 4;
			if (sgn == '>') {
				l = max(l, value);
			} else {
				r = min(r, value);
			}
		}
		if (l <= r) {
			a.push_back(make_pair(l, r));
		}
	}
	if (a.empty()) {
		cout << "false\n";
		return;
	}
	sort(a.begin(), a.end());
	if (a[0].first == MIN && a[0].second == MAX && a.back().first == MIN && a.back().second == MAX) {
		cout << "true\n";
		return;
	}
	vector< pair<int, int> > e;
	for (auto x : a) {
		e.push_back(make_pair(x.first, -1));
		e.push_back(make_pair(x.second + 1, 1));
	}
	vector< pair<int, int> > ans;
	sort(e.begin(), e.end());
	int first;
	int bal = 0;
	for (auto x : e) {
		if (!bal) {
			first = x.first;
			++bal;
		} else if (x.second == -1) {
			bal++;
		} else {
			bal--;
			if (!bal) {
				ans.push_back(make_pair(first, x.first - 1));
			}
		}
	}
	string answer;
	for (int i = 0; i < (int) ans.size(); ++i) {
		int l = ans[i].first;
		int r = ans[i].second;
		string cr;
		if (l != MIN) {
			cr +=  "x >= " + to_string(l);
		}
		if (r != MAX) {
			if (!cr.empty()) {
				cr += " && ";
			}
			cr += "x <= " + to_string(r);
		}
		if (!cr.empty()) {
			if (!answer.empty()) {
				answer += " ||\n";
			}
			answer += cr;
		}
	}
	if (answer.empty()) {
		cout << "true\n";
	} else cout << answer << '\n';
}

int main() {
    #ifdef KOBRA
        freopen("input.txt", "r", stdin);
//        freopen("output.txt", "w", stdout);
    #else
        freopen("hard.in", "r", stdin);
        freopen("hard.out", "w", stdout);
    #endif // KOBRA
    solve();
	
    return 0;
}
