#include <bits/stdc++.h>

using namespace std;

typedef long double ld;

const int MAXN = 10;

ld hp[MAXN + 1], wp[MAXN + 1];

int n, h, m;
int l[MAXN + 1], r[MAXN + 1], cnt[MAXN + 1];
bool delt[MAXN + 1][MAXN + 1];
int reqn;

void rebound(int level) {
	while (l[level] + 1 <= n && delt[level][l[level] + 1]) {
		l[level]++;
	}
	while (r[level] > 0 && delt[level][r[level]]) {
		r[level]--;
	}
	if (r[level] == 0) {
		if (level == h) {
			h--;
		} else {
			cout << "yes\n" << reqn;
			exit(0);
		}
	}
}

int lev, k;

void recalc(int level) {
	ld x = ld(n) / 2;
	ld y = ld(k) + 0.5;
	if ((lev ^ 1) == 0)
		swap(x, y);
	hp[level] = (hp[level] * cnt[level] - x) / (cnt[level] - 1);
	wp[level] = (wp[level] * cnt[level] - y) / (cnt[level] - 1);
	cnt[level]--;
}

bool isgood(int level) {
	if (level + 1 > h) {
		return true;
	}
	ld x = hp[level + 1];
	if (lev ^ 1) {
		x = wp[level + 1];
	}
	return (x > l[level] && x < r[level]);
}

int main() {
	ios_base::sync_with_stdio(false);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
#endif // KOBRA
	cin >> n >> h >> h >> m;
	fill(hp, hp + MAXN + 1, ld(n) / 2);
	fill(wp, wp + MAXN + 1, ld(n) / 2);
	fill(r, r + MAXN + 1, n);
	for (reqn = 1; reqn <= m; reqn++) {
		cin >> lev >> k;
		delt[lev][k] = true;
		rebound(lev);
		for (int i = lev; i >= 1; i--) {
			if (!isgood(i)) {
				cout << "yes\n" << reqn;
				exit(0);
			}
			recalc(i);
		}
	}
	cout << "no\n";
}
