#include <bits/stdc++.h>

using namespace std;

int l[5001];
int k[5001];
int n, w;

const long double eps = 1e-10;
const long double INF = 1e9;
long double gt(int x){
    return ((2 * x + 1) * w) / 2.0;
}

int pr[5001];
int nx[5001];
int head, tail;
int sz;

void init(){
    head = 0;
    tail = n - 1;
    sz = n;
    for (int i = 1; i < n; i++){
        pr[i] = i - 1;
        nx[i - 1] = i;
    }
    pr[0] = -1;
    nx[n - 1] = -1;
}

void del(int i){
    if (pr[i] != -1)
        nx[pr[i]] = nx[i];
    else
        head = nx[i];
    if (nx[i] != -1)
        pr[nx[i]] = pr[i];
    else
        tail = pr[i];
    sz--;
}

bool emp(){
    return sz == 0;
}

int beg(){
    return head;
}

int rbeg(){
    return tail;
}

int main()
{
    #ifndef DEBUG
    freopen("jenga.in", "r", stdin);
    freopen("jenga.out", "w", stdout);
    #else
    freopen("input.txt", "r", stdin);
    #endif // DEBUG
    cin >> n >> w;
    int h, m;
    cin >> h >> m;
    for (int i = 0; i < m; i++){
        cin >> l[i] >> k[i];
    }
    bool g = 1;
    long double mid = (n * w) / 2.0;
    long double half = w / 2.0;
    int ans = m + 1;
    for (int lv = h; lv > 0; lv--){
        init();
        long double x = mid, y = mid;
        long long wg = n;
        wg *= h - lv;
        for (int i = 0; i < m; i++){
            if (l[i] > lv){
                if (wg < 2){
                    wg = 0;
                }
                else{
                    if (l[i] & 1){
                        x = (wg * x - gt(k[i] - 1)) / ((long double)(wg - 1));
                        y = (wg * y - mid) / ((long double)(wg - 1));
                    }
                    else{
                        y = (wg * y - gt(k[i] - 1)) / ((long double)(wg - 1));
                        x = (wg * x - mid) / ((long double)(wg - 1));
                    }
                    wg--;
                }
            }
            else if (l[i] == lv){
               del(k[i] - 1);
            }
            long double l, r;
            if (emp()){
                l = INF;
                r = -INF;
            }
            else{
                l = gt(beg()) - half;
                r = gt(rbeg()) + half;
            }
            long double z;
            if (lv & 1){
                z = x;
            }
            else{
                z = y;
            }
            if (wg != 0 && (l > z - eps || r < z + eps)){
                ans = min(ans, i + 1);
            }
        }
    }
    if (ans == m + 1){
        cout << "no\n";
        return 0;
    }
    cout << "yes\n" << ans << "\n";
    return 0;
}

