#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <memory.h>
#include <assert.h>
using namespace std;

#pragma comment(linker, "/STACK:100000000")

#define ll long long
#define sz(x) (int)(x).size()
#define mp make_pair

string get_next_word(string& s, int& p) {
	string res;
	for (int i = p; i < sz(s); i++) {
		if (s[i] >= 'a' && s[i] <= 'z' || s[i] >= 'A' && s[i] <= 'Z') {
			res += s[i];
			p++;
		}
		else {
			if (res.empty()) res += s[i], p++;
			break;
		}
	}
	return res;
}

bool check(string& s) {
	if (sz(s) < 2) return false;
	for (int i = 1; i < sz(s); i++) {
		if (s[i] >= 'a' && s[i] <= 'z') {}
		else return false;
	}
	if (s[0] >= 'A' && s[0] <= 'Z') return true;
	else return false;
}

int main() {
	//freopen("input.txt", "rt", stdin);
	freopen("abbreviation.in", "rt", stdin);
	freopen("abbreviation.out", "wt", stdout);

	string s;
	while (getline(cin, s)) {
		string res;
		int p = 0;
		vector<string> tmp;
		bool spaces = false;
		while (p < sz(s)) {
			string word = get_next_word(s, p);
			tmp.push_back(word);
		}
		for (int i = 0; i < sz(tmp); i++) {
			if (check(tmp[i])) {
				if (i + 2 < sz(tmp) && tmp[i + 1] == " " && check(tmp[i + 2])) {
					int j = i + 2;
					while (j + 2 < sz(tmp) && tmp[j + 1] == " " && check(tmp[j + 2])) {
						j += 2;
					}
					string res;
					for (int k = i; k <= j; k += 2) res += tmp[k][0];
					cout << res << " (";
					for (int k = i; k <= j; k++) cout << tmp[k];
					cout << ")";
					i = j;
				}
				else {
					cout << tmp[i];
				}
			}
			else {
				cout << tmp[i];
			}
		}
		cout << endl;
	}

	return 0;
}
