#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <memory.h>
#include <assert.h>
using namespace std;

#pragma comment(linker, "/STACK:100000000")

#define ll long long
#define sz(x) (int)(x).size()
#define mp make_pair

int getinteger(string& s, int& p) {
	int val = 0;
	bool sign = false;
	if (s[p] == '-') sign = true, p++;
	while (s[p] >= '0' && s[p] <= '9') {
		val *= 10;
		val += s[p] - '0';
		p++;
	}
	if (sign) val *= -1;
	return val;
}

int mas[100100];
bool vis[100100];

int main() {
	//freopen("input.txt", "rt", stdin);
	freopen("hard.in", "rt", stdin);
	freopen("hard.out", "wt", stdout);
	const int MINI = -32768;
	const int MAXI = 32767;
	vector<pair<int, int> > intervals;
	string s;
	while (getline(cin, s)) {
		if (s.empty()) continue;
		bool fand = false;
		for (int i = 0; i < sz(s); i++) {
			if (s[i] == '&') fand = true;
		}
		int p = 0;
		int L = MINI, R = MAXI;
		if (s[p + 2] == '>' && s[p + 3] == '=') {
			p = p + 5;
			L = max(L, getinteger(s, p));
		}
		else {
			p = p + 5;
			R = min(R, getinteger(s, p));
		}
		if (p + 1 < sz(s) && s[p + 1] == '&') {
			p += 4;
			if (s[p + 2] == '>' && s[p + 3] == '=') {
				p = p + 5;
				L = max(L, getinteger(s, p));
			}
			else {
				p = p + 5;
				R = min(R, getinteger(s, p));
			}
		}
		intervals.push_back(mp(L, R));
	}
	const int ADD = 50000;
	sort(intervals.begin(), intervals.end());
	for (int i = 0; i < sz(intervals); i++) {
		int L = intervals[i].first;
		int R = intervals[i].second;
		if (L <= R) {
			mas[L + ADD]++;
			mas[R + 1 + ADD]--;
		}
	}
	int sum = 0;
	for (int i = 0; i < 100100; i++) {
		sum += mas[i];
		if (sum) vis[i] = true;
	}

	int cnt = 0;
	for (int i = 0; i < 100100; i++) {
		if (vis[i]) cnt++;
	}
	if (cnt == 0) {
		cout << "false" << endl;
		return 0;
	}
	if (cnt == MAXI - MINI + 1) {
		cout << "true" << endl;
		return 0;
	}
	bool pr = false;
	for (int i = MINI; i <= MAXI; i++) {
		if (vis[i + ADD]) {
			int j = i;
			while (j + 1 <= MAXI && vis[j + 1 + ADD]) j++;
			int l = i, r = j;
			i = j;
			if (pr) cout << " ||" << endl;
			pr = true;
			if (l == MINI) cout << "x <= " << r;
			else if (r == MAXI) cout << "x >= " << l;
			else cout << "x >= " << l << " && x <= " << r;
		}
	}
	cout << endl;

	return 0;
}
