#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <vector>
#include <list>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

string l = "p";


pair<int, int> getBord(string line){
	int det = line.find("&&");
	if (det == -1){
		int tmp;
		if (line.find("<=") != -1){
			sscanf(line.c_str(), " x <= %d", &tmp);
			sscanf(line.c_str(), "x <= %d", &tmp);
			return{ -32768, tmp };
		}
		else {
			sscanf(line.c_str(), "x >= %d", &tmp);
			return{ tmp, 32767 };
		}
	}
	else{
		pair<int, int> f = getBord(line.substr(0, det)),
			s = getBord(line.substr(det + 2));
		return{ max(f.first, s.first), min(f.second, s.second) };
	}
}

int main(){
#if !_DEBUG
	l = "hard";
#endif
	ifstream cin(l + ".in");
	ofstream cout(l + ".out");
	map<int, int> mp;
	while (!cout.eof()){
		string line;
		getline(cin, line);
		if (line == "") break;
		pair<int, int> tmp = getBord(line);
		if (tmp.second < tmp.first) continue;
		mp[tmp.first]++;
		mp[tmp.second]--;
	}
	int level = 0;
	pair<int, int> bord;
	if (mp.size() == 0) cout << "false\n";

	queue<pair<int, int>> que;
	bool merge = false;
	for (auto &x : mp){
		if (level == 0 && !merge) bord.first = x.first;
		else merge = false;
		level += x.second;
		if (level == 0){
			if (mp.count(x.first + 1)){
				merge = true;
				continue;
			}
			bord.second = x.first;
			que.push(bord);
		}
	}
	while (!que.empty()){
		if (que.front().first == -32768){
			if (que.front().second != 32767) cout << "x <= " << que.front().second;
			else cout << "true\n";
		}
		else if (que.front().second == 32767){
			cout << "x >= " << que.front().first;
		}
		else cout << "x >= " << que.front().first << " && " << "x <= " << que.front().second;
		if (que.size() > 1) cout << " ||\n";
		que.pop();
	}
	return 0;
}