#include <iostream>
#include <string>
#include <vector>
#include <fstream>
#include <sstream>

using namespace std;


ifstream in("abbreviation.in");
ofstream out("abbreviation.out");
#define cin in
#define cout out
/**/

bool islt(char x) {
	return (x >= 'A' && x <= 'Z') ||
		(x >= 'a' && x <= 'z');
}

bool islow(char x) {
	return (x >= 'a' && x <= 'z');
}

bool iscap(char x) {
	return (x >= 'A' && x <= 'Z');
}

pair<string, int> readWord(const string &s, int i) {
	string res = "";
	int j = i;
	while (j < s.length() && islt(s[j])) {
		res += s[j];
		j++;
	}
	j--;
	return make_pair(res, j);
}

bool good(const string& word) {
	int cap = 0;
	for (int i = 0; i < word.length(); i++) {
		cap += iscap(word[i]);
    }
	//cerr << cap << " " << iscap(word[0]) << " " << word.length() << endl;
	return (cap == 1 && iscap(word[0]) && word.length() > 1);
}

string makeAbr(const vector<string> & words) {
	if (words.size() == 1) {
		return words[0];
	}
	string abr = "";
	for (int i = 0; i < words.size(); i++) {
		abr += words[i][0];
    }
	abr += " (";
	for (int i = 0; i < words.size(); i++) {
		abr += words[i];
		if (i < (int)words.size() - 1) {
			abr += " ";
		}
    }
	abr += ")";

	return abr;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	string s;
	while (getline(cin, s)) {
		s += '#';
		stringstream ln(s);
		string res = "";
		for (int i = 0; i < s.length();) {
			//cerr << i << endl;
            if (!islt(s[i]) ) {
				res += s[i];
				i++;
				continue;
            }
			if (!iscap(s[i])) {
				pair<string, int> pp = readWord(s, i);
				res += pp.first;
                i = pp.second;
				i++;
				continue;
            }
			pair<string, int> pp = readWord(s, i);
			if (!good(pp.first)) {
				res += pp.first;
				i = pp.second;
				i++;
				continue;
            }
			vector<string> words;
			while (true) {
				pair<string, int> pp = readWord(s, i);
				//cerr << pp.first << " " << pp.second << endl;
				if (!good(pp.first) ) {
					i--;
					break;
                }
				words.push_back(pp.first);
				int j = pp.second;
				j++;
				//cerr << s[j] << endl;
				if (s[j] != ' ') {
					i = j;
					break;
                }
				//cerr << "wh" << endl;
				j++;
				if (!islt(s[j])) {
					i = j - 1;
					break;
                }
				//cerr << "fffff" << j << endl;
				i = j;
				
			}
			//cerr << "fkl;f" << " " << words.size() << endl;
			res += makeAbr(words);
        }

		res.pop_back();

		cout << res << "\n";
    }
}
/*
This is ACM Nor East Europe Regi Conte,
sponsored by Intern Busine Machi.
The. Best. Contest. Ever.
A Grea Opport for all contes.
ab Ab A Abc AB Abcd ABc Abcde AbC
Oh  No  Extra Spaces.And,Punctuation Ruin Everything
*/