#include <iostream>
#include <string>
#include <vector>
#include <fstream>
#include <sstream> 

using namespace std;


ifstream in("jenga.in");
ofstream out("jenga.out");
#define cin in
#define cout out
/**/

int l[5100][11000];
int r[5100][11000];
int cnt[5100];
long long sx[5100];
long long sy[5100];
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, w;
	cin >> n >> w;
	int h, m;
	cin >> h >> m;
	for (int i = 1; i <= h; ++i)
		cnt[i] = n;
	for (int i = 1; i <= h; ++i)
		for (int j = 0; j <= n; ++j)
			r[i][j] = j + 1;
	for (int i = 1; i <= h; ++i)
		for (int j = 1; j <= n+1; ++j)
			l[i][j] = j - 1;
	for (int i = 1; i <= h; ++i)
	{
	    if (i & 1)
	    {
			sx[i] = 1ll * n * (n + 1);
			sy[i] = 1ll*(n+1)*n;
	    }
		else
		{
			sy[i] = 1ll * n * (n + 1);
			sx[i] = 1ll*(n+1)*n;
		}
    }
	for (int i = 0; i < m; ++i)
	{
		int li, ki;
		cin >> li >> ki;
		cnt[li]--;
		int last = w;
		for (int j = h; j >= 1; --j)
		{
		    if (cnt[j] != 0)
		    {
			    last = j;
			    break;
		    }
	    }
		if (cnt[li] == 0)
		{
			bool ok = false;
			for (int j = h; j > li; --j)
				if (cnt[j] != 0)
					ok = true;
			if (ok)
			{
				cout << "yes\n" << i + 1 << endl;
				return 0;
			}
		}
		int rRef = r[li][ki];
		int lRef = l[li][ki];
		r[li][lRef] = rRef;
		l[li][rRef] = lRef;
		if (li & 1)
		{
			sx[li] -= 2 * ki + 1;
			sy[li] -= n + 1;
		}
		else
		{
			sx[li] -= n + 1;
			sy[li] -= 2 * ki + 1;
		}
		
		long long sumx = sx[last];
		long long sumy = sy[last];
		int cntSum = cnt[last];
		for (int j = last-1; j >= 1; --j)
		{
			long long msXMin, msXMax, msYMin, msYMax;
			if (j & 1)
			{
				msXMin = 2*r[j][0] - 1;
				msXMax = 2*l[j][n + 1] + 1;
				msYMin = 1;
				msYMax = 2*n + 1;
			}
			else
			{
				msYMin = 2 * r[j][0] - 1;
				msYMax = 2*l[j][n + 1] + 1;
				msXMin = 1;
				msXMax = 2*n + 1;
			}
			if (sumx <= msXMin * cntSum || sumx >= msXMax * cntSum || sumy <= msYMin * cntSum || sumy >= msYMax * cntSum)
			{
				cout << "yes\n" << i+1 << endl;
				return 0;
			}
			sumx += sx[j];
			sumy += sy[j];
			cntSum += cnt[j];
		}
	}
	cout << "no\n";
}
/*
This is ACM Nor East Europe Regi Conte,
sponsored by Intern Busine Machi.
The. Best. Contest. Ever.
A Grea Opport for all contes.
ab Ab A Abc AB Abcd ABc Abcde AbC
Oh  No  Extra Spaces.And,Punctuation Ruin Everything
*/