#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

const int INF = 32768;

bool is_dig(char ch) {
    return ('0' <= ch && ch <= '9');
}

bool fnd;

int getnum(string s, int &pos) {
    fnd = false;
    int n = s.length();
    int res = 0;
    while (pos < n && s[pos] != '-' && !is_dig(s[pos]))
        pos++;
    bool ot = false;
    if (s[pos] == '-') {
        pos++;
        ot = true;
    }

    while (pos < n && is_dig(s[pos])) {
        res = res * 10 + s[pos] - '0';
        pos++;
        fnd = true;
    }
    return (ot ? -res : res);
}

pair <int, int> v[100000];
int len;
pair <int, int> cur;

int get_seg(int x) {
    for (int i = 0; i < len; i++)
        if (v[i].first <= x && x <= v[i].second)
            return i;
    return -1;
}

pair <int, int> sum(pair<int, int> s1, pair<int, int> s2) {
    return make_pair(min(s1.first, s2.first), max(s1.second, s2.second));
}

bool u[1002];

int main() {
    freopen("hard.in", "r", stdin);
    freopen("hard.out", "w", stdout);

    string s;
    int l, r, pos;
    int sl, sr;
    int it = 0;

    while (getline(cin, s)) {
        //cerr << s << "\n";
        pos = 0;
        l = getnum(s, pos);
        r = getnum(s, pos);

        if (!fnd) {
            if (s[2] == '<') {
                r = l;
                l = -INF;
            } else {
                r = INF - 1;
            }
        }

        if (l > r) {
            cout << "false\n";
            return 0;
        }

        it++;
        if (it == 1) {
            v[len++] = make_pair(l, r);
            continue;
        }


        v[len++] = make_pair(l, r);
        sort(v, v + len);

        for (int i = 0; i < len; i++) u[i] = false;
        for (int i = 1; i < len; i++) {
            if (max(v[i - 1].first, v[i].first) - 1 <= min(v[i - 1].second, v[i].second)) {
                v[i] = sum(v[i], v[i - 1]);
                u[i - 1] = true;
            }
        }

        pos = 0;
        for (int i = 0; i < len; i++) {
            if (!u[i]) v[pos++] = v[i];
        }
        len = pos;
    }

    if (len == 1 && v[0].first == -INF && v[0].second == INF - 1) {
        cout << "true\n";
        return 0;
    }

    for (int i = 0; i < len; i++) {
        if (v[i].first == -INF) {
            cout << "x <= " << v[i].second;
        } else if (v[i].second == INF - 1) {
            cout << "x >= " << v[i].first;
        } else {
            cout << "x >= " << v[i].first << " && x <= " << v[i].second;
        }
        if (i + 1 < len)
            cout << " ||\n";
    }

    return 0;
}
