#include <iostream>
#include <fstream>
#include <vector>
#include <utility>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
int const LEFT = -32768;
int const RIGHT = 32767;
#define TASK "hard"
int const INTERVAL = RIGHT - LEFT + 1;
bool b[INTERVAL];
class TaskA
{
public:
	void solve(int test_number, istream &cin, ostream &cout)
	{
		string s;
		vector<pii> v;
		while (cin >> s)
		{
			cin >> s;
			pii p = { LEFT, RIGHT };
			int num;
			cin >> num;
			if (s == ">=")
			{
				p.first = num;
			}
			else
			{
				p.second = num;
			}
			if (!(cin >> s))
			{
				v.push_back(p);
				break;
			}
			if (s == "||")
			{
				v.push_back(p);
				continue;
			}
			cin >> s;
			cin >> s;
			cin >> num;
			if (s == ">=")
			{
				p.first = num;
			}
			else
			{
				p.second = num;
			}
			if (!(cin >> s))
			{
				v.push_back(p);
				break;
			}
			v.push_back(p);
		}
		for (auto p : v)
		{
			for (int i = p.first; i <= p.second; i++)
			{
				b[i - LEFT] = true;
			}
		}
		bool flag = true;
		vector<pii> ans;
		for (int i = 0; i < INTERVAL; i++)
		{
			int l = i, r = i;
			while (i < INTERVAL && b[i])
			{
				r++;
				i++;
			}
			if (l != r)
			{
				ans.push_back({ l + LEFT, r - 1 + LEFT });
			}
		}
		if (ans.empty())
		{
			cout << "false" << endl;
		}
		else if (ans.size() == 1 && ans[0].first == LEFT && ans[0].second == RIGHT)
		{
			cout << "true" << endl;
		}
		else
		{
			for (int i = 0; i < ans.size(); i++)
			{
				auto p = ans[i];
				if (p.first == LEFT)
				{
					cout << "x <= " << p.second << " ";
				}
				else if(p.second == RIGHT)
				{
					cout << "x >= " << p.first << " ";
				}
				else
				{
					cout << "x >= " << p.first << " && ";
					cout << "x <= " << p.second << " ";
				}
				if (i < ans.size() - 1)
				{
					cout << "||";
				}
				cout << endl;
			}
		}

	}
};

int main()
{
	ios::sync_with_stdio(false);
#ifdef TASK
	ifstream cin(TASK".in");
	ofstream cout(TASK".out");
#endif
	TaskA task;
	task.solve(1, cin, cout);
	return 0;
}