#ifdef DEBUG
#include <fstream>
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#else
#include <fstream>
std::ifstream cin("hard.in");
std::ofstream cout("hard.out");
#endif
#include <algorithm>
#include <vector>
#include <map>
#include <ctype.h>
#include <set>
#include <deque>
#include <string>
#include <sstream>
#include <iomanip>
using namespace std;


struct otr{
	int l, r;
	bool operator<(const otr&o) const{
		return l == o.l ? r < o.r : l < o.l;
	}
};

int main(){
	ios_base::sync_with_stdio(0);
	
	string s;
	set<otr> o;
	while (getline(cin, s)) {
		stringstream ss(s);
		int l=-32768, r=32767;
		if (s.find("&&") != s.npos){
			char buf;
			ss >> buf>>buf>>buf>>l>>buf>>buf>>buf>>buf>>buf>>r;
		}
		else if (s.find(">=") != s.npos){
			char buf;
			ss >> buf >> buf >> buf >> l;
		}
		else{
			char buf;
			ss >> buf >> buf >> buf >> r;
		}
		if (l > r) continue;
		otr a;
		a.l = l;
		a.r = r;
		o.insert(a);
	}
	set<otr> oo;
	for (auto &a : o){
		if (oo.begin() != oo.end()){
			auto prev = *(--oo.end());
			if (a.l - prev.r<=1){
				oo.erase(--oo.end());
				otr newa = a;
				newa.l = min(prev.l, a.l);
				newa.r = max(prev.r, a.r);
				oo.insert(newa);
			}
			else{
				oo.insert(a);
			}
		}
		else{
			oo.insert(a);
		}
	}
	if (oo.size() == 1 && (*oo.begin()).l == -32768 && (*oo.begin()).r == 32767)
	{
		cout << "true";
	}
	else if (oo.size() == 0){
		cout << "false";
	}
	else{
		int i = 0;
		for (auto &a : oo){
			if (a.l == -32768)
				cout << "x <= " << a.r;
			else if (a.r == 32767)
				cout << "x >= " << a.l;
			else
				cout << "x >= " << a.l << " && x <= " << a.r;
			if (i != oo.size() - 1)
				cout << " ||";
			cout << endl;
			i++;
		}
	}
}