#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>

using namespace std;

string s[1000];
vector<pair<int, int>> dist;
vector<bool> f;

int main()
{
	//freopen("abbreviation.in", "r", stdin);
	//freopen("abbreviation.out", "w", stdout);
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	int i = 0;
	while (getline(cin, s[i]))
	{
		bool flag_great = s[i][2] == '>';
		int lo = 0, hi = 0;
		int j = 5;
		bool flag_sign = false;
		if (s[i][j] == '-')
		{
			flag_sign = true;
			j++;
		}
		while (s[i][j] >= '0' && s[i][j] <= '9')
		{
			if (flag_great)
				lo = lo * 10 + (s[i][j++] - '0');
			else
				hi = hi * 10 + (s[i][j++] - '0');
		}
		if (flag_sign)
		{
			lo *= -1;
			hi *= -1;
		}
		j++;
		if (j >= s[i].length() || s[i][j] == '|')
		{
			i++;
			if (flag_great)
				dist.push_back(make_pair(lo, 32767));
			else
				dist.push_back(make_pair(-32768, hi));
			continue;
		}

		j += 8;
		flag_sign = false;
		if (s[i][j] == '-')
		{
			flag_sign = true;
			j++;
		}
		while (s[i][j] >= '0' && s[i][j] <= '9')
			hi = hi * 10 + (s[i][j++] - '0');
		if (flag_sign)
			hi *= -1;

		if (lo <= hi)
			dist.push_back(make_pair(lo, hi));
		i++;
	}

	if (dist.size() == 0)
	{
		cout << "false";
		exit(0);
	}

	f = vector<bool>(dist.size(), false);

	for (int i = dist.size() - 1; i >= 0; i--)
	{
		for (int j = 0; j < dist.size(); j++)
		{
			if (i == j || f[j] || f[i])
				continue;
			if (min(dist[i].second, dist[j].second) < max(dist[i].first, dist[j].first) - 1)
				continue;
			dist[i] = make_pair(min(dist[i].first, dist[j].first), max(dist[i].second, dist[j].second));
			f[j] = true;
		}
	}

	for (size_t j = 0; j < dist.size(); j++)
	{
		if (dist[j].first == -32768 && dist[j].second == 32767)
		{
			cout << "true";
			exit(0);
		}
	}

	bool flg = false;
	for (size_t j = 0; j < dist.size(); j++)
	{
		if (!f[j])
		{
			if (flg)
				cout << " ||" << endl;
			if (dist[j].first == -32768)
				cout << "x <= " << dist[j].second;
			else if (dist[j].second == 32767)
				cout << "x >= " << dist[j].first;
			else
			{
				cout << "x >= " << dist[j].first << " && x <= " << dist[j].second;
			}
			flg = true;
		}
	}

	return 0;
}