#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <cmath>
#include <set>
#include <vector>
#include <map>
using namespace std;


bool arr[(1 << 16) + 1];


#define taskname "hard"
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(taskname".in", "r", stdin);
    freopen(taskname".out", "w", stdout);
#endif

    const int off = 1 << 15;
    const int INF = 1 << 15;

    string str;
    while (getline(cin, str)) {
        
        if (str == "") {
            continue;
        }
        int t1 = -INF, t2 = INF - 1;

        for (int i = 0; i < (int)str.length(); i++) {
            if (str[i] == '|') {
                break;
            }
            if (str[i] == '>') {
                t1 = 0;
                bool is_neg = false;
                if (str[i + 3] == '-') {
                    is_neg = true;
                    i++;
                }
                for (int j = i + 3; j < (int)str.length(); j++) {
                    if (!isdigit(str[j])) {
                        i = j - 1;
                        break;
                    }
                    t1 = t1 * 10 + str[j] - '0';
                }
                if (is_neg) {
                    t1 *= -1;
                }
            }
            else if (str[i] == '<') {
                t2 = 0;
                bool is_neg = false;
                if (str[i + 3] == '-') {
                    is_neg = true;
                    i++;
                }
                for (int j = i + 3; j < (int)str.length(); j++) {
                    if (!isdigit(str[j])) {
                        i = j - 1;
                        break;
                    }
                    t2 = t2 * 10 + str[j] - '0';
                }
                if (is_neg) {
                    t2 *= -1;
                }
            }
        }
        if (t2 < t1) {
            continue;
        }
        for (int i = t1; i <= t2; i++) {
            arr[i + off] = true;
        }
    }

    vector<pair<int, int> > pr;

    bool has_last = false, has_false = false;
    int l = -INF - 1;
    for (int i = -INF; i <= INF; i++) {
        if (!arr[i + off] && i != INF) {
            has_false = true;
        }
        if (!arr[i + off] && l != -INF - 1) {
            if (has_last) {
                cout << " ||" << endl;
            }
            if (l != -INF) {
                if (i != INF) {
                    cout << "x >= " << l << " && x <= " << i - 1;
                }
                else
                {
                    cout << "x >= " << l;
                }
                has_last = true;
            }
            else {
                if (i != INF) {
                    cout << "x <= " << i - 1;
                }
                has_last = true;
            }
            l = -INF - 1;
        }
        else if (arr[i + off] && l == -INF - 1) {
            l = i;
        }
    }

    if (!has_false) {
        cout << "true" << endl;
    } 
    else if (!has_last) {
        cout << "false" << endl;
    }
    else {
        cout << endl;
    }

    return 0;
}