#include <iostream>
#include <set>
#include <iomanip>
#include <map>
#include <queue>
#include <vector>

#include <assert.h>
#include <math.h>
#include <algorithm>
#include <string.h>
#include <string>

using namespace std;


const int N = 1e5 + 5;
const int K = 30;

typedef long long li;

#define mp make_pair
#define pb push_back
#define sz(x) (x).size()


#define FILE "abbreviation" 

string s;
bool islet(char i){
  if (s[i] >= 'A' && s[i] <= 'Z') return true;
  if (s[i] >= 'a' && s[i] <= 'z') return true;
  return false;
}

bool is_abbr(string tek){
  if (tek.size() < 2) return false;
  if (tek[0] < 'A' || tek[0] > 'Z') return false;
  for (int i = 1; i < tek.size(); i++){
    if (tek[i] < 'a' || tek[i] > 'z') return false;
  }
  return true;
}
int main(){
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else 
  freopen(FILE ".in", "r", stdin);
  freopen(FILE ".out", "w", stdout);
#endif
  while (getline(cin, s)){
    vector <string> w;
    string tek = "";
    int i = 0;


    while (i < s.length()){

      tek = "";

      while (i < s.length() && islet(i)){
        tek += s[i];
        i++;
      }
      if (!tek.empty())
        w.push_back(tek);

      tek = "";

      while (i < s.length() && !islet(i)){
        tek += s[i];
        i++;
      }
      if (!tek.empty())
        w.push_back(tek);
    }

    int j = 0;
    while (j < w.size()){
      int pos = -1;
      int cnt = 0;
      for (int k = j; k < w.size(); k += 2){
        if (is_abbr(w[k]) && (k == j || (w[k - 1] == " "))){
          pos = k;
          cnt++;
        }
        else{
          break;
        }
      }

      if (cnt >= 2){

        //cout << j << " " << pos << endl;
        for (int k = j; k <= pos; k += 2){
          cout << w[k][0];
        }
        cout << " (";
        for (int k = j; k <= pos; k++){
          cout << w[k];
        }
        cout << ")";
        j = pos + 1;
      }
      else{
        cout << w[j];
        j++;
      }
    }
    cout << endl;
  }
  
}