#include <iostream>
#include <set>
#include <iomanip>
#include <map>
#include <queue>
#include <vector>

#include <assert.h>
#include <math.h>
#include <algorithm>
#include <string.h>
#include <string>

using namespace std;


const int N = 1e6 + 5;
const int K = 30;

typedef long long li;

#define mp make_pair
#define pb push_back
#define sz(x) (x).size()


#define FILE "foreign" 

int n;

double ans[N];
string s;

int f(int i, int j){
  int ans = 0;
  if (s[i] == 'C'){
    for (int k = i; k <= j; k++){
      ans += (s[k] == 'W');
    }
  }
  else{
    for (int k = i; k <= j; k++){
      ans += (s[k] == 'C');
    }
  }
  return ans;
}

double ans2[N];

void brute(int i, int n, double p, int c){

  
  if (i == n){
    ans[c] += p;
    return;
  }

  ans2[i] += p;

  int len = n - i;
  double prob = 1.0 / len;
  
  for (int j = 1; j <= len; j++){
  
    brute(i + j, n, p * prob, c + f(i, i + j - 1));
  }
}

double clever(string s){

  int cntw = 0, cntc = 0;
  double ans = 0;
  int n = s.length();
 
  double sum = (1 + n)* n / 2.0;

  cout << sum << endl;

  for (int i = 0; i < s.length(); i++){
    if (s[i] == 'C') cntc++;
    else cntw++;

    int j = s.length() - i;


    if (s[i] == 'W'){
      ans += (cntc  * j + 0.0);
    }
    else{
      ans += (cntw * j + 0.0);
    }
  }

  return ans;
}

long double pres[N];
long double pre[N];
long double pp[N];

long double precalc(){

  for (int i = 0; i < N; i++){
    pres[i] = pre[i] = pp[i] = 0;
  }
  pre[0] = 1;


  long double sum = 0;

  for (int i = 0; i < n; i++){
    
    pre[i] += sum;

    int len = n - i;
    long double prob = 1.0 / len;
    long double plus = prob * pre[i];

    sum += plus;
    pp[i] = pre[i];
    pre[i] += plus;
  }
 
  long double answer = 0;

  long double sum1 = 0;
  long double sum2 = 0;
  int k = 1;


  for (int j = n - 1; j >= 0; j--){
    if (s[j] == 'W'){
      sum1 += k;
    }
    else{
      sum2 += k;
    }
    k++;
  }

  for (int i = 0; i < n; i++){

    if (s[i] == 'W'){
      sum1 -= (n - i);
    }
    else{
      sum2 -= (n - i);
    }

    if (s[i] == 'C'){
      long double p = 1.0 / (n - i);
      answer += pp[i] * sum1 * p;

      //cout << pp[i] * sum1 * p << endl;

    }
    if (s[i] == 'W'){
      long double p = 1.0 / (n - i);
      answer += pp[i] * sum2 * p;

      //cout << pp[i] * sum2 * p << endl;
    }
  }
  return answer;
}

int main(){
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else 
  freopen(FILE ".in", "r", stdin);
  freopen(FILE ".out", "w", stdout);
#endif
  
  cin >> s;
  n = s.length();
  cout.precision(12);
  cout << fixed<< precalc();

}