#include <iomanip>
#include <ios>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <cstdio>
#include <cstring>
#include <string>
#include <array>
#include <stack>
#include <queue>

#define mp make_pair
using namespace std;

string s;

bool chw(int l, int r)
{
	if (!(s[l] >= 'A' && s[l] <= 'Z'))
		return false; 
	if (r-l==1)
		return false;
	for (int i = l+1; i < r; i++)
		if (!(s[i] >= 'a' && s[i] <= 'z'))
			return false;

	return true;
}

int main() {
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	
	while (getline(cin, s))
	{
		int l = 0, r = 0, p = 0;
		string abb = "";
		while (r < s.size())
		{
			while (r < s.size() && s[r] != ' ' && s[r] != '.' && s[r] != ',')
				r++;
			if (chw(l, r))
			{
				if (abb == "") p = l;
				abb += s[l];
			}
			else
			{
				if (abb.size() >= 2)
				{
					cout << abb << " (";

					for (int i = p; i < l - 1; i++)
						cout << s[i];
					cout << ")";
					for (int i = l - 1; i < r; i++)
						cout << s[i];
				}
				else
				{
					for (int i = p; i < r; i++)
						cout << s[i];

				}
				if (r < s.size())
					cout << s[r];
				abb = "";
				p = r + 1;
			}
			if ((s[r] == '.' || s[r] == ',') && p!=r+1)
			{
				if (abb.size() >= 2)
				{
					cout << abb << " (";
				}
				for (int i = p; i < r; i++)
					cout << s[i];
				if (abb.size() >= 2)
				{
					cout << ")";
				}
				if (r < s.size())
					cout << s[r];
				abb = "";
				p = r + 1;
			}
			l = r + 1;
			r++;
		}
		if (abb.size() >= 2)
		{
			cout << abb << " (";
		}
		for (int i = p; i < r-1; i++)
			cout << s[i];
		if (abb.size() >= 2)
		{
			cout << ")";
		}
		if (r < s.size())
			cout << s[r];
		abb = "";
		cout << endl;

	}
	return 0;
}