#include <iomanip>
#include <ios>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <cstdio>
#include <cstring>
#include <string>
#include <array>
#include <stack>
#include <queue>

#define mp make_pair
#define ll long long
using namespace std;

typedef double dbl;

dbl c[1000010];
dbl sc[1000010];
dbl w[1000010];
dbl sw[1000010];
dbl s, r;
string str;

int main() {
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);

	cin >> str;
	for (int i = 0; i < str.size(); i++)
	{
		if (str[i] == 'C') {
			c[i + 1] = c[i] + 1.0;
			w[i + 1] = w[i];
		}
		else {
			c[i + 1] = c[i];
			w[i + 1] = w[i] + 1.0;
		}
		sc[i + 1] = sc[i] + c[i + 1];
		sw[i + 1] = sw[i] + w[i + 1];
	}

	s = 0; r = 0;
	for (int i = 1; i <= str.size(); i++)
	{
		r = s;
		if (str[str.size() - i] == 'C') {
			r += sc[str.size()] - sc[str.size() - i] - c[str.size() - i] * i;
		}
		else {
			r += sw[str.size()] - sw[str.size() - i] - w[str.size() - i] * i;
		}
		r /= dbl(i);
		s += r;
	}
	cout << fixed << setprecision(10) << (dbl) str.size() - r << '\n';
	return 0;
}