#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>

using namespace std;

template<class T>
void printV(vector<T> a) {
    for (auto x: a) cout << x << " "; cout << endl;
}


int main() {
    freopen("foreign.in", "rt", stdin);
    freopen("foreign.out", "wt", stdout);

    string ss;
    cin >> ss;
    reverse(ss.begin(), ss.end());
    int n = ss.size();

    vector<int> w(n);
    vector<int> c(n);
    vector<int> s(n);
    vector<double> a(n, 0);

    s[0] = 0;
    if (ss[0] == 'W') {
        w[0] = 1;
    } else {
        c[0] = 1;
    }
    double magic = 0;

    for (int i = 1; i < n; i++) {
        if (ss[i] == 'W') {
            w[i] = w[i-1] + (i+1);
        } else {
            c[i] = c[i-1] + (i+1);
        }
        w[i] = max(w[i], w[i-1]);
        c[i] = max(c[i], c[i-1]);

        if (ss[i] == 'C') {
            s[i] = w[i];
        } else {
            s[i] = c[i];
        }

        a[i] = (s[i] + magic) /(double) (i + 1);
        magic += a[i];
    }
    /*printV(c);
    printV(w);
    printV(a);*/
    cout << fixed << setprecision(10) << a[n-1] << endl;
    return 0;
}

