#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define mp make_pair
#define pb push_back
#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif
#define TASK "abbreviation"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1);


void precalc() {
}

char tmp[200];
string s;

int read() {
  if (!gets(tmp)) {
    return 0;
  }
  s = tmp;
  return 1;
}

bool alpha(int i) {
  return ('A' <= s[i] && s[i] <= 'Z') || ('a' <= s[i] && s[i] <= 'z');
}

bool good(const string &t) {
  if (!('A' <= t[0] && t[0] <= 'Z')) {
    return false;
  }
  if (sz(t) < 2) {
    return false;
  }
  for (int i = 1; i < sz(t); i++) {
    if (!('a' <= t[i] && t[i] <= 'z')) {
      return false;
    }
  }
  return true;
}

void solve() {
  int n = sz(s);
  for (int i = 0; i < n;) {
    if (alpha(i)) {
      int j = i + 1;
      while (j < n && alpha(j)) {
        j++;
      }
      string t = s.substr(i, j - i);
      if (!good(t)) {
        printf("%s", t.c_str());
        i = j;
        continue;
      }
      string abbr;
      abbr += t[0];
      while (true) {
        if (j >= n || s[j] != ' ') {
          break;
        }
        if (j + 1 >= n || !alpha(j + 1)) {
          break;
        }
        int k = j + 1;
        while (k < n && alpha(k)) {
          k++;
        }
        string w = s.substr(j + 1, k - j - 1);
        if (!good(w)) {
          break;
        }
        t += ' ';
        t += w;
        abbr += w[0];
        j = k;
      }
      if (sz(abbr) >= 2) {
        printf("%s (%s)", abbr.c_str(), t.c_str());
        i = j;
      } else {
        printf("%s", t.c_str());
        i = j;
      }
    } else {
      printf("%c", s[i]);
      i++;
    }
  }
  printf("\n");
}

int main() {
  precalc();
  
  freopen(TASK ".out", "w", stdout);
  freopen(TASK ".in", "r", stdin);
  
  while (read()) {
    solve();
    eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
  }
  
  return 0;
}