#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define mp make_pair
#define pb push_back
#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif
#define TASK "cactus"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1);


void precalc() {
}

const int maxn = (int) 5e4 + 10;
int n;

vector<vector<int> > es;

int read() {
  int cnt;
  if (scanf("%d%d", &n, &cnt) < 2) {
    return 0;
  }
  es = vector<vector<int> >(n);
  for (int i = 0; i < cnt; ++i) {
    int last = -1;
    int k;
    scanf("%d", &k);
    for (int j = 0; j < k; ++j) {
      int x;
      scanf("%d", &x);
      --x;
      if (last != -1) {
        int s = last, t = x;
        es[s].pb(t), es[t].pb(s);
      }
      last = x;
    }
  }
  return 1;
}

int used[maxn];

vector<vector<int> > ans;

pair<int, int> dfs(int v, int p = -1) {
  pair<int, int> res(-1, -1);
  used[v] = 1;
  ans.pb({1, v, 1, 2});
  for (int u : es[v]) {
    if (u == p) {
      continue;
    }
    if (used[u] == 2) {
      continue;
    }
    if (used[u] == 1) {
      res = mp(v, u);
      continue;
    }
    
    auto got = dfs(u, v);
    
    if (got.first == u) {
      ans.pb({0, v, u});
      ans.pb({2, v, 2, 3});
      res = got;
    } else {
      ans.pb({1, u, 2, 4});
      if (got.second == v) {
        ans.pb({1, u, 3, 4});
      }
      ans.pb({0, v, u});
      ans.pb({2, v, 2, 4});
      ans.pb({1, v, 4, 1});
      if (got.first != -1 && got.second != v) {
        res = got;
      }
    }
  }
  used[v] = 2;
  if (res.first == v) {
    ans.pb({1, v, 2, 3});
  }
  return res;
}

void solve() {
  for (int i = 0; i < n; ++i) {
    used[i] = 0;
  }
  ans.clear();
  dfs(0);
  const static char chs[] = "jrc";
  printf("%d\n", sz(ans));
  for (int i = 0; i < sz(ans); ++i) {
    if (ans[i][0] == 0) {
      printf("%c %d %d\n", chs[ans[i][0]], ans[i][1] + 1, ans[i][2] + 1);
    } else {
      printf("%c %d %d %d\n", chs[ans[i][0]], ans[i][1] + 1, ans[i][2], ans[i][3]);
    }
  }
}

int main() {
  precalc();
  
  freopen(TASK ".out", "w", stdout);
  freopen(TASK ".in", "r", stdin);
  
  while (read()) {
    solve();
    eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
  }
  
  return 0;
}