#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define mp make_pair
#define pb push_back
#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif
#define TASK "expect"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1);


void precalc() {
}

const int maxn = (int) 1e5 + 5;
int n, q;
int t[maxn], add[maxn];
int b[maxn];

int read() {
  if (scanf("%d%d", &n, &q) < 2) {
    return 0;
  }
  t[0] = 0;
  add[0] = 0;
  for (int i = 1; i <= n; i++) {
    char tc;
    scanf(" %c%d%d", &tc, &t[i], &add[i]);
    if (tc == '-') {
      add[i] *= -1;
    }
  }
  n++;
  for (int i = 0; i < q; i++) {
    scanf("%d", &b[i]);
  }
  return 1;
}

pair<int, pair<int, int> > ev[2 * maxn];
long long res[maxn];

void solve() {
  int evs = 0;
  int bal = 0;
  for (int i = 0; i < n; i++) {
    int len = (i + 1 < n ? t[i + 1] - t[i] : inf);
    bal += add[i];
    ev[evs++] = make_pair(bal, make_pair(len, -1));
  }
  for (int i = 0; i < q; i++) {
    ev[evs++] = make_pair(-b[i], make_pair(-1, i));
  }
  sort(ev, ev + evs);
  long long s = 0;
  for (int i = 0; i < q; i++) {
    res[i] = -1;
  }
  int cur = 0;
  for (int i = 0; i < evs; i++) {
    if (i) {
      s += (long long) (ev[i].first - ev[i - 1].first) * cur;
    }
    if (ev[i].second.second == -1) {
      int len = ev[i].second.first;
      if (len == inf) {
        break;
      }
      cur += len;
    } else {
      res[ev[i].second.second] = s;
    }
  }
  for (int i = 0; i < q; i++) {
    if (res[i] == -1) {
      printf("INFINITY\n");
    } else {
      printf("%lld\n", res[i]);
    }
  }
}

int main() {
  precalc();
  
  freopen(TASK ".out", "w", stdout);
  freopen(TASK ".in", "r", stdin);
  
  while (read()) {
    solve();
    eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
  }
  
  return 0;
}