#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define mp make_pair
#define pb push_back
#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif
#define TASK "foreign"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1);


void precalc() {
}

const int maxn = 1e6 + 100;
int n;
char s[maxn];

int read() {
  if (scanf("%s", s) < 1) {
    return 0;
  }
  n = strlen(s);
  return 1;
}

ld sum[2];

void solve() {
  sum[0] = sum[1] = 0;
  ld toadd = 0;
  ld curans;
  for (int i = n - 1; i >= 0; i--) {
    int cur = (s[i] == 'C');
    sum[cur] += n - i;
    curans = (sum[!cur] + toadd) / (n - i);
    toadd += curans;
  }
  printf("%.18f\n", (double) curans);
}

int main() {
  precalc();
  
  freopen(TASK ".out", "w", stdout);
  freopen(TASK ".in", "r", stdin);
  
  while (read()) {
    solve();
    eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
  }
  
  return 0;
}