#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define mp make_pair
#define pb push_back
#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif
#define TASK "jenga"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1);


void precalc() {
}

int n, w, h, m;

const int maxm = (int) 5e3 + 10;

vector<int> have[maxm];

pair<int, int> ps[maxm];

int read() {
  if (scanf("%d%d%d%d", &n, &w, &h, &m) < 4) {
    return 0;
  }
  for (int i = 0; i < h; ++i) {
    have[i].clear();
  }
  for (int i = 0; i < m; ++i) {
    int l, k;
    scanf("%d%d", &l, &k);
    --l, --k;
    ps[i] = mp(l, k);
  }
  return 1;
}

const int maxn = (int) 1e4 + 10;
bool now[maxn];

void solve() {
  for (int mid = 1; mid <= m; ++mid) {
    bool fail = 0;
    
    have[ps[mid - 1].first].pb(ps[mid - 1].second);
    
    int cnt = 0;
    long long sumx = 0, sumy = 0;
    for (int i = h - 1; !fail && i >= 0; --i, swap(sumx, sumy)) {
      sort(have[i].begin(), have[i].end());
      if (cnt) {
        int l = -1, r = -1;
        for (int j = 0; j < sz(have[i]); ++j) {
          int x = have[i][j];
          if (x > j) {
            l = j;
            break;
          }
        }
        if (l == -1 && sz(have[i]) < n) {
          l = sz(have[i]);
        }
        if (l == -1) {
          fail = 1;
          break;
        }
        for (int j = 0; j < sz(have[i]); ++j) {
          int x = have[i][sz(have[i]) - 1 - j];
          if (x < n - 1 - j) {
            r = n - 1 - j;
            break;
          }
        }
        if (r == -1 && sz(have[i]) < n) {
          r = n - 1 - sz(have[i]);
        }
        int xl = w * l * 2;
        int xr = w * (r + 1) * 2;
        if ((long long) xl * cnt >= sumx || sumx >= (long long) xr * cnt) {
          fail = 1;
          break;
        }
      }
      
      sumx += (long long) w * n * n;
      sumy += (long long) w * n * n;
      cnt += n;
      for (int j : have[i]) {
        int x = w * (j * 2 + 1);
        int y = w * n;
        sumx -= x, sumy -= y, --cnt;
      }
    }
    
    if (fail) {
      printf("yes\n%d\n", mid);
      return;
    }
  }
  
  printf("no\n");
}

int main() {
  precalc();
  
  freopen(TASK ".out", "w", stdout);
  freopen(TASK ".in", "r", stdin);
  
  while (read()) {
    solve();
    eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
  }
  
  return 0;
}