#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define mp make_pair
#define pb push_back
#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif
#define TASK "mole"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1);


void precalc() {
}

const int maxn = (int) 1e5 + 5;
int n, m;
int c[maxn], p[maxn];

int read() {
  if (scanf("%d%d", &n, &m) < 2) {
    return 0;
  }
  for (int i = 1; i <= n; i++) {
    scanf("%d", &c[i]);
  }
  for (int i = 0; i < m; i++) {
    scanf("%d", &p[i]);
  }
  return 1;
}

int d[maxn], pd[maxn];
int lc[maxn], rc[maxn], pc[maxn];

void solve() {
  for (int i = 1; i <= n; i++) {
    lc[i] = 0;
    rc[i] = 0;
    pc[i] = 0;
  }
  for (int i = n; i > 0; i--) {
    if (c[i]) {
      d[i] = 0;
      pd[i] = i;
      continue;
    }
    d[i] = inf;
    pd[i] = -1;
    if (2 * i <= n) {
      if (1 + d[2 * i] < d[i]) {
        d[i] = 1 + d[2 * i];
        pd[i] = pd[2 * i];
      }
    }
    if (2 * i + 1 <= n) {
      if (1 + d[2 * i + 1] < d[i]) {
        d[i] = 1 + d[2 * i + 1];
        pd[i] = pd[2 * i + 1];
      }
    }
  }
  int res = 0;
  for (int it = 0; it < m; it++) {
    /*eprintf("%d\n", c[1]);
    for (int i = 1; i <= n; i++) {
      eprintf("%d %d\n", d[i], pd[i]);
    }
    eprintf("\n");*/
    int v = p[it];
    int bestanc = v, dist = inf;
    int up = 0;
    for (int anc = v; anc > 0; anc /= 2) {
      if (up + d[anc] < dist) {
        dist = up + d[anc];
        bestanc = anc;
      }
      if (!pc[anc]) {
        up++;
      } else {
        up--;
      }
    }
    res += dist;
    for (int u = v; u != bestanc; u /= 2) {
      if (pc[u]) {
        pc[u]--;
      } else {
        if (u & 1) {
          rc[u / 2]++;
        } else {
          lc[u / 2]++;
        }
      }
    }
    int w = pd[bestanc];
    assert(w != -1);
    //eprintf("v = %d, w = %d\n", v, w);
    for (int u = w; u != bestanc; u /= 2) {
      if (u & 1) {
        if (rc[u / 2]) {
          rc[u / 2]--;
        } else {
          pc[u]++;
        }
      } else {
        if (lc[u / 2]) {
          lc[u / 2]--;
        } else {
          pc[u]++;
        }
      }
    }
    assert(c[w]);
    c[w]--;
    for (int iter = 0; iter < 2; iter++) {
      for (int u = (iter ? w : v); u > 0; u /= 2) {
        //eprintf("u = %d, %d %d\n", u, d[u], c[u]);
        if (c[u]) {
          d[u] = 0;
          pd[u] = u;
        } else {
          d[u] = inf;
          pd[u] = -1;
        }
        if (2 * u <= n && d[u] > d[2 * u] + (lc[u] ? -1 : 1)) {
          d[u] = d[2 * u] + (lc[u] ? -1 : 1);
          pd[u] = pd[2 * u];
        }
        if (2 * u + 1 <= n && d[u] > d[2 * u + 1] + (rc[u] ? -1 : 1)) {
          d[u] = d[2 * u + 1] + (rc[u] ? -1 : 1);
          pd[u] = pd[2 * u + 1];
        }
      }
    }
    printf("%d ", res);
  }
  printf("\n");
}

int main() {
  precalc();
  
  freopen(TASK ".out", "w", stdout);
  freopen(TASK ".in", "r", stdin);
  
  while (read()) {
    solve();
    eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
  }
  
  return 0;
}