#include <bits/stdc++.h>

#define FILENAME "expect"

using namespace std;

const int MX = 100000;

long long ans[MX];

int main()
{
	#ifndef LOCAL
	freopen( FILENAME ".in", "r", stdin );
	freopen( FILENAME ".out", "w", stdout );
	#endif // LOCAL

    int n, m, bal = 0;
    scanf("%d %d", &n, &m);

    vector<pair<int, int>> p, q;
    p.emplace_back(0, 0);
    for (int i = 0; i < n; i++) {
        char c;
        int t, k;
        scanf(" %c %d %d", &c, &t, &k);

        if (c == '+') {
			p.emplace_back(t, k);
			bal += k;
        }
        else {
			q.emplace_back(t, k);
			bal -= k;
        }
    }

    while (bal > 0) {
        if (p.back().second > bal) {
			p.back().second -= bal;
			bal = 0;
        }
        else {
			bal -= p.back().second;
			p.pop_back();
        }
    }

    p[0].second = -bal;

    vector<tuple<int, int, long long>> vec;
    int s = 1;
    for (int i = 0, j = 0, k = 0; i < q.size(); i++) {
        while (j < p.size() && p[j].first <= q[i].first) {
			k += p[j].second;
			j++;
        }

        vec.emplace_back(s - k, q[i].first, -q[i].first * 1ll * (s - k - 1));
		s += q[i].second;
        vec.emplace_back(s - k, -q[i].first, q[i].first * 1ll * (s - k - 1));
    }

    for (int i = p.size() - 1, j = q.size() - 1, k = s - 1; i >= 0; i--) {
        while (j >= 0 && q[j].first >= p[i].first) {
			s -= q[j].second;
			j--;
        }

        vec.emplace_back(s - k, -p[i].first, p[i].first * 1ll * (s - k - 1));
        k -= p[i].second;
        vec.emplace_back(s - k, p[i].first, -p[i].first * 1ll * (s - k - 1));
    }

    long long A = 0, B = 0;
    for (auto& x : p) B += x.first * 1ll * x.second;
    for (auto& y : q) B -= y.first * 1ll * y.second;

    vector<pair<int, int>> qq;
	for (int i = 0; i < m; i++) {
		int b;
		scanf("%d", &b);

		qq.emplace_back(b + bal, i);
	}

    sort(qq.begin(), qq.end());
    sort(vec.begin(), vec.end());

    int i = 0;
	for (auto& q : qq) {
		int b = q.first;
        while (i < vec.size() && get<0>(vec[i]) <= b) {
            A += get<1>(vec[i]);
            B += get<2>(vec[i]);
            i++;
        }

        ans[q.second] = b < 0 ? -1 : A * b + B;
	}

	for (int i = 0; i < m; i++)
		if (ans[i] == -1) printf("INFINITY\n");
		else printf("%lld\n", ans[i]);

	return 0;
}
