#include <bits/stdc++.h>

#define FILENAME "game"

using namespace std;

const int MX = 100000;

int deg[2][MX];
bool haveLose[2][MX], haveWin[2][MX];
char ans[2][MX + 1];
vector<int> G[MX];

int main()
{
	#ifndef LOCAL
	freopen( FILENAME ".in", "r", stdin );
	freopen( FILENAME ".out", "w", stdout );
	#endif // LOCAL

	int n, m;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < m; i++) {
		int u, v;
		scanf("%d %d", &u, &v);
		u--; v--;
        deg[0][u]++;
        deg[1][u]++;
        G[v].push_back(u);
	}

    vector<pair<int, int>> q1;
    vector<int> q2;

    for (int i = 0; i < n; i++) {
		ans[0][i] = ans[1][i] = 'D';

        if (deg[0][i] == 0) {
			ans[0][i] = ans[1][i] = 'L';

			q1.emplace_back(0, i);
			q1.emplace_back(1, i);
        }
    }

    while (q1.size() + q2.size() > 0u) {
		if (q1.size() == 0u) {
            int v = q2.back();
            q2.pop_back();

            if (ans[1][v] != 'D') continue;

            ans[1][v] = 'L';

            for (int u : G[v]) {
                deg[0][u]--;
				haveLose[0][u] = true;
				if (deg[0][u] == 0) {
					q1.emplace_back(0, u);
					ans[0][u] = 'W';
				}
            }
		}
		else {
			int p, v;
			tie(p, v) = q1.back();
			q1.pop_back();

			int q = 1 ^ p;
			for (int u : G[v]) {
				deg[q][u]--;

				if (q == 1 && haveLose[q][u] == false && ans[p][v] == 'L') {
                    ans[1][u] = 'W';
                    q1.emplace_back(1, u);
				}
				if (q == 1 && haveWin [q][u] == false && ans[p][v] == 'W') q2.emplace_back(u);

				haveLose[q][u] = haveLose[q][u] || ans[p][v] == 'L';
				haveWin [q][u] = haveWin [q][u] || ans[p][v] == 'W';

				if (deg[q][u] == 0 && q == 0) {
					q1.emplace_back(q, u);
                    if (haveLose[q][u]) {
						ans[q][u] = 'W';
                    }
                    else {
						ans[q][u] = 'L';
                    }
				}
			}
		}
    }

    printf("%s\n%s\n", ans[0], ans[1]);

	return 0;
}
