#include "bits/stdc++.h"

using namespace std;

using LL = long long;

const LL INF64 = 1e18;

#define time tim234
#define X first
#define Y second

int main() {
#if ZEBER
	freopen("input.txt", "r", stdin);
#else
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	
	LL curLevel = 0;
	map<LL, LL> len;

	int n, q;
	LL prevTime = -1;
	cin >> n >> q;

	LL minInf = 0;

	len[curLevel] = INF64;
	for (int i = 0; i < n; ++i) {
		char type;
		int time;
		int ppls;

		cin >> type >> time >> ppls;

		if (i != 0) {
			len[curLevel] += (time - prevTime);
		}

		prevTime = time;
		curLevel += (type == '+' ? +1 : -1) * ppls;
	}
	len[curLevel] = INF64;

	minInf = min(curLevel, minInf);

	map<LL, LL> sum;
	LL curSum = 0;

	for (auto it = len.begin(); it != len.end(); ++it) {
		curSum += it->Y;
		sum[it->X] = curSum;
	}

	map<LL, LL> ans;
	LL curAns = 0;

	for (auto it = len.begin(); it != len.end(); ++it) {
		if (it != len.begin()) {
			auto prv = it;
			--prv;
			LL dist = it->X - prv->X;
			curAns += dist * sum.at(prv->X);
		}

		ans[it->X] = curAns;
	}

	for (int qq = 0; qq < q; ++qq) {
		LL cur;
		cin >> cur;
		cur = -cur;

		if (cur > minInf) {
			cout << "INFINITY" << endl;
			continue;
		}

		auto it = ans.lower_bound(cur);
		if (it == ans.begin()) {
			cout << 0 << endl;
			continue;
		}

		if (it->X != cur) --it;
		LL dcnt = abs(it->X - cur);
		LL dans = dcnt * sum.at(it->X);
		cout << it->Y + dans << endl;
	}

	// cout << "Hello!" << endl;
}