#include "bits/stdc++.h"

using namespace std;

using LL = long long;
using LD = long double;

const int N = 1e6 + 100;
LL t[2][N];
LL ps[2][N];
string s;

char buf[N];

void prep() {
	const int n = s.size();
	for (int i = 0; i < n; ++i) {
		if (s[i] == 'C') t[0][i] = (i + 1);
		else t[1][i] = (i + 1);
	}

	partial_sum(t[0], t[0] + n, ps[0]);
	partial_sum(t[1], t[1] + n, ps[1]);
}

LD dp[N];

int main() {
#if ZEBER
	freopen("input.txt", "r", stdin);
#else
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
#endif
	// ios_base::sync_with_stdio(false);

	// cin >> s;
	scanf("%s", buf);
	s = buf;
	const int n = s.size();

	reverse(s.begin(), s.end());
	prep();

	dp[0] = 0;
	LD sum = 0;

	int cur;
	for (int x = 1; x < n; ++x) {
		cur = (s[x] == 'C') ? 0 : 1;
		int other = cur ^ 1;

		dp[x] = sum / (x + 1);
		dp[x] += LD(ps[other][x]) / (x + 1);

		sum += dp[x];
	}

	cout << fixed << setprecision(20) << dp[n - 1] << endl;
}