#include "bits/stdc++.h"

using namespace std;

using pii = pair < int, int > ;
#define X first
#define Y second

const int Min = -32768;
const int Max = +32767;

const int Cnt = Max - Min + 1;
const int Inf = 1e9;

bool canUse[Cnt];
bool* ptr;

void proc(int l, int r) {
	for (int x = l; x <= r; ++x)
		ptr[x] = true;
}

bool checkTrue() {
	for (int x = Min; x <= Max; ++x)
		if (!ptr[x])
			return false;
	return true;
}

bool checkFalse() {
	for (int x = Min; x <= Max; ++x)
		if (ptr[x])
			return false;
	return true;
}

bool readAndProc() {
	string s;
	cin >> s;
	cin >> s;

	int l = Min;
	int r = Max;

	if (s == ">=") cin >> l;
	if (s == "<=") cin >> r;

	if (cin >> s) {
		if (s == "||") {
			proc(l, r);
			return true;
		}

		cin >> s;
		cin >> s;

		if (s == ">=") cin >> l;
		if (s == "<=") cin >> r;

		proc(l, r);
		if (cin >> s) {
			return true;
		}
		else {
			return false;
		}
	} else {
		proc(l, r);
		return false;
	}
}

void output() {
	if (checkTrue()) {
		cout << "true" << endl;
		return;
	}

	if (checkFalse()) {
		cout << "false" << endl;
		return;
	}

	bool fst = true;
	int l = -Inf;
	int r = -Inf;

	for (int x = Min; x <= Max; ++x) {
		if (ptr[x]) {
			if (l == -Inf)
				l = x;
			r = x;
		} else {
			if (l != -Inf) {
				if (!fst) cout << " ||" << endl;

				if (l != Min) {
					cout << "x >= " << l;
					if (r != Max)
                        cout << " && ";
				}

				if (r != Max)
					cout << "x <= " << r;

				l = -Inf;
				r = -Inf;
				fst = false;
			}
		}
	}

	if (l != -Inf) {
		if (!fst) cout << " ||" << endl;

		if (l != Min) {
			cout << "x >= " << l;
			if (r != Max)
				cout << " && ";
		}

		if (r != Max)
			cout << "x <= " << r;

		l = -Inf;
		r = -Inf;
		fst = false;
	}

	cout << endl;
}

int main() {
#if ZEBER
	freopen("input.txt", "r", stdin);
#else
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
#endif
	
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ptr = canUse - Min;

	while (readAndProc());
	output();
}