#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <queue>
#include <iomanip>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;

typedef long long LL;
typedef pair<int, int> pair_ii;
typedef pair<long long, long long> pair_LL;
typedef pair<string, string> pair_s;

#define fori(i,s,n) for (int i = s; i < n; ++i)
#define forir(i,f) for (int i = f - 1; i >= 0; --i)
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz size()

void set_precise(int n) {
	cout << fixed;
	cout << setprecision(n);
}

double forw[1000003];
double   dp[1000003];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
#endif
	string s;
	cin >> s;
	int n = s.length();
	fori(i, 0, n) {
		forw[i] = (double)(n - i);
	}
	double cur_w = 0.0;
	double cur_c = 0.0;
	for (int i = n - 1; i >= 0; --i) {
		double cur = forw[i];
		if (s[i] == 'C') {
			forw[i] = cur_w;
			cur_c += cur;
		}
		if (s[i] == 'W') {
			forw[i] = cur_c;
			cur_w += cur;
		}
	}
	dp[0] = 0.0;
	double cur_sum = 0.0;
	for (int i = 1; i <= n; ++i) {
		int id = n - i;
		double div = (double)i;
		dp[i] = (1.0 / div) * (forw[id] + cur_sum);
		cur_sum += dp[i];
	}
	set_precise(10);
	cout << dp[n];
	return 0;
}