#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <iomanip>
#include <climits>
#include <fstream>
#include <queue>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second

typedef long long ll;
typedef long double ld;
typedef pair < int ,int > pii;
typedef pair < ll, ll > pll;

const int MAXN = 1000400;
const ll INF = (ll) 2e18;

int main() {
//    ifstream cin("input.txt");
    ifstream cin("jenga.in");
    ofstream cout("jenga.out");

    int n, w;
    cin >> n >> w;

    int h, m;
    cin >> h >> m;

    priority_queue < pii > all;

    for (int step = 1; step <= m; step ++) {
        int hh, k;
        cin >> hh >> k;
        all.push(mp(hh, k));
        priority_queue < pii > q = all;
        ll fl = 0, sl = 0;
        ll fr = 0, sr = 0;
        bool ok = true;
        for (int i = h; i >= 0; i --) {
            vector < int > vec;
            while ( !q.empty() && q.top().F == i) {
                vec.pb(q.top().S);
                q.pop();
            }
            int l = 1;
            int r = n;
            for (int v : vec)
                if (r == v) r --;
                else break;
            for (int k = vec.size() - 1; k >= 0; k --)
                if (l == vec[k]) l ++;
                else break;
            if (i & 1)  {
                ok &= (1ll * sl * l <= fl && 1ll * sl * r >= fl);
              //  cout << "F " << fl << " S " << sl << "\n";
            }
            else {
                ok &= (1ll * sr * l <= fr && 1ll * sr * r >= fr);
                //cout << "F " << fr << " S " << sr << "\n";
            }
            sl += n; fl += 1ll * n * (n + 1) / 2;
            sr += n; fr += 1ll * n * (n + 1) / 2;
            for (int v : vec)
                if (i & 1) fl -= v, sl --;
                else fr -= v, sr --;
        }
        if (!ok) {
            cout << "yes\n" << step;
            return 0;

        }

    }
    cout << "no";
    return 0;
}
