#define FNAME "abbreviation"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int,int> pii;

#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define all(V) V.begin(), V.end()
#define sz(V) (int)(V.size())
#define forn(i, N) for(int i = 0; i < int(N); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define fornr(i, N) for(int i = int(N) - 1; i >= 0; --i)
#define forit(i, V) for(__typeof(V.begin()) i = V.begin(); i != V.end(); ++i)

const int MAX_L = 1e3 + 100;
char S[MAX_L];
vector<string> ans;

char buf[MAX_L], buf2[MAX_L];
int len = 0, cnt = 0;

void clear(){
	len = 0;
}
inline void add(char c){
	buf[len++] = c;
}

void write(){
	forn(i, len)
		putchar(buf[i]);
	len = 0;
}
void flush(){
	if(cnt==1){
		for(char c: ans[0])
			putchar(c);
	}else if(cnt>1){
		string abb;
		for(auto &s: ans)
			abb+=s[0];
		printf("%s (",abb.c_str());
		forit(s, ans){
			printf("%s",s->c_str());
			if(s+1!=ans.end())
				putchar(' ');
		}
		putchar(')');
	}
	ans.clear();
	cnt = 0;
}
void newWord(){
	buf[len] = 0;
	ans.pb(buf);
	++cnt;
}

int main(){
	assert(freopen(FNAME".in", "r", stdin));
	assert(freopen(FNAME".out", "w", stdout));
	
	while(gets(S)){
		int L = strlen(S);
//		printf("L=%d\n",L);
		if(!L)
			break;
		int cur = 0;
		bool saved = 0;
		while(S[cur]){
			if(!isalpha(S[cur])){
				int len2 = 0;
				while(S[cur] && !isalpha(S[cur]))
					buf2[len2++] = S[cur++];
				if(!(len2==1 && buf2[0] == ' ')){
					flush();
					forn(i, len2)
						putchar(buf2[i]);
					saved = 0;
				}else
					saved = 1;
			} if(S[cur]>='A' && S[cur]<='Z'){
				clear();
				add(S[cur]), ++cur;
				bool ok = 0;
				while(S[cur]>='a' && S[cur]<='z')
					add(S[cur]), ++cur, ok = 1;
				if(!ok || (S[cur]>='A' && S[cur]<='Z')){
					flush();
					if(saved){
						putchar(' ');
						saved=0;
					}
					write();
					while(isalpha(S[cur]))
						putchar(S[cur]), ++cur;
				}else{
					newWord();
					if(saved && cnt == 1){
						putchar(' ');
						saved = 0;
					}
				}
			}else{
				flush();
				if(saved){
					putchar(' ');
					saved=0;
				}
				while(isalpha(S[cur]))
					putchar(S[cur]), ++cur;
			}
		}
		flush();
		puts("");
	}
	
	return 0;
}