#define FNAME "hard"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int,int> pii;

#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define all(V) V.begin(), V.end()
#define sz(V) (int)(V.size())
#define forn(i, N) for(int i = 0; i < int(N); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define fornr(i, N) for(int i = int(N) - 1; i >= 0; --i)
#define forit(i, V) for(__typeof(V.begin()) i = V.begin(); i != V.end(); ++i)

const int MAX_N = 1e4 + 5, MAX_L = 1e6;
const int MIN = -32768, MAX = 32767;

char s[MAX_N];
int a[MAX_L];

string toStr(int k) {
	string ans;
	if (k == 0)
		return "0";
	bool was = 0;
	if (k < 0)
		was = 1, k *= -1;
	while (k > 0)
		ans.pb('0' + (k % 10)), k /= 10;
	reverse(all(ans));
	if (was)
		return "-" + ans;
	return ans;
}

string print(int l, int r) {
	if (l == MIN) {
		return "x <= " + toStr(r);
	}
	if (r == MAX) {
		return "x >= " + toStr(l);
	}
	return "x >= " + toStr(l) + " && x <= " + toStr(r);
}

int main(){
	assert(freopen(FNAME".in", "r", stdin));
	assert(freopen(FNAME".out", "w", stdout));
	
	while (gets(s)) {
		int minn = MIN, maxx = MAX;
		//puts(s);
		int pntr = 0;
		while (1) {
			char ch1, ch2, ch3 = '|', ch4;
			int k, cc;
			sscanf(s + pntr, " %c %c= %d %c%c%n", &ch1, &ch2, &k, &ch3, &ch4, &cc); 
			pntr += cc;
			//printf("%c %c %c %c %d\n", ch1, ch2, ch3, ch4, k);
			if (ch2 == '>')
				minn = k;
			else
				maxx = k;
			if (ch3 == '|')
				break;
		}
		forab (i, minn, maxx + 1)
			a[i + abs(MIN)] = 1;
	}
	int cnt = 0;
	forab (i, MIN, MAX + 1)
		cnt += a[i + abs(MIN)];
	if (cnt == 0) {
		puts("false");
		return 0;
	}
	if (cnt == MAX - MIN + 1) {
		puts("true");
		return 0;
	}
	vector<string> ans;
	forab (i, MIN, MAX + 1) {
		if (a[i + abs(MIN)] == 1) {
			int j = i;
			while (j <= MAX && a[j + abs(MIN)])
				j++;
			ans.pb(print(i, j - 1));
			i = j - 1;
		}
	}
	forn (i, sz(ans)) {
		printf("%s", ans[i].c_str());
		if (i != sz(ans) - 1)
			printf(" ||\n");
		else
			printf("\n");
	}
	return 0;
}