#define FNAME "jenga"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int,int> pii;

#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define all(V) V.begin(), V.end()
#define sz(V) (int)(V.size())
#define forn(i, N) for(int i = 0; i < int(N); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define forba(i, a, b) for(int i = int(b) - 1; i >= a; --i)
#define fornr(i, N) for(int i = int(N) - 1; i >= 0; --i)
#define forit(i, V) for(__typeof(V.begin()) i = V.begin(); i != V.end(); ++i)

const int N = 1e4 + 100;

ll sum[2][N], cnt[N], minC[2][N], maxC[2][N];
set <int> del[N];

void ex(int i) {
	puts("yes");
	printf("%d\n", i + 1);
	exit(0);
}

bool check(int i, int h, int n) {
	if (i == h)
		return true;
	int c = i & 1;
	double coord = sum[c][i + 1] * 1. / (cnt[i + 1] * 1. * n);
	return (minC[c][i] * 2 - 2 < coord && coord < maxC[c][i] * 2);
}

int main(){
	assert(freopen(FNAME".in", "r", stdin));
	assert(freopen(FNAME".out", "w", stdout));
	int n, w, h, m;
	scanf("%d%d%d%d", &n, &w, &h, &m);
	ll fullSum = 0;
	forn(i, n) {
		fullSum += (2 * i + 1) * 1ll * n;
	}
	forba(i, 1, h + 1) {
		cnt[i] = cnt[i + 1] + n;
		forn(j, 2) {
			sum[j][i] = sum[j][i + 1] + fullSum;
			minC[j][i] = 1;
			maxC[j][i] = n;
		}
	}
	forn(i, m) {
		int l, pos;
		scanf("%d%d", &l, &pos);
		del[l].insert(pos);
		int c = l & 1;
		if (sz(del[l]) == n) {
			ex(i);
		}
		if (minC[c][l] == pos) {
			auto it = del[l].find(pos);
			int now = pos;
			while(it != del[l].end() && *it == now) {
				it++;
				now++;
			}
			--it;
			minC[c][l] = *it + 1;
		}
		if (maxC[c][l] == pos) {		
			auto it = del[l].find(pos);
			int now = pos;
			while(it != del[l].begin() && *it == now) {
				it--;
				now--;
			}
			++it;
			maxC[c][l] = *it - 1;
		}
//		cerr << minC[c][l] << " " << maxC[c][l] << '\n';
		ll coord[2];
		coord[c] = pos * 2 - 1;
		coord[c ^ 1] = n;
		forba(j, 1, l + 1) {
			cnt[j]--;
			sum[0][j] -= coord[0] * n;
			sum[1][j] -= coord[1] * n;
//			cerr << j << '\n';
			if (!check(j, h, n))
				ex(i);
		}
	}
	puts("no");
	
	
	return 0;
}