#define FNAME "mole"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int,int> pii;

#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define all(V) V.begin(), V.end()
#define sz(V) (int)(V.size())
#define forn(i, N) for(int i = 0; i < int(N); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define fornr(i, N) for(int i = int(N) - 1; i >= 0; --i)
#define forit(i, V) for(__typeof(V.begin()) i = V.begin(); i != V.end(); ++i)

const int N = 4e5 + 100;
const int INF = 1e9 + 7;

pii closest[N];
int up[N], got[N], n, goes[N];

int get_up(int v) {
	if (goes[v] <= 0)
		return 1;
	return -1;
}

int get_down(int v) {
	if (goes[v] >= 0)
		return 1;
	return -1;
}

void recalc(int v) {
	closest[v] = mp(INF, -1);
	if (got[v])
		closest[v] = mp(0, v);
	forn(i, 2) {
		if (closest[2 * v + i].fst + get_down(2 * v + i) < closest[v].fst)
			closest[v] = mp(closest[2 * v + i].fst + get_down(2 * v + i), closest[2 * v + i].snd);
	}
}

void calc(int v) {
	closest[v] = mp(INF, -1);
	if (v > n)
		return;
	calc(2 * v);
	calc(2 * v + 1);
	recalc(v);
}

int main(){
	assert(freopen(FNAME".in", "r", stdin));
	assert(freopen(FNAME".out", "w", stdout));
	int m;
	scanf("%d%d", &n, &m);
	forn (i, n) {
		scanf("%d", &got[i + 1]);
	}
	calc(1);
	int ans = 0;
	forn(i, m) {
		int v; scanf("%d", &v);
		int u = v;
		pii best = mp(INF, -1);
		int from = -1, now = 0;
		while(u) {
			if (got[u]) {
				if (best.fst > now) {
					best = mp(now, u);
				}
			}
			forn(j, 2) {
				if (from != j) {
					if (best.fst > now + get_down(2 * u + j) + closest[2 * u + j].fst) {
						best = mp(now + get_down(2 * u + j) + closest[2 * u + j].fst, closest[2 * u + j].snd);
					}
				} 
			}
			from = u & 1;
			now += get_up(u);
			u /= 2;
		}
		assert(best.snd != -1);
		ans += best.fst;
		u = best.snd;
		got[u]--;
		while(u) {
			goes[u]++;
			recalc(u);
			u /= 2;
		}
		while(v) {
			goes[v]--;
			recalc(v);
			v /= 2;
		}
		printf("%d ", ans);
	}
	puts("");
	
	return 0;
}