#define _USE_MATH_DEFINES
#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <iomanip>
#include <stack>
#include <deque>
#include <queue>
#include <list>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <limits.h>
#include <math.h>
#include <algorithm>
using namespace std;

void prepare(string s = "")
{
#ifdef _DEBUG
	freopen("input.txt","r",stdin);
	//freopen("output.txt", "w", stdout);
#else
	if (!s.empty())
	{
		freopen((s + ".in").c_str(), "r", stdin);
		freopen((s + ".out").c_str(), "w", stdout);
	}
#endif
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
}

#define mp make_pair
#define forn(i, n) for (int i = 0; i < n; ++i)
#define forab(i, a, b) for (int i = a; i <= b; ++i)
#define fornd(i, n) for (int i = n - 1; i >= 0; --i)
#define forabd(i, a, b) for (int i = b; i >= a; --i)
#define _(a, val) memset(a, val, sizeof(a));
#define sz(a) (int) a.size()
#ifdef _DEBUG
#define dbg(x) cout<<#x<<" = "<<x<<endl;
#else
template <class T> inline void dbg(T x) {}
#endif
typedef long long ll;
typedef unsigned long long ull;
#define all(a) a.begin(),a.end()

void read()
{
}

bool isTrueWord(string &s)
{
	if (s.size() < 2)
		return false;
	if (islower(s[0]))
		return false;
	for (int i = 1; i < s.size(); ++i)
	{
		if (isupper(s[i]))
			return false;
	}
	return true;
}


string getAbb(vector <string> h)
{
	string res;

	for (int i = 0; i < h.size(); ++i)
	{
		res.push_back(h[i][0]);
	}
	return res;
}

void myprint(vector <string> h)
{
	if (h.empty())
		return;
	if (h.size() == 1)
	{
		cout << h[0];
		return;
	}
	cout << getAbb(h)<<" (";
	for (int i = 0; i < h.size(); ++i)
	{
		if (i)
			cout << ' ';
		cout << h[i];
	}
	cout << ")";
	h.clear();
}

void solve()
{
	string s;
	while (getline(cin,s))
	{
		vector <string> st;
		string curw;
		s.push_back('.');
		for (int i = 0; i < s.size(); ++i)
		{
			if (isalpha(s[i]))
			{
				curw.push_back(s[i]);
				continue;
			}
			bool ki = isTrueWord(curw);
			if (ki)
			{
				st.push_back(curw);
				if (s[i] != ' ')
				{
					myprint(st);
					if (i != (int)s.size() - 1)
						cout << s[i];
					st.clear();
				}
			}
			else
			{
				myprint(st);
				if (st.size())
					cout << ' ';
				cout  << curw;
				if (i != (int)s.size() - 1)
					cout << s[i];
				st.clear();
			}
			curw.clear();
			
				
		}
		cout << endl;
	}
}

int main()
{
	prepare("abbreviation");
	read();
	solve();
	return 0;
}

