#define _USE_MATH_DEFINES
#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <iomanip>
#include <stack>
#include <deque>
#include <queue>
#include <list>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <limits.h>
#include <math.h>
#include <algorithm>
using namespace std;

void prepare(string s = "")
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	if (!s.empty())
	{
		freopen((s + ".in").c_str(), "r", stdin);
		freopen((s + ".out").c_str(), "w", stdout);
	}
#endif
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
}

#define mp make_pair
#define forn(i, n) for (int i = 0; i < n; ++i)
#define forab(i, a, b) for (int i = a; i <= b; ++i)
#define fornd(i, n) for (int i = n - 1; i >= 0; --i)
#define forabd(i, a, b) for (int i = b; i >= a; --i)
#define _(a, val) memset(a, val, sizeof(a));
#define sz(a) (int) a.size()
#ifdef _DEBUG
#define dbg(x) cout<<#x<<" = "<<x<<endl;
#else
template <class T> inline void dbg(T x) {}
#endif
typedef long long ll;
typedef unsigned long long ull;
#define all(a) a.begin(),a.end()

string s;
const double eps = 1e-12;
bool cacheU[1000 * 1000 + 7];
double cacheV[1000 * 1000 + 7];



double rec(int l)
{
	int c, w;
	c = w = 0;
	double length = (double)s.size() - (double)l;
	double ans = 0;
	for (int i = l; i < s.size(); ++i)
	{
		if (s[i] == 'C')
			++c;
		else
			++w;
		if (s[l] == 'C')
			ans += (double)w / length;
		else
			ans += (double)c / length;

	}
	if ((int)s.size() - l == 1)
		return ans;
	else
	{
		for (int i = 1; l + i < s.size(); ++i)
		{
			double dans;
			//double dans = rec(l + i) / length;
			if (!cacheU[l + i])
			{
				cacheV[l + i] = rec(l + i);
				cacheU[l + i] = true;
			}
			dans = cacheV[l + i] / length;
			if (dans < eps)
				break;
			ans += dans;
		}
		return ans;
	}
}

void read()
{
	cin >> s;
}

void solve()
{
	cout << fixed << setprecision(12) << rec(0) << endl;;
}

int main()
{
	prepare("foreign");
	read();
	solve();
	return 0;
}

