#define _USE_MATH_DEFINES
#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <iomanip>
#include <stack>
#include <deque>
#include <queue>
#include <list>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <limits.h>
#include <math.h>
#include <algorithm>
using namespace std;

void prepare(string s = "")
{
#ifdef _DEBUG
	freopen("input.txt","r",stdin);
	//freopen("output.txt", "w", stdout);
#else
	if (!s.empty())
	{
		freopen((s + ".in").c_str(), "r", stdin);
		freopen((s + ".out").c_str(), "w", stdout);
	}
#endif
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
}

#define mp make_pair
#define forn(i, n) for (int i = 0; i < n; ++i)
#define forab(i, a, b) for (int i = a; i <= b; ++i)
#define fornd(i, n) for (int i = n - 1; i >= 0; --i)
#define forabd(i, a, b) for (int i = b; i >= a; --i)
#define _(a, val) memset(a, val, sizeof(a));
#define sz(a) (int) a.size()
#ifdef _DEBUG
#define dbg(x) cout<<#x<<" = "<<x<<endl;
#else
template <class T> inline void dbg(T x) {}
#endif
typedef long long ll;
typedef unsigned long long ull;
#define all(a) a.begin(),a.end()

const int A = -32768;
const int B = 32767;

vector< pair<int, bool> > v, ans;

bool readline(pair<int, bool> &a, pair<int, bool> &b) {
	string s;

	cin >> s >> s >> a.first;
	a.second = s[0] == '<';

	bool flag = false;
	if (cin >> s)
		flag = true;

	if (!flag || s == "||") {
		b.first = a.second ? A : B;
		b.second = !a.second;
		return flag;
	}

	cin >> s >> s >> b.first;
	b.second = s[0] == '<';

	if (cin >> s)
		return true;
	return false;
}

void read()
{
	pair<int, bool> a, b;

	bool flag = true;
	while (flag) {
		flag = readline(a, b);
		v.push_back(a);
		v.push_back(b);
	}
}

void solve()
{
	sort(all(v));

	int val = 0;
	bool flag = true;
	pair<int, bool> a, b;

	forn(i, sz(v)) {
		pair<int, bool> item = v[i];

		if (!item.second) {
			if (flag) {
				a = item;
				flag = false;
			}

			val++;
		}
		else {
			val--;

			if (val < 0) {
				cout << "false" << endl;
				return;
			}

			if (val == 0 && (i + 1 == sz(v) || i + 1 != sz(v) && v[i+1].first != v[i].first + 1)) {
				flag = true;
				b = item;
				
				ans.push_back(a);
				ans.push_back(b);
			}
		}
	}

	if (sz(ans) == 2 && ans[0].first == A && ans[1].first == B) {
		cout << "true" << endl;
		return;
	}

	forn(i, sz(ans)) {
		if (ans[i].first != A) {
			cout << "x >= " << ans[i].first;

			if (ans[i + 1].first != B)
				cout << " && ";
		}

		if (ans[i + 1].first != B) {
			cout << "x <= " << ans[i + 1].first << " ||";
		}

		cout << endl;

		++i;
	}
}

int main()
{
	prepare("hard");
	read();
	solve();
	return 0;
}

