#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#define ll long long
#define ld double
#define pii pair <int, int>
#define mp make_pair

using namespace std;

string s;
string t;

int checkword(int &pos) {
	if ('A' <= s[pos] && s[pos] <= 'Z') {
		for (int i = pos + 1; i < (int)s.size(); i++) {
			if (s[i] == ' ' || s[i] == ',' || s[i] == '.') {
				if (i - pos == 1) {
					return -1;
				}

				t.push_back(s[pos]);
				pos = i;
				return i;
			}

			if (!('a' <= s[i] && s[i] <= 'z')) {
				return -1;
			}
		}

		if ((int)s.size() - pos == 1) {
			return -1;
		}

		t.push_back(s[pos]);
		pos = (int)s.size();
		return s.size();
	}
	else {
		return -1;
	}
}

int main() {
	//freopen("input.txt", "r", stdin);
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
	while (getline(cin, s)) {
		for (int i = 0; i < (int)s.size(); i++) {
			t.clear();
			int pos = i;
			int cnt = 0;

			while (checkword(pos) != -1) {
				cnt++;

				if (s[pos] != ' ') {
					break;
				}

				pos++;
			}

			if (cnt <= 1) {
				while (pos < (int)s.size() && !(s[pos] == ' ' || s[pos] == '.' || s[pos] == ',')) {
					pos++;
				}

				for (int j = i; j <= pos; j++) {
					if (j == (int)s.size()) {
						break;
					}

					printf("%c", s[j]);
				}
			}
			else {
				if (pos != (int)s.size() && s[pos] != '.' && s[pos] != ',' && s[pos] != ' ') {
					pos--;
				}

				cout << t << " (";
				for (int j = i; j < pos; j++) {
					printf("%c", s[j]);
				}

				if (pos != (int)s.size()) {
					printf(")%c", s[pos]);
				}
				else {
					printf(")");
				}
			}

			i = pos;
		}

		printf("\n");
	}

	return 0;
}
