#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#define ll long long
#define ld double
#define pii pair <int, int>
#define mp make_pair

using namespace std;

const int maxn = (int)5101;

double l[maxn], r[maxn], cx[maxn], cy[maxn];
int n, m, x, y, cnt[maxn];
double w, h;
vector<vector<pair<int, int> > > v(maxn);

int main() {
	//freopen("input.txt", "r", stdin);
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
	
	cin >> n >> w >> h >> m;
	for (int i = 0; i < h; i++) {
		cx[i] = w * n / 2;
		cy[i] = w * n / 2;
		l[i] = 0;
		r[i] = w * n;
		cnt[i] = n;
		for (int j = 0; j < n; j++) {
			v[i].push_back(mp(j, 1));
		}
	}
	for (int i = 0; i < m; i++) {
		cin >> x >> y;
		x--;
		y--;
		double le, ri;
		double a = -1, b = -1;
		le = w * y;
		ri = 2 * (y + 1);
		if (cnt[x] == 1) {
			cout << "yes\n" << i + 1;
			return 0;
		}
		cnt[x]--;
		double sum = 0;
		for (int j = 0; j < v[x].size(); j++) {
			if (v[x][j].first == y) {
				v[x][j].second = 0;
			}
			if (a == -1 && v[x][j].second) {
				a = w * v[x][j].first;
			}
			if (v[x][j].second) {
				b = w * (v[x][j].first + 1);
			}
			if (v[x][j].second) {
				sum += (w * v[x][j].first + w / 2.0);
			}
		}
		sum /= cnt[x];
		l[x] = a;
		r[x] = b;
		if (x % 2 == 0) {
			cx[x] = w * n / 2.0;
			cy[x] = sum;
		}
		else {
			cy[x] = w * n / 2.0;
			cx[x] = sum;
		}
		double sumx = 0;
		double sumy = 0;
		for (int j = h - 2; j >= 0; j--) {
			sumx += cx[j + 1];
			sumy += cy[j + 1];
			double tk = h - 1 - j;
			double ccx = sumx / tk;
			double ccy = sumy / tk;
			if (j % 2 == 0) {
				if (ccy <= l[j] || ccy >= r[j]) {
					cout << "yes\n" << i + 1;
					return 0;
				}
			}
			else {
				if (ccx <= l[j] || ccx >= r[j]) {
					cout << "yes\n" << i + 1;
					return 0;
				}
			}
		}
	}
	cout << "no";
	return 0;
}




