import sys
import re

def get_chn(wr):
    wrm = wr.groups(0)[0]
    w = wrm[1: -1]
    tk = w.split()
    result = wrm[0]
    for i in tk:
        result += i[0]
    result += ' ('
    result += w
    result += ')'
    result += wrm[-1]
    return result

def transf(line):
    line = '.' + line + '.'
    rexp = r'([^A-Za-z]([A-Z][a-z]+( [A-Z][a-z]+)+)[^A-Za-z])'
    line = re.sub(rexp, get_chn, line)
    return line[1: -1]

def main():
    '''
    sys.stdin = open("input.txt", "r")
    sys.stdout = open("output.txt","w")
    '''
    sys.stdin = open("abbreviation.in", "r")
    sys.stdout = open("abbreviation.out","w")
    
    for line in sys.stdin:
        print(transf(line), end = '')

main()
