#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <fstream>

using namespace std;

#define ll long long
#define ull unsigned ll

#define fileName "expect"

int main() {
	ifstream cin(string(fileName) + ".in");
	ofstream cout(string(fileName) + ".out");
	
	int N, M;

	cin >> N >> M;

	int *t= new int(N + 1);
	int *k= new int(N + 1);
	int *b= new int(M);

	t[0] = 0;
	k[0] = 0;

	char ch;

	for (int i = 1; i <= N; i++)
	{
		cin >> ch;
		cin >> t[i];
		cin >> k[i];
		if (ch == '-') k[i] *= -1;
	}

	for (int i = 0; i < M; i++)
	{
		cin >> b[i];
	}

	for (int i = 0; i < M; i++){
		int n = b[i];
		int sum = 0;
		for (int j = 1; j <= N; j++)
		{
			if (n < 0)
				sum += (t[j] - t[j - 1])*abs(n);
			n += k[j];
		}
		if (n < 0) cout << "INFINITY" << endl;
		else
			cout << sum << endl;
	}

	return 0;
}