#include <iostream>
#include <iomanip>
#include <string>
#include <set>
#include <sstream>

using namespace std;

bool ok[1 << 16];
const int add = 32768;
const int N = (1 << 16);
bool prntd = false;

inline void addCond(const string& s){
	istringstream ss(s);
	int less = -1, greater = -1;
	string a; int t;
	ss >> a >> a >> t;
	if (a == ">="){
		greater = t + add;
	}
	else {
		less = t + add;
	}
	ss >> a;
	if (a == "&&"){
		ss >> a >> a >> t;
		less = t + add;
	}
	for (int i = 0; i < (1 << 16); ++i){
		bool& v = ok[i];
		v |= (i >= greater || greater < 0) && (i <= less || less < 0);
	}
}

int main(){
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	string s;
	while (getline(cin, s)){
		if (s.back() != ('|')) s = s + " ||";
		addCond(s);
	};
	int cntg = 0, cntf = 0;
	for (bool b : ok){
		if (b) ++cntg;
		else ++cntf;
	}
	if (cntg == 0){
		cout << "false" << endl;
		return 0;
	}
	if (cntf == 0){
		cout << "true" << endl;
		return 0;
	}
	int pos = 0;
	if (ok[pos]){
		while (ok[pos]) ++pos;
		cout << "x <= " << pos - 1 - add;
		prntd = true;
	}
	while (pos < N){
		while (pos < N && !ok[pos]) ++pos;
		if (pos == N) break;
		if (prntd) cout << " ||" << endl;
		else cout << endl;
		int l = pos;
		while (pos < N && ok[pos]) ++pos;
		if (pos == N){
			cout << "x >= " << l - add;
			break;
		}

		int r = pos - 1;
		cout << "x >= " << l - add << " && x <= " << r - add;
		prntd = true;
	}


	return 0;
}