#include <iostream>
#include <iomanip>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

const int MAX = 1001000;
const int INF = 1000000000;
const double EPS = 1e-9;

string str;
int n;
long long csum[MAX];
long long wsum[MAX];

int main() {
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);

	cin >> str;
	n = str.length();
	csum[n] = wsum[n] = 0;

	double d = 0.0;

	for (int i = 1; i <= n; ++i) {
		char c = str[n - i];
		double div;

		if (i == n) {
			div = 1.;
		} else {
			div = i + 1.;
		}

		if (c == 'C') {
			csum[n - i] = csum[n - i + 1];
			wsum[n - i] = wsum[n - i + 1] + i;
			d += csum[n - i] / double(i) / div;
		} else {
			csum[n - i] = csum[n - i + 1] + i;
			wsum[n - i] = wsum[n - i + 1];
			d += wsum[n - i] / double(i) / div;
		}
	}

	cout << fixed << setprecision(10) << d << endl;
}
