#include <bits/stdc++.h>
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
using namespace std;
typedef long long ll;

bool isLower(char c) {
    return c >= 'a' && c <= 'z';
}

bool isUpper(char c) {
    return c >= 'A' && c <= 'Z';
}

bool isLetter(char c) {
    return isLower(c) || isUpper(c);
}

bool cap(string s) {
    bool ok = 1;
    ok &= s.length() >= 2;
    if (ok) ok &= isUpper(s[0]);
    for (int i = 1; i < (int)s.length(); i++) ok &= isLower(s[i]);
    return ok;
}

string format(string s) {
    int n = s.length();
    vector<string> a;
    string cur = "";
    for (int i = 0; i < n; i++) {
        if (isLetter(s[i])) {
            cur += s[i];
        } else {
            if (cur != "") a.push_back(cur);
            cur = "";
            cur += s[i];
            a.push_back(cur);
            cur = "";
        }
    }
    if (cur != "") a.push_back(cur);

    int m = a.size();
    vector<char> f(m);
    for (int i = 0; i < m; i++) {
        f[i] = cap(a[i]);
    }

    string res = "";
    for (int i = 0; i < m; i++) {
        int j = i;
        if (!f[i]) {
            res += a[i];
            continue;
        }
        while (j + 2 < m && a[j + 1] == " " && f[j + 2]) j += 2;

        if (j != i) {
            string abr = "";
            for (int k = i; k <= j; k += 2) {
                abr += a[k][0];
            }
            res += abr;
            res += " (";
            for (int k = i; k <= j; k++) res += a[k];
            res += ")";
            i = j;
            continue;
        } else {
            res += a[i];
            continue;
        }
    }
    return res;
}

#define TASK "abbreviation"
int main()
{
    assert(freopen(TASK".in", "r", stdin));
    assert(freopen(TASK".out", "w", stdout));

    string s;
    while (getline(cin, s)) {
        string t = format(s);
        cout << t << endl;
    }

    return 0;
}