#include <bits/stdc++.h>
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define db(x) cerr << #x << " " << x << endl
#define db2(x, y) cerr << "(" << #x << ", " << #y << ") = (" << x << ", " << y << ")" << endl
using namespace std;
typedef long long ll;
const int N = 1e4 + 10;


struct pt {
    ll x, y;
    pt () { }
    pt (ll xx, ll yy): x(xx), y(yy) { }
    pt operator + (pt A) {
        return pt(x + A.x, y + A.y);
    }
    pt operator - (pt A) {
        return pt(x - A.x, y - A.y);
    }
    pt operator * (ll k) {
        return pt(x * k, y * k);
    }
};

int curL[N];
int curR[N];
set<int> used[N];
pt sumV[N];

int main() {
#ifdef HOME
    freopen("in", "r", stdin);
#else
    assert(freopen("jenga.in", "r", stdin));
    assert(freopen("jenga.out", "w", stdout));
#endif
    int n, w;
    int h, m;
    scanf("%d%d", &n, &w);
    w = 2;
    scanf("%d%d", &h, &m);

    for (int i = 0; i < h; i++) {
        curL[i] = 0;
        curR[i] = n - 1;
        sumV[i] = pt(w * 1ll * n / 2, w * 1ll * n / 2) * n;
    }

    for (int i = 0; i < m; i++) {
        int l, k;
        scanf("%d%d", &l, &k);  l--; k--;
        //db2(l, k);

        used[l].insert(k);
        if (l % 2 == 0) {
            sumV[l] = sumV[l] - pt((k * 2 + 1), n);
        }
        else {
            sumV[l] = sumV[l] - pt(n, (k * 2 + 1));
        }

        if ((int)used[l].size() != n) {
            for (; used[l].count(curL[l]) == 1; curL[l]++);
            for (; used[l].count(curR[l]) == 1; curR[l]--);
            //db(used[l].size());
            //assert(curL[l] <= curR[l]);
        }

        pt curSum(0, 0);
        ll cnt = 0;
        for (int j = h - 1; j >= 0; j--) {
            //db(cnt);
            //db2(curSum.x, curSum.y);
            
            if (cnt != 0) {
                pt A, B;
                if (j % 2 == 0) {
                    A = pt(curL[j] * w, 0);
                    B = pt((curR[j] + 1) * w, w * n);
                }
                else {
                    A = pt(0, curL[j] * w);
                    B = pt(w * n, (curR[j] + 1) * w);
                }

                //db2(curL[j], curR[j]);
                A = A * cnt;
                B = B * cnt;
                if ((!(A.x < curSum.x && curSum.x < B.x && A.y < curSum.y  && curSum.y < B.y)) || (int)used[j].size() == n) {
                    puts("yes");
                    printf("%d\n", i + 1);
                    return 0;
                }
            }
            curSum = curSum + sumV[j];
            cnt += n - used[j].size();
        }

    }
    /*for (int i = 0; i < h; i++) {
        db2(curL[i], curR[i]);
        db(used[i].size());
        for (auto x: used[i])
            cerr << x << " ";
        cerr << endl;
    }*/
    puts("no");
    


    return 0;
}




