#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>

using namespace std;

const int MAXN = 1000000 + 1000;

int n;
int f[MAXN], r[MAXN];
double sumC = 0, sumCR = 0, sumPref = 0, dp[MAXN], p[MAXN];
string s;

int main () {
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
	cin >> s;
	n = s.length();
	s = "." + s;
	for(int i = 1; i <= n; i++) f[i] = f[i - 1] + (s[i] == 'W');
	for(int i = 1; i <= n; i++) r[i] = r[i - 1] + (s[i] == 'C');
	dp[0] = 0;
	p[0] = 1;

/*	for(int i = 0; i < n; i++) {
		dp[i] /= p[i];
		if (s[i + 1] == 'C') {
			for(int j = i + 1; j <= n; j++) {
				dp[j] += (dp[i] + f[j] - f[i]) * 1.0 / (n - i) * p[i];
				p[j] += p[i] * 1.0 / (n - i);
			}
		} else {
			for(int j = i + 1; j <= n; j++) {
				dp[j] += (dp[i] + r[j] - r[i]) * 1.0 / (n - i) * p[i];
				p[j] += p[i] * 1.0 / (n - i);
			}

		}
	}

	cout << dp[n] << endl;
	return 0;*/

	double sumP = 0.0;

	for(int i = 0; i <= n; i++) {
		if (i > 0) {
			p[i] = sumP;
		}
		dp[i] = sumC * f[i] + sumCR * r[i] + sumPref;
		dp[i] /= p[i];

		if (i == n) break;

		if (s[i + 1] == 'C') {
			double C = 1.0 / (n - i) * p[i];
			sumC += C;
			sumPref += C * dp[i] - C * f[i];
		} else if (s[i + 1] == 'W') {
			double C = 1.0 / (n - i) * p[i];
			sumCR += C;
			sumPref += C * dp[i] - C * r[i];
		}
		if (i != n) {
			sumP += p[i] * 1.0 / (n - i);
		}
	}
	printf("%.10lf\n", dp[n]);
	return 0;
}