#include <iostream>
#include <string>  
#include <vector>

using namespace std;

bool is_big(char c) {
	return c >= 'A' && c <= 'Z';
}

bool is_small(char c) {
	return c >= 'a' && c <= 'z';
}

bool is_letter(char c) {
	return is_big(c) || is_small(c);
}

bool check(string const & s) {
	if ((int)s.size() <= 1 || !is_big(s[0])) return 0;
	for (int i = 1; i < (int)s.size(); i++) {
		if (!is_small(s[i])) return 0;
	}
	return 1;
}

int main() {

	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);

	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
*/
	string s;

	while (getline(cin, s)) {
		vector< string > mas;
		for (int i = 0; i < (int)s.size(); i++) {
			int j = i;
			string t = "";
			while (j < (int)s.size() && is_letter(s[i]) == is_letter(s[j]))
				t.push_back(s[j++]);
			j--;
			mas.push_back(t);
			i = j;
		}
		//for (auto i : mas) cout << i << " " << check(i) << " " << is_big(i[0]) << "\n";
		for (int i = 0; i < (int)mas.size(); i++) {
			if (!check(mas[i])) {
				cout << mas[i];
			}
			else {
				int j = i;
				string t = "";
				t.push_back(mas[i][0]);
				while (1) {
					if (j + 2 < (int)mas.size() && check(mas[j]) && check(mas[j + 2]) && mas[j + 1] == " ")
						t.push_back(mas[j + 2][0]), j += 2;
					else
						break;
				}
				if ((int)t.size() > 1) {
					cout << t << " (";
					for (int q = i; q <= j; q++) cout << mas[q];
					cout << ")";
					i = j;
				}
				else {
					cout << mas[i];
				}
			}
		}
		cout << "\n";
	}

	return 0;
}