//Ural FU 2 Apex (604)

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <assert.h>
#include <iomanip>
#include <ctime>
using namespace std;

#define FILENAME "foreign"

const int maxN = (int)1e6 + 100;

string str;
double dp[maxN];

void solve()
{
    cin >> str;
    reverse(str.begin(), str.end());
    int n = str.length();
    dp[0] = 0;
    double sumC = 0;
    double sumW = 0;
    for (int i = 1; i <= n; i++)
    {
        if (str[i - 1] == 'C')
        {
            dp[i] = sumC / i;
            sumC += dp[i];
            sumW += dp[i] + i;
        }
        else
        {
            dp[i] = sumW / i;
            sumC += dp[i] + i;
            sumW += dp[i];
        }
    }
    cout << fixed << setprecision(10);
    cout << dp[n];
}

int main()
{
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);
#endif

    assert(FILENAME != "TODO");

    solve();

#ifdef LOCAL
    fprintf(stderr, "\n\n\n%.2lf ms\n", clock() * 1000.0 / CLOCKS_PER_SEC);
#endif
}