//Ural FU 2 Apex (604)

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <assert.h>
#include <ctime>
using namespace std;

#define FILENAME "hard"

struct Event
{
    int t;
    bool open;
    Event() {}
    Event(int _t, bool _open) : t(_t), open(_open) {}
    bool const operator < (Event const &e)
    {
        if (t < e.t)
            return true;
        if (t > e.t)
            return false;
        return open < e.open;
    }
};

vector<Event> ev = vector<Event>();

vector<pair<int, int> > res;

void solve()
{
    char c1, c2, c3;
    int l, r;
    while (true)
    {
        c2 = 0;
        scanf("x %c= %d %c%c", &c1, &l, &c2, &c3);
        if (c1 == '<')
        {
            ev.push_back(Event(-32768, true));
            ev.push_back(Event(l + 1, false));
        }
        else
        {
            if (c2 == '|' || c2 == 0)
            {
                ev.push_back(Event(l, true));
                ev.push_back(Event(32768, false));
            }
            else
            {
                c2 = 0;
                scanf(" x <= %d %c%c", &r, &c2, &c3);
                if (l <= r)
                {
                    ev.push_back(Event(l, true));
                    ev.push_back(Event(r + 1, false));
                }
            }
        }
        if (c2 == 0)
        {
            break;
        }
        scanf("\n");
    }
    sort(ev.begin(), ev.end());
    int i = 0;
    int h = 0;
    int prev = -32768;
    for (int n = -32768; n <= 32768; ++n)
    {
        while (i < ev.size() && ev[i].t <= n)
        {
            h += (ev[i].open ? 1 : -1);
            ++i;
        }
        if (h == 0)
        {
            if (prev < n)
            {
                res.push_back(make_pair(prev, n - 1));
            }
            prev = n + 1;
        }
    }
    if (res.size() == 0)
        printf("false");
    else if (res.size() == 1 && res[0].first == -32768 && res[0].second == 32767)
        printf("true");
    else
    {
        for (int i = 0; i < res.size(); ++i)
        {
            if (res[i].first == -32768)
                printf("x <= %d", res[i].second);
            else if (res[i].second == 32767)
                printf("x >= %d", res[i].first);
            else
                printf("x >= %d && x <= %d", res[i].first, res[i].second);
            if (i < res.size() - 1)
                printf(" ||\n");
        }
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);
#endif

    assert(FILENAME != "TODO");
    solve();

#ifdef LOCAL
    fprintf(stderr, "\n\n\n%.2lf ms\n", clock() * 1000.0 / CLOCKS_PER_SEC);
#endif
}