//Ural FU 2 Apex (604)

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <assert.h>
#include <ctime>
using namespace std;
typedef long long ll;
#define FILENAME "jenga"

bool check(int n, int l, int r, long long x, long long y, long long cnt)
{
    return x > l * cnt && x < r * cnt && y > 0 && y < n * 2 * cnt;
}

set<int> deleted[5005];
int sumx[5005];
int sumy[5005];
int cnt[5005];
int mi[5005];
int ma[5005];

void solve()
{
    int n, w;
    int h, m;
    scanf("%d %d\n%d %d", &n, &w, &h, &m);
    for (int i = 0; i < n; ++i)
    {
        sumx[0] += i * 2 + 1;
        sumy[0] += i * 2 + 1;
    }
    cnt[0] = n;
    ma[0] = n - 1;
    for (int i = 1; i < h; ++i)
    {
        sumx[i] = sumx[0];
        sumy[i] = sumy[0];
        cnt[i] = n;
        ma[i] = n - 1;
    }
    for (int im = 0; im < m; ++im)
    {
        int l, k;
        scanf("%d %d", &l, &k);
        --l; --k;
        --cnt[l];
        if (l & 1)
        {
            sumx[l] -= n;
            sumy[l] -= k * 2 + 1;
        }
        else
        {
            sumy[l] -= n;
            sumx[l] -= k * 2 + 1;
        }
        deleted[l].insert(k);
        while (deleted[l].count(mi[l]))
            ++mi[l];
        while (deleted[l].count(ma[l]))
            --ma[l];
        if (mi[l] > ma[l])
        {
            if (l == h - 1)
                --h;
            else
            {
                printf("yes\n%d", im + 1);
                return;
            }
        }
        /*for (int i = 0; i < h; ++i)
            cout << "Ln82 " << i << ' ' << ((double)sumx[i]) / cnt[i] << ' ' << ((double)sumy[i]) / cnt[i] << '\n';*/
        ll sux = 0, suy = 0, cn = 0;
        for (int i = h - 1; i >= 0; --i)
        {
            if (cn > 0 && i <= l)
            {
                bool succ;
                if (i & 1)
                    succ = check(n, mi[i] * 2, ma[i] * 2 + 2, suy, sux, cn);
                else
                    succ = check(n, mi[i] * 2, ma[i] * 2 + 2, sux, suy, cn);
                if (!succ)
                {
                    printf("yes\n%d", im + 1);
                    return;
                }
            }
            cn += cnt[i];
            sux += sumx[i];
            suy += sumy[i];
        }
    }
    printf("no");
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);
#endif

    assert(FILENAME != "TODO");
    solve();

#ifdef LOCAL
    fprintf(stderr, "\n\n\n%.2lf ms\n", clock() * 1000.0 / CLOCKS_PER_SEC);
#endif
}