//Ural FU 2 Apex (604)

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <assert.h>
#include <ctime>
using namespace std;

typedef long long ll;
#define FILENAME "list"

const int sumLim = 2610;
const int primeLim = sumLim;

int getLen(int x)
{
    if (x == 0)
        return 1;
    int res = 0;
    while (x > 0)
    {
        x /= 10;
        ++res;
    }
    return res;
}

int getLen(vector<int> const &v) // unused, uncheked
{
    if (v.empty())
        return 0;
    int res = v.size() * 2 + 2;
    for (int i = 0; i < v.size(); ++i)
        res += getLen(v[i]);
}

char getDigit(int n, int i)
{
    i = getLen(n) - i - 1;
    for (; i > 0; --i)
        n /= 10;
    return n % 10 + '0';
    //int l = getLen
    //for (in
}

vector<int> primes; // 0 = 2
int ps;
int backPrimes[sumLim];
bool unprime[primeLim]; 
ll backpack[sumLim][500]; //          >=    
vector<int> rf[sumLim]; //     ,      

void printans(ll a, ll b, int s, int from)
{
    while (backpack[s][from] <= a)
    {
        a -= backpack[s][from];
        b -= backpack[s][from];
        ++s;
        from = 0;
        /*printans(a - backpack[s][0], b - backpack[s][0], s + 1, 0);
        return;*/
    }
    int k = 0;
    while (k < rf[s].size() && rf[s][k] < primes[from])
        ++k;
    while (k < rf[s].size() && backpack[s][backPrimes[rf[s][k]]] - backpack[s][backPrimes[rf[s][k]] + 1] <= a)
    {
        a -= backpack[s][backPrimes[rf[s][k]]] - backpack[s][backPrimes[rf[s][k]] + 1];
        b -= backpack[s][backPrimes[rf[s][k]]] - backpack[s][backPrimes[rf[s][k]] + 1];
        ++k;
    }
    if (a == 0)
        cout << '[';
    else if (a == backpack[s][from] - 1)
        cout << ' ';
    else if (a == backpack[s][from] - 2)
        cout << ',';
    else if (a == backpack[s][from] - 3)
        cout << ']';
    else
    {
        int curlen = getLen(rf[s][k]);
        if (a <= curlen)
        {
            cout << getDigit(rf[s][k], curlen - a);
        }
        else if (a == curlen + 1)
            cout << (rf[s][k] == s ? ']' : ',');
        else if (a == curlen + 2)
            cout << (rf[s][k] == s ? ',' : ' ');
        else if (rf[s][k] == s)
            cout << ' ';
        else
            printans(a - curlen - 2, b - curlen - 2, s - rf[s][k], backPrimes[rf[s][k]] + 1);
    }
}

void printans() {
    ll a, b, total = 0;
    cin >> a >> b;
    --a;
    for (int i = a; i < b; ++i)
    printans(i, i + 1, 0, 0);
}

void solve()
{
    for (int i = 2; i < primeLim; ++i)
    {
        if (!unprime[i])
        {
            for (ll j = (ll)i * i; j < primeLim; j += i)
                unprime[j] = true;
            backPrimes[i] = primes.size();
            primes.push_back(i);
        }
    }
    ps = primes.size() - 1;
    /*for (int i = 0; i < primes.size(); ++i)
    {
        int cur = primes[i];
        int curLen = getLen(cur);
        backpack[cur][i] += curLen + 4;
        rf[cur].push_back(cur);
        if (i != 0)
        {
            for (int j = 0; j < sumLim; ++j)
            {
                backpack[j][i] += backpack[j][i - 1];
            }
            for (int j = cur + 1; j < sumLim; ++j)
            {
                if (backpack[j - cur][i - 1] > 0)
                {
                    backpack[j][i] += backpack[j - cur][i - 1] + curLen + 2;
                    rf[j].push_back(cur);
                }
            }
        }
    }*/
    for (int i = primes.size() - 1; i >= 0; --i)
    {
        int cur = primes[i];
        int curLen = getLen(cur);
        backpack[cur][i] = curLen + 4;
        rf[cur].push_back(cur);
        if (i != primes.size() - 1)
        {
            for (int j = 0; j < sumLim; ++j)
            {
                backpack[j][i] += backpack[j][i + 1];
            }
            for (int j = cur + 1; j < sumLim; ++j)
            {
                if (backpack[j - cur][i + 1] > 0)
                {
                    backpack[j][i] += backpack[j - cur][i + 1] + curLen + 2;
                    rf[j].push_back(cur);
                }
            }
        }
    }
    for (int i = 0; i < sumLim; ++i)
        reverse(rf[i].begin(), rf[i].end());

    /*ll total = 0;
    for (int s = 0; s < sumLim; ++s)
    {
        ll ss = backpack[s][0];
        cout << s << ' ' << ss << ' ';
        for (int i = 0; i < rf[s].size(); ++i)
            cout << ' ' << rf[s][i];
        cout << '\n';
        total += ss;
    }
    cout << total << endl;*/

    printans();
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);
#endif

    assert(FILENAME != "TODO");
    solve();

#ifdef LOCAL
    fprintf(stderr, "\n\n\n%.2lf ms\n", clock() * 1000.0 / CLOCKS_PER_SEC);
#endif
}