

import string

def iscap(s):
    if len(s) < 2:
        return False
    if s[0] not in string.ascii_uppercase:
        return False
    for ch in s[1:]:
        if ch not in string.ascii_lowercase:
            return False
    return True

def getabbr(lst):
    ret = ""
    for word in lst[::2]:
        ret += word[0]
    ret += ' ('
    for word in lst:
        ret += word
    ret += ')'
    return ret

def solve(lst):
    ret = ''
    i = 0
    while i < len(lst):
        if not iscap(lst[i]):
            ret += lst[i]
            i += 1
            continue
        j = i + 1
        words = 1
        while j < len(lst) - 1 and lst[j] == ' ' and iscap(lst[j+1]):
            j += 2
            words += 1
        if words == 1:
            ret += lst[i]
            i += 1
        else:
            ret += getabbr(lst[i:j])
            i = j
    return ret

def split(s):
    ret = ""
    if not s:
        return []
    for i, ch in enumerate(s):
        if ch not in string.ascii_lowercase and ch not in string.ascii_uppercase:
            return [ret] + [ch] + split(s[i+1:])
        ret += ch
    return [ret]

def answer(s):
    return solve(split(s))

fout = open("abbreviation.out", 'w')

for line in open("abbreviation.in"):
    fout.write(answer(line))
    
fout.close()