#include <bits/stdc++.h>
using namespace std;

const int add = 32768;

char val[2 * add + 1];

vector<pair<int, int> > all;

void parse(string s, int &cnt)
{
    if(s.length() < 4) return;
    int left = -add;
    int right = add;
    int pos = 0;
    int mult = 1;
    char type = 'a';
    while(pos < s.length())
    {
        if(s[pos] == ' ' || s[pos] == 'x' || s[pos] == '&' || s[pos] == '|')
        {
            ++pos;
            continue;
        }
        if(s[pos] == '-')
        {
            mult = -1;
            pos++;
            continue;
        }
        if(s[pos] == '>')
        {
            type = 'g';
            pos += 3;
            continue;
        }
        if(s[pos] == '<')
        {
            type = 'l';
            pos += 3;
            continue;
        }
        if(s[pos] >= '0' && s[pos] <= '9')
        {
            int cur = 0;
            while(pos < s.length() && s[pos] >= '0' && s[pos] <= '9')
            {
                cur = cur * 10 + s[pos] - '0';
                ++pos;
            }
            cur *= mult;
            if(type == 'g')
                left = cur;
            else if(type == 'l')
                right = cur;
            mult = 1;
            continue;
        }
    }
    all.push_back(make_pair(left, right));
    cnt++;
}

bool check(int x)
{
    for(int i = 0; i < all.size(); ++i)
    {
        if(x >= all[i].first && x <= all[i].second) return 1;
    }
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(0);
    ifstream cin("hard.in");
    ofstream cout("hard.out");
    string s;
    int cnt = 0;
    while(getline(cin, s))
    {
        parse(s, cnt);
    }
    if(cnt == 0)
    {
        cout << "true" << endl;
        return 0;
    }
    /*for(int i = 0; i < all.size(); ++i)
    {
        cout << all[i].first << " " << all[i].second << endl;
    }
    return 0;*/
    for(int i = -add; i <= add; ++i)
        val[i + add] = check(i);
    vector<pair<int, int> > ans;
    int left = 0;
    while(left <= 2 * add)
    {
        if(val[left] == 0)
        {
            ++left;
            continue;
        }
        int right = left;
        while(right + 1 <= 2 * add && val[right + 1] == 1) ++right;
        ans.push_back(make_pair(left - add, right - add));
        left = right + 1;
    }
    if(ans.size() == 0)
    {
        cout << "false" << endl;
        return 0;
    }
    if(ans.size() == 1)
    {
        if(ans[0].first == -add && ans[0].second == add)
        {
            cout << "true" << endl;
            return 0;
        }
    }
    for(int i = 0; i < ans.size(); ++i)
    {
        if(ans[i].first == -add)
        {
            cout << "x <= " << ans[i].second;
        }
        else if(ans[i].second == add)
        {
            cout << "x >= " << ans[i].first;
        }
        else
        {
            cout << "x >= " << ans[i].first << " && " << "x <= " << ans[i].second;
        }
        if(i + 1 != ans.size())
            cout << " ||\n";
    }
    return 0;
}
