#include <cstdio>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int maxp = 3000;
const int maxsum = 3000;

long long cnt[maxsum];
long long cnt_a[maxsum][maxsum];
long long lens[maxsum];
long long lens_a[maxsum][maxsum];
bool p[maxp];

vector<int> ps;
vector<int> lenps;

long long a, b;

int mp;
int mp_num;

int get_len(int val)
{
    int res = 0;
    while (val) {
        ++res;
        val /= 10;
    }
    return res;
}

string to_str(int v)
{
    string res = "";
    while (v) {
        res += v % 10 + '0';
        v /= 10;
    }
    return string(res.rbegin(), res.rend());
}

vector<string> sps;

long long gpos = 0;

void to_out(int sum, long long a, long long b, string pref="", int min_p = 0)
{
    if (sum == 0) {
        pref += "], ";
        for (int i = 0; i < (int)pref.size(); ++i) {
            if (gpos >= a) {
                if (gpos > b) {
                    break;
                }
                putchar(pref[i]);
            }
            ++gpos;
        }
    }
    for (int i = min_p; i < mp_num && a <= b && ps[i] <= sum; ++i) {
        long long ngpos = gpos + lens_a[i][sum] + cnt_a[i][sum] * ((int)pref.size());
        if (ngpos < a) {
            gpos = ngpos;
            continue;
        }

        if (cnt_a[i][sum]) {
            string new_pref;
            if (pref.size()) {
                new_pref = pref + ", " + sps[i];
            }
            else {
                new_pref = "[" + sps[i];
            }
            to_out(sum - ps[i], a, b, new_pref, i + 1);
        }
        if (gpos > b) {
            break;
        }
    }
}

int main()
{
    for (int i = 2; i < maxp; ++i) {
        if (!p[i]) {
            ps.push_back(i);
            lenps.push_back(get_len(i));
            sps.push_back(to_str(i));
        }
        else {
            continue;
        }
        for (int j = i * i; j < maxp; j += i) {
            p[j] = true;
        }
    }

    mp_num = ps.size() - 1;
    while (ps[mp_num] >= maxsum) {
        --mp_num;
    }
    mp = ps[mp_num];
    //cout << mp_num << " " << mp << endl;

    cnt[0] = 1;
    for (int i = mp_num; i >= 0; --i) {
        for (int j = maxsum -1; j >= ps[i]; --j) {
            cnt_a[i][j] = cnt[j - ps[i]];
            lens_a[i][j] = lens[j - ps[i]] + cnt[j - ps[i]] * (2 + lenps[i]) + (j == ps[i] ? 2 : 0);
            cnt[j] += cnt[j - ps[i]];
            lens[j] += lens[j - ps[i]] + cnt[j - ps[i]] * (2 + lenps[i]) + (j == ps[i] ? 2 : 0);
        }
    }


    /*

    long long sum_len = 0;
    for (int i = 0; i < maxsum; ++i) {
        sum_len += lens[i];
        cout << i << ":\t" << sum_len << " " << cnt[i] << " " << lens[i] << endl;
    }
    return 0;
*/

    //freopen("L.in", "r", stdin);
    freopen("list.in", "r", stdin);
    freopen("list.out", "w", stdout);

    cin >> a >> b;
    --a; --b;

    int cur_sum = 1;
    long long cur_len = 0;
    while (a <= b) {
        if (cur_len + lens[cur_sum] > a) {
            //cout << "# " << cur_sum << " " << a << " " << b << endl;
            gpos = 0;
            to_out(cur_sum, a - cur_len, b - cur_len);
            a = cur_len + gpos;
        }
        cur_len += lens[cur_sum];
        ++cur_sum;
    }

    puts("");



    return 0;
}
