#include <vector>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <algorithm>
#include <utility>
using namespace std;
const int OO = 1e9;
const int N = 1e6 + 3;

#define mp make_pair
#define forn(i,a,b) for(int i=a;i<b;i++)

typedef long long ll;
typedef int Int;
//#define int ll

#define Mod(a,b) (((a)%(b)+(b))%(b))

char str[N];

double CC[N];
double CW[N];
double CCm[N];
double CWm[N];
double pdp[N];
double dp[N];
int n;

double sum(double A[], int l, int r)
{
	if (l > r)return 0;
	return A[l] - A[r + 1];
}

double ssum(double A[], double B[], int l, int r)
{
	if (l > r)return 0;
	double mul = n - 1 - r;
	return sum(A, l, r) - mul*sum(B, l, r);
}

double DP(int pos)
{
	if (pos == n) {
		return 0;
	}
	double ret = 0;

	forn(i, pos, n) {
		if (str[pos] == 'C') {
			ret += (DP(i + 1) + (1.*sum(CW, pos, i))) / (n - pos);
		} else {
			ret += (DP(i + 1) + (1.*sum(CC, pos, i))) / (n - pos);
		}
	}

	return ret;
}

int main()
{
#ifdef Home
	freopen("inp.txt", "r", stdin);
#else
#define FILENAME "foreign"
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
#endif

	cin >> str;
	n = strlen(str);

	for (int i = n - 1, mul = 1; i >= 0; i--, mul++) {
		CC[i] = CC[i + 1] + (str[i] == 'C');
		CW[i] = CW[i + 1] + (str[i] == 'W');
		CCm[i] = CCm[i + 1] + (str[i] == 'C')*mul;
		CWm[i] = CWm[i + 1] + (str[i] == 'W')*mul;
	}

	//auto dbg=ssum(CCm, CC, 0, 2);

	//cout << DP(0) << endl;
	for (int i = n-1; i >= 0; i--) {
		dp[i] += sum(pdp, i + 1, n);
		if (str[i] == 'C') {
			dp[i] += ssum(CWm, CW, i, n - 1);
		} else {
			dp[i] += ssum(CCm, CC, i, n - 1);
		}
		dp[i] /= (n - i);
		pdp[i] = dp[i] + pdp[i + 1];
	}
	printf("%.12lf\n", dp[0]);

	return 0;
}