#include <bits/stdc++.h>

using namespace std;

inline bool cap(char c)
{
  return ('A' <= c && c <= 'Z');
}

void split(const string& S, vector<string>& v)
{
  int n = S.length();
  int i = 0;
  while (i < n) {
    string t;
    int j = i;
    while (j < n && isalpha(S[j])) {
      t += S[j];
      ++j;
    }
    if (t.length() > 0) {
      v.push_back(t);
      t = "";
    }
    if (j >= n) {
      break;
    }
    t += S[j];
    v.push_back(t);
    i = j + 1;
  }
}

bool cap_str(const string& S)
{
  if (S.length() < 2 || !cap(S[0]))
    return 0;

  for (int i = 1; i < S.length(); ++i) {
    if (cap(S[i])) {
      return 0;
    }
  }
  return 1;
}

int main()
{
  ifstream cin("abbreviation.in");
  ofstream cout("abbreviation.out");
  cin.tie(nullptr);
  ios_base::sync_with_stdio(0);
  string S;
  vector<string> v;
  while (getline(cin, S)) {
      v.clear();
      split(S, v);
      /*for (auto& x : v) {
        cout << x << endl;
      }*/
      for (int i = 0; i < v.size(); ++i) {
        int n = v.size();
        if (cap_str(v[i])) {
          int j = i + 1;
          string abbr;
          abbr +=v[i][0];
          while (j + 1 < n) {
            if (v[j] == " " && cap_str(v[j + 1])) {
              abbr += v[j + 1][0];
              j += 2;
              continue;
            }
            break;
          }
          if (abbr.length() > 1) {
            cout << abbr;
            cout << " (";
            for (int z = i; z < j; ++z) {
              cout << v[z];
            }
            cout << ')';
            i = j - 1;
            continue;
          }
        }
        cout << v[i];
      }
      cout << "\n";
  }
  return 0;
}
