#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
using namespace std;

#define TASK "abbreviation" 

const int N = 100010;
int n;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	string s;
	while (getline(cin, s)) {
		bool isAb = false;
		string ab, fullAb, word;
		int low = 0, up = 0;
		for (int i = 0; i < s.length(); ++i) {
			if (s[i] == ' ') {
				if (up == 1 && low > 0 && word[0] >= 'A' && word[0] <= 'Z') {
					ab.push_back(word[0]);
					if (!fullAb.empty()) {
						fullAb += " ";
						isAb = true;
					}
					fullAb += word;
				}
				else {
					if (isAb) {
						cout << ab << " (" << fullAb << ") ";
						isAb = false;
					}
					else if (!fullAb.empty()) {
						cout << fullAb << " ";
					}
					ab.clear();
					fullAb.clear();
					cout << word << " ";
				}
				word.clear();
				low = 0;
				up = 0;
			}
			else if (s[i] == '.' || s[i] == ',') {
				if (up == 1 && low > 0 && word[0] >= 'A' && word[0] <= 'Z') {
					ab.push_back(word[0]);
					if (!fullAb.empty()) {
						fullAb += " ";
						isAb = true;
					}
					fullAb += word;
					if (isAb) {
						cout << ab << " (" << fullAb << ")";
						isAb = false;
					}
					else if (!fullAb.empty()) {
						cout << fullAb;
					}
					word.clear();
				}
				else {
					if (isAb) {
						cout << ab << " (" << fullAb << ") ";
						isAb = false;
					}
					else if (!fullAb.empty()) {
						cout << fullAb << " "; 
					}
				}
				cout << word << s[i];
				ab.clear();
				fullAb.clear();
				word.clear();
				low = 0;
				up = 0;
			}
			else if (s[i] >= 'a' && s[i] <= 'z') {
				word.push_back(s[i]);
				low++;
			}
			else if (s[i] >= 'A' && s[i] <= 'Z') {
				word.push_back(s[i]);
				up++;
			}
	}
	if (!word.empty()) {
		if (up == 1 && low > 0 && word[0] >= 'A' && word[0] <= 'Z') {
			ab.push_back(word[0]);
			if (!fullAb.empty()) {
				fullAb += " ";
				isAb = true;
			}
			fullAb += word;
			if (isAb) {
				cout << ab << " (" << fullAb << ")";
				isAb = false;
			}
			else if (!fullAb.empty()) 
				cout << fullAb; 
		}
		else {
			if (isAb) {
				cout << ab << " (" << fullAb << ") ";
				isAb = false;
			}
			else if (!fullAb.empty()) {
				cout << fullAb << " "; //////////////////////////
			}
			ab.clear();
			fullAb.clear();
			cout << word;
		}
	}
	cout << endl;
	}
return 0;
}