//#define FFFF "binary"
#define FFFF "abbreviation"
 
#include <bits/stdc++.h>
 
using namespace std;
 
#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define fore(i, l, r) for (int i = int(l); i < int(r); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define pb push_back
#define mp make_pair
#define x first
#define y second
 
typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;
 
template<typename X> inline X abs(const X &a) {return a < 0 ? -a : a;}
template<typename X> inline X sqr(const X &a) {return a * a;}
 
const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(ld(-1));
 
mt19937 mt(time(NULL));
 
const int NODES = int(1e6) + 1234;
const int N = int(5e5) + 1234;
int n;
string s[N];
char buf[N];
int tr[NODES][2];
int where[N][2];
vector<pt> v[NODES];
int nodes = 1;
int from[NODES];
 
int add(string s, int j) {
    for (char &c : s) {
        if (c == '?') {
            c = char('0' + j);
        }
    }
    int ind = 0;
    for (char cc : s) {
        int c = int(cc - '0');
        if (!tr[ind][c]) {
            tr[ind][c] = nodes++;
        }
        ind = tr[ind][c];
    }
    return ind;
}
 
void gen() {
    n = 500000;
    forn(i, n) {
        s[i] = "?";
    }
    /*n = 500;
    forn(i, n) {
        forn(j, 1000) {
            s[i] += char(mt() % 2 + '0');
        }
        s[i][mt() % 1000] = '?';
    }*/
}
 
inline bool read() {
    //gen();
   // return true;
    if (scanf("%d", &n) != 1) {
        return false;
    }
    forn(i, n) {
        scanf("%s", buf);
        s[i] = string(buf);
    }
    return true;
}
 
const int TOT = 4 * NODES + 6 * N;
 
int tot;
vector<int> g[TOT];
int revs[TOT];
int tmp[6 * NODES + 12 * N];
int *rev[TOT];
 
void addEdge(int x, int xx, int y, int yy) {
    g[(x << 1) | xx].pb((y << 1) | yy);
    assert(((x << 1) | xx) < TOT);
    assert(((y << 1) | yy) < TOT);
    xx ^= 1;
    yy ^= 1;
    g[(y << 1) | yy].pb((x << 1) | xx);
    assert(((x << 1) | xx) < TOT);
    assert(((y << 1) | yy) < TOT);
}   
 
bool used[TOT];
 
int ord[TOT], szord;
int ptr[TOT], st[TOT];
int szst;
 
inline void dfs1(int s) {
	st[szst++] = s;
	used[s] = 1;
	while (szst)
	{
		int v = st[szst - 1];
		bool f = 0;			
		while (ptr[v] < sz(g[v]))
		{
			int to = g[v][ ptr[v] ];
			ptr[v]++;
			
			if (!used[to])
			{
				f = 1;
				used[to] = 1;
				st[szst++] = to;
				break;
			}
		}
		
		if (!f && ptr[v] == sz(g[v]))
		{
			ord[szord++] = v;
			szst--;
		}
	}
    /*used[v] = true;
    for (int to : g[v]) {
        if (!used[to]) {
            dfs1(to);
        }
    }
    ord.pb(v);*/
}
 
int curCmp;
int num[TOT];
 
inline void dfs2(int s) {
	st[szst++] = s;
	used[s] = 1;
	num[s] = curCmp;
	while (szst)
	{
		int v = st[szst - 1];
		bool f = 0;
		while (ptr[v] < revs[v])
		{
			int to = rev[v][ ptr[v] ];
			ptr[v]++;
			
			if (!used[to])
			{
				used[to] = 1;
				num[to] = curCmp;
				st[szst++] = to;
				f = 1;
				break;
			}
		}
		
		if (!f && ptr[v] == revs[v])
			szst--;
	}

 /*   used[v] = true;
    num[v] = curCmp;
    for (int to : rev[v]) {
        if (!used[to]) {
            dfs2(to);
        }
    }*/
}
 
 
inline void solve() {
    memset(tr, 0, sizeof tr);
    forn(i, n) {
        forn(j, 2) {
            int pos = add(s[i], j);
            v[pos].pb(mp(i, j));
            where[i][j] = pos;
        }
    }
    int curFrom = 0;
    forn(i, nodes) {
        from[i] = curFrom;
        curFrom += sz(v[i]);
    }
    forn(i, nodes) {
        forn(j, 2) {
            if (tr[i][j] == 0) {
                continue;
            }
            addEdge(i, true, nodes + tr[i][j], false);
            addEdge(nodes + i, false, nodes + tr[i][j], false);
        }
        addEdge(nodes + i, false, i, false);
    }
    forn(i, n) {
        addEdge(2 * nodes + i, false, where[i][0], true);
        addEdge(2 * nodes + i, true, where[i][1], true);
    }
     
    int off = 2 * nodes + n;
    forn(i, nodes) {
        forn(j, sz(v[i]) - 1) {
            addEdge(2 * nodes + v[i][j].x, v[i][j].y, off + from[i] + j, false);
            addEdge(off + from[i] + j, false, off + from[i] + j + 1, false);
            addEdge(off + from[i] + j, false, 2 * nodes + v[i][j + 1].x, v[i][j + 1].y ^ 1);
        }
    }
     
    tot = 4 * nodes + 6 * n;
     
    /*forn(i, tot) {
        for (int to : g[i]) {
            cerr << i << ' ' << to << endl;
        }
    }*/

    memset(revs, 0, sizeof revs);
	forn(i, tot) {
		for (int to : g[i]) {
			++revs[to];
		}
	}
	int sum = 0;
	forn(i, tot) {
		rev[i] = tmp + sum;
		sum += revs[i];
	}
	memset(revs, 0, sizeof revs);
	forn(i, tot) {
		for (int to : g[i]) {
			rev[to][revs[to]++] = i;
		}
	}
    memset(used, 0, sizeof used);
    memset(ptr, 0, sizeof ptr);
    
    forn(i, tot) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    reverse(ord, ord + szord);
    memset(used, 0, sizeof used);
    memset(ptr, 0, sizeof ptr);    
    curCmp = 0;
    forn (i, szord) {
    	int x = ord[i];
    	
        if (used[x]) {
            continue;
        }
        curCmp++;
        dfs2(x);
    }
    for (int i = 0; i < tot; i += 2) {
        if (num[i] == num[i ^ 1]) {
            cout << "NO" << endl;
            return;
        }
    }
    cout << "YES" << endl;
    forn(i, n) {
        int node = 2 * nodes + i;
        node <<= 1;
        if (num[node] > num[node ^ 1]) {
            for (char &c : s[i]) {
                if (c == '?') {
                    c = '0';
                }
            }
        } else {
            for (char &c : s[i]) {
                if (c == '?') {
                    c = '1';
                }
            }
        }
    }
    forn(i, n) {
        printf("%s\n", s[i].c_str());
    }
}
 
int main() {
#ifdef SU2_PROJ
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
#else
    assert(freopen(FFFF ".in", "r", stdin));
    assert(freopen(FFFF ".out", "w", stdout));
#endif
     
    cout << setprecision(25) << fixed;
    cerr << setprecision(10) << fixed;
     
    assert(read());
    solve();
 
#ifdef SU2_PROJ
    cerr << "TIME: " << clock() << endl;
#endif
    return 0;
}
