#define FFFF "expect"

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define fore(i, l, r) for (int i = int(l); i < int(r); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define pb push_back
#define mp make_pair
#define x first
#define y second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X abs(const X &a) {return a < 0 ? -a : a;}
template<typename X> inline X sqr(const X &a) {return a * a;}

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(ld(-1));

mt19937 mt(time(NULL));

const int N = int(1e5) + 5;
int n, q;
char buf[N][2];
int t[N], ks[N];
li ans[N];
pt tq[N];

int kks[N];

li ft[N];

li naive(int ft) {
	queue <pt> tp, tb;
	tb.push(mp(0, ft));
	
	li res = 0;
	
	forn(i, n) {
		if (buf[i][0] == '+') {
			tb.push(mp(t[i], kks[i]));
		} else {
			tp.push(mp(t[i], kks[i]));
		}
		
		while (sz(tb) && sz(tp)) {
			pt &b = tb.front();
			pt &p = tp.front();
			
			int take = min(b.y, p.y);
			b.y -= take;
			p.y -= take;
			
			if (b.x >= p.x) {
				res += (b.x - p.x) * 1ll * take;
			}
			
			if (!b.y)
				tb.pop();
			if (!p.y)
				tp.pop();
		}
	}	
	
	if (sz(tp))
		return -1;
	
	return res;
}

inline bool read() {
/*	n = 50;
	q = n + 1;
	fore(i, 1, n + 1) {
		buf[i][0] = string("+-")[mt() & 1];
		t[i] = i + 1;
		ks[i] = (mt() & 10) + 1;
		kks[i] = ks[i];
		cerr << buf[i][0] << " " << t[i] << " " << ks[i] << endl;
	}
	
	forn(i, q)
		tq[i] = mp(i, i);
	return true;*/
	
	if (!(cin >> n >> q))
		return false;
	forn(i, n) {
		assert(scanf("%s%d%d", buf[i + 1], &t[i + 1], &ks[i + 1]) == 3);
		kks[i + 1] = ks[i + 1];
	}
	forn(i, q) {
		assert(scanf("%d", &tq[i].x) == 1);
		tq[i].y = i;
	}
	return true;
}

li st[N * 4];
li add[N * 4];

void push(int v, int l, int r) {
	st[v] += add[v];
	if (add[v] && l + 1 < r) {
		add[v * 2 + 1] += add[v];
		add[v * 2 + 2] += add[v];
	}
	add[v] = 0;
}

void inc(int v, int l, int r, int L, int R, li delta) {
	assert(l <= L && R <= r);
	push(v, l, r);
	if (l == L && r == R) {
		add[v] += delta;
		push(v, l, r);
		return;
	}
	
	int m = (l + r) >> 1;
	if (L < m)
		inc(v * 2 + 1, l, m, L, min(R, m), delta);
	if (R > m)
		inc(v * 2 + 2, m, r, max(L, m), R, delta);
		
	push(v * 2 + 1, l, m);
	push(v * 2 + 2, m, r);
	st[v] = max(st[v * 2 + 1], st[v * 2 + 2]);
}

li get(int v, int l, int r, int L, int R) {
	assert(l <= L && R <= r);
	push(v, l, r);
	if (l == L && r == R)
		return st[v];
		
	li res = -INF64;
	
	int m = (l + r) >> 1;
	if (L < m)
		res = max(res, get(v * 2 + 1, l, m, L, min(R, m)));
	if (R > m)
		res = max(res, get(v * 2 + 2, m, r, max(L, m), R));
		
	return res;
	
}

int get_first(int v, int l, int r) {
	push(v, l, r);
	if (st[v] <= 0)
		return -1;
	if (l + 1 == r)
		return l;
	int m = (l + r) >> 1;
	int res = get_first(v * 2 + 1, l, m);
	if (res != -1)
		return res;
	return get_first(v * 2 + 2, m, r);
}

inline void solve() {
	memset(st, 0, sizeof(st));	
	memset(add, 0, sizeof(add));
	
	li sum = 0;
	set <pt> s;
	n++;
	
	li cp = 0, cb = 0;
	
	fore(i, 1, n) {
		if (buf[i][0] == '-') {
			sum -= t[i] * 1ll * ks[i];
			s.insert(mp(i, ks[i]));
			cp += ks[i];
		} else {
			sum += t[i] * 1ll * ks[i];
			cb += ks[i];
		}
		inc(0, 0, n, i, n, buf[i][0] == '-' ? -ks[i] : ks[i]);
	}
	sort(tq, tq + q);
	int prev = 0;
	t[0] = 0;
	buf[0][0] = '+';
	forn(i, q) {
		int delta = tq[i].x - prev;
		
		kks[0] += delta;
		ks[0] += delta;
		cb += delta;
		sum += 0;
		inc(0, 0, n, 0, n, delta); 
		
    	while (get(0, 0, n, 0, n) > 0) {
    		/*int l = 0, r = n;
    		while (l + 1 < r) {
    			int m = (l + r) >> 1;
    			if (get(0, 0, n, 0, m) > 0)
    				r = m;
    			else
    				l = m;	
    		}*/
    		int r = get_first(0, 0, n) + 1;
    		assert(r > 0);
    		
    		li takell = get(0, 0, n, r - 1, r);
    		assert(takell <= int(1e9));
    		
    		int take = int(takell);
    		assert(take > 0);
    		auto it = s.lower_bound(mp(r - 1, -1));
    		if (it == s.end()) {
    			inc(0, 0, n, r - 1, n, -take);
    			ks[r - 1] -= take;
    			sum -= take * 1ll * t[r - 1];
    			cb -= take;
    		} else {
    			take = min(take, it->y);
    			
    			inc(0, 0, n, r - 1, n, -take);
    			ks[r - 1] -= take;			
    			sum -= take * 1ll * t[r - 1];
    			cb -= take;
    			
    			int pos = it->x;
    			s.erase(it);
    			ks[pos] -= take;
    			if (ks[pos])
    				s.insert(mp(pos, ks[pos]));
    			inc(0, 0, n, pos, n, +take);
    			sum += take * 1ll * t[pos];
    			cp -= take;
    		}
    	}
    	
    	if (cb < cp)
    		ans[tq[i].y] = -1;
    	else
    		ans[tq[i].y] = sum;
    //	cerr << tq[i].y << " ";    		
    //	cerr << naive(0) << ' ' << ans[tq[i].y] << endl;

//    	assert(naive(0) == ans[tq[i].y]);
    	
    	prev = tq[i].x;
    }
		
	forn(i, q) {
		if (ans[i] == -1) {
			puts("INFINITY");
		}
		else {
			printf("%lld\n", ans[i]);
		}
	}
}

int main() {
#ifdef SU2_PROJ
	assert(freopen("input.txt", "r", stdin));
	assert(freopen("output.txt", "w", stdout));
#else
	assert(freopen(FFFF ".in", "r", stdin));
	assert(freopen(FFFF ".out", "w", stdout));
#endif
	
	cout << setprecision(25) << fixed;
	cerr << setprecision(10) << fixed;
	
	assert(read());
	solve();

#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif
	return 0;
}