#define FFFF "foreign"

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define fore(i, l, r) for (int i = int(l); i < int(r); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define pb push_back
#define mp make_pair
#define x first
#define y second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X abs(const X &a) {return a < 0 ? -a : a;}
template<typename X> inline X sqr(const X &a) {return a * a;}

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;
const ld PI = acosl(ld(-1));

mt19937 mt(time(NULL));

const int N = int(1e6) + 5;
int n;
char s[N];

inline bool read() {
	if (scanf("%s", s) != 1)
		return false;
	n = strlen(s);
	return true;
}

ld dp[N];
int S[N];

inline void solve() {
	reverse(s, s + n);	
	dp[0] = 0;
	S[0] = 0;
	forn(i, n)
		S[i + 1] = S[i] + (s[i] == 'W');
		
	ld sumg = 0, sumb = 0;
	
	fore(i, 1, n + 1) {
		if (s[i - 1] == 'C')
			dp[i] = sumg / i + S[i];
		else
			dp[i] = sumb / i - S[i] + i;
		sumg += dp[i] - S[i];
		sumb += dp[i] - i + S[i];
		//cout << dp[i] << endl;
	}
	cout << dp[n] << endl;
}

int main() {
#ifdef SU2_PROJ
	assert(freopen("input.txt", "r", stdin));
	assert(freopen("output.txt", "w", stdout));
#else
	assert(freopen(FFFF ".in", "r", stdin));
	assert(freopen(FFFF ".out", "w", stdout));
#endif
	
	cout << setprecision(25) << fixed;
	cerr << setprecision(10) << fixed;
	
	assert(read());
	solve();

#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif
	return 0;
}