#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>
#include <cstring>

using namespace std;


#define fst first
#define snd second
#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back

template<typename T>
T abs(T x) {
	return x > 0 ? x : -x;
}

template<typename T>
T sqr(T x) {
	return x * x;
}

template<typename U, typename V>
ostream& operator << (ostream &s, const pair<U, V> &x) {
	return s << "(" << x.fst << ", " << x.snd << ")";
}

template<typename T>
ostream& operator << (ostream &s, const vector<T> &x) {
	s << "[";
	for (auto y : x) {
		s << y << ", ";
	}
	s << "]";
	return s;
}

bool isSeparator(char c) {
	return c == ' ' || c == ',' || c == '.';
}

bool isCapitalized(string s) {
	if (s.size() <= 1) return false;
	if (!isupper(s[0])) return false;
	for (int i = 1; i < (int)s.size(); i++) {
		if (isupper(s[i])) return false;
	}
	return true;
}

string toAbbr(vector<string> v) {
	if (v.empty()) return "";
	if (v.size() == 1) return v[0];
	string res;
	for (string s : v) {
		res += s[0];
	}
	res += " (";
	for (int i = 0; i < (int)v.size(); i++) {
		res += v[i];
		if (i + 1 < (int)v.size()) res += " ";
	}
	res += ")";
	return res;
}

string foo(string s) {
	vector<string> tokens;
	string tk;
	for (int i = 0; i < (int)s.size(); i++) {
		tk.push_back(s[i]);
		if (i + 1 == (int)s.size() || isSeparator(s[i]) != isSeparator(s[i + 1])) {
			tokens.push_back(tk);
			tk.clear();
		}
	}
	if (isSeparator(tokens[0][0])) {
		tokens.insert(tokens.begin(), "");
	}
	string res;
	vector<string> cap;
	for (int i = 0; i < (int)tokens.size(); i += 2) {
		if (isCapitalized(tokens[i])) {
			cap.push_back(tokens[i]);
			if (i + 1 == (int)tokens.size()) {
				res += toAbbr(cap);
				cap.clear();
				if (i + 1 < (int)tokens.size()) res += tokens[i + 1];
			}
			else if (tokens[i + 1] != " ") {
				res += toAbbr(cap);
				cap.clear();
				if (i + 1 < (int)tokens.size()) res += tokens[i + 1];
			}
			else if (i + 2 < (int)tokens.size() && !isCapitalized(tokens[i + 2])) {
				res += toAbbr(cap);
				cap.clear();
				if (i + 1 < (int)tokens.size()) res += tokens[i + 1];
			}
		}
		else {
			res += tokens[i];
			if (i + 1 < (int)tokens.size()) res += tokens[i + 1];
		}
		
	}
	return res;
}

int main() {
#ifdef LOCAL
	freopen("a.in", "r", stdin);
#else
	freopen("abbreviation.in", "r", stdin);
	freopen("abbreviation.out", "w", stdout);
#endif

	string s;

	while (getline(cin, s)) {
		s = foo(s);
		puts(s.c_str());
	}

	return 0;
}