#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>
#include <cstring>

using namespace std;


#define fst first
#define snd second
#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back

template<typename T>
T abs(T x) {
	return x > 0 ? x : -x;
}

template<typename T>
T sqr(T x) {
	return x * x;
}

template<typename U, typename V>
ostream& operator << (ostream &s, const pair<U, V> &x) {
	return s << "(" << x.fst << ", " << x.snd << ")";
}

template<typename T>
ostream& operator << (ostream &s, const vector<T> &x) {
	s << "[";
	for (auto y : x) {
		s << y << ", ";
	}
	s << "]";
	return s;
}



int main() {
#ifdef LOCAL
	freopen("a.in", "r", stdin);
#else
	freopen("expect.in", "r", stdin);
	freopen("expect.out", "w", stdout);
#endif


	int n, q;
	scanf("%d %d\n", &n, &q);

	vector<pair<ll, ll>> a;
	ll bal = 0;
	vector<pair<int, pair<ll, ll>>> ev;
	for (int i = 0; i < n; i++) {
		char type;
		int x, y;
		scanf("%c %d %d\n", &type, &x, &y);

		if (type == '-') {
			ev.pb(mp(0, mp(x, y)));
		}
		else {
			ev.pb(mp(1, mp(x, y)));
		}
	}

	for (int i = 0; i < n; i++) {
		if (ev[i].fst == 0) {
			bal += ev[i].snd.snd;
		}
		else {
			bal -= ev[i].snd.snd;
		}

		if (bal > 0) {
			if (i != n - 1) {
				a.pb(mp(bal, ev[i + 1].snd.fst - ev[i].snd.fst));
			}
		}
	}

	sort(ev.begin(), ev.end());

	bal = max(0LL, bal);
	vector<ll> sumH(a.size()), sumC(a.size());

	for (int i = (int)a.size() - 1; i >= 0; i--) {
		sumH[i] = a[i].fst * a[i].snd;;
		if (i + 1 < a.size()) {
			sumH[i] += sumH[i + 1];
		}

		sumC[i] = a[i].snd;
		if (i + 1 < a.size()) {
			sumC[i] += sumC[i + 1];
		}
	}

	for (int i = 0; i < q; i++) {
		int x;
		scanf("%d", &x);

		if (x < bal) {
			printf("INFINITY\n");
		}
		else {
			auto id = lower_bound(a.begin(), a.end(), pair<ll, ll>(x, -1e18)) - a.begin();

			if (id < a.size()) {
				printf("%lld\n", sumH[id] - x * 1LL * sumC[id]);
			}
			else {
				printf("0\n");
			}
		}
	}

	

	return 0;
}