#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>
#include <cstring>

using namespace std;


#define fst first
#define snd second
#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back

template<typename T>
T abs(T x) {
	return x > 0 ? x : -x;
}

template<typename T>
T sqr(T x) {
	return x * x;
}

template<typename U, typename V>
ostream& operator << (ostream &s, const pair<U, V> &x) {
	return s << "(" << x.fst << ", " << x.snd << ")";
}

template<typename T>
ostream& operator << (ostream &s, const vector<T> &x) {
	s << "[";
	for (auto y : x) {
		s << y << ", ";
	}
	s << "]";
	return s;
}

/////////////////////////////////////////////////

int main() {
#ifdef LOCAL
	freopen("a.in", "r", stdin);
#else
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);
#endif

	string s;
	cin >> s;
	int n = (int)s.length();
	ld sum = 0, sumbad = 0, sumgood = 0;
	ld ans = 0;
	for (int i = n - 1; i >= 0; i--) {
		ld x = sum;
		if (s[i]== 'C') {
			x += sumbad;
			sumgood += (n - i);
		}
		else {
			x += sumgood;
			sumbad += (n - i);
		}
		ans = x / (n - i);
		sum += ans;
	}
	cout.precision(10);
	cout << fixed << ans << "\n";

	return 0;
}