#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>
#include <cstring>

using namespace std;


#define fst first
#define snd second
#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back

template<typename T>
T abs(T x) {
	return x > 0 ? x : -x;
}

template<typename T>
T sqr(T x) {
	return x * x;
}

template<typename U, typename V>
ostream& operator << (ostream &s, const pair<U, V> &x) {
	return s << "(" << x.fst << ", " << x.snd << ")";
}

template<typename T>
ostream& operator << (ostream &s, const vector<T> &x) {
	s << "[";
	for (auto y : x) {
		s << y << ", ";
	}
	s << "]";
	return s;
}

/////////////////////////////////////////////////

const int maxn = 5005;
ll l[maxn], r[maxn], cnt[maxn], sum[maxn];
bool used[maxn][maxn];

int main() {
#ifdef LOCAL
	freopen("a.in", "r", stdin);
#else
	freopen("jenga.in", "r", stdin);
	freopen("jenga.out", "w", stdout);
#endif

	int n, w;
	cin >> n >> w;
	int h, m;
	cin >> h >> m;
	ll all = 0;
	for (int i = 1; i <= n; i++) {
		all += i * 2 - 1;
	}
	for (int i = 1; i <= h; i++) {
		cnt[i] = n;
		l[i] = 1;
		r[i] = n;
		sum[i] = all;
	}
	for (int t = 1; t <= m; t++) {
		int level, k;
		cin >> level >> k;
		cnt[level]--;
		sum[level] -= k * 2 - 1;
		used[level][k] = true;
		while (l[level] <= n && used[level][l[level]]) {
			l[level]++;
		}
		while (r[level] >= 1 && used[level][r[level]]) {
			r[level]--;
		}
		
		vector < ll > ss(2), cc(2);

		bool flag = true;
		for (int i = h; i >= 1; i--) {
			ll cursum = ss[i & 1] + cc[1 - (i & 1)] * n;
			ll curcnt = cc[0] + cc[1];
			ll lower = (l[i] - 1) * 2ll * curcnt, upper = (r[i]) * 2ll * curcnt;
			if (curcnt > 0 && (cursum <= lower || cursum >= upper)) {
				flag = false;
				//cout << i << "\n";
				break;
			}
			
			ss[i & 1] += sum[i];
			cc[i & 1] += cnt[i];
		}
		if (!flag) {
			cout << "yes\n" << t << "\n";
			return 0;
		}
	}
	cout << "no\n";

	return 0;
}