#include<fstream>
#include<string>
#include<iomanip>
#include<vector>
using namespace std;


int main() {
	ifstream in("foreign.in");
	ofstream out("foreign.out");

	string s;
	in >> s;
	int n = s.size();

	vector<double> p(n, 0.0);
	p[0] = 1.0;
	double toAdd = 0.0;

	double pSwap = 0.0;
	double pSwapReduce = 0.0;

	double result = 0;

	for(int i=0;i<n;i++) {
		p[i] += toAdd;
		toAdd += p[i] / (n-i);

		if(s[i] == 'W') {
			pSwap += (p[i]);
			pSwapReduce += (p[i]) / (n-i);

			result += (1-pSwap);
		}
		else
			result += pSwap;

		

		pSwap -= pSwapReduce;
	}

	out << fixed << setprecision(9) << result << '\n';

	return 0;
}