#include<fstream>
#include<string>
#include<iomanip>
#include<vector>
using namespace std;
typedef long long ll;

ll n, w, h,m;

struct fen{
	vector<ll> arr;
	fen(){
	}
	fen(int siz){
		arr.resize(siz+5);
	}
	void update(ll l, ll val){
		l = (h / 2 + 3) - l + 1;
		while(l<arr.size()){
			arr[l]+= val;
			l += l&(-l);
		}
	}
	ll query(ll l){
		ll val = 0;
		l = (h/2+3) - l + 1;
		while (l > 0){
			val += arr[l];
			l -= l&(-l);
		}
		return val;
	}
};


int main() {
	ifstream fin("jenga.in");
	ofstream fout("jenga.out");
	fin>>n>>w;
	fin>>h>>m;
	vector<fen> cf(2, fen(h/2));
	vector<vector<fen> > pm(2, vector<fen>(n+1, fen(h/2)));
	vector<vector<bool> > blocks(h + 5, vector<bool>(n, true));
	vector<ll> fir(h+5, 0), las(h+5, n-1);
	for (ll l = h; l > 0; --l){
		cf[l & 1].update(l / 2, n);
	}
		for (ll x = 0; x <= n; ++x){
			for (ll l = h; l > 0; --l){
			pm[l & 1][x].update(l / 2, (n-2*x)*n);
		}
	}
	for (int i=1; i<=m; ++i){
        ll li,ki;
        fin>>li>>ki;
        --ki;
		cf[li & 1].update(li / 2, -1);
		for (ll x = 0; x <= n; ++x){
			pm[li & 1][x].update(li / 2, 2*x-2*ki-1);
		}
		blocks[li][ki] = false;
		while (fir[li]<n && blocks[li][fir[li]]){
			++fir[li];
		}
		if (fir[li] == n){
			fout << "yes\n"<<i<<"\n";
            return 0;
		}
		while (las[li]>=0 && blocks[li][las[li]]){
			--las[li];
		}
		for (ll l = 1; l <= li; ++l){
			if (pm[l & 1][fir[l]].query((l + 2) / 2) + cf[(l + 1) & 1].query((l + 1) / 2)*(n - 2 * fir[l]) <= 0){
				fout << "yes\n" << i << "\n";
				return 0;
			}
			if (pm[l & 1][las[l]+1].query((l + 2) / 2) + cf[(l + 1) & 1].query((l + 1) / 2)*(n - 2 * las[l]) >= 0){
				fout << "yes\n" << i << "\n";
				return 0;
			}
		}
		fout << "no\n";
		return 0;

	}
}