#include <cstdio>
#include <vector>
#include <set>
#include <iostream>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <memory.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define FILE_NAME "abbreviation"

#define forn(i, n) for (int i = 0; i < (int) n; ++i)
#define ford(i, n) for (int i = (int) n - 1; i >= 0; --i)
#define pb push_back
#define mp(x, y) make_pair(x, y)
#define sz(c) ((int) (c).size())
#define all(c) (c).begin(), (c).end()
#define fst first 
#define snd second

int n;

bool isletter(char c) {
  return isalpha(c);
}

string skip(int& i, const string& s) {
  string res;
  while (i < sz(s) && !isletter(s[i])) {
    res += s[i];
    ++i;
  }
  return res;
}

string get_w(int& i, const string& s) {
  string res;
  while (i < sz(s) && isletter(s[i])) {
    res += s[i];
    ++i;
  }
  return res;
}

bool capitalized(const string& s) {
  if (sz(s) <= 1) {
    return 0;
  }
  if  (!isupper(s[0])) {
    return 0;
  }
  for (int i = 1; i < sz(s); ++i) {
    if  (!islower(s[i])) {
      return 0;
    }
  }
  return 1;
}

bool read() {
  string s;
  while (getline(cin, s)) {
    string res;
    int i = 0;
    while (i < sz(s)) {
      auto was = skip(i, s);
      res += was;
      // find abbr
      int j = i;
      vector<string> ws;              
      {
        bool start = 1;
        while (j < sz(s)) {
          int old = j;
          auto was = skip(j, s);
//          printf("was = |%s|\n", was.data());
          if  (was != " " && !start) {
            j = old;
            break;
          }
          start = 0;
          string w = get_w(j, s);
          if (!capitalized(w)) {
            j = old;
            break;
          }
          ws.pb(w);
        }
      }

//      printf("j = %d, sz = %d\n", j, sz(ws));

      if  (sz(ws) <= 1) {
        j = i;
        ws.clear();
      }

      if (!ws.empty()) {
        string abbr;
        for (auto w : ws) {
          abbr += w[0];
        }

        res += abbr;
        res += " ";
        res += "(";
        forn(k, sz(ws)) {
          res += ws[k];
          if  (k + 1 < sz(ws)) {
            res += " ";
          }
        }
        res += ")";
      }
      if  (j == i) {
        res += skip(i, s);
        res += get_w(i, s);
      } else {
        i = j;
      }
    }
    cout << res << "\n";
//    return 1;
  }
  return 1;
}

void solve() {

}

int main() {
#ifdef LOCAL
  freopen(FILE_NAME ".in", "r", stdin);
//  freopen(FILE_NAME ".out", "w", stdout);
#else 
  freopen(FILE_NAME ".in", "r", stdin);
  freopen(FILE_NAME ".out", "w", stdout);
#endif

  while (read()) {
    solve();

    break;
  }

  return 0;
}
