#include <cstdio>
#include <vector>
#include <set>
#include <iostream>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <cstring>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define FILE_NAME "foreign"

#define forn(i, n) for (int i = 0; i < (int) n; ++i)
#define ford(i, n) for (int i = (int) n - 1; i >= 0; --i)
#define pb push_back
#define mp(x, y) make_pair(x, y)
#define sz(c) ((int) (c).size())
#define all(c) (c).begin(), (c).end()

int n;
char a[(int)1e6 + 5];
bool read() {
  if  (scanf("%s", a) < 1) {
    return 0;
  }
  
  //assert((int)strlen(a) == n);
  n = strlen(a);
  return 1;
}

typedef long double ld;
ld dp[(int)1e6+5];
ld s[(int)1e6+5];
void solve() {
   s[0] = 0;
   for (int i = 0; i < n; i++) {
      s[i+1] = s[i] + (a[i]=='W'?1.:0.);
   //   cout << "s[" << i << "] = " << s[i] << endl;
   }
   dp[n] = 0;
   ld sumdp = 0;
   ld sums = s[n];
   for (int i = n-1; i >= 0; i--) {
      dp[i] = 1./ld(n-i) * ((a[i] == 'C'?sums - (ld)(n-i)*s[i]:ld(n-i)*ld(n-i+1)/2. - sums + (ld)(n-i)*s[i]) + sumdp);
    //  dp[i] = 0;
    //  for (int j = i+1; j <= n; j++)
    //     dp[i] += 1./ld(n-i) * ((a[i] == 'W'?(ld(j-i)-s[j]+s[i]):s[j] - s[i]) + dp[j]);
    //  cout << "dp[" << i << "] = " << dp[i] << endl;
      sums += s[i];
      sumdp += dp[i];
   }
   cout.precision(20);
   cout << fixed << dp[0] << endl; 
}

int main() {
#ifdef LOCAL
  //freopen(FILE_NAME ".in", "r", stdin);
  //freopen(FILE_NAME ".out", "w", stdout);
#else 
  freopen(FILE_NAME ".in", "r", stdin);
  freopen(FILE_NAME ".out", "w", stdout);
#endif

  while (read()) {
    solve();
  }

  return 0;
}
