#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <string>
#include <list>
#include <sstream>

using namespace std;



#define INF 2000000000


void solve();
void solve2();
void solve3();
int main()
{
	solve();
}
#define int long long

bool big(char c)
{
	return c>='A'&&c<='Z';
}
bool small(char c)
{
	return c>='a'&& c<='z';
}
string s; 
int n;
bool good(int pos)
{
	if (!big(s[pos]))
		return false;
	pos++;
	if (pos == n ||!small(s[pos]))
		return false;
	
	while (pos < n && small(s[pos]))
		pos++;
	if (pos < n && big(s[pos]))
		return false;
	return true;
}
void solve()
{
#ifndef HOME
	string task = "abbreviation";
	ifstream cin(task + ".in");
	ofstream cout(task + ".out");
#else
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#endif

	while (getline(cin, s))
	{
		string res = "";
		string abb = "";
		n = s.size();
		for (int i = 0; i < n; i++)
		{
			if (good(i))
			{
				abb += s[i];
				res += s[i];
				i++;
				while (i < n && small(s[i]))
				{
					res += s[i];
					i++;
				}
				
				if (i < n - 1 && s[i] == ' ' && good(i+1))
				{
					res += s[i];
					continue;
				}
				else
				{

					i--;
					if (abb.size() == 1)
						cout << res;
					else
						cout << abb << " (" << res << ")";
					res = "";
					abb = "";
				}
			}
			else
			{
				abb = "";
				res = "";
				bool ok = false;
				while (i<n&& (big(s[i])||small(s[i])))
				{
					cout << s[i];
					i++;
				}
				cout << s[i];
				
			}
		}
		cout << endl;
	}





	cout << endl;
#ifdef HOME
	system("pause");
#endif

}


void solve2()
{
#ifndef HOME
	string task = "hard";
	ifstream cin(task + ".in");
	ofstream cout(task + ".out");
#else
	ifstream cin("input.txt");
#endif

	
	bool isleft = false,
		isright = false;
	int left = -INF,
		right = INF;

	vector <pair <int, int> > a;
	while (1)
	{
		string s;
		getline(cin, s);

		if (s.find("&&") != string::npos)
		{
			int p = s.find(">=") + 3;
			string n1;
			while ('0' <= s[p] && s[p] <= '9' || s[p] == '-')
				n1 += s[p++];

			p = s.find("<=") + 3;
			string n2;
			while ('0' <= s[p] && s[p] <= '9' || s[p] == '-')
				n2 += s[p++];

			int l, r;

			stringstream ss;
			ss << n1;
			ss >> l;

			stringstream ss2;
			ss2 << n2;
			ss2 >> r;

			if (l <= r)
				a.push_back(make_pair(l, r));
		}
		else
		{
			if (s.find("<=") != string::npos)
			{
				int p = s.find("<=") + 3;
				string n1;
				while ('0' <= s[p] && s[p] <= '9' || s[p] == '-')
					n1 += s[p++];

				isleft = true;
				int tmp;

				stringstream ss;
				ss << n1;
				ss >> tmp;

				left = max(left, tmp);
			}
			else
			{
				int p = s.find(">=") + 3;
				string n1;
				while ('0' <= s[p] && s[p] <= '9' || s[p] == '-')
					n1 += s[p++];

				isright = true;
				int tmp;

				stringstream ss;
				ss << n1;
				ss >> tmp;

				right = min(right, tmp);
			}
		}
	
		if (s.find("||") == string::npos)
			break;
	}

	if (a.size() == 0 && !isleft && !isright)
		cout << "false";
	else
	{
		sort(a.begin(), a.end());

		list <pair <int, int> > b;

		for (int i = 0; i < a.size();)
		{
			int j = i + 1;

			while (j < a.size() &&
				a[i].first <= a[j].first && a[j].first <= a[i].second + 1)
			{
				a[i].second = max(a[i].second, a[j].second);
				j++;
			}

			b.push_back(a[i]);
			i = j;
		}

		while (isleft && b.size() > 0 &&
			(b.front().first - 1 <= left && left <= b.front().second))
		{
			left = b.front().second;
			b.pop_front();
		}

		while (isright && b.size() > 0 &&
			(b.back().first <= right && right <= b.back().second + 1))
		{
			right = b.back().first;
			b.pop_front();
		}

		if (isleft && left == 32767 ||
			isright && right == -32768 ||
			b.size() > 0 && b.front().first == -32768 && b.front().second == 32767 ||
			isleft && isright && left >= right - 1)
			cout << "true";
		else
		{
			vector <string> ans;
			if (isleft)
			{
				stringstream ss;
				ss << "x <= " << left << " ||";

				string s;
				getline(ss, s);
				ans.push_back(s);
			}
			if (isright)
			{
				stringstream ss;
				ss << "x >= " << right << " ||";

				string s;
				getline(ss, s);
				ans.push_back(s);
			}

			for (auto it : b)
			{
				stringstream ss;
				ss << "x >= " << it.first << " && x <= " << it.second << " ||";

				string s;
				getline(ss, s);
				ans.push_back(s);
			}

			for (int i = 0; i < 3; i++)
				ans.back().pop_back();

			for (auto it : ans)
				cout << it << endl;
		}

	}




	cout << endl;
#ifdef HOME
	system("pause");
#endif

}



void solve3()
{
#ifndef HOME
	string task = "foreign";
	ifstream cin(task + ".in");
	ofstream cout(task + ".out");
#else
	ifstream cin("input.txt");
#endif

	//string s;
	cin >> s;
	int n = s.size();
	double* a = new double[n + 1];
/*	int* w = new int[n];
	w[n - 1] = (s[n - 1] == 'W');
	for (int i = n - 2; i >= 0; i--)
		w[i] = w[i + 1] + (s[i] == 'W');
	int* err = new int[n];*/
	double t[2];
	t[0] = t[1] = 0;
	double sum = 0;
	a[0] = 1;
	a[1] = 0;
	for (int i = 2; i <= n; i++)
	{
			a[i] = sum / i;
			if (s[i - 1] == 'S')
				t[0] += a[i];
			else
				t[1] += a[i];
	}
	cout << fixed << setprecision(10) << a[n];
#ifdef HOME
	system("pause");
#endif

}
