#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <string>
#include <list>
#include <sstream>

using namespace std;



#define INF 2000000000


void solve();
void solve3();
int main()
{
	solve();
}
#define int long long

void solve()
{
#ifndef HOME
	string task = "hard";
	ifstream cin(task + ".in");
	ofstream cout(task + ".out");
#else
	ifstream cin("input.txt");
#endif

	
	bool isleft = false,
		isright = false;
	int left = -INF,
		right = INF;

	vector <pair <int, int> > a;
	while (1)
	{
		string s;
		getline(cin, s);

		int l, r;
		if (s.find("&&") != string::npos)
		{
			int p = s.find(">=") + 3;
			string n1;
			while ('0' <= s[p] && s[p] <= '9' || s[p] == '-')
				n1 += s[p++];

			p = s.find("<=") + 3;
			string n2;
			while ('0' <= s[p] && s[p] <= '9' || s[p] == '-')
				n2 += s[p++];


			stringstream ss;
			ss << n1;
			ss >> l;

			stringstream ss2;
			ss2 << n2;
			ss2 >> r;
		}
		else
		{
			if (s.find("<=") != string::npos)
			{
				int p = s.find("<=") + 3;
				string n1;
				while ('0' <= s[p] && s[p] <= '9' || s[p] == '-')
					n1 += s[p++];

				stringstream ss;
				ss << n1;
				ss >> r;

				l = -INF;
			}
			else
			{
				int p = s.find(">=") + 3;
				string n1;
				while ('0' <= s[p] && s[p] <= '9' || s[p] == '-')
					n1 += s[p++];

				stringstream ss;
				ss << n1;
				ss >> l;

				r = INF;
			}
		}

		if (l <= r)
			a.push_back(make_pair(l, r));

		if (s.find("||") == string::npos)
			break;
	}

	if (a.size() == 0)
		cout << "false";
	else
	{
		sort(a.begin(), a.end());

		list <pair <int, int> > b;

		for (int i = 0; i < a.size();)
		{
			int j = i + 1;

			while (j < a.size() && a[j].first <= a[i].second + 1)
			{
				a[i].second = max(a[i].second, a[j].second);
				j++;
			}

			b.push_back(a[i]);
			i = j;
		}

		if (b.size() == 1 && b.front().first <= -32768 && b.front().second >= 32767)
			cout << "true";
		else
		{
			vector <string> ans;

			for (auto it : b)
			{
				stringstream ss;

				if (it.first <= -32768)
					ss << "x <= " << it.second << " ||";
				else if (it.second >= 32767)
					ss << "x >= " << it.first << " ||";
				else
					ss << "x >= " << it.first << " && x <= " << it.second << " ||";

				string s;
				getline(ss, s);
				ans.push_back(s);
			}

			for (int i = 0; i < 3; i++)
				ans.back().pop_back();

			for (auto it : ans)
				cout << it << endl;
		}

	}




	cout << endl;
#ifdef HOME
	system("pause");
#endif

}



void solve3()
{
#ifndef HOME
	string task = "foreign";
	ifstream cin(task + ".in");
	ofstream cout(task + ".out");
#else
	ifstream cin("input.txt");
#endif

	string s;
	cin >> s;
	int n = s.size();
	double* a = new double[n + 1];
/*	int* w = new int[n];
	w[n - 1] = (s[n - 1] == 'W');
	for (int i = n - 2; i >= 0; i--)
		w[i] = w[i + 1] + (s[i] == 'W');
	int* err = new int[n];*/
	double t[2];
	t[0] = t[1] = 0;
	double sum = 0;
	a[0] = 1;
	a[1] = 0;
	for (int i = 2; i <= n; i++)
	{
			a[i] = sum / i;
			if (s[i - 1] == 'S')
				t[0] += a[i];
			else
				t[1] += a[i];
	}
	cout << fixed << setprecision(10) << a[n];
#ifdef HOME
	system("pause");
#endif

}
