#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
#include <sstream>
#include <algorithm>
using namespace std;

#define mp(x, y) make_pair(x, y)

typedef pair<int, int> pii;

void solve()
{
	string s;
	vector<pii> segments;
	const int MINX = -32768;
	const int MAXX = 32767;
	while (getline(cin, s))
	{
		if (s.back() == '|')
			s = s.substr(0, s.size() - 3);
		int posAnd = -1;
		for(int i=0; i<s.size(); ++i)
			if (s[i] == '&')
			{
				posAnd = i;
				break;
			}
		if (posAnd == -1)
		{
			stringstream ss(s.substr(5));
			int b;
			ss >> b;
			if (s[2] == '<')
				segments.push_back(mp(MINX, b));
			else segments.push_back(mp(b, MAXX));
		}
		else
		{
			stringstream ss(s.substr(5));
			int l;
			ss >> l;
			stringstream ss2(s.substr(posAnd + 8));
			int r;
			ss2 >> r;
			if (l > r)
			{
				cout << "false" << endl;
				return;
			}
			segments.push_back(mp(l, r));
		}
	}
	
	vector<pii> res;
	sort(segments.begin(), segments.end());
	int curStart = segments[0].first;
	int curEnd = segments[0].second;
	for (int i = 1; i < segments.size(); ++i)
	{
		if (segments[i].first <= curEnd+1)
			curEnd = max(curEnd, segments[i].second);
		else
		{
			res.push_back(mp(curStart, curEnd));
			curStart = segments[i].first;
			curEnd = segments[i].second;
		}
	}
	res.push_back(mp(curStart, curEnd));
	if (res.size() == 1 && res[0].first == MINX && res[0].second == MAXX)
		cout << "true" << endl;
	else
	{
		for (int i = 0; i < (int)res.size() - 1; i++) {
			if (res[i].first == MINX)
				cout << "x <= " << res[i].second << " ||" << endl;
			else if (res[i].second == MAXX)
				cout << "x >= " << res[i].first << " ||" << endl;
			else cout << "x >= " << res[i].first << " && x <= " << res[i].second << " ||" << endl;
		}
		if (res.back().first == MINX)
			cout << "x <= " << res.back().second << endl;
		else if (res.back().second == MAXX)
			cout << "x >= " << res.back().first  << endl;
		else cout << "x >= " << res.back().first << " && x <= " << res.back().second  << endl;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("hard.in", "r", stdin);
	freopen("hard.out", "w", stdout);
#endif
	solve();
	return 0;
}