#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
using namespace std;

const int MAXN = 1000100;

string s;

double d[MAXN], sum[MAXN];
double f[MAXN], rf[MAXN];

int main() {
	freopen("foreign.in", "r", stdin);
	freopen("foreign.out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cin >> s;
	reverse(s.begin(), s.end());
	for (int i = 0; i < s.size(); ++i) {
		if (i == 0) {
			if (s[i] == 'C') {
				f[i] = 1;
				rf[i] = 0;
			}
			else {
				f[i] = 0;
				rf[i] = 1;
			}
			continue;
		}

		if (s[i] == 'C') {
			f[i] = f[i - 1] + i + 1;
			rf[i] = rf[i - 1];
		}
		else {
			f[i] = f[i - 1];
			rf[i] = rf[i - 1] + i + 1;
		}
	}

	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == 'C') {
			d[i + 1] = 1.0 / (i + 1) * (sum[i] + rf[i]);
		}
		else {
			d[i + 1] = 1.0 / (i + 1) * (sum[i] + f[i]);
		} 
		sum[i + 1] = sum[i] + d[i + 1];
	}

	printf("%.12lf\n", d[s.size()]);
}