#include <stdio.h>
#include <iostream>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

bool ok(string s) {
	if (s.size() < 2) return false;
	if (!isupper(s[0])) return false;

	for (int i = 1; i < (int)s.size(); i++)
		if (!islower(s[i])) return false;

	return true;
}

bool ok(char c) {
	return c == ' ';
}

void check(int cnt, string s) {
	if (cnt < 2) {
		cout << s;
		return;
	};

	for (int i = 0; i < (int)s.length(); i++)
		if (isupper(s[i])) cout << s[i];

	cout << " (";

	int i = 0, j = (int)s.size() - 1;
	while (!isalpha(s[i])) i++;
	while (!isalpha(s[j])) j--;

	for (int k = i; k <= j; k++)
		cout << s[k];	
	cout << ")";

	for (int k = j + 1; k < (int)s.size(); k++)
		cout << s[k];
}

int main() {
	#ifdef RSATU2
	freopen("in.txt", "rt", stdin);
	freopen("out.txt", "wt", stdout);
	#else
	#define FILENAME "abbreviation"
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
	#endif

	string s; 

	while (getline(cin, s)) {
		int cnt = 0;
		string abbreviation = "";
		string word = "";

		s += '\n';

		for (int i = 0; i < (int)s.size(); i++) {
			if (isalpha(s[i])) 
				word += s[i]; 
			else {
				if (ok(word) && ok(s[i])) {
					abbreviation += word + s[i];
					cnt += 1;
				} else {
					if (ok(word)) {
						abbreviation += word;
						cnt += 1;
						word = "";
					}

					check(cnt, abbreviation);
					abbreviation = "";
					cnt = 0;

					cout << word << s[i];
				}

				word = "";
			}
		}
	}

	return 0;
}