#include <stdio.h>
#include <iostream>
#include <string>
#include <sstream>
#include <vector>
#include <map>
#include <iomanip>
#include <set>

using namespace std;

struct Item {
	long long x;
	long long cnt;
	long long val;

	Item(long long x, long long cnt): x(x), cnt(cnt) {
		val = cnt * -x;
	}
};

int n, q;

map<long long, long long> heap;

vector<Item> items;

int main() {
	#ifdef RSATU2
	freopen("in.txt", "rt", stdin);
	freopen("out.txt", "wt", stdout);
	#else
	#define FILENAME "expect"
	freopen(FILENAME".in", "r", stdin);
	freopen(FILENAME".out", "w", stdout);
	#endif

	cin >> n >> q;

	int lt = 0;
	int la = 0;

	for (int i = 0; i < n; i++) {
		string c; int t, a;
		cin >> c >> t >> a;

		if (c == "-")
			a = -a;

		long long dt = t - lt;
		lt = t;
		la += a;

		heap[la] += dt;
	}

	map<long long, long long>::iterator it;
	for (it = heap.begin(); it != heap.end(); it++) {
		long long x = it->first;
		long long cnt = it->second;

		items.push_back(Item(x, cnt));
	}

	for (int i = 1; i < (int)items.size(); i++) {
		items[i].val += items[i - 1].val;
		items[i].cnt += items[i - 1].cnt;
	}

	for (int i = 0; i < q; i++) {
		long long x; cin >> x; 
		x = -x;

		if (x > la) {
			cout << "INFINITY" << endl;
			continue;
		}

		if (x < items[0].x) {
			cout << 0 << endl;
			continue;
		}

		int l = 0;
		int r = (int) items.size();

		while (r - l > 1) {
			int lr = (l + r) >> 1;
			if (items[lr].x <= x)
				l = lr; else r = lr;
		}

		long long ans = items[l].val;
		ans += items[l].cnt * x;

		cout << ans << endl;
	}

	return 0;
}