#define FNAME "jenga"

#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < (n); i++)
#define fornr(i, n) for (int i = (n) - 1; i >= 0; i--)
#define forab(i, a, b) for (int i = (a); i < (b); i++)
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long LL;
typedef LL ll;
typedef unsigned long long ULL;
typedef ULL ull;
typedef pair <int, int> pii;
typedef vector <int> vi;

const int MAXN = 5e3 + 10;
const double eps = 1e-11;

double sumX[MAXN], sumY[MAXN];
set <int> Set[MAXN];
int n, w, h, m;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen(FNAME".in", "r", stdin);
    freopen(FNAME".out", "w", stdout);


    scanf("%d%d%d%d", &n, &w, &h, &m);
    forn(i, h) {
        forn(j, n)
            Set[i].insert(j), sumX[i] += w * j + w / 2.0, sumY[i] += n * w / 2.0;
    } 

    forn(i, m) {
        int x, y;
        scanf("%d%d", &x, &y);
        x--, y--;
        Set[x].erase(y);
        sumX[x] -= w * y + w / 2.0;
        sumY[x] -= n * w / 2.0;
        double sX = 0, sY = 0;
        int cnt = 0;
        fornr(level, h) {
            double s1X = sX, s1Y = sY;
            if (level % 2 == 1) {
                s1X = s1Y, s1Y = 1.0 * n * w * cnt - s1X;
            }
            if (cnt) {
                s1X /= cnt, s1Y /= cnt;
//                printf("s1X=%f s1Y=%f minX=%f maxX=%f\n", s1X, s1Y, *Set[level].begin() * w + eps, (*(--Set[level].end()) + 1) * w - eps);
                if (Set[level].size() == 0 || s1X < *Set[level].begin() * w + eps || s1X > (*(--Set[level].end()) + 1) * w - eps) {
                    printf("yes\n%d\n", i + 1);
                    return 0;
                }
            }
            cnt += Set[level].size();
            if (level % 2 == 0) {
                sX += sumX[level], sY += sumY[level];
            } else {
                sX += sumY[level], sY += 1.0 * n * w * Set[level].size() - sumX[level];
            }
        }
    }
    puts("no");
    return 0;
}
