#define FNAME "list"

#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < (n); i++)
#define fornr(i, n) for (int i = (n) - 1; i >= 0; i--)
#define forab(i, a, b) for (int i = (a); i < (b); i++)
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long LL;
typedef LL ll;
typedef unsigned long long ULL;
typedef ULL ull;
typedef pair <int, int> pii;
typedef vector <int> vi;

const int CNT = 1150;
const int MAX_W = 1e4;
const LL INF = 3e18;

inline string toString(int x) {
    string t;
    while (x) 
        t += (char) (x % 10 + '0'), x /= 10;
    reverse(all(t));
    return t;
}

inline int getLen(int x) {
    int len =0 ;
    while (x) x /= 10, len++;
    return len;
}

inline LL add(LL x, LL y) {
    return x + y < INF ? x + y : INF;
}

inline LL mul(LL x, LL y) {
    if (y == 0) return 0;
    return x < INF / y ? x * y : INF;
}

int ignoreFirst;
vi primes;
LL sumLen[CNT][MAX_W], sumCnt[CNT][MAX_W], sumLenSuff[CNT][MAX_W], sumCntSuff[CNT][MAX_W];
vector<vi> ans;
vi Set;

string toString(const vi &v) {
    if (v.size() == 0) {
        return "";
    }
    string res = "[";
    for (int i = 0; i < (int) v.size() - 1; i++) {
        res += toString(v[i]) + ", ";
    }
    res += toString(v.back()) + "]";
    return res;
}

int found = 0, ignored = 0;

void go(LL &A, LL &B, int pos, int w) {
    assert(w >= 0);
    if (B < 0)
        return;
//    if (!w && found) assert(A < toString(Set).length());
    int len = toString(Set).length();
    if (!w && found && A >= len + 2) {
        A -= len + 2;
        return;
    }
    if (!w && found && A < len + 2 && B >= 0) {
        if (!ignored) {
            ignoreFirst = A;
            ignored = 1;
            B += A;
            A = 0;
        }
        if (Set.size()) {
    //        cerr << B << endl;
            ans.pb(Set);
            B -= len + 2;
        }
        return;
    }
//    cerr << A << " " << B << " " << pos << " " << w << endl;
    forab(i, pos, CNT) {
        if (primes[i] > w) break;
        if (sumLen[i][w] == 0) continue;
        LL sum = sumLen[i][w] + 2 * (sumCnt[i][w]) + sumCnt[i][w] * (toString(Set).length());

        if (sum <= A) {
  //          cerr << primes[i] << " " << sumLen[i][w] << " " << sumCnt[i][w] << endl;
            A -= sum;
            continue;
        } else if (!found && sum > A) {
            found = 1;
        }
        if (found) {
            Set.pb(primes[i]);
            go(A, B, i + 1, w - primes[i]);
            Set.pop_back();
        }
    }    
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen(FNAME".in", "r", stdin);
    freopen(FNAME".out", "w", stdout);

    LL A, B;
    scanf("%lld%lld", &A, &B);
            
    forab(i, 2, 10000) {
        if (primes.size() == CNT) break;
        int ok = 1;
        forab(j, 2, i) {
            if (i % j == 0) {
                ok = 0;
                break;
            }

        }
        if (ok) primes.pb(i);
    }
    cerr << primes.back() << endl;

    fornr(i, CNT) {
        forab(w, primes[i], MAX_W) {
                sumLen[i][w] = add(sumLen[i][w], sumLenSuff[i + 1][w - primes[i]]);
                sumLen[i][w] = add(sumLen[i][w], mul(getLen(primes[i]) + 2, sumCntSuff[i + 1][w - primes[i]]));
                sumCnt[i][w] = add(sumCnt[i][w], sumCntSuff[i + 1][w - primes[i]]);
        }
        sumLen[i][primes[i]] = add(sumLen[i][primes[i]], 2 + getLen(primes[i]));
        sumCnt[i][primes[i]] = add(sumCnt[i][primes[i]], 1);
    
        forn(w, MAX_W) {
            sumLenSuff[i][w] = add(sumLenSuff[i + 1][w], sumLen[i][w]);
            sumCntSuff[i][w] = add(sumCntSuff[i + 1][w], sumCnt[i][w]);
        }
    } 
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
//    cerr << getLen(2) << " " << sumLen[0][7] << endl;
    A--, B--;
    B -= A;
    int cnt = (int) B;
    forn(w, MAX_W) {
        go(A, B, 0, w);
    }
    string res;
    for (auto x: ans) {
        res += toString(x) + ", ";
    }
//    printf("%d %s\n", ignoreFirst, res.c_str());
    forab(i, ignoreFirst, ignoreFirst + cnt + 1)
        printf("%c", res[i]);
    puts("");
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
    return 0;
}
