#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef long long i64;
#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define sz(x) ((int) (x).size())

#define NAME "expect"
#define prev mamky_ebal_stl_hui

const int M = 100100;

struct Seg {
    ll x, l, r;
};

vector<Seg> s;
int n, q;
ll ss[M], slen[M], sx[M];
ll last = 0;
ll prev = 0;

void read() {
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        char ch;
        int t, k;
        cin >> ch >> t >> k;
        if (ch == '+')
            k = -k;
        s.push_back(Seg{last, prev, t});
        last += k;
        prev = t;
    }
}

void kill() {
    sort(s.begin(), s.end(), [](const Seg &x, const Seg &y) -> bool {
            return x.x < y.x;
            });

    int m = s.size();

    for (int i = m - 1; i >= 0; --i) {
        ss[i] = s[i].x;
        ll len = s[i].r - s[i].l;

        slen[i] = len;
        sx[i] = ss[i] * len;

        slen[i] += slen[i + 1];
        sx[i] += sx[i + 1];
    }

    while (q--) {
        ll b;
        cin >> b;
        if (b < last) {
            cout << "INFINITY\n";
            continue;
        }

        ll pos = lower_bound(ss, ss + m, b) - ss;
        ll ans = sx[pos] - b * slen[pos];

        cout << ans << "\n";
    }
}


int main() {
#ifdef LOCAL
    assert(freopen("e.in", "r", stdin));
#else
    assert(freopen(NAME ".in", "r", stdin));
    assert(freopen(NAME ".out", "w", stdout));
#endif

    read();
    kill();

}
