#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef long long i64;
#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define sz(x) ((int) (x).size())

#define NAME "jenga"

const int maxn = 15005;

int n, h;

ll sx[maxn];
ll sy[maxn];
ll cnt[maxn];
set<int> bad[maxn];
int l[maxn], r[maxn];

void init() {
    forn (i, h) {
        l[i] = 0, r[i] = n - 1;
    }
    for (int i = h - 2; i >= 0; --i) {
        sx[i] = sx[i + 1], sy[i] = sy[i + 1];
        cnt[i] = cnt[i + 1];

        cnt[i] += n;
        sx[i] += n * n;
        sy[i] += n * n;
    }
}

bool del(int ch, int k) {
    bad[ch].insert(k);
    ll x, y;
    x = 2 * k + 1;
    y = n;
    if (ch % 2)
        swap(x, y);
    while (bad[ch].count(l[ch]))
        ++l[ch];
    while (bad[ch].count(r[ch]))
        --r[ch];
    if (l[ch] > r[ch]) {
        if (ch == h - 1) {
            --h;
            return false;
        }
        return true;
    }
    for (int i = ch - 1; i >= 0; --i) {
        cnt[i]--;
        sx[i] -= x;
        sy[i] -= y;
    }
    forn (i, h - 1) {
        ll xl = l[i] * 2;
        ll xr = r[i] * 2 + 2;
        xl *= cnt[i];
        xr *= cnt[i];
        ll X;
        if (i % 2 == 0)
            X = sx[i];
        else
            X = sy[i];
        if (X <= xl || X >= xr)
            return true;
    }
    return false;
}

int main() {
#ifdef LOCAL
    assert(freopen("j.in", "r", stdin));
#else
    assert(freopen(NAME ".in", "r", stdin));
    assert(freopen(NAME ".out", "w", stdout));
#endif
    int w, m;
    cin >> n >> w >> h >> m;
    init();
    forn (i, m) {
        int l, k;
        cin >> l >> k;
        --l, --k;
        if (del(l, k)) {
            cout << "yes\n";
            cout << i + 1 << '\n';
            return 0;
        }
    }
    cout << "no\n";
}
