#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define for1(i, n) for (int i = 1; i < int(n); ++i)
#define forft(i, f, t) for (int i = int(f); i < int(t); ++i)
#define forr(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define X first
#define Y second
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define ms(a, v) memset(a, v, sizeof(a))

template <typename X> X sqr(const X &a) {return a * a;}

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = 1e9;
const li INF64 = (1e18) + 4e5;
const ld EPS = 1e-9;

li l, r;

const int SUM = 2100;
const int N = 320;

bool read() {
	cin >> l >> r;
	return true;
}

const int M = 100 * 1000 + 5;
bool np[M];

vector<int> p;
li len[SUM][N];
li cnt[SUM][N];

int calclen(int x) {
	int res = 0;
	while(x) {
		res++;
		x /= 10;
	}
	return res;
}

int dlen[N];

void upd(li &val, li x) {
	val = min(INF64, val + x);
}

string curans = "";

li tlen[SUM];

string tostr(int x) {
	string res;
	while(x) {
		res += '0' + x % 10;
		x /= 10;
	}
	reverse(all(res));
	return res;
}


li restore(int sum, li l) {
//	cerr << "REST " << sum << ' ' << l << endl;
	li pos = 0;
	curans += '[';
	forn (i, N) {
		int nsum = sum - p[i];
		if (nsum < -INF / 2)
			nsum = 0;
		if (nsum < 0)
			continue;
		li add = sz(curans);
		if (add == 1)
			add -= 2;
		li tmp = 0;
		upd(tmp, add * cnt[sum][i] + len[sum][i]);
		if (tmp > l) {
			if (p[i] != INF) {
				if (sz(curans) > 1)
					curans += ", ";
				curans += tostr(p[i]);
			}
			sum = nsum;			
		} else {
			l -= tmp;
			pos += tmp;			
		}					
	}	
	curans += "], ";
	return pos;
}

li get(li l) {
	curans = "";
	li pos = 0;
	
	li s = -1;

	for (int i = 2; i < SUM; ++i) {
		if (tlen[i] > l) {
			s = i;
			break;
		}
		pos += tlen[i];
		l -= tlen[i];	
	}

	pos += restore(s, l);

	return pos;	
}

void solve() {
	for (int i = 2; i < M; ++i) {
		if (np[i])
			continue;
		for (int j = 2 * i; j < M; j += i)
			np[j] = true;
		if (sz(p) + 1 < N)
			p.pb(i);			
	}
	
	p.pb(INF);



	cnt[0][N - 1] = 1;
	len[0][N - 1] = 3;
	
	forn (i, sz(p))
		dlen[i] = calclen(p[i]);
	
	forn (i, SUM) {
		forn (j, N) {
			upd(tlen[i], len[i][j] - cnt[i][j]);
			if (len[i][j] == 0 && cnt[i][j] == 0)
				continue;
			forn (k, j) {
				if (i + p[k] >= SUM)
					break;
				upd(cnt[i + p[k]][k], cnt[i][j]);
				upd(len[i + p[k]][k], len[i][j] + (dlen[k] + 2) * cnt[i][j]);					
			}
		}
	}

	
	string ans = "";
	li lpos = get(l - 1);
	ans += curans;
	cerr << curans << endl;
	while(sz(ans) < 200 * 1000 + 5) {
		get(lpos + sz(ans));
		ans += curans;		
	}

	l--, r--;

	cerr << lpos << ' ' << l << endl;

	forn (i, r - l + 1)
		cout << ans[l - lpos + i];		
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("list.in", "rt", stdin);
	freopen("list.out", "wt", stdout);
#endif

	srand(time(NULL));
	cout << setprecision(10) << fixed;	
	cerr << setprecision(10) << fixed;

	read();
	solve();

#ifdef _DEBUG
	cerr << "Time: " << clock() << endl;
#endif

	return 0;	
}