#include <bits/stdc++.h>
#define DEBUG(x) cout << #x << " = " << x << endl;
using namespace std;
typedef long long ll;

bool capLetter(char c) {
    return ('A' <= c && c <= 'Z');
}
bool noCapLetter(char c) {
    return ('a' <= c && c <= 'z');
}
string s;

bool capWord(int i, int j) {
    if (j - i <= 1) return false;
    if (!capLetter(s[i])) return false;

    for (int k = i + 1; k < j; k++) {
        if (!noCapLetter(s[k])) return false;
    }

    return true;
}

int main()
{
    freopen("abbreviation.in", "r", stdin);
    freopen("abbreviation.out", "w", stdout);

    while (getline(cin, s))
    {
        int i = 0;

        while (i < s.length())
        {
            if (s[i] == ' ' || s[i] == ',' || s[i] == '.') {
                cout << s[i];
                i++;
                continue;
            }

            int j = i;
            while (j < s.length() && (s[j] != '.' && s[j] != ',' && s[j] != ' ')) j++;

            bool isCapital = capWord(i, j);

            if (!isCapital) {
                for (int k = i; k < j; k++) {
                    cout << s[k];
                }
                i = j;
                continue;
            }

            string begChar;
            begChar.push_back(s[i]);

            int from = i, to = j;

            while (true)
            {
                if (to == s.length() || s[to] != ' ') break;

                int t = to + 1;
                while (t < s.length() & (s[t] != '.' && s[t] != ',' && s[t] != ' ')) t++;

                if (capWord(to + 1, t)) {
                    begChar.push_back(s[to + 1]);
                    to = t;
                }
                else break;
            }

            if (begChar.size() <= 1) {
                for (int k = i; k < j; k++) {
                    cout << s[k];
                }
                i = j;
                continue;
            }

            cout << begChar << " (";
            for (int k = from; k < to; k++) {
                cout << s[k];
            }
            cout << ")";
            i = to;
        }

        cout << endl;
    }

    return 0;
}
