#include <bits/stdc++.h>
#define DEBUG(x) cout << #x << " = " << x << endl;
using namespace std;
typedef long long ll;
const int OFFSET = 50000;
const int mi_inf = -32768;
const int pl_inf =  32767;


int cnt[2 * OFFSET];

int getDigit(string s, int pos)
{
    for (int i = pos; i < s.size(); i++)
    {
        if ('0' <= s[i] && s[i] <= '9') return i;
    }
}

void getNumber(string s, int& pos, int& x)
{
    int res = 0;
    int p = pos;
    while('0' <= s[pos] && s[pos] <= '9')
    {
        res *= 10;
        res += (int)(s[pos] - '0');
        pos++;
    }

    if (s[p - 1] == '-') res = -res;
    x = res;
}

void printAns(int l, int r)
{
    if (l == mi_inf && r == pl_inf)
    {
        cout << "true" << endl;
        exit(0);
    }

    if (l == mi_inf)
    {
        cout << "x <= " << r; // << endl;
        return;
    }

    if (r == pl_inf)
    {
        cout << "x >= " << l; // << endl;
        return;
    }

    cout << "x >= " << l << " && x <= " << r; //  << endl;
}

int main()
{
    freopen("hard.in", "r", stdin);
    freopen("hard.out", "w", stdout);

    string s;
    while(getline(cin, s))
    {
        //cout << s.size() << endl;
        if (s.size() == 0) break;

        int i = 0;
        bool two = false;
        while (i < s.size())
        {
            if (s[i] == '&') two = true;
            i++;
        }

        if (two)
        {
            int pnt;
            int a, b;

            pnt = getDigit(s, 0);
            getNumber(s, pnt, a);
            pnt = getDigit(s, pnt);
            getNumber(s, pnt, b);

            if (a > b)
            {
                cout << "false" << endl;
                return 0;
            }

            cnt[a + OFFSET]++;
            cnt[b + OFFSET + 1]--;

            //cout << a << " " << b << endl;
        }
        else
        {
            int pnt;
            int a, b;

            pnt = getDigit(s, 0);
            getNumber(s, pnt, a);

            //DEBUG(s[2]);

            if (s[2] == '>') b = pl_inf;
            if (s[2] == '<')
            {
                b = mi_inf;
                swap(a, b);
            }

            cnt[a + OFFSET]++;
            cnt[b + 1 + OFFSET]--;

            //cout << a << " " << b << endl;
        }

        //cout << s << endl;
    }


    int pnt = mi_inf;
    int sum = 0;
    int ansCnt = 0;
    while(pnt <= pl_inf)
    {
        while(sum == 0 && cnt[pnt + OFFSET] == 0) pnt++;
        sum += cnt[pnt + OFFSET];
        int l = pnt;
        int r = pnt;
        while (sum > 0)
        {
            r++;
            sum += cnt[r + OFFSET];
        }

        pnt = r + 1;

        if (ansCnt != 0)
            cout << " ||" << endl;

        ansCnt++;
        printAns(l, r - 1);
    }


    return 0;
}
