#include <bits/stdc++.h>
#define ff first
#define ss second
#define puba push_back
#define szof(_x) ((int) (_x).size())
#define bend(_x) (_x).begin(), (_x).end()
#define TASK_NAME "hard"

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

const int N = 100500;
const int C = 40000;
const int R1 = -32768;
const int R2 = 32767;

int as[N];
bool a[N];

void addRange(int l, int r)
{
	if (l > r)
		return;
	as[l+C]++;
	as[r+1+C]--;
}

int main() {
	freopen(TASK_NAME ".in", "r", stdin);	
	freopen(TASK_NAME ".out", "w", stdout);
	ios::sync_with_stdio(false);

	int cl = R1, cr = R2;
	while (true)
	{
		string s;
		if (!(cin >> s))
			break;
		if (s == "||")
		{
			addRange(cl, cr);
			cl = R1;
			cr = R2;
			continue;
		}
		if (s == "&&")
			continue;
		assert(s == "x");
		cin >> s;
		if (s == ">=")
		{                   
			int w;
			cin >> w;
			cl = max(w, cl);
		} else if (s == "<=")
		{
			int w;
			cin >> w;
			cr = min(cr, w);
		} else
			assert(false);
	}                       
	addRange(cl, cr);

	int cnt = 0;
	for (int i = R1; i <= R2; ++i)
	{
		cnt += as[i+C];
		a[i+C] = cnt;
	}

	vector < pii > ans;
	for (int i = R1; i <= R2; ++i)
	{
		if (a[i+C])
		{
			int j = i;
			while (a[j+1+C])
				++j;
			ans.emplace_back(i, j);
			i = j;
		}
	}

	if (ans.empty())
		cout << "false\n";
	else
	{
		for (int i = 0; i < szof(ans); ++i)
		{
			auto p = ans[i];
			if (p.ff == R1 && p.ss == R2)
				cout << "true";
			else if (p.ff == R1)
				cout << "x <= " << p.ss;
			else if (p.ss == R2)
				cout << "x >= " << p.ff;
			else
				cout << "x >= " << p.ff << " && " << "x <= " << p.ss;
			if (i == szof(ans) - 1)
				cout << "\n";
			else
				cout << " ||\n";
		}
	}

 	return 0;
}