#include <bits/stdc++.h>
#define ff first
#define ss second
#define puba push_back
#define szof(_x) ((int) (_x).size())
#define bend(_x) (_x).begin(), (_x).end()
#define TASK_NAME "jenga"

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

int const N = 10100;

int h, n;
bool used[N][N];
ll sx[N], sy[N];
int cnt[N];
int first[N], last[N];

int get_x(int lev, int pos) {
	if (lev % 2 == 0)
		return 2 * pos + 1;
	return n;
}

int get_y(int lev, int pos) {
	if (lev % 2 == 1)
		return 2 * pos + 1;
	return n;
}

bool check_bad(int lev) {
	int next = lev + 1;
	if (cnt[next] == 0)
		return false;
	if (first[lev] > last[lev])
		return true;
	if (lev % 2 == 0) {
		ll fromx = get_x(lev, first[lev]) - 1;
		ll tox = get_x(lev, last[lev]) + 1;
		return !(fromx * cnt[next] < sx[next] && sx[next] < tox * cnt[next]);
	} else {
		ll fromy = get_y(lev, first[lev]) - 1;
		ll toy = get_y(lev, last[lev]) + 1;
		return !(fromy * cnt[next] < sy[next] && sy[next] < toy * cnt[next]);
	}
}

void solve() {

	int w;
	scanf("%d%d", &n, &w);
	int m;
	scanf("%d%d", &h, &m);

	for (int lev = h - 1; lev >= 0; --lev) {
		for (int pos = 0; pos < n; ++pos) {
			sx[lev] += get_x(lev, pos);
			sy[lev] += get_y(lev, pos);
			++cnt[lev];
		}
		if (lev < h - 1) {
			cnt[lev] += cnt[lev + 1];
			sx[lev] += sx[lev + 1];
			sy[lev] += sy[lev + 1];
		}
		last[lev] = n - 1;
		first[lev] = 0;
	}

	for (int it = 0; it < m; ++it) {
		
	    int lev, pos;
	    scanf("%d%d", &lev, &pos);
	    --lev, --pos;	
	    int x = get_x(lev, pos);
	    int y = get_y(lev, pos);
		
		for (int i = 0; i <= lev; ++i) {
			--cnt[i];
			sx[i] -= x;
			sy[i] -= y;
		}

		used[lev][pos] = 1;
		while (last[lev] >= 0 && used[lev][last[lev]])
			--last[lev];
		while (first[lev] < n && used[lev][first[lev]])
			++first[lev];
		bool foo = false;
		for (int i = 0; i < h - 1; ++i)
			foo |= check_bad(i);
		if (foo) {
			cout << "yes" << '\n';
			cout << it + 1 << '\n';
			return;
		}
	}
	cout << "no" << '\n';
}

int main() {
	freopen(TASK_NAME ".in", "r", stdin);	
	freopen(TASK_NAME ".out", "w", stdout);

	solve();

 	return 0;
}