#include <bits/stdc++.h>
#define ff first
#define ss second
#define puba push_back
#define szof(_x) ((int) (_x).size())
#define bend(_x) (_x).begin(), (_x).end()
#define TASK_NAME "kids"

using namespace std;
typedef long long ll;         
typedef pair<int, int> pii;
typedef pair<int, int> ipair;

const int INF = 0x3f3f3f3f;
const int N = 2048;

struct Figure
{              
	bitset < N > a[N];
	int ss[N];
	int wx, wy;
	bool isEmpty; 
	void read()
	{
		int sx, sy;
		isEmpty = true;
		scanf("%d%d", &sx, &sy);
		wx = -1;
		wy = sy;
		for (int i = 0; i < sx; ++i)
		{
			static char s[N];
			scanf("%s", s);
			if (wx == -1)
			{
				bool have = false;
				for (int j = 0; j < sy; ++j)
					if (s[j] == '*')
					{
						have = true;
						break;
					}
				if (have)
					wx = i;
			}
			if (wx != -1)
			{
				for (int j = 0; j < sy; ++j)
					if (s[j] == '*')
					{
						a[i - wx].set(j);
						wy = min(wy, j);
						isEmpty = false;
					}
			}          
		}
		for (int i = 0; i < sx; ++i)
			a[i] >>= wy;
		for (int i = 0; i < N; ++i)
		{
			ss[i] = N;
			for (int j = 0; j < N; ++j)
				if (a[i][j])
				{
					ss[i] = j;
					break;
				}
		}
	}
} f[3];

void answer(pii f0, pii f1)
{
	f0.ff -= f[0].wx;
	f0.ss -= f[0].wy;

	f1.ff -= f[1].wx;
	f1.ss -= f[1].wy;

	cout << "YES\n";
	cout << f1.ss - f0.ss << " " << f1.ff - f0.ff << "\n";
	exit(0);
}

int fbit(const bitset < N > & b)
{
	for (int i = 0; i < N; ++i)
		if (b[i])
			return i;
	return N;
}

ipair merge(const Figure & f0, const Figure & f1, int y, const Figure & ft)
{
	if (y < 0)
	{
		pii p = merge(f1, f0, -y, ft);
		if (p.ff == INF)
			return p;
		return {p.ff, p.ss + y};
	}
                               
    int ansX = -INF, ansY = -INF;
    for (int i = 0; i < N; ++i)
    {
    	bitset < N > rez = f0.a[i] ^ (f1.a[i] << y);
       	if (rez.count() != 0 && ansX == -INF)
    		ansX = i;  
    	if (ansX != -INF)
    	{
    		int e0 = fbit(rez);
    		int et = ft.ss[i - ansX];
    		if (e0 == N && et == N)
    			continue;
    		if ((e0 == N) != (et == N))
    			return {INF, INF};
    		int cansY = e0 - et;
    		if (cansY < 0 || (cansY != ansY && ansY != -INF))
    			return {INF, INF};
    		ansY = cansY;
    		if (rez != (ft.a[i - ansX] << ansY))
    			return {INF, INF};
    	}
    }
    if (ft.isEmpty)
    {
    	if (ansX == -INF)
    		return {0, 0};
    	return {INF, INF};
    } else if (ansX == -INF)
    	return {INF, INF};                             
    return {ansX, ansY};
}

int main() {
	freopen(TASK_NAME ".in", "r", stdin);	
	freopen(TASK_NAME ".out", "w", stdout);

	f[0].read();
	f[1].read();
	f[2].read();

	/*for (int i = 0; i < 3; ++i)
	{
		cerr << f[i].wx << " " << f[i].wy << "\n";
		for (int x = 0; x < 6; ++x)
		{
			cerr << f[i].ss[x] << " ";
			for (int y = 0; y < 10; ++y)
				cerr << ".*"[f[i].a[x][y]];
			cerr << "\n";
		}
		cerr << "\n";
	}       */

	ipair p = merge(f[0], f[1], 0, f[2]);
	if (p.ff != INF)          
		answer(pii(0, 0), pii(0, 0));

	p = merge(f[1], f[2], 0, f[0]);
	if (p.ff != INF)
		answer(p, pii(0, 0));

	
	p = merge(f[2], f[0], 0, f[1]);
	if (p.ff != INF)
		answer(pii(0, 0), p);
		              
    int s[3] = {0,0,0};
    for (int i = 0; i < 3; ++i)
    	for (int j = 0; j < N; ++j)
    		if (f[i].a[0][j])
    		{
    			s[i] = j;
    			break;
    		}
      
    p = merge(f[0], f[1], s[0] - s[1], f[2]);
	if (p.ff != INF)                         
		answer(pii(0, 0), pii(0, s[0] - s[1]));
                          
    p = merge(f[1], f[2], s[1] - s[2], f[0]);
	if (p.ff != INF)          
		answer(p, pii(0, 0));      
                               
	p = merge(f[2], f[0], s[2] - s[0], f[1]);
	if (p.ff != INF)          
		answer(pii(0, s[2] - s[0]), p);

	cout << "NO\n";
         
    return 0;
}