import sys

sys.stdin = open("abbreviation.in", "r")
sys.stdout = open("abbreviation.out", "w")

def capi(word):
  if len(word) < 2:
    return False
  if len(word) == 0:
    return False
  if not ('A' <= word[0] and word[0] <= 'Z'):
    return False
  for x in word[1:]:
    if not ('a' <= x and x <= 'z'):
      return False
  return True

def get(word):
  if word[0] == ' ':
    return word[1]
  return word[0]


def solve(line):
  if line[-1] == '\n':
    line = line[:-1]
  if not line:
    return
  words = []
  pos = 0
  n = len(line)
  ok = set(list("qqwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM"))
  while pos < n:
    tmp = [line[pos]]
    pos += 1
    if tmp[0] != ' ' and (tmp[0] not in ok):
      words.append("".join(tmp))
      continue
    while pos < n and line[pos] in ok:
      tmp.append(line[pos])
      pos += 1
    words.append("".join(tmp))
  cap = []
  for word in words:
    cap.append(capi(word) or (word[0] == ' ' and capi(word[1:])))
  pos = 0
  n = len(cap)
  ret = []
  while pos < n:
    if not cap[pos]:
      ret.append(words[pos])
      pos += 1
      continue
    cnt = 0
    tmp = []
    rest = []
    if words[pos][0] == ' ':
      ret.append(" ")
      words[pos] = words[pos][1:]
    while pos < n and cap[pos]:
      tmp.append(get(words[pos]))
      rest.append(words[pos])
      cnt += 1
      pos += 1
    if cnt == 1:
      ret.append(words[pos - 1])
      continue
    else:
      name = "".join(tmp) + " (" + "".join(rest) + ")"
      ret.append(name)
  print("".join(ret))


for line in sys.stdin:
  solve(line)