#include <bits/stdc++.h>

#define mp make_pair
#define pb push_back
#define F first
#define S second
#define ll long long

#define filename "expect"

using namespace std;

struct query {
	bool add;
	long long ti, ki;
	query(long long ti = 0, long long ki = 0, bool add = false) : ti(ti), ki(ki), add(add){}
};

const int maxn = 2e5;

#define add_const dslkfjsdlkfj

vector < query > qs;
vector < long long > x;
long long cur_balance = 0;
long long add_const[maxn], add_linear[maxn];
int N;
int find_pos_plus(long long val) {
	auto it = upper_bound(x.begin(), x.end(), val - 1);
	if (it == x.end()) {
		return (it - x.begin());
	}
	while (it != x.end()) {
		if (*it >= val) {
			return (it - x.begin());
		}
		it++;
	}
}

int find_pos_minus(long long val) {
	auto it = lower_bound(x.begin(), x.end(), val + 1);
	while (true) {
		if (it == x.begin()) {
			if (*it <= val) {
				return 0;
			}
			return -1;
		}
		if (*it <= val) {
			return (it - x.begin());
		}
		it--;
	}
}

void solve_plus(query q) {
	int pos_1 = find_pos_plus(-cur_balance);
	int pos_2 = find_pos_minus(-cur_balance - q.ki);
	assert(pos_1 >= pos_2);
	add_const[0] += q.ki * q.ti;
	add_const[pos_2 + 1] -= q.ki * q.ti;
	add_const[pos_2 + 1] -= cur_balance * q.ti;
	add_const[pos_1] += cur_balance * q.ti;
	add_linear[pos_2 + 1] -= q.ti;
	add_linear[pos_1] += q.ti;
}
void solve_minus(query q)
{
  int pos_1 = find_pos_minus(-cur_balance);
  int pos_2 = find_pos_plus(-cur_balance + q.ki);
  assert(pos_1 <= pos_2);
  add_const[pos_2] += q.ki * q.ti;
  add_const[N] -= q.ki * q.ti;
  add_const[pos_1 + 1] += cur_balance * q.ti;
  add_const[pos_2] -= cur_balance * q.ti;
  add_linear[pos_1 + 1] += q.ti;
  add_linear[pos_2] -= q.ti;
}
int main() {
	freopen(filename".in", "r", stdin);
	freopen(filename".out", "w", stdout);
	ios_base :: sync_with_stdio(false);
	cin.tie(0);
	int n = 0;
	int q = 0;
	cin >> n >> q;
	N = q;
	long long in_time = 0;
	long long cycles = 0;
	for (int i = 0; i < n; ++i) {
		char ch;
	    int ti;
		int ki;
		cin >> ch >> ti >> ki;
		qs.push_back(query(ti, ki, ch == '+'));
		if (ch == '-') {
			in_time += ki * 1ll * ti;
			cycles -= ki;
		} else {
			cycles += ki;
		}
	}
	vector < pair < long long, long long > > b;
	for (int i = 0; i < q; i++) {
		int x;
		cin >> x;
		b.push_back({x, i});
	}
	sort(b.begin(), b.end());
	x.resize(b.size());
	for (int i = 0; i < q; ++i) {
		x[i] = b[i].first;
	}
	for (const auto& q: qs) {
		if (q.add) {
		    solve_plus(q);
			cur_balance += q.ki;
		} else {
		    solve_minus(q);
			cur_balance -= q.ki;
		}
	}	
	vector<ll> ans(q);
	vector<ll> curans(q);
	vector<ll> base_b(q);
	ll curadd = 0, curlinear = 0;
	for(int i = 0; i < q; i++)
	{
	  curadd += add_const[i];
	  curlinear += add_linear[i];
	  curans[i] = curadd + x[i] * curlinear;
	  ans[b[i].second] = curans[i];
	  base_b[b[i].second] = b[i].first;
	}
	for(int i = 0; i < q; i++)
	{
	  if(base_b[i] + cycles >= 0)
	    cout << ans[i] - in_time << "\n";
	  else
	    cout << "INFINITY\n";
	}
	return 0;
}